/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00h0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|h0) integrals */

void d12hrr_order_00h0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][5][11] = int_stack + 0;
 Libderiv->deriv_classes[0][5][10] = int_stack + 21;
 Libderiv->deriv_classes[0][5][9] = int_stack + 42;
 Libderiv->deriv_classes[0][5][8] = int_stack + 63;
 Libderiv->deriv_classes[0][5][7] = int_stack + 84;
 Libderiv->deriv_classes[0][5][6] = int_stack + 105;
 Libderiv->deriv_classes[0][5][2] = int_stack + 126;
 Libderiv->deriv_classes[0][5][1] = int_stack + 147;
 Libderiv->deriv_classes[0][5][0] = int_stack + 168;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 189;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 210;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 231;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 252;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 273;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 294;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 315;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 336;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 357;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 378;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 399;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 420;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 441;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 462;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 483;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 504;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 525;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 546;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 567;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 588;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 609;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 630;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 651;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 672;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 693;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 714;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 735;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 756;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 777;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 798;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 819;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 840;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 861;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 882;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 903;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 924;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 945;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 966;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 987;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 1008;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 1029;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 1050;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 1071;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 1092;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 1113;
 memset(int_stack,0,9072);

 Libderiv->dvrr_stack = int_stack + 1134;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00h0(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[10] = int_stack + 21;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[9] = int_stack + 42;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[8] = int_stack + 63;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[7] = int_stack + 84;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[6] = int_stack + 105;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[2] = int_stack + 126;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[1] = int_stack + 147;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[0] = int_stack + 168;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[155] = int_stack + 189;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[143] = int_stack + 210;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[142] = int_stack + 231;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[131] = int_stack + 252;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[130] = int_stack + 273;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[129] = int_stack + 294;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[119] = int_stack + 315;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[118] = int_stack + 336;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[117] = int_stack + 357;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[116] = int_stack + 378;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[107] = int_stack + 399;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[106] = int_stack + 420;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[105] = int_stack + 441;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[104] = int_stack + 462;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[103] = int_stack + 483;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[95] = int_stack + 504;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[94] = int_stack + 525;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[93] = int_stack + 546;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[92] = int_stack + 567;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[91] = int_stack + 588;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[90] = int_stack + 609;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[47] = int_stack + 630;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[46] = int_stack + 651;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[45] = int_stack + 672;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[44] = int_stack + 693;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[43] = int_stack + 714;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[42] = int_stack + 735;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[38] = int_stack + 756;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[35] = int_stack + 777;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[34] = int_stack + 798;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[33] = int_stack + 819;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[32] = int_stack + 840;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[31] = int_stack + 861;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[30] = int_stack + 882;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[26] = int_stack + 903;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[25] = int_stack + 924;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[23] = int_stack + 945;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[22] = int_stack + 966;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[21] = int_stack + 987;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[20] = int_stack + 1008;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[19] = int_stack + 1029;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[18] = int_stack + 1050;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[14] = int_stack + 1071;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[13] = int_stack + 1092;
 /*--- compute (00|h0) ---*/
     Libderiv->ABCD[12] = int_stack + 1113;

}
