/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_d0g0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|g0) integrals */

void d12hrr_order_d0g0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][4][11] = int_stack + 0;
 Libderiv->deriv_classes[2][4][10] = int_stack + 90;
 Libderiv->deriv_classes[2][4][9] = int_stack + 180;
 Libderiv->deriv_classes[2][4][8] = int_stack + 270;
 Libderiv->deriv_classes[2][4][7] = int_stack + 360;
 Libderiv->deriv_classes[2][4][6] = int_stack + 450;
 Libderiv->deriv_classes[2][4][2] = int_stack + 540;
 Libderiv->deriv_classes[2][4][1] = int_stack + 630;
 Libderiv->deriv_classes[2][4][0] = int_stack + 720;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 810;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 900;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 990;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 1080;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 1170;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 1260;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 1350;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 1440;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 1530;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 1620;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 1710;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 1800;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 1890;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 1980;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 2070;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 2160;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 2250;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 2340;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 2430;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 2520;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 2610;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 2700;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 2790;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 2880;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 2970;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 3060;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 3150;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 3240;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 3330;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 3420;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 3510;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 3600;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 3690;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 3780;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 3870;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 3960;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 4050;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 4140;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 4230;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 4320;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 4410;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 4500;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 4590;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 4680;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 4770;
 memset(int_stack,0,38880);

 Libderiv->dvrr_stack = int_stack + 4860;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_d0g0(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[10] = int_stack + 90;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[9] = int_stack + 180;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[8] = int_stack + 270;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[7] = int_stack + 360;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[6] = int_stack + 450;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[2] = int_stack + 540;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[1] = int_stack + 630;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[0] = int_stack + 720;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[155] = int_stack + 810;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[143] = int_stack + 900;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[142] = int_stack + 990;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[131] = int_stack + 1080;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[130] = int_stack + 1170;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[129] = int_stack + 1260;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[119] = int_stack + 1350;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[118] = int_stack + 1440;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[117] = int_stack + 1530;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[116] = int_stack + 1620;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[107] = int_stack + 1710;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[106] = int_stack + 1800;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[105] = int_stack + 1890;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[104] = int_stack + 1980;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[103] = int_stack + 2070;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[95] = int_stack + 2160;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[94] = int_stack + 2250;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[93] = int_stack + 2340;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[92] = int_stack + 2430;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[91] = int_stack + 2520;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[90] = int_stack + 2610;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[47] = int_stack + 2700;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[46] = int_stack + 2790;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[45] = int_stack + 2880;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[44] = int_stack + 2970;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[43] = int_stack + 3060;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[42] = int_stack + 3150;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[38] = int_stack + 3240;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[35] = int_stack + 3330;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[34] = int_stack + 3420;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[33] = int_stack + 3510;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[32] = int_stack + 3600;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[31] = int_stack + 3690;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[30] = int_stack + 3780;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[26] = int_stack + 3870;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[25] = int_stack + 3960;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[23] = int_stack + 4050;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[22] = int_stack + 4140;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[21] = int_stack + 4230;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[20] = int_stack + 4320;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[19] = int_stack + 4410;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[18] = int_stack + 4500;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[14] = int_stack + 4590;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[13] = int_stack + 4680;
 /*--- compute (d0|g0) ---*/
     Libderiv->ABCD[12] = int_stack + 4770;

}
