/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fph0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|h0) integrals */

void d12hrr_order_fph0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][5][10] = int_stack + 315;
 Libderiv->deriv_classes[4][5][9] = int_stack + 630;
 Libderiv->deriv_classes[4][5][8] = int_stack + 945;
 Libderiv->deriv_classes[4][5][7] = int_stack + 1260;
 Libderiv->deriv_classes[4][5][6] = int_stack + 1575;
 Libderiv->deriv_classes[4][5][2] = int_stack + 1890;
 Libderiv->deriv_classes[4][5][1] = int_stack + 2205;
 Libderiv->dvrr_classes[3][5] = int_stack + 2520;
 Libderiv->deriv_classes[4][5][0] = int_stack + 2730;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 3045;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 3255;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 3570;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 3780;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 4095;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 4305;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 4620;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 4830;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 5145;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 5355;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 5670;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 5880;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 6195;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 6405;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 6720;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 6930;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 7245;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 7455;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 7770;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 7980;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 8295;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 8505;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 8820;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 9030;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 9345;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 9555;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 9870;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 10080;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 10395;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 10605;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 10920;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 11130;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 11445;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 11655;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 11970;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 12180;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 12495;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 12705;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 13020;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 13230;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 13545;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 13755;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 14070;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 14280;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 14595;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 14805;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 15120;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 15330;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 15645;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 15855;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 16170;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 16380;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 16695;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 16905;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 17220;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 17430;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 17745;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 17955;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 18270;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 18480;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 18795;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 19005;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 19320;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 19530;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 19845;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 20055;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 20370;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 20580;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 20895;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 21105;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 21420;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 21630;
 Libderiv->deriv_classes[3][5][11] = int_stack + 21945;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 22155;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 22365;
 Libderiv->deriv_classes[3][5][10] = int_stack + 22680;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 22890;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 23100;
 Libderiv->deriv_classes[3][5][9] = int_stack + 23415;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 23625;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 23835;
 Libderiv->deriv_classes[3][5][8] = int_stack + 24150;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 24360;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 24570;
 Libderiv->deriv_classes[3][5][7] = int_stack + 24885;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 25095;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 25305;
 Libderiv->deriv_classes[3][5][6] = int_stack + 25620;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 25830;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 26040;
 Libderiv->deriv_classes[3][5][2] = int_stack + 26355;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 26565;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 26775;
 Libderiv->deriv_classes[3][5][1] = int_stack + 27090;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 27300;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 27510;
 Libderiv->deriv_classes[3][5][0] = int_stack + 27825;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 28035;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 28245;
 memset(int_stack,0,228480);

 Libderiv->dvrr_stack = int_stack + 36120;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fph0(Libderiv, Data);
   Data++;
 }

 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+28560,int_stack+0,int_stack+21945,21);
     Libderiv->ABCD[11] = int_stack + 28560;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+29190,int_stack+315,int_stack+22680,21);
     Libderiv->ABCD[10] = int_stack + 29190;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+630,int_stack+23415,21);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+29820,int_stack+945,int_stack+24150,21);
     Libderiv->ABCD[8] = int_stack + 29820;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+630,int_stack+1260,int_stack+24885,21);
     Libderiv->ABCD[7] = int_stack + 630;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+30450,int_stack+1575,int_stack+25620,21);
     Libderiv->ABCD[6] = int_stack + 30450;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1260,int_stack+1890,int_stack+26355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[2] = int_stack + 1260;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+31080,int_stack+2205,int_stack+27090, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[1] = int_stack + 31080;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1890,int_stack+2730,int_stack+27825, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[0] = int_stack + 1890;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+31710,int_stack+3255,int_stack+3045,21);
     Libderiv->ABCD[155] = int_stack + 31710;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2520,int_stack+3780,int_stack+3570,21);
     Libderiv->ABCD[143] = int_stack + 2520;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+3150,int_stack+4305,int_stack+4095,21);
     Libderiv->ABCD[142] = int_stack + 3150;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+3780,int_stack+4830,int_stack+4620,21);
     Libderiv->ABCD[131] = int_stack + 3780;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4410,int_stack+5355,int_stack+5145,21);
     Libderiv->ABCD[130] = int_stack + 4410;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5040,int_stack+5880,int_stack+5670,21);
     Libderiv->ABCD[129] = int_stack + 5040;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+32340,int_stack+6405,int_stack+6195,21);
     Libderiv->ABCD[119] = int_stack + 32340;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5670,int_stack+6930,int_stack+6720,21);
     Libderiv->ABCD[118] = int_stack + 5670;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+6300,int_stack+7455,int_stack+7245,21);
     Libderiv->ABCD[117] = int_stack + 6300;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+6930,int_stack+7980,int_stack+7770,21);
     Libderiv->ABCD[116] = int_stack + 6930;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+7560,int_stack+8505,int_stack+8295,21);
     Libderiv->ABCD[107] = int_stack + 7560;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+8190,int_stack+9030,int_stack+8820,21);
     Libderiv->ABCD[106] = int_stack + 8190;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+32970,int_stack+9555,int_stack+9345,21);
     Libderiv->ABCD[105] = int_stack + 32970;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+8820,int_stack+10080,int_stack+9870,21);
     Libderiv->ABCD[104] = int_stack + 8820;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+9450,int_stack+10605,int_stack+10395,21);
     Libderiv->ABCD[103] = int_stack + 9450;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+10080,int_stack+11130,int_stack+10920,21);
     Libderiv->ABCD[95] = int_stack + 10080;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+10710,int_stack+11655,int_stack+11445,21);
     Libderiv->ABCD[94] = int_stack + 10710;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+11340,int_stack+12180,int_stack+11970,21);
     Libderiv->ABCD[93] = int_stack + 11340;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+33600,int_stack+12705,int_stack+12495,21);
     Libderiv->ABCD[92] = int_stack + 33600;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+11970,int_stack+13230,int_stack+13020,21);
     Libderiv->ABCD[91] = int_stack + 11970;
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12600,int_stack+13755,int_stack+13545,21);
     Libderiv->ABCD[90] = int_stack + 12600;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+13230,int_stack+14280,int_stack+14070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[47] = int_stack + 13230;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+13860,int_stack+14805,int_stack+14595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[46] = int_stack + 13860;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+14490,int_stack+15330,int_stack+15120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[45] = int_stack + 14490;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+34230,int_stack+15855,int_stack+15645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[44] = int_stack + 34230;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+15120,int_stack+16380,int_stack+16170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[43] = int_stack + 15120;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+15750,int_stack+16905,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[42] = int_stack + 15750;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+16380,int_stack+17430,int_stack+17220, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+26355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[38] = int_stack + 16380;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+17010,int_stack+17955,int_stack+17745, 0.0, zero_stack, 1.0, int_stack+21945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[35] = int_stack + 17010;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+17640,int_stack+18480,int_stack+18270, 0.0, zero_stack, 1.0, int_stack+22680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[34] = int_stack + 17640;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+34860,int_stack+19005,int_stack+18795, 0.0, zero_stack, 1.0, int_stack+23415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[33] = int_stack + 34860;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+18270,int_stack+19530,int_stack+19320, 0.0, zero_stack, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[32] = int_stack + 18270;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+18900,int_stack+20055,int_stack+19845, 0.0, zero_stack, 1.0, int_stack+24885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[31] = int_stack + 18900;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+19530,int_stack+20580,int_stack+20370, 0.0, zero_stack, 1.0, int_stack+25620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[30] = int_stack + 19530;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+20160,int_stack+21105,int_stack+20895, 0.0, zero_stack, 1.0, int_stack+26355, 1.0, int_stack+27090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[26] = int_stack + 20160;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+20790,int_stack+21630,int_stack+21420, 0.0, zero_stack, 2.0, int_stack+27090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[25] = int_stack + 20790;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+35490,int_stack+22365,int_stack+22155, 1.0, int_stack+21945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[23] = int_stack + 35490;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+21420,int_stack+23100,int_stack+22890, 1.0, int_stack+22680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[22] = int_stack + 21420;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+22050,int_stack+23835,int_stack+23625, 1.0, int_stack+23415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[21] = int_stack + 22050;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+22680,int_stack+24570,int_stack+24360, 1.0, int_stack+24150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[20] = int_stack + 22680;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+23310,int_stack+25305,int_stack+25095, 1.0, int_stack+24885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[19] = int_stack + 23310;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+23940,int_stack+26040,int_stack+25830, 1.0, int_stack+25620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[18] = int_stack + 23940;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+24570,int_stack+26775,int_stack+26565, 1.0, int_stack+26355, 0.0, zero_stack, 1.0, int_stack+27825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[14] = int_stack + 24570;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+25200,int_stack+27510,int_stack+27300, 1.0, int_stack+27090, 1.0, int_stack+27825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[13] = int_stack + 25200;
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+25830,int_stack+28245,int_stack+28035, 2.0, int_stack+27825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[12] = int_stack + 25830;

}
