/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_g0fp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|fp) integrals */

void d12hrr_order_g0fp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][4][11] = int_stack + 0;
 Libderiv->deriv_classes[4][4][10] = int_stack + 225;
 Libderiv->deriv_classes[4][4][9] = int_stack + 450;
 Libderiv->deriv_classes[4][4][8] = int_stack + 675;
 Libderiv->deriv_classes[4][4][7] = int_stack + 900;
 Libderiv->dvrr_classes[4][3] = int_stack + 1125;
 Libderiv->deriv_classes[4][4][6] = int_stack + 1275;
 Libderiv->deriv_classes[4][4][2] = int_stack + 1500;
 Libderiv->deriv_classes[4][4][1] = int_stack + 1725;
 Libderiv->deriv_classes[4][4][0] = int_stack + 1950;
 Libderiv->deriv2_classes[4][3][143] = int_stack + 2175;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 2325;
 Libderiv->deriv2_classes[4][3][131] = int_stack + 2550;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 2700;
 Libderiv->deriv2_classes[4][3][130] = int_stack + 2925;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 3075;
 Libderiv->deriv2_classes[4][3][119] = int_stack + 3300;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 3450;
 Libderiv->deriv2_classes[4][3][118] = int_stack + 3675;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 3825;
 Libderiv->deriv2_classes[4][3][117] = int_stack + 4050;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 4200;
 Libderiv->deriv2_classes[4][3][107] = int_stack + 4425;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 4575;
 Libderiv->deriv2_classes[4][3][106] = int_stack + 4800;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 4950;
 Libderiv->deriv2_classes[4][3][105] = int_stack + 5175;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 5325;
 Libderiv->deriv2_classes[4][3][104] = int_stack + 5550;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 5700;
 Libderiv->deriv2_classes[4][3][95] = int_stack + 5925;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 6075;
 Libderiv->deriv2_classes[4][3][94] = int_stack + 6300;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 6450;
 Libderiv->deriv2_classes[4][3][93] = int_stack + 6675;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 6825;
 Libderiv->deriv2_classes[4][3][92] = int_stack + 7050;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 7200;
 Libderiv->deriv2_classes[4][3][91] = int_stack + 7425;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 7575;
 Libderiv->deriv_classes[4][3][11] = int_stack + 7800;
 Libderiv->deriv2_classes[4][3][83] = int_stack + 7950;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 8100;
 Libderiv->deriv_classes[4][3][10] = int_stack + 8325;
 Libderiv->deriv2_classes[4][3][82] = int_stack + 8475;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 8625;
 Libderiv->deriv_classes[4][3][9] = int_stack + 8850;
 Libderiv->deriv2_classes[4][3][81] = int_stack + 9000;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 9150;
 Libderiv->deriv_classes[4][3][8] = int_stack + 9375;
 Libderiv->deriv2_classes[4][3][80] = int_stack + 9525;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 9675;
 Libderiv->deriv_classes[4][3][7] = int_stack + 9900;
 Libderiv->deriv2_classes[4][3][79] = int_stack + 10050;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 10200;
 Libderiv->deriv_classes[4][3][6] = int_stack + 10425;
 Libderiv->deriv2_classes[4][3][78] = int_stack + 10575;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 10725;
 Libderiv->deriv2_classes[4][3][35] = int_stack + 10950;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 11100;
 Libderiv->deriv2_classes[4][3][34] = int_stack + 11325;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 11475;
 Libderiv->deriv2_classes[4][3][33] = int_stack + 11700;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 11850;
 Libderiv->deriv2_classes[4][3][32] = int_stack + 12075;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 12225;
 Libderiv->deriv2_classes[4][3][31] = int_stack + 12450;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 12600;
 Libderiv->deriv_classes[4][3][2] = int_stack + 12825;
 Libderiv->deriv2_classes[4][3][30] = int_stack + 12975;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 13125;
 Libderiv->deriv2_classes[4][3][26] = int_stack + 13350;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 13500;
 Libderiv->deriv2_classes[4][3][23] = int_stack + 13725;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 13875;
 Libderiv->deriv2_classes[4][3][22] = int_stack + 14100;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 14250;
 Libderiv->deriv2_classes[4][3][21] = int_stack + 14475;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 14625;
 Libderiv->deriv2_classes[4][3][20] = int_stack + 14850;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 15000;
 Libderiv->deriv2_classes[4][3][19] = int_stack + 15225;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 15375;
 Libderiv->deriv_classes[4][3][1] = int_stack + 15600;
 Libderiv->deriv2_classes[4][3][18] = int_stack + 15750;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 15900;
 Libderiv->deriv2_classes[4][3][14] = int_stack + 16125;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 16275;
 Libderiv->deriv2_classes[4][3][13] = int_stack + 16500;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 16650;
 Libderiv->deriv2_classes[4][3][11] = int_stack + 16875;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 17025;
 Libderiv->deriv2_classes[4][3][10] = int_stack + 17250;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 17400;
 Libderiv->deriv2_classes[4][3][9] = int_stack + 17625;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 17775;
 Libderiv->deriv2_classes[4][3][8] = int_stack + 18000;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 18150;
 Libderiv->deriv2_classes[4][3][7] = int_stack + 18375;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 18525;
 Libderiv->deriv_classes[4][3][0] = int_stack + 18750;
 Libderiv->deriv2_classes[4][3][6] = int_stack + 18900;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 19050;
 Libderiv->deriv2_classes[4][3][2] = int_stack + 19275;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 19425;
 Libderiv->deriv2_classes[4][3][1] = int_stack + 19650;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 19800;
 Libderiv->deriv2_classes[4][3][0] = int_stack + 20025;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 20175;
 memset(int_stack,0,163200);

 Libderiv->dvrr_stack = int_stack + 24900;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_g0fp(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+20400,int_stack+0,int_stack+7800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1125,15);
     Libderiv->ABCD[11] = int_stack + 20400;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+20850,int_stack+225,int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1125, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 20850;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+0,int_stack+450,int_stack+8850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1125, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+21300,int_stack+675,int_stack+9375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 21300;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+450,int_stack+900,int_stack+9900, 0.0, zero_stack, 1.0, int_stack+1125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 450;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+21750,int_stack+1275,int_stack+10425, 1.0, int_stack+1125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 21750;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+900,int_stack+1500,int_stack+12825,15);
     Libderiv->ABCD[2] = int_stack + 900;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+22200,int_stack+1725,int_stack+15600,15);
     Libderiv->ABCD[1] = int_stack + 22200;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+1350,int_stack+1950,int_stack+18750,15);
     Libderiv->ABCD[0] = int_stack + 1350;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+22650,int_stack+2325,int_stack+2175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7800,15);
     Libderiv->ABCD[155] = int_stack + 22650;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+1800,int_stack+2700,int_stack+2550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7800, 1.0, int_stack+8325,15);
     Libderiv->ABCD[143] = int_stack + 1800;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+2250,int_stack+3075,int_stack+2925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8325, 0.0, zero_stack,15);
     Libderiv->ABCD[142] = int_stack + 2250;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+2700,int_stack+3450,int_stack+3300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7800, 0.0, zero_stack, 1.0, int_stack+8850,15);
     Libderiv->ABCD[131] = int_stack + 2700;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+3150,int_stack+3825,int_stack+3675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8325, 1.0, int_stack+8850, 0.0, zero_stack,15);
     Libderiv->ABCD[130] = int_stack + 3150;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+3600,int_stack+4200,int_stack+4050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8850, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[129] = int_stack + 3600;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+23100,int_stack+4575,int_stack+4425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9375,15);
     Libderiv->ABCD[119] = int_stack + 23100;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+4050,int_stack+4950,int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8325, 0.0, zero_stack, 1.0, int_stack+9375, 0.0, zero_stack,15);
     Libderiv->ABCD[118] = int_stack + 4050;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+4500,int_stack+5325,int_stack+5175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8850, 1.0, int_stack+9375, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[117] = int_stack + 4500;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+4950,int_stack+5700,int_stack+5550, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[116] = int_stack + 4950;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+5400,int_stack+6075,int_stack+5925, 0.0, zero_stack, 1.0, int_stack+7800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9900,15);
     Libderiv->ABCD[107] = int_stack + 5400;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+5850,int_stack+6450,int_stack+6300, 0.0, zero_stack, 1.0, int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9900, 0.0, zero_stack,15);
     Libderiv->ABCD[106] = int_stack + 5850;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+23550,int_stack+6825,int_stack+6675, 0.0, zero_stack, 1.0, int_stack+8850, 0.0, zero_stack, 1.0, int_stack+9900, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[105] = int_stack + 23550;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+6300,int_stack+7200,int_stack+7050, 0.0, zero_stack, 1.0, int_stack+9375, 1.0, int_stack+9900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[104] = int_stack + 6300;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+6750,int_stack+7575,int_stack+7425, 0.0, zero_stack, 2.0, int_stack+9900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[103] = int_stack + 6750;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+7200,int_stack+8100,int_stack+7950, 1.0, int_stack+7800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10425,15);
     Libderiv->ABCD[95] = int_stack + 7200;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+7650,int_stack+8625,int_stack+8475, 1.0, int_stack+8325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10425, 0.0, zero_stack,15);
     Libderiv->ABCD[94] = int_stack + 7650;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8100,int_stack+9150,int_stack+9000, 1.0, int_stack+8850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10425, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[93] = int_stack + 8100;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+8550,int_stack+9675,int_stack+9525, 1.0, int_stack+9375, 0.0, zero_stack, 1.0, int_stack+10425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[92] = int_stack + 8550;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+9000,int_stack+10200,int_stack+10050, 1.0, int_stack+9900, 1.0, int_stack+10425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[91] = int_stack + 9000;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+9450,int_stack+10725,int_stack+10575, 2.0, int_stack+10425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[90] = int_stack + 9450;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+9900,int_stack+11100,int_stack+10950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12825,15);
     Libderiv->ABCD[47] = int_stack + 9900;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+10350,int_stack+11475,int_stack+11325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12825, 0.0, zero_stack,15);
     Libderiv->ABCD[46] = int_stack + 10350;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+10800,int_stack+11850,int_stack+11700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12825, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[45] = int_stack + 10800;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+11250,int_stack+12225,int_stack+12075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[44] = int_stack + 11250;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+11700,int_stack+12600,int_stack+12450, 0.0, zero_stack, 1.0, int_stack+12825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[43] = int_stack + 11700;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+12150,int_stack+13125,int_stack+12975, 1.0, int_stack+12825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[42] = int_stack + 12150;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+12600,int_stack+13500,int_stack+13350,15);
     Libderiv->ABCD[38] = int_stack + 12600;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+13050,int_stack+13875,int_stack+13725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15600,15);
     Libderiv->ABCD[35] = int_stack + 13050;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+13500,int_stack+14250,int_stack+14100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15600, 0.0, zero_stack,15);
     Libderiv->ABCD[34] = int_stack + 13500;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+13950,int_stack+14625,int_stack+14475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15600, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[33] = int_stack + 13950;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+14400,int_stack+15000,int_stack+14850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[32] = int_stack + 14400;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+24000,int_stack+15375,int_stack+15225, 0.0, zero_stack, 1.0, int_stack+15600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[31] = int_stack + 24000;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+14850,int_stack+15900,int_stack+15750, 1.0, int_stack+15600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[30] = int_stack + 14850;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+15300,int_stack+16275,int_stack+16125,15);
     Libderiv->ABCD[26] = int_stack + 15300;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+15750,int_stack+16650,int_stack+16500,15);
     Libderiv->ABCD[25] = int_stack + 15750;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+16200,int_stack+17025,int_stack+16875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18750,15);
     Libderiv->ABCD[23] = int_stack + 16200;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+16650,int_stack+17400,int_stack+17250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18750, 0.0, zero_stack,15);
     Libderiv->ABCD[22] = int_stack + 16650;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+17100,int_stack+17775,int_stack+17625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18750, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[21] = int_stack + 17100;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+17550,int_stack+18150,int_stack+18000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[20] = int_stack + 17550;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+24450,int_stack+18525,int_stack+18375, 0.0, zero_stack, 1.0, int_stack+18750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[19] = int_stack + 24450;
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+18000,int_stack+19050,int_stack+18900, 1.0, int_stack+18750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[18] = int_stack + 18000;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+18450,int_stack+19425,int_stack+19275,15);
     Libderiv->ABCD[14] = int_stack + 18450;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+18900,int_stack+19800,int_stack+19650,15);
     Libderiv->ABCD[13] = int_stack + 18900;
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+19350,int_stack+20175,int_stack+20025,15);
     Libderiv->ABCD[12] = int_stack + 19350;

}
