/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_pphp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|hp) integrals */

void d12hrr_order_pphp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][10] = int_stack + 168;
 Libderiv->deriv_classes[2][6][9] = int_stack + 336;
 Libderiv->deriv_classes[2][6][8] = int_stack + 504;
 Libderiv->deriv_classes[2][6][7] = int_stack + 672;
 Libderiv->dvrr_classes[2][5] = int_stack + 840;
 Libderiv->deriv_classes[2][6][6] = int_stack + 966;
 Libderiv->deriv_classes[2][6][2] = int_stack + 1134;
 Libderiv->deriv_classes[2][6][1] = int_stack + 1302;
 Libderiv->dvrr_classes[1][6] = int_stack + 1470;
 Libderiv->deriv_classes[2][6][0] = int_stack + 1554;
 Libderiv->deriv2_classes[1][5][143] = int_stack + 1722;
 Libderiv->deriv2_classes[1][6][143] = int_stack + 1785;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 1869;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 1995;
 Libderiv->deriv2_classes[1][5][131] = int_stack + 2163;
 Libderiv->deriv2_classes[1][6][131] = int_stack + 2226;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 2310;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 2436;
 Libderiv->deriv2_classes[1][5][130] = int_stack + 2604;
 Libderiv->deriv2_classes[1][6][130] = int_stack + 2667;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 2751;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 2877;
 Libderiv->deriv2_classes[1][5][119] = int_stack + 3045;
 Libderiv->deriv2_classes[1][6][119] = int_stack + 3108;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 3192;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 3318;
 Libderiv->deriv2_classes[1][5][118] = int_stack + 3486;
 Libderiv->deriv2_classes[1][6][118] = int_stack + 3549;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 3633;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 3759;
 Libderiv->deriv2_classes[1][5][117] = int_stack + 3927;
 Libderiv->deriv2_classes[1][6][117] = int_stack + 3990;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 4074;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 4200;
 Libderiv->deriv2_classes[1][5][107] = int_stack + 4368;
 Libderiv->deriv2_classes[1][6][107] = int_stack + 4431;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 4515;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 4641;
 Libderiv->deriv2_classes[1][5][106] = int_stack + 4809;
 Libderiv->deriv2_classes[1][6][106] = int_stack + 4872;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 4956;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 5082;
 Libderiv->deriv2_classes[1][5][105] = int_stack + 5250;
 Libderiv->deriv2_classes[1][6][105] = int_stack + 5313;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 5397;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 5523;
 Libderiv->deriv2_classes[1][5][104] = int_stack + 5691;
 Libderiv->deriv2_classes[1][6][104] = int_stack + 5754;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 5838;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 5964;
 Libderiv->deriv2_classes[1][5][95] = int_stack + 6132;
 Libderiv->deriv2_classes[1][6][95] = int_stack + 6195;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 6279;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 6405;
 Libderiv->deriv2_classes[1][5][94] = int_stack + 6573;
 Libderiv->deriv2_classes[1][6][94] = int_stack + 6636;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 6720;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 6846;
 Libderiv->deriv2_classes[1][5][93] = int_stack + 7014;
 Libderiv->deriv2_classes[1][6][93] = int_stack + 7077;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 7161;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 7287;
 Libderiv->deriv2_classes[1][5][92] = int_stack + 7455;
 Libderiv->deriv2_classes[1][6][92] = int_stack + 7518;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 7602;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 7728;
 Libderiv->deriv2_classes[1][5][91] = int_stack + 7896;
 Libderiv->deriv2_classes[1][6][91] = int_stack + 7959;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 8043;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 8169;
 Libderiv->deriv2_classes[1][5][83] = int_stack + 8337;
 Libderiv->deriv2_classes[1][6][83] = int_stack + 8400;
 Libderiv->deriv_classes[2][5][11] = int_stack + 8484;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 8610;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 8736;
 Libderiv->deriv2_classes[1][5][82] = int_stack + 8904;
 Libderiv->deriv2_classes[1][6][82] = int_stack + 8967;
 Libderiv->deriv_classes[2][5][10] = int_stack + 9051;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 9177;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 9303;
 Libderiv->deriv2_classes[1][5][81] = int_stack + 9471;
 Libderiv->deriv2_classes[1][6][81] = int_stack + 9534;
 Libderiv->deriv_classes[2][5][9] = int_stack + 9618;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 9744;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 9870;
 Libderiv->deriv2_classes[1][5][80] = int_stack + 10038;
 Libderiv->deriv2_classes[1][6][80] = int_stack + 10101;
 Libderiv->deriv_classes[2][5][8] = int_stack + 10185;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 10311;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 10437;
 Libderiv->deriv2_classes[1][5][79] = int_stack + 10605;
 Libderiv->deriv2_classes[1][6][79] = int_stack + 10668;
 Libderiv->deriv_classes[2][5][7] = int_stack + 10752;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 10878;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 11004;
 Libderiv->deriv2_classes[1][5][78] = int_stack + 11172;
 Libderiv->deriv2_classes[1][6][78] = int_stack + 11235;
 Libderiv->deriv_classes[2][5][6] = int_stack + 11319;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 11445;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 11571;
 Libderiv->deriv2_classes[1][5][35] = int_stack + 11739;
 Libderiv->deriv2_classes[1][6][35] = int_stack + 11802;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 11886;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 12012;
 Libderiv->deriv2_classes[1][5][34] = int_stack + 12180;
 Libderiv->deriv2_classes[1][6][34] = int_stack + 12243;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 12327;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 12453;
 Libderiv->deriv2_classes[1][5][33] = int_stack + 12621;
 Libderiv->deriv2_classes[1][6][33] = int_stack + 12684;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 12768;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 12894;
 Libderiv->deriv2_classes[1][5][32] = int_stack + 13062;
 Libderiv->deriv2_classes[1][6][32] = int_stack + 13125;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 13209;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 13335;
 Libderiv->deriv2_classes[1][5][31] = int_stack + 13503;
 Libderiv->deriv2_classes[1][6][31] = int_stack + 13566;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 13650;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 13776;
 Libderiv->deriv2_classes[1][5][30] = int_stack + 13944;
 Libderiv->deriv2_classes[1][6][30] = int_stack + 14007;
 Libderiv->deriv_classes[2][5][2] = int_stack + 14091;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 14217;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 14343;
 Libderiv->deriv2_classes[1][5][26] = int_stack + 14511;
 Libderiv->deriv2_classes[1][6][26] = int_stack + 14574;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 14658;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 14784;
 Libderiv->deriv2_classes[1][5][23] = int_stack + 14952;
 Libderiv->deriv2_classes[1][6][23] = int_stack + 15015;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 15099;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 15225;
 Libderiv->deriv2_classes[1][5][22] = int_stack + 15393;
 Libderiv->deriv2_classes[1][6][22] = int_stack + 15456;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 15540;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 15666;
 Libderiv->deriv2_classes[1][5][21] = int_stack + 15834;
 Libderiv->deriv2_classes[1][6][21] = int_stack + 15897;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 15981;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 16107;
 Libderiv->deriv2_classes[1][5][20] = int_stack + 16275;
 Libderiv->deriv2_classes[1][6][20] = int_stack + 16338;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 16422;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 16548;
 Libderiv->deriv2_classes[1][5][19] = int_stack + 16716;
 Libderiv->deriv2_classes[1][6][19] = int_stack + 16779;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 16863;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 16989;
 Libderiv->deriv2_classes[1][5][18] = int_stack + 17157;
 Libderiv->deriv2_classes[1][6][18] = int_stack + 17220;
 Libderiv->deriv_classes[2][5][1] = int_stack + 17304;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 17430;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 17556;
 Libderiv->deriv2_classes[1][5][14] = int_stack + 17724;
 Libderiv->deriv2_classes[1][6][14] = int_stack + 17787;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 17871;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 17997;
 Libderiv->deriv2_classes[1][5][13] = int_stack + 18165;
 Libderiv->deriv2_classes[1][6][13] = int_stack + 18228;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 18312;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 18438;
 Libderiv->deriv_classes[1][5][11] = int_stack + 18606;
 Libderiv->deriv_classes[1][6][11] = int_stack + 18669;
 Libderiv->deriv2_classes[1][5][11] = int_stack + 18753;
 Libderiv->deriv2_classes[1][6][11] = int_stack + 18816;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 18900;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 19026;
 Libderiv->deriv_classes[1][5][10] = int_stack + 19194;
 Libderiv->deriv_classes[1][6][10] = int_stack + 19257;
 Libderiv->deriv2_classes[1][5][10] = int_stack + 19341;
 Libderiv->deriv2_classes[1][6][10] = int_stack + 19404;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 19488;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 19614;
 Libderiv->deriv_classes[1][5][9] = int_stack + 19782;
 Libderiv->deriv_classes[1][6][9] = int_stack + 19845;
 Libderiv->deriv2_classes[1][5][9] = int_stack + 19929;
 Libderiv->deriv2_classes[1][6][9] = int_stack + 19992;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 20076;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 20202;
 Libderiv->deriv_classes[1][5][8] = int_stack + 20370;
 Libderiv->deriv_classes[1][6][8] = int_stack + 20433;
 Libderiv->deriv2_classes[1][5][8] = int_stack + 20517;
 Libderiv->deriv2_classes[1][6][8] = int_stack + 20580;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 20664;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 20790;
 Libderiv->deriv_classes[1][5][7] = int_stack + 20958;
 Libderiv->deriv_classes[1][6][7] = int_stack + 21021;
 Libderiv->deriv2_classes[1][5][7] = int_stack + 21105;
 Libderiv->deriv2_classes[1][6][7] = int_stack + 21168;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 21252;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 21378;
 Libderiv->dvrr_classes[1][5] = int_stack + 21546;
 Libderiv->deriv_classes[1][5][6] = int_stack + 21609;
 Libderiv->deriv_classes[1][6][6] = int_stack + 21672;
 Libderiv->deriv2_classes[1][5][6] = int_stack + 21756;
 Libderiv->deriv2_classes[1][6][6] = int_stack + 21819;
 Libderiv->deriv_classes[2][5][0] = int_stack + 21903;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 22029;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 22155;
 Libderiv->deriv_classes[1][5][2] = int_stack + 22323;
 Libderiv->deriv_classes[1][6][2] = int_stack + 22386;
 Libderiv->deriv2_classes[1][5][2] = int_stack + 22470;
 Libderiv->deriv2_classes[1][6][2] = int_stack + 22533;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 22617;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 22743;
 Libderiv->deriv_classes[1][5][1] = int_stack + 22911;
 Libderiv->deriv_classes[1][6][1] = int_stack + 22974;
 Libderiv->deriv2_classes[1][5][1] = int_stack + 23058;
 Libderiv->deriv2_classes[1][6][1] = int_stack + 23121;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 23205;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 23331;
 Libderiv->deriv_classes[1][5][0] = int_stack + 23499;
 Libderiv->deriv_classes[1][6][0] = int_stack + 23562;
 Libderiv->deriv2_classes[1][5][0] = int_stack + 23646;
 Libderiv->deriv2_classes[1][6][0] = int_stack + 23709;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 23793;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 23919;
 memset(int_stack,0,192696);

 Libderiv->dvrr_stack = int_stack + 34482;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_pphp(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24087,int_stack+18669,int_stack+18606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21546,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24276,int_stack+0,int_stack+8484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24654,int_stack+19257,int_stack+19194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21546, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24843,int_stack+168,int_stack+9051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+19845,int_stack+19782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21546, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25221,int_stack+336,int_stack+9618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189,int_stack+20433,int_stack+20370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25599,int_stack+504,int_stack+10185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+21021,int_stack+20958, 0.0, zero_stack, 1.0, int_stack+21546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25977,int_stack+672,int_stack+10752, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+567,int_stack+21672,int_stack+21609, 1.0, int_stack+21546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26355,int_stack+966,int_stack+11319, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+1470,int_stack+21546,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+22386,int_stack+22323,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26733,int_stack+1134,int_stack+14091,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+27111,int_stack+22974,int_stack+22911,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+27300,int_stack+1302,int_stack+17304,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1134,int_stack+23562,int_stack+23499,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+27678,int_stack+1554,int_stack+21903,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1323,int_stack+1785,int_stack+1722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18606,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28056,int_stack+1995,int_stack+1869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8484,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1512,int_stack+2226,int_stack+2163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18606, 1.0, int_stack+19194,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1701,int_stack+2436,int_stack+2310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8484, 1.0, int_stack+9051,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2079,int_stack+2667,int_stack+2604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19194, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2268,int_stack+2877,int_stack+2751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9051, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2646,int_stack+3108,int_stack+3045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18606, 0.0, zero_stack, 1.0, int_stack+19782,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28434,int_stack+3318,int_stack+3192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8484, 0.0, zero_stack, 1.0, int_stack+9618,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28812,int_stack+3549,int_stack+3486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19194, 1.0, int_stack+19782, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2835,int_stack+3759,int_stack+3633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9051, 1.0, int_stack+9618, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3213,int_stack+3990,int_stack+3927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19782, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3402,int_stack+4200,int_stack+4074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9618, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+4431,int_stack+4368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18606, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20370,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3969,int_stack+4641,int_stack+4515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10185,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4347,int_stack+4872,int_stack+4809, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19194, 0.0, zero_stack, 1.0, int_stack+20370, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4536,int_stack+5082,int_stack+4956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9051, 0.0, zero_stack, 1.0, int_stack+10185, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4914,int_stack+5313,int_stack+5250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19782, 1.0, int_stack+20370, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29001,int_stack+5523,int_stack+5397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9618, 1.0, int_stack+10185, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5103,int_stack+5754,int_stack+5691, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5292,int_stack+5964,int_stack+5838, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+10185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5670,int_stack+6195,int_stack+6132, 0.0, zero_stack, 1.0, int_stack+18606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20958,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5859,int_stack+6405,int_stack+6279, 0.0, zero_stack, 1.0, int_stack+8484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10752,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6237,int_stack+6636,int_stack+6573, 0.0, zero_stack, 1.0, int_stack+19194, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20958, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29379,int_stack+6846,int_stack+6720, 0.0, zero_stack, 1.0, int_stack+9051, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10752, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6426,int_stack+7077,int_stack+7014, 0.0, zero_stack, 1.0, int_stack+19782, 0.0, zero_stack, 1.0, int_stack+20958, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6615,int_stack+7287,int_stack+7161, 0.0, zero_stack, 1.0, int_stack+9618, 0.0, zero_stack, 1.0, int_stack+10752, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6993,int_stack+7518,int_stack+7455, 0.0, zero_stack, 1.0, int_stack+20370, 1.0, int_stack+20958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7182,int_stack+7728,int_stack+7602, 0.0, zero_stack, 1.0, int_stack+10185, 1.0, int_stack+10752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7560,int_stack+7959,int_stack+7896, 0.0, zero_stack, 2.0, int_stack+20958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29757,int_stack+8169,int_stack+8043, 0.0, zero_stack, 2.0, int_stack+10752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7749,int_stack+8400,int_stack+8337, 1.0, int_stack+18606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21609,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7938,int_stack+8736,int_stack+8610, 1.0, int_stack+8484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11319,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8316,int_stack+8967,int_stack+8904, 1.0, int_stack+19194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21609, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8505,int_stack+9303,int_stack+9177, 1.0, int_stack+9051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11319, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8883,int_stack+9534,int_stack+9471, 1.0, int_stack+19782, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21609, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9072,int_stack+9870,int_stack+9744, 1.0, int_stack+9618, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11319, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+10101,int_stack+10038, 1.0, int_stack+20370, 0.0, zero_stack, 1.0, int_stack+21609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9639,int_stack+10437,int_stack+10311, 1.0, int_stack+10185, 0.0, zero_stack, 1.0, int_stack+11319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10017,int_stack+10668,int_stack+10605, 1.0, int_stack+20958, 1.0, int_stack+21609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10206,int_stack+11004,int_stack+10878, 1.0, int_stack+10752, 1.0, int_stack+11319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10584,int_stack+11235,int_stack+11172, 2.0, int_stack+21609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10773,int_stack+11571,int_stack+11445, 2.0, int_stack+11319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11151,int_stack+11802,int_stack+11739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22323,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11340,int_stack+12012,int_stack+11886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14091,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11718,int_stack+12243,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22323, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11907,int_stack+12453,int_stack+12327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14091, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+12684,int_stack+12621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22323, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30135,int_stack+12894,int_stack+12768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14091, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12474,int_stack+13125,int_stack+13062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12663,int_stack+13335,int_stack+13209, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13041,int_stack+13566,int_stack+13503, 0.0, zero_stack, 1.0, int_stack+22323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13230,int_stack+13776,int_stack+13650, 0.0, zero_stack, 1.0, int_stack+14091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13608,int_stack+14007,int_stack+13944, 1.0, int_stack+22323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30513,int_stack+14343,int_stack+14217, 1.0, int_stack+14091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13797,int_stack+14574,int_stack+14511,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13986,int_stack+14784,int_stack+14658,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14364,int_stack+15015,int_stack+14952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22911,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14553,int_stack+15225,int_stack+15099, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17304,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14931,int_stack+15456,int_stack+15393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22911, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15120,int_stack+15666,int_stack+15540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17304, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15498,int_stack+15897,int_stack+15834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22911, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30891,int_stack+16107,int_stack+15981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17304, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15687,int_stack+16338,int_stack+16275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15876,int_stack+16548,int_stack+16422, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16254,int_stack+16779,int_stack+16716, 0.0, zero_stack, 1.0, int_stack+22911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16443,int_stack+16989,int_stack+16863, 0.0, zero_stack, 1.0, int_stack+17304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16821,int_stack+17220,int_stack+17157, 1.0, int_stack+22911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31269,int_stack+17556,int_stack+17430, 1.0, int_stack+17304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+17010,int_stack+17787,int_stack+17724,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+17199,int_stack+17997,int_stack+17871,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+17577,int_stack+18228,int_stack+18165,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+17766,int_stack+18438,int_stack+18312,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18144,int_stack+18816,int_stack+18753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23499,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18333,int_stack+19026,int_stack+18900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21903,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18711,int_stack+19404,int_stack+19341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23499, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18900,int_stack+19614,int_stack+19488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21903, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19278,int_stack+19992,int_stack+19929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23499, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19467,int_stack+20202,int_stack+20076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21903, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19845,int_stack+20580,int_stack+20517, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20034,int_stack+20790,int_stack+20664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20412,int_stack+21168,int_stack+21105, 0.0, zero_stack, 1.0, int_stack+23499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20601,int_stack+21378,int_stack+21252, 0.0, zero_stack, 1.0, int_stack+21903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20979,int_stack+21819,int_stack+21756, 1.0, int_stack+23499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21168,int_stack+22155,int_stack+22029, 1.0, int_stack+21903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21546,int_stack+22533,int_stack+22470,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+21735,int_stack+22743,int_stack+22617,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22113,int_stack+23121,int_stack+23058,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22302,int_stack+23331,int_stack+23205,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22680,int_stack+23709,int_stack+23646,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22869,int_stack+23919,int_stack+23793,6);
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+23247,int_stack+24276,int_stack+24087,63);
     Libderiv->ABCD[11] = int_stack + 23247;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+31647,int_stack+24843,int_stack+24654,63);
     Libderiv->ABCD[10] = int_stack + 31647;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+32214,int_stack+25221,int_stack+0,63);
     Libderiv->ABCD[9] = int_stack + 32214;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+24843,int_stack+25599,int_stack+189,63);
     Libderiv->ABCD[8] = int_stack + 24843;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+25410,int_stack+25977,int_stack+378,63);
     Libderiv->ABCD[7] = int_stack + 25410;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+32781,int_stack+26355,int_stack+567,63);
     Libderiv->ABCD[6] = int_stack + 32781;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+25977,int_stack+26733,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[2] = int_stack + 25977;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+26544,int_stack+27300,int_stack+27111, 0.0, zero_stack, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[1] = int_stack + 26544;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+33348,int_stack+27678,int_stack+1134, 1.0, int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[0] = int_stack + 33348;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+27300,int_stack+28056,int_stack+1323,63);
     Libderiv->ABCD[155] = int_stack + 27300;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+27867,int_stack+1701,int_stack+1512,63);
     Libderiv->ABCD[143] = int_stack + 27867;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1323,int_stack+2268,int_stack+2079,63);
     Libderiv->ABCD[142] = int_stack + 1323;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1890,int_stack+28434,int_stack+2646,63);
     Libderiv->ABCD[131] = int_stack + 1890;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+33915,int_stack+2835,int_stack+28812,63);
     Libderiv->ABCD[130] = int_stack + 33915;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+28434,int_stack+3402,int_stack+3213,63);
     Libderiv->ABCD[129] = int_stack + 28434;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+2457,int_stack+3969,int_stack+3780,63);
     Libderiv->ABCD[119] = int_stack + 2457;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3024,int_stack+4536,int_stack+4347,63);
     Libderiv->ABCD[118] = int_stack + 3024;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+3591,int_stack+29001,int_stack+4914,63);
     Libderiv->ABCD[117] = int_stack + 3591;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4158,int_stack+5292,int_stack+5103,63);
     Libderiv->ABCD[116] = int_stack + 4158;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+4725,int_stack+5859,int_stack+5670,63);
     Libderiv->ABCD[107] = int_stack + 4725;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5292,int_stack+29379,int_stack+6237,63);
     Libderiv->ABCD[106] = int_stack + 5292;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+5859,int_stack+6615,int_stack+6426,63);
     Libderiv->ABCD[105] = int_stack + 5859;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+6426,int_stack+7182,int_stack+6993,63);
     Libderiv->ABCD[104] = int_stack + 6426;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+6993,int_stack+29757,int_stack+7560,63);
     Libderiv->ABCD[103] = int_stack + 6993;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+29001,int_stack+7938,int_stack+7749,63);
     Libderiv->ABCD[95] = int_stack + 29001;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+29568,int_stack+8505,int_stack+8316,63);
     Libderiv->ABCD[94] = int_stack + 29568;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+7560,int_stack+9072,int_stack+8883,63);
     Libderiv->ABCD[93] = int_stack + 7560;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+8127,int_stack+9639,int_stack+9450,63);
     Libderiv->ABCD[92] = int_stack + 8127;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+8694,int_stack+10206,int_stack+10017,63);
     Libderiv->ABCD[91] = int_stack + 8694;
 /*--- compute (pp|hp) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+9261,int_stack+10773,int_stack+10584,63);
     Libderiv->ABCD[90] = int_stack + 9261;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+9828,int_stack+11340,int_stack+11151, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[47] = int_stack + 9828;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+10395,int_stack+11907,int_stack+11718, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[46] = int_stack + 10395;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+10962,int_stack+30135,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[45] = int_stack + 10962;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+11529,int_stack+12663,int_stack+12474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[44] = int_stack + 11529;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+12096,int_stack+13230,int_stack+13041, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[43] = int_stack + 12096;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+12663,int_stack+30513,int_stack+13608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[42] = int_stack + 12663;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+13230,int_stack+13986,int_stack+13797, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[38] = int_stack + 13230;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+13797,int_stack+14553,int_stack+14364, 0.0, zero_stack, 1.0, int_stack+24087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[35] = int_stack + 13797;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+14364,int_stack+15120,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+24654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[34] = int_stack + 14364;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+14931,int_stack+30891,int_stack+15498, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[33] = int_stack + 14931;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+30135,int_stack+15876,int_stack+15687, 0.0, zero_stack, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[32] = int_stack + 30135;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+30702,int_stack+16443,int_stack+16254, 0.0, zero_stack, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[31] = int_stack + 30702;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+15498,int_stack+31269,int_stack+16821, 0.0, zero_stack, 1.0, int_stack+567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[30] = int_stack + 15498;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+16065,int_stack+17199,int_stack+17010, 0.0, zero_stack, 1.0, int_stack+945, 1.0, int_stack+27111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[26] = int_stack + 16065;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+16632,int_stack+17766,int_stack+17577, 0.0, zero_stack, 2.0, int_stack+27111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[25] = int_stack + 16632;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+17199,int_stack+18333,int_stack+18144, 1.0, int_stack+24087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[23] = int_stack + 17199;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+17766,int_stack+18900,int_stack+18711, 1.0, int_stack+24654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[22] = int_stack + 17766;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+18333,int_stack+19467,int_stack+19278, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[21] = int_stack + 18333;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+18900,int_stack+20034,int_stack+19845, 1.0, int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[20] = int_stack + 18900;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+19467,int_stack+20601,int_stack+20412, 1.0, int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[19] = int_stack + 19467;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+21168,int_stack+20979, 1.0, int_stack+567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[18] = int_stack + 0;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+20034,int_stack+21735,int_stack+21546, 1.0, int_stack+945, 0.0, zero_stack, 1.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[14] = int_stack + 20034;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+567,int_stack+22302,int_stack+22113, 1.0, int_stack+27111, 1.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[13] = int_stack + 567;
 /*--- compute (pp|hp) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+20601,int_stack+22869,int_stack+22680, 2.0, int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[12] = int_stack + 20601;

}
