/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_f0f0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (f0|f0) integrals */

void d1hrr_order_f0f0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][3][11] = int_stack + 0;
 Libderiv->deriv_classes[3][3][10] = int_stack + 100;
 Libderiv->deriv_classes[3][3][9] = int_stack + 200;
 Libderiv->deriv_classes[3][3][8] = int_stack + 300;
 Libderiv->deriv_classes[3][3][7] = int_stack + 400;
 Libderiv->deriv_classes[3][3][6] = int_stack + 500;
 Libderiv->deriv_classes[3][3][2] = int_stack + 600;
 Libderiv->deriv_classes[3][3][1] = int_stack + 700;
 Libderiv->deriv_classes[3][3][0] = int_stack + 800;
 memset(int_stack,0,7200);

 Libderiv->dvrr_stack = int_stack + 900;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_f0f0(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[10] = int_stack + 100;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[9] = int_stack + 200;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[8] = int_stack + 300;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[7] = int_stack + 400;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[6] = int_stack + 500;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[2] = int_stack + 600;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[1] = int_stack + 700;
 /*--- compute (f0|f0) ---*/
     Libderiv->ABCD[0] = int_stack + 800;

}
