/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_g0if(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|if) integrals */

void d1hrr_order_g0if(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][6][11] = int_stack + 0;
 Libderiv->deriv_classes[4][7][11] = int_stack + 420;
 Libderiv->deriv_classes[4][8][11] = int_stack + 960;
 Libderiv->deriv_classes[4][9][11] = int_stack + 1635;
 Libderiv->deriv_classes[4][6][10] = int_stack + 2460;
 Libderiv->deriv_classes[4][7][10] = int_stack + 2880;
 Libderiv->deriv_classes[4][8][10] = int_stack + 3420;
 Libderiv->deriv_classes[4][9][10] = int_stack + 4095;
 Libderiv->deriv_classes[4][6][9] = int_stack + 4920;
 Libderiv->deriv_classes[4][7][9] = int_stack + 5340;
 Libderiv->deriv_classes[4][8][9] = int_stack + 5880;
 Libderiv->deriv_classes[4][9][9] = int_stack + 6555;
 Libderiv->deriv_classes[4][6][8] = int_stack + 7380;
 Libderiv->deriv_classes[4][7][8] = int_stack + 7800;
 Libderiv->deriv_classes[4][8][8] = int_stack + 8340;
 Libderiv->deriv_classes[4][9][8] = int_stack + 9015;
 Libderiv->deriv_classes[4][6][7] = int_stack + 9840;
 Libderiv->deriv_classes[4][7][7] = int_stack + 10260;
 Libderiv->deriv_classes[4][8][7] = int_stack + 10800;
 Libderiv->deriv_classes[4][9][7] = int_stack + 11475;
 Libderiv->dvrr_classes[4][6] = int_stack + 12300;
 Libderiv->deriv_classes[4][6][6] = int_stack + 12720;
 Libderiv->dvrr_classes[4][7] = int_stack + 13140;
 Libderiv->deriv_classes[4][7][6] = int_stack + 13680;
 Libderiv->dvrr_classes[4][8] = int_stack + 14220;
 Libderiv->deriv_classes[4][8][6] = int_stack + 14895;
 Libderiv->deriv_classes[4][9][6] = int_stack + 15570;
 Libderiv->deriv_classes[4][6][2] = int_stack + 16395;
 Libderiv->deriv_classes[4][7][2] = int_stack + 16815;
 Libderiv->deriv_classes[4][8][2] = int_stack + 17355;
 Libderiv->deriv_classes[4][9][2] = int_stack + 18030;
 Libderiv->deriv_classes[4][6][1] = int_stack + 18855;
 Libderiv->deriv_classes[4][7][1] = int_stack + 19275;
 Libderiv->deriv_classes[4][8][1] = int_stack + 19815;
 Libderiv->deriv_classes[4][9][1] = int_stack + 20490;
 Libderiv->deriv_classes[4][6][0] = int_stack + 21315;
 Libderiv->deriv_classes[4][7][0] = int_stack + 21735;
 Libderiv->deriv_classes[4][8][0] = int_stack + 22275;
 Libderiv->deriv_classes[4][9][0] = int_stack + 22950;
 memset(int_stack,0,190200);

 Libderiv->dvrr_stack = int_stack + 66720;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_g0if(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23775,int_stack+13140,int_stack+12300,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+25035,int_stack+14220,int_stack+13140,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+26655,int_stack+25035,int_stack+23775,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29175,int_stack+420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+30435,int_stack+960,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13140,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32055,int_stack+30435,int_stack+29175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23775,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+1635,int_stack+960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14220,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+36600,int_stack+34575,int_stack+30435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25035,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+34575,int_stack+2880,int_stack+2460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29175,int_stack+3420,int_stack+2880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13140, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+29175,int_stack+34575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23775, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+4095,int_stack+3420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14220, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+39840,int_stack+34575,int_stack+29175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25035, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29175,int_stack+5340,int_stack+4920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+30435,int_stack+5880,int_stack+5340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2520,int_stack+30435,int_stack+29175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23775, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+6555,int_stack+5880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14220, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+43080,int_stack+34575,int_stack+30435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25035, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+34575,int_stack+7800,int_stack+7380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29175,int_stack+8340,int_stack+7800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5040,int_stack+29175,int_stack+34575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+9015,int_stack+8340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+46320,int_stack+34575,int_stack+29175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29175,int_stack+10260,int_stack+9840, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+30435,int_stack+10800,int_stack+10260, 0.0, zero_stack, 1.0, int_stack+13140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7560,int_stack+30435,int_stack+29175, 0.0, zero_stack, 1.0, int_stack+23775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+11475,int_stack+10800, 0.0, zero_stack, 1.0, int_stack+14220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+49560,int_stack+34575,int_stack+30435, 0.0, zero_stack, 1.0, int_stack+25035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+34575,int_stack+13680,int_stack+12720, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29175,int_stack+14895,int_stack+13680, 1.0, int_stack+13140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10080,int_stack+29175,int_stack+34575, 1.0, int_stack+23775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+15570,int_stack+14895, 1.0, int_stack+14220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12600,int_stack+34575,int_stack+29175, 1.0, int_stack+25035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+29175,int_stack+16815,int_stack+16395,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+30435,int_stack+17355,int_stack+16815,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+23775,int_stack+30435,int_stack+29175,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+18030,int_stack+17355,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+52800,int_stack+34575,int_stack+30435,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+34575,int_stack+19275,int_stack+18855,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+29175,int_stack+19815,int_stack+19275,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+15840,int_stack+29175,int_stack+34575,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+20490,int_stack+19815,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+56040,int_stack+34575,int_stack+29175,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+29175,int_stack+21735,int_stack+21315,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+30435,int_stack+22275,int_stack+21735,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+18360,int_stack+30435,int_stack+29175,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+34575,int_stack+22950,int_stack+22275,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+59280,int_stack+34575,int_stack+30435,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+62520,int_stack+36600,int_stack+32055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26655,15);
     Libderiv->ABCD[11] = int_stack + 62520;
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29175,int_stack+39840,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26655, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 29175;
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+33375,int_stack+43080,int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26655, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 33375;
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+46320,int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+37575,int_stack+49560,int_stack+7560, 0.0, zero_stack, 1.0, int_stack+26655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 37575;
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4200,int_stack+12600,int_stack+10080, 1.0, int_stack+26655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 4200;
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+8400,int_stack+52800,int_stack+23775,15);
     Libderiv->ABCD[2] = int_stack + 8400;
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+41775,int_stack+56040,int_stack+15840,15);
     Libderiv->ABCD[1] = int_stack + 41775;
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12600,int_stack+59280,int_stack+18360,15);
     Libderiv->ABCD[0] = int_stack + 12600;

}
