/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_gdhg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gd|hg) integrals */

void d1hrr_order_gdhg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[4][8][11] = int_stack + 1275;
 Libderiv->deriv_classes[4][9][11] = int_stack + 1950;
 Libderiv->deriv_classes[5][5][11] = int_stack + 2775;
 Libderiv->deriv_classes[5][6][11] = int_stack + 3216;
 Libderiv->deriv_classes[5][7][11] = int_stack + 3804;
 Libderiv->deriv_classes[5][8][11] = int_stack + 4560;
 Libderiv->deriv_classes[5][9][11] = int_stack + 5505;
 Libderiv->deriv_classes[6][5][11] = int_stack + 6660;
 Libderiv->deriv_classes[6][6][11] = int_stack + 7248;
 Libderiv->deriv_classes[6][7][11] = int_stack + 8032;
 Libderiv->deriv_classes[6][8][11] = int_stack + 9040;
 Libderiv->deriv_classes[6][9][11] = int_stack + 10300;
 Libderiv->deriv_classes[4][5][10] = int_stack + 11840;
 Libderiv->deriv_classes[4][6][10] = int_stack + 12155;
 Libderiv->deriv_classes[4][7][10] = int_stack + 12575;
 Libderiv->deriv_classes[4][8][10] = int_stack + 13115;
 Libderiv->deriv_classes[4][9][10] = int_stack + 13790;
 Libderiv->deriv_classes[5][5][10] = int_stack + 14615;
 Libderiv->deriv_classes[5][6][10] = int_stack + 15056;
 Libderiv->deriv_classes[5][7][10] = int_stack + 15644;
 Libderiv->deriv_classes[5][8][10] = int_stack + 16400;
 Libderiv->deriv_classes[5][9][10] = int_stack + 17345;
 Libderiv->deriv_classes[6][5][10] = int_stack + 18500;
 Libderiv->deriv_classes[6][6][10] = int_stack + 19088;
 Libderiv->deriv_classes[6][7][10] = int_stack + 19872;
 Libderiv->deriv_classes[6][8][10] = int_stack + 20880;
 Libderiv->deriv_classes[6][9][10] = int_stack + 22140;
 Libderiv->deriv_classes[4][5][9] = int_stack + 23680;
 Libderiv->deriv_classes[4][6][9] = int_stack + 23995;
 Libderiv->deriv_classes[4][7][9] = int_stack + 24415;
 Libderiv->deriv_classes[4][8][9] = int_stack + 24955;
 Libderiv->deriv_classes[4][9][9] = int_stack + 25630;
 Libderiv->deriv_classes[5][5][9] = int_stack + 26455;
 Libderiv->deriv_classes[5][6][9] = int_stack + 26896;
 Libderiv->deriv_classes[5][7][9] = int_stack + 27484;
 Libderiv->deriv_classes[5][8][9] = int_stack + 28240;
 Libderiv->deriv_classes[5][9][9] = int_stack + 29185;
 Libderiv->deriv_classes[6][5][9] = int_stack + 30340;
 Libderiv->deriv_classes[6][6][9] = int_stack + 30928;
 Libderiv->deriv_classes[6][7][9] = int_stack + 31712;
 Libderiv->deriv_classes[6][8][9] = int_stack + 32720;
 Libderiv->deriv_classes[6][9][9] = int_stack + 33980;
 Libderiv->deriv_classes[4][5][8] = int_stack + 35520;
 Libderiv->deriv_classes[4][6][8] = int_stack + 35835;
 Libderiv->deriv_classes[4][7][8] = int_stack + 36255;
 Libderiv->deriv_classes[4][8][8] = int_stack + 36795;
 Libderiv->deriv_classes[4][9][8] = int_stack + 37470;
 Libderiv->deriv_classes[5][5][8] = int_stack + 38295;
 Libderiv->deriv_classes[5][6][8] = int_stack + 38736;
 Libderiv->deriv_classes[5][7][8] = int_stack + 39324;
 Libderiv->deriv_classes[5][8][8] = int_stack + 40080;
 Libderiv->deriv_classes[5][9][8] = int_stack + 41025;
 Libderiv->deriv_classes[6][5][8] = int_stack + 42180;
 Libderiv->deriv_classes[6][6][8] = int_stack + 42768;
 Libderiv->deriv_classes[6][7][8] = int_stack + 43552;
 Libderiv->deriv_classes[6][8][8] = int_stack + 44560;
 Libderiv->deriv_classes[6][9][8] = int_stack + 45820;
 Libderiv->deriv_classes[4][5][7] = int_stack + 47360;
 Libderiv->deriv_classes[4][6][7] = int_stack + 47675;
 Libderiv->deriv_classes[4][7][7] = int_stack + 48095;
 Libderiv->deriv_classes[4][8][7] = int_stack + 48635;
 Libderiv->deriv_classes[4][9][7] = int_stack + 49310;
 Libderiv->deriv_classes[5][5][7] = int_stack + 50135;
 Libderiv->deriv_classes[5][6][7] = int_stack + 50576;
 Libderiv->deriv_classes[5][7][7] = int_stack + 51164;
 Libderiv->deriv_classes[5][8][7] = int_stack + 51920;
 Libderiv->deriv_classes[5][9][7] = int_stack + 52865;
 Libderiv->deriv_classes[6][5][7] = int_stack + 54020;
 Libderiv->deriv_classes[6][6][7] = int_stack + 54608;
 Libderiv->deriv_classes[6][7][7] = int_stack + 55392;
 Libderiv->deriv_classes[6][8][7] = int_stack + 56400;
 Libderiv->deriv_classes[6][9][7] = int_stack + 57660;
 Libderiv->deriv_classes[4][5][6] = int_stack + 59200;
 Libderiv->deriv_classes[4][6][6] = int_stack + 59515;
 Libderiv->deriv_classes[4][7][6] = int_stack + 59935;
 Libderiv->deriv_classes[4][8][6] = int_stack + 60475;
 Libderiv->deriv_classes[4][9][6] = int_stack + 61150;
 Libderiv->deriv_classes[5][5][6] = int_stack + 61975;
 Libderiv->deriv_classes[5][6][6] = int_stack + 62416;
 Libderiv->deriv_classes[5][7][6] = int_stack + 63004;
 Libderiv->deriv_classes[5][8][6] = int_stack + 63760;
 Libderiv->deriv_classes[5][9][6] = int_stack + 64705;
 Libderiv->dvrr_classes[6][5] = int_stack + 65860;
 Libderiv->deriv_classes[6][5][6] = int_stack + 66448;
 Libderiv->dvrr_classes[6][6] = int_stack + 67036;
 Libderiv->deriv_classes[6][6][6] = int_stack + 67820;
 Libderiv->dvrr_classes[6][7] = int_stack + 68604;
 Libderiv->deriv_classes[6][7][6] = int_stack + 69612;
 Libderiv->dvrr_classes[6][8] = int_stack + 70620;
 Libderiv->deriv_classes[6][8][6] = int_stack + 71880;
 Libderiv->deriv_classes[6][9][6] = int_stack + 73140;
 Libderiv->deriv_classes[4][5][2] = int_stack + 74680;
 Libderiv->deriv_classes[4][6][2] = int_stack + 74995;
 Libderiv->deriv_classes[4][7][2] = int_stack + 75415;
 Libderiv->deriv_classes[4][8][2] = int_stack + 75955;
 Libderiv->deriv_classes[4][9][2] = int_stack + 76630;
 Libderiv->deriv_classes[5][5][2] = int_stack + 77455;
 Libderiv->deriv_classes[5][6][2] = int_stack + 77896;
 Libderiv->deriv_classes[5][7][2] = int_stack + 78484;
 Libderiv->deriv_classes[5][8][2] = int_stack + 79240;
 Libderiv->deriv_classes[5][9][2] = int_stack + 80185;
 Libderiv->deriv_classes[6][5][2] = int_stack + 81340;
 Libderiv->deriv_classes[6][6][2] = int_stack + 81928;
 Libderiv->deriv_classes[6][7][2] = int_stack + 82712;
 Libderiv->deriv_classes[6][8][2] = int_stack + 83720;
 Libderiv->deriv_classes[6][9][2] = int_stack + 84980;
 Libderiv->deriv_classes[4][5][1] = int_stack + 86520;
 Libderiv->deriv_classes[4][6][1] = int_stack + 86835;
 Libderiv->deriv_classes[4][7][1] = int_stack + 87255;
 Libderiv->deriv_classes[4][8][1] = int_stack + 87795;
 Libderiv->deriv_classes[4][9][1] = int_stack + 88470;
 Libderiv->deriv_classes[5][5][1] = int_stack + 89295;
 Libderiv->deriv_classes[5][6][1] = int_stack + 89736;
 Libderiv->deriv_classes[5][7][1] = int_stack + 90324;
 Libderiv->deriv_classes[5][8][1] = int_stack + 91080;
 Libderiv->deriv_classes[5][9][1] = int_stack + 92025;
 Libderiv->deriv_classes[6][5][1] = int_stack + 93180;
 Libderiv->deriv_classes[6][6][1] = int_stack + 93768;
 Libderiv->deriv_classes[6][7][1] = int_stack + 94552;
 Libderiv->deriv_classes[6][8][1] = int_stack + 95560;
 Libderiv->deriv_classes[6][9][1] = int_stack + 96820;
 Libderiv->dvrr_classes[4][5] = int_stack + 98360;
 Libderiv->dvrr_classes[4][6] = int_stack + 98675;
 Libderiv->dvrr_classes[4][7] = int_stack + 99095;
 Libderiv->dvrr_classes[4][8] = int_stack + 99635;
 Libderiv->dvrr_classes[4][9] = int_stack + 100310;
 Libderiv->deriv_classes[4][5][0] = int_stack + 101135;
 Libderiv->deriv_classes[4][6][0] = int_stack + 101450;
 Libderiv->deriv_classes[4][7][0] = int_stack + 101870;
 Libderiv->deriv_classes[4][8][0] = int_stack + 102410;
 Libderiv->deriv_classes[4][9][0] = int_stack + 103085;
 Libderiv->dvrr_classes[5][5] = int_stack + 103910;
 Libderiv->dvrr_classes[5][6] = int_stack + 104351;
 Libderiv->dvrr_classes[5][7] = int_stack + 104939;
 Libderiv->dvrr_classes[5][8] = int_stack + 105695;
 Libderiv->dvrr_classes[5][9] = int_stack + 106640;
 Libderiv->deriv_classes[5][5][0] = int_stack + 107795;
 Libderiv->deriv_classes[5][6][0] = int_stack + 108236;
 Libderiv->deriv_classes[5][7][0] = int_stack + 108824;
 Libderiv->deriv_classes[5][8][0] = int_stack + 109580;
 Libderiv->deriv_classes[5][9][0] = int_stack + 110525;
 Libderiv->deriv_classes[6][5][0] = int_stack + 111680;
 Libderiv->deriv_classes[6][6][0] = int_stack + 112268;
 Libderiv->deriv_classes[6][7][0] = int_stack + 113052;
 Libderiv->deriv_classes[6][8][0] = int_stack + 114060;
 Libderiv->deriv_classes[6][9][0] = int_stack + 115320;
 memset(int_stack,0,934880);

 Libderiv->dvrr_stack = int_stack + 416221;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_gdhg(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+116860,int_stack+98675,int_stack+98360,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+117805,int_stack+99095,int_stack+98675,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+119065,int_stack+117805,int_stack+116860,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+120955,int_stack+99635,int_stack+99095,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+122575,int_stack+120955,int_stack+117805,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+125095,int_stack+122575,int_stack+119065,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+128245,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98360,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+129190,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98675,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+130450,int_stack+129190,int_stack+128245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116860,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+132340,int_stack+1275,int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99095,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+133960,int_stack+132340,int_stack+129190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117805,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+136480,int_stack+133960,int_stack+130450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119065,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+128245,int_stack+1950,int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99635,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+139630,int_stack+128245,int_stack+132340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120955,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+128245,int_stack+139630,int_stack+133960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122575,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+139630,int_stack+128245,int_stack+136480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125095,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+128245,int_stack+104351,int_stack+103910,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+129568,int_stack+104939,int_stack+104351,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+131332,int_stack+129568,int_stack+128245,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+133978,int_stack+105695,int_stack+104939,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+144355,int_stack+133978,int_stack+129568,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+147883,int_stack+144355,int_stack+131332,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136246,int_stack+3216,int_stack+2775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103910,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+137569,int_stack+3804,int_stack+3216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104351,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+137569,int_stack+136246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128245,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+152293,int_stack+4560,int_stack+3804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104939,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+154561,int_stack+152293,int_stack+137569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129568,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+158089,int_stack+154561,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131332,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+5505,int_stack+4560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105695,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+162499,int_stack+0,int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133978,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+162499,int_stack+154561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+162499,int_stack+0,int_stack+158089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147883,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+169114,int_stack+162499,int_stack+139630,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+67036,int_stack+65860,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+68604,int_stack+67036,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+152293,int_stack+1764,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+155821,int_stack+70620,int_stack+68604,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+136246,int_stack+155821,int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+183289,int_stack+136246,int_stack+152293,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+7248,int_stack+6660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65860,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+158845,int_stack+8032,int_stack+7248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67036,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+189169,int_stack+158845,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+9040,int_stack+8032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68604,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+192697,int_stack+4116,int_stack+158845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+197401,int_stack+192697,int_stack+189169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152293,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+203281,int_stack+10300,int_stack+9040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70620,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+207061,int_stack+203281,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155821,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+213109,int_stack+207061,int_stack+192697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136246,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+203281,int_stack+213109,int_stack+197401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183289,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+212101,int_stack+203281,int_stack+162499,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+12155,int_stack+11840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98360, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5061,int_stack+12575,int_stack+12155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98675, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6321,int_stack+5061,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116860, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8211,int_stack+13115,int_stack+12575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99095, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9831,int_stack+8211,int_stack+5061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117805, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+189169,int_stack+9831,int_stack+6321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119065, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4116,int_stack+13790,int_stack+13115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99635, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+192319,int_stack+4116,int_stack+8211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120955, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4116,int_stack+192319,int_stack+9831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122575, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+192319,int_stack+4116,int_stack+189169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125095, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189169,int_stack+15056,int_stack+14615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103910, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+190492,int_stack+15644,int_stack+15056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104351, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4116,int_stack+190492,int_stack+189169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128245, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6762,int_stack+16400,int_stack+15644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104939, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9030,int_stack+6762,int_stack+190492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129568, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+197044,int_stack+9030,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131332, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+189169,int_stack+17345,int_stack+16400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105695, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12558,int_stack+189169,int_stack+6762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133978, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+201454,int_stack+12558,int_stack+9030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+4116,int_stack+201454,int_stack+197044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147883, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+197044,int_stack+4116,int_stack+192319,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189169,int_stack+19088,int_stack+18500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65860, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+190933,int_stack+19872,int_stack+19088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67036, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+193285,int_stack+190933,int_stack+189169, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10731,int_stack+20880,int_stack+19872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68604, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13755,int_stack+10731,int_stack+190933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+158845,int_stack+13755,int_stack+193285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152293, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+189169,int_stack+22140,int_stack+20880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70620, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+231946,int_stack+189169,int_stack+10731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155821, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+189169,int_stack+231946,int_stack+13755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136246, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+10731,int_stack+189169,int_stack+158845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183289, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+231946,int_stack+10731,int_stack+4116,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+23995,int_stack+23680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98360, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5061,int_stack+24415,int_stack+23995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98675, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6321,int_stack+5061,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8211,int_stack+24955,int_stack+24415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99095, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9831,int_stack+8211,int_stack+5061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117805, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12351,int_stack+9831,int_stack+6321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119065, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4116,int_stack+25630,int_stack+24955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99635, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+15501,int_stack+4116,int_stack+8211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120955, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4116,int_stack+15501,int_stack+9831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+15501,int_stack+4116,int_stack+12351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125095, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+26896,int_stack+26455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103910, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5439,int_stack+27484,int_stack+26896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104351, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7203,int_stack+5439,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128245, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9849,int_stack+28240,int_stack+27484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104939, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20226,int_stack+9849,int_stack+5439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129568, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23754,int_stack+20226,int_stack+7203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131332, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4116,int_stack+29185,int_stack+28240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105695, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+158845,int_stack+4116,int_stack+9849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133978, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4116,int_stack+158845,int_stack+20226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+158845,int_stack+4116,int_stack+23754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147883, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+251791,int_stack+158845,int_stack+15501,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+30928,int_stack+30340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65860, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5880,int_stack+31712,int_stack+30928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67036, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8232,int_stack+5880,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11760,int_stack+32720,int_stack+31712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68604, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14784,int_stack+11760,int_stack+5880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19488,int_stack+14784,int_stack+8232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4116,int_stack+33980,int_stack+32720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70620, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+25368,int_stack+4116,int_stack+11760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155821, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4116,int_stack+25368,int_stack+14784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136246, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+25368,int_stack+4116,int_stack+19488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183289, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+4116,int_stack+25368,int_stack+158845,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+158845,int_stack+35835,int_stack+35520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+159790,int_stack+36255,int_stack+35835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+161050,int_stack+159790,int_stack+158845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+162940,int_stack+36795,int_stack+36255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+164560,int_stack+162940,int_stack+159790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23961,int_stack+164560,int_stack+161050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+119065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+158845,int_stack+37470,int_stack+36795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+27111,int_stack+158845,int_stack+162940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+158845,int_stack+27111,int_stack+164560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+27111,int_stack+158845,int_stack+23961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23961,int_stack+38736,int_stack+38295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25284,int_stack+39324,int_stack+38736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+158845,int_stack+25284,int_stack+23961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+161491,int_stack+40080,int_stack+39324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+163759,int_stack+161491,int_stack+25284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+31836,int_stack+163759,int_stack+158845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23961,int_stack+41025,int_stack+40080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+36246,int_stack+23961,int_stack+161491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+189169,int_stack+36246,int_stack+163759, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+158845,int_stack+189169,int_stack+31836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+265966,int_stack+158845,int_stack+27111,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189169,int_stack+42768,int_stack+42180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+65860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+190933,int_stack+43552,int_stack+42768, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+67036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+193285,int_stack+190933,int_stack+189169, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23961,int_stack+44560,int_stack+43552, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+26985,int_stack+23961,int_stack+190933, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+31689,int_stack+26985,int_stack+193285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+189169,int_stack+45820,int_stack+44560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+37569,int_stack+189169,int_stack+23961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+189169,int_stack+37569,int_stack+26985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+37569,int_stack+189169,int_stack+31689, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+280141,int_stack+37569,int_stack+158845,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+158845,int_stack+47675,int_stack+47360, 0.0, zero_stack, 1.0, int_stack+98360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+159790,int_stack+48095,int_stack+47675, 0.0, zero_stack, 1.0, int_stack+98675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+161050,int_stack+159790,int_stack+158845, 0.0, zero_stack, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+162940,int_stack+48635,int_stack+48095, 0.0, zero_stack, 1.0, int_stack+99095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+164560,int_stack+162940,int_stack+159790, 0.0, zero_stack, 1.0, int_stack+117805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+189169,int_stack+164560,int_stack+161050, 0.0, zero_stack, 1.0, int_stack+119065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+158845,int_stack+49310,int_stack+48635, 0.0, zero_stack, 1.0, int_stack+99635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+192319,int_stack+158845,int_stack+162940, 0.0, zero_stack, 1.0, int_stack+120955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+158845,int_stack+192319,int_stack+164560, 0.0, zero_stack, 1.0, int_stack+122575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+192319,int_stack+158845,int_stack+189169, 0.0, zero_stack, 1.0, int_stack+125095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189169,int_stack+50576,int_stack+50135, 0.0, zero_stack, 1.0, int_stack+103910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+190492,int_stack+51164,int_stack+50576, 0.0, zero_stack, 1.0, int_stack+104351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+158845,int_stack+190492,int_stack+189169, 0.0, zero_stack, 1.0, int_stack+128245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+161491,int_stack+51920,int_stack+51164, 0.0, zero_stack, 1.0, int_stack+104939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+163759,int_stack+161491,int_stack+190492, 0.0, zero_stack, 1.0, int_stack+129568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23961,int_stack+163759,int_stack+158845, 0.0, zero_stack, 1.0, int_stack+131332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+189169,int_stack+52865,int_stack+51920, 0.0, zero_stack, 1.0, int_stack+105695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+28371,int_stack+189169,int_stack+161491, 0.0, zero_stack, 1.0, int_stack+133978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+32907,int_stack+28371,int_stack+163759, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+158845,int_stack+32907,int_stack+23961, 0.0, zero_stack, 1.0, int_stack+147883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+23961,int_stack+158845,int_stack+192319,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38136,int_stack+54608,int_stack+54020, 0.0, zero_stack, 1.0, int_stack+65860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+39900,int_stack+55392,int_stack+54608, 0.0, zero_stack, 1.0, int_stack+67036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+42252,int_stack+39900,int_stack+38136, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+45780,int_stack+56400,int_stack+55392, 0.0, zero_stack, 1.0, int_stack+68604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+48804,int_stack+45780,int_stack+39900, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+189169,int_stack+48804,int_stack+42252, 0.0, zero_stack, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+38136,int_stack+57660,int_stack+56400, 0.0, zero_stack, 1.0, int_stack+70620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+299986,int_stack+38136,int_stack+45780, 0.0, zero_stack, 1.0, int_stack+155821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+38136,int_stack+299986,int_stack+48804, 0.0, zero_stack, 1.0, int_stack+136246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+45976,int_stack+38136,int_stack+189169, 0.0, zero_stack, 1.0, int_stack+183289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+299986,int_stack+45976,int_stack+158845,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+158845,int_stack+59515,int_stack+59200, 1.0, int_stack+98360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+159790,int_stack+59935,int_stack+59515, 1.0, int_stack+98675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+161050,int_stack+159790,int_stack+158845, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+162940,int_stack+60475,int_stack+59935, 1.0, int_stack+99095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+164560,int_stack+162940,int_stack+159790, 1.0, int_stack+117805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+189169,int_stack+164560,int_stack+161050, 1.0, int_stack+119065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+116860,int_stack+61150,int_stack+60475, 1.0, int_stack+99635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+158845,int_stack+116860,int_stack+162940, 1.0, int_stack+120955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+192319,int_stack+158845,int_stack+164560, 1.0, int_stack+122575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+158845,int_stack+192319,int_stack+189169, 1.0, int_stack+125095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189169,int_stack+62416,int_stack+61975, 1.0, int_stack+103910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+190492,int_stack+63004,int_stack+62416, 1.0, int_stack+104351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+192256,int_stack+190492,int_stack+189169, 1.0, int_stack+128245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163570,int_stack+63760,int_stack+63004, 1.0, int_stack+104939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+116860,int_stack+163570,int_stack+190492, 1.0, int_stack+129568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+38136,int_stack+116860,int_stack+192256, 1.0, int_stack+131332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+128245,int_stack+64705,int_stack+63760, 1.0, int_stack+105695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+189169,int_stack+128245,int_stack+163570, 1.0, int_stack+133978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+42546,int_stack+189169,int_stack+116860, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+189169,int_stack+42546,int_stack+38136, 1.0, int_stack+147883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+38136,int_stack+189169,int_stack+158845,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+158845,int_stack+67820,int_stack+66448, 1.0, int_stack+65860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+160609,int_stack+69612,int_stack+67820, 1.0, int_stack+67036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+162961,int_stack+160609,int_stack+158845, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+52311,int_stack+71880,int_stack+69612, 1.0, int_stack+68604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+55335,int_stack+52311,int_stack+160609, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60039,int_stack+55335,int_stack+162961, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+73140,int_stack+71880, 1.0, int_stack+70620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+158845,int_stack+0,int_stack+52311, 1.0, int_stack+155821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+65919,int_stack+158845,int_stack+55335, 1.0, int_stack+136246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+152293,int_stack+65919,int_stack+60039, 1.0, int_stack+183289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+52311,int_stack+152293,int_stack+189169,315);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+152293,int_stack+100310,int_stack+99635,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+154318,int_stack+152293,int_stack+120955,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+157558,int_stack+154318,int_stack+122575,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+152293,int_stack+157558,int_stack+125095,15);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+157018,int_stack+106640,int_stack+105695,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+159853,int_stack+157018,int_stack+133978,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+183289,int_stack+159853,int_stack+144355,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+157018,int_stack+183289,int_stack+147883,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+116860,int_stack+157018,int_stack+152293,315);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+183289,int_stack+74995,int_stack+74680,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+184234,int_stack+75415,int_stack+74995,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+185494,int_stack+184234,int_stack+183289,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+187384,int_stack+75955,int_stack+75415,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+189004,int_stack+187384,int_stack+184234,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+191524,int_stack+189004,int_stack+185494,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+183289,int_stack+76630,int_stack+75955,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+163633,int_stack+183289,int_stack+187384,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+183289,int_stack+163633,int_stack+189004,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+163633,int_stack+183289,int_stack+191524,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+183289,int_stack+77896,int_stack+77455,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+184612,int_stack+78484,int_stack+77896,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+186376,int_stack+184612,int_stack+183289,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+189022,int_stack+79240,int_stack+78484,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+191290,int_stack+189022,int_stack+184612,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+72156,int_stack+191290,int_stack+186376,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+183289,int_stack+80185,int_stack+79240,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+76566,int_stack+183289,int_stack+189022,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+183289,int_stack+76566,int_stack+191290,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+189169,int_stack+183289,int_stack+72156,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+131035,int_stack+189169,int_stack+163633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+163633,int_stack+81928,int_stack+81340,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+165397,int_stack+82712,int_stack+81928,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+72156,int_stack+165397,int_stack+163633,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+75684,int_stack+83720,int_stack+82712,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+78708,int_stack+75684,int_stack+165397,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+183289,int_stack+78708,int_stack+72156,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+163633,int_stack+84980,int_stack+83720,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+145210,int_stack+163633,int_stack+75684,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+319831,int_stack+145210,int_stack+78708,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+72156,int_stack+319831,int_stack+183289,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+319831,int_stack+72156,int_stack+189169, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+157018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+72156,int_stack+86835,int_stack+86520,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+73101,int_stack+87255,int_stack+86835,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+74361,int_stack+73101,int_stack+72156,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+76251,int_stack+87795,int_stack+87255,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+77871,int_stack+76251,int_stack+73101,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+80391,int_stack+77871,int_stack+74361,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+72156,int_stack+88470,int_stack+87795,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+83541,int_stack+72156,int_stack+76251,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+72156,int_stack+83541,int_stack+77871,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+83541,int_stack+72156,int_stack+80391,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+72156,int_stack+89736,int_stack+89295,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+73479,int_stack+90324,int_stack+89736,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+75243,int_stack+73479,int_stack+72156,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+77889,int_stack+91080,int_stack+90324,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+183289,int_stack+77889,int_stack+73479,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+186817,int_stack+183289,int_stack+75243,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+72156,int_stack+92025,int_stack+91080,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+88266,int_stack+72156,int_stack+77889,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+72156,int_stack+88266,int_stack+183289,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+145210,int_stack+72156,int_stack+186817,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+339676,int_stack+145210,int_stack+83541, 0.0, zero_stack, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+72156,int_stack+93768,int_stack+93180,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+73920,int_stack+94552,int_stack+93768,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+76272,int_stack+73920,int_stack+72156,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+79800,int_stack+95560,int_stack+94552,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+82824,int_stack+79800,int_stack+73920,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+87528,int_stack+82824,int_stack+76272,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+72156,int_stack+96820,int_stack+95560,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+93408,int_stack+72156,int_stack+79800,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+72156,int_stack+93408,int_stack+82824,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+183289,int_stack+72156,int_stack+87528,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+72156,int_stack+183289,int_stack+145210, 0.0, zero_stack, 1.0, int_stack+157018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145210,int_stack+101450,int_stack+101135,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+146155,int_stack+101870,int_stack+101450,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+147415,int_stack+146155,int_stack+145210,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+149305,int_stack+102410,int_stack+101870,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+183289,int_stack+149305,int_stack+146155,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+185809,int_stack+183289,int_stack+147415,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+145210,int_stack+103085,int_stack+102410,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+188959,int_stack+145210,int_stack+149305,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+145210,int_stack+188959,int_stack+183289,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+188959,int_stack+145210,int_stack+185809,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145210,int_stack+108236,int_stack+107795,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+146533,int_stack+108824,int_stack+108236,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+148297,int_stack+146533,int_stack+145210,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+183289,int_stack+109580,int_stack+108824,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+92001,int_stack+183289,int_stack+146533,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+95529,int_stack+92001,int_stack+148297,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+145210,int_stack+110525,int_stack+109580,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+99939,int_stack+145210,int_stack+183289,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+145210,int_stack+99939,int_stack+92001,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+99939,int_stack+145210,int_stack+95529,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+353851,int_stack+99939,int_stack+188959, 1.0, int_stack+152293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145210,int_stack+112268,int_stack+111680,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+146974,int_stack+113052,int_stack+112268,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+149326,int_stack+146974,int_stack+145210,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+152854,int_stack+114060,int_stack+113052,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+92001,int_stack+152854,int_stack+146974,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+106554,int_stack+92001,int_stack+149326,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+145210,int_stack+115320,int_stack+114060,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+183289,int_stack+145210,int_stack+152854,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+145210,int_stack+183289,int_stack+92001,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+183289,int_stack+145210,int_stack+106554,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+368026,int_stack+183289,int_stack+99939, 1.0, int_stack+157018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+387871,int_stack+212101,int_stack+169114,315);
     Libderiv->ABCD[11] = int_stack + 387871;
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+145210,int_stack+231946,int_stack+197044,315);
     Libderiv->ABCD[10] = int_stack + 145210;
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+173560,int_stack+4116,int_stack+251791,315);
     Libderiv->ABCD[9] = int_stack + 173560;
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+201910,int_stack+280141,int_stack+265966,315);
     Libderiv->ABCD[8] = int_stack + 201910;
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+230260,int_stack+299986,int_stack+23961,315);
     Libderiv->ABCD[7] = int_stack + 230260;
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+258610,int_stack+52311,int_stack+38136,315);
     Libderiv->ABCD[6] = int_stack + 258610;
 /*--- compute (gd|hg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+286960,int_stack+319831,int_stack+131035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[2] = int_stack + 286960;
 /*--- compute (gd|hg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+0,int_stack+72156,int_stack+339676, 0.0, zero_stack, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[1] = int_stack + 0;
 /*--- compute (gd|hg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+315310,int_stack+368026,int_stack+353851, 1.0, int_stack+116860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[0] = int_stack + 315310;

}
