/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_gfhg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gf|hg) integrals */

void d1hrr_order_gfhg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[4][8][11] = int_stack + 1275;
 Libderiv->deriv_classes[4][9][11] = int_stack + 1950;
 Libderiv->deriv_classes[5][5][11] = int_stack + 2775;
 Libderiv->deriv_classes[5][6][11] = int_stack + 3216;
 Libderiv->deriv_classes[5][7][11] = int_stack + 3804;
 Libderiv->deriv_classes[5][8][11] = int_stack + 4560;
 Libderiv->deriv_classes[5][9][11] = int_stack + 5505;
 Libderiv->deriv_classes[6][5][11] = int_stack + 6660;
 Libderiv->deriv_classes[6][6][11] = int_stack + 7248;
 Libderiv->deriv_classes[6][7][11] = int_stack + 8032;
 Libderiv->deriv_classes[6][8][11] = int_stack + 9040;
 Libderiv->deriv_classes[6][9][11] = int_stack + 10300;
 Libderiv->deriv_classes[7][5][11] = int_stack + 11840;
 Libderiv->deriv_classes[7][6][11] = int_stack + 12596;
 Libderiv->deriv_classes[7][7][11] = int_stack + 13604;
 Libderiv->deriv_classes[7][8][11] = int_stack + 14900;
 Libderiv->deriv_classes[7][9][11] = int_stack + 16520;
 Libderiv->deriv_classes[4][5][10] = int_stack + 18500;
 Libderiv->deriv_classes[4][6][10] = int_stack + 18815;
 Libderiv->deriv_classes[4][7][10] = int_stack + 19235;
 Libderiv->deriv_classes[4][8][10] = int_stack + 19775;
 Libderiv->deriv_classes[4][9][10] = int_stack + 20450;
 Libderiv->deriv_classes[5][5][10] = int_stack + 21275;
 Libderiv->deriv_classes[5][6][10] = int_stack + 21716;
 Libderiv->deriv_classes[5][7][10] = int_stack + 22304;
 Libderiv->deriv_classes[5][8][10] = int_stack + 23060;
 Libderiv->deriv_classes[5][9][10] = int_stack + 24005;
 Libderiv->deriv_classes[6][5][10] = int_stack + 25160;
 Libderiv->deriv_classes[6][6][10] = int_stack + 25748;
 Libderiv->deriv_classes[6][7][10] = int_stack + 26532;
 Libderiv->deriv_classes[6][8][10] = int_stack + 27540;
 Libderiv->deriv_classes[6][9][10] = int_stack + 28800;
 Libderiv->deriv_classes[7][5][10] = int_stack + 30340;
 Libderiv->deriv_classes[7][6][10] = int_stack + 31096;
 Libderiv->deriv_classes[7][7][10] = int_stack + 32104;
 Libderiv->deriv_classes[7][8][10] = int_stack + 33400;
 Libderiv->deriv_classes[7][9][10] = int_stack + 35020;
 Libderiv->deriv_classes[4][5][9] = int_stack + 37000;
 Libderiv->deriv_classes[4][6][9] = int_stack + 37315;
 Libderiv->deriv_classes[4][7][9] = int_stack + 37735;
 Libderiv->deriv_classes[4][8][9] = int_stack + 38275;
 Libderiv->deriv_classes[4][9][9] = int_stack + 38950;
 Libderiv->deriv_classes[5][5][9] = int_stack + 39775;
 Libderiv->deriv_classes[5][6][9] = int_stack + 40216;
 Libderiv->deriv_classes[5][7][9] = int_stack + 40804;
 Libderiv->deriv_classes[5][8][9] = int_stack + 41560;
 Libderiv->deriv_classes[5][9][9] = int_stack + 42505;
 Libderiv->deriv_classes[6][5][9] = int_stack + 43660;
 Libderiv->deriv_classes[6][6][9] = int_stack + 44248;
 Libderiv->deriv_classes[6][7][9] = int_stack + 45032;
 Libderiv->deriv_classes[6][8][9] = int_stack + 46040;
 Libderiv->deriv_classes[6][9][9] = int_stack + 47300;
 Libderiv->deriv_classes[7][5][9] = int_stack + 48840;
 Libderiv->deriv_classes[7][6][9] = int_stack + 49596;
 Libderiv->deriv_classes[7][7][9] = int_stack + 50604;
 Libderiv->deriv_classes[7][8][9] = int_stack + 51900;
 Libderiv->deriv_classes[7][9][9] = int_stack + 53520;
 Libderiv->deriv_classes[4][5][8] = int_stack + 55500;
 Libderiv->deriv_classes[4][6][8] = int_stack + 55815;
 Libderiv->deriv_classes[4][7][8] = int_stack + 56235;
 Libderiv->deriv_classes[4][8][8] = int_stack + 56775;
 Libderiv->deriv_classes[4][9][8] = int_stack + 57450;
 Libderiv->deriv_classes[5][5][8] = int_stack + 58275;
 Libderiv->deriv_classes[5][6][8] = int_stack + 58716;
 Libderiv->deriv_classes[5][7][8] = int_stack + 59304;
 Libderiv->deriv_classes[5][8][8] = int_stack + 60060;
 Libderiv->deriv_classes[5][9][8] = int_stack + 61005;
 Libderiv->deriv_classes[6][5][8] = int_stack + 62160;
 Libderiv->deriv_classes[6][6][8] = int_stack + 62748;
 Libderiv->deriv_classes[6][7][8] = int_stack + 63532;
 Libderiv->deriv_classes[6][8][8] = int_stack + 64540;
 Libderiv->deriv_classes[6][9][8] = int_stack + 65800;
 Libderiv->deriv_classes[7][5][8] = int_stack + 67340;
 Libderiv->deriv_classes[7][6][8] = int_stack + 68096;
 Libderiv->deriv_classes[7][7][8] = int_stack + 69104;
 Libderiv->deriv_classes[7][8][8] = int_stack + 70400;
 Libderiv->deriv_classes[7][9][8] = int_stack + 72020;
 Libderiv->deriv_classes[4][5][7] = int_stack + 74000;
 Libderiv->deriv_classes[4][6][7] = int_stack + 74315;
 Libderiv->deriv_classes[4][7][7] = int_stack + 74735;
 Libderiv->deriv_classes[4][8][7] = int_stack + 75275;
 Libderiv->deriv_classes[4][9][7] = int_stack + 75950;
 Libderiv->deriv_classes[5][5][7] = int_stack + 76775;
 Libderiv->deriv_classes[5][6][7] = int_stack + 77216;
 Libderiv->deriv_classes[5][7][7] = int_stack + 77804;
 Libderiv->deriv_classes[5][8][7] = int_stack + 78560;
 Libderiv->deriv_classes[5][9][7] = int_stack + 79505;
 Libderiv->deriv_classes[6][5][7] = int_stack + 80660;
 Libderiv->deriv_classes[6][6][7] = int_stack + 81248;
 Libderiv->deriv_classes[6][7][7] = int_stack + 82032;
 Libderiv->deriv_classes[6][8][7] = int_stack + 83040;
 Libderiv->deriv_classes[6][9][7] = int_stack + 84300;
 Libderiv->deriv_classes[7][5][7] = int_stack + 85840;
 Libderiv->deriv_classes[7][6][7] = int_stack + 86596;
 Libderiv->deriv_classes[7][7][7] = int_stack + 87604;
 Libderiv->deriv_classes[7][8][7] = int_stack + 88900;
 Libderiv->deriv_classes[7][9][7] = int_stack + 90520;
 Libderiv->deriv_classes[4][5][6] = int_stack + 92500;
 Libderiv->deriv_classes[4][6][6] = int_stack + 92815;
 Libderiv->deriv_classes[4][7][6] = int_stack + 93235;
 Libderiv->deriv_classes[4][8][6] = int_stack + 93775;
 Libderiv->deriv_classes[4][9][6] = int_stack + 94450;
 Libderiv->deriv_classes[5][5][6] = int_stack + 95275;
 Libderiv->deriv_classes[5][6][6] = int_stack + 95716;
 Libderiv->deriv_classes[5][7][6] = int_stack + 96304;
 Libderiv->deriv_classes[5][8][6] = int_stack + 97060;
 Libderiv->deriv_classes[5][9][6] = int_stack + 98005;
 Libderiv->deriv_classes[6][5][6] = int_stack + 99160;
 Libderiv->deriv_classes[6][6][6] = int_stack + 99748;
 Libderiv->deriv_classes[6][7][6] = int_stack + 100532;
 Libderiv->deriv_classes[6][8][6] = int_stack + 101540;
 Libderiv->deriv_classes[6][9][6] = int_stack + 102800;
 Libderiv->dvrr_classes[7][5] = int_stack + 104340;
 Libderiv->deriv_classes[7][5][6] = int_stack + 105096;
 Libderiv->dvrr_classes[7][6] = int_stack + 105852;
 Libderiv->deriv_classes[7][6][6] = int_stack + 106860;
 Libderiv->dvrr_classes[7][7] = int_stack + 107868;
 Libderiv->deriv_classes[7][7][6] = int_stack + 109164;
 Libderiv->dvrr_classes[7][8] = int_stack + 110460;
 Libderiv->deriv_classes[7][8][6] = int_stack + 112080;
 Libderiv->deriv_classes[7][9][6] = int_stack + 113700;
 Libderiv->deriv_classes[4][5][2] = int_stack + 115680;
 Libderiv->deriv_classes[4][6][2] = int_stack + 115995;
 Libderiv->deriv_classes[4][7][2] = int_stack + 116415;
 Libderiv->deriv_classes[4][8][2] = int_stack + 116955;
 Libderiv->deriv_classes[4][9][2] = int_stack + 117630;
 Libderiv->deriv_classes[5][5][2] = int_stack + 118455;
 Libderiv->deriv_classes[5][6][2] = int_stack + 118896;
 Libderiv->deriv_classes[5][7][2] = int_stack + 119484;
 Libderiv->deriv_classes[5][8][2] = int_stack + 120240;
 Libderiv->deriv_classes[5][9][2] = int_stack + 121185;
 Libderiv->deriv_classes[6][5][2] = int_stack + 122340;
 Libderiv->deriv_classes[6][6][2] = int_stack + 122928;
 Libderiv->deriv_classes[6][7][2] = int_stack + 123712;
 Libderiv->deriv_classes[6][8][2] = int_stack + 124720;
 Libderiv->deriv_classes[6][9][2] = int_stack + 125980;
 Libderiv->deriv_classes[7][5][2] = int_stack + 127520;
 Libderiv->deriv_classes[7][6][2] = int_stack + 128276;
 Libderiv->deriv_classes[7][7][2] = int_stack + 129284;
 Libderiv->deriv_classes[7][8][2] = int_stack + 130580;
 Libderiv->deriv_classes[7][9][2] = int_stack + 132200;
 Libderiv->deriv_classes[4][5][1] = int_stack + 134180;
 Libderiv->deriv_classes[4][6][1] = int_stack + 134495;
 Libderiv->deriv_classes[4][7][1] = int_stack + 134915;
 Libderiv->deriv_classes[4][8][1] = int_stack + 135455;
 Libderiv->deriv_classes[4][9][1] = int_stack + 136130;
 Libderiv->deriv_classes[5][5][1] = int_stack + 136955;
 Libderiv->deriv_classes[5][6][1] = int_stack + 137396;
 Libderiv->deriv_classes[5][7][1] = int_stack + 137984;
 Libderiv->deriv_classes[5][8][1] = int_stack + 138740;
 Libderiv->deriv_classes[5][9][1] = int_stack + 139685;
 Libderiv->deriv_classes[6][5][1] = int_stack + 140840;
 Libderiv->deriv_classes[6][6][1] = int_stack + 141428;
 Libderiv->deriv_classes[6][7][1] = int_stack + 142212;
 Libderiv->deriv_classes[6][8][1] = int_stack + 143220;
 Libderiv->deriv_classes[6][9][1] = int_stack + 144480;
 Libderiv->deriv_classes[7][5][1] = int_stack + 146020;
 Libderiv->deriv_classes[7][6][1] = int_stack + 146776;
 Libderiv->deriv_classes[7][7][1] = int_stack + 147784;
 Libderiv->deriv_classes[7][8][1] = int_stack + 149080;
 Libderiv->deriv_classes[7][9][1] = int_stack + 150700;
 Libderiv->dvrr_classes[4][5] = int_stack + 152680;
 Libderiv->dvrr_classes[4][6] = int_stack + 152995;
 Libderiv->dvrr_classes[4][7] = int_stack + 153415;
 Libderiv->dvrr_classes[4][8] = int_stack + 153955;
 Libderiv->dvrr_classes[4][9] = int_stack + 154630;
 Libderiv->deriv_classes[4][5][0] = int_stack + 155455;
 Libderiv->deriv_classes[4][6][0] = int_stack + 155770;
 Libderiv->deriv_classes[4][7][0] = int_stack + 156190;
 Libderiv->deriv_classes[4][8][0] = int_stack + 156730;
 Libderiv->deriv_classes[4][9][0] = int_stack + 157405;
 Libderiv->dvrr_classes[5][5] = int_stack + 158230;
 Libderiv->dvrr_classes[5][6] = int_stack + 158671;
 Libderiv->dvrr_classes[5][7] = int_stack + 159259;
 Libderiv->dvrr_classes[5][8] = int_stack + 160015;
 Libderiv->dvrr_classes[5][9] = int_stack + 160960;
 Libderiv->deriv_classes[5][5][0] = int_stack + 162115;
 Libderiv->deriv_classes[5][6][0] = int_stack + 162556;
 Libderiv->deriv_classes[5][7][0] = int_stack + 163144;
 Libderiv->deriv_classes[5][8][0] = int_stack + 163900;
 Libderiv->deriv_classes[5][9][0] = int_stack + 164845;
 Libderiv->dvrr_classes[6][5] = int_stack + 166000;
 Libderiv->dvrr_classes[6][6] = int_stack + 166588;
 Libderiv->dvrr_classes[6][7] = int_stack + 167372;
 Libderiv->dvrr_classes[6][8] = int_stack + 168380;
 Libderiv->dvrr_classes[6][9] = int_stack + 169640;
 Libderiv->deriv_classes[6][5][0] = int_stack + 171180;
 Libderiv->deriv_classes[6][6][0] = int_stack + 171768;
 Libderiv->deriv_classes[6][7][0] = int_stack + 172552;
 Libderiv->deriv_classes[6][8][0] = int_stack + 173560;
 Libderiv->deriv_classes[6][9][0] = int_stack + 174820;
 Libderiv->deriv_classes[7][5][0] = int_stack + 176360;
 Libderiv->deriv_classes[7][6][0] = int_stack + 177116;
 Libderiv->deriv_classes[7][7][0] = int_stack + 178124;
 Libderiv->deriv_classes[7][8][0] = int_stack + 179420;
 Libderiv->deriv_classes[7][9][0] = int_stack + 181040;
 memset(int_stack,0,1464160);

 Libderiv->dvrr_stack = int_stack + 894932;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_gfhg(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+183020,int_stack+152995,int_stack+152680,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+183965,int_stack+153415,int_stack+152995,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+185225,int_stack+183965,int_stack+183020,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+187115,int_stack+153955,int_stack+153415,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+188735,int_stack+187115,int_stack+183965,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+191255,int_stack+188735,int_stack+185225,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+194405,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152680,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195350,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152995,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+196610,int_stack+195350,int_stack+194405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183020,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+198500,int_stack+1275,int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153415,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+200120,int_stack+198500,int_stack+195350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183965,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+202640,int_stack+200120,int_stack+196610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185225,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+194405,int_stack+1950,int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153955,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+205790,int_stack+194405,int_stack+198500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187115,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+194405,int_stack+205790,int_stack+200120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188735,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+205790,int_stack+194405,int_stack+202640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191255,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+194405,int_stack+158671,int_stack+158230,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+195728,int_stack+159259,int_stack+158671,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+197492,int_stack+195728,int_stack+194405,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+200138,int_stack+160015,int_stack+159259,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+210515,int_stack+200138,int_stack+195728,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214043,int_stack+210515,int_stack+197492,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+202406,int_stack+3216,int_stack+2775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158230,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+203729,int_stack+3804,int_stack+3216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158671,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+203729,int_stack+202406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194405,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+218453,int_stack+4560,int_stack+3804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159259,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+220721,int_stack+218453,int_stack+203729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195728,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+224249,int_stack+220721,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197492,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+5505,int_stack+4560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160015,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+228659,int_stack+0,int_stack+218453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200138,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+228659,int_stack+220721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210515,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+228659,int_stack+0,int_stack+224249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214043,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+235274,int_stack+228659,int_stack+205790,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+166588,int_stack+166000,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+167372,int_stack+166588,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+218453,int_stack+1764,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+221981,int_stack+168380,int_stack+167372,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+202406,int_stack+221981,int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+249449,int_stack+202406,int_stack+218453,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+7248,int_stack+6660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166000,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+225005,int_stack+8032,int_stack+7248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166588,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+255329,int_stack+225005,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4116,int_stack+9040,int_stack+8032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167372,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+258857,int_stack+4116,int_stack+225005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+263561,int_stack+258857,int_stack+255329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218453,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+269441,int_stack+10300,int_stack+9040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168380,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+273221,int_stack+269441,int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221981,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+279269,int_stack+273221,int_stack+258857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202406,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+269441,int_stack+279269,int_stack+263561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249449,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+278261,int_stack+269441,int_stack+228659,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+298106,int_stack+278261,int_stack+235274,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4116,int_stack+105852,int_stack+104340,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6384,int_stack+107868,int_stack+105852,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+255329,int_stack+6384,int_stack+4116,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+259865,int_stack+110460,int_stack+107868,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+225005,int_stack+259865,int_stack+6384,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+231053,int_stack+225005,int_stack+255329,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9408,int_stack+12596,int_stack+11840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104340,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+263753,int_stack+13604,int_stack+12596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105852,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+238613,int_stack+263753,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4116,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9408,int_stack+14900,int_stack+13604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107868,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+243149,int_stack+9408,int_stack+263753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6384,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+326456,int_stack+243149,int_stack+238613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255329,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+263753,int_stack+16520,int_stack+14900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+334016,int_stack+263753,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259865,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+341792,int_stack+334016,int_stack+243149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225005,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+351872,int_stack+341792,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231053,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+363212,int_stack+351872,int_stack+269441,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+389672,int_stack+363212,int_stack+278261,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+18815,int_stack+18500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152680, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327401,int_stack+19235,int_stack+18815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152995, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328661,int_stack+327401,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183020, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+330551,int_stack+19775,int_stack+19235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153415, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+332171,int_stack+330551,int_stack+327401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183965, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+334691,int_stack+332171,int_stack+328661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185225, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+20450,int_stack+19775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153955, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+337841,int_stack+326456,int_stack+330551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187115, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+337841,int_stack+332171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188735, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+337841,int_stack+326456,int_stack+334691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191255, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+21716,int_stack+21275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158230, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327779,int_stack+22304,int_stack+21716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158671, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+329543,int_stack+327779,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194405, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+332189,int_stack+23060,int_stack+22304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159259, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+342566,int_stack+332189,int_stack+327779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195728, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+346094,int_stack+342566,int_stack+329543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197492, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+24005,int_stack+23060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160015, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+350504,int_stack+326456,int_stack+332189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200138, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+350504,int_stack+342566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210515, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+350504,int_stack+326456,int_stack+346094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214043, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+357119,int_stack+350504,int_stack+337841,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+25748,int_stack+25160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166000, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+328220,int_stack+26532,int_stack+25748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166588, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+330572,int_stack+328220,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334100,int_stack+27540,int_stack+26532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167372, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+337124,int_stack+334100,int_stack+328220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+341828,int_stack+337124,int_stack+330572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218453, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+28800,int_stack+27540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168380, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+371294,int_stack+326456,int_stack+334100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221981, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+371294,int_stack+337124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202406, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+371294,int_stack+326456,int_stack+341828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249449, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+326456,int_stack+371294,int_stack+350504,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+263753,int_stack+326456,int_stack+357119,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346301,int_stack+31096,int_stack+30340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104340, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+348569,int_stack+32104,int_stack+31096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105852, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+351593,int_stack+348569,int_stack+346301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4116, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+356129,int_stack+33400,int_stack+32104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107868, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+360017,int_stack+356129,int_stack+348569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6384, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+380114,int_stack+360017,int_stack+351593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255329, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+346301,int_stack+35020,int_stack+33400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9408,int_stack+346301,int_stack+356129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259865, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+346301,int_stack+9408,int_stack+360017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225005, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9408,int_stack+346301,int_stack+380114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231053, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+429362,int_stack+9408,int_stack+371294,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+346301,int_stack+429362,int_stack+326456,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+37315,int_stack+37000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152680, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327401,int_stack+37735,int_stack+37315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152995, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328661,int_stack+327401,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+330551,int_stack+38275,int_stack+37735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153415, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+332171,int_stack+330551,int_stack+327401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183965, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+334691,int_stack+332171,int_stack+328661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185225, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+38950,int_stack+38275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153955, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+337841,int_stack+326456,int_stack+330551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187115, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+337841,int_stack+332171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188735, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+337841,int_stack+326456,int_stack+334691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191255, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+40216,int_stack+39775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158230, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327779,int_stack+40804,int_stack+40216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158671, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+329543,int_stack+327779,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194405, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+332189,int_stack+41560,int_stack+40804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159259, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+342566,int_stack+332189,int_stack+327779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195728, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+429362,int_stack+342566,int_stack+329543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197492, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+42505,int_stack+41560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160015, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+433772,int_stack+326456,int_stack+332189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200138, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+433772,int_stack+342566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+433772,int_stack+326456,int_stack+429362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214043, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+440387,int_stack+433772,int_stack+337841,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+429362,int_stack+44248,int_stack+43660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166000, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+431126,int_stack+45032,int_stack+44248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166588, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+326456,int_stack+431126,int_stack+429362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+329984,int_stack+46040,int_stack+45032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167372, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333008,int_stack+329984,int_stack+431126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+337712,int_stack+333008,int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218453, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+429362,int_stack+47300,int_stack+46040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168380, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9408,int_stack+429362,int_stack+329984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221981, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15456,int_stack+9408,int_stack+333008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202406, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+326456,int_stack+15456,int_stack+337712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249449, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+9408,int_stack+326456,int_stack+433772,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+454562,int_stack+9408,int_stack+440387,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29253,int_stack+49596,int_stack+48840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104340, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+31521,int_stack+50604,int_stack+49596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105852, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+34545,int_stack+31521,int_stack+29253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4116, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+39081,int_stack+51900,int_stack+50604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107868, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+42969,int_stack+39081,int_stack+31521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6384, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+429362,int_stack+42969,int_stack+34545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255329, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29253,int_stack+53520,int_stack+51900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+436922,int_stack+29253,int_stack+39081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259865, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29253,int_stack+436922,int_stack+42969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225005, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+436922,int_stack+29253,int_stack+429362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231053, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+482912,int_stack+436922,int_stack+326456,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+509372,int_stack+482912,int_stack+9408,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9408,int_stack+55815,int_stack+55500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10353,int_stack+56235,int_stack+55815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11613,int_stack+10353,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+13503,int_stack+56775,int_stack+56235, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15123,int_stack+13503,int_stack+10353, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17643,int_stack+15123,int_stack+11613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+185225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9408,int_stack+57450,int_stack+56775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20793,int_stack+9408,int_stack+13503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9408,int_stack+20793,int_stack+15123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+20793,int_stack+9408,int_stack+17643, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9408,int_stack+58716,int_stack+58275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10731,int_stack+59304,int_stack+58716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12495,int_stack+10731,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15141,int_stack+60060,int_stack+59304, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+25518,int_stack+15141,int_stack+10731, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+29046,int_stack+25518,int_stack+12495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9408,int_stack+61005,int_stack+60060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+33456,int_stack+9408,int_stack+15141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9408,int_stack+33456,int_stack+25518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+33456,int_stack+9408,int_stack+29046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+40071,int_stack+33456,int_stack+20793,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9408,int_stack+62748,int_stack+62160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11172,int_stack+63532,int_stack+62748, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13524,int_stack+11172,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17052,int_stack+64540,int_stack+63532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+167372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20076,int_stack+17052,int_stack+11172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+24780,int_stack+20076,int_stack+13524, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9408,int_stack+65800,int_stack+64540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+54246,int_stack+9408,int_stack+17052, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9408,int_stack+54246,int_stack+20076, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+54246,int_stack+9408,int_stack+24780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+326456,int_stack+54246,int_stack+33456,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+9408,int_stack+326456,int_stack+40071,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37758,int_stack+68096,int_stack+67340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40026,int_stack+69104,int_stack+68096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+43050,int_stack+40026,int_stack+37758, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+47586,int_stack+70400,int_stack+69104, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63066,int_stack+47586,int_stack+40026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+482912,int_stack+63066,int_stack+43050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+37758,int_stack+72020,int_stack+70400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+490472,int_stack+37758,int_stack+47586, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+37758,int_stack+490472,int_stack+63066, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+490472,int_stack+37758,int_stack+482912, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+549062,int_stack+490472,int_stack+54246,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+575522,int_stack+549062,int_stack+326456,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+74315,int_stack+74000, 0.0, zero_stack, 1.0, int_stack+152680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327401,int_stack+74735,int_stack+74315, 0.0, zero_stack, 1.0, int_stack+152995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328661,int_stack+327401,int_stack+326456, 0.0, zero_stack, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+330551,int_stack+75275,int_stack+74735, 0.0, zero_stack, 1.0, int_stack+153415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+332171,int_stack+330551,int_stack+327401, 0.0, zero_stack, 1.0, int_stack+183965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+334691,int_stack+332171,int_stack+328661, 0.0, zero_stack, 1.0, int_stack+185225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+75950,int_stack+75275, 0.0, zero_stack, 1.0, int_stack+153955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+337841,int_stack+326456,int_stack+330551, 0.0, zero_stack, 1.0, int_stack+187115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+337841,int_stack+332171, 0.0, zero_stack, 1.0, int_stack+188735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+337841,int_stack+326456,int_stack+334691, 0.0, zero_stack, 1.0, int_stack+191255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+77216,int_stack+76775, 0.0, zero_stack, 1.0, int_stack+158230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327779,int_stack+77804,int_stack+77216, 0.0, zero_stack, 1.0, int_stack+158671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+329543,int_stack+327779,int_stack+326456, 0.0, zero_stack, 1.0, int_stack+194405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+332189,int_stack+78560,int_stack+77804, 0.0, zero_stack, 1.0, int_stack+159259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+342566,int_stack+332189,int_stack+327779, 0.0, zero_stack, 1.0, int_stack+195728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+549062,int_stack+342566,int_stack+329543, 0.0, zero_stack, 1.0, int_stack+197492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+79505,int_stack+78560, 0.0, zero_stack, 1.0, int_stack+160015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+553472,int_stack+326456,int_stack+332189, 0.0, zero_stack, 1.0, int_stack+200138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+553472,int_stack+342566, 0.0, zero_stack, 1.0, int_stack+210515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+553472,int_stack+326456,int_stack+549062, 0.0, zero_stack, 1.0, int_stack+214043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+560087,int_stack+553472,int_stack+337841,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+549062,int_stack+81248,int_stack+80660, 0.0, zero_stack, 1.0, int_stack+166000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+550826,int_stack+82032,int_stack+81248, 0.0, zero_stack, 1.0, int_stack+166588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+326456,int_stack+550826,int_stack+549062, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+329984,int_stack+83040,int_stack+82032, 0.0, zero_stack, 1.0, int_stack+167372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333008,int_stack+329984,int_stack+550826, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+337712,int_stack+333008,int_stack+326456, 0.0, zero_stack, 1.0, int_stack+218453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+549062,int_stack+84300,int_stack+83040, 0.0, zero_stack, 1.0, int_stack+168380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+482912,int_stack+549062,int_stack+329984, 0.0, zero_stack, 1.0, int_stack+221981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+488960,int_stack+482912,int_stack+333008, 0.0, zero_stack, 1.0, int_stack+202406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+326456,int_stack+488960,int_stack+337712, 0.0, zero_stack, 1.0, int_stack+249449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+482912,int_stack+326456,int_stack+553472,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+37758,int_stack+482912,int_stack+560087,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+502757,int_stack+86596,int_stack+85840, 0.0, zero_stack, 1.0, int_stack+104340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+505025,int_stack+87604,int_stack+86596, 0.0, zero_stack, 1.0, int_stack+105852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+549062,int_stack+505025,int_stack+502757, 0.0, zero_stack, 1.0, int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+553598,int_stack+88900,int_stack+87604, 0.0, zero_stack, 1.0, int_stack+107868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557486,int_stack+553598,int_stack+505025, 0.0, zero_stack, 1.0, int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+563534,int_stack+557486,int_stack+549062, 0.0, zero_stack, 1.0, int_stack+255329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+502757,int_stack+90520,int_stack+88900, 0.0, zero_stack, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+335276,int_stack+502757,int_stack+553598, 0.0, zero_stack, 1.0, int_stack+259865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+66108,int_stack+335276,int_stack+557486, 0.0, zero_stack, 1.0, int_stack+225005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+549062,int_stack+66108,int_stack+563534, 0.0, zero_stack, 1.0, int_stack+231053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+615212,int_stack+549062,int_stack+326456,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+641672,int_stack+615212,int_stack+482912,315);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+482912,int_stack+92815,int_stack+92500, 1.0, int_stack+152680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+483857,int_stack+93235,int_stack+92815, 1.0, int_stack+152995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+485117,int_stack+483857,int_stack+482912, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+487007,int_stack+93775,int_stack+93235, 1.0, int_stack+153415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+488627,int_stack+487007,int_stack+483857, 1.0, int_stack+183965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+491147,int_stack+488627,int_stack+485117, 1.0, int_stack+185225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+183020,int_stack+94450,int_stack+93775, 1.0, int_stack+153955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+482912,int_stack+183020,int_stack+487007, 1.0, int_stack+187115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+494297,int_stack+482912,int_stack+488627, 1.0, int_stack+188735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+482912,int_stack+494297,int_stack+491147, 1.0, int_stack+191255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+487637,int_stack+95716,int_stack+95275, 1.0, int_stack+158230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+488960,int_stack+96304,int_stack+95716, 1.0, int_stack+158671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+490724,int_stack+488960,int_stack+487637, 1.0, int_stack+194405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+493370,int_stack+97060,int_stack+96304, 1.0, int_stack+159259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+495638,int_stack+493370,int_stack+488960, 1.0, int_stack+195728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+499166,int_stack+495638,int_stack+490724, 1.0, int_stack+197492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+194405,int_stack+98005,int_stack+97060, 1.0, int_stack+160015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+487637,int_stack+194405,int_stack+493370, 1.0, int_stack+200138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+615212,int_stack+487637,int_stack+495638, 1.0, int_stack+210515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+487637,int_stack+615212,int_stack+499166, 1.0, int_stack+214043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+615212,int_stack+487637,int_stack+482912,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+482912,int_stack+99748,int_stack+99160, 1.0, int_stack+166000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+484676,int_stack+100532,int_stack+99748, 1.0, int_stack+166588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+629387,int_stack+484676,int_stack+482912, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+632915,int_stack+101540,int_stack+100532, 1.0, int_stack+167372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+635939,int_stack+632915,int_stack+484676, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+494252,int_stack+635939,int_stack+629387, 1.0, int_stack+218453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+102800,int_stack+101540, 1.0, int_stack+168380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+500132,int_stack+0,int_stack+632915, 1.0, int_stack+221981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326456,int_stack+500132,int_stack+635939, 1.0, int_stack+202406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+500132,int_stack+326456,int_stack+494252, 1.0, int_stack+249449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+326456,int_stack+500132,int_stack+487637,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+66108,int_stack+326456,int_stack+615212,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+615212,int_stack+106860,int_stack+105096, 1.0, int_stack+104340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+617480,int_stack+109164,int_stack+106860, 1.0, int_stack+105852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+620504,int_stack+617480,int_stack+615212, 1.0, int_stack+4116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+625040,int_stack+112080,int_stack+109164, 1.0, int_stack+107868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+628928,int_stack+625040,int_stack+617480, 1.0, int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+628928,int_stack+620504, 1.0, int_stack+255329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+615212,int_stack+113700,int_stack+112080, 1.0, int_stack+110460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+482912,int_stack+615212,int_stack+625040, 1.0, int_stack+259865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+615212,int_stack+482912,int_stack+628928, 1.0, int_stack+225005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+482912,int_stack+615212,int_stack+0, 1.0, int_stack+231053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+615212,int_stack+482912,int_stack+500132,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+681362,int_stack+615212,int_stack+326456,315);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+154630,int_stack+153955,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+328481,int_stack+326456,int_stack+187115,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+331721,int_stack+328481,int_stack+188735,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+326456,int_stack+331721,int_stack+191255,15);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+331181,int_stack+160960,int_stack+160015,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+334016,int_stack+331181,int_stack+200138,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+338552,int_stack+334016,int_stack+210515,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+331181,int_stack+338552,int_stack+214043,21);
 /*--- compute (gp|hg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+615212,int_stack+331181,int_stack+326456,315);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+337796,int_stack+169640,int_stack+168380,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+629387,int_stack+337796,int_stack+221981,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+337796,int_stack+629387,int_stack+202406,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+629387,int_stack+337796,int_stack+249449,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+482912,int_stack+629387,int_stack+331181,315);
 /*--- compute (gd|hg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+183020,int_stack+482912,int_stack+615212,315);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+337796,int_stack+115995,int_stack+115680,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+338741,int_stack+116415,int_stack+115995,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+340001,int_stack+338741,int_stack+337796,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+341891,int_stack+116955,int_stack+116415,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+343511,int_stack+341891,int_stack+338741,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+638207,int_stack+343511,int_stack+340001,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+337796,int_stack+117630,int_stack+116955,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+502757,int_stack+337796,int_stack+341891,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+337796,int_stack+502757,int_stack+343511,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+502757,int_stack+337796,int_stack+638207,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+638207,int_stack+118896,int_stack+118455,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+639530,int_stack+119484,int_stack+118896,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+337796,int_stack+639530,int_stack+638207,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+340442,int_stack+120240,int_stack+119484,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+342710,int_stack+340442,int_stack+639530,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+342710,int_stack+337796,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+638207,int_stack+121185,int_stack+120240,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4410,int_stack+638207,int_stack+340442,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+211370,int_stack+4410,int_stack+342710,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+337796,int_stack+211370,int_stack+0,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+211370,int_stack+337796,int_stack+502757, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+502757,int_stack+122928,int_stack+122340,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+504521,int_stack+123712,int_stack+122928,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+504521,int_stack+502757,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3528,int_stack+124720,int_stack+123712,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+225545,int_stack+3528,int_stack+504521,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+502757,int_stack+225545,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+230249,int_stack+125980,int_stack+124720,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+234029,int_stack+230249,int_stack+3528,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+234029,int_stack+225545,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+225545,int_stack+0,int_stack+502757,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+234365,int_stack+225545,int_stack+337796, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (gd|hg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+94458,int_stack+234365,int_stack+211370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+211370,int_stack+128276,int_stack+127520,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+213638,int_stack+129284,int_stack+128276,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+216662,int_stack+213638,int_stack+211370,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+221198,int_stack+130580,int_stack+129284,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+337796,int_stack+221198,int_stack+213638,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+337796,int_stack+216662,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+211370,int_stack+132200,int_stack+130580,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+254210,int_stack+211370,int_stack+221198,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+211370,int_stack+254210,int_stack+337796,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+549062,int_stack+211370,int_stack+0,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+721052,int_stack+549062,int_stack+225545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hd|hg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+747512,int_stack+721052,int_stack+234365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+721052,int_stack+134495,int_stack+134180,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+721997,int_stack+134915,int_stack+134495,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+723257,int_stack+721997,int_stack+721052,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+725147,int_stack+135455,int_stack+134915,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+726767,int_stack+725147,int_stack+721997,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+729287,int_stack+726767,int_stack+723257,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+721052,int_stack+136130,int_stack+135455,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+732437,int_stack+721052,int_stack+725147,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+721052,int_stack+732437,int_stack+726767,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+732437,int_stack+721052,int_stack+729287,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+721052,int_stack+137396,int_stack+136955,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+722375,int_stack+137984,int_stack+137396,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+724139,int_stack+722375,int_stack+721052,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+726785,int_stack+138740,int_stack+137984,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+737162,int_stack+726785,int_stack+722375,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+740690,int_stack+737162,int_stack+724139,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+721052,int_stack+139685,int_stack+138740,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+549062,int_stack+721052,int_stack+726785,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+721052,int_stack+549062,int_stack+737162,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+502757,int_stack+721052,int_stack+740690,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+549062,int_stack+502757,int_stack+732437, 0.0, zero_stack, 1.0, int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+721052,int_stack+141428,int_stack+140840,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+722816,int_stack+142212,int_stack+141428,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+725168,int_stack+722816,int_stack+721052,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+728696,int_stack+143220,int_stack+142212,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+731720,int_stack+728696,int_stack+722816,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+736424,int_stack+731720,int_stack+725168,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+721052,int_stack+144480,int_stack+143220,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+563237,int_stack+721052,int_stack+728696,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+721052,int_stack+563237,int_stack+731720,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+563237,int_stack+721052,int_stack+736424,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+721052,int_stack+563237,int_stack+502757, 0.0, zero_stack, 1.0, int_stack+331181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (gd|hg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+211370,int_stack+721052,int_stack+549062, 0.0, zero_stack, 1.0, int_stack+615212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+549062,int_stack+146776,int_stack+146020,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+551330,int_stack+147784,int_stack+146776,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+554354,int_stack+551330,int_stack+549062,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+558890,int_stack+149080,int_stack+147784,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+502757,int_stack+558890,int_stack+551330,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+502757,int_stack+554354,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+549062,int_stack+150700,int_stack+149080,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+239720,int_stack+549062,int_stack+558890,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+549062,int_stack+239720,int_stack+502757,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+239720,int_stack+549062,int_stack+0,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+122808,int_stack+239720,int_stack+563237, 0.0, zero_stack, 1.0, int_stack+629387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hd|hg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+787202,int_stack+122808,int_stack+721052, 0.0, zero_stack, 1.0, int_stack+482912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+721052,int_stack+155770,int_stack+155455,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+721997,int_stack+156190,int_stack+155770,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+723257,int_stack+721997,int_stack+721052,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+725147,int_stack+156730,int_stack+156190,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+726767,int_stack+725147,int_stack+721997,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+729287,int_stack+726767,int_stack+723257,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+721052,int_stack+157405,int_stack+156730,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+732437,int_stack+721052,int_stack+725147,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+721052,int_stack+732437,int_stack+726767,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+732437,int_stack+721052,int_stack+729287,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+721052,int_stack+162556,int_stack+162115,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+722375,int_stack+163144,int_stack+162556,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+724139,int_stack+722375,int_stack+721052,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+726785,int_stack+163900,int_stack+163144,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+737162,int_stack+726785,int_stack+722375,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+740690,int_stack+737162,int_stack+724139,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+721052,int_stack+164845,int_stack+163900,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+122808,int_stack+721052,int_stack+726785,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+721052,int_stack+122808,int_stack+737162,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+502757,int_stack+721052,int_stack+740690,21);
 /*--- compute (gp|hg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+122808,int_stack+502757,int_stack+732437, 1.0, int_stack+326456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+326456,int_stack+171768,int_stack+171180,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+328220,int_stack+172552,int_stack+171768,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+721052,int_stack+328220,int_stack+326456,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+724580,int_stack+173560,int_stack+172552,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+727604,int_stack+724580,int_stack+328220,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+732308,int_stack+727604,int_stack+721052,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+326456,int_stack+174820,int_stack+173560,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+738188,int_stack+326456,int_stack+724580,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+136983,int_stack+738188,int_stack+727604,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+738188,int_stack+136983,int_stack+732308,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+136983,int_stack+738188,int_stack+502757, 1.0, int_stack+331181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (gd|hg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+826892,int_stack+136983,int_stack+122808, 1.0, int_stack+615212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+615212,int_stack+177116,int_stack+176360,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+617480,int_stack+178124,int_stack+177116,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+620504,int_stack+617480,int_stack+615212,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+625040,int_stack+179420,int_stack+178124,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+122808,int_stack+625040,int_stack+617480,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+128856,int_stack+122808,int_stack+620504,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+615212,int_stack+181040,int_stack+179420,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+156828,int_stack+615212,int_stack+625040,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+615212,int_stack+156828,int_stack+122808,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+156828,int_stack+615212,int_stack+128856,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+549062,int_stack+156828,int_stack+738188, 1.0, int_stack+629387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hd|hg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+855242,int_stack+549062,int_stack+136983, 1.0, int_stack+482912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (gf|hg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+122808,int_stack+389672,int_stack+298106,315);
     Libderiv->ABCD[11] = int_stack + 122808;
 /*--- compute (gf|hg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+385991,int_stack+346301,int_stack+263753,315);
     Libderiv->ABCD[10] = int_stack + 385991;
 /*--- compute (gf|hg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+239720,int_stack+509372,int_stack+454562,315);
     Libderiv->ABCD[9] = int_stack + 239720;
 /*--- compute (gf|hg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+286970,int_stack+575522,int_stack+9408,315);
     Libderiv->ABCD[8] = int_stack + 286970;
 /*--- compute (gf|hg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+334220,int_stack+641672,int_stack+37758,315);
     Libderiv->ABCD[7] = int_stack + 334220;
 /*--- compute (gf|hg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+0,int_stack+681362,int_stack+66108,315);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (gf|hg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+433241,int_stack+747512,int_stack+94458, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[2] = int_stack + 433241;
 /*--- compute (gf|hg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+47250,int_stack+787202,int_stack+211370, 0.0, zero_stack, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[1] = int_stack + 47250;
 /*--- compute (gf|hg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+480491,int_stack+855242,int_stack+826892, 1.0, int_stack+183020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[0] = int_stack + 480491;

}
