/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|hd) integrals */

void d1hrr_order_h0hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][11] = int_stack + 441;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1029;
 Libderiv->deriv_classes[5][5][10] = int_stack + 1785;
 Libderiv->deriv_classes[5][6][10] = int_stack + 2226;
 Libderiv->deriv_classes[5][7][10] = int_stack + 2814;
 Libderiv->deriv_classes[5][5][9] = int_stack + 3570;
 Libderiv->deriv_classes[5][6][9] = int_stack + 4011;
 Libderiv->deriv_classes[5][7][9] = int_stack + 4599;
 Libderiv->deriv_classes[5][5][8] = int_stack + 5355;
 Libderiv->deriv_classes[5][6][8] = int_stack + 5796;
 Libderiv->deriv_classes[5][7][8] = int_stack + 6384;
 Libderiv->deriv_classes[5][5][7] = int_stack + 7140;
 Libderiv->deriv_classes[5][6][7] = int_stack + 7581;
 Libderiv->deriv_classes[5][7][7] = int_stack + 8169;
 Libderiv->dvrr_classes[5][5] = int_stack + 8925;
 Libderiv->deriv_classes[5][5][6] = int_stack + 9366;
 Libderiv->dvrr_classes[5][6] = int_stack + 9807;
 Libderiv->deriv_classes[5][6][6] = int_stack + 10395;
 Libderiv->deriv_classes[5][7][6] = int_stack + 10983;
 Libderiv->deriv_classes[5][5][2] = int_stack + 11739;
 Libderiv->deriv_classes[5][6][2] = int_stack + 12180;
 Libderiv->deriv_classes[5][7][2] = int_stack + 12768;
 Libderiv->deriv_classes[5][5][1] = int_stack + 13524;
 Libderiv->deriv_classes[5][6][1] = int_stack + 13965;
 Libderiv->deriv_classes[5][7][1] = int_stack + 14553;
 Libderiv->deriv_classes[5][5][0] = int_stack + 15309;
 Libderiv->deriv_classes[5][6][0] = int_stack + 15750;
 Libderiv->deriv_classes[5][7][0] = int_stack + 16338;
 memset(int_stack,0,136752);

 Libderiv->dvrr_stack = int_stack + 34734;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+17094,int_stack+9807,int_stack+8925,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18417,int_stack+441,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8925,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19740,int_stack+1029,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9807,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+2226,int_stack+1785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8925, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21504,int_stack+2814,int_stack+2226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9807, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1323,int_stack+4011,int_stack+3570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8925, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23268,int_stack+4599,int_stack+4011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9807, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2646,int_stack+5796,int_stack+5355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3969,int_stack+6384,int_stack+5796, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5733,int_stack+7581,int_stack+7140, 0.0, zero_stack, 1.0, int_stack+8925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25032,int_stack+8169,int_stack+7581, 0.0, zero_stack, 1.0, int_stack+9807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7056,int_stack+10395,int_stack+9366, 1.0, int_stack+8925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26796,int_stack+10983,int_stack+10395, 1.0, int_stack+9807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8379,int_stack+12180,int_stack+11739,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9702,int_stack+12768,int_stack+12180,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11466,int_stack+13965,int_stack+13524,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+28560,int_stack+14553,int_stack+13965,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+12789,int_stack+15750,int_stack+15309,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+30324,int_stack+16338,int_stack+15750,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14112,int_stack+19740,int_stack+18417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17094,21);
     Libderiv->ABCD[11] = int_stack + 14112;
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18417,int_stack+21504,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17094, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 18417;
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+32088,int_stack+23268,int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17094, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 32088;
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+3969,int_stack+2646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2646,int_stack+25032,int_stack+5733, 0.0, zero_stack, 1.0, int_stack+17094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 2646;
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21063,int_stack+26796,int_stack+7056, 1.0, int_stack+17094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 21063;
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5292,int_stack+9702,int_stack+8379,21);
     Libderiv->ABCD[2] = int_stack + 5292;
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7938,int_stack+28560,int_stack+11466,21);
     Libderiv->ABCD[1] = int_stack + 7938;
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+23709,int_stack+30324,int_stack+12789,21);
     Libderiv->ABCD[0] = int_stack + 23709;

}
