/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0if(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|if) integrals */

void d1hrr_order_h0if(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][6][10] = int_stack + 3444;
 Libderiv->deriv_classes[5][7][10] = int_stack + 4032;
 Libderiv->deriv_classes[5][8][10] = int_stack + 4788;
 Libderiv->deriv_classes[5][9][10] = int_stack + 5733;
 Libderiv->deriv_classes[5][6][9] = int_stack + 6888;
 Libderiv->deriv_classes[5][7][9] = int_stack + 7476;
 Libderiv->deriv_classes[5][8][9] = int_stack + 8232;
 Libderiv->deriv_classes[5][9][9] = int_stack + 9177;
 Libderiv->deriv_classes[5][6][8] = int_stack + 10332;
 Libderiv->deriv_classes[5][7][8] = int_stack + 10920;
 Libderiv->deriv_classes[5][8][8] = int_stack + 11676;
 Libderiv->deriv_classes[5][9][8] = int_stack + 12621;
 Libderiv->deriv_classes[5][6][7] = int_stack + 13776;
 Libderiv->deriv_classes[5][7][7] = int_stack + 14364;
 Libderiv->deriv_classes[5][8][7] = int_stack + 15120;
 Libderiv->deriv_classes[5][9][7] = int_stack + 16065;
 Libderiv->dvrr_classes[5][6] = int_stack + 17220;
 Libderiv->deriv_classes[5][6][6] = int_stack + 17808;
 Libderiv->dvrr_classes[5][7] = int_stack + 18396;
 Libderiv->deriv_classes[5][7][6] = int_stack + 19152;
 Libderiv->dvrr_classes[5][8] = int_stack + 19908;
 Libderiv->deriv_classes[5][8][6] = int_stack + 20853;
 Libderiv->deriv_classes[5][9][6] = int_stack + 21798;
 Libderiv->deriv_classes[5][6][2] = int_stack + 22953;
 Libderiv->deriv_classes[5][7][2] = int_stack + 23541;
 Libderiv->deriv_classes[5][8][2] = int_stack + 24297;
 Libderiv->deriv_classes[5][9][2] = int_stack + 25242;
 Libderiv->deriv_classes[5][6][1] = int_stack + 26397;
 Libderiv->deriv_classes[5][7][1] = int_stack + 26985;
 Libderiv->deriv_classes[5][8][1] = int_stack + 27741;
 Libderiv->deriv_classes[5][9][1] = int_stack + 28686;
 Libderiv->deriv_classes[5][6][0] = int_stack + 29841;
 Libderiv->deriv_classes[5][7][0] = int_stack + 30429;
 Libderiv->deriv_classes[5][8][0] = int_stack + 31185;
 Libderiv->deriv_classes[5][9][0] = int_stack + 32130;
 memset(int_stack,0,266280);

 Libderiv->dvrr_stack = int_stack + 93408;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0if(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+33285,int_stack+18396,int_stack+17220,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+35049,int_stack+19908,int_stack+18396,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+37317,int_stack+35049,int_stack+33285,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40845,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17220,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42609,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18396,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+44877,int_stack+42609,int_stack+40845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33285,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19908,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+51240,int_stack+48405,int_stack+42609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35049,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+48405,int_stack+4032,int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17220, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40845,int_stack+4788,int_stack+4032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18396, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+40845,int_stack+48405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33285, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+5733,int_stack+4788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19908, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+55776,int_stack+48405,int_stack+40845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35049, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40845,int_stack+7476,int_stack+6888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17220, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42609,int_stack+8232,int_stack+7476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18396, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3528,int_stack+42609,int_stack+40845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33285, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+9177,int_stack+8232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+60312,int_stack+48405,int_stack+42609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35049, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+48405,int_stack+10920,int_stack+10332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40845,int_stack+11676,int_stack+10920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7056,int_stack+40845,int_stack+48405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+33285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+12621,int_stack+11676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+64848,int_stack+48405,int_stack+40845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40845,int_stack+14364,int_stack+13776, 0.0, zero_stack, 1.0, int_stack+17220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42609,int_stack+15120,int_stack+14364, 0.0, zero_stack, 1.0, int_stack+18396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10584,int_stack+42609,int_stack+40845, 0.0, zero_stack, 1.0, int_stack+33285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+16065,int_stack+15120, 0.0, zero_stack, 1.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+69384,int_stack+48405,int_stack+42609, 0.0, zero_stack, 1.0, int_stack+35049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+48405,int_stack+19152,int_stack+17808, 1.0, int_stack+17220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+40845,int_stack+20853,int_stack+19152, 1.0, int_stack+18396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14112,int_stack+40845,int_stack+48405, 1.0, int_stack+33285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+21798,int_stack+20853, 1.0, int_stack+19908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+17640,int_stack+48405,int_stack+40845, 1.0, int_stack+35049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+40845,int_stack+23541,int_stack+22953,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+42609,int_stack+24297,int_stack+23541,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+33285,int_stack+42609,int_stack+40845,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+25242,int_stack+24297,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+73920,int_stack+48405,int_stack+42609,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+48405,int_stack+26985,int_stack+26397,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+40845,int_stack+27741,int_stack+26985,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+22176,int_stack+40845,int_stack+48405,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+28686,int_stack+27741,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+78456,int_stack+48405,int_stack+40845,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+40845,int_stack+30429,int_stack+29841,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+42609,int_stack+31185,int_stack+30429,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+25704,int_stack+42609,int_stack+40845,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+48405,int_stack+32130,int_stack+31185,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+82992,int_stack+48405,int_stack+42609,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+87528,int_stack+51240,int_stack+44877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37317,21);
     Libderiv->ABCD[11] = int_stack + 87528;
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+40845,int_stack+55776,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37317, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 40845;
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+46725,int_stack+60312,int_stack+3528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37317, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 46725;
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+64848,int_stack+7056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+52605,int_stack+69384,int_stack+10584, 0.0, zero_stack, 1.0, int_stack+37317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 52605;
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5880,int_stack+17640,int_stack+14112, 1.0, int_stack+37317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 5880;
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+11760,int_stack+73920,int_stack+33285,21);
     Libderiv->ABCD[2] = int_stack + 11760;
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+58485,int_stack+78456,int_stack+22176,21);
     Libderiv->ABCD[1] = int_stack + 58485;
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+17640,int_stack+82992,int_stack+25704,21);
     Libderiv->ABCD[0] = int_stack + 17640;

}
