/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hdid(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hd|id) integrals */

void d1hrr_order_hdid(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[6][6][11] = int_stack + 2289;
 Libderiv->deriv_classes[6][7][11] = int_stack + 3073;
 Libderiv->deriv_classes[6][8][11] = int_stack + 4081;
 Libderiv->deriv_classes[7][6][11] = int_stack + 5341;
 Libderiv->deriv_classes[7][7][11] = int_stack + 6349;
 Libderiv->deriv_classes[7][8][11] = int_stack + 7645;
 Libderiv->deriv_classes[5][6][10] = int_stack + 9265;
 Libderiv->deriv_classes[5][7][10] = int_stack + 9853;
 Libderiv->deriv_classes[5][8][10] = int_stack + 10609;
 Libderiv->deriv_classes[6][6][10] = int_stack + 11554;
 Libderiv->deriv_classes[6][7][10] = int_stack + 12338;
 Libderiv->deriv_classes[6][8][10] = int_stack + 13346;
 Libderiv->deriv_classes[7][6][10] = int_stack + 14606;
 Libderiv->deriv_classes[7][7][10] = int_stack + 15614;
 Libderiv->deriv_classes[7][8][10] = int_stack + 16910;
 Libderiv->deriv_classes[5][6][9] = int_stack + 18530;
 Libderiv->deriv_classes[5][7][9] = int_stack + 19118;
 Libderiv->deriv_classes[5][8][9] = int_stack + 19874;
 Libderiv->deriv_classes[6][6][9] = int_stack + 20819;
 Libderiv->deriv_classes[6][7][9] = int_stack + 21603;
 Libderiv->deriv_classes[6][8][9] = int_stack + 22611;
 Libderiv->deriv_classes[7][6][9] = int_stack + 23871;
 Libderiv->deriv_classes[7][7][9] = int_stack + 24879;
 Libderiv->deriv_classes[7][8][9] = int_stack + 26175;
 Libderiv->deriv_classes[5][6][8] = int_stack + 27795;
 Libderiv->deriv_classes[5][7][8] = int_stack + 28383;
 Libderiv->deriv_classes[5][8][8] = int_stack + 29139;
 Libderiv->deriv_classes[6][6][8] = int_stack + 30084;
 Libderiv->deriv_classes[6][7][8] = int_stack + 30868;
 Libderiv->deriv_classes[6][8][8] = int_stack + 31876;
 Libderiv->deriv_classes[7][6][8] = int_stack + 33136;
 Libderiv->deriv_classes[7][7][8] = int_stack + 34144;
 Libderiv->deriv_classes[7][8][8] = int_stack + 35440;
 Libderiv->deriv_classes[5][6][7] = int_stack + 37060;
 Libderiv->deriv_classes[5][7][7] = int_stack + 37648;
 Libderiv->deriv_classes[5][8][7] = int_stack + 38404;
 Libderiv->deriv_classes[6][6][7] = int_stack + 39349;
 Libderiv->deriv_classes[6][7][7] = int_stack + 40133;
 Libderiv->deriv_classes[6][8][7] = int_stack + 41141;
 Libderiv->deriv_classes[7][6][7] = int_stack + 42401;
 Libderiv->deriv_classes[7][7][7] = int_stack + 43409;
 Libderiv->deriv_classes[7][8][7] = int_stack + 44705;
 Libderiv->deriv_classes[5][6][6] = int_stack + 46325;
 Libderiv->deriv_classes[5][7][6] = int_stack + 46913;
 Libderiv->deriv_classes[5][8][6] = int_stack + 47669;
 Libderiv->deriv_classes[6][6][6] = int_stack + 48614;
 Libderiv->deriv_classes[6][7][6] = int_stack + 49398;
 Libderiv->deriv_classes[6][8][6] = int_stack + 50406;
 Libderiv->dvrr_classes[7][6] = int_stack + 51666;
 Libderiv->deriv_classes[7][6][6] = int_stack + 52674;
 Libderiv->dvrr_classes[7][7] = int_stack + 53682;
 Libderiv->deriv_classes[7][7][6] = int_stack + 54978;
 Libderiv->deriv_classes[7][8][6] = int_stack + 56274;
 Libderiv->deriv_classes[5][6][2] = int_stack + 57894;
 Libderiv->deriv_classes[5][7][2] = int_stack + 58482;
 Libderiv->deriv_classes[5][8][2] = int_stack + 59238;
 Libderiv->deriv_classes[6][6][2] = int_stack + 60183;
 Libderiv->deriv_classes[6][7][2] = int_stack + 60967;
 Libderiv->deriv_classes[6][8][2] = int_stack + 61975;
 Libderiv->deriv_classes[7][6][2] = int_stack + 63235;
 Libderiv->deriv_classes[7][7][2] = int_stack + 64243;
 Libderiv->deriv_classes[7][8][2] = int_stack + 65539;
 Libderiv->deriv_classes[5][6][1] = int_stack + 67159;
 Libderiv->deriv_classes[5][7][1] = int_stack + 67747;
 Libderiv->deriv_classes[5][8][1] = int_stack + 68503;
 Libderiv->deriv_classes[6][6][1] = int_stack + 69448;
 Libderiv->deriv_classes[6][7][1] = int_stack + 70232;
 Libderiv->deriv_classes[6][8][1] = int_stack + 71240;
 Libderiv->deriv_classes[7][6][1] = int_stack + 72500;
 Libderiv->deriv_classes[7][7][1] = int_stack + 73508;
 Libderiv->deriv_classes[7][8][1] = int_stack + 74804;
 Libderiv->dvrr_classes[5][6] = int_stack + 76424;
 Libderiv->dvrr_classes[5][7] = int_stack + 77012;
 Libderiv->dvrr_classes[5][8] = int_stack + 77768;
 Libderiv->deriv_classes[5][6][0] = int_stack + 78713;
 Libderiv->deriv_classes[5][7][0] = int_stack + 79301;
 Libderiv->deriv_classes[5][8][0] = int_stack + 80057;
 Libderiv->dvrr_classes[6][6] = int_stack + 81002;
 Libderiv->dvrr_classes[6][7] = int_stack + 81786;
 Libderiv->dvrr_classes[6][8] = int_stack + 82794;
 Libderiv->deriv_classes[6][6][0] = int_stack + 84054;
 Libderiv->deriv_classes[6][7][0] = int_stack + 84838;
 Libderiv->deriv_classes[6][8][0] = int_stack + 85846;
 Libderiv->deriv_classes[7][6][0] = int_stack + 87106;
 Libderiv->deriv_classes[7][7][0] = int_stack + 88114;
 Libderiv->deriv_classes[7][8][0] = int_stack + 89410;
 memset(int_stack,0,728240);

 Libderiv->dvrr_stack = int_stack + 297922;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hdid(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+91030,int_stack+77012,int_stack+76424,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+92794,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76424,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+94558,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77012,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+96826,int_stack+94558,int_stack+92794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91030,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+92794,int_stack+81786,int_stack+81002,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+100354,int_stack+3073,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81002,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+4081,int_stack+3073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81786,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+102706,int_stack+0,int_stack+100354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92794,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+107410,int_stack+102706,int_stack+96826,168);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+53682,int_stack+51666,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+95146,int_stack+6349,int_stack+5341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51666,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+98170,int_stack+7645,int_stack+6349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53682,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3024,int_stack+98170,int_stack+95146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (ip|id) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+117994,int_stack+3024,int_stack+102706,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3024,int_stack+9853,int_stack+9265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76424, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4788,int_stack+10609,int_stack+9853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77012, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7056,int_stack+4788,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91030, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3024,int_stack+12338,int_stack+11554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81002, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+95146,int_stack+13346,int_stack+12338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81786, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+98170,int_stack+95146,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92794, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+132106,int_stack+98170,int_stack+7056,168);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+95146,int_stack+15614,int_stack+14606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51666, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3024,int_stack+16910,int_stack+15614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53682, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6912,int_stack+3024,int_stack+95146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (ip|id) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+142690,int_stack+6912,int_stack+98170,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+95146,int_stack+19118,int_stack+18530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76424, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+96910,int_stack+19874,int_stack+19118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77012, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+99178,int_stack+96910,int_stack+95146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+95146,int_stack+21603,int_stack+20819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81002, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+102706,int_stack+22611,int_stack+21603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81786, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3024,int_stack+102706,int_stack+95146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92794, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+7728,int_stack+3024,int_stack+99178,168);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+95146,int_stack+24879,int_stack+23871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51666, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+98170,int_stack+26175,int_stack+24879, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53682, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18312,int_stack+98170,int_stack+95146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|id) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+156802,int_stack+18312,int_stack+3024,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3024,int_stack+28383,int_stack+27795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4788,int_stack+29139,int_stack+28383, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18312,int_stack+4788,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3024,int_stack+30868,int_stack+30084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21840,int_stack+31876,int_stack+30868, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24864,int_stack+21840,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+95146,int_stack+24864,int_stack+18312,168);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18312,int_stack+34144,int_stack+33136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3024,int_stack+35440,int_stack+34144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29568,int_stack+3024,int_stack+18312, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|id) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+170914,int_stack+29568,int_stack+24864,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18312,int_stack+37648,int_stack+37060, 0.0, zero_stack, 1.0, int_stack+76424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20076,int_stack+38404,int_stack+37648, 0.0, zero_stack, 1.0, int_stack+77012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22344,int_stack+20076,int_stack+18312, 0.0, zero_stack, 1.0, int_stack+91030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18312,int_stack+40133,int_stack+39349, 0.0, zero_stack, 1.0, int_stack+81002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+25872,int_stack+41141,int_stack+40133, 0.0, zero_stack, 1.0, int_stack+81786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3024,int_stack+25872,int_stack+18312, 0.0, zero_stack, 1.0, int_stack+92794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+25872,int_stack+3024,int_stack+22344,168);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18312,int_stack+43409,int_stack+42401, 0.0, zero_stack, 1.0, int_stack+51666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21336,int_stack+44705,int_stack+43409, 0.0, zero_stack, 1.0, int_stack+53682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36456,int_stack+21336,int_stack+18312, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|id) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+185026,int_stack+36456,int_stack+3024,168);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3024,int_stack+46913,int_stack+46325, 1.0, int_stack+76424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4788,int_stack+47669,int_stack+46913, 1.0, int_stack+77012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36456,int_stack+4788,int_stack+3024, 1.0, int_stack+91030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3024,int_stack+49398,int_stack+48614, 1.0, int_stack+81002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+39984,int_stack+50406,int_stack+49398, 1.0, int_stack+81786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43008,int_stack+39984,int_stack+3024, 1.0, int_stack+92794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+199138,int_stack+43008,int_stack+36456,168);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+54978,int_stack+52674, 1.0, int_stack+51666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3024,int_stack+56274,int_stack+54978, 1.0, int_stack+53682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+47712,int_stack+3024,int_stack+36456, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|id) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+209722,int_stack+47712,int_stack+43008,168);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+77768,int_stack+77012,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2268,int_stack+0,int_stack+91030,21);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+36456,int_stack+82794,int_stack+81786,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+39480,int_stack+36456,int_stack+92794,28);
 /*--- compute (hp|id) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+44184,int_stack+39480,int_stack+2268,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+58482,int_stack+57894,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+59238,int_stack+58482,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+91030,int_stack+0,int_stack+36456,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+60967,int_stack+60183,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+54768,int_stack+61975,int_stack+60967,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+57792,int_stack+54768,int_stack+36456,28);
 /*--- compute (hp|id) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+223834,int_stack+57792,int_stack+91030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+64243,int_stack+63235,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+91030,int_stack+65539,int_stack+64243,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+18312,int_stack+91030,int_stack+36456,36);
 /*--- compute (ip|id) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+234418,int_stack+18312,int_stack+57792, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+18312,int_stack+67747,int_stack+67159,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+68503,int_stack+67747,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+20076,int_stack+0,int_stack+18312,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+70232,int_stack+69448,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+91030,int_stack+71240,int_stack+70232,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+54768,int_stack+91030,int_stack+36456,28);
 /*--- compute (hp|id) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+59472,int_stack+54768,int_stack+20076, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+73508,int_stack+72500,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+91030,int_stack+74804,int_stack+73508,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+18312,int_stack+91030,int_stack+36456,36);
 /*--- compute (ip|id) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+248530,int_stack+18312,int_stack+54768, 0.0, zero_stack, 1.0, int_stack+39480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54768,int_stack+79301,int_stack+78713,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+80057,int_stack+79301,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+18312,int_stack+0,int_stack+54768,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54768,int_stack+84838,int_stack+84054,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+36456,int_stack+85846,int_stack+84838,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+70056,int_stack+36456,int_stack+54768,28);
 /*--- compute (hp|id) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+74760,int_stack+70056,int_stack+18312, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+36456,int_stack+88114,int_stack+87106,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+18312,int_stack+89410,int_stack+88114,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+18312,int_stack+36456,36);
 /*--- compute (ip|id) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+262642,int_stack+0,int_stack+70056, 1.0, int_stack+39480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
 /*--- compute (hd|id) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+276754,int_stack+117994,int_stack+107410,168);
     Libderiv->ABCD[11] = int_stack + 276754;
 /*--- compute (hd|id) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+105730,int_stack+142690,int_stack+132106,168);
     Libderiv->ABCD[10] = int_stack + 105730;
 /*--- compute (hd|id) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+126898,int_stack+156802,int_stack+7728,168);
     Libderiv->ABCD[9] = int_stack + 126898;
 /*--- compute (hd|id) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+0,int_stack+170914,int_stack+95146,168);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (hd|id) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+148066,int_stack+185026,int_stack+25872,168);
     Libderiv->ABCD[7] = int_stack + 148066;
 /*--- compute (hd|id) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+21168,int_stack+209722,int_stack+199138,168);
     Libderiv->ABCD[6] = int_stack + 21168;
 /*--- compute (hd|id) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+169234,int_stack+234418,int_stack+223834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[2] = int_stack + 169234;
 /*--- compute (hd|id) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+190402,int_stack+248530,int_stack+59472, 0.0, zero_stack, 1.0, int_stack+44184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[1] = int_stack + 190402;
 /*--- compute (hd|id) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+211570,int_stack+262642,int_stack+74760, 1.0, int_stack+44184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,168);
     Libderiv->ABCD[0] = int_stack + 211570;

}
