/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hpip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hp|ip) integrals */

void d1hrr_order_hpip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1344;
 Libderiv->deriv_classes[6][7][11] = int_stack + 2128;
 Libderiv->deriv_classes[5][6][10] = int_stack + 3136;
 Libderiv->deriv_classes[5][7][10] = int_stack + 3724;
 Libderiv->deriv_classes[6][6][10] = int_stack + 4480;
 Libderiv->deriv_classes[6][7][10] = int_stack + 5264;
 Libderiv->deriv_classes[5][6][9] = int_stack + 6272;
 Libderiv->deriv_classes[5][7][9] = int_stack + 6860;
 Libderiv->deriv_classes[6][6][9] = int_stack + 7616;
 Libderiv->deriv_classes[6][7][9] = int_stack + 8400;
 Libderiv->deriv_classes[5][6][8] = int_stack + 9408;
 Libderiv->deriv_classes[5][7][8] = int_stack + 9996;
 Libderiv->deriv_classes[6][6][8] = int_stack + 10752;
 Libderiv->deriv_classes[6][7][8] = int_stack + 11536;
 Libderiv->deriv_classes[5][6][7] = int_stack + 12544;
 Libderiv->deriv_classes[5][7][7] = int_stack + 13132;
 Libderiv->deriv_classes[6][6][7] = int_stack + 13888;
 Libderiv->deriv_classes[6][7][7] = int_stack + 14672;
 Libderiv->deriv_classes[5][6][6] = int_stack + 15680;
 Libderiv->deriv_classes[5][7][6] = int_stack + 16268;
 Libderiv->dvrr_classes[6][6] = int_stack + 17024;
 Libderiv->deriv_classes[6][6][6] = int_stack + 17808;
 Libderiv->deriv_classes[6][7][6] = int_stack + 18592;
 Libderiv->deriv_classes[5][6][2] = int_stack + 19600;
 Libderiv->deriv_classes[5][7][2] = int_stack + 20188;
 Libderiv->deriv_classes[6][6][2] = int_stack + 20944;
 Libderiv->deriv_classes[6][7][2] = int_stack + 21728;
 Libderiv->deriv_classes[5][6][1] = int_stack + 22736;
 Libderiv->deriv_classes[5][7][1] = int_stack + 23324;
 Libderiv->deriv_classes[6][6][1] = int_stack + 24080;
 Libderiv->deriv_classes[6][7][1] = int_stack + 24864;
 Libderiv->dvrr_classes[5][6] = int_stack + 25872;
 Libderiv->dvrr_classes[5][7] = int_stack + 26460;
 Libderiv->deriv_classes[5][6][0] = int_stack + 27216;
 Libderiv->deriv_classes[5][7][0] = int_stack + 27804;
 Libderiv->deriv_classes[6][6][0] = int_stack + 28560;
 Libderiv->deriv_classes[6][7][0] = int_stack + 29344;
 memset(int_stack,0,242816);

 Libderiv->dvrr_stack = int_stack + 57400;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hpip(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+30352,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25872,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32116,int_stack+2128,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17024,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+3724,int_stack+3136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25872, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+5264,int_stack+4480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17024, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4116,int_stack+6860,int_stack+6272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25872, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+34468,int_stack+8400,int_stack+7616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17024, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5880,int_stack+9996,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7644,int_stack+11536,int_stack+10752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9996,int_stack+13132,int_stack+12544, 0.0, zero_stack, 1.0, int_stack+25872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+36820,int_stack+14672,int_stack+13888, 0.0, zero_stack, 1.0, int_stack+17024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11760,int_stack+16268,int_stack+15680, 1.0, int_stack+25872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13524,int_stack+18592,int_stack+17808, 1.0, int_stack+17024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+15876,int_stack+26460,int_stack+25872,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+17640,int_stack+20188,int_stack+19600,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39172,int_stack+21728,int_stack+20944,28);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+19404,int_stack+23324,int_stack+22736,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+21168,int_stack+24864,int_stack+24080,28);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23520,int_stack+27804,int_stack+27216,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+25284,int_stack+29344,int_stack+28560,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+41524,int_stack+32116,int_stack+30352,84);
     Libderiv->ABCD[11] = int_stack + 41524;
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+27636,int_stack+1764,int_stack+0,84);
     Libderiv->ABCD[10] = int_stack + 27636;
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+46816,int_stack+34468,int_stack+4116,84);
     Libderiv->ABCD[9] = int_stack + 46816;
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+0,int_stack+7644,int_stack+5880,84);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+52108,int_stack+36820,int_stack+9996,84);
     Libderiv->ABCD[7] = int_stack + 52108;
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+5292,int_stack+13524,int_stack+11760,84);
     Libderiv->ABCD[6] = int_stack + 5292;
 /*--- compute (hp|ip) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+10584,int_stack+39172,int_stack+17640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[2] = int_stack + 10584;
 /*--- compute (hp|ip) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+32928,int_stack+21168,int_stack+19404, 0.0, zero_stack, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[1] = int_stack + 32928;
 /*--- compute (hp|ip) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+17640,int_stack+25284,int_stack+23520, 1.0, int_stack+15876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[0] = int_stack + 17640;

}
