/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ifhg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (if|hg) integrals */

void d1hrr_order_ifhg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1372;
 Libderiv->deriv_classes[6][8][11] = int_stack + 2380;
 Libderiv->deriv_classes[6][9][11] = int_stack + 3640;
 Libderiv->deriv_classes[7][5][11] = int_stack + 5180;
 Libderiv->deriv_classes[7][6][11] = int_stack + 5936;
 Libderiv->deriv_classes[7][7][11] = int_stack + 6944;
 Libderiv->deriv_classes[7][8][11] = int_stack + 8240;
 Libderiv->deriv_classes[7][9][11] = int_stack + 9860;
 Libderiv->deriv_classes[8][5][11] = int_stack + 11840;
 Libderiv->deriv_classes[8][6][11] = int_stack + 12785;
 Libderiv->deriv_classes[8][7][11] = int_stack + 14045;
 Libderiv->deriv_classes[8][8][11] = int_stack + 15665;
 Libderiv->deriv_classes[8][9][11] = int_stack + 17690;
 Libderiv->deriv_classes[9][5][11] = int_stack + 20165;
 Libderiv->deriv_classes[9][6][11] = int_stack + 21320;
 Libderiv->deriv_classes[9][7][11] = int_stack + 22860;
 Libderiv->deriv_classes[9][8][11] = int_stack + 24840;
 Libderiv->deriv_classes[9][9][11] = int_stack + 27315;
 Libderiv->deriv_classes[6][5][10] = int_stack + 30340;
 Libderiv->deriv_classes[6][6][10] = int_stack + 30928;
 Libderiv->deriv_classes[6][7][10] = int_stack + 31712;
 Libderiv->deriv_classes[6][8][10] = int_stack + 32720;
 Libderiv->deriv_classes[6][9][10] = int_stack + 33980;
 Libderiv->deriv_classes[7][5][10] = int_stack + 35520;
 Libderiv->deriv_classes[7][6][10] = int_stack + 36276;
 Libderiv->deriv_classes[7][7][10] = int_stack + 37284;
 Libderiv->deriv_classes[7][8][10] = int_stack + 38580;
 Libderiv->deriv_classes[7][9][10] = int_stack + 40200;
 Libderiv->deriv_classes[8][5][10] = int_stack + 42180;
 Libderiv->deriv_classes[8][6][10] = int_stack + 43125;
 Libderiv->deriv_classes[8][7][10] = int_stack + 44385;
 Libderiv->deriv_classes[8][8][10] = int_stack + 46005;
 Libderiv->deriv_classes[8][9][10] = int_stack + 48030;
 Libderiv->deriv_classes[9][5][10] = int_stack + 50505;
 Libderiv->deriv_classes[9][6][10] = int_stack + 51660;
 Libderiv->deriv_classes[9][7][10] = int_stack + 53200;
 Libderiv->deriv_classes[9][8][10] = int_stack + 55180;
 Libderiv->deriv_classes[9][9][10] = int_stack + 57655;
 Libderiv->deriv_classes[6][5][9] = int_stack + 60680;
 Libderiv->deriv_classes[6][6][9] = int_stack + 61268;
 Libderiv->deriv_classes[6][7][9] = int_stack + 62052;
 Libderiv->deriv_classes[6][8][9] = int_stack + 63060;
 Libderiv->deriv_classes[6][9][9] = int_stack + 64320;
 Libderiv->deriv_classes[7][5][9] = int_stack + 65860;
 Libderiv->deriv_classes[7][6][9] = int_stack + 66616;
 Libderiv->deriv_classes[7][7][9] = int_stack + 67624;
 Libderiv->deriv_classes[7][8][9] = int_stack + 68920;
 Libderiv->deriv_classes[7][9][9] = int_stack + 70540;
 Libderiv->deriv_classes[8][5][9] = int_stack + 72520;
 Libderiv->deriv_classes[8][6][9] = int_stack + 73465;
 Libderiv->deriv_classes[8][7][9] = int_stack + 74725;
 Libderiv->deriv_classes[8][8][9] = int_stack + 76345;
 Libderiv->deriv_classes[8][9][9] = int_stack + 78370;
 Libderiv->deriv_classes[9][5][9] = int_stack + 80845;
 Libderiv->deriv_classes[9][6][9] = int_stack + 82000;
 Libderiv->deriv_classes[9][7][9] = int_stack + 83540;
 Libderiv->deriv_classes[9][8][9] = int_stack + 85520;
 Libderiv->deriv_classes[9][9][9] = int_stack + 87995;
 Libderiv->deriv_classes[6][5][8] = int_stack + 91020;
 Libderiv->deriv_classes[6][6][8] = int_stack + 91608;
 Libderiv->deriv_classes[6][7][8] = int_stack + 92392;
 Libderiv->deriv_classes[6][8][8] = int_stack + 93400;
 Libderiv->deriv_classes[6][9][8] = int_stack + 94660;
 Libderiv->deriv_classes[7][5][8] = int_stack + 96200;
 Libderiv->deriv_classes[7][6][8] = int_stack + 96956;
 Libderiv->deriv_classes[7][7][8] = int_stack + 97964;
 Libderiv->deriv_classes[7][8][8] = int_stack + 99260;
 Libderiv->deriv_classes[7][9][8] = int_stack + 100880;
 Libderiv->deriv_classes[8][5][8] = int_stack + 102860;
 Libderiv->deriv_classes[8][6][8] = int_stack + 103805;
 Libderiv->deriv_classes[8][7][8] = int_stack + 105065;
 Libderiv->deriv_classes[8][8][8] = int_stack + 106685;
 Libderiv->deriv_classes[8][9][8] = int_stack + 108710;
 Libderiv->deriv_classes[9][5][8] = int_stack + 111185;
 Libderiv->deriv_classes[9][6][8] = int_stack + 112340;
 Libderiv->deriv_classes[9][7][8] = int_stack + 113880;
 Libderiv->deriv_classes[9][8][8] = int_stack + 115860;
 Libderiv->deriv_classes[9][9][8] = int_stack + 118335;
 Libderiv->deriv_classes[6][5][7] = int_stack + 121360;
 Libderiv->deriv_classes[6][6][7] = int_stack + 121948;
 Libderiv->deriv_classes[6][7][7] = int_stack + 122732;
 Libderiv->deriv_classes[6][8][7] = int_stack + 123740;
 Libderiv->deriv_classes[6][9][7] = int_stack + 125000;
 Libderiv->deriv_classes[7][5][7] = int_stack + 126540;
 Libderiv->deriv_classes[7][6][7] = int_stack + 127296;
 Libderiv->deriv_classes[7][7][7] = int_stack + 128304;
 Libderiv->deriv_classes[7][8][7] = int_stack + 129600;
 Libderiv->deriv_classes[7][9][7] = int_stack + 131220;
 Libderiv->deriv_classes[8][5][7] = int_stack + 133200;
 Libderiv->deriv_classes[8][6][7] = int_stack + 134145;
 Libderiv->deriv_classes[8][7][7] = int_stack + 135405;
 Libderiv->deriv_classes[8][8][7] = int_stack + 137025;
 Libderiv->deriv_classes[8][9][7] = int_stack + 139050;
 Libderiv->deriv_classes[9][5][7] = int_stack + 141525;
 Libderiv->deriv_classes[9][6][7] = int_stack + 142680;
 Libderiv->deriv_classes[9][7][7] = int_stack + 144220;
 Libderiv->deriv_classes[9][8][7] = int_stack + 146200;
 Libderiv->deriv_classes[9][9][7] = int_stack + 148675;
 Libderiv->deriv_classes[6][5][6] = int_stack + 151700;
 Libderiv->deriv_classes[6][6][6] = int_stack + 152288;
 Libderiv->deriv_classes[6][7][6] = int_stack + 153072;
 Libderiv->deriv_classes[6][8][6] = int_stack + 154080;
 Libderiv->deriv_classes[6][9][6] = int_stack + 155340;
 Libderiv->deriv_classes[7][5][6] = int_stack + 156880;
 Libderiv->deriv_classes[7][6][6] = int_stack + 157636;
 Libderiv->deriv_classes[7][7][6] = int_stack + 158644;
 Libderiv->deriv_classes[7][8][6] = int_stack + 159940;
 Libderiv->deriv_classes[7][9][6] = int_stack + 161560;
 Libderiv->deriv_classes[8][5][6] = int_stack + 163540;
 Libderiv->deriv_classes[8][6][6] = int_stack + 164485;
 Libderiv->deriv_classes[8][7][6] = int_stack + 165745;
 Libderiv->deriv_classes[8][8][6] = int_stack + 167365;
 Libderiv->deriv_classes[8][9][6] = int_stack + 169390;
 Libderiv->dvrr_classes[9][5] = int_stack + 171865;
 Libderiv->deriv_classes[9][5][6] = int_stack + 173020;
 Libderiv->dvrr_classes[9][6] = int_stack + 174175;
 Libderiv->deriv_classes[9][6][6] = int_stack + 175715;
 Libderiv->dvrr_classes[9][7] = int_stack + 177255;
 Libderiv->deriv_classes[9][7][6] = int_stack + 179235;
 Libderiv->dvrr_classes[9][8] = int_stack + 181215;
 Libderiv->deriv_classes[9][8][6] = int_stack + 183690;
 Libderiv->deriv_classes[9][9][6] = int_stack + 186165;
 Libderiv->deriv_classes[6][5][2] = int_stack + 189190;
 Libderiv->deriv_classes[6][6][2] = int_stack + 189778;
 Libderiv->deriv_classes[6][7][2] = int_stack + 190562;
 Libderiv->deriv_classes[6][8][2] = int_stack + 191570;
 Libderiv->deriv_classes[6][9][2] = int_stack + 192830;
 Libderiv->deriv_classes[7][5][2] = int_stack + 194370;
 Libderiv->deriv_classes[7][6][2] = int_stack + 195126;
 Libderiv->deriv_classes[7][7][2] = int_stack + 196134;
 Libderiv->deriv_classes[7][8][2] = int_stack + 197430;
 Libderiv->deriv_classes[7][9][2] = int_stack + 199050;
 Libderiv->deriv_classes[8][5][2] = int_stack + 201030;
 Libderiv->deriv_classes[8][6][2] = int_stack + 201975;
 Libderiv->deriv_classes[8][7][2] = int_stack + 203235;
 Libderiv->deriv_classes[8][8][2] = int_stack + 204855;
 Libderiv->deriv_classes[8][9][2] = int_stack + 206880;
 Libderiv->deriv_classes[9][5][2] = int_stack + 209355;
 Libderiv->deriv_classes[9][6][2] = int_stack + 210510;
 Libderiv->deriv_classes[9][7][2] = int_stack + 212050;
 Libderiv->deriv_classes[9][8][2] = int_stack + 214030;
 Libderiv->deriv_classes[9][9][2] = int_stack + 216505;
 Libderiv->deriv_classes[6][5][1] = int_stack + 219530;
 Libderiv->deriv_classes[6][6][1] = int_stack + 220118;
 Libderiv->deriv_classes[6][7][1] = int_stack + 220902;
 Libderiv->deriv_classes[6][8][1] = int_stack + 221910;
 Libderiv->deriv_classes[6][9][1] = int_stack + 223170;
 Libderiv->deriv_classes[7][5][1] = int_stack + 224710;
 Libderiv->deriv_classes[7][6][1] = int_stack + 225466;
 Libderiv->deriv_classes[7][7][1] = int_stack + 226474;
 Libderiv->deriv_classes[7][8][1] = int_stack + 227770;
 Libderiv->deriv_classes[7][9][1] = int_stack + 229390;
 Libderiv->deriv_classes[8][5][1] = int_stack + 231370;
 Libderiv->deriv_classes[8][6][1] = int_stack + 232315;
 Libderiv->deriv_classes[8][7][1] = int_stack + 233575;
 Libderiv->deriv_classes[8][8][1] = int_stack + 235195;
 Libderiv->deriv_classes[8][9][1] = int_stack + 237220;
 Libderiv->deriv_classes[9][5][1] = int_stack + 239695;
 Libderiv->deriv_classes[9][6][1] = int_stack + 240850;
 Libderiv->deriv_classes[9][7][1] = int_stack + 242390;
 Libderiv->deriv_classes[9][8][1] = int_stack + 244370;
 Libderiv->deriv_classes[9][9][1] = int_stack + 246845;
 Libderiv->dvrr_classes[6][5] = int_stack + 249870;
 Libderiv->dvrr_classes[6][6] = int_stack + 250458;
 Libderiv->dvrr_classes[6][7] = int_stack + 251242;
 Libderiv->dvrr_classes[6][8] = int_stack + 252250;
 Libderiv->dvrr_classes[6][9] = int_stack + 253510;
 Libderiv->deriv_classes[6][5][0] = int_stack + 255050;
 Libderiv->deriv_classes[6][6][0] = int_stack + 255638;
 Libderiv->deriv_classes[6][7][0] = int_stack + 256422;
 Libderiv->deriv_classes[6][8][0] = int_stack + 257430;
 Libderiv->deriv_classes[6][9][0] = int_stack + 258690;
 Libderiv->dvrr_classes[7][5] = int_stack + 260230;
 Libderiv->dvrr_classes[7][6] = int_stack + 260986;
 Libderiv->dvrr_classes[7][7] = int_stack + 261994;
 Libderiv->dvrr_classes[7][8] = int_stack + 263290;
 Libderiv->dvrr_classes[7][9] = int_stack + 264910;
 Libderiv->deriv_classes[7][5][0] = int_stack + 266890;
 Libderiv->deriv_classes[7][6][0] = int_stack + 267646;
 Libderiv->deriv_classes[7][7][0] = int_stack + 268654;
 Libderiv->deriv_classes[7][8][0] = int_stack + 269950;
 Libderiv->deriv_classes[7][9][0] = int_stack + 271570;
 Libderiv->dvrr_classes[8][5] = int_stack + 273550;
 Libderiv->dvrr_classes[8][6] = int_stack + 274495;
 Libderiv->dvrr_classes[8][7] = int_stack + 275755;
 Libderiv->dvrr_classes[8][8] = int_stack + 277375;
 Libderiv->dvrr_classes[8][9] = int_stack + 279400;
 Libderiv->deriv_classes[8][5][0] = int_stack + 281875;
 Libderiv->deriv_classes[8][6][0] = int_stack + 282820;
 Libderiv->deriv_classes[8][7][0] = int_stack + 284080;
 Libderiv->deriv_classes[8][8][0] = int_stack + 285700;
 Libderiv->deriv_classes[8][9][0] = int_stack + 287725;
 Libderiv->deriv_classes[9][5][0] = int_stack + 290200;
 Libderiv->deriv_classes[9][6][0] = int_stack + 291355;
 Libderiv->deriv_classes[9][7][0] = int_stack + 292895;
 Libderiv->deriv_classes[9][8][0] = int_stack + 294875;
 Libderiv->deriv_classes[9][9][0] = int_stack + 297350;
 memset(int_stack,0,2403000);

 Libderiv->dvrr_stack = int_stack + 1583484;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ifhg(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+300375,int_stack+250458,int_stack+249870,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+302139,int_stack+251242,int_stack+250458,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+304491,int_stack+302139,int_stack+300375,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+308019,int_stack+252250,int_stack+251242,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+311043,int_stack+308019,int_stack+302139,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+315747,int_stack+311043,int_stack+304491,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+321627,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249870,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+323391,int_stack+1372,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250458,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+325743,int_stack+323391,int_stack+321627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300375,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+329271,int_stack+2380,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251242,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+332295,int_stack+329271,int_stack+323391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302139,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+336999,int_stack+332295,int_stack+325743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304491,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+321627,int_stack+3640,int_stack+2380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252250,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+342879,int_stack+321627,int_stack+329271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308019,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+321627,int_stack+342879,int_stack+332295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311043,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+342879,int_stack+321627,int_stack+336999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315747,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+321627,int_stack+260986,int_stack+260230,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+323895,int_stack+261994,int_stack+260986,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+326919,int_stack+323895,int_stack+321627,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+331455,int_stack+263290,int_stack+261994,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+335343,int_stack+331455,int_stack+323895,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+351699,int_stack+335343,int_stack+326919,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+5936,int_stack+5180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260230,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+6944,int_stack+5936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260986,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+359259,int_stack+2268,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321627,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+363795,int_stack+8240,int_stack+6944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261994,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+367683,int_stack+363795,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323895,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+367683,int_stack+359259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326919,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+373731,int_stack+9860,int_stack+8240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263290,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+378591,int_stack+373731,int_stack+363795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331455,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+386367,int_stack+378591,int_stack+367683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335343,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359259,int_stack+386367,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351699,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+370599,int_stack+359259,int_stack+342879,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+274495,int_stack+273550,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2835,int_stack+275755,int_stack+274495,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+341391,int_stack+2835,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6615,int_stack+277375,int_stack+275755,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+397059,int_stack+6615,int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+404619,int_stack+397059,int_stack+341391,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+347061,int_stack+12785,int_stack+11840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273550,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+414069,int_stack+14045,int_stack+12785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274495,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+417849,int_stack+414069,int_stack+347061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423519,int_stack+15665,int_stack+14045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275755,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+428379,int_stack+423519,int_stack+414069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+435939,int_stack+428379,int_stack+417849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341391,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+414069,int_stack+17690,int_stack+15665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277375,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+445389,int_stack+414069,int_stack+423519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+414069,int_stack+445389,int_stack+428379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397059,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+445389,int_stack+414069,int_stack+435939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404619,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+459564,int_stack+445389,int_stack+359259,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+493584,int_stack+459564,int_stack+370599,315);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+359259,int_stack+174175,int_stack+171865,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+362724,int_stack+177255,int_stack+174175,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+367344,int_stack+362724,int_stack+359259,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+374274,int_stack+181215,int_stack+177255,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+380214,int_stack+374274,int_stack+362724,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+414069,int_stack+380214,int_stack+367344,55);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+389454,int_stack+21320,int_stack+20165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171865,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+425619,int_stack+22860,int_stack+21320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174175,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+430239,int_stack+425619,int_stack+389454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359259,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+389454,int_stack+24840,int_stack+22860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177255,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11475,int_stack+389454,int_stack+425619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362724,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+546504,int_stack+11475,int_stack+430239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367344,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+425619,int_stack+27315,int_stack+24840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181215,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+433044,int_stack+425619,int_stack+389454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+374274,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+558054,int_stack+433044,int_stack+11475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380214,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11475,int_stack+558054,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414069,55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+546504,int_stack+11475,int_stack+445389,315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+589029,int_stack+546504,int_stack+459564,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+30928,int_stack+30340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249870, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548268,int_stack+31712,int_stack+30928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250458, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+550620,int_stack+548268,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300375, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+554148,int_stack+32720,int_stack+31712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251242, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557172,int_stack+554148,int_stack+548268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302139, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+561876,int_stack+557172,int_stack+550620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304491, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+33980,int_stack+32720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252250, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+554148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308019, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+567756,int_stack+557172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311043, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+561876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315747, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+36276,int_stack+35520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260230, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548772,int_stack+37284,int_stack+36276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260986, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+551796,int_stack+548772,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321627, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+556332,int_stack+38580,int_stack+37284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261994, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+560220,int_stack+556332,int_stack+548772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323895, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+576576,int_stack+560220,int_stack+551796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326919, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+40200,int_stack+38580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263290, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+11475,int_stack+546504,int_stack+556332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331455, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+11475,int_stack+560220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335343, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11475,int_stack+546504,int_stack+576576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351699, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+425619,int_stack+11475,int_stack+567756,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+43125,int_stack+42180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273550, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+549339,int_stack+44385,int_stack+43125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274495, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+553119,int_stack+549339,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+558789,int_stack+46005,int_stack+44385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275755, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+563649,int_stack+558789,int_stack+549339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+571209,int_stack+563649,int_stack+553119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341391, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+48030,int_stack+46005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277375, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22815,int_stack+546504,int_stack+558789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+22815,int_stack+563649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397059, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+22815,int_stack+546504,int_stack+571209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404619, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+546504,int_stack+22815,int_stack+11475,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+657069,int_stack+546504,int_stack+425619,315);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+425619,int_stack+51660,int_stack+50505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171865, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+429084,int_stack+53200,int_stack+51660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174175, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+433704,int_stack+429084,int_stack+425619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359259, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+440634,int_stack+55180,int_stack+53200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177255, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+446574,int_stack+440634,int_stack+429084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362724, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+455814,int_stack+446574,int_stack+433704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367344, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+425619,int_stack+57655,int_stack+55180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181215, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+467364,int_stack+425619,int_stack+440634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+374274, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+425619,int_stack+467364,int_stack+446574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380214, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+467364,int_stack+425619,int_stack+455814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414069, 0.0, zero_stack,55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+709989,int_stack+467364,int_stack+22815,315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+752514,int_stack+709989,int_stack+546504,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+61268,int_stack+60680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249870, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548268,int_stack+62052,int_stack+61268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250458, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+550620,int_stack+548268,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+554148,int_stack+63060,int_stack+62052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251242, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557172,int_stack+554148,int_stack+548268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302139, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+561876,int_stack+557172,int_stack+550620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304491, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+64320,int_stack+63060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252250, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+554148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308019, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+567756,int_stack+557172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311043, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+561876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315747, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+66616,int_stack+65860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260230, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548772,int_stack+67624,int_stack+66616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260986, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+551796,int_stack+548772,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321627, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+556332,int_stack+68920,int_stack+67624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261994, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+560220,int_stack+556332,int_stack+548772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323895, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+576576,int_stack+560220,int_stack+551796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326919, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+70540,int_stack+68920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263290, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+709989,int_stack+546504,int_stack+556332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331455, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+709989,int_stack+560220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335343, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+709989,int_stack+546504,int_stack+576576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351699, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+721329,int_stack+709989,int_stack+567756,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+73465,int_stack+72520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273550, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+549339,int_stack+74725,int_stack+73465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274495, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+553119,int_stack+549339,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+558789,int_stack+76345,int_stack+74725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275755, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+563649,int_stack+558789,int_stack+549339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+571209,int_stack+563649,int_stack+553119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341391, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+78370,int_stack+76345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277375, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425619,int_stack+546504,int_stack+558789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+425619,int_stack+563649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397059, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+425619,int_stack+546504,int_stack+571209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404619, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+546504,int_stack+425619,int_stack+709989,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+439794,int_stack+546504,int_stack+721329,315);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+709989,int_stack+82000,int_stack+80845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171865, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+713454,int_stack+83540,int_stack+82000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174175, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+718074,int_stack+713454,int_stack+709989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359259, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+725004,int_stack+85520,int_stack+83540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177255, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+730944,int_stack+725004,int_stack+713454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362724, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+740184,int_stack+730944,int_stack+718074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367344, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+709989,int_stack+87995,int_stack+85520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181215, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+11475,int_stack+709989,int_stack+725004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+374274, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+709989,int_stack+11475,int_stack+730944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380214, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+11475,int_stack+709989,int_stack+740184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414069, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+709989,int_stack+11475,int_stack+425619,315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+11475,int_stack+709989,int_stack+546504,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+91608,int_stack+91020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548268,int_stack+92392,int_stack+91608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+550620,int_stack+548268,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+554148,int_stack+93400,int_stack+92392, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557172,int_stack+554148,int_stack+548268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+561876,int_stack+557172,int_stack+550620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+94660,int_stack+93400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+554148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+567756,int_stack+557172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+561876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+96956,int_stack+96200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548772,int_stack+97964,int_stack+96956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+551796,int_stack+548772,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+556332,int_stack+99260,int_stack+97964, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+560220,int_stack+556332,int_stack+548772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+576576,int_stack+560220,int_stack+551796, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+100880,int_stack+99260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+709989,int_stack+546504,int_stack+556332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+709989,int_stack+560220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+709989,int_stack+546504,int_stack+576576, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+721329,int_stack+709989,int_stack+567756,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+103805,int_stack+102860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+549339,int_stack+105065,int_stack+103805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+553119,int_stack+549339,int_stack+546504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+558789,int_stack+106685,int_stack+105065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+563649,int_stack+558789,int_stack+549339, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+571209,int_stack+563649,int_stack+553119, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+108710,int_stack+106685, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425619,int_stack+546504,int_stack+558789, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+425619,int_stack+563649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+425619,int_stack+546504,int_stack+571209, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+546504,int_stack+425619,int_stack+709989,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+820554,int_stack+546504,int_stack+721329,315);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+709989,int_stack+112340,int_stack+111185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+713454,int_stack+113880,int_stack+112340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+718074,int_stack+713454,int_stack+709989, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+725004,int_stack+115860,int_stack+113880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+730944,int_stack+725004,int_stack+713454, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+740184,int_stack+730944,int_stack+718074, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+709989,int_stack+118335,int_stack+115860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+79515,int_stack+709989,int_stack+725004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+374274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+709989,int_stack+79515,int_stack+730944, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+79515,int_stack+709989,int_stack+740184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+709989,int_stack+79515,int_stack+425619,315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+873474,int_stack+709989,int_stack+546504,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+121948,int_stack+121360, 0.0, zero_stack, 1.0, int_stack+249870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548268,int_stack+122732,int_stack+121948, 0.0, zero_stack, 1.0, int_stack+250458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+550620,int_stack+548268,int_stack+546504, 0.0, zero_stack, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+554148,int_stack+123740,int_stack+122732, 0.0, zero_stack, 1.0, int_stack+251242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557172,int_stack+554148,int_stack+548268, 0.0, zero_stack, 1.0, int_stack+302139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+561876,int_stack+557172,int_stack+550620, 0.0, zero_stack, 1.0, int_stack+304491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+125000,int_stack+123740, 0.0, zero_stack, 1.0, int_stack+252250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+554148, 0.0, zero_stack, 1.0, int_stack+308019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+567756,int_stack+557172, 0.0, zero_stack, 1.0, int_stack+311043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+561876, 0.0, zero_stack, 1.0, int_stack+315747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+127296,int_stack+126540, 0.0, zero_stack, 1.0, int_stack+260230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548772,int_stack+128304,int_stack+127296, 0.0, zero_stack, 1.0, int_stack+260986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+551796,int_stack+548772,int_stack+546504, 0.0, zero_stack, 1.0, int_stack+321627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+556332,int_stack+129600,int_stack+128304, 0.0, zero_stack, 1.0, int_stack+261994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+560220,int_stack+556332,int_stack+548772, 0.0, zero_stack, 1.0, int_stack+323895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+576576,int_stack+560220,int_stack+551796, 0.0, zero_stack, 1.0, int_stack+326919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+131220,int_stack+129600, 0.0, zero_stack, 1.0, int_stack+263290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+709989,int_stack+546504,int_stack+556332, 0.0, zero_stack, 1.0, int_stack+331455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+709989,int_stack+560220, 0.0, zero_stack, 1.0, int_stack+335343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+709989,int_stack+546504,int_stack+576576, 0.0, zero_stack, 1.0, int_stack+351699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+721329,int_stack+709989,int_stack+567756,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+134145,int_stack+133200, 0.0, zero_stack, 1.0, int_stack+273550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+549339,int_stack+135405,int_stack+134145, 0.0, zero_stack, 1.0, int_stack+274495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+553119,int_stack+549339,int_stack+546504, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+558789,int_stack+137025,int_stack+135405, 0.0, zero_stack, 1.0, int_stack+275755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+563649,int_stack+558789,int_stack+549339, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+571209,int_stack+563649,int_stack+553119, 0.0, zero_stack, 1.0, int_stack+341391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+139050,int_stack+137025, 0.0, zero_stack, 1.0, int_stack+277375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425619,int_stack+546504,int_stack+558789, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+425619,int_stack+563649, 0.0, zero_stack, 1.0, int_stack+397059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+425619,int_stack+546504,int_stack+571209, 0.0, zero_stack, 1.0, int_stack+404619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+546504,int_stack+425619,int_stack+709989,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+79515,int_stack+546504,int_stack+721329,315);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+709989,int_stack+142680,int_stack+141525, 0.0, zero_stack, 1.0, int_stack+171865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+713454,int_stack+144220,int_stack+142680, 0.0, zero_stack, 1.0, int_stack+174175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+718074,int_stack+713454,int_stack+709989, 0.0, zero_stack, 1.0, int_stack+359259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+725004,int_stack+146200,int_stack+144220, 0.0, zero_stack, 1.0, int_stack+177255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+730944,int_stack+725004,int_stack+713454, 0.0, zero_stack, 1.0, int_stack+362724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+740184,int_stack+730944,int_stack+718074, 0.0, zero_stack, 1.0, int_stack+367344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+709989,int_stack+148675,int_stack+146200, 0.0, zero_stack, 1.0, int_stack+181215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+132435,int_stack+709989,int_stack+725004, 0.0, zero_stack, 1.0, int_stack+374274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+709989,int_stack+132435,int_stack+730944, 0.0, zero_stack, 1.0, int_stack+380214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+132435,int_stack+709989,int_stack+740184, 0.0, zero_stack, 1.0, int_stack+414069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+709989,int_stack+132435,int_stack+425619,315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+941514,int_stack+709989,int_stack+546504,315);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+152288,int_stack+151700, 1.0, int_stack+249870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+548268,int_stack+153072,int_stack+152288, 1.0, int_stack+250458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+550620,int_stack+548268,int_stack+546504, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+554148,int_stack+154080,int_stack+153072, 1.0, int_stack+251242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+557172,int_stack+554148,int_stack+548268, 1.0, int_stack+302139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+561876,int_stack+557172,int_stack+550620, 1.0, int_stack+304491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+300375,int_stack+155340,int_stack+154080, 1.0, int_stack+252250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+546504,int_stack+300375,int_stack+554148, 1.0, int_stack+308019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+567756,int_stack+546504,int_stack+557172, 1.0, int_stack+311043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+546504,int_stack+567756,int_stack+561876, 1.0, int_stack+315747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+555324,int_stack+157636,int_stack+156880, 1.0, int_stack+260230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557592,int_stack+158644,int_stack+157636, 1.0, int_stack+260986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+560616,int_stack+557592,int_stack+555324, 1.0, int_stack+321627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+565152,int_stack+159940,int_stack+158644, 1.0, int_stack+261994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+569040,int_stack+565152,int_stack+557592, 1.0, int_stack+323895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+575088,int_stack+569040,int_stack+560616, 1.0, int_stack+326919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+321627,int_stack+161560,int_stack+159940, 1.0, int_stack+263290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+555324,int_stack+321627,int_stack+565152, 1.0, int_stack+331455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+709989,int_stack+555324,int_stack+569040, 1.0, int_stack+335343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+555324,int_stack+709989,int_stack+575088, 1.0, int_stack+351699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+709989,int_stack+555324,int_stack+546504,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+164485,int_stack+163540, 1.0, int_stack+273550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+549339,int_stack+165745,int_stack+164485, 1.0, int_stack+274495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+736449,int_stack+549339,int_stack+546504, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+742119,int_stack+167365,int_stack+165745, 1.0, int_stack+275755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+566664,int_stack+742119,int_stack+549339, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+574224,int_stack+566664,int_stack+736449, 1.0, int_stack+341391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+341391,int_stack+169390,int_stack+167365, 1.0, int_stack+277375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+321627,int_stack+341391,int_stack+742119, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+736449,int_stack+321627,int_stack+566664, 1.0, int_stack+397059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+425619,int_stack+736449,int_stack+574224, 1.0, int_stack+404619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+132435,int_stack+425619,int_stack+555324,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1009554,int_stack+132435,int_stack+709989,315);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+709989,int_stack+175715,int_stack+173020, 1.0, int_stack+171865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+713454,int_stack+179235,int_stack+175715, 1.0, int_stack+174175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+718074,int_stack+713454,int_stack+709989, 1.0, int_stack+359259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+725004,int_stack+183690,int_stack+179235, 1.0, int_stack+177255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+730944,int_stack+725004,int_stack+713454, 1.0, int_stack+362724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+740184,int_stack+730944,int_stack+718074, 1.0, int_stack+367344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+359259,int_stack+186165,int_stack+183690, 1.0, int_stack+181215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+709989,int_stack+359259,int_stack+725004, 1.0, int_stack+374274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+359259,int_stack+709989,int_stack+730944, 1.0, int_stack+380214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+709989,int_stack+359259,int_stack+740184, 1.0, int_stack+414069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+546504,int_stack+709989,int_stack+425619,315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1062474,int_stack+546504,int_stack+132435,315);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+132435,int_stack+253510,int_stack+252250,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+136215,int_stack+132435,int_stack+308019,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+142263,int_stack+136215,int_stack+311043,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+132435,int_stack+142263,int_stack+315747,28);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+141255,int_stack+264910,int_stack+263290,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+146115,int_stack+141255,int_stack+331455,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+153891,int_stack+146115,int_stack+335343,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+141255,int_stack+153891,int_stack+351699,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+152595,int_stack+141255,int_stack+132435,315);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+179055,int_stack+279400,int_stack+277375,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+546504,int_stack+179055,int_stack+6615,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+556224,int_stack+546504,int_stack+397059,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+568824,int_stack+556224,int_stack+404619,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+709989,int_stack+568824,int_stack+141255,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+300375,int_stack+709989,int_stack+152595,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+189778,int_stack+189190,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+548268,int_stack+190562,int_stack+189778,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+550620,int_stack+548268,int_stack+546504,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+554148,int_stack+191570,int_stack+190562,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+557172,int_stack+554148,int_stack+548268,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+561876,int_stack+557172,int_stack+550620,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+192830,int_stack+191570,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+179055,int_stack+546504,int_stack+554148,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+179055,int_stack+557172,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+179055,int_stack+546504,int_stack+561876,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+546504,int_stack+195126,int_stack+194370,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+548772,int_stack+196134,int_stack+195126,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+551796,int_stack+548772,int_stack+546504,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+556332,int_stack+197430,int_stack+196134,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+560220,int_stack+556332,int_stack+548772,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+187875,int_stack+560220,int_stack+551796,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+546504,int_stack+199050,int_stack+197430,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+744009,int_stack+546504,int_stack+556332,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+546504,int_stack+744009,int_stack+560220,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+556584,int_stack+546504,int_stack+187875,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+353295,int_stack+556584,int_stack+179055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+179055,int_stack+201975,int_stack+201030,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+181890,int_stack+203235,int_stack+201975,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+185670,int_stack+181890,int_stack+179055,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+191340,int_stack+204855,int_stack+203235,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+196200,int_stack+191340,int_stack+181890,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+546504,int_stack+196200,int_stack+185670,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+179055,int_stack+206880,int_stack+204855,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+179055,int_stack+191340,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+179055,int_stack+0,int_stack+196200,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+191655,int_stack+179055,int_stack+546504,45);
 /*--- compute (kp|hg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+379755,int_stack+191655,int_stack+556584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (id|hg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1130514,int_stack+379755,int_stack+353295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+353295,int_stack+210510,int_stack+209355,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+356760,int_stack+212050,int_stack+210510,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+361380,int_stack+356760,int_stack+353295,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+368310,int_stack+214030,int_stack+212050,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+546504,int_stack+368310,int_stack+356760,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+555744,int_stack+546504,int_stack+361380,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+353295,int_stack+216505,int_stack+214030,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+179055,int_stack+353295,int_stack+368310,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+353295,int_stack+179055,int_stack+546504,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+413775,int_stack+353295,int_stack+555744,55);
 /*--- compute (lp|hg) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+1183434,int_stack+413775,int_stack+191655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (kd|hg) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+1225959,int_stack+1183434,int_stack+379755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+709989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1183434,int_stack+220118,int_stack+219530,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1185198,int_stack+220902,int_stack+220118,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1187550,int_stack+1185198,int_stack+1183434,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1191078,int_stack+221910,int_stack+220902,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1194102,int_stack+1191078,int_stack+1185198,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1198806,int_stack+1194102,int_stack+1187550,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1183434,int_stack+223170,int_stack+221910,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1204686,int_stack+1183434,int_stack+1191078,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1183434,int_stack+1204686,int_stack+1194102,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1204686,int_stack+1183434,int_stack+1198806,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1183434,int_stack+225466,int_stack+224710,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1185702,int_stack+226474,int_stack+225466,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1188726,int_stack+1185702,int_stack+1183434,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1193262,int_stack+227770,int_stack+226474,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1197150,int_stack+1193262,int_stack+1185702,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1213506,int_stack+1197150,int_stack+1188726,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1183434,int_stack+229390,int_stack+227770,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+353295,int_stack+1183434,int_stack+1193262,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1183434,int_stack+353295,int_stack+1197150,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+353295,int_stack+1183434,int_stack+1213506,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+364635,int_stack+353295,int_stack+1204686, 0.0, zero_stack, 1.0, int_stack+132435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1183434,int_stack+232315,int_stack+231370,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1186269,int_stack+233575,int_stack+232315,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1190049,int_stack+1186269,int_stack+1183434,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1195719,int_stack+235195,int_stack+233575,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1200579,int_stack+1195719,int_stack+1186269,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1208139,int_stack+1200579,int_stack+1190049,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1183434,int_stack+237220,int_stack+235195,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+391095,int_stack+1183434,int_stack+1195719,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1183434,int_stack+391095,int_stack+1200579,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+391095,int_stack+1183434,int_stack+1208139,45);
 /*--- compute (kp|hg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+1183434,int_stack+391095,int_stack+353295, 0.0, zero_stack, 1.0, int_stack+141255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (id|hg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+179055,int_stack+1183434,int_stack+364635, 0.0, zero_stack, 1.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+353295,int_stack+240850,int_stack+239695,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+356760,int_stack+242390,int_stack+240850,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+361380,int_stack+356760,int_stack+353295,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+368310,int_stack+244370,int_stack+242390,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+374250,int_stack+368310,int_stack+356760,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+405270,int_stack+374250,int_stack+361380,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+353295,int_stack+246845,int_stack+244370,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+416820,int_stack+353295,int_stack+368310,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+353295,int_stack+416820,int_stack+374250,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+416820,int_stack+353295,int_stack+405270,55);
 /*--- compute (lp|hg) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+1293999,int_stack+416820,int_stack+391095, 0.0, zero_stack, 1.0, int_stack+568824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (kd|hg) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+353295,int_stack+1293999,int_stack+1183434, 0.0, zero_stack, 1.0, int_stack+709989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1183434,int_stack+255638,int_stack+255050,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1185198,int_stack+256422,int_stack+255638,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1187550,int_stack+1185198,int_stack+1183434,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1191078,int_stack+257430,int_stack+256422,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1194102,int_stack+1191078,int_stack+1185198,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1198806,int_stack+1194102,int_stack+1187550,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1183434,int_stack+258690,int_stack+257430,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1204686,int_stack+1183434,int_stack+1191078,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1183434,int_stack+1204686,int_stack+1194102,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1204686,int_stack+1183434,int_stack+1198806,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1183434,int_stack+267646,int_stack+266890,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1185702,int_stack+268654,int_stack+267646,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1188726,int_stack+1185702,int_stack+1183434,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1193262,int_stack+269950,int_stack+268654,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1197150,int_stack+1193262,int_stack+1185702,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1213506,int_stack+1197150,int_stack+1188726,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1183434,int_stack+271570,int_stack+269950,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1293999,int_stack+1183434,int_stack+1193262,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1183434,int_stack+1293999,int_stack+1197150,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1293999,int_stack+1183434,int_stack+1213506,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+1305339,int_stack+1293999,int_stack+1204686, 1.0, int_stack+132435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+132435,int_stack+282820,int_stack+281875,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+135270,int_stack+284080,int_stack+282820,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1183434,int_stack+135270,int_stack+132435,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1189104,int_stack+285700,int_stack+284080,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1193964,int_stack+1189104,int_stack+135270,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1201524,int_stack+1193964,int_stack+1183434,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+132435,int_stack+287725,int_stack+285700,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1210974,int_stack+132435,int_stack+1189104,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+421335,int_stack+1210974,int_stack+1193964,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1210974,int_stack+421335,int_stack+1201524,45);
 /*--- compute (kp|hg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+231975,int_stack+1210974,int_stack+1293999, 1.0, int_stack+141255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (id|hg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1331799,int_stack+231975,int_stack+1305339, 1.0, int_stack+152595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1293999,int_stack+291355,int_stack+290200,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1297464,int_stack+292895,int_stack+291355,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1302084,int_stack+1297464,int_stack+1293999,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1309014,int_stack+294875,int_stack+292895,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1314954,int_stack+1309014,int_stack+1297464,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+421335,int_stack+1314954,int_stack+1302084,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1293999,int_stack+297350,int_stack+294875,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+132435,int_stack+1293999,int_stack+1309014,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1293999,int_stack+132435,int_stack+1314954,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+132435,int_stack+1293999,int_stack+421335,55);
 /*--- compute (lp|hg) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+1384719,int_stack+132435,int_stack+1210974, 1.0, int_stack+568824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (kd|hg) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+1427244,int_stack+1384719,int_stack+231975, 1.0, int_stack+709989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1495284,int_stack+589029,int_stack+493584,315);
     Libderiv->ABCD[11] = int_stack + 1495284;
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+492714,int_stack+752514,int_stack+657069,315);
     Libderiv->ABCD[10] = int_stack + 492714;
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+580914,int_stack+11475,int_stack+439794,315);
     Libderiv->ABCD[9] = int_stack + 580914;
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+669114,int_stack+873474,int_stack+820554,315);
     Libderiv->ABCD[8] = int_stack + 669114;
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+757314,int_stack+941514,int_stack+79515,315);
     Libderiv->ABCD[7] = int_stack + 757314;
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+0,int_stack+1062474,int_stack+1009554,315);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (if|hg) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+88200,int_stack+1225959,int_stack+1130514, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[2] = int_stack + 88200;
 /*--- compute (if|hg) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+845514,int_stack+353295,int_stack+179055, 0.0, zero_stack, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[1] = int_stack + 845514;
 /*--- compute (if|hg) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+353295,int_stack+1427244,int_stack+1331799, 1.0, int_stack+300375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[0] = int_stack + 353295;

}
