/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_p0hf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|hf) integrals */

void d1hrr_order_p0hf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[1][6][11] = int_stack + 63;
 Libderiv->deriv_classes[1][7][11] = int_stack + 147;
 Libderiv->deriv_classes[1][8][11] = int_stack + 255;
 Libderiv->deriv_classes[1][5][10] = int_stack + 390;
 Libderiv->deriv_classes[1][6][10] = int_stack + 453;
 Libderiv->deriv_classes[1][7][10] = int_stack + 537;
 Libderiv->deriv_classes[1][8][10] = int_stack + 645;
 Libderiv->deriv_classes[1][5][9] = int_stack + 780;
 Libderiv->deriv_classes[1][6][9] = int_stack + 843;
 Libderiv->deriv_classes[1][7][9] = int_stack + 927;
 Libderiv->deriv_classes[1][8][9] = int_stack + 1035;
 Libderiv->deriv_classes[1][5][8] = int_stack + 1170;
 Libderiv->deriv_classes[1][6][8] = int_stack + 1233;
 Libderiv->deriv_classes[1][7][8] = int_stack + 1317;
 Libderiv->deriv_classes[1][8][8] = int_stack + 1425;
 Libderiv->deriv_classes[1][5][7] = int_stack + 1560;
 Libderiv->deriv_classes[1][6][7] = int_stack + 1623;
 Libderiv->deriv_classes[1][7][7] = int_stack + 1707;
 Libderiv->deriv_classes[1][8][7] = int_stack + 1815;
 Libderiv->dvrr_classes[1][5] = int_stack + 1950;
 Libderiv->deriv_classes[1][5][6] = int_stack + 2013;
 Libderiv->dvrr_classes[1][6] = int_stack + 2076;
 Libderiv->deriv_classes[1][6][6] = int_stack + 2160;
 Libderiv->dvrr_classes[1][7] = int_stack + 2244;
 Libderiv->deriv_classes[1][7][6] = int_stack + 2352;
 Libderiv->deriv_classes[1][8][6] = int_stack + 2460;
 Libderiv->deriv_classes[1][5][2] = int_stack + 2595;
 Libderiv->deriv_classes[1][6][2] = int_stack + 2658;
 Libderiv->deriv_classes[1][7][2] = int_stack + 2742;
 Libderiv->deriv_classes[1][8][2] = int_stack + 2850;
 Libderiv->deriv_classes[1][5][1] = int_stack + 2985;
 Libderiv->deriv_classes[1][6][1] = int_stack + 3048;
 Libderiv->deriv_classes[1][7][1] = int_stack + 3132;
 Libderiv->deriv_classes[1][8][1] = int_stack + 3240;
 Libderiv->deriv_classes[1][5][0] = int_stack + 3375;
 Libderiv->deriv_classes[1][6][0] = int_stack + 3438;
 Libderiv->deriv_classes[1][7][0] = int_stack + 3522;
 Libderiv->deriv_classes[1][8][0] = int_stack + 3630;
 memset(int_stack,0,30120);

 Libderiv->dvrr_stack = int_stack + 10263;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_p0hf(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3765,int_stack+2076,int_stack+1950,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3954,int_stack+2244,int_stack+2076,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4206,int_stack+3954,int_stack+3765,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4584,int_stack+63,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1950,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4773,int_stack+147,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2076,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5025,int_stack+4773,int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3765,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+255,int_stack+147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2244,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5727,int_stack+5403,int_stack+4773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3954,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5403,int_stack+453,int_stack+390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1950, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4584,int_stack+537,int_stack+453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2076, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+4584,int_stack+5403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3765, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+645,int_stack+537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2244, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6231,int_stack+5403,int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3954, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4584,int_stack+843,int_stack+780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1950, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4773,int_stack+927,int_stack+843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2076, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378,int_stack+4773,int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3765, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+1035,int_stack+927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2244, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6735,int_stack+5403,int_stack+4773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3954, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5403,int_stack+1233,int_stack+1170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4584,int_stack+1317,int_stack+1233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+756,int_stack+4584,int_stack+5403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+1425,int_stack+1317, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7239,int_stack+5403,int_stack+4584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4584,int_stack+1623,int_stack+1560, 0.0, zero_stack, 1.0, int_stack+1950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4773,int_stack+1707,int_stack+1623, 0.0, zero_stack, 1.0, int_stack+2076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1134,int_stack+4773,int_stack+4584, 0.0, zero_stack, 1.0, int_stack+3765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+1815,int_stack+1707, 0.0, zero_stack, 1.0, int_stack+2244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7743,int_stack+5403,int_stack+4773, 0.0, zero_stack, 1.0, int_stack+3954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5403,int_stack+2160,int_stack+2013, 1.0, int_stack+1950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4584,int_stack+2352,int_stack+2160, 1.0, int_stack+2076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1512,int_stack+4584,int_stack+5403, 1.0, int_stack+3765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+2460,int_stack+2352, 1.0, int_stack+2244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1890,int_stack+5403,int_stack+4584, 1.0, int_stack+3954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4584,int_stack+2658,int_stack+2595,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4773,int_stack+2742,int_stack+2658,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3765,int_stack+4773,int_stack+4584,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+2850,int_stack+2742,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2394,int_stack+5403,int_stack+4773,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5403,int_stack+3048,int_stack+2985,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4584,int_stack+3132,int_stack+3048,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+8247,int_stack+4584,int_stack+5403,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+3240,int_stack+3132,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8625,int_stack+5403,int_stack+4584,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4584,int_stack+3438,int_stack+3375,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4773,int_stack+3522,int_stack+3438,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2898,int_stack+4773,int_stack+4584,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5403,int_stack+3630,int_stack+3522,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+9129,int_stack+5403,int_stack+4773,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9633,int_stack+5727,int_stack+5025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4206,3);
     Libderiv->ABCD[11] = int_stack + 9633;
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4584,int_stack+6231,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4206, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 4584;
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5214,int_stack+6735,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4206, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 5214;
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+7239,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5844,int_stack+7743,int_stack+1134, 0.0, zero_stack, 1.0, int_stack+4206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 5844;
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+630,int_stack+1890,int_stack+1512, 1.0, int_stack+4206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 630;
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1260,int_stack+2394,int_stack+3765,3);
     Libderiv->ABCD[2] = int_stack + 1260;
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+8625,int_stack+8247,3);
     Libderiv->ABCD[1] = int_stack + 1890;
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6474,int_stack+9129,int_stack+2898,3);
     Libderiv->ABCD[0] = int_stack + 6474;

}
