/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00ff(Libint_t*, prim_data*);

  /* Computes quartets of (00|ff) integrals */

REALTYPE *hrr_order_00ff(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][3] = int_stack + 0;
 Libint->vrr_classes[0][4] = int_stack + 10;
 Libint->vrr_classes[0][5] = int_stack + 25;
 Libint->vrr_classes[0][6] = int_stack + 46;
 memset(int_stack,0,74*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 74;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00ff(Libint, Data);
   Data++;
 }
 /*--- compute (00|fp) ---*/
 hrr3_build_fp(Libint->CD,int_stack+74,int_stack+10,int_stack+0,1);
 /*--- compute (00|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+104,int_stack+25,int_stack+10,1);
 /*--- compute (00|fd) ---*/
 hrr3_build_fd(Libint->CD,int_stack+149,int_stack+104,int_stack+74,1);
 /*--- compute (00|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+209,int_stack+46,int_stack+25,1);
 /*--- compute (00|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+0,int_stack+209,int_stack+104,1);
 /*--- compute (00|ff) ---*/
 hrr3_build_ff(Libint->CD,int_stack+209,int_stack+0,int_stack+149,1);
 return int_stack+209;}
