/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0ll(Libint_t*, prim_data*);

  /* Computes quartets of (d0|ll) integrals */

REALTYPE *hrr_order_d0ll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[2][14] = int_stack + 2640;
 Libint->vrr_classes[2][15] = int_stack + 3360;
 Libint->vrr_classes[2][16] = int_stack + 4176;
 memset(int_stack,0,5094*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5094;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0ll(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5094,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5904,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+6894,int_stack+5904,int_stack+5094,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8514,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+9702,int_stack+8514,int_stack+5904,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+11682,int_stack+9702,int_stack+6894,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5094,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+14382,int_stack+5094,int_stack+8514,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+16758,int_stack+14382,int_stack+9702,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+6498,int_stack+16758,int_stack+11682,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+10548,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+20058,int_stack+10548,int_stack+5094,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+22866,int_stack+20058,int_stack+14382,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+26826,int_stack+22866,int_stack+16758,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+12186,int_stack+26826,int_stack+6498,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5094,int_stack+2640,int_stack+2010,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6984,int_stack+5094,int_stack+10548,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+31776,int_stack+6984,int_stack+20058,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+36456,int_stack+31776,int_stack+22866,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+17856,int_stack+36456,int_stack+26826,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+42396,int_stack+17856,int_stack+12186,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+10260,int_stack+3360,int_stack+2640,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+12420,int_stack+10260,int_stack+5094,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+24786,int_stack+12420,int_stack+6984,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+49956,int_stack+24786,int_stack+31776,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+56976,int_stack+49956,int_stack+36456,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+30246,int_stack+56976,int_stack+17856,6);
 /*--- compute (d0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+65292,int_stack+30246,int_stack+42396,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5094,int_stack+4176,int_stack+3360,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+16200,int_stack+5094,int_stack+10260,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+39486,int_stack+16200,int_stack+12420,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+39486,int_stack+24786,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+39486,int_stack+0,int_stack+49956,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+39486,int_stack+56976,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+39486,int_stack+0,int_stack+30246,6);
 /*--- compute (d0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+39486,int_stack+65292,6);
 return int_stack+0;}
