/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0ni(Libint_t*, prim_data*);

  /* Computes quartets of (d0|ni) integrals */

REALTYPE *hrr_order_d0ni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 memset(int_stack,0,4494*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4494;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0ni(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4494,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5682,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+7086,int_stack+5682,int_stack+4494,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9462,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+11100,int_stack+9462,int_stack+5682,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+13908,int_stack+11100,int_stack+7086,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4494,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17868,int_stack+4494,int_stack+9462,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6384,int_stack+17868,int_stack+11100,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+21144,int_stack+6384,int_stack+13908,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+11064,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+13224,int_stack+11064,int_stack+4494,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+27084,int_stack+13224,int_stack+17868,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+32544,int_stack+27084,int_stack+6384,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+39564,int_stack+32544,int_stack+21144,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4494,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+17004,int_stack+4494,int_stack+11064,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+17004,int_stack+13224,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6300,int_stack+0,int_stack+27084,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+14490,int_stack+6300,int_stack+32544,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+14490,int_stack+39564,6);
 return int_stack+0;}
