/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddmg(Libint_t*, prim_data*);

  /* Computes quartets of (dd|mg) integrals */

REALTYPE *hrr_order_ddmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][9] = int_stack + 0;
 Libint->vrr_classes[2][10] = int_stack + 330;
 Libint->vrr_classes[2][11] = int_stack + 726;
 Libint->vrr_classes[2][12] = int_stack + 1194;
 Libint->vrr_classes[2][13] = int_stack + 1740;
 Libint->vrr_classes[3][9] = int_stack + 2370;
 Libint->vrr_classes[3][10] = int_stack + 2920;
 Libint->vrr_classes[3][11] = int_stack + 3580;
 Libint->vrr_classes[3][12] = int_stack + 4360;
 Libint->vrr_classes[3][13] = int_stack + 5270;
 Libint->vrr_classes[4][9] = int_stack + 6320;
 Libint->vrr_classes[4][10] = int_stack + 7145;
 Libint->vrr_classes[4][11] = int_stack + 8135;
 Libint->vrr_classes[4][12] = int_stack + 9305;
 Libint->vrr_classes[4][13] = int_stack + 10670;
 memset(int_stack,0,12245*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12245;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddmg(Libint, Data);
   Data++;
 }
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12245,int_stack+330,int_stack+0,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13235,int_stack+726,int_stack+330,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+14423,int_stack+13235,int_stack+12245,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16403,int_stack+1194,int_stack+726,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+17807,int_stack+16403,int_stack+13235,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+20183,int_stack+17807,int_stack+14423,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12245,int_stack+1740,int_stack+1194,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+23483,int_stack+12245,int_stack+16403,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12245,int_stack+23483,int_stack+17807,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+23483,int_stack+12245,int_stack+20183,6);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12245,int_stack+2920,int_stack+2370,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13895,int_stack+3580,int_stack+2920,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+15875,int_stack+13895,int_stack+12245,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19175,int_stack+4360,int_stack+3580,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+19175,int_stack+13895,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+28433,int_stack+0,int_stack+15875,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12245,int_stack+5270,int_stack+4360,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+33933,int_stack+12245,int_stack+19175,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12245,int_stack+33933,int_stack+0,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+33933,int_stack+12245,int_stack+28433,10);
 /*--- compute (dp|mg) ---*/
 hrr1_build_dp(Libint->AB,int_stack+42183,int_stack+33933,int_stack+23483,825);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12245,int_stack+7145,int_stack+6320,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14720,int_stack+8135,int_stack+7145,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+17690,int_stack+14720,int_stack+12245,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+22640,int_stack+9305,int_stack+8135,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+26150,int_stack+22640,int_stack+14720,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+26150,int_stack+17690,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+12245,int_stack+10670,int_stack+9305,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57033,int_stack+12245,int_stack+22640,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+8250,int_stack+57033,int_stack+26150,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+18150,int_stack+8250,int_stack+0,15);
 /*--- compute (fp|mg) ---*/
 hrr1_build_fp(Libint->AB,int_stack+57033,int_stack+18150,int_stack+33933,825);
 /*--- compute (dd|mg) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+57033,int_stack+42183,825);
 return int_stack+0;}
