/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddnm(Libint_t*, prim_data*);

  /* Computes quartets of (dd|nm) integrals */

REALTYPE *hrr_order_ddnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 Libint->vrr_classes[2][17] = int_stack + 4494;
 Libint->vrr_classes[2][18] = int_stack + 5520;
 Libint->vrr_classes[2][19] = int_stack + 6660;
 Libint->vrr_classes[3][10] = int_stack + 7920;
 Libint->vrr_classes[3][11] = int_stack + 8580;
 Libint->vrr_classes[3][12] = int_stack + 9360;
 Libint->vrr_classes[3][13] = int_stack + 10270;
 Libint->vrr_classes[3][14] = int_stack + 11320;
 Libint->vrr_classes[3][15] = int_stack + 12520;
 Libint->vrr_classes[3][16] = int_stack + 13880;
 Libint->vrr_classes[3][17] = int_stack + 15410;
 Libint->vrr_classes[3][18] = int_stack + 17120;
 Libint->vrr_classes[3][19] = int_stack + 19020;
 Libint->vrr_classes[4][10] = int_stack + 21120;
 Libint->vrr_classes[4][11] = int_stack + 22110;
 Libint->vrr_classes[4][12] = int_stack + 23280;
 Libint->vrr_classes[4][13] = int_stack + 24645;
 Libint->vrr_classes[4][14] = int_stack + 26220;
 Libint->vrr_classes[4][15] = int_stack + 28020;
 Libint->vrr_classes[4][16] = int_stack + 30060;
 Libint->vrr_classes[4][17] = int_stack + 32355;
 Libint->vrr_classes[4][18] = int_stack + 34920;
 Libint->vrr_classes[4][19] = int_stack + 37770;
 memset(int_stack,0,40920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddnm(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40920,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+42108,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43512,int_stack+42108,int_stack+40920,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45888,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+47526,int_stack+45888,int_stack+42108,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+50334,int_stack+47526,int_stack+43512,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+40920,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+54294,int_stack+40920,int_stack+45888,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42810,int_stack+54294,int_stack+47526,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+57570,int_stack+42810,int_stack+50334,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+47490,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49650,int_stack+47490,int_stack+40920,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+63510,int_stack+49650,int_stack+54294,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+68970,int_stack+63510,int_stack+42810,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+75990,int_stack+68970,int_stack+57570,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+40920,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+53430,int_stack+40920,int_stack+47490,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+84306,int_stack+53430,int_stack+49650,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+43368,int_stack+84306,int_stack+63510,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+57750,int_stack+43368,int_stack+68970,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+90606,int_stack+57750,int_stack+75990,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+67578,int_stack+4494,int_stack+3576,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+70332,int_stack+67578,int_stack+40920,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+75228,int_stack+70332,int_stack+53430,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+101694,int_stack+75228,int_stack+84306,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+111144,int_stack+101694,int_stack+43368,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+40920,int_stack+111144,int_stack+57750,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+122610,int_stack+40920,int_stack+90606,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+54024,int_stack+5520,int_stack+4494,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+57102,int_stack+54024,int_stack+67578,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+82428,int_stack+57102,int_stack+70332,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+62610,int_stack+82428,int_stack+75228,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+136866,int_stack+62610,int_stack+101694,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+90588,int_stack+136866,int_stack+111144,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+150096,int_stack+90588,int_stack+40920,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+166944,int_stack+150096,int_stack+122610,6);
 /*--- compute (d0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+40920,int_stack+6660,int_stack+5520,6);
 /*--- compute (d0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44340,int_stack+40920,int_stack+54024,6);
 /*--- compute (d0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105876,int_stack+44340,int_stack+57102,6);
 /*--- compute (d0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+40920,int_stack+105876,int_stack+82428,6);
 /*--- compute (d0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+105876,int_stack+40920,int_stack+62610,6);
 /*--- compute (d0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+40920,int_stack+105876,int_stack+136866,6);
 /*--- compute (d0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+105876,int_stack+40920,int_stack+90588,6);
 /*--- compute (d0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+40920,int_stack+105876,int_stack+150096,6);
 /*--- compute (d0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+61980,int_stack+40920,int_stack+166944,6);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40920,int_stack+8580,int_stack+7920,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+42900,int_stack+9360,int_stack+8580,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45240,int_stack+42900,int_stack+40920,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49200,int_stack+10270,int_stack+9360,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+51930,int_stack+49200,int_stack+42900,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+83760,int_stack+51930,int_stack+45240,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+40920,int_stack+11320,int_stack+10270,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+90360,int_stack+40920,int_stack+49200,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+44070,int_stack+90360,int_stack+51930,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+51870,int_stack+44070,int_stack+83760,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+83760,int_stack+12520,int_stack+11320,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+95820,int_stack+83760,int_stack+40920,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+102120,int_stack+95820,int_stack+90360,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+111220,int_stack+102120,int_stack+44070,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+122920,int_stack+111220,int_stack+51870,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+40920,int_stack+13880,int_stack+12520,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+45000,int_stack+40920,int_stack+83760,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+83760,int_stack+45000,int_stack+95820,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+136780,int_stack+83760,int_stack+102120,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+94260,int_stack+136780,int_stack+111220,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+150430,int_stack+94260,int_stack+122920,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+110640,int_stack+15410,int_stack+13880,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+115230,int_stack+110640,int_stack+40920,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+123390,int_stack+115230,int_stack+45000,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+40920,int_stack+123390,int_stack+83760,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+168910,int_stack+40920,int_stack+136780,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+188020,int_stack+168910,int_stack+94260,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+83760,int_stack+188020,int_stack+150430,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+56670,int_stack+17120,int_stack+15410,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+135390,int_stack+56670,int_stack+110640,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+144570,int_stack+135390,int_stack+115230,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+209860,int_stack+144570,int_stack+123390,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+107520,int_stack+209860,int_stack+40920,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+227860,int_stack+107520,int_stack+168910,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+158170,int_stack+227860,int_stack+188020,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+253340,int_stack+158170,int_stack+83760,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+83760,int_stack+19020,int_stack+17120,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+89460,int_stack+83760,int_stack+56670,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+40920,int_stack+89460,int_stack+135390,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+83760,int_stack+40920,int_stack+144570,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+129570,int_stack+83760,int_stack+209860,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+186250,int_stack+129570,int_stack+107520,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+83760,int_stack+186250,int_stack+227860,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+186250,int_stack+83760,int_stack+158170,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+83760,int_stack+186250,int_stack+253340,10);
 /*--- compute (dp|nm) ---*/
 hrr1_build_dp(Libint->AB,int_stack+120060,int_stack+83760,int_stack+61980,3630);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+185400,int_stack+22110,int_stack+21120,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+188370,int_stack+23280,int_stack+22110,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+191880,int_stack+188370,int_stack+185400,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+197820,int_stack+24645,int_stack+23280,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+201915,int_stack+197820,int_stack+188370,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+208935,int_stack+201915,int_stack+191880,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+185400,int_stack+26220,int_stack+24645,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+218835,int_stack+185400,int_stack+197820,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+190125,int_stack+218835,int_stack+201915,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+227025,int_stack+190125,int_stack+208935,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+201825,int_stack+28020,int_stack+26220,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+207225,int_stack+201825,int_stack+185400,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+241875,int_stack+207225,int_stack+218835,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+255525,int_stack+241875,int_stack+190125,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+40920,int_stack+255525,int_stack+227025,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+185400,int_stack+30060,int_stack+28020,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+216675,int_stack+185400,int_stack+201825,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+61710,int_stack+216675,int_stack+207225,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+191520,int_stack+61710,int_stack+241875,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+227475,int_stack+191520,int_stack+255525,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+252045,int_stack+227475,int_stack+40920,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+40920,int_stack+32355,int_stack+30060,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+47805,int_stack+40920,int_stack+185400,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+47805,int_stack+216675,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+279765,int_stack+0,int_stack+61710,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+303390,int_stack+279765,int_stack+191520,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+185400,int_stack+303390,int_stack+227475,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+332055,int_stack+185400,int_stack+252045,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+218160,int_stack+34920,int_stack+32355,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+225855,int_stack+218160,int_stack+40920,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+239625,int_stack+225855,int_stack+47805,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+40920,int_stack+239625,int_stack+0,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+40920,int_stack+279765,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+260025,int_stack+0,int_stack+303390,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+367695,int_stack+260025,int_stack+185400,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+409815,int_stack+367695,int_stack+332055,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+185400,int_stack+37770,int_stack+34920,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+193950,int_stack+185400,int_stack+218160,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+298245,int_stack+193950,int_stack+225855,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+185400,int_stack+298245,int_stack+239625,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+298245,int_stack+185400,int_stack+40920,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+185400,int_stack+298245,int_stack+0,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+185400,int_stack+260025,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+185400,int_stack+0,int_stack+367695,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+185400,int_stack+409815,15);
 /*--- compute (fp|nm) ---*/
 hrr1_build_fp(Libint->AB,int_stack+185400,int_stack+0,int_stack+83760,3630);
 /*--- compute (dd|nm) ---*/
 hrr1_build_dd(Libint->AB,int_stack+294300,int_stack+185400,int_stack+120060,3630);
 return int_stack+294300;}
