/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpkp(Libint_t*, prim_data*);

  /* Computes quartets of (dp|kp) integrals */

REALTYPE *hrr_order_dpkp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][7] = int_stack + 0;
 Libint->vrr_classes[2][8] = int_stack + 216;
 Libint->vrr_classes[3][7] = int_stack + 486;
 Libint->vrr_classes[3][8] = int_stack + 846;
 memset(int_stack,0,1296*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1296;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpkp(Libint, Data);
   Data++;
 }
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1296,int_stack+216,int_stack+0,6);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1944,int_stack+846,int_stack+486,10);
 /*--- compute (dp|kp) ---*/
 hrr1_build_dp(Libint->AB,int_stack+3024,int_stack+1944,int_stack+1296,108);
 return int_stack+3024;}
