/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdll(Libint_t*, prim_data*);

  /* Computes quartets of (fd|ll) integrals */

REALTYPE *hrr_order_fdll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[3][14] = int_stack + 4400;
 Libint->vrr_classes[3][15] = int_stack + 5600;
 Libint->vrr_classes[3][16] = int_stack + 6960;
 Libint->vrr_classes[4][8] = int_stack + 8490;
 Libint->vrr_classes[4][9] = int_stack + 9165;
 Libint->vrr_classes[4][10] = int_stack + 9990;
 Libint->vrr_classes[4][11] = int_stack + 10980;
 Libint->vrr_classes[4][12] = int_stack + 12150;
 Libint->vrr_classes[4][13] = int_stack + 13515;
 Libint->vrr_classes[4][14] = int_stack + 15090;
 Libint->vrr_classes[4][15] = int_stack + 16890;
 Libint->vrr_classes[4][16] = int_stack + 18930;
 Libint->vrr_classes[5][8] = int_stack + 21225;
 Libint->vrr_classes[5][9] = int_stack + 22170;
 Libint->vrr_classes[5][10] = int_stack + 23325;
 Libint->vrr_classes[5][11] = int_stack + 24711;
 Libint->vrr_classes[5][12] = int_stack + 26349;
 Libint->vrr_classes[5][13] = int_stack + 28260;
 Libint->vrr_classes[5][14] = int_stack + 30465;
 Libint->vrr_classes[5][15] = int_stack + 32985;
 Libint->vrr_classes[5][16] = int_stack + 35841;
 memset(int_stack,0,39054*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 39054;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdll(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39054,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40404,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+42054,int_stack+40404,int_stack+39054,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44754,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46734,int_stack+44754,int_stack+40404,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+50034,int_stack+46734,int_stack+42054,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39054,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54534,int_stack+39054,int_stack+44754,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+58494,int_stack+54534,int_stack+46734,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+41394,int_stack+58494,int_stack+50034,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+48144,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+63994,int_stack+48144,int_stack+39054,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+68674,int_stack+63994,int_stack+54534,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+75274,int_stack+68674,int_stack+58494,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+50874,int_stack+75274,int_stack+41394,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39054,int_stack+4400,int_stack+3350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+42204,int_stack+39054,int_stack+48144,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+83524,int_stack+42204,int_stack+63994,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+91324,int_stack+83524,int_stack+68674,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+60324,int_stack+91324,int_stack+75274,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+101224,int_stack+60324,int_stack+50874,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+47664,int_stack+5600,int_stack+4400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+51264,int_stack+47664,int_stack+39054,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+71874,int_stack+51264,int_stack+42204,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+113824,int_stack+71874,int_stack+83524,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+125524,int_stack+113824,int_stack+91324,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+80974,int_stack+125524,int_stack+60324,10);
 /*--- compute (f0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+139384,int_stack+80974,int_stack+101224,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+39054,int_stack+6960,int_stack+5600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+57564,int_stack+39054,int_stack+47664,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+39054,int_stack+57564,int_stack+51264,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+49554,int_stack+39054,int_stack+71874,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+63204,int_stack+49554,int_stack+113824,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+39054,int_stack+63204,int_stack+125524,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+57534,int_stack+39054,int_stack+80974,10);
 /*--- compute (f0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+77334,int_stack+57534,int_stack+139384,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39054,int_stack+9165,int_stack+8490,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41079,int_stack+9990,int_stack+9165,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+43554,int_stack+41079,int_stack+39054,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47604,int_stack+10980,int_stack+9990,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50574,int_stack+47604,int_stack+41079,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+55524,int_stack+50574,int_stack+43554,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39054,int_stack+12150,int_stack+10980,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62274,int_stack+39054,int_stack+47604,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+68214,int_stack+62274,int_stack+50574,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+42564,int_stack+68214,int_stack+55524,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+52689,int_stack+13515,int_stack+12150,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+97584,int_stack+52689,int_stack+39054,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+104604,int_stack+97584,int_stack+62274,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+114504,int_stack+104604,int_stack+68214,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+56784,int_stack+114504,int_stack+42564,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39054,int_stack+15090,int_stack+13515,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+43779,int_stack+39054,int_stack+52689,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+126879,int_stack+43779,int_stack+97584,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+138579,int_stack+126879,int_stack+104604,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+153429,int_stack+138579,int_stack+114504,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+97584,int_stack+153429,int_stack+56784,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+116484,int_stack+16890,int_stack+15090,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+51969,int_stack+116484,int_stack+39054,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+61419,int_stack+51969,int_stack+43779,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+170754,int_stack+61419,int_stack+126879,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+188304,int_stack+170754,int_stack+138579,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+121884,int_stack+188304,int_stack+153429,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+144984,int_stack+121884,int_stack+97584,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+97584,int_stack+18930,int_stack+16890,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+103704,int_stack+97584,int_stack+116484,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+103704,int_stack+51969,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+97584,int_stack+0,int_stack+61419,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+39054,int_stack+97584,int_stack+170754,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+209094,int_stack+39054,int_stack+188304,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+39054,int_stack+209094,int_stack+121884,15);
 /*--- compute (g0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+97584,int_stack+39054,int_stack+144984,15);
 /*--- compute (fp|ll) ---*/
 hrr1_build_fp(Libint->AB,int_stack+127959,int_stack+97584,int_stack+77334,2025);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39054,int_stack+22170,int_stack+21225,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41889,int_stack+23325,int_stack+22170,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+45354,int_stack+41889,int_stack+39054,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51024,int_stack+24711,int_stack+23325,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+55182,int_stack+51024,int_stack+41889,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+62112,int_stack+55182,int_stack+45354,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39054,int_stack+26349,int_stack+24711,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+71562,int_stack+39054,int_stack+51024,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+79878,int_stack+71562,int_stack+55182,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+43968,int_stack+79878,int_stack+62112,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+58143,int_stack+28260,int_stack+26349,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188709,int_stack+58143,int_stack+39054,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+198537,int_stack+188709,int_stack+71562,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+212397,int_stack+198537,int_stack+79878,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+63876,int_stack+212397,int_stack+43968,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39054,int_stack+30465,int_stack+28260,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+45669,int_stack+39054,int_stack+58143,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+45669,int_stack+188709,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+229722,int_stack+0,int_stack+198537,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+250512,int_stack+229722,int_stack+212397,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+188709,int_stack+250512,int_stack+63876,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+215169,int_stack+32985,int_stack+30465,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+57135,int_stack+215169,int_stack+39054,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+70365,int_stack+57135,int_stack+45669,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+274767,int_stack+70365,int_stack+0,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+274767,int_stack+229722,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+299337,int_stack+0,int_stack+250512,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+222729,int_stack+299337,int_stack+188709,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+188709,int_stack+35841,int_stack+32985,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+197277,int_stack+188709,int_stack+215169,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+29106,int_stack+197277,int_stack+57135,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+188709,int_stack+29106,int_stack+70365,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+29106,int_stack+188709,int_stack+274767,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+256749,int_stack+29106,int_stack+0,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+256749,int_stack+299337,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+256749,int_stack+0,int_stack+222729,21);
 /*--- compute (gp|ll) ---*/
 hrr1_build_gp(Libint->AB,int_stack+0,int_stack+256749,int_stack+97584,2025);
 /*--- compute (fd|ll) ---*/
 hrr1_build_fd(Libint->AB,int_stack+188709,int_stack+0,int_stack+127959,2025);
 return int_stack+188709;}
