/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpkh(Libint_t*, prim_data*);

  /* Computes quartets of (fp|kh) integrals */

REALTYPE *hrr_order_fpkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[4][7] = int_stack + 3710;
 Libint->vrr_classes[4][8] = int_stack + 4250;
 Libint->vrr_classes[4][9] = int_stack + 4925;
 Libint->vrr_classes[4][10] = int_stack + 5750;
 Libint->vrr_classes[4][11] = int_stack + 6740;
 Libint->vrr_classes[4][12] = int_stack + 7910;
 memset(int_stack,0,9275*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9275;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpkh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+9275,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10355,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+11705,int_stack+10355,int_stack+9275,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+13865,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+15515,int_stack+13865,int_stack+10355,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+18215,int_stack+15515,int_stack+11705,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9275,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21815,int_stack+9275,int_stack+13865,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+25115,int_stack+21815,int_stack+15515,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+11255,int_stack+25115,int_stack+18215,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16655,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+29615,int_stack+16655,int_stack+9275,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33575,int_stack+29615,int_stack+21815,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+16655,int_stack+33575,int_stack+25115,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+23405,int_stack+16655,int_stack+11255,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+9275,int_stack+4250,int_stack+3710,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10895,int_stack+4925,int_stack+4250,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+12920,int_stack+10895,int_stack+9275,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16160,int_stack+5750,int_stack+4925,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18635,int_stack+16160,int_stack+10895,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+30965,int_stack+18635,int_stack+12920,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9275,int_stack+6740,int_stack+5750,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+9275,int_stack+16160,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+36365,int_stack+0,int_stack+18635,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+12245,int_stack+36365,int_stack+30965,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30965,int_stack+7910,int_stack+6740,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+43115,int_stack+30965,int_stack+9275,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+49055,int_stack+43115,int_stack+0,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+49055,int_stack+36365,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+30965,int_stack+0,int_stack+12245,15);
 /*--- compute (fp|kh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+0,int_stack+30965,int_stack+23405,756);
 return int_stack+0;}
