/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_g0kk(Libint_t*, prim_data*);

  /* Computes quartets of (g0|kk) integrals */

REALTYPE *hrr_order_g0kk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[4][13] = int_stack + 5565;
 Libint->vrr_classes[4][14] = int_stack + 7140;
 memset(int_stack,0,8940*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8940;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_g0kk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8940,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10560,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+12585,int_stack+10560,int_stack+8940,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+15825,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18300,int_stack+15825,int_stack+10560,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+22350,int_stack+18300,int_stack+12585,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8940,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27750,int_stack+8940,int_stack+15825,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+32700,int_stack+27750,int_stack+18300,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+11910,int_stack+32700,int_stack+22350,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20010,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39450,int_stack+20010,int_stack+8940,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45390,int_stack+39450,int_stack+27750,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+53640,int_stack+45390,int_stack+32700,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+23520,int_stack+53640,int_stack+11910,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8940,int_stack+5565,int_stack+4200,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+63765,int_stack+8940,int_stack+20010,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+13035,int_stack+63765,int_stack+39450,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+70785,int_stack+13035,int_stack+45390,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+34860,int_stack+70785,int_stack+53640,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+83160,int_stack+34860,int_stack+23520,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+22935,int_stack+7140,int_stack+5565,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+49035,int_stack+22935,int_stack+8940,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+22935,int_stack+49035,int_stack+63765,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+49035,int_stack+22935,int_stack+13035,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+49035,int_stack+70785,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+49035,int_stack+0,int_stack+34860,15);
 /*--- compute (g0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+49035,int_stack+83160,15);
 return int_stack+0;}
