/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdif(Libint_t*, prim_data*);

  /* Computes quartets of (gd|if) integrals */

REALTYPE *hrr_order_gdif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[4][9] = int_stack + 1635;
 Libint->vrr_classes[5][6] = int_stack + 2460;
 Libint->vrr_classes[5][7] = int_stack + 3048;
 Libint->vrr_classes[5][8] = int_stack + 3804;
 Libint->vrr_classes[5][9] = int_stack + 4749;
 Libint->vrr_classes[6][6] = int_stack + 5904;
 Libint->vrr_classes[6][7] = int_stack + 6688;
 Libint->vrr_classes[6][8] = int_stack + 7696;
 Libint->vrr_classes[6][9] = int_stack + 8956;
 memset(int_stack,0,10496*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10496;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdif(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+10496,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11756,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+13376,int_stack+11756,int_stack+10496,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15896,int_stack+1635,int_stack+960,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17921,int_stack+15896,int_stack+11756,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+21161,int_stack+17921,int_stack+13376,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+10496,int_stack+3048,int_stack+2460,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12260,int_stack+3804,int_stack+3048,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+14528,int_stack+12260,int_stack+10496,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18056,int_stack+4749,int_stack+3804,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+18056,int_stack+12260,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+25361,int_stack+0,int_stack+14528,21);
 /*--- compute (gp|if) ---*/
 hrr1_build_gp(Libint->AB,int_stack+31241,int_stack+25361,int_stack+21161,280);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+6688,int_stack+5904,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2352,int_stack+7696,int_stack+6688,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10496,int_stack+2352,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15200,int_stack+8956,int_stack+7696,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18980,int_stack+15200,int_stack+2352,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+18980,int_stack+10496,28);
 /*--- compute (hp|if) ---*/
 hrr1_build_hp(Libint->AB,int_stack+43841,int_stack+0,int_stack+25361,280);
 /*--- compute (gd|if) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+43841,int_stack+31241,280);
 return int_stack+0;}
