/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggkg(Libint_t*, prim_data*);

  /* Computes quartets of (gg|kg) integrals */

REALTYPE *hrr_order_ggkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[5][7] = int_stack + 4200;
 Libint->vrr_classes[5][8] = int_stack + 4956;
 Libint->vrr_classes[5][9] = int_stack + 5901;
 Libint->vrr_classes[5][10] = int_stack + 7056;
 Libint->vrr_classes[5][11] = int_stack + 8442;
 Libint->vrr_classes[6][7] = int_stack + 10080;
 Libint->vrr_classes[6][8] = int_stack + 11088;
 Libint->vrr_classes[6][9] = int_stack + 12348;
 Libint->vrr_classes[6][10] = int_stack + 13888;
 Libint->vrr_classes[6][11] = int_stack + 15736;
 Libint->vrr_classes[7][7] = int_stack + 17920;
 Libint->vrr_classes[7][8] = int_stack + 19216;
 Libint->vrr_classes[7][9] = int_stack + 20836;
 Libint->vrr_classes[7][10] = int_stack + 22816;
 Libint->vrr_classes[7][11] = int_stack + 25192;
 Libint->vrr_classes[8][7] = int_stack + 28000;
 Libint->vrr_classes[8][8] = int_stack + 29620;
 Libint->vrr_classes[8][9] = int_stack + 31645;
 Libint->vrr_classes[8][10] = int_stack + 34120;
 Libint->vrr_classes[8][11] = int_stack + 37090;
 memset(int_stack,0,40600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggkg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40600,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+42220,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44245,int_stack+42220,int_stack+40600,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47485,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49960,int_stack+47485,int_stack+42220,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+54010,int_stack+49960,int_stack+44245,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40600,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59410,int_stack+40600,int_stack+47485,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+40600,int_stack+59410,int_stack+49960,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+59410,int_stack+40600,int_stack+54010,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40600,int_stack+4956,int_stack+4200,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+42868,int_stack+5901,int_stack+4956,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+45703,int_stack+42868,int_stack+40600,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50239,int_stack+7056,int_stack+5901,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+53704,int_stack+50239,int_stack+42868,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+67510,int_stack+53704,int_stack+45703,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40600,int_stack+8442,int_stack+7056,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+40600,int_stack+50239,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+40600,int_stack+0,int_stack+53704,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+75070,int_stack+40600,int_stack+67510,21);
 /*--- compute (gp|kg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+86410,int_stack+75070,int_stack+59410,540);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40600,int_stack+11088,int_stack+10080,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43624,int_stack+12348,int_stack+11088,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47404,int_stack+43624,int_stack+40600,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53452,int_stack+13888,int_stack+12348,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+58072,int_stack+53452,int_stack+43624,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+58072,int_stack+47404,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40600,int_stack+15736,int_stack+13888,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65632,int_stack+40600,int_stack+53452,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+40600,int_stack+65632,int_stack+58072,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+53200,int_stack+40600,int_stack+0,28);
 /*--- compute (hp|kg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+110710,int_stack+53200,int_stack+75070,540);
 /*--- compute (gd|kg) ---*/
 hrr1_build_gd(Libint->AB,int_stack+144730,int_stack+110710,int_stack+86410,540);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+19216,int_stack+17920,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+20836,int_stack+19216,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+8748,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40600,int_stack+22816,int_stack+20836,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68320,int_stack+40600,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+78040,int_stack+68320,int_stack+8748,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+25192,int_stack+22816,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7128,int_stack+0,int_stack+40600,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+91000,int_stack+7128,int_stack+68320,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+91000,int_stack+78040,36);
 /*--- compute (ip|kg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+193330,int_stack+0,int_stack+53200,540);
 /*--- compute (hd|kg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+40600,int_stack+193330,int_stack+110710,540);
 /*--- compute (gf|kg) ---*/
 hrr1_build_gf(Libint->AB,int_stack+238690,int_stack+40600,int_stack+144730,540);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+108640,int_stack+29620,int_stack+28000,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+113500,int_stack+31645,int_stack+29620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+119575,int_stack+113500,int_stack+108640,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129295,int_stack+34120,int_stack+31645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+136720,int_stack+129295,int_stack+113500,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+148870,int_stack+136720,int_stack+119575,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+108640,int_stack+37090,int_stack+34120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+165070,int_stack+108640,int_stack+129295,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+108640,int_stack+165070,int_stack+136720,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+165070,int_stack+108640,int_stack+148870,45);
 /*--- compute (kp|kg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+319690,int_stack+165070,int_stack+0,540);
 /*--- compute (id|kg) ---*/
 hrr1_build_id(Libint->AB,int_stack+378010,int_stack+319690,int_stack+193330,540);
 /*--- compute (hf|kg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+108640,int_stack+378010,int_stack+40600,540);
 /*--- compute (gg|kg) ---*/
 hrr1_build_gg(Libint->AB,int_stack+319690,int_stack+108640,int_stack+238690,540);
 return int_stack+319690;}
