/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gglk(Libint_t*, prim_data*);

  /* Computes quartets of (gg|lk) integrals */

REALTYPE *hrr_order_gglk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 Libint->vrr_classes[5][8] = int_stack + 10440;
 Libint->vrr_classes[5][9] = int_stack + 11385;
 Libint->vrr_classes[5][10] = int_stack + 12540;
 Libint->vrr_classes[5][11] = int_stack + 13926;
 Libint->vrr_classes[5][12] = int_stack + 15564;
 Libint->vrr_classes[5][13] = int_stack + 17475;
 Libint->vrr_classes[5][14] = int_stack + 19680;
 Libint->vrr_classes[5][15] = int_stack + 22200;
 Libint->vrr_classes[6][8] = int_stack + 25056;
 Libint->vrr_classes[6][9] = int_stack + 26316;
 Libint->vrr_classes[6][10] = int_stack + 27856;
 Libint->vrr_classes[6][11] = int_stack + 29704;
 Libint->vrr_classes[6][12] = int_stack + 31888;
 Libint->vrr_classes[6][13] = int_stack + 34436;
 Libint->vrr_classes[6][14] = int_stack + 37376;
 Libint->vrr_classes[6][15] = int_stack + 40736;
 Libint->vrr_classes[7][8] = int_stack + 44544;
 Libint->vrr_classes[7][9] = int_stack + 46164;
 Libint->vrr_classes[7][10] = int_stack + 48144;
 Libint->vrr_classes[7][11] = int_stack + 50520;
 Libint->vrr_classes[7][12] = int_stack + 53328;
 Libint->vrr_classes[7][13] = int_stack + 56604;
 Libint->vrr_classes[7][14] = int_stack + 60384;
 Libint->vrr_classes[7][15] = int_stack + 64704;
 Libint->vrr_classes[8][8] = int_stack + 69600;
 Libint->vrr_classes[8][9] = int_stack + 71625;
 Libint->vrr_classes[8][10] = int_stack + 74100;
 Libint->vrr_classes[8][11] = int_stack + 77070;
 Libint->vrr_classes[8][12] = int_stack + 80580;
 Libint->vrr_classes[8][13] = int_stack + 84675;
 Libint->vrr_classes[8][14] = int_stack + 89400;
 Libint->vrr_classes[8][15] = int_stack + 94800;
 memset(int_stack,0,100920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 100920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gglk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+100920,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+102945,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+105420,int_stack+102945,int_stack+100920,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+109470,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+112440,int_stack+109470,int_stack+102945,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+117390,int_stack+112440,int_stack+105420,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100920,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124140,int_stack+100920,int_stack+109470,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+130080,int_stack+124140,int_stack+112440,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+104430,int_stack+130080,int_stack+117390,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+114555,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138330,int_stack+114555,int_stack+100920,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+145350,int_stack+138330,int_stack+124140,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+155250,int_stack+145350,int_stack+130080,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+118650,int_stack+155250,int_stack+104430,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+100920,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+105645,int_stack+100920,int_stack+114555,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+167625,int_stack+105645,int_stack+138330,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+179325,int_stack+167625,int_stack+145350,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+132825,int_stack+179325,int_stack+155250,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+194175,int_stack+132825,int_stack+118650,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+113835,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+119235,int_stack+113835,int_stack+100920,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+150150,int_stack+119235,int_stack+105645,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+100920,int_stack+150150,int_stack+167625,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+150150,int_stack+100920,int_stack+179325,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+100920,int_stack+150150,int_stack+132825,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+124020,int_stack+100920,int_stack+194175,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+100920,int_stack+11385,int_stack+10440,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+103755,int_stack+12540,int_stack+11385,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+107220,int_stack+103755,int_stack+100920,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+112890,int_stack+13926,int_stack+12540,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+117048,int_stack+112890,int_stack+103755,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+148320,int_stack+117048,int_stack+107220,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100920,int_stack+15564,int_stack+13926,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+157770,int_stack+100920,int_stack+112890,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+166086,int_stack+157770,int_stack+117048,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+105834,int_stack+166086,int_stack+148320,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+148320,int_stack+17475,int_stack+15564,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+177636,int_stack+148320,int_stack+100920,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+187464,int_stack+177636,int_stack+157770,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+187464,int_stack+166086,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+154053,int_stack+0,int_stack+105834,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+100920,int_stack+19680,int_stack+17475,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+107535,int_stack+100920,int_stack+148320,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+201324,int_stack+107535,int_stack+177636,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+217704,int_stack+201324,int_stack+187464,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+173898,int_stack+217704,int_stack+0,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+238494,int_stack+173898,int_stack+154053,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+22200,int_stack+19680,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7560,int_stack+0,int_stack+100920,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+148320,int_stack+7560,int_stack+107535,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+148320,int_stack+201324,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+264954,int_stack+0,int_stack+217704,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+198153,int_stack+264954,int_stack+173898,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+148320,int_stack+198153,int_stack+238494,21);
 /*--- compute (gp|lk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+182340,int_stack+148320,int_stack+124020,1620);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+26316,int_stack+25056,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3780,int_stack+27856,int_stack+26316,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+8400,int_stack+3780,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15960,int_stack+29704,int_stack+27856,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+255240,int_stack+15960,int_stack+3780,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+264480,int_stack+255240,int_stack+8400,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+31888,int_stack+29704,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+277080,int_stack+0,int_stack+15960,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+6552,int_stack+277080,int_stack+255240,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+100920,int_stack+6552,int_stack+264480,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+255240,int_stack+34436,int_stack+31888,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+262884,int_stack+255240,int_stack+0,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119820,int_stack+262884,int_stack+277080,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+275988,int_stack+119820,int_stack+6552,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+275988,int_stack+100920,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+100920,int_stack+37376,int_stack+34436,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+299088,int_stack+100920,int_stack+255240,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+314376,int_stack+299088,int_stack+262884,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+336216,int_stack+314376,int_stack+119820,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+109740,int_stack+336216,int_stack+275988,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+255240,int_stack+109740,int_stack+0,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+40736,int_stack+37376,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10080,int_stack+0,int_stack+100920,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+363936,int_stack+10080,int_stack+299088,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+363936,int_stack+314376,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+290520,int_stack+0,int_stack+336216,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+290520,int_stack+109740,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+290520,int_stack+0,int_stack+255240,28);
 /*--- compute (hp|lk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+335880,int_stack+290520,int_stack+148320,1620);
 /*--- compute (gd|lk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+437940,int_stack+335880,int_stack+182340,1620);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+46164,int_stack+44544,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4860,int_stack+48144,int_stack+46164,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+10800,int_stack+4860,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20520,int_stack+50520,int_stack+48144,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27648,int_stack+20520,int_stack+4860,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+100920,int_stack+27648,int_stack+10800,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+53328,int_stack+50520,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+117120,int_stack+0,int_stack+20520,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+131376,int_stack+117120,int_stack+27648,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+8424,int_stack+131376,int_stack+100920,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+100920,int_stack+56604,int_stack+53328,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+32724,int_stack+100920,int_stack+0,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+151176,int_stack+32724,int_stack+117120,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+174936,int_stack+151176,int_stack+131376,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+110748,int_stack+174936,int_stack+8424,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+60384,int_stack+56604,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11340,int_stack+0,int_stack+100920,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+204636,int_stack+11340,int_stack+32724,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+232716,int_stack+204636,int_stack+151176,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+583740,int_stack+232716,int_stack+174936,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+144768,int_stack+583740,int_stack+110748,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+100920,int_stack+64704,int_stack+60384,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113880,int_stack+100920,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+30996,int_stack+113880,int_stack+11340,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+100920,int_stack+30996,int_stack+204636,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+100920,int_stack+232716,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+190128,int_stack+0,int_stack+583740,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+190128,int_stack+144768,36);
 /*--- compute (ip|lk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+100920,int_stack+0,int_stack+290520,1620);
 /*--- compute (hd|lk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+583740,int_stack+100920,int_stack+335880,1620);
 /*--- compute (gf|lk) ---*/
 hrr1_build_gf(Libint->AB,int_stack+787860,int_stack+583740,int_stack+437940,1620);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+58320,int_stack+71625,int_stack+69600,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+237000,int_stack+74100,int_stack+71625,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+244425,int_stack+237000,int_stack+58320,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58320,int_stack+77070,int_stack+74100,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+256575,int_stack+58320,int_stack+237000,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+271425,int_stack+256575,int_stack+244425,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+237000,int_stack+80580,int_stack+77070,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+291675,int_stack+237000,int_stack+58320,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+309495,int_stack+291675,int_stack+256575,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+334245,int_stack+309495,int_stack+271425,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+58320,int_stack+84675,int_stack+80580,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+247530,int_stack+58320,int_stack+237000,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+364620,int_stack+247530,int_stack+291675,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+268590,int_stack+364620,int_stack+309495,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+394320,int_stack+268590,int_stack+334245,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+305715,int_stack+89400,int_stack+84675,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+319890,int_stack+305715,int_stack+58320,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+436845,int_stack+319890,int_stack+247530,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+471945,int_stack+436845,int_stack+364620,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+516495,int_stack+471945,int_stack+268590,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+237000,int_stack+516495,int_stack+394320,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+58320,int_stack+94800,int_stack+89400,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+344460,int_stack+58320,int_stack+305715,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+58320,int_stack+344460,int_stack+319890,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+293700,int_stack+58320,int_stack+436845,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+346350,int_stack+293700,int_stack+471945,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+408720,int_stack+346350,int_stack+516495,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+293700,int_stack+408720,int_stack+237000,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+366600,int_stack+293700,int_stack+0,1620);
 /*--- compute (id|lk) ---*/
 hrr1_build_id(Libint->AB,int_stack+1030860,int_stack+366600,int_stack+100920,1620);
 /*--- compute (hf|lk) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+1030860,int_stack+583740,1620);
 /*--- compute (gg|lk) ---*/
 hrr1_build_gg(Libint->AB,int_stack+340200,int_stack+0,int_stack+787860,1620);
 return int_stack+340200;}
