/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpkk(Libint_t*, prim_data*);

  /* Computes quartets of (gp|kk) integrals */

REALTYPE *hrr_order_gpkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[4][13] = int_stack + 5565;
 Libint->vrr_classes[4][14] = int_stack + 7140;
 Libint->vrr_classes[5][7] = int_stack + 8940;
 Libint->vrr_classes[5][8] = int_stack + 9696;
 Libint->vrr_classes[5][9] = int_stack + 10641;
 Libint->vrr_classes[5][10] = int_stack + 11796;
 Libint->vrr_classes[5][11] = int_stack + 13182;
 Libint->vrr_classes[5][12] = int_stack + 14820;
 Libint->vrr_classes[5][13] = int_stack + 16731;
 Libint->vrr_classes[5][14] = int_stack + 18936;
 memset(int_stack,0,21456*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21456;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpkk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+21456,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+23076,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25101,int_stack+23076,int_stack+21456,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28341,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30816,int_stack+28341,int_stack+23076,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+34866,int_stack+30816,int_stack+25101,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21456,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+40266,int_stack+21456,int_stack+28341,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45216,int_stack+40266,int_stack+30816,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+24426,int_stack+45216,int_stack+34866,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+32526,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51966,int_stack+32526,int_stack+21456,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+57906,int_stack+51966,int_stack+40266,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+66156,int_stack+57906,int_stack+45216,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+36036,int_stack+66156,int_stack+24426,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21456,int_stack+5565,int_stack+4200,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+76281,int_stack+21456,int_stack+32526,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25551,int_stack+76281,int_stack+51966,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+83301,int_stack+25551,int_stack+57906,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+47376,int_stack+83301,int_stack+66156,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+95676,int_stack+47376,int_stack+36036,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35451,int_stack+7140,int_stack+5565,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61551,int_stack+35451,int_stack+21456,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+35451,int_stack+61551,int_stack+76281,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+61551,int_stack+35451,int_stack+25551,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+21456,int_stack+61551,int_stack+83301,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+61551,int_stack+21456,int_stack+47376,15);
 /*--- compute (g0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+21456,int_stack+61551,int_stack+95676,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40896,int_stack+9696,int_stack+8940,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43164,int_stack+10641,int_stack+9696,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+45999,int_stack+43164,int_stack+40896,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50535,int_stack+11796,int_stack+10641,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54000,int_stack+50535,int_stack+43164,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59670,int_stack+54000,int_stack+45999,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40896,int_stack+13182,int_stack+11796,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67230,int_stack+40896,int_stack+50535,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+74160,int_stack+67230,int_stack+54000,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+45054,int_stack+74160,int_stack+59670,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56394,int_stack+14820,int_stack+13182,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+83610,int_stack+56394,int_stack+40896,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+91926,int_stack+83610,int_stack+67230,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+91926,int_stack+74160,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+61308,int_stack+0,int_stack+45054,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+40896,int_stack+16731,int_stack+14820,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+103476,int_stack+40896,int_stack+56394,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+46629,int_stack+103476,int_stack+83610,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+113304,int_stack+46629,int_stack+91926,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+77184,int_stack+113304,int_stack+0,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+130629,int_stack+77184,int_stack+61308,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+18936,int_stack+16731,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+40896,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+60489,int_stack+6615,int_stack+103476,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+60489,int_stack+46629,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+40896,int_stack+0,int_stack+113304,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+97029,int_stack+40896,int_stack+77184,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+40896,int_stack+97029,int_stack+130629,21);
 /*--- compute (gp|kk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+68112,int_stack+40896,int_stack+21456,1296);
 return int_stack+68112;}
