/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gplk(Libint_t*, prim_data*);

  /* Computes quartets of (gp|lk) integrals */

REALTYPE *hrr_order_gplk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 Libint->vrr_classes[5][8] = int_stack + 10440;
 Libint->vrr_classes[5][9] = int_stack + 11385;
 Libint->vrr_classes[5][10] = int_stack + 12540;
 Libint->vrr_classes[5][11] = int_stack + 13926;
 Libint->vrr_classes[5][12] = int_stack + 15564;
 Libint->vrr_classes[5][13] = int_stack + 17475;
 Libint->vrr_classes[5][14] = int_stack + 19680;
 Libint->vrr_classes[5][15] = int_stack + 22200;
 memset(int_stack,0,25056*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 25056;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gplk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+25056,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27081,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29556,int_stack+27081,int_stack+25056,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33606,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36576,int_stack+33606,int_stack+27081,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+41526,int_stack+36576,int_stack+29556,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25056,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48276,int_stack+25056,int_stack+33606,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+54216,int_stack+48276,int_stack+36576,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+28566,int_stack+54216,int_stack+41526,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+38691,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+62466,int_stack+38691,int_stack+25056,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+69486,int_stack+62466,int_stack+48276,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+79386,int_stack+69486,int_stack+54216,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+42786,int_stack+79386,int_stack+28566,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+25056,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+29781,int_stack+25056,int_stack+38691,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+91761,int_stack+29781,int_stack+62466,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+103461,int_stack+91761,int_stack+69486,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+56961,int_stack+103461,int_stack+79386,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+118311,int_stack+56961,int_stack+42786,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+37971,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43371,int_stack+37971,int_stack+25056,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+74286,int_stack+43371,int_stack+29781,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+25056,int_stack+74286,int_stack+91761,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+74286,int_stack+25056,int_stack+103461,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+25056,int_stack+74286,int_stack+56961,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+48156,int_stack+25056,int_stack+118311,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+25056,int_stack+11385,int_stack+10440,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27891,int_stack+12540,int_stack+11385,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31356,int_stack+27891,int_stack+25056,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37026,int_stack+13926,int_stack+12540,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+41184,int_stack+37026,int_stack+27891,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72456,int_stack+41184,int_stack+31356,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25056,int_stack+15564,int_stack+13926,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+81906,int_stack+25056,int_stack+37026,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+90222,int_stack+81906,int_stack+41184,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+29970,int_stack+90222,int_stack+72456,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+72456,int_stack+17475,int_stack+15564,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+101772,int_stack+72456,int_stack+25056,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+111600,int_stack+101772,int_stack+81906,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+111600,int_stack+90222,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+78189,int_stack+0,int_stack+29970,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+25056,int_stack+19680,int_stack+17475,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+31671,int_stack+25056,int_stack+72456,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+125460,int_stack+31671,int_stack+101772,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+141840,int_stack+125460,int_stack+111600,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+98034,int_stack+141840,int_stack+0,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+162630,int_stack+98034,int_stack+78189,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+22200,int_stack+19680,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7560,int_stack+0,int_stack+25056,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+72456,int_stack+7560,int_stack+31671,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+72456,int_stack+125460,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+189090,int_stack+0,int_stack+141840,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+189090,int_stack+98034,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+72456,int_stack+0,int_stack+162630,21);
 /*--- compute (gp|lk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+106476,int_stack+72456,int_stack+48156,1620);
 return int_stack+106476;}
