/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpmg(Libint_t*, prim_data*);

  /* Computes quartets of (gp|mg) integrals */

REALTYPE *hrr_order_gpmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[5][9] = int_stack + 5925;
 Libint->vrr_classes[5][10] = int_stack + 7080;
 Libint->vrr_classes[5][11] = int_stack + 8466;
 Libint->vrr_classes[5][12] = int_stack + 10104;
 Libint->vrr_classes[5][13] = int_stack + 12015;
 memset(int_stack,0,14220*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14220;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpmg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14220,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+16695,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19665,int_stack+16695,int_stack+14220,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+24615,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28125,int_stack+24615,int_stack+16695,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+34065,int_stack+28125,int_stack+19665,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14220,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+42315,int_stack+14220,int_stack+24615,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+14220,int_stack+42315,int_stack+28125,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+42315,int_stack+14220,int_stack+34065,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14220,int_stack+7080,int_stack+5925,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17685,int_stack+8466,int_stack+7080,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21843,int_stack+17685,int_stack+14220,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28773,int_stack+10104,int_stack+8466,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33687,int_stack+28773,int_stack+17685,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+54690,int_stack+33687,int_stack+21843,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14220,int_stack+12015,int_stack+10104,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+14220,int_stack+28773,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+9828,int_stack+0,int_stack+33687,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+23688,int_stack+9828,int_stack+54690,21);
 /*--- compute (gp|mg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+54690,int_stack+23688,int_stack+42315,825);
 return int_stack+54690;}
