/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpnk(Libint_t*, prim_data*);

  /* Computes quartets of (gp|nk) integrals */

REALTYPE *hrr_order_gpnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[5][10] = int_stack + 13800;
 Libint->vrr_classes[5][11] = int_stack + 15186;
 Libint->vrr_classes[5][12] = int_stack + 16824;
 Libint->vrr_classes[5][13] = int_stack + 18735;
 Libint->vrr_classes[5][14] = int_stack + 20940;
 Libint->vrr_classes[5][15] = int_stack + 23460;
 Libint->vrr_classes[5][16] = int_stack + 26316;
 Libint->vrr_classes[5][17] = int_stack + 29529;
 memset(int_stack,0,33120*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33120;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpnk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33120,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36090,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39600,int_stack+36090,int_stack+33120,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49635,int_stack+45540,int_stack+36090,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56655,int_stack+49635,int_stack+39600,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+33120,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+66555,int_stack+33120,int_stack+45540,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37845,int_stack+66555,int_stack+49635,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+74745,int_stack+37845,int_stack+56655,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+49545,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+54945,int_stack+49545,int_stack+33120,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+89595,int_stack+54945,int_stack+66555,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+103245,int_stack+89595,int_stack+37845,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+120795,int_stack+103245,int_stack+74745,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+33120,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+64395,int_stack+33120,int_stack+49545,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+141585,int_stack+64395,int_stack+54945,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+39240,int_stack+141585,int_stack+89595,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+75195,int_stack+39240,int_stack+103245,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+157335,int_stack+75195,int_stack+120795,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+99765,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+106650,int_stack+99765,int_stack+33120,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+118890,int_stack+106650,int_stack+64395,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+185055,int_stack+118890,int_stack+141585,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+99765,int_stack+185055,int_stack+39240,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+33120,int_stack+99765,int_stack+75195,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+65880,int_stack+33120,int_stack+157335,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33120,int_stack+15186,int_stack+13800,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37278,int_stack+16824,int_stack+15186,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42192,int_stack+37278,int_stack+33120,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+50508,int_stack+18735,int_stack+16824,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+101520,int_stack+50508,int_stack+37278,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+111348,int_stack+101520,int_stack+42192,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+33120,int_stack+20940,int_stack+18735,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+125208,int_stack+33120,int_stack+50508,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+39735,int_stack+125208,int_stack+101520,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+136674,int_stack+39735,int_stack+111348,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+101520,int_stack+23460,int_stack+20940,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+109080,int_stack+101520,int_stack+33120,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+157464,int_stack+109080,int_stack+125208,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+176574,int_stack+157464,int_stack+39735,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+33120,int_stack+176574,int_stack+136674,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+122310,int_stack+26316,int_stack+23460,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+130878,int_stack+122310,int_stack+101520,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+130878,int_stack+109080,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+201144,int_stack+0,int_stack+157464,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+229809,int_stack+201144,int_stack+176574,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+145998,int_stack+229809,int_stack+33120,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+33120,int_stack+29529,int_stack+26316,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+42759,int_stack+33120,int_stack+122310,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+101520,int_stack+42759,int_stack+130878,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+22050,int_stack+101520,int_stack+0,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+101520,int_stack+22050,int_stack+201144,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+101520,int_stack+229809,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+184806,int_stack+0,int_stack+145998,21);
 /*--- compute (gp|nk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+234702,int_stack+184806,int_stack+65880,2376);
 return int_stack+234702;}
