/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_h0li(Libint_t*, prim_data*);

  /* Computes quartets of (h0|li) integrals */

REALTYPE *hrr_order_h0li(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[5][13] = int_stack + 7035;
 Libint->vrr_classes[5][14] = int_stack + 9240;
 memset(int_stack,0,11760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_h0li(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11760,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14595,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18060,int_stack+14595,int_stack+11760,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23730,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27888,int_stack+23730,int_stack+14595,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+34818,int_stack+27888,int_stack+18060,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+11760,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+44268,int_stack+11760,int_stack+23730,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+52584,int_stack+44268,int_stack+27888,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+16674,int_stack+52584,int_stack+34818,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+30849,int_stack+7035,int_stack+5124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+64134,int_stack+30849,int_stack+11760,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+73962,int_stack+64134,int_stack+44268,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+87822,int_stack+73962,int_stack+52584,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+36582,int_stack+87822,int_stack+16674,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+11760,int_stack+9240,int_stack+7035,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+18375,int_stack+11760,int_stack+30849,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+18375,int_stack+64134,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+105147,int_stack+0,int_stack+73962,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+105147,int_stack+87822,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+56427,int_stack+0,int_stack+36582,21);
 return int_stack+56427;}
