/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdlg(Libint_t*, prim_data*);

  /* Computes quartets of (hd|lg) integrals */

REALTYPE *hrr_order_hdlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[6][8] = int_stack + 7035;
 Libint->vrr_classes[6][9] = int_stack + 8295;
 Libint->vrr_classes[6][10] = int_stack + 9835;
 Libint->vrr_classes[6][11] = int_stack + 11683;
 Libint->vrr_classes[6][12] = int_stack + 13867;
 Libint->vrr_classes[7][8] = int_stack + 16415;
 Libint->vrr_classes[7][9] = int_stack + 18035;
 Libint->vrr_classes[7][10] = int_stack + 20015;
 Libint->vrr_classes[7][11] = int_stack + 22391;
 Libint->vrr_classes[7][12] = int_stack + 25199;
 memset(int_stack,0,28475*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28475;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdlg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28475,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31310,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34775,int_stack+31310,int_stack+28475,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40445,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+44603,int_stack+40445,int_stack+31310,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51533,int_stack+44603,int_stack+34775,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28475,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+60983,int_stack+28475,int_stack+40445,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+28475,int_stack+60983,int_stack+44603,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+60983,int_stack+28475,int_stack+51533,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28475,int_stack+8295,int_stack+7035,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32255,int_stack+9835,int_stack+8295,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+36875,int_stack+32255,int_stack+28475,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44435,int_stack+11683,int_stack+9835,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49979,int_stack+44435,int_stack+32255,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+75158,int_stack+49979,int_stack+36875,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28475,int_stack+13867,int_stack+11683,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+28475,int_stack+44435,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+28475,int_stack+0,int_stack+49979,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+87758,int_stack+28475,int_stack+75158,28);
 /*--- compute (hp|lg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+106658,int_stack+87758,int_stack+60983,675);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28475,int_stack+18035,int_stack+16415,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33335,int_stack+20015,int_stack+18035,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+39275,int_stack+33335,int_stack+28475,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48995,int_stack+22391,int_stack+20015,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+56123,int_stack+48995,int_stack+33335,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+68003,int_stack+56123,int_stack+39275,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28475,int_stack+25199,int_stack+22391,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+28475,int_stack+48995,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+14256,int_stack+0,int_stack+56123,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+34056,int_stack+14256,int_stack+68003,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+149183,int_stack+34056,int_stack+87758,675);
 /*--- compute (hd|lg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+149183,int_stack+106658,675);
 return int_stack+0;}
