/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdnh(Libint_t*, prim_data*);

  /* Computes quartets of (hd|nh) integrals */

REALTYPE *hrr_order_hdnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[6][10] = int_stack + 12516;
 Libint->vrr_classes[6][11] = int_stack + 14364;
 Libint->vrr_classes[6][12] = int_stack + 16548;
 Libint->vrr_classes[6][13] = int_stack + 19096;
 Libint->vrr_classes[6][14] = int_stack + 22036;
 Libint->vrr_classes[6][15] = int_stack + 25396;
 Libint->vrr_classes[7][10] = int_stack + 29204;
 Libint->vrr_classes[7][11] = int_stack + 31580;
 Libint->vrr_classes[7][12] = int_stack + 34388;
 Libint->vrr_classes[7][13] = int_stack + 37664;
 Libint->vrr_classes[7][14] = int_stack + 41444;
 Libint->vrr_classes[7][15] = int_stack + 45764;
 memset(int_stack,0,50660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 50660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdnh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50660,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54818,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+59732,int_stack+54818,int_stack+50660,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68048,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+73781,int_stack+68048,int_stack+54818,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+83609,int_stack+73781,int_stack+59732,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+50660,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+97469,int_stack+50660,int_stack+68048,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+57275,int_stack+97469,int_stack+73781,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+108935,int_stack+57275,int_stack+83609,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+73655,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+81215,int_stack+73655,int_stack+50660,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+129725,int_stack+81215,int_stack+97469,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+73655,int_stack+129725,int_stack+57275,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+129725,int_stack+73655,int_stack+108935,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50660,int_stack+14364,int_stack+12516,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+56204,int_stack+16548,int_stack+14364,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62756,int_stack+56204,int_stack+50660,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73844,int_stack+19096,int_stack+16548,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+81488,int_stack+73844,int_stack+56204,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+94592,int_stack+81488,int_stack+62756,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+50660,int_stack+22036,int_stack+19096,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+113072,int_stack+50660,int_stack+73844,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+59480,int_stack+113072,int_stack+81488,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+158831,int_stack+59480,int_stack+94592,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+81320,int_stack+25396,int_stack+22036,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+91400,int_stack+81320,int_stack+50660,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+91400,int_stack+113072,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+81320,int_stack+0,int_stack+59480,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+186551,int_stack+81320,int_stack+158831,28);
 /*--- compute (hp|nh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+225359,int_stack+186551,int_stack+129725,1386);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+31580,int_stack+29204,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+34388,int_stack+31580,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15552,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+50660,int_stack+37664,int_stack+34388,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60488,int_stack+50660,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+77336,int_stack+60488,int_stack+15552,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+41444,int_stack+37664,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11340,int_stack+0,int_stack+50660,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+101096,int_stack+11340,int_stack+60488,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+129176,int_stack+101096,int_stack+77336,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+50660,int_stack+45764,int_stack+41444,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+63620,int_stack+50660,int_stack+0,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+312677,int_stack+63620,int_stack+11340,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+312677,int_stack+101096,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+42120,int_stack+0,int_stack+129176,36);
 /*--- compute (ip|nh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+312677,int_stack+42120,int_stack+186551,1386);
 /*--- compute (hd|nh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+312677,int_stack+225359,1386);
 return int_stack+0;}
