/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfii(Libint_t*, prim_data*);

  /* Computes quartets of (hf|ii) integrals */

REALTYPE *hrr_order_hfii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[5][8] = int_stack + 1344;
 Libint->vrr_classes[5][9] = int_stack + 2289;
 Libint->vrr_classes[5][10] = int_stack + 3444;
 Libint->vrr_classes[5][11] = int_stack + 4830;
 Libint->vrr_classes[5][12] = int_stack + 6468;
 Libint->vrr_classes[6][6] = int_stack + 8379;
 Libint->vrr_classes[6][7] = int_stack + 9163;
 Libint->vrr_classes[6][8] = int_stack + 10171;
 Libint->vrr_classes[6][9] = int_stack + 11431;
 Libint->vrr_classes[6][10] = int_stack + 12971;
 Libint->vrr_classes[6][11] = int_stack + 14819;
 Libint->vrr_classes[6][12] = int_stack + 17003;
 Libint->vrr_classes[7][6] = int_stack + 19551;
 Libint->vrr_classes[7][7] = int_stack + 20559;
 Libint->vrr_classes[7][8] = int_stack + 21855;
 Libint->vrr_classes[7][9] = int_stack + 23475;
 Libint->vrr_classes[7][10] = int_stack + 25455;
 Libint->vrr_classes[7][11] = int_stack + 27831;
 Libint->vrr_classes[7][12] = int_stack + 30639;
 Libint->vrr_classes[8][6] = int_stack + 33915;
 Libint->vrr_classes[8][7] = int_stack + 35175;
 Libint->vrr_classes[8][8] = int_stack + 36795;
 Libint->vrr_classes[8][9] = int_stack + 38820;
 Libint->vrr_classes[8][10] = int_stack + 41295;
 Libint->vrr_classes[8][11] = int_stack + 44265;
 Libint->vrr_classes[8][12] = int_stack + 47775;
 memset(int_stack,0,51870*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 51870;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfii(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+51870,int_stack+588,int_stack+0,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+53634,int_stack+1344,int_stack+588,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+55902,int_stack+53634,int_stack+51870,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59430,int_stack+2289,int_stack+1344,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+62265,int_stack+59430,int_stack+53634,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+66801,int_stack+62265,int_stack+55902,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51870,int_stack+3444,int_stack+2289,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+72681,int_stack+51870,int_stack+59430,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+78351,int_stack+72681,int_stack+62265,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+55335,int_stack+78351,int_stack+66801,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64155,int_stack+4830,int_stack+3444,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+85911,int_stack+64155,int_stack+51870,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+92841,int_stack+85911,int_stack+72681,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+102291,int_stack+92841,int_stack+78351,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+68313,int_stack+102291,int_stack+55335,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51870,int_stack+6468,int_stack+4830,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+51870,int_stack+64155,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51870,int_stack+0,int_stack+85911,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+113631,int_stack+51870,int_stack+92841,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+51870,int_stack+113631,int_stack+102291,21);
 /*--- compute (h0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+80661,int_stack+51870,int_stack+68313,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+51870,int_stack+9163,int_stack+8379,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+54222,int_stack+10171,int_stack+9163,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+57246,int_stack+54222,int_stack+51870,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+61950,int_stack+11431,int_stack+10171,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+65730,int_stack+61950,int_stack+54222,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+71778,int_stack+65730,int_stack+57246,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51870,int_stack+12971,int_stack+11431,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+51870,int_stack+61950,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+97125,int_stack+0,int_stack+65730,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+56490,int_stack+97125,int_stack+71778,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68250,int_stack+14819,int_stack+12971,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+107205,int_stack+68250,int_stack+51870,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+116445,int_stack+107205,int_stack+0,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+129045,int_stack+116445,int_stack+97125,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+144165,int_stack+129045,int_stack+56490,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97125,int_stack+17003,int_stack+14819,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+97125,int_stack+68250,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51870,int_stack+0,int_stack+107205,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+51870,int_stack+116445,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+51870,int_stack+0,int_stack+129045,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+97125,int_stack+51870,int_stack+144165,28);
 /*--- compute (hp|ii) ---*/
 hrr1_build_hp(Libint->AB,int_stack+119077,int_stack+97125,int_stack+80661,784);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+51870,int_stack+20559,int_stack+19551,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+54894,int_stack+21855,int_stack+20559,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+58782,int_stack+54894,int_stack+51870,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+64830,int_stack+23475,int_stack+21855,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+69690,int_stack+64830,int_stack+54894,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+77466,int_stack+69690,int_stack+58782,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+51870,int_stack+25455,int_stack+23475,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+51870,int_stack+64830,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+9720,int_stack+0,int_stack+69690,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+57810,int_stack+9720,int_stack+77466,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+72930,int_stack+27831,int_stack+25455,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80058,int_stack+72930,int_stack+51870,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+168469,int_stack+80058,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+184669,int_stack+168469,int_stack+9720,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+184669,int_stack+57810,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51870,int_stack+30639,int_stack+27831,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+204109,int_stack+51870,int_stack+72930,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51870,int_stack+204109,int_stack+80058,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+71670,int_stack+51870,int_stack+168469,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+204109,int_stack+71670,int_stack+184669,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+168469,int_stack+204109,int_stack+0,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+196693,int_stack+168469,int_stack+97125,784);
 /*--- compute (hd|ii) ---*/
 hrr1_build_hd(Libint->AB,int_stack+262549,int_stack+196693,int_stack+119077,784);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+35175,int_stack+33915,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+36795,int_stack+35175,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8640,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16200,int_stack+38820,int_stack+36795,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22275,int_stack+16200,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+51870,int_stack+22275,int_stack+8640,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+41295,int_stack+38820,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+64470,int_stack+0,int_stack+16200,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+76620,int_stack+64470,int_stack+22275,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+7425,int_stack+76620,int_stack+51870,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+44265,int_stack+41295,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+26325,int_stack+51870,int_stack+0,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+92820,int_stack+26325,int_stack+64470,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+113070,int_stack+92820,int_stack+76620,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+60780,int_stack+113070,int_stack+7425,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+47775,int_stack+44265,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+137370,int_stack+0,int_stack+51870,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+137370,int_stack+26325,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+137370,int_stack+0,int_stack+92820,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+137370,int_stack+113070,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+87240,int_stack+0,int_stack+60780,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+0,int_stack+87240,int_stack+168469,784);
 /*--- compute (id|ii) ---*/
 hrr1_build_id(Libint->AB,int_stack+361333,int_stack+0,int_stack+196693,784);
 /*--- compute (hf|ii) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+361333,int_stack+262549,784);
 return int_stack+0;}
