/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgml(Libint_t*, prim_data*);

  /* Computes quartets of (hg|ml) integrals */

REALTYPE *hrr_order_hgml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[6][9] = int_stack + 20475;
 Libint->vrr_classes[6][10] = int_stack + 22015;
 Libint->vrr_classes[6][11] = int_stack + 23863;
 Libint->vrr_classes[6][12] = int_stack + 26047;
 Libint->vrr_classes[6][13] = int_stack + 28595;
 Libint->vrr_classes[6][14] = int_stack + 31535;
 Libint->vrr_classes[6][15] = int_stack + 34895;
 Libint->vrr_classes[6][16] = int_stack + 38703;
 Libint->vrr_classes[6][17] = int_stack + 42987;
 Libint->vrr_classes[7][9] = int_stack + 47775;
 Libint->vrr_classes[7][10] = int_stack + 49755;
 Libint->vrr_classes[7][11] = int_stack + 52131;
 Libint->vrr_classes[7][12] = int_stack + 54939;
 Libint->vrr_classes[7][13] = int_stack + 58215;
 Libint->vrr_classes[7][14] = int_stack + 61995;
 Libint->vrr_classes[7][15] = int_stack + 66315;
 Libint->vrr_classes[7][16] = int_stack + 71211;
 Libint->vrr_classes[7][17] = int_stack + 76719;
 Libint->vrr_classes[8][9] = int_stack + 82875;
 Libint->vrr_classes[8][10] = int_stack + 85350;
 Libint->vrr_classes[8][11] = int_stack + 88320;
 Libint->vrr_classes[8][12] = int_stack + 91830;
 Libint->vrr_classes[8][13] = int_stack + 95925;
 Libint->vrr_classes[8][14] = int_stack + 100650;
 Libint->vrr_classes[8][15] = int_stack + 106050;
 Libint->vrr_classes[8][16] = int_stack + 112170;
 Libint->vrr_classes[8][17] = int_stack + 119055;
 Libint->vrr_classes[9][9] = int_stack + 126750;
 Libint->vrr_classes[9][10] = int_stack + 129775;
 Libint->vrr_classes[9][11] = int_stack + 133405;
 Libint->vrr_classes[9][12] = int_stack + 137695;
 Libint->vrr_classes[9][13] = int_stack + 142700;
 Libint->vrr_classes[9][14] = int_stack + 148475;
 Libint->vrr_classes[9][15] = int_stack + 155075;
 Libint->vrr_classes[9][16] = int_stack + 162555;
 Libint->vrr_classes[9][17] = int_stack + 170970;
 memset(int_stack,0,180375*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 180375;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgml(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+180375,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183840,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+187998,int_stack+183840,int_stack+180375,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+194928,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+199842,int_stack+194928,int_stack+183840,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+208158,int_stack+199842,int_stack+187998,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+180375,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+219708,int_stack+180375,int_stack+194928,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+229536,int_stack+219708,int_stack+199842,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+186108,int_stack+229536,int_stack+208158,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+203433,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+243396,int_stack+203433,int_stack+180375,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+254862,int_stack+243396,int_stack+219708,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+271242,int_stack+254862,int_stack+229536,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+210048,int_stack+271242,int_stack+186108,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+180375,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+187935,int_stack+180375,int_stack+203433,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+292032,int_stack+187935,int_stack+243396,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+311142,int_stack+292032,int_stack+254862,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+234303,int_stack+311142,int_stack+271242,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+335712,int_stack+234303,int_stack+210048,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+201165,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+209733,int_stack+201165,int_stack+180375,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+263409,int_stack+209733,int_stack+187935,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368052,int_stack+263409,int_stack+292032,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+396717,int_stack+368052,int_stack+311142,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+285459,int_stack+396717,int_stack+234303,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+431115,int_stack+285459,int_stack+335712,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+180375,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+224853,int_stack+180375,int_stack+201165,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+180375,int_stack+224853,int_stack+209733,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+205575,int_stack+180375,int_stack+263409,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+238650,int_stack+205575,int_stack+368052,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+180375,int_stack+238650,int_stack+396717,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+226239,int_stack+180375,int_stack+285459,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+276135,int_stack+226239,int_stack+431115,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+180375,int_stack+22015,int_stack+20475,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+184995,int_stack+23863,int_stack+22015,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+190539,int_stack+184995,int_stack+180375,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+199779,int_stack+26047,int_stack+23863,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+206331,int_stack+199779,int_stack+184995,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+217419,int_stack+206331,int_stack+190539,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+180375,int_stack+28595,int_stack+26047,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+232819,int_stack+180375,int_stack+199779,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245923,int_stack+232819,int_stack+206331,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+188019,int_stack+245923,int_stack+217419,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+211119,int_stack+31535,int_stack+28595,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+328110,int_stack+211119,int_stack+180375,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+343398,int_stack+328110,int_stack+232819,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+365238,int_stack+343398,int_stack+245923,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+219939,int_stack+365238,int_stack+188019,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+180375,int_stack+34895,int_stack+31535,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+190455,int_stack+180375,int_stack+211119,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+392958,int_stack+190455,int_stack+328110,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+418438,int_stack+392958,int_stack+343398,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+451198,int_stack+418438,int_stack+365238,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+328110,int_stack+451198,int_stack+219939,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+371230,int_stack+38703,int_stack+34895,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+208095,int_stack+371230,int_stack+180375,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+228255,int_stack+208095,int_stack+190455,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+228255,int_stack+392958,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+490006,int_stack+0,int_stack+418438,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+382654,int_stack+490006,int_stack+451198,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+434398,int_stack+382654,int_stack+328110,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+328110,int_stack+42987,int_stack+38703,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+340962,int_stack+328110,int_stack+371230,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+535870,int_stack+340962,int_stack+208095,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+328110,int_stack+535870,int_stack+228255,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+180375,int_stack+328110,int_stack+0,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+535870,int_stack+180375,int_stack+490006,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+180375,int_stack+535870,int_stack+382654,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+328110,int_stack+180375,int_stack+434398,28);
 /*--- compute (hp|ml) ---*/
 hrr1_build_hp(Libint->AB,int_stack+397410,int_stack+328110,int_stack+276135,2475);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+180375,int_stack+49755,int_stack+47775,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+186315,int_stack+52131,int_stack+49755,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+193443,int_stack+186315,int_stack+180375,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+205323,int_stack+54939,int_stack+52131,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+213747,int_stack+205323,int_stack+186315,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+228003,int_stack+213747,int_stack+193443,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+180375,int_stack+58215,int_stack+54939,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+247803,int_stack+180375,int_stack+205323,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+264651,int_stack+247803,int_stack+213747,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+190203,int_stack+264651,int_stack+228003,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+219903,int_stack+61995,int_stack+58215,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+288411,int_stack+219903,int_stack+180375,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+288411,int_stack+247803,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+553335,int_stack+0,int_stack+264651,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+231243,int_stack+553335,int_stack+190203,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+180375,int_stack+66315,int_stack+61995,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+193335,int_stack+180375,int_stack+219903,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+28080,int_stack+193335,int_stack+288411,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+272823,int_stack+28080,int_stack+0,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+588975,int_stack+272823,int_stack+553335,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+638871,int_stack+588975,int_stack+231243,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+553335,int_stack+71211,int_stack+66315,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+553335,int_stack+180375,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+216015,int_stack+0,int_stack+193335,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+694311,int_stack+216015,int_stack+28080,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+743451,int_stack+694311,int_stack+272823,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+253815,int_stack+743451,int_stack+588975,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+802419,int_stack+253815,int_stack+638871,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+180375,int_stack+76719,int_stack+71211,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+568023,int_stack+180375,int_stack+553335,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+597399,int_stack+568023,int_stack+0,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+597399,int_stack+216015,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+553335,int_stack+0,int_stack+694311,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+553335,int_stack+743451,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+553335,int_stack+0,int_stack+253815,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+638871,int_stack+553335,int_stack+802419,36);
 /*--- compute (ip|ml) ---*/
 hrr1_build_ip(Libint->AB,int_stack+727971,int_stack+638871,int_stack+328110,2475);
 /*--- compute (hd|ml) ---*/
 hrr1_build_hd(Libint->AB,int_stack+935871,int_stack+727971,int_stack+397410,2475);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+85350,int_stack+82875,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+88320,int_stack+85350,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31185,int_stack+91830,int_stack+88320,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41715,int_stack+31185,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59535,int_stack+41715,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+95925,int_stack+91830,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+180375,int_stack+0,int_stack+31185,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+201435,int_stack+180375,int_stack+41715,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12285,int_stack+201435,int_stack+59535,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+49410,int_stack+100650,int_stack+95925,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+63585,int_stack+49410,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+231135,int_stack+63585,int_stack+180375,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+266235,int_stack+231135,int_stack+201435,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+310785,int_stack+266235,int_stack+12285,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+180375,int_stack+106050,int_stack+100650,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+196575,int_stack+180375,int_stack+49410,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+196575,int_stack+63585,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+40950,int_stack+0,int_stack+231135,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+362760,int_stack+40950,int_stack+266235,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+224925,int_stack+362760,int_stack+310785,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+294225,int_stack+112170,int_stack+106050,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+312585,int_stack+294225,int_stack+180375,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+425130,int_stack+312585,int_stack+196575,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+472380,int_stack+425130,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+533805,int_stack+472380,int_stack+40950,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+533805,int_stack+362760,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1247721,int_stack+0,int_stack+224925,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+83160,int_stack+119055,int_stack+112170,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+180375,int_stack+83160,int_stack+294225,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+217095,int_stack+180375,int_stack+312585,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+271095,int_stack+217095,int_stack+425130,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+180375,int_stack+271095,int_stack+472380,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+266370,int_stack+180375,int_stack+533805,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+364650,int_stack+266370,int_stack+0,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+364650,int_stack+1247721,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+180375,int_stack+0,int_stack+638871,2475);
 /*--- compute (id|ml) ---*/
 hrr1_build_id(Libint->AB,int_stack+1247721,int_stack+180375,int_stack+727971,2475);
 /*--- compute (hf|ml) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1663521,int_stack+1247721,int_stack+935871,2475);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+111375,int_stack+129775,int_stack+126750,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+447675,int_stack+133405,int_stack+129775,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+458565,int_stack+447675,int_stack+111375,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+111375,int_stack+137695,int_stack+133405,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+476715,int_stack+111375,int_stack+447675,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+498495,int_stack+476715,int_stack+458565,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+447675,int_stack+142700,int_stack+137695,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+528745,int_stack+447675,int_stack+111375,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+554485,int_stack+528745,int_stack+476715,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+590785,int_stack+554485,int_stack+498495,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111375,int_stack+148475,int_stack+142700,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+462690,int_stack+111375,int_stack+447675,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+636160,int_stack+462690,int_stack+528745,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+492720,int_stack+636160,int_stack+554485,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+679060,int_stack+492720,int_stack+590785,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+547170,int_stack+155075,int_stack+148475,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+566970,int_stack+547170,int_stack+111375,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+742585,int_stack+566970,int_stack+462690,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+792635,int_stack+742585,int_stack+636160,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+601620,int_stack+792635,int_stack+492720,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+447675,int_stack+601620,int_stack+679060,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+111375,int_stack+162555,int_stack+155075,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+677850,int_stack+111375,int_stack+547170,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+856985,int_stack+677850,int_stack+566970,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+914735,int_stack+856985,int_stack+742585,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+989810,int_stack+914735,int_stack+792635,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+717450,int_stack+989810,int_stack+601620,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+532375,int_stack+717450,int_stack+447675,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+447675,int_stack+170970,int_stack+162555,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+472920,int_stack+447675,int_stack+111375,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+111375,int_stack+472920,int_stack+677850,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1079900,int_stack+111375,int_stack+856985,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2183271,int_stack+1079900,int_stack+914735,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1079900,int_stack+2183271,int_stack+989810,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+819090,int_stack+1079900,int_stack+717450,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+641275,int_stack+819090,int_stack+532375,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+777400,int_stack+641275,int_stack+0,2475);
 /*--- compute (kd|ml) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2183271,int_stack+777400,int_stack+180375,2475);
 /*--- compute (if|ml) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+2183271,int_stack+1247721,2475);
 /*--- compute (hg|ml) ---*/
 hrr1_build_hg(Libint->AB,int_stack+693000,int_stack+0,int_stack+1663521,2475);
 return int_stack+693000;}
