/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgmp(Libint_t*, prim_data*);

  /* Computes quartets of (hg|mp) integrals */

REALTYPE *hrr_order_hgmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[6][9] = int_stack + 2541;
 Libint->vrr_classes[6][10] = int_stack + 4081;
 Libint->vrr_classes[7][9] = int_stack + 5929;
 Libint->vrr_classes[7][10] = int_stack + 7909;
 Libint->vrr_classes[8][9] = int_stack + 10285;
 Libint->vrr_classes[8][10] = int_stack + 12760;
 Libint->vrr_classes[9][9] = int_stack + 15730;
 Libint->vrr_classes[9][10] = int_stack + 18755;
 memset(int_stack,0,22385*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 22385;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgmp(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22385,int_stack+1155,int_stack+0,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25850,int_stack+4081,int_stack+2541,28);
 /*--- compute (hp|mp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+30470,int_stack+25850,int_stack+22385,165);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40865,int_stack+7909,int_stack+5929,36);
 /*--- compute (ip|mp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+46805,int_stack+40865,int_stack+25850,165);
 /*--- compute (hd|mp) ---*/
 hrr1_build_hd(Libint->AB,int_stack+60665,int_stack+46805,int_stack+30470,165);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22385,int_stack+12760,int_stack+10285,45);
 /*--- compute (kp|mp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+81455,int_stack+22385,int_stack+40865,165);
 /*--- compute (id|mp) ---*/
 hrr1_build_id(Libint->AB,int_stack+99275,int_stack+81455,int_stack+46805,165);
 /*--- compute (hf|mp) ---*/
 hrr1_build_hf(Libint->AB,int_stack+126995,int_stack+99275,int_stack+60665,165);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29810,int_stack+18755,int_stack+15730,55);
 /*--- compute (lp|mp) ---*/
 hrr1_build_lp(Libint->AB,int_stack+38885,int_stack+29810,int_stack+22385,165);
 /*--- compute (kd|mp) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+38885,int_stack+81455,165);
 /*--- compute (if|mp) ---*/
 hrr1_build_if(Libint->AB,int_stack+35640,int_stack+0,int_stack+99275,165);
 /*--- compute (hg|mp) ---*/
 hrr1_build_hg(Libint->AB,int_stack+161645,int_stack+35640,int_stack+126995,165);
 return int_stack+161645;}
