/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpmf(Libint_t*, prim_data*);

  /* Computes quartets of (hp|mf) integrals */

REALTYPE *hrr_order_hpmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[6][9] = int_stack + 6090;
 Libint->vrr_classes[6][10] = int_stack + 7630;
 Libint->vrr_classes[6][11] = int_stack + 9478;
 Libint->vrr_classes[6][12] = int_stack + 11662;
 memset(int_stack,0,14210*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14210;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpmf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14210,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17675,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21833,int_stack+17675,int_stack+14210,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+28763,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33677,int_stack+28763,int_stack+17675,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+41993,int_stack+33677,int_stack+21833,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14210,int_stack+7630,int_stack+6090,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+18830,int_stack+9478,int_stack+7630,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24374,int_stack+18830,int_stack+14210,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33614,int_stack+11662,int_stack+9478,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+33614,int_stack+18830,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+53543,int_stack+0,int_stack+24374,28);
 /*--- compute (hp|mf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+0,int_stack+53543,int_stack+41993,550);
 return int_stack+0;}
