/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpmk(Libint_t*, prim_data*);

  /* Computes quartets of (hp|mk) integrals */

REALTYPE *hrr_order_hpmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[6][9] = int_stack + 16884;
 Libint->vrr_classes[6][10] = int_stack + 18424;
 Libint->vrr_classes[6][11] = int_stack + 20272;
 Libint->vrr_classes[6][12] = int_stack + 22456;
 Libint->vrr_classes[6][13] = int_stack + 25004;
 Libint->vrr_classes[6][14] = int_stack + 27944;
 Libint->vrr_classes[6][15] = int_stack + 31304;
 Libint->vrr_classes[6][16] = int_stack + 35112;
 memset(int_stack,0,39396*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 39396;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpmk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39396,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+42861,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47019,int_stack+42861,int_stack+39396,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+53949,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58863,int_stack+53949,int_stack+42861,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+67179,int_stack+58863,int_stack+47019,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+39396,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+78729,int_stack+39396,int_stack+53949,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+88557,int_stack+78729,int_stack+58863,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+45129,int_stack+88557,int_stack+67179,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+62454,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+102417,int_stack+62454,int_stack+39396,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+113883,int_stack+102417,int_stack+78729,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+130263,int_stack+113883,int_stack+88557,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+69069,int_stack+130263,int_stack+45129,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+39396,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+46956,int_stack+39396,int_stack+62454,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+151053,int_stack+46956,int_stack+102417,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+170163,int_stack+151053,int_stack+113883,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+93324,int_stack+170163,int_stack+130263,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+194733,int_stack+93324,int_stack+69069,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+60186,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+68754,int_stack+60186,int_stack+39396,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+122430,int_stack+68754,int_stack+46956,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+39396,int_stack+122430,int_stack+151053,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+122430,int_stack+39396,int_stack+170163,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+39396,int_stack+122430,int_stack+93324,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+78204,int_stack+39396,int_stack+194733,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39396,int_stack+18424,int_stack+16884,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44016,int_stack+20272,int_stack+18424,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49560,int_stack+44016,int_stack+39396,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+58800,int_stack+22456,int_stack+20272,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+65352,int_stack+58800,int_stack+44016,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+119784,int_stack+65352,int_stack+49560,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+39396,int_stack+25004,int_stack+22456,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+135184,int_stack+39396,int_stack+58800,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+148288,int_stack+135184,int_stack+65352,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+47040,int_stack+148288,int_stack+119784,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+119784,int_stack+27944,int_stack+25004,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+166768,int_stack+119784,int_stack+39396,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+182056,int_stack+166768,int_stack+135184,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+182056,int_stack+148288,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+128604,int_stack+0,int_stack+47040,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+39396,int_stack+31304,int_stack+27944,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49476,int_stack+39396,int_stack+119784,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+203896,int_stack+49476,int_stack+166768,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+229376,int_stack+203896,int_stack+182056,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+160944,int_stack+229376,int_stack+0,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+262136,int_stack+160944,int_stack+128604,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+35112,int_stack+31304,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+11424,int_stack+0,int_stack+39396,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+119784,int_stack+11424,int_stack+49476,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+119784,int_stack+203896,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+305256,int_stack+0,int_stack+229376,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+305256,int_stack+160944,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+119784,int_stack+0,int_stack+262136,28);
 /*--- compute (hp|mk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+175224,int_stack+119784,int_stack+78204,1980);
 return int_stack+175224;}
