/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpmm(Libint_t*, prim_data*);

  /* Computes quartets of (hp|mm) integrals */

REALTYPE *hrr_order_hpmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[5][18] = int_stack + 20475;
 Libint->vrr_classes[6][9] = int_stack + 24465;
 Libint->vrr_classes[6][10] = int_stack + 26005;
 Libint->vrr_classes[6][11] = int_stack + 27853;
 Libint->vrr_classes[6][12] = int_stack + 30037;
 Libint->vrr_classes[6][13] = int_stack + 32585;
 Libint->vrr_classes[6][14] = int_stack + 35525;
 Libint->vrr_classes[6][15] = int_stack + 38885;
 Libint->vrr_classes[6][16] = int_stack + 42693;
 Libint->vrr_classes[6][17] = int_stack + 46977;
 Libint->vrr_classes[6][18] = int_stack + 51765;
 memset(int_stack,0,57085*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 57085;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpmm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57085,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60550,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64708,int_stack+60550,int_stack+57085,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+71638,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+76552,int_stack+71638,int_stack+60550,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84868,int_stack+76552,int_stack+64708,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57085,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+96418,int_stack+57085,int_stack+71638,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+106246,int_stack+96418,int_stack+76552,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+62818,int_stack+106246,int_stack+84868,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+80143,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+120106,int_stack+80143,int_stack+57085,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+131572,int_stack+120106,int_stack+96418,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+147952,int_stack+131572,int_stack+106246,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+86758,int_stack+147952,int_stack+62818,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+57085,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+64645,int_stack+57085,int_stack+80143,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+168742,int_stack+64645,int_stack+120106,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+187852,int_stack+168742,int_stack+131572,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+111013,int_stack+187852,int_stack+147952,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+212422,int_stack+111013,int_stack+86758,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+77875,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+86443,int_stack+77875,int_stack+57085,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140119,int_stack+86443,int_stack+64645,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+244762,int_stack+140119,int_stack+168742,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+273427,int_stack+244762,int_stack+187852,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+162169,int_stack+273427,int_stack+111013,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+307825,int_stack+162169,int_stack+212422,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+57085,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+101563,int_stack+57085,int_stack+77875,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+200977,int_stack+101563,int_stack+86443,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+66724,int_stack+200977,int_stack+140119,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+118699,int_stack+66724,int_stack+244762,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+226177,int_stack+118699,int_stack+273427,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+349405,int_stack+226177,int_stack+162169,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+399301,int_stack+349405,int_stack+307825,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+158830,int_stack+20475,int_stack+16884,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+169603,int_stack+158830,int_stack+57085,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+272041,int_stack+169603,int_stack+101563,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+158830,int_stack+272041,int_stack+200977,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+272041,int_stack+158830,int_stack+66724,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+158830,int_stack+272041,int_stack+118699,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+272041,int_stack+158830,int_stack+226177,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+57085,int_stack+272041,int_stack+349405,21);
 /*--- compute (h0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+119455,int_stack+57085,int_stack+399301,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+57085,int_stack+26005,int_stack+24465,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61705,int_stack+27853,int_stack+26005,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67249,int_stack+61705,int_stack+57085,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+76489,int_stack+30037,int_stack+27853,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+83041,int_stack+76489,int_stack+61705,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+94129,int_stack+83041,int_stack+67249,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57085,int_stack+32585,int_stack+30037,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+182980,int_stack+57085,int_stack+76489,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+196084,int_stack+182980,int_stack+83041,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+64729,int_stack+196084,int_stack+94129,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+87829,int_stack+35525,int_stack+32585,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+96649,int_stack+87829,int_stack+57085,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+214564,int_stack+96649,int_stack+182980,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+236404,int_stack+214564,int_stack+196084,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+264124,int_stack+236404,int_stack+64729,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+182980,int_stack+38885,int_stack+35525,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+193060,int_stack+182980,int_stack+87829,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57085,int_stack+193060,int_stack+96649,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+82565,int_stack+57085,int_stack+214564,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+296464,int_stack+82565,int_stack+236404,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+210700,int_stack+296464,int_stack+264124,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+253820,int_stack+42693,int_stack+38885,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+265244,int_stack+253820,int_stack+182980,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+335272,int_stack+265244,int_stack+193060,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+364672,int_stack+335272,int_stack+57085,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+402892,int_stack+364672,int_stack+82565,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+57085,int_stack+402892,int_stack+296464,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+448756,int_stack+57085,int_stack+210700,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+182980,int_stack+46977,int_stack+42693,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+195832,int_stack+182980,int_stack+253820,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+218680,int_stack+195832,int_stack+265244,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+252280,int_stack+218680,int_stack+335272,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+296380,int_stack+252280,int_stack+364672,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+504196,int_stack+296380,int_stack+402892,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+349888,int_stack+504196,int_stack+57085,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+565348,int_stack+349888,int_stack+448756,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+57085,int_stack+51765,int_stack+46977,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+71449,int_stack+57085,int_stack+182980,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+416416,int_stack+71449,int_stack+195832,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+416416,int_stack+218680,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+416416,int_stack+0,int_stack+252280,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+416416,int_stack+296380,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+416416,int_stack+0,int_stack+504196,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+416416,int_stack+349888,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+182980,int_stack+0,int_stack+565348,28);
 /*--- compute (hp|mm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+267680,int_stack+182980,int_stack+119455,3025);
 return int_stack+267680;}
