/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpnd(Libint_t*, prim_data*);

  /* Computes quartets of (hp|nd) integrals */

REALTYPE *hrr_order_hpnd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[6][10] = int_stack + 4935;
 Libint->vrr_classes[6][11] = int_stack + 6783;
 Libint->vrr_classes[6][12] = int_stack + 8967;
 memset(int_stack,0,11515*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11515;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpnd(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11515,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15673,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20587,int_stack+15673,int_stack+11515,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11515,int_stack+6783,int_stack+4935,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+8967,int_stack+6783,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28903,int_stack+0,int_stack+11515,28);
 /*--- compute (hp|nd) ---*/
 hrr1_build_hp(Libint->AB,int_stack+39991,int_stack+28903,int_stack+20587,396);
 return int_stack+39991;}
