/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpnk(Libint_t*, prim_data*);

  /* Computes quartets of (hp|nk) integrals */

REALTYPE *hrr_order_hpnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[6][10] = int_stack + 19320;
 Libint->vrr_classes[6][11] = int_stack + 21168;
 Libint->vrr_classes[6][12] = int_stack + 23352;
 Libint->vrr_classes[6][13] = int_stack + 25900;
 Libint->vrr_classes[6][14] = int_stack + 28840;
 Libint->vrr_classes[6][15] = int_stack + 32200;
 Libint->vrr_classes[6][16] = int_stack + 36008;
 Libint->vrr_classes[6][17] = int_stack + 40292;
 memset(int_stack,0,45080*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 45080;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpnk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45080,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+49238,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54152,int_stack+49238,int_stack+45080,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62468,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+68201,int_stack+62468,int_stack+49238,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+78029,int_stack+68201,int_stack+54152,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+45080,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+91889,int_stack+45080,int_stack+62468,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+51695,int_stack+91889,int_stack+68201,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+103355,int_stack+51695,int_stack+78029,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+68075,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+75635,int_stack+68075,int_stack+45080,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+124145,int_stack+75635,int_stack+91889,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+143255,int_stack+124145,int_stack+51695,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+167825,int_stack+143255,int_stack+103355,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+45080,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+88865,int_stack+45080,int_stack+68075,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+196931,int_stack+88865,int_stack+75635,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+53648,int_stack+196931,int_stack+124145,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+103985,int_stack+53648,int_stack+143255,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+218981,int_stack+103985,int_stack+167825,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+138383,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+148022,int_stack+138383,int_stack+45080,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+165158,int_stack+148022,int_stack+88865,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+257789,int_stack+165158,int_stack+196931,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+138383,int_stack+257789,int_stack+53648,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+45080,int_stack+138383,int_stack+103985,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+90944,int_stack+45080,int_stack+218981,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45080,int_stack+21168,int_stack+19320,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50624,int_stack+23352,int_stack+21168,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+57176,int_stack+50624,int_stack+45080,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68264,int_stack+25900,int_stack+23352,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+75908,int_stack+68264,int_stack+50624,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+140840,int_stack+75908,int_stack+57176,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+45080,int_stack+28840,int_stack+25900,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+159320,int_stack+45080,int_stack+68264,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+53900,int_stack+159320,int_stack+75908,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+174608,int_stack+53900,int_stack+140840,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+140840,int_stack+32200,int_stack+28840,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+202328,int_stack+140840,int_stack+45080,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+219968,int_stack+202328,int_stack+159320,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+245448,int_stack+219968,int_stack+53900,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+45080,int_stack+245448,int_stack+174608,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+150920,int_stack+36008,int_stack+32200,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+162344,int_stack+150920,int_stack+140840,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+162344,int_stack+202328,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+278208,int_stack+0,int_stack+219968,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+182504,int_stack+278208,int_stack+245448,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+316428,int_stack+182504,int_stack+45080,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+45080,int_stack+40292,int_stack+36008,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+57932,int_stack+45080,int_stack+150920,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+228368,int_stack+57932,int_stack+162344,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+29400,int_stack+228368,int_stack+0,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+368172,int_stack+29400,int_stack+278208,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+368172,int_stack+182504,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+140840,int_stack+0,int_stack+316428,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+207368,int_stack+140840,int_stack+90944,2376);
 return int_stack+207368;}
