/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idhh(Libint_t*, prim_data*);

  /* Computes quartets of (id|hh) integrals */

REALTYPE *hrr_order_idhh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][5] = int_stack + 0;
 Libint->vrr_classes[6][6] = int_stack + 588;
 Libint->vrr_classes[6][7] = int_stack + 1372;
 Libint->vrr_classes[6][8] = int_stack + 2380;
 Libint->vrr_classes[6][9] = int_stack + 3640;
 Libint->vrr_classes[6][10] = int_stack + 5180;
 Libint->vrr_classes[7][5] = int_stack + 7028;
 Libint->vrr_classes[7][6] = int_stack + 7784;
 Libint->vrr_classes[7][7] = int_stack + 8792;
 Libint->vrr_classes[7][8] = int_stack + 10088;
 Libint->vrr_classes[7][9] = int_stack + 11708;
 Libint->vrr_classes[7][10] = int_stack + 13688;
 Libint->vrr_classes[8][5] = int_stack + 16064;
 Libint->vrr_classes[8][6] = int_stack + 17009;
 Libint->vrr_classes[8][7] = int_stack + 18269;
 Libint->vrr_classes[8][8] = int_stack + 19889;
 Libint->vrr_classes[8][9] = int_stack + 21914;
 Libint->vrr_classes[8][10] = int_stack + 24389;
 memset(int_stack,0,27359*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27359;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idhh(Libint, Data);
   Data++;
 }
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+27359,int_stack+588,int_stack+0,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+29123,int_stack+1372,int_stack+588,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+31475,int_stack+29123,int_stack+27359,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35003,int_stack+2380,int_stack+1372,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+38027,int_stack+35003,int_stack+29123,28);
 /*--- compute (i0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+42731,int_stack+38027,int_stack+31475,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27359,int_stack+3640,int_stack+2380,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+48611,int_stack+27359,int_stack+35003,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+54659,int_stack+48611,int_stack+38027,28);
 /*--- compute (i0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+31139,int_stack+54659,int_stack+42731,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39959,int_stack+5180,int_stack+3640,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+62499,int_stack+39959,int_stack+27359,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+70059,int_stack+62499,int_stack+48611,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+39959,int_stack+70059,int_stack+54659,28);
 /*--- compute (i0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+51719,int_stack+39959,int_stack+31139,28);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+27359,int_stack+7784,int_stack+7028,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+29627,int_stack+8792,int_stack+7784,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+32651,int_stack+29627,int_stack+27359,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37187,int_stack+10088,int_stack+8792,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+41075,int_stack+37187,int_stack+29627,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+64067,int_stack+41075,int_stack+32651,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27359,int_stack+11708,int_stack+10088,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+71627,int_stack+27359,int_stack+37187,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+71627,int_stack+41075,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+32219,int_stack+0,int_stack+64067,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64067,int_stack+13688,int_stack+11708,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+79403,int_stack+64067,int_stack+27359,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+89123,int_stack+79403,int_stack+71627,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+64067,int_stack+89123,int_stack+0,36);
 /*--- compute (k0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+64067,int_stack+32219,36);
 /*--- compute (ip|hh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+64067,int_stack+0,int_stack+51719,441);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+27359,int_stack+17009,int_stack+16064,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+30194,int_stack+18269,int_stack+17009,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+33974,int_stack+30194,int_stack+27359,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+39644,int_stack+19889,int_stack+18269,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+44504,int_stack+39644,int_stack+30194,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+52064,int_stack+44504,int_stack+33974,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+27359,int_stack+21914,int_stack+19889,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+101111,int_stack+27359,int_stack+39644,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+110831,int_stack+101111,int_stack+44504,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+33434,int_stack+110831,int_stack+52064,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47609,int_stack+24389,int_stack+21914,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+123431,int_stack+47609,int_stack+27359,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+47609,int_stack+123431,int_stack+101111,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+123431,int_stack+47609,int_stack+110831,45);
 /*--- compute (l0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+101111,int_stack+123431,int_stack+33434,45);
 /*--- compute (kp|hh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+15876,int_stack+101111,int_stack+0,441);
 /*--- compute (id|hh) ---*/
 hrr1_build_id(Libint->AB,int_stack+101111,int_stack+15876,int_stack+64067,441);
 return int_stack+101111;}
