/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idld(Libint_t*, prim_data*);

  /* Computes quartets of (id|ld) integrals */

REALTYPE *hrr_order_idld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[7][8] = int_stack + 4648;
 Libint->vrr_classes[7][9] = int_stack + 6268;
 Libint->vrr_classes[7][10] = int_stack + 8248;
 Libint->vrr_classes[8][8] = int_stack + 10624;
 Libint->vrr_classes[8][9] = int_stack + 12649;
 Libint->vrr_classes[8][10] = int_stack + 15124;
 memset(int_stack,0,18094*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18094;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idld(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18094,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21874,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+26494,int_stack+21874,int_stack+18094,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18094,int_stack+6268,int_stack+4648,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+8248,int_stack+6268,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34054,int_stack+0,int_stack+18094,36);
 /*--- compute (ip|ld) ---*/
 hrr1_build_ip(Libint->AB,int_stack+43774,int_stack+34054,int_stack+26494,270);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18094,int_stack+12649,int_stack+10624,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+24169,int_stack+15124,int_stack+12649,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+24169,int_stack+18094,45);
 /*--- compute (kp|ld) ---*/
 hrr1_build_kp(Libint->AB,int_stack+66454,int_stack+0,int_stack+34054,270);
 /*--- compute (id|ld) ---*/
 hrr1_build_id(Libint->AB,int_stack+95614,int_stack+66454,int_stack+43774,270);
 return int_stack+95614;}
