/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idll(Libint_t*, prim_data*);

  /* Computes quartets of (id|ll) integrals */

REALTYPE *hrr_order_idll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[6][16] = int_stack + 19488;
 Libint->vrr_classes[7][8] = int_stack + 23772;
 Libint->vrr_classes[7][9] = int_stack + 25392;
 Libint->vrr_classes[7][10] = int_stack + 27372;
 Libint->vrr_classes[7][11] = int_stack + 29748;
 Libint->vrr_classes[7][12] = int_stack + 32556;
 Libint->vrr_classes[7][13] = int_stack + 35832;
 Libint->vrr_classes[7][14] = int_stack + 39612;
 Libint->vrr_classes[7][15] = int_stack + 43932;
 Libint->vrr_classes[7][16] = int_stack + 48828;
 Libint->vrr_classes[8][8] = int_stack + 54336;
 Libint->vrr_classes[8][9] = int_stack + 56361;
 Libint->vrr_classes[8][10] = int_stack + 58836;
 Libint->vrr_classes[8][11] = int_stack + 61806;
 Libint->vrr_classes[8][12] = int_stack + 65316;
 Libint->vrr_classes[8][13] = int_stack + 69411;
 Libint->vrr_classes[8][14] = int_stack + 74136;
 Libint->vrr_classes[8][15] = int_stack + 79536;
 Libint->vrr_classes[8][16] = int_stack + 85656;
 memset(int_stack,0,92541*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 92541;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idll(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+92541,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+96321,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+100941,int_stack+96321,int_stack+92541,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+108501,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114045,int_stack+108501,int_stack+96321,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+123285,int_stack+114045,int_stack+100941,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92541,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+135885,int_stack+92541,int_stack+108501,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+146973,int_stack+135885,int_stack+114045,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+99093,int_stack+146973,int_stack+123285,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+117993,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+162373,int_stack+117993,int_stack+92541,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+175477,int_stack+162373,int_stack+135885,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+193957,int_stack+175477,int_stack+146973,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+125637,int_stack+193957,int_stack+99093,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92541,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+101361,int_stack+92541,int_stack+117993,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+217057,int_stack+101361,int_stack+162373,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+238897,int_stack+217057,int_stack+175477,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+152097,int_stack+238897,int_stack+193957,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+266617,int_stack+152097,int_stack+125637,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+116649,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+126729,int_stack+116649,int_stack+92541,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+184437,int_stack+126729,int_stack+101361,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+301897,int_stack+184437,int_stack+217057,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+334657,int_stack+301897,int_stack+238897,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+209917,int_stack+334657,int_stack+152097,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+373465,int_stack+209917,int_stack+266617,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+92541,int_stack+19488,int_stack+15680,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+144369,int_stack+92541,int_stack+116649,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+92541,int_stack+144369,int_stack+126729,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+121941,int_stack+92541,int_stack+184437,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+160161,int_stack+121941,int_stack+301897,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+92541,int_stack+160161,int_stack+334657,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+144285,int_stack+92541,int_stack+209917,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+199725,int_stack+144285,int_stack+373465,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+92541,int_stack+25392,int_stack+23772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97401,int_stack+27372,int_stack+25392,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+103341,int_stack+97401,int_stack+92541,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113061,int_stack+29748,int_stack+27372,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+120189,int_stack+113061,int_stack+97401,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+132069,int_stack+120189,int_stack+103341,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92541,int_stack+32556,int_stack+29748,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+148269,int_stack+92541,int_stack+113061,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+162525,int_stack+148269,int_stack+120189,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+100965,int_stack+162525,int_stack+132069,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+125265,int_stack+35832,int_stack+32556,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+182325,int_stack+125265,int_stack+92541,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+256425,int_stack+182325,int_stack+148269,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+280185,int_stack+256425,int_stack+162525,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+135093,int_stack+280185,int_stack+100965,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92541,int_stack+39612,int_stack+35832,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+103881,int_stack+92541,int_stack+125265,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+309885,int_stack+103881,int_stack+182325,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+337965,int_stack+309885,int_stack+256425,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+373605,int_stack+337965,int_stack+280185,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+256425,int_stack+373605,int_stack+135093,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+123537,int_stack+43932,int_stack+39612,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+136497,int_stack+123537,int_stack+92541,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+159177,int_stack+136497,int_stack+103881,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+159177,int_stack+309885,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+415185,int_stack+0,int_stack+337965,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+301785,int_stack+415185,int_stack+373605,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+465081,int_stack+301785,int_stack+256425,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+256425,int_stack+48828,int_stack+43932,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+271113,int_stack+256425,int_stack+123537,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+92541,int_stack+271113,int_stack+136497,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+357225,int_stack+92541,int_stack+159177,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+92541,int_stack+357225,int_stack+0,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+523401,int_stack+92541,int_stack+415185,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+92541,int_stack+523401,int_stack+301785,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+256425,int_stack+92541,int_stack+465081,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+329325,int_stack+256425,int_stack+199725,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+92541,int_stack+56361,int_stack+54336,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+98616,int_stack+58836,int_stack+56361,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+106041,int_stack+98616,int_stack+92541,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118191,int_stack+61806,int_stack+58836,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+127101,int_stack+118191,int_stack+98616,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+141951,int_stack+127101,int_stack+106041,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92541,int_stack+65316,int_stack+61806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162201,int_stack+92541,int_stack+118191,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+180021,int_stack+162201,int_stack+127101,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+103071,int_stack+180021,int_stack+141951,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+133446,int_stack+69411,int_stack+65316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+204771,int_stack+133446,int_stack+92541,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+225831,int_stack+204771,int_stack+162201,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+225831,int_stack+180021,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+145731,int_stack+0,int_stack+103071,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92541,int_stack+74136,int_stack+69411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+106716,int_stack+92541,int_stack+133446,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37125,int_stack+106716,int_stack+204771,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+499425,int_stack+37125,int_stack+225831,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+188256,int_stack+499425,int_stack+0,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+543975,int_stack+188256,int_stack+145731,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+79536,int_stack+74136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+131286,int_stack+0,int_stack+92541,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+600675,int_stack+131286,int_stack+106716,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+641625,int_stack+600675,int_stack+37125,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16200,int_stack+641625,int_stack+499425,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+694275,int_stack+16200,int_stack+188256,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+159636,int_stack+694275,int_stack+543975,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+499425,int_stack+85656,int_stack+79536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+517785,int_stack+499425,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+550185,int_stack+517785,int_stack+131286,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+78570,int_stack+550185,int_stack+600675,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+499425,int_stack+78570,int_stack+641625,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+573135,int_stack+499425,int_stack+16200,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+573135,int_stack+694275,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+499425,int_stack+0,int_stack+159636,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+0,int_stack+499425,int_stack+256425,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+499425,int_stack+0,int_stack+329325,2025);
 return int_stack+499425;}
