/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifkg(Libint_t*, prim_data*);

  /* Computes quartets of (if|kg) integrals */

REALTYPE *hrr_order_ifkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[7][7] = int_stack + 7840;
 Libint->vrr_classes[7][8] = int_stack + 9136;
 Libint->vrr_classes[7][9] = int_stack + 10756;
 Libint->vrr_classes[7][10] = int_stack + 12736;
 Libint->vrr_classes[7][11] = int_stack + 15112;
 Libint->vrr_classes[8][7] = int_stack + 17920;
 Libint->vrr_classes[8][8] = int_stack + 19540;
 Libint->vrr_classes[8][9] = int_stack + 21565;
 Libint->vrr_classes[8][10] = int_stack + 24040;
 Libint->vrr_classes[8][11] = int_stack + 27010;
 Libint->vrr_classes[9][7] = int_stack + 30520;
 Libint->vrr_classes[9][8] = int_stack + 32500;
 Libint->vrr_classes[9][9] = int_stack + 34975;
 Libint->vrr_classes[9][10] = int_stack + 38000;
 Libint->vrr_classes[9][11] = int_stack + 41630;
 memset(int_stack,0,45920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 45920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifkg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45920,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+48944,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+52724,int_stack+48944,int_stack+45920,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58772,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+63392,int_stack+58772,int_stack+48944,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+70952,int_stack+63392,int_stack+52724,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45920,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+81032,int_stack+45920,int_stack+58772,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45920,int_stack+81032,int_stack+63392,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+81032,int_stack+45920,int_stack+70952,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45920,int_stack+9136,int_stack+7840,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+49808,int_stack+10756,int_stack+9136,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+54668,int_stack+49808,int_stack+45920,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62444,int_stack+12736,int_stack+10756,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68384,int_stack+62444,int_stack+49808,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+96152,int_stack+68384,int_stack+54668,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45920,int_stack+15112,int_stack+12736,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+45920,int_stack+62444,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45920,int_stack+0,int_stack+68384,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+109112,int_stack+45920,int_stack+96152,36);
 /*--- compute (ip|kg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+128552,int_stack+109112,int_stack+81032,540);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45920,int_stack+19540,int_stack+17920,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50780,int_stack+21565,int_stack+19540,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+56855,int_stack+50780,int_stack+45920,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66575,int_stack+24040,int_stack+21565,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+74000,int_stack+66575,int_stack+50780,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+86150,int_stack+74000,int_stack+56855,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+45920,int_stack+27010,int_stack+24040,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+45920,int_stack+66575,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45920,int_stack+0,int_stack+74000,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+45920,int_stack+86150,45);
 /*--- compute (kp|kg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+45920,int_stack+0,int_stack+109112,540);
 /*--- compute (id|kg) ---*/
 hrr1_build_id(Libint->AB,int_stack+173912,int_stack+45920,int_stack+128552,540);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+104240,int_stack+32500,int_stack+30520,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+110180,int_stack+34975,int_stack+32500,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+117605,int_stack+110180,int_stack+104240,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129485,int_stack+38000,int_stack+34975,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+138560,int_stack+129485,int_stack+110180,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+153410,int_stack+138560,int_stack+117605,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+104240,int_stack+41630,int_stack+38000,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24300,int_stack+104240,int_stack+129485,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+104240,int_stack+24300,int_stack+138560,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+264632,int_stack+104240,int_stack+153410,55);
 /*--- compute (lp|kg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+294332,int_stack+264632,int_stack+0,540);
 /*--- compute (kd|kg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+367232,int_stack+294332,int_stack+45920,540);
 /*--- compute (if|kg) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+367232,int_stack+173912,540);
 return int_stack+0;}
