/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igmp(Libint_t*, prim_data*);

  /* Computes quartets of (ig|mp) integrals */

REALTYPE *hrr_order_igmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[7][9] = int_stack + 3388;
 Libint->vrr_classes[7][10] = int_stack + 5368;
 Libint->vrr_classes[8][9] = int_stack + 7744;
 Libint->vrr_classes[8][10] = int_stack + 10219;
 Libint->vrr_classes[9][9] = int_stack + 13189;
 Libint->vrr_classes[9][10] = int_stack + 16214;
 Libint->vrr_classes[10][9] = int_stack + 19844;
 Libint->vrr_classes[10][10] = int_stack + 23474;
 memset(int_stack,0,27830*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27830;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igmp(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27830,int_stack+1540,int_stack+0,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32450,int_stack+5368,int_stack+3388,36);
 /*--- compute (ip|mp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+38390,int_stack+32450,int_stack+27830,165);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+10219,int_stack+7744,45);
 /*--- compute (kp|mp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+52250,int_stack+0,int_stack+32450,165);
 /*--- compute (id|mp) ---*/
 hrr1_build_id(Libint->AB,int_stack+70070,int_stack+52250,int_stack+38390,165);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27830,int_stack+16214,int_stack+13189,55);
 /*--- compute (lp|mp) ---*/
 hrr1_build_lp(Libint->AB,int_stack+97790,int_stack+27830,int_stack+0,165);
 /*--- compute (kd|mp) ---*/
 hrr1_build_kd(Libint->AB,int_stack+120065,int_stack+97790,int_stack+52250,165);
 /*--- compute (if|mp) ---*/
 hrr1_build_if(Libint->AB,int_stack+155705,int_stack+120065,int_stack+70070,165);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+23474,int_stack+19844,66);
 /*--- compute (mp|mp) ---*/
 hrr1_build_mp(Libint->AB,int_stack+36905,int_stack+0,int_stack+27830,165);
 /*--- compute (ld|mp) ---*/
 hrr1_build_ld(Libint->AB,int_stack+201905,int_stack+36905,int_stack+97790,165);
 /*--- compute (kf|mp) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+201905,int_stack+120065,165);
 /*--- compute (ig|mp) ---*/
 hrr1_build_ig(Libint->AB,int_stack+59400,int_stack+0,int_stack+155705,165);
 return int_stack+59400;}
