/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihkk(Libint_t*, prim_data*);

  /* Computes quartets of (ih|kk) integrals */

REALTYPE *hrr_order_ihkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][7] = int_stack + 0;
 Libint->vrr_classes[6][8] = int_stack + 1008;
 Libint->vrr_classes[6][9] = int_stack + 2268;
 Libint->vrr_classes[6][10] = int_stack + 3808;
 Libint->vrr_classes[6][11] = int_stack + 5656;
 Libint->vrr_classes[6][12] = int_stack + 7840;
 Libint->vrr_classes[6][13] = int_stack + 10388;
 Libint->vrr_classes[6][14] = int_stack + 13328;
 Libint->vrr_classes[7][7] = int_stack + 16688;
 Libint->vrr_classes[7][8] = int_stack + 17984;
 Libint->vrr_classes[7][9] = int_stack + 19604;
 Libint->vrr_classes[7][10] = int_stack + 21584;
 Libint->vrr_classes[7][11] = int_stack + 23960;
 Libint->vrr_classes[7][12] = int_stack + 26768;
 Libint->vrr_classes[7][13] = int_stack + 30044;
 Libint->vrr_classes[7][14] = int_stack + 33824;
 Libint->vrr_classes[8][7] = int_stack + 38144;
 Libint->vrr_classes[8][8] = int_stack + 39764;
 Libint->vrr_classes[8][9] = int_stack + 41789;
 Libint->vrr_classes[8][10] = int_stack + 44264;
 Libint->vrr_classes[8][11] = int_stack + 47234;
 Libint->vrr_classes[8][12] = int_stack + 50744;
 Libint->vrr_classes[8][13] = int_stack + 54839;
 Libint->vrr_classes[8][14] = int_stack + 59564;
 Libint->vrr_classes[9][7] = int_stack + 64964;
 Libint->vrr_classes[9][8] = int_stack + 66944;
 Libint->vrr_classes[9][9] = int_stack + 69419;
 Libint->vrr_classes[9][10] = int_stack + 72444;
 Libint->vrr_classes[9][11] = int_stack + 76074;
 Libint->vrr_classes[9][12] = int_stack + 80364;
 Libint->vrr_classes[9][13] = int_stack + 85369;
 Libint->vrr_classes[9][14] = int_stack + 91144;
 Libint->vrr_classes[10][7] = int_stack + 97744;
 Libint->vrr_classes[10][8] = int_stack + 100120;
 Libint->vrr_classes[10][9] = int_stack + 103090;
 Libint->vrr_classes[10][10] = int_stack + 106720;
 Libint->vrr_classes[10][11] = int_stack + 111076;
 Libint->vrr_classes[10][12] = int_stack + 116224;
 Libint->vrr_classes[10][13] = int_stack + 122230;
 Libint->vrr_classes[10][14] = int_stack + 129160;
 Libint->vrr_classes[11][7] = int_stack + 137080;
 Libint->vrr_classes[11][8] = int_stack + 139888;
 Libint->vrr_classes[11][9] = int_stack + 143398;
 Libint->vrr_classes[11][10] = int_stack + 147688;
 Libint->vrr_classes[11][11] = int_stack + 152836;
 Libint->vrr_classes[11][12] = int_stack + 158920;
 Libint->vrr_classes[11][13] = int_stack + 166018;
 Libint->vrr_classes[11][14] = int_stack + 174208;
 memset(int_stack,0,183568*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 183568;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihkk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+183568,int_stack+1008,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+186592,int_stack+2268,int_stack+1008,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+190372,int_stack+186592,int_stack+183568,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+196420,int_stack+3808,int_stack+2268,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+201040,int_stack+196420,int_stack+186592,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+208600,int_stack+201040,int_stack+190372,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183568,int_stack+5656,int_stack+3808,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+218680,int_stack+183568,int_stack+196420,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+227920,int_stack+218680,int_stack+201040,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+189112,int_stack+227920,int_stack+208600,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+204232,int_stack+7840,int_stack+5656,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+240520,int_stack+204232,int_stack+183568,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+251608,int_stack+240520,int_stack+218680,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+267008,int_stack+251608,int_stack+227920,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+210784,int_stack+267008,int_stack+189112,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+183568,int_stack+10388,int_stack+7840,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+285908,int_stack+183568,int_stack+204232,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+191212,int_stack+285908,int_stack+240520,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+299012,int_stack+191212,int_stack+251608,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+231952,int_stack+299012,int_stack+267008,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+322112,int_stack+231952,int_stack+210784,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+209692,int_stack+13328,int_stack+10388,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+258412,int_stack+209692,int_stack+183568,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+209692,int_stack+258412,int_stack+285908,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+258412,int_stack+209692,int_stack+191212,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+183568,int_stack+258412,int_stack+299012,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+258412,int_stack+183568,int_stack+231952,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+183568,int_stack+258412,int_stack+322112,28);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+219856,int_stack+17984,int_stack+16688,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+223744,int_stack+19604,int_stack+17984,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+228604,int_stack+223744,int_stack+219856,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+236380,int_stack+21584,int_stack+19604,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+242320,int_stack+236380,int_stack+223744,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+252040,int_stack+242320,int_stack+228604,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+219856,int_stack+23960,int_stack+21584,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+265000,int_stack+219856,int_stack+236380,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+276880,int_stack+265000,int_stack+242320,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+226984,int_stack+276880,int_stack+252040,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246424,int_stack+26768,int_stack+23960,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293080,int_stack+246424,int_stack+219856,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+307336,int_stack+293080,int_stack+265000,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+307336,int_stack+276880,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+254848,int_stack+0,int_stack+226984,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+219856,int_stack+30044,int_stack+26768,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+327136,int_stack+219856,int_stack+246424,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+229684,int_stack+327136,int_stack+293080,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+343984,int_stack+229684,int_stack+307336,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+282064,int_stack+343984,int_stack+0,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+373684,int_stack+282064,int_stack+254848,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+33824,int_stack+30044,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11340,int_stack+0,int_stack+219856,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+253444,int_stack+11340,int_stack+327136,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+253444,int_stack+229684,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+219856,int_stack+0,int_stack+343984,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+316084,int_stack+219856,int_stack+282064,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+219856,int_stack+316084,int_stack+373684,36);
 /*--- compute (ip|kk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+266512,int_stack+219856,int_stack+183568,1296);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+183568,int_stack+39764,int_stack+38144,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+188428,int_stack+41789,int_stack+39764,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+194503,int_stack+188428,int_stack+183568,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+204223,int_stack+44264,int_stack+41789,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+375376,int_stack+204223,int_stack+188428,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+387526,int_stack+375376,int_stack+194503,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183568,int_stack+47234,int_stack+44264,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+183568,int_stack+204223,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+192478,int_stack+0,int_stack+375376,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+14850,int_stack+192478,int_stack+387526,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+375376,int_stack+50744,int_stack+47234,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+385906,int_stack+375376,int_stack+183568,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+403726,int_stack+385906,int_stack+0,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+428476,int_stack+403726,int_stack+192478,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+183568,int_stack+428476,int_stack+14850,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+54839,int_stack+50744,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+12285,int_stack+0,int_stack+375376,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+458851,int_stack+12285,int_stack+385906,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+488551,int_stack+458851,int_stack+403726,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+375376,int_stack+488551,int_stack+428476,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+525676,int_stack+375376,int_stack+183568,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+183568,int_stack+59564,int_stack+54839,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+417901,int_stack+183568,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+183568,int_stack+417901,int_stack+12285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+183568,int_stack+458851,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+417901,int_stack+0,int_stack+488551,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+417901,int_stack+375376,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+375376,int_stack+0,int_stack+525676,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+433696,int_stack+375376,int_stack+219856,1296);
 /*--- compute (id|kk) ---*/
 hrr1_build_id(Libint->AB,int_stack+573664,int_stack+433696,int_stack+266512,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+66944,int_stack+64964,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+69419,int_stack+66944,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+72444,int_stack+69419,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+34320,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+49170,int_stack+34320,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+76074,int_stack+72444,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+183568,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+201718,int_stack+183568,int_stack+34320,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+10890,int_stack+201718,int_stack+49170,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+40590,int_stack+80364,int_stack+76074,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+53460,int_stack+40590,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+226468,int_stack+53460,int_stack+183568,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+256718,int_stack+226468,int_stack+201718,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+183568,int_stack+256718,int_stack+10890,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+85369,int_stack+80364,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+293843,int_stack+0,int_stack+40590,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15015,int_stack+293843,int_stack+53460,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+319583,int_stack+15015,int_stack+226468,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+791392,int_stack+319583,int_stack+256718,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+225148,int_stack+791392,int_stack+183568,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+183568,int_stack+91144,int_stack+85369,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+51315,int_stack+183568,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+843367,int_stack+51315,int_stack+293843,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+886267,int_stack+843367,int_stack+15015,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+886267,int_stack+319583,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+843367,int_stack+0,int_stack+791392,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+843367,int_stack+225148,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+183568,int_stack+0,int_stack+375376,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+791392,int_stack+183568,int_stack+433696,1296);
 /*--- compute (if|kk) ---*/
 hrr1_build_if(Libint->AB,int_stack+1071328,int_stack+791392,int_stack+573664,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+71280,int_stack+100120,int_stack+97744,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+78408,int_stack+103090,int_stack+100120,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+87318,int_stack+78408,int_stack+71280,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+358528,int_stack+106720,int_stack+103090,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+369418,int_stack+358528,int_stack+78408,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+387238,int_stack+369418,int_stack+87318,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71280,int_stack+111076,int_stack+106720,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+84348,int_stack+71280,int_stack+358528,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+410998,int_stack+84348,int_stack+369418,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+440698,int_stack+410998,int_stack+387238,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+358528,int_stack+116224,int_stack+111076,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+373972,int_stack+358528,int_stack+71280,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+476338,int_stack+373972,int_stack+84348,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+71280,int_stack+476338,int_stack+410998,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+512638,int_stack+71280,int_stack+440698,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+400108,int_stack+122230,int_stack+116224,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+418126,int_stack+400108,int_stack+358528,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+562534,int_stack+418126,int_stack+373972,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+606094,int_stack+562534,int_stack+476338,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+449014,int_stack+606094,int_stack+71280,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+660544,int_stack+449014,int_stack+512638,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+71280,int_stack+129160,int_stack+122230,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+92070,int_stack+71280,int_stack+400108,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+358528,int_stack+92070,int_stack+418126,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+71280,int_stack+358528,int_stack+562534,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+358528,int_stack+71280,int_stack+606094,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+511384,int_stack+358528,int_stack+449014,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+358528,int_stack+511384,int_stack+660544,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+444064,int_stack+358528,int_stack+0,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1434208,int_stack+444064,int_stack+183568,1296);
 /*--- compute (kf|kk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1784128,int_stack+1434208,int_stack+791392,1296);
 /*--- compute (ig|kk) ---*/
 hrr1_build_ig(Libint->AB,int_stack+2250688,int_stack+1784128,int_stack+1071328,1296);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+183568,int_stack+139888,int_stack+137080,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+191992,int_stack+143398,int_stack+139888,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+202522,int_stack+191992,int_stack+183568,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+219370,int_stack+147688,int_stack+143398,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+232240,int_stack+219370,int_stack+191992,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+253300,int_stack+232240,int_stack+202522,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183568,int_stack+152836,int_stack+147688,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+281380,int_stack+183568,int_stack+219370,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+307120,int_stack+281380,int_stack+232240,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+199012,int_stack+307120,int_stack+253300,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+241132,int_stack+158920,int_stack+152836,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+241132,int_stack+183568,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+30888,int_stack+0,int_stack+281380,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+73788,int_stack+30888,int_stack+307120,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+259384,int_stack+73788,int_stack+199012,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+183568,int_stack+166018,int_stack+158920,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+318352,int_stack+183568,int_stack+241132,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+204862,int_stack+318352,int_stack+0,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+657904,int_stack+204862,int_stack+30888,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+657904,int_stack+73788,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+73710,int_stack+0,int_stack+259384,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+256342,int_stack+174208,int_stack+166018,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+722254,int_stack+256342,int_stack+183568,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+256342,int_stack+722254,int_stack+318352,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+722254,int_stack+256342,int_stack+204862,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+799474,int_stack+722254,int_stack+657904,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+657904,int_stack+799474,int_stack+0,78);
 /*--- compute (o0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+756184,int_stack+657904,int_stack+73710,78);
 /*--- compute (np|kk) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+756184,int_stack+358528,1296);
 /*--- compute (md|kk) ---*/
 hrr1_build_md(Libint->AB,int_stack+657904,int_stack+0,int_stack+444064,1296);
 /*--- compute (lf|kk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+657904,int_stack+1434208,1296);
 /*--- compute (kg|kk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+583200,int_stack+0,int_stack+1784128,1296);
 /*--- compute (ih|kk) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1283040,int_stack+583200,int_stack+2250688,1296);
 return int_stack+1283040;}
