/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihll(Libint_t*, prim_data*);

  /* Computes quartets of (ih|ll) integrals */

REALTYPE *hrr_order_ihll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[6][16] = int_stack + 19488;
 Libint->vrr_classes[7][8] = int_stack + 23772;
 Libint->vrr_classes[7][9] = int_stack + 25392;
 Libint->vrr_classes[7][10] = int_stack + 27372;
 Libint->vrr_classes[7][11] = int_stack + 29748;
 Libint->vrr_classes[7][12] = int_stack + 32556;
 Libint->vrr_classes[7][13] = int_stack + 35832;
 Libint->vrr_classes[7][14] = int_stack + 39612;
 Libint->vrr_classes[7][15] = int_stack + 43932;
 Libint->vrr_classes[7][16] = int_stack + 48828;
 Libint->vrr_classes[8][8] = int_stack + 54336;
 Libint->vrr_classes[8][9] = int_stack + 56361;
 Libint->vrr_classes[8][10] = int_stack + 58836;
 Libint->vrr_classes[8][11] = int_stack + 61806;
 Libint->vrr_classes[8][12] = int_stack + 65316;
 Libint->vrr_classes[8][13] = int_stack + 69411;
 Libint->vrr_classes[8][14] = int_stack + 74136;
 Libint->vrr_classes[8][15] = int_stack + 79536;
 Libint->vrr_classes[8][16] = int_stack + 85656;
 Libint->vrr_classes[9][8] = int_stack + 92541;
 Libint->vrr_classes[9][9] = int_stack + 95016;
 Libint->vrr_classes[9][10] = int_stack + 98041;
 Libint->vrr_classes[9][11] = int_stack + 101671;
 Libint->vrr_classes[9][12] = int_stack + 105961;
 Libint->vrr_classes[9][13] = int_stack + 110966;
 Libint->vrr_classes[9][14] = int_stack + 116741;
 Libint->vrr_classes[9][15] = int_stack + 123341;
 Libint->vrr_classes[9][16] = int_stack + 130821;
 Libint->vrr_classes[10][8] = int_stack + 139236;
 Libint->vrr_classes[10][9] = int_stack + 142206;
 Libint->vrr_classes[10][10] = int_stack + 145836;
 Libint->vrr_classes[10][11] = int_stack + 150192;
 Libint->vrr_classes[10][12] = int_stack + 155340;
 Libint->vrr_classes[10][13] = int_stack + 161346;
 Libint->vrr_classes[10][14] = int_stack + 168276;
 Libint->vrr_classes[10][15] = int_stack + 176196;
 Libint->vrr_classes[10][16] = int_stack + 185172;
 Libint->vrr_classes[11][8] = int_stack + 195270;
 Libint->vrr_classes[11][9] = int_stack + 198780;
 Libint->vrr_classes[11][10] = int_stack + 203070;
 Libint->vrr_classes[11][11] = int_stack + 208218;
 Libint->vrr_classes[11][12] = int_stack + 214302;
 Libint->vrr_classes[11][13] = int_stack + 221400;
 Libint->vrr_classes[11][14] = int_stack + 229590;
 Libint->vrr_classes[11][15] = int_stack + 238950;
 Libint->vrr_classes[11][16] = int_stack + 249558;
 memset(int_stack,0,261492*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 261492;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihll(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+261492,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+265272,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+269892,int_stack+265272,int_stack+261492,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+277452,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+282996,int_stack+277452,int_stack+265272,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+292236,int_stack+282996,int_stack+269892,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+261492,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+304836,int_stack+261492,int_stack+277452,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+315924,int_stack+304836,int_stack+282996,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+268044,int_stack+315924,int_stack+292236,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+286944,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+331324,int_stack+286944,int_stack+261492,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+344428,int_stack+331324,int_stack+304836,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+362908,int_stack+344428,int_stack+315924,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+294588,int_stack+362908,int_stack+268044,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+261492,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+270312,int_stack+261492,int_stack+286944,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+386008,int_stack+270312,int_stack+331324,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+407848,int_stack+386008,int_stack+344428,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+321048,int_stack+407848,int_stack+362908,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+435568,int_stack+321048,int_stack+294588,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+285600,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+295680,int_stack+285600,int_stack+261492,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+353388,int_stack+295680,int_stack+270312,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+470848,int_stack+353388,int_stack+386008,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+503608,int_stack+470848,int_stack+407848,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+378868,int_stack+503608,int_stack+321048,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+542416,int_stack+378868,int_stack+435568,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+261492,int_stack+19488,int_stack+15680,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+313320,int_stack+261492,int_stack+285600,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+261492,int_stack+313320,int_stack+295680,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+290892,int_stack+261492,int_stack+353388,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+329112,int_stack+290892,int_stack+470848,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+261492,int_stack+329112,int_stack+503608,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+313236,int_stack+261492,int_stack+378868,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+368676,int_stack+313236,int_stack+542416,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+261492,int_stack+25392,int_stack+23772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+266352,int_stack+27372,int_stack+25392,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+272292,int_stack+266352,int_stack+261492,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+282012,int_stack+29748,int_stack+27372,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+289140,int_stack+282012,int_stack+266352,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+301020,int_stack+289140,int_stack+272292,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+261492,int_stack+32556,int_stack+29748,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+317220,int_stack+261492,int_stack+282012,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+331476,int_stack+317220,int_stack+289140,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+269916,int_stack+331476,int_stack+301020,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+294216,int_stack+35832,int_stack+32556,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+351276,int_stack+294216,int_stack+261492,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+425376,int_stack+351276,int_stack+317220,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+449136,int_stack+425376,int_stack+331476,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+304044,int_stack+449136,int_stack+269916,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+261492,int_stack+39612,int_stack+35832,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+272832,int_stack+261492,int_stack+294216,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+478836,int_stack+272832,int_stack+351276,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+506916,int_stack+478836,int_stack+425376,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+542556,int_stack+506916,int_stack+449136,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+425376,int_stack+542556,int_stack+304044,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+292488,int_stack+43932,int_stack+39612,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+305448,int_stack+292488,int_stack+261492,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+328128,int_stack+305448,int_stack+272832,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+328128,int_stack+478836,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+584136,int_stack+0,int_stack+506916,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+470736,int_stack+584136,int_stack+542556,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+634032,int_stack+470736,int_stack+425376,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+425376,int_stack+48828,int_stack+43932,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+440064,int_stack+425376,int_stack+292488,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+261492,int_stack+440064,int_stack+305448,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+526176,int_stack+261492,int_stack+328128,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+261492,int_stack+526176,int_stack+0,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+692352,int_stack+261492,int_stack+584136,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+261492,int_stack+692352,int_stack+470736,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+425376,int_stack+261492,int_stack+634032,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+498276,int_stack+425376,int_stack+368676,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+261492,int_stack+56361,int_stack+54336,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+267567,int_stack+58836,int_stack+56361,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+274992,int_stack+267567,int_stack+261492,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+287142,int_stack+61806,int_stack+58836,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+296052,int_stack+287142,int_stack+267567,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+310902,int_stack+296052,int_stack+274992,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+261492,int_stack+65316,int_stack+61806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+331152,int_stack+261492,int_stack+287142,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+348972,int_stack+331152,int_stack+296052,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+272022,int_stack+348972,int_stack+310902,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+302397,int_stack+69411,int_stack+65316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+373722,int_stack+302397,int_stack+261492,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+394782,int_stack+373722,int_stack+331152,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+394782,int_stack+348972,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+314682,int_stack+0,int_stack+272022,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+261492,int_stack+74136,int_stack+69411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+275667,int_stack+261492,int_stack+302397,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37125,int_stack+275667,int_stack+373722,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+668376,int_stack+37125,int_stack+394782,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+357207,int_stack+668376,int_stack+0,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+712926,int_stack+357207,int_stack+314682,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+79536,int_stack+74136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+300237,int_stack+0,int_stack+261492,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+769626,int_stack+300237,int_stack+275667,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+810576,int_stack+769626,int_stack+37125,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16200,int_stack+810576,int_stack+668376,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+863226,int_stack+16200,int_stack+357207,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+328587,int_stack+863226,int_stack+712926,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+668376,int_stack+85656,int_stack+79536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+686736,int_stack+668376,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+719136,int_stack+686736,int_stack+300237,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+261492,int_stack+719136,int_stack+769626,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+668376,int_stack+261492,int_stack+810576,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+742086,int_stack+668376,int_stack+16200,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+742086,int_stack+863226,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+668376,int_stack+0,int_stack+328587,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+759501,int_stack+668376,int_stack+425376,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+978201,int_stack+759501,int_stack+498276,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+95016,int_stack+92541,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+98041,int_stack+95016,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+101671,int_stack+98041,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42240,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+60390,int_stack+42240,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+105961,int_stack+101671,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+261492,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+283272,int_stack+261492,int_stack+42240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12870,int_stack+283272,int_stack+60390,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49995,int_stack+110966,int_stack+105961,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+65010,int_stack+49995,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+313522,int_stack+65010,int_stack+261492,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+349822,int_stack+313522,int_stack+283272,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+261492,int_stack+349822,int_stack+12870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116741,int_stack+110966,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+49995,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+395197,int_stack+17325,int_stack+65010,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+47355,int_stack+395197,int_stack+313522,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+438097,int_stack+47355,int_stack+349822,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+313467,int_stack+438097,int_stack+261492,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+261492,int_stack+123341,int_stack+116741,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+501622,int_stack+261492,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+536272,int_stack+501622,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+586322,int_stack+536272,int_stack+395197,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1318401,int_stack+586322,int_stack+47355,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1318401,int_stack+438097,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+382767,int_stack+0,int_stack+313467,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84700,int_stack+130821,int_stack+123341,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+281292,int_stack+84700,int_stack+261492,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+320892,int_stack+281292,int_stack+501622,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1394631,int_stack+320892,int_stack+536272,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+261492,int_stack+1394631,int_stack+586322,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+471867,int_stack+261492,int_stack+1318401,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1318401,int_stack+471867,int_stack+0,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1318401,int_stack+382767,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+261492,int_stack+0,int_stack+668376,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1318401,int_stack+261492,int_stack+759501,2025);
 /*--- compute (if|ll) ---*/
 hrr1_build_if(Libint->AB,int_stack+1755801,int_stack+1318401,int_stack+978201,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+111375,int_stack+142206,int_stack+139236,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+120285,int_stack+145836,int_stack+142206,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+534867,int_stack+120285,int_stack+111375,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131175,int_stack+150192,int_stack+145836,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+552687,int_stack+131175,int_stack+120285,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+574467,int_stack+552687,int_stack+534867,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+534867,int_stack+155340,int_stack+150192,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+604167,int_stack+534867,int_stack+131175,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+111375,int_stack+604167,int_stack+552687,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+630303,int_stack+111375,int_stack+574467,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+550311,int_stack+161346,int_stack+155340,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+568329,int_stack+550311,int_stack+534867,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+674853,int_stack+568329,int_stack+604167,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+718413,int_stack+674853,int_stack+111375,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+772863,int_stack+718413,int_stack+630303,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111375,int_stack+168276,int_stack+161346,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+132165,int_stack+111375,int_stack+550311,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+599217,int_stack+132165,int_stack+568329,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+835233,int_stack+599217,int_stack+674853,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+900573,int_stack+835233,int_stack+718413,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+650697,int_stack+900573,int_stack+772863,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+534867,int_stack+176196,int_stack+168276,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+733857,int_stack+534867,int_stack+111375,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+976803,int_stack+733857,int_stack+132165,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1036863,int_stack+976803,int_stack+599217,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+558627,int_stack+1036863,int_stack+835233,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+775437,int_stack+558627,int_stack+900573,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1114083,int_stack+775437,int_stack+650697,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+111375,int_stack+185172,int_stack+176196,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+138303,int_stack+111375,int_stack+534867,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+650103,int_stack+138303,int_stack+733857,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+877077,int_stack+650103,int_stack+976803,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+650103,int_stack+877077,int_stack+1036863,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+877077,int_stack+650103,int_stack+558627,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+534867,int_stack+877077,int_stack+775437,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+665547,int_stack+534867,int_stack+1114083,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+799197,int_stack+665547,int_stack+0,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2322801,int_stack+799197,int_stack+261492,2025);
 /*--- compute (kf|ll) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2869551,int_stack+2322801,int_stack+1318401,2025);
 /*--- compute (ig|ll) ---*/
 hrr1_build_ig(Libint->AB,int_stack+3598551,int_stack+2869551,int_stack+1755801,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+261492,int_stack+198780,int_stack+195270,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+272022,int_stack+203070,int_stack+198780,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+284892,int_stack+272022,int_stack+261492,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+305952,int_stack+208218,int_stack+203070,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+321396,int_stack+305952,int_stack+272022,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+347136,int_stack+321396,int_stack+284892,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+261492,int_stack+214302,int_stack+208218,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+382236,int_stack+261492,int_stack+305952,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+413124,int_stack+382236,int_stack+321396,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+279744,int_stack+413124,int_stack+347136,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+332394,int_stack+221400,int_stack+214302,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+456024,int_stack+332394,int_stack+261492,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+492528,int_stack+456024,int_stack+382236,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+544008,int_stack+492528,int_stack+413124,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+353688,int_stack+544008,int_stack+279744,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+261492,int_stack+229590,int_stack+221400,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+286062,int_stack+261492,int_stack+332394,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+286062,int_stack+456024,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+60840,int_stack+0,int_stack+492528,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+427398,int_stack+60840,int_stack+544008,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+517488,int_stack+427398,int_stack+353688,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+328650,int_stack+238950,int_stack+229590,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+356730,int_stack+328650,int_stack+261492,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+138060,int_stack+356730,int_stack+286062,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1133322,int_stack+138060,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1224582,int_stack+1133322,int_stack+60840,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1224582,int_stack+427398,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1332690,int_stack+0,int_stack+517488,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+261492,int_stack+249558,int_stack+238950,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+405870,int_stack+261492,int_stack+328650,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+462030,int_stack+405870,int_stack+356730,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+543930,int_stack+462030,int_stack+138060,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+120120,int_stack+543930,int_stack+1133322,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+247884,int_stack+120120,int_stack+1224582,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1133322,int_stack+247884,int_stack+0,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1133322,int_stack+1332690,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+1133322,int_stack+0,int_stack+665547,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+1133322,int_stack+799197,2025);
 /*--- compute (lf|ll) ---*/
 hrr1_build_lf(Libint->AB,int_stack+668250,int_stack+0,int_stack+2322801,2025);
 /*--- compute (kg|ll) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1579500,int_stack+668250,int_stack+2869551,2025);
 /*--- compute (ih|ll) ---*/
 hrr1_build_ih(Libint->AB,int_stack+0,int_stack+1579500,int_stack+3598551,2025);
 return int_stack+0;}
