/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihnn(Libint_t*, prim_data*);

  /* Computes quartets of (ih|nn) integrals */

REALTYPE *hrr_order_ihnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[6][20] = int_stack + 36960;
 Libint->vrr_classes[7][10] = int_stack + 43428;
 Libint->vrr_classes[7][11] = int_stack + 45804;
 Libint->vrr_classes[7][12] = int_stack + 48612;
 Libint->vrr_classes[7][13] = int_stack + 51888;
 Libint->vrr_classes[7][14] = int_stack + 55668;
 Libint->vrr_classes[7][15] = int_stack + 59988;
 Libint->vrr_classes[7][16] = int_stack + 64884;
 Libint->vrr_classes[7][17] = int_stack + 70392;
 Libint->vrr_classes[7][18] = int_stack + 76548;
 Libint->vrr_classes[7][19] = int_stack + 83388;
 Libint->vrr_classes[7][20] = int_stack + 90948;
 Libint->vrr_classes[8][10] = int_stack + 99264;
 Libint->vrr_classes[8][11] = int_stack + 102234;
 Libint->vrr_classes[8][12] = int_stack + 105744;
 Libint->vrr_classes[8][13] = int_stack + 109839;
 Libint->vrr_classes[8][14] = int_stack + 114564;
 Libint->vrr_classes[8][15] = int_stack + 119964;
 Libint->vrr_classes[8][16] = int_stack + 126084;
 Libint->vrr_classes[8][17] = int_stack + 132969;
 Libint->vrr_classes[8][18] = int_stack + 140664;
 Libint->vrr_classes[8][19] = int_stack + 149214;
 Libint->vrr_classes[8][20] = int_stack + 158664;
 Libint->vrr_classes[9][10] = int_stack + 169059;
 Libint->vrr_classes[9][11] = int_stack + 172689;
 Libint->vrr_classes[9][12] = int_stack + 176979;
 Libint->vrr_classes[9][13] = int_stack + 181984;
 Libint->vrr_classes[9][14] = int_stack + 187759;
 Libint->vrr_classes[9][15] = int_stack + 194359;
 Libint->vrr_classes[9][16] = int_stack + 201839;
 Libint->vrr_classes[9][17] = int_stack + 210254;
 Libint->vrr_classes[9][18] = int_stack + 219659;
 Libint->vrr_classes[9][19] = int_stack + 230109;
 Libint->vrr_classes[9][20] = int_stack + 241659;
 Libint->vrr_classes[10][10] = int_stack + 254364;
 Libint->vrr_classes[10][11] = int_stack + 258720;
 Libint->vrr_classes[10][12] = int_stack + 263868;
 Libint->vrr_classes[10][13] = int_stack + 269874;
 Libint->vrr_classes[10][14] = int_stack + 276804;
 Libint->vrr_classes[10][15] = int_stack + 284724;
 Libint->vrr_classes[10][16] = int_stack + 293700;
 Libint->vrr_classes[10][17] = int_stack + 303798;
 Libint->vrr_classes[10][18] = int_stack + 315084;
 Libint->vrr_classes[10][19] = int_stack + 327624;
 Libint->vrr_classes[10][20] = int_stack + 341484;
 Libint->vrr_classes[11][10] = int_stack + 356730;
 Libint->vrr_classes[11][11] = int_stack + 361878;
 Libint->vrr_classes[11][12] = int_stack + 367962;
 Libint->vrr_classes[11][13] = int_stack + 375060;
 Libint->vrr_classes[11][14] = int_stack + 383250;
 Libint->vrr_classes[11][15] = int_stack + 392610;
 Libint->vrr_classes[11][16] = int_stack + 403218;
 Libint->vrr_classes[11][17] = int_stack + 415152;
 Libint->vrr_classes[11][18] = int_stack + 428490;
 Libint->vrr_classes[11][19] = int_stack + 443310;
 Libint->vrr_classes[11][20] = int_stack + 459690;
 memset(int_stack,0,477708*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 477708;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihnn(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+477708,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+483252,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+489804,int_stack+483252,int_stack+477708,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+500892,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+508536,int_stack+500892,int_stack+483252,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+521640,int_stack+508536,int_stack+489804,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+477708,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+540120,int_stack+477708,int_stack+500892,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+486528,int_stack+540120,int_stack+508536,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+555408,int_stack+486528,int_stack+521640,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+508368,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+518448,int_stack+508368,int_stack+477708,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+583128,int_stack+518448,int_stack+540120,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+608608,int_stack+583128,int_stack+486528,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+641368,int_stack+608608,int_stack+555408,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+477708,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+536088,int_stack+477708,int_stack+508368,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+680176,int_stack+536088,int_stack+518448,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+489132,int_stack+680176,int_stack+583128,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+556248,int_stack+489132,int_stack+608608,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+709576,int_stack+556248,int_stack+641368,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+602112,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+614964,int_stack+602112,int_stack+477708,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+637812,int_stack+614964,int_stack+536088,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+761320,int_stack+637812,int_stack+680176,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+805420,int_stack+761320,int_stack+489132,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+477708,int_stack+805420,int_stack+556248,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+858928,int_stack+477708,int_stack+709576,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+538860,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+553224,int_stack+538860,int_stack+602112,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+671412,int_stack+553224,int_stack+614964,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+578928,int_stack+671412,int_stack+637812,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+925456,int_stack+578928,int_stack+761320,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+709492,int_stack+925456,int_stack+805420,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+987196,int_stack+709492,int_stack+477708,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1065820,int_stack+987196,int_stack+858928,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+477708,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+493668,int_stack+477708,int_stack+538860,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+780836,int_stack+493668,int_stack+553224,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+823676,int_stack+780836,int_stack+671412,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+629328,int_stack+823676,int_stack+578928,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+522396,int_stack+629328,int_stack+925456,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+880796,int_stack+522396,int_stack+709492,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1148980,int_stack+880796,int_stack+987196,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1247260,int_stack+1148980,int_stack+1065820,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+604716,int_stack+36960,int_stack+31080,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+699888,int_stack+604716,int_stack+477708,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+731808,int_stack+699888,int_stack+493668,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+972524,int_stack+731808,int_stack+780836,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+699888,int_stack+972524,int_stack+823676,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+972524,int_stack+699888,int_stack+629328,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+604716,int_stack+972524,int_stack+522396,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+972524,int_stack+604716,int_stack+880796,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+477708,int_stack+972524,int_stack+1148980,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+597828,int_stack+477708,int_stack+1247260,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+477708,int_stack+45804,int_stack+43428,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+484836,int_stack+48612,int_stack+45804,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+493260,int_stack+484836,int_stack+477708,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+507516,int_stack+51888,int_stack+48612,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+517344,int_stack+507516,int_stack+484836,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+534192,int_stack+517344,int_stack+493260,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+477708,int_stack+55668,int_stack+51888,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+557952,int_stack+477708,int_stack+507516,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+489048,int_stack+557952,int_stack+517344,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+719796,int_stack+489048,int_stack+534192,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+517128,int_stack+59988,int_stack+55668,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+530088,int_stack+517128,int_stack+477708,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+755436,int_stack+530088,int_stack+557952,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+552768,int_stack+755436,int_stack+489048,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+788196,int_stack+552768,int_stack+719796,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+719796,int_stack+64884,int_stack+59988,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+477708,int_stack+719796,int_stack+517128,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+838092,int_stack+477708,int_stack+530088,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+503628,int_stack+838092,int_stack+755436,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+875892,int_stack+503628,int_stack+552768,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+934860,int_stack+875892,int_stack+788196,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+552768,int_stack+70392,int_stack+64884,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+734484,int_stack+552768,int_stack+719796,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+763860,int_stack+734484,int_stack+477708,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1001388,int_stack+763860,int_stack+838092,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+807060,int_stack+1001388,int_stack+503628,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1058088,int_stack+807060,int_stack+875892,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1136712,int_stack+1058088,int_stack+934860,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+477708,int_stack+76548,int_stack+70392,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+496176,int_stack+477708,int_stack+552768,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+529224,int_stack+496176,int_stack+734484,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+875856,int_stack+529224,int_stack+763860,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+719796,int_stack+875856,int_stack+1001388,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+940656,int_stack+719796,int_stack+807060,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1222248,int_stack+940656,int_stack+1058088,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1323336,int_stack+1222248,int_stack+1136712,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+799176,int_stack+83388,int_stack+76548,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+819696,int_stack+799176,int_stack+477708,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1032384,int_stack+819696,int_stack+496176,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1087464,int_stack+1032384,int_stack+529224,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+477708,int_stack+1087464,int_stack+875856,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1430256,int_stack+477708,int_stack+719796,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1536096,int_stack+1430256,int_stack+940656,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+856632,int_stack+1536096,int_stack+1222248,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1160904,int_stack+856632,int_stack+1323336,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+719796,int_stack+90948,int_stack+83388,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+742476,int_stack+719796,int_stack+799176,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1291584,int_stack+742476,int_stack+819696,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+719796,int_stack+1291584,int_stack+1032384,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1291584,int_stack+719796,int_stack+1087464,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+719796,int_stack+1291584,int_stack+477708,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1291584,int_stack+719796,int_stack+1430256,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+982992,int_stack+1291584,int_stack+1536096,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1291584,int_stack+982992,int_stack+856632,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1446024,int_stack+1291584,int_stack+1160904,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+719796,int_stack+1446024,int_stack+597828,4356);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1602840,int_stack+102234,int_stack+99264,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1611750,int_stack+105744,int_stack+102234,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1622280,int_stack+1611750,int_stack+1602840,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1640100,int_stack+109839,int_stack+105744,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1085700,int_stack+1640100,int_stack+1611750,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1106760,int_stack+1085700,int_stack+1622280,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1602840,int_stack+114564,int_stack+109839,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1136460,int_stack+1602840,int_stack+1640100,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1617015,int_stack+1136460,int_stack+1085700,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1161030,int_stack+1617015,int_stack+1106760,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1085700,int_stack+119964,int_stack+114564,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1101900,int_stack+1085700,int_stack+1602840,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1205580,int_stack+1101900,int_stack+1136460,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1246530,int_stack+1205580,int_stack+1617015,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1299180,int_stack+1246530,int_stack+1161030,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1602840,int_stack+126084,int_stack+119964,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1621200,int_stack+1602840,int_stack+1085700,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1130250,int_stack+1621200,int_stack+1101900,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1361550,int_stack+1130250,int_stack+1205580,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+477708,int_stack+1361550,int_stack+1246530,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1177500,int_stack+477708,int_stack+1299180,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1085700,int_stack+132969,int_stack+126084,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1260660,int_stack+1085700,int_stack+1602840,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1297380,int_stack+1260660,int_stack+1621200,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+551418,int_stack+1297380,int_stack+1130250,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+622293,int_stack+551418,int_stack+1361550,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+622293,int_stack+477708,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1602840,int_stack+0,int_stack+1177500,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+477708,int_stack+140664,int_stack+132969,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+500793,int_stack+477708,int_stack+1085700,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1085700,int_stack+500793,int_stack+1260660,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1146900,int_stack+1085700,int_stack+1297380,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1227900,int_stack+1146900,int_stack+551418,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1327125,int_stack+1227900,int_stack+622293,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+542103,int_stack+1327125,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+542103,int_stack+1602840,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1602840,int_stack+149214,int_stack+140664,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1628490,int_stack+1602840,int_stack+477708,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1674660,int_stack+1628490,int_stack+500793,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1743510,int_stack+1674660,int_stack+1085700,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1835310,int_stack+1743510,int_stack+1146900,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1085700,int_stack+1835310,int_stack+1227900,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1948710,int_stack+1085700,int_stack+1327125,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1218000,int_stack+1948710,int_stack+542103,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+477708,int_stack+1218000,int_stack+0,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+158664,int_stack+149214,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+28350,int_stack+0,int_stack+1602840,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+79650,int_stack+28350,int_stack+1628490,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2096130,int_stack+79650,int_stack+1674660,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1602840,int_stack+2096130,int_stack+1743510,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+1602840,int_stack+1835310,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1602840,int_stack+0,int_stack+1085700,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2096130,int_stack+1602840,int_stack+1948710,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1602840,int_stack+2096130,int_stack+1218000,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1795890,int_stack+1602840,int_stack+477708,45);
 /*--- compute (kp|nn) ---*/
 hrr1_build_kp(Libint->AB,int_stack+1991910,int_stack+1795890,int_stack+1446024,4356);
 /*--- compute (id|nn) ---*/
 hrr1_build_id(Libint->AB,int_stack+2462358,int_stack+1991910,int_stack+719796,4356);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+477708,int_stack+172689,int_stack+169059,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+488598,int_stack+176979,int_stack+172689,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+501468,int_stack+488598,int_stack+477708,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+523248,int_stack+181984,int_stack+176979,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+538263,int_stack+523248,int_stack+488598,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+564003,int_stack+538263,int_stack+501468,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+477708,int_stack+187759,int_stack+181984,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+600303,int_stack+477708,int_stack+523248,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+495033,int_stack+600303,int_stack+538263,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+630333,int_stack+495033,int_stack+564003,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+537933,int_stack+194359,int_stack+187759,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+557733,int_stack+537933,int_stack+477708,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+684783,int_stack+557733,int_stack+600303,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+734833,int_stack+684783,int_stack+495033,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+799183,int_stack+734833,int_stack+630333,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+477708,int_stack+201839,int_stack+194359,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+592383,int_stack+477708,int_stack+537933,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+875413,int_stack+592383,int_stack+557733,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+500148,int_stack+875413,int_stack+684783,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+631983,int_stack+500148,int_stack+734833,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+933163,int_stack+631983,int_stack+799183,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+722073,int_stack+210254,int_stack+201839,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+747318,int_stack+722073,int_stack+477708,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+792198,int_stack+747318,int_stack+592383,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1034803,int_stack+792198,int_stack+875413,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1121428,int_stack+1034803,int_stack+500148,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+477708,int_stack+1121428,int_stack+631983,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1226533,int_stack+477708,int_stack+933163,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+597828,int_stack+219659,int_stack+210254,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+626043,int_stack+597828,int_stack+722073,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+858198,int_stack+626043,int_stack+747318,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+676533,int_stack+858198,int_stack+792198,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1357213,int_stack+676533,int_stack+1034803,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+932998,int_stack+1357213,int_stack+1121428,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1478488,int_stack+932998,int_stack+477708,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1478488,int_stack+1226533,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+477708,int_stack+230109,int_stack+219659,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+509058,int_stack+477708,int_stack+597828,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1073138,int_stack+509058,int_stack+626043,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1157288,int_stack+1073138,int_stack+858198,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+775533,int_stack+1157288,int_stack+676533,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+565488,int_stack+775533,int_stack+1357213,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1269488,int_stack+565488,int_stack+932998,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3194166,int_stack+1269488,int_stack+1478488,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1449668,int_stack+3194166,int_stack+0,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+241659,int_stack+230109,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+34650,int_stack+0,int_stack+477708,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+97350,int_stack+34650,int_stack+509058,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+914133,int_stack+97350,int_stack+1073138,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+914133,int_stack+1157288,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+914133,int_stack+0,int_stack+775533,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+914133,int_stack+565488,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+477708,int_stack+0,int_stack+1269488,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+477708,int_stack+3194166,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+477708,int_stack+0,int_stack+1449668,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+717288,int_stack+477708,int_stack+1795890,4356);
 /*--- compute (kd|nn) ---*/
 hrr1_build_kd(Libint->AB,int_stack+3194166,int_stack+717288,int_stack+1991910,4356);
 /*--- compute (if|nn) ---*/
 hrr1_build_if(Libint->AB,int_stack+4135062,int_stack+3194166,int_stack+2462358,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+258720,int_stack+254364,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+263868,int_stack+258720,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+269874,int_stack+263868,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103554,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+276804,int_stack+269874,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+147114,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+147114,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+183150,int_stack+20790,int_stack+103554,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+72270,int_stack+284724,int_stack+276804,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96030,int_stack+72270,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1305348,int_stack+96030,int_stack+147114,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1365408,int_stack+1305348,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1442628,int_stack+1365408,int_stack+183150,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+293700,int_stack+284724,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+137610,int_stack+0,int_stack+72270,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+185130,int_stack+137610,int_stack+96030,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+26928,int_stack+185130,int_stack+1305348,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1534104,int_stack+26928,int_stack+1365408,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1305348,int_stack+1534104,int_stack+1442628,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1427316,int_stack+303798,int_stack+293700,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1457610,int_stack+1427316,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1642212,int_stack+1457610,int_stack+137610,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1721412,int_stack+1642212,int_stack+185130,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+117018,int_stack+1721412,int_stack+26928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1825362,int_stack+117018,int_stack+1534104,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1969506,int_stack+1825362,int_stack+1305348,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1305348,int_stack+315084,int_stack+303798,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1339206,int_stack+1305348,int_stack+1427316,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+1339206,int_stack+1457610,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1399794,int_stack+0,int_stack+1642212,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1518594,int_stack+1399794,int_stack+1721412,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2126322,int_stack+1518594,int_stack+117018,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+89760,int_stack+2126322,int_stack+1825362,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1664124,int_stack+89760,int_stack+1969506,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1860144,int_stack+327624,int_stack+315084,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1897764,int_stack+1860144,int_stack+1305348,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1965480,int_stack+1897764,int_stack+1339206,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2294490,int_stack+1965480,int_stack+0,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2429130,int_stack+2294490,int_stack+1399794,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1305348,int_stack+2429130,int_stack+1518594,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2595450,int_stack+1305348,int_stack+2126322,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2811666,int_stack+2595450,int_stack+89760,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+2811666,int_stack+1664124,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+239580,int_stack+341484,int_stack+327624,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+281160,int_stack+239580,int_stack+1860144,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1499388,int_stack+281160,int_stack+1897764,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1612248,int_stack+1499388,int_stack+1965480,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1763718,int_stack+1612248,int_stack+2294490,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1499388,int_stack+1763718,int_stack+2429130,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1721148,int_stack+1499388,int_stack+1305348,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1305348,int_stack+1721148,int_stack+2595450,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1575618,int_stack+1305348,int_stack+2811666,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1858758,int_stack+1575618,int_stack+0,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2146254,int_stack+1858758,int_stack+477708,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+5354742,int_stack+2146254,int_stack+717288,4356);
 /*--- compute (kf|nn) ---*/
 hrr1_build_kf(Libint->AB,int_stack+6530862,int_stack+5354742,int_stack+3194166,4356);
 /*--- compute (ig|nn) ---*/
 hrr1_build_ig(Libint->AB,int_stack+8099022,int_stack+6530862,int_stack+4135062,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+477708,int_stack+361878,int_stack+356730,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+493152,int_stack+367962,int_stack+361878,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+511404,int_stack+493152,int_stack+477708,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+542292,int_stack+375060,int_stack+367962,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+563586,int_stack+542292,int_stack+493152,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+600090,int_stack+563586,int_stack+511404,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+477708,int_stack+383250,int_stack+375060,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+651570,int_stack+477708,int_stack+542292,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+502278,int_stack+651570,int_stack+563586,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+694158,int_stack+502278,int_stack+600090,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+563118,int_stack+392610,int_stack+383250,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+591198,int_stack+563118,int_stack+477708,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+771378,int_stack+591198,int_stack+651570,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+842358,int_stack+771378,int_stack+502278,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+933618,int_stack+842358,int_stack+694158,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+477708,int_stack+403218,int_stack+392610,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+640338,int_stack+477708,int_stack+563118,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1041726,int_stack+640338,int_stack+591198,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+509532,int_stack+1041726,int_stack+771378,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+696498,int_stack+509532,int_stack+842358,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1123626,int_stack+696498,int_stack+933618,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+824262,int_stack+415152,int_stack+403218,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+860064,int_stack+824262,int_stack+477708,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+923712,int_stack+860064,int_stack+640338,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1267770,int_stack+923712,int_stack+1041726,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1390620,int_stack+1267770,int_stack+509532,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+477708,int_stack+1390620,int_stack+696498,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1539678,int_stack+477708,int_stack+1123626,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+648060,int_stack+428490,int_stack+415152,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+688074,int_stack+648060,int_stack+824262,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1017312,int_stack+688074,int_stack+860064,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+759678,int_stack+1017312,int_stack+923712,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+759678,int_stack+1267770,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1123392,int_stack+0,int_stack+1390620,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+171990,int_stack+1123392,int_stack+477708,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2864994,int_stack+171990,int_stack+1539678,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+477708,int_stack+443310,int_stack+428490,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+522168,int_stack+477708,int_stack+648060,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1322136,int_stack+522168,int_stack+688074,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1441476,int_stack+1322136,int_stack+1017312,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+900078,int_stack+1441476,int_stack+759678,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+602196,int_stack+900078,int_stack+0,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1600596,int_stack+602196,int_stack+1123392,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3096654,int_stack+1600596,int_stack+171990,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+3096654,int_stack+2864994,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2864994,int_stack+459690,int_stack+443310,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2914134,int_stack+2864994,int_stack+477708,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+283140,int_stack+2914134,int_stack+522168,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2864994,int_stack+283140,int_stack+1322136,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+283140,int_stack+2864994,int_stack+1441476,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1096638,int_stack+283140,int_stack+900078,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+283140,int_stack+1096638,int_stack+602196,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+577980,int_stack+283140,int_stack+1600596,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+897390,int_stack+577980,int_stack+3096654,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+283140,int_stack+897390,int_stack+0,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+622908,int_stack+283140,int_stack+1858758,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+2864994,int_stack+622908,int_stack+2146254,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+2864994,int_stack+5354742,4356);
 /*--- compute (kg|nn) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1960200,int_stack+0,int_stack+6530862,4356);
 /*--- compute (ih|nn) ---*/
 hrr1_build_ih(Libint->AB,int_stack+4312440,int_stack+1960200,int_stack+8099022,4356);
 return int_stack+4312440;}
