/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipih(Libint_t*, prim_data*);

  /* Computes quartets of (ip|ih) integrals */

REALTYPE *hrr_order_ipih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[7][6] = int_stack + 8624;
 Libint->vrr_classes[7][7] = int_stack + 9632;
 Libint->vrr_classes[7][8] = int_stack + 10928;
 Libint->vrr_classes[7][9] = int_stack + 12548;
 Libint->vrr_classes[7][10] = int_stack + 14528;
 Libint->vrr_classes[7][11] = int_stack + 16904;
 memset(int_stack,0,19712*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 19712;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipih(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+19712,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+22064,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+25088,int_stack+22064,int_stack+19712,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29792,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33572,int_stack+29792,int_stack+22064,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+39620,int_stack+33572,int_stack+25088,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19712,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47460,int_stack+19712,int_stack+29792,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+55020,int_stack+47460,int_stack+33572,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+24332,int_stack+55020,int_stack+39620,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36092,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65100,int_stack+36092,int_stack+19712,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+74340,int_stack+65100,int_stack+47460,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+36092,int_stack+74340,int_stack+55020,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+51212,int_stack+36092,int_stack+24332,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+19712,int_stack+9632,int_stack+8624,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+22736,int_stack+10928,int_stack+9632,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+26624,int_stack+22736,int_stack+19712,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+32672,int_stack+12548,int_stack+10928,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+37532,int_stack+32672,int_stack+22736,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+67676,int_stack+37532,int_stack+26624,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19712,int_stack+14528,int_stack+12548,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+19712,int_stack+32672,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77756,int_stack+0,int_stack+37532,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+25652,int_stack+77756,int_stack+67676,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+67676,int_stack+16904,int_stack+14528,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+90716,int_stack+67676,int_stack+19712,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+102596,int_stack+90716,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+102596,int_stack+77756,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+67676,int_stack+0,int_stack+25652,36);
 /*--- compute (ip|ih) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+67676,int_stack+51212,588);
 return int_stack+0;}
