/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfng(Libint_t*, prim_data*);

  /* Computes quartets of (kf|ng) integrals */

REALTYPE *hrr_order_kfng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[8][10] = int_stack + 16560;
 Libint->vrr_classes[8][11] = int_stack + 19530;
 Libint->vrr_classes[8][12] = int_stack + 23040;
 Libint->vrr_classes[8][13] = int_stack + 27135;
 Libint->vrr_classes[8][14] = int_stack + 31860;
 Libint->vrr_classes[9][10] = int_stack + 37260;
 Libint->vrr_classes[9][11] = int_stack + 40890;
 Libint->vrr_classes[9][12] = int_stack + 45180;
 Libint->vrr_classes[9][13] = int_stack + 50185;
 Libint->vrr_classes[9][14] = int_stack + 55960;
 Libint->vrr_classes[10][10] = int_stack + 62560;
 Libint->vrr_classes[10][11] = int_stack + 66916;
 Libint->vrr_classes[10][12] = int_stack + 72064;
 Libint->vrr_classes[10][13] = int_stack + 78070;
 Libint->vrr_classes[10][14] = int_stack + 85000;
 memset(int_stack,0,92920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 92920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfng(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92920,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100048,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108472,int_stack+100048,int_stack+92920,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+122728,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132556,int_stack+122728,int_stack+100048,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+149404,int_stack+132556,int_stack+108472,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92920,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173164,int_stack+92920,int_stack+122728,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+92920,int_stack+173164,int_stack+132556,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+173164,int_stack+92920,int_stack+149404,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92920,int_stack+19530,int_stack+16560,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+101830,int_stack+23040,int_stack+19530,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+112360,int_stack+101830,int_stack+92920,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+130180,int_stack+27135,int_stack+23040,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+142465,int_stack+130180,int_stack+101830,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+208804,int_stack+142465,int_stack+112360,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+92920,int_stack+31860,int_stack+27135,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+92920,int_stack+130180,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+92920,int_stack+0,int_stack+142465,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+128020,int_stack+92920,int_stack+208804,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+208804,int_stack+128020,int_stack+173164,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92920,int_stack+40890,int_stack+37260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103810,int_stack+45180,int_stack+40890,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+103810,int_stack+92920,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21780,int_stack+50185,int_stack+45180,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172570,int_stack+21780,int_stack+103810,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+315724,int_stack+172570,int_stack+0,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+55960,int_stack+50185,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+92920,int_stack+0,int_stack+21780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+92920,int_stack+172570,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+352024,int_stack+0,int_stack+315724,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+406474,int_stack+352024,int_stack+128020,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+540124,int_stack+406474,int_stack+208804,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+66916,int_stack+62560,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+72064,int_stack+66916,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+92920,int_stack+78070,int_stack+72064,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+110938,int_stack+92920,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+141826,int_stack+110938,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+85000,int_stack+78070,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+92920,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+56826,int_stack+20790,int_stack+110938,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+185386,int_stack+56826,int_stack+141826,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+185386,int_stack+352024,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+753964,int_stack+0,int_stack+406474,990);
 /*--- compute (kf|ng) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+753964,int_stack+540124,990);
 return int_stack+0;}
