/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kglh(Libint_t*, prim_data*);

  /* Computes quartets of (kg|lh) integrals */

REALTYPE *hrr_order_kglh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[8][8] = int_stack + 15840;
 Libint->vrr_classes[8][9] = int_stack + 17865;
 Libint->vrr_classes[8][10] = int_stack + 20340;
 Libint->vrr_classes[8][11] = int_stack + 23310;
 Libint->vrr_classes[8][12] = int_stack + 26820;
 Libint->vrr_classes[8][13] = int_stack + 30915;
 Libint->vrr_classes[9][8] = int_stack + 35640;
 Libint->vrr_classes[9][9] = int_stack + 38115;
 Libint->vrr_classes[9][10] = int_stack + 41140;
 Libint->vrr_classes[9][11] = int_stack + 44770;
 Libint->vrr_classes[9][12] = int_stack + 49060;
 Libint->vrr_classes[9][13] = int_stack + 54065;
 Libint->vrr_classes[10][8] = int_stack + 59840;
 Libint->vrr_classes[10][9] = int_stack + 62810;
 Libint->vrr_classes[10][10] = int_stack + 66440;
 Libint->vrr_classes[10][11] = int_stack + 70796;
 Libint->vrr_classes[10][12] = int_stack + 75944;
 Libint->vrr_classes[10][13] = int_stack + 81950;
 Libint->vrr_classes[11][8] = int_stack + 88880;
 Libint->vrr_classes[11][9] = int_stack + 92390;
 Libint->vrr_classes[11][10] = int_stack + 96680;
 Libint->vrr_classes[11][11] = int_stack + 101828;
 Libint->vrr_classes[11][12] = int_stack + 107912;
 Libint->vrr_classes[11][13] = int_stack + 115010;
 memset(int_stack,0,123200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 123200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kglh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123200,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+128060,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+134000,int_stack+128060,int_stack+123200,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+143720,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+150848,int_stack+143720,int_stack+128060,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+162728,int_stack+150848,int_stack+134000,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123200,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+178928,int_stack+123200,int_stack+143720,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+193184,int_stack+178928,int_stack+150848,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+131624,int_stack+193184,int_stack+162728,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+155924,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+212984,int_stack+155924,int_stack+123200,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+229832,int_stack+212984,int_stack+178928,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+155924,int_stack+229832,int_stack+193184,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+185624,int_stack+155924,int_stack+131624,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123200,int_stack+17865,int_stack+15840,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+129275,int_stack+20340,int_stack+17865,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+136700,int_stack+129275,int_stack+123200,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+148850,int_stack+23310,int_stack+20340,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+157760,int_stack+148850,int_stack+129275,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+219644,int_stack+157760,int_stack+136700,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123200,int_stack+26820,int_stack+23310,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+123200,int_stack+148850,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+239894,int_stack+0,int_stack+157760,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+133730,int_stack+239894,int_stack+219644,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+219644,int_stack+30915,int_stack+26820,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+164105,int_stack+219644,int_stack+123200,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+264644,int_stack+164105,int_stack+0,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+294344,int_stack+264644,int_stack+239894,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+219644,int_stack+294344,int_stack+133730,45);
 /*--- compute (kp|lh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+262169,int_stack+219644,int_stack+185624,945);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+38115,int_stack+35640,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+41140,int_stack+38115,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123200,int_stack+44770,int_stack+41140,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+134090,int_stack+123200,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+152240,int_stack+134090,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+49060,int_stack+44770,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12870,int_stack+0,int_stack+123200,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+176990,int_stack+12870,int_stack+134090,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+364229,int_stack+176990,int_stack+152240,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+123200,int_stack+54065,int_stack+49060,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138215,int_stack+123200,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+401354,int_stack+138215,int_stack+12870,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+401354,int_stack+176990,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+123200,int_stack+0,int_stack+364229,55);
 /*--- compute (lp|lh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+364229,int_stack+123200,int_stack+219644,945);
 /*--- compute (kd|lh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+491804,int_stack+364229,int_stack+262169,945);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+62810,int_stack+59840,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+66440,int_stack+62810,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+70796,int_stack+66440,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+175175,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+196955,int_stack+175175,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+75944,int_stack+70796,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+226655,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+15444,int_stack+226655,int_stack+175175,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+252791,int_stack+15444,int_stack+196955,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+175175,int_stack+81950,int_stack+75944,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+193193,int_stack+175175,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+297341,int_stack+193193,int_stack+226655,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+175175,int_stack+297341,int_stack+15444,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+297341,int_stack+175175,int_stack+252791,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+695924,int_stack+297341,int_stack+123200,945);
 /*--- compute (ld|lh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+851849,int_stack+695924,int_stack+364229,945);
 /*--- compute (kf|lh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1106999,int_stack+851849,int_stack+491804,945);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123200,int_stack+92390,int_stack+88880,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+133730,int_stack+96680,int_stack+92390,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+146600,int_stack+133730,int_stack+123200,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+167660,int_stack+101828,int_stack+96680,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+183104,int_stack+167660,int_stack+133730,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+208844,int_stack+183104,int_stack+146600,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123200,int_stack+107912,int_stack+101828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+243944,int_stack+123200,int_stack+167660,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+359711,int_stack+243944,int_stack+183104,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+141452,int_stack+359711,int_stack+208844,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+194102,int_stack+115010,int_stack+107912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+402611,int_stack+194102,int_stack+123200,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+439115,int_stack+402611,int_stack+243944,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+194102,int_stack+439115,int_stack+359711,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+359711,int_stack+194102,int_stack+141452,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+433421,int_stack+359711,int_stack+297341,945);
 /*--- compute (md|lh) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+433421,int_stack+695924,945);
 /*--- compute (lf|lh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+311850,int_stack+0,int_stack+851849,945);
 /*--- compute (kg|lh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1447199,int_stack+311850,int_stack+1106999,945);
 return int_stack+1447199;}
