/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgmh(Libint_t*, prim_data*);

  /* Computes quartets of (kg|mh) integrals */

REALTYPE *hrr_order_kgmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[8][9] = int_stack + 18540;
 Libint->vrr_classes[8][10] = int_stack + 21015;
 Libint->vrr_classes[8][11] = int_stack + 23985;
 Libint->vrr_classes[8][12] = int_stack + 27495;
 Libint->vrr_classes[8][13] = int_stack + 31590;
 Libint->vrr_classes[8][14] = int_stack + 36315;
 Libint->vrr_classes[9][9] = int_stack + 41715;
 Libint->vrr_classes[9][10] = int_stack + 44740;
 Libint->vrr_classes[9][11] = int_stack + 48370;
 Libint->vrr_classes[9][12] = int_stack + 52660;
 Libint->vrr_classes[9][13] = int_stack + 57665;
 Libint->vrr_classes[9][14] = int_stack + 63440;
 Libint->vrr_classes[10][9] = int_stack + 70040;
 Libint->vrr_classes[10][10] = int_stack + 73670;
 Libint->vrr_classes[10][11] = int_stack + 78026;
 Libint->vrr_classes[10][12] = int_stack + 83174;
 Libint->vrr_classes[10][13] = int_stack + 89180;
 Libint->vrr_classes[10][14] = int_stack + 96110;
 Libint->vrr_classes[11][9] = int_stack + 104030;
 Libint->vrr_classes[11][10] = int_stack + 108320;
 Libint->vrr_classes[11][11] = int_stack + 113468;
 Libint->vrr_classes[11][12] = int_stack + 119552;
 Libint->vrr_classes[11][13] = int_stack + 126650;
 Libint->vrr_classes[11][14] = int_stack + 134840;
 memset(int_stack,0,144200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 144200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgmh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+144200,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+150140,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+157268,int_stack+150140,int_stack+144200,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+169148,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177572,int_stack+169148,int_stack+150140,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+191828,int_stack+177572,int_stack+157268,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144200,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+211628,int_stack+144200,int_stack+169148,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+228476,int_stack+211628,int_stack+177572,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+154028,int_stack+228476,int_stack+191828,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+183728,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+252236,int_stack+183728,int_stack+144200,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+271892,int_stack+252236,int_stack+211628,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+183728,int_stack+271892,int_stack+228476,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+219368,int_stack+183728,int_stack+154028,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+144200,int_stack+21015,int_stack+18540,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+151625,int_stack+23985,int_stack+21015,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+160535,int_stack+151625,int_stack+144200,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+175385,int_stack+27495,int_stack+23985,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+185915,int_stack+175385,int_stack+151625,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+260948,int_stack+185915,int_stack+160535,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144200,int_stack+31590,int_stack+27495,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+144200,int_stack+175385,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+285698,int_stack+0,int_stack+185915,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+156485,int_stack+285698,int_stack+260948,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+260948,int_stack+36315,int_stack+31590,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+193610,int_stack+260948,int_stack+144200,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+315398,int_stack+193610,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+350498,int_stack+315398,int_stack+285698,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+260948,int_stack+350498,int_stack+156485,45);
 /*--- compute (kp|mh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+312923,int_stack+260948,int_stack+219368,1155);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+44740,int_stack+41715,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+48370,int_stack+44740,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+144200,int_stack+52660,int_stack+48370,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+157070,int_stack+144200,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+178850,int_stack+157070,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+57665,int_stack+52660,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15015,int_stack+0,int_stack+144200,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+209100,int_stack+15015,int_stack+157070,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+437663,int_stack+209100,int_stack+178850,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+144200,int_stack+63440,int_stack+57665,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+161525,int_stack+144200,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+483038,int_stack+161525,int_stack+15015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+483038,int_stack+209100,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+144200,int_stack+0,int_stack+437663,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+437663,int_stack+144200,int_stack+260948,1155);
 /*--- compute (kd|mh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+593588,int_stack+437663,int_stack+312923,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+73670,int_stack+70040,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+78026,int_stack+73670,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+45738,int_stack+83174,int_stack+78026,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+207725,int_stack+45738,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233861,int_stack+207725,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+89180,int_stack+83174,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+270161,int_stack+0,int_stack+45738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18018,int_stack+270161,int_stack+207725,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+301049,int_stack+18018,int_stack+233861,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+207725,int_stack+96110,int_stack+89180,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+228515,int_stack+207725,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+355499,int_stack+228515,int_stack+270161,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+207725,int_stack+355499,int_stack+18018,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+355499,int_stack+207725,int_stack+301049,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+843068,int_stack+355499,int_stack+144200,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1033643,int_stack+843068,int_stack+437663,1155);
 /*--- compute (kf|mh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1345493,int_stack+1033643,int_stack+593588,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+144200,int_stack+108320,int_stack+104030,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+157070,int_stack+113468,int_stack+108320,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172514,int_stack+157070,int_stack+144200,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+198254,int_stack+119552,int_stack+113468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+216506,int_stack+198254,int_stack+157070,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+247394,int_stack+216506,int_stack+172514,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144200,int_stack+126650,int_stack+119552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+290294,int_stack+144200,int_stack+198254,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+431729,int_stack+290294,int_stack+216506,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+165494,int_stack+431729,int_stack+247394,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+229844,int_stack+134840,int_stack+126650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+483209,int_stack+229844,int_stack+144200,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+525797,int_stack+483209,int_stack+290294,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+229844,int_stack+525797,int_stack+431729,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+431729,int_stack+229844,int_stack+165494,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+521819,int_stack+431729,int_stack+355499,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+521819,int_stack+843068,1155);
 /*--- compute (lf|mh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+381150,int_stack+0,int_stack+1033643,1155);
 /*--- compute (kg|mh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1761293,int_stack+381150,int_stack+1345493,1155);
 return int_stack+1761293;}
