/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khkh(Libint_t*, prim_data*);

  /* Computes quartets of (kh|kh) integrals */

REALTYPE *hrr_order_khkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[8][7] = int_stack + 13356;
 Libint->vrr_classes[8][8] = int_stack + 14976;
 Libint->vrr_classes[8][9] = int_stack + 17001;
 Libint->vrr_classes[8][10] = int_stack + 19476;
 Libint->vrr_classes[8][11] = int_stack + 22446;
 Libint->vrr_classes[8][12] = int_stack + 25956;
 Libint->vrr_classes[9][7] = int_stack + 30051;
 Libint->vrr_classes[9][8] = int_stack + 32031;
 Libint->vrr_classes[9][9] = int_stack + 34506;
 Libint->vrr_classes[9][10] = int_stack + 37531;
 Libint->vrr_classes[9][11] = int_stack + 41161;
 Libint->vrr_classes[9][12] = int_stack + 45451;
 Libint->vrr_classes[10][7] = int_stack + 50456;
 Libint->vrr_classes[10][8] = int_stack + 52832;
 Libint->vrr_classes[10][9] = int_stack + 55802;
 Libint->vrr_classes[10][10] = int_stack + 59432;
 Libint->vrr_classes[10][11] = int_stack + 63788;
 Libint->vrr_classes[10][12] = int_stack + 68936;
 Libint->vrr_classes[11][7] = int_stack + 74942;
 Libint->vrr_classes[11][8] = int_stack + 77750;
 Libint->vrr_classes[11][9] = int_stack + 81260;
 Libint->vrr_classes[11][10] = int_stack + 85550;
 Libint->vrr_classes[11][11] = int_stack + 90698;
 Libint->vrr_classes[11][12] = int_stack + 96782;
 Libint->vrr_classes[12][7] = int_stack + 103880;
 Libint->vrr_classes[12][8] = int_stack + 107156;
 Libint->vrr_classes[12][9] = int_stack + 111251;
 Libint->vrr_classes[12][10] = int_stack + 116256;
 Libint->vrr_classes[12][11] = int_stack + 122262;
 Libint->vrr_classes[12][12] = int_stack + 129360;
 memset(int_stack,0,137641*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 137641;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khkh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+137641,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+141529,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+146389,int_stack+141529,int_stack+137641,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+154165,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+160105,int_stack+154165,int_stack+141529,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+169825,int_stack+160105,int_stack+146389,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137641,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+182785,int_stack+137641,int_stack+154165,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+194665,int_stack+182785,int_stack+160105,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+144769,int_stack+194665,int_stack+169825,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+164209,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210865,int_stack+164209,int_stack+137641,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+225121,int_stack+210865,int_stack+182785,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+164209,int_stack+225121,int_stack+194665,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+188509,int_stack+164209,int_stack+144769,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+137641,int_stack+14976,int_stack+13356,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+142501,int_stack+17001,int_stack+14976,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+148576,int_stack+142501,int_stack+137641,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158296,int_stack+19476,int_stack+17001,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+165721,int_stack+158296,int_stack+142501,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+215725,int_stack+165721,int_stack+148576,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137641,int_stack+22446,int_stack+19476,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+137641,int_stack+158296,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+231925,int_stack+0,int_stack+165721,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+146551,int_stack+231925,int_stack+215725,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+215725,int_stack+25956,int_stack+22446,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+252175,int_stack+215725,int_stack+137641,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+269995,int_stack+252175,int_stack+0,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+294745,int_stack+269995,int_stack+231925,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+215725,int_stack+294745,int_stack+146551,45);
 /*--- compute (kp|kh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+249745,int_stack+215725,int_stack+188509,756);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+32031,int_stack+30051,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+5940,int_stack+34506,int_stack+32031,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13365,int_stack+5940,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25245,int_stack+37531,int_stack+34506,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+137641,int_stack+25245,int_stack+5940,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+152491,int_stack+137641,int_stack+13365,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+41161,int_stack+37531,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172291,int_stack+0,int_stack+25245,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+10890,int_stack+172291,int_stack+137641,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+331393,int_stack+10890,int_stack+152491,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+137641,int_stack+45451,int_stack+41161,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+150511,int_stack+137641,int_stack+0,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+361093,int_stack+150511,int_stack+172291,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+137641,int_stack+361093,int_stack+10890,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+137641,int_stack+331393,55);
 /*--- compute (lp|kh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+331393,int_stack+0,int_stack+215725,756);
 /*--- compute (kd|kh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+433453,int_stack+331393,int_stack+249745,756);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+137641,int_stack+52832,int_stack+50456,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+144769,int_stack+55802,int_stack+52832,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+153679,int_stack+144769,int_stack+137641,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+167935,int_stack+59432,int_stack+55802,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+178825,int_stack+167935,int_stack+144769,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+196645,int_stack+178825,int_stack+153679,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137641,int_stack+63788,int_stack+59432,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+220405,int_stack+137641,int_stack+167935,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+242185,int_stack+220405,int_stack+178825,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+150709,int_stack+242185,int_stack+196645,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+186349,int_stack+68936,int_stack+63788,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+271885,int_stack+186349,int_stack+137641,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+596749,int_stack+271885,int_stack+220405,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+271885,int_stack+596749,int_stack+242185,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+186349,int_stack+271885,int_stack+150709,66);
 /*--- compute (mp|kh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+596749,int_stack+186349,int_stack+0,756);
 /*--- compute (ld|kh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+721489,int_stack+596749,int_stack+331393,756);
 /*--- compute (kf|kh) ---*/
 hrr1_build_kf(Libint->AB,int_stack+925609,int_stack+721489,int_stack+433453,756);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+77750,int_stack+74942,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8424,int_stack+81260,int_stack+77750,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18954,int_stack+8424,int_stack+0,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35802,int_stack+85550,int_stack+81260,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48672,int_stack+35802,int_stack+8424,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+137641,int_stack+48672,int_stack+18954,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+90698,int_stack+85550,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+236245,int_stack+0,int_stack+35802,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+261985,int_stack+236245,int_stack+48672,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+15444,int_stack+261985,int_stack+137641,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+137641,int_stack+96782,int_stack+90698,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+57564,int_stack+137641,int_stack+0,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+137641,int_stack+57564,int_stack+236245,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+297085,int_stack+137641,int_stack+261985,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+236245,int_stack+297085,int_stack+15444,78);
 /*--- compute (np|kh) ---*/
 hrr1_build_np(Libint->AB,int_stack+295213,int_stack+236245,int_stack+186349,756);
 /*--- compute (md|kh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1197769,int_stack+295213,int_stack+596749,756);
 /*--- compute (lf|kh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1447249,int_stack+1197769,int_stack+721489,756);
 /*--- compute (kg|kh) ---*/
 hrr1_build_kg(Libint->AB,int_stack+444901,int_stack+1447249,int_stack+925609,756);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+137641,int_stack+107156,int_stack+103880,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+147469,int_stack+111251,int_stack+107156,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+159754,int_stack+147469,int_stack+137641,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+179410,int_stack+116256,int_stack+111251,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+194425,int_stack+179410,int_stack+147469,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+853141,int_stack+194425,int_stack+159754,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137641,int_stack+122262,int_stack+116256,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+885901,int_stack+137641,int_stack+179410,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+915931,int_stack+885901,int_stack+194425,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+155659,int_stack+915931,int_stack+853141,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+853141,int_stack+129360,int_stack+122262,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+956881,int_stack+853141,int_stack+137641,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+992917,int_stack+956881,int_stack+885901,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+853141,int_stack+992917,int_stack+915931,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+914566,int_stack+853141,int_stack+155659,91);
 /*--- compute (op|kh) ---*/
 hrr1_build_op(Libint->AB,int_stack+983362,int_stack+914566,int_stack+236245,756);
 /*--- compute (nd|kh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1787449,int_stack+983362,int_stack+295213,756);
 /*--- compute (mf|kh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1787449,int_stack+1197769,756);
 /*--- compute (lg|kh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+853141,int_stack+0,int_stack+1447249,756);
 /*--- compute (kh|kh) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1363441,int_stack+853141,int_stack+444901,756);
 return int_stack+1363441;}
