/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kiki(Libint_t*, prim_data*);

  /* Computes quartets of (ki|ki) integrals */

REALTYPE *hrr_order_kiki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[7][13] = int_stack + 13356;
 Libint->vrr_classes[8][7] = int_stack + 17136;
 Libint->vrr_classes[8][8] = int_stack + 18756;
 Libint->vrr_classes[8][9] = int_stack + 20781;
 Libint->vrr_classes[8][10] = int_stack + 23256;
 Libint->vrr_classes[8][11] = int_stack + 26226;
 Libint->vrr_classes[8][12] = int_stack + 29736;
 Libint->vrr_classes[8][13] = int_stack + 33831;
 Libint->vrr_classes[9][7] = int_stack + 38556;
 Libint->vrr_classes[9][8] = int_stack + 40536;
 Libint->vrr_classes[9][9] = int_stack + 43011;
 Libint->vrr_classes[9][10] = int_stack + 46036;
 Libint->vrr_classes[9][11] = int_stack + 49666;
 Libint->vrr_classes[9][12] = int_stack + 53956;
 Libint->vrr_classes[9][13] = int_stack + 58961;
 Libint->vrr_classes[10][7] = int_stack + 64736;
 Libint->vrr_classes[10][8] = int_stack + 67112;
 Libint->vrr_classes[10][9] = int_stack + 70082;
 Libint->vrr_classes[10][10] = int_stack + 73712;
 Libint->vrr_classes[10][11] = int_stack + 78068;
 Libint->vrr_classes[10][12] = int_stack + 83216;
 Libint->vrr_classes[10][13] = int_stack + 89222;
 Libint->vrr_classes[11][7] = int_stack + 96152;
 Libint->vrr_classes[11][8] = int_stack + 98960;
 Libint->vrr_classes[11][9] = int_stack + 102470;
 Libint->vrr_classes[11][10] = int_stack + 106760;
 Libint->vrr_classes[11][11] = int_stack + 111908;
 Libint->vrr_classes[11][12] = int_stack + 117992;
 Libint->vrr_classes[11][13] = int_stack + 125090;
 Libint->vrr_classes[12][7] = int_stack + 133280;
 Libint->vrr_classes[12][8] = int_stack + 136556;
 Libint->vrr_classes[12][9] = int_stack + 140651;
 Libint->vrr_classes[12][10] = int_stack + 145656;
 Libint->vrr_classes[12][11] = int_stack + 151662;
 Libint->vrr_classes[12][12] = int_stack + 158760;
 Libint->vrr_classes[12][13] = int_stack + 167041;
 Libint->vrr_classes[13][7] = int_stack + 176596;
 Libint->vrr_classes[13][8] = int_stack + 180376;
 Libint->vrr_classes[13][9] = int_stack + 185101;
 Libint->vrr_classes[13][10] = int_stack + 190876;
 Libint->vrr_classes[13][11] = int_stack + 197806;
 Libint->vrr_classes[13][12] = int_stack + 205996;
 Libint->vrr_classes[13][13] = int_stack + 215551;
 memset(int_stack,0,226576*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 226576;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kiki(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+226576,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+230464,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+235324,int_stack+230464,int_stack+226576,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+243100,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+249040,int_stack+243100,int_stack+230464,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+258760,int_stack+249040,int_stack+235324,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+226576,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+271720,int_stack+226576,int_stack+243100,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+283600,int_stack+271720,int_stack+249040,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+233704,int_stack+283600,int_stack+258760,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+253144,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+299800,int_stack+253144,int_stack+226576,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+314056,int_stack+299800,int_stack+271720,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+333856,int_stack+314056,int_stack+283600,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+261568,int_stack+333856,int_stack+233704,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226576,int_stack+13356,int_stack+10080,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+226576,int_stack+253144,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+226576,int_stack+0,int_stack+299800,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+358156,int_stack+226576,int_stack+314056,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+226576,int_stack+358156,int_stack+333856,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+288784,int_stack+226576,int_stack+261568,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+226576,int_stack+18756,int_stack+17136,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+231436,int_stack+20781,int_stack+18756,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+237511,int_stack+231436,int_stack+226576,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+247231,int_stack+23256,int_stack+20781,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+254656,int_stack+247231,int_stack+231436,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+266806,int_stack+254656,int_stack+237511,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+226576,int_stack+26226,int_stack+23256,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+226576,int_stack+247231,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+325072,int_stack+0,int_stack+254656,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+235486,int_stack+325072,int_stack+266806,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+259786,int_stack+29736,int_stack+26226,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+270316,int_stack+259786,int_stack+226576,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+345322,int_stack+270316,int_stack+0,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+370072,int_stack+345322,int_stack+325072,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+400447,int_stack+370072,int_stack+235486,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+325072,int_stack+33831,int_stack+29736,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+325072,int_stack+259786,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+226576,int_stack+0,int_stack+270316,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+226576,int_stack+345322,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+226576,int_stack+0,int_stack+370072,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+325072,int_stack+226576,int_stack+400447,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+370432,int_stack+325072,int_stack+288784,1008);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+226576,int_stack+40536,int_stack+38556,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+232516,int_stack+43011,int_stack+40536,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+239941,int_stack+232516,int_stack+226576,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+251821,int_stack+46036,int_stack+43011,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+260896,int_stack+251821,int_stack+232516,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+275746,int_stack+260896,int_stack+239941,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+226576,int_stack+49666,int_stack+46036,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+295546,int_stack+226576,int_stack+251821,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+295546,int_stack+260896,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+237466,int_stack+0,int_stack+275746,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+267166,int_stack+53956,int_stack+49666,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24750,int_stack+267166,int_stack+226576,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+479296,int_stack+24750,int_stack+295546,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+280036,int_stack+479296,int_stack+0,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+509546,int_stack+280036,int_stack+237466,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+58961,int_stack+53956,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+226576,int_stack+0,int_stack+267166,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+551126,int_stack+226576,int_stack+24750,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+226576,int_stack+551126,int_stack+479296,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+226576,int_stack+280036,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+226576,int_stack+0,int_stack+509546,55);
 /*--- compute (lp|ki) ---*/
 hrr1_build_lp(Libint->AB,int_stack+479296,int_stack+226576,int_stack+325072,1008);
 /*--- compute (kd|ki) ---*/
 hrr1_build_kd(Libint->AB,int_stack+615376,int_stack+479296,int_stack+370432,1008);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+67112,int_stack+64736,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+70082,int_stack+67112,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30294,int_stack+73712,int_stack+70082,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41184,int_stack+30294,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+282016,int_stack+41184,int_stack+16038,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+78068,int_stack+73712,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+305776,int_stack+0,int_stack+30294,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+327556,int_stack+305776,int_stack+41184,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13068,int_stack+327556,int_stack+282016,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+282016,int_stack+83216,int_stack+78068,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48708,int_stack+282016,int_stack+0,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+357256,int_stack+48708,int_stack+305776,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+393556,int_stack+357256,int_stack+327556,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+297460,int_stack+393556,int_stack+13068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+89222,int_stack+83216,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+438106,int_stack+0,int_stack+282016,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+438106,int_stack+48708,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+833104,int_stack+0,int_stack+357256,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+833104,int_stack+393556,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+347356,int_stack+0,int_stack+297460,66);
 /*--- compute (mp|ki) ---*/
 hrr1_build_mp(Libint->AB,int_stack+833104,int_stack+347356,int_stack+226576,1008);
 /*--- compute (ld|ki) ---*/
 hrr1_build_ld(Libint->AB,int_stack+999424,int_stack+833104,int_stack+479296,1008);
 /*--- compute (kf|ki) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1271584,int_stack+999424,int_stack+615376,1008);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+226576,int_stack+98960,int_stack+96152,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+235000,int_stack+102470,int_stack+98960,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+245530,int_stack+235000,int_stack+226576,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+262378,int_stack+106760,int_stack+102470,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+275248,int_stack+262378,int_stack+235000,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+296308,int_stack+275248,int_stack+245530,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+226576,int_stack+111908,int_stack+106760,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+226576,int_stack+262378,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+25740,int_stack+0,int_stack+275248,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+242020,int_stack+25740,int_stack+296308,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+284140,int_stack+117992,int_stack+111908,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+302392,int_stack+284140,int_stack+226576,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+60840,int_stack+302392,int_stack+0,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+413884,int_stack+60840,int_stack+25740,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+413884,int_stack+242020,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226576,int_stack+125090,int_stack+117992,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+466534,int_stack+226576,int_stack+284140,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+226576,int_stack+466534,int_stack+302392,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+466534,int_stack+226576,int_stack+60840,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+226576,int_stack+466534,int_stack+413884,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+413884,int_stack+226576,int_stack+0,78);
 /*--- compute (np|ki) ---*/
 hrr1_build_np(Libint->AB,int_stack+492508,int_stack+413884,int_stack+347356,1008);
 /*--- compute (md|ki) ---*/
 hrr1_build_md(Libint->AB,int_stack+1634464,int_stack+492508,int_stack+833104,1008);
 /*--- compute (lf|ki) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1967104,int_stack+1634464,int_stack+999424,1008);
 /*--- compute (kg|ki) ---*/
 hrr1_build_kg(Libint->AB,int_stack+692092,int_stack+1967104,int_stack+1271584,1008);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+136556,int_stack+133280,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9828,int_stack+140651,int_stack+136556,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22113,int_stack+9828,int_stack+0,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41769,int_stack+145656,int_stack+140651,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56784,int_stack+41769,int_stack+9828,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+81354,int_stack+56784,int_stack+22113,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+151662,int_stack+145656,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114114,int_stack+0,int_stack+41769,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+226576,int_stack+114114,int_stack+56784,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18018,int_stack+226576,int_stack+81354,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67158,int_stack+158760,int_stack+151662,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+267526,int_stack+67158,int_stack+0,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+303562,int_stack+267526,int_stack+114114,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+88452,int_stack+303562,int_stack+226576,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+1236412,int_stack+88452,int_stack+18018,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226576,int_stack+167041,int_stack+158760,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+226576,int_stack+67158,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+353612,int_stack+0,int_stack+267526,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+353612,int_stack+303562,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+226576,int_stack+0,int_stack+88452,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+226576,int_stack+1236412,91);
 /*--- compute (op|ki) ---*/
 hrr1_build_op(Libint->AB,int_stack+1236412,int_stack+0,int_stack+413884,1008);
 /*--- compute (nd|ki) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2420704,int_stack+1236412,int_stack+492508,1008);
 /*--- compute (mf|ki) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2819872,int_stack+2420704,int_stack+1634464,1008);
 /*--- compute (lg|ki) ---*/
 hrr1_build_lg(Libint->AB,int_stack+3374272,int_stack+2819872,int_stack+1967104,1008);
 /*--- compute (kh|ki) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1472284,int_stack+3374272,int_stack+692092,1008);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2234332,int_stack+180376,int_stack+176596,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2245672,int_stack+185101,int_stack+180376,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+2259847,int_stack+2245672,int_stack+2234332,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2282527,int_stack+190876,int_stack+185101,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2299852,int_stack+2282527,int_stack+2245672,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+2328202,int_stack+2299852,int_stack+2259847,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2234332,int_stack+197806,int_stack+190876,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2366002,int_stack+2234332,int_stack+2282527,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+226576,int_stack+2366002,int_stack+2299852,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+2255122,int_stack+226576,int_stack+2328202,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2311822,int_stack+205996,int_stack+197806,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+273826,int_stack+2311822,int_stack+2234332,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+315406,int_stack+273826,int_stack+2366002,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2336392,int_stack+315406,int_stack+226576,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+373156,int_stack+2336392,int_stack+2255122,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+226576,int_stack+215551,int_stack+205996,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2234332,int_stack+226576,int_stack+2311822,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+452536,int_stack+2234332,int_stack+273826,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2234332,int_stack+452536,int_stack+315406,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+452536,int_stack+2234332,int_stack+2336392,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+2234332,int_stack+452536,int_stack+373156,105);
 /*--- compute (qp|ki) ---*/
 hrr1_build_qp(Libint->AB,int_stack+91728,int_stack+2234332,int_stack+0,1008);
 /*--- compute (od|ki) ---*/
 hrr1_build_od(Libint->AB,int_stack+366912,int_stack+91728,int_stack+1236412,1008);
 /*--- compute (nf|ki) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4054672,int_stack+366912,int_stack+2420704,1008);
 /*--- compute (mg|ki) ---*/
 hrr1_build_mg(Libint->AB,int_stack+0,int_stack+4054672,int_stack+2819872,1008);
 /*--- compute (lh|ki) ---*/
 hrr1_build_lh(Libint->AB,int_stack+2234332,int_stack+0,int_stack+3374272,1008);
 /*--- compute (ki|ki) ---*/
 hrr1_build_ki(Libint->AB,int_stack+0,int_stack+2234332,int_stack+1472284,1008);
 return int_stack+0;}
