/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kinf(Libint_t*, prim_data*);

  /* Computes quartets of (ki|nf) integrals */

REALTYPE *hrr_order_kinf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[8][10] = int_stack + 12240;
 Libint->vrr_classes[8][11] = int_stack + 15210;
 Libint->vrr_classes[8][12] = int_stack + 18720;
 Libint->vrr_classes[8][13] = int_stack + 22815;
 Libint->vrr_classes[9][10] = int_stack + 27540;
 Libint->vrr_classes[9][11] = int_stack + 31170;
 Libint->vrr_classes[9][12] = int_stack + 35460;
 Libint->vrr_classes[9][13] = int_stack + 40465;
 Libint->vrr_classes[10][10] = int_stack + 46240;
 Libint->vrr_classes[10][11] = int_stack + 50596;
 Libint->vrr_classes[10][12] = int_stack + 55744;
 Libint->vrr_classes[10][13] = int_stack + 61750;
 Libint->vrr_classes[11][10] = int_stack + 68680;
 Libint->vrr_classes[11][11] = int_stack + 73828;
 Libint->vrr_classes[11][12] = int_stack + 79912;
 Libint->vrr_classes[11][13] = int_stack + 87010;
 Libint->vrr_classes[12][10] = int_stack + 95200;
 Libint->vrr_classes[12][11] = int_stack + 101206;
 Libint->vrr_classes[12][12] = int_stack + 108304;
 Libint->vrr_classes[12][13] = int_stack + 116585;
 Libint->vrr_classes[13][10] = int_stack + 126140;
 Libint->vrr_classes[13][11] = int_stack + 133070;
 Libint->vrr_classes[13][12] = int_stack + 141260;
 Libint->vrr_classes[13][13] = int_stack + 150815;
 memset(int_stack,0,161840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 161840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kinf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+168968,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+177392,int_stack+168968,int_stack+161840,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+191648,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+201476,int_stack+191648,int_stack+168968,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+218324,int_stack+201476,int_stack+177392,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+15210,int_stack+12240,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+170750,int_stack+18720,int_stack+15210,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+181280,int_stack+170750,int_stack+161840,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+199100,int_stack+22815,int_stack+18720,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+199100,int_stack+170750,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+242084,int_stack+0,int_stack+181280,45);
 /*--- compute (kp|nf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+271784,int_stack+242084,int_stack+218324,660);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+31170,int_stack+27540,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+35460,int_stack+31170,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+161840,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+183620,int_stack+40465,int_stack+35460,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+198635,int_stack+183620,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+198635,int_stack+161840,55);
 /*--- compute (lp|nf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+343064,int_stack+0,int_stack+242084,660);
 /*--- compute (kd|nf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+432164,int_stack+343064,int_stack+271784,660);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+50596,int_stack+46240,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+174908,int_stack+55744,int_stack+50596,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+190352,int_stack+174908,int_stack+161840,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+216488,int_stack+61750,int_stack+55744,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+234506,int_stack+216488,int_stack+174908,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+265394,int_stack+234506,int_stack+190352,66);
 /*--- compute (mp|nf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+574724,int_stack+265394,int_stack+0,660);
 /*--- compute (ld|nf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+683624,int_stack+574724,int_stack+343064,660);
 /*--- compute (kf|nf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+861824,int_stack+683624,int_stack+432164,660);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+73828,int_stack+68680,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+79912,int_stack+73828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161840,int_stack+87010,int_stack+79912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+183134,int_stack+161840,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+308954,int_stack+183134,int_stack+33696,78);
 /*--- compute (np|nf) ---*/
 hrr1_build_np(Libint->AB,int_stack+360434,int_stack+308954,int_stack+265394,660);
 /*--- compute (md|nf) ---*/
 hrr1_build_md(Libint->AB,int_stack+1099424,int_stack+360434,int_stack+574724,660);
 /*--- compute (lf|nf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1317224,int_stack+1099424,int_stack+683624,660);
 /*--- compute (kg|nf) ---*/
 hrr1_build_kg(Libint->AB,int_stack+491114,int_stack+1317224,int_stack+861824,660);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+101206,int_stack+95200,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+179858,int_stack+108304,int_stack+101206,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+201152,int_stack+179858,int_stack+161840,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237188,int_stack+116585,int_stack+108304,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+262031,int_stack+237188,int_stack+179858,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+262031,int_stack+201152,91);
 /*--- compute (op|nf) ---*/
 hrr1_build_op(Libint->AB,int_stack+847514,int_stack+0,int_stack+308954,660);
 /*--- compute (nd|nf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1614224,int_stack+847514,int_stack+360434,660);
 /*--- compute (mf|nf) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1875584,int_stack+1614224,int_stack+1099424,660);
 /*--- compute (lg|nf) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2238584,int_stack+1875584,int_stack+1317224,660);
 /*--- compute (kh|nf) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1001954,int_stack+2238584,int_stack+491114,660);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+133070,int_stack+126140,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+182630,int_stack+141260,int_stack+133070,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+207200,int_stack+182630,int_stack+161840,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+248780,int_stack+150815,int_stack+141260,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+277445,int_stack+248780,int_stack+182630,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+326585,int_stack+277445,int_stack+207200,105);
 /*--- compute (qp|nf) ---*/
 hrr1_build_qp(Libint->AB,int_stack+395885,int_stack+326585,int_stack+0,660);
 /*--- compute (od|nf) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+395885,int_stack+847514,660);
 /*--- compute (nf|nf) ---*/
 hrr1_build_nf(Libint->AB,int_stack+308880,int_stack+0,int_stack+1614224,660);
 /*--- compute (mg|nf) ---*/
 hrr1_build_mg(Libint->AB,int_stack+2684084,int_stack+308880,int_stack+1875584,660);
 /*--- compute (lh|nf) ---*/
 hrr1_build_lh(Libint->AB,int_stack+0,int_stack+2684084,int_stack+2238584,660);
 /*--- compute (ki|nf) ---*/
 hrr1_build_ki(Libint->AB,int_stack+1500914,int_stack+0,int_stack+1001954,660);
 return int_stack+1500914;}
