/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_l0gg(Libint_t*, prim_data*);

  /* Computes quartets of (l0|gg) integrals */

REALTYPE *hrr_order_l0gg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][4] = int_stack + 0;
 Libint->vrr_classes[8][5] = int_stack + 675;
 Libint->vrr_classes[8][6] = int_stack + 1620;
 Libint->vrr_classes[8][7] = int_stack + 2880;
 Libint->vrr_classes[8][8] = int_stack + 4500;
 memset(int_stack,0,6525*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6525;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_l0gg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+6525,int_stack+675,int_stack+0,45);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+8550,int_stack+1620,int_stack+675,45);
 /*--- compute (l0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+11385,int_stack+8550,int_stack+6525,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+15435,int_stack+2880,int_stack+1620,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+19215,int_stack+15435,int_stack+8550,45);
 /*--- compute (l0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+24885,int_stack+19215,int_stack+11385,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+6525,int_stack+4500,int_stack+2880,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+31635,int_stack+6525,int_stack+15435,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+0,int_stack+31635,int_stack+19215,45);
 /*--- compute (l0|gg) ---*/
 hrr3_build_gg(Libint->CD,int_stack+9450,int_stack+0,int_stack+24885,45);
 return int_stack+9450;}
