/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldlh(Libint_t*, prim_data*);

  /* Computes quartets of (ld|lh) integrals */

REALTYPE *hrr_order_ldlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[8][13] = int_stack + 15075;
 Libint->vrr_classes[9][8] = int_stack + 19800;
 Libint->vrr_classes[9][9] = int_stack + 22275;
 Libint->vrr_classes[9][10] = int_stack + 25300;
 Libint->vrr_classes[9][11] = int_stack + 28930;
 Libint->vrr_classes[9][12] = int_stack + 33220;
 Libint->vrr_classes[9][13] = int_stack + 38225;
 Libint->vrr_classes[10][8] = int_stack + 44000;
 Libint->vrr_classes[10][9] = int_stack + 46970;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 memset(int_stack,0,73040*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 73040;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldlh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+73040,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+79115,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+86540,int_stack+79115,int_stack+73040,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98690,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+107600,int_stack+98690,int_stack+79115,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+122450,int_stack+107600,int_stack+86540,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73040,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+142700,int_stack+73040,int_stack+98690,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+160520,int_stack+142700,int_stack+107600,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+83570,int_stack+160520,int_stack+122450,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+113945,int_stack+15075,int_stack+10980,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+185270,int_stack+113945,int_stack+73040,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+206330,int_stack+185270,int_stack+142700,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+113945,int_stack+206330,int_stack+160520,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+151070,int_stack+113945,int_stack+83570,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+73040,int_stack+22275,int_stack+19800,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+80465,int_stack+25300,int_stack+22275,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+89540,int_stack+80465,int_stack+73040,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+104390,int_stack+28930,int_stack+25300,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+115280,int_stack+104390,int_stack+80465,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+193595,int_stack+115280,int_stack+89540,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73040,int_stack+33220,int_stack+28930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+73040,int_stack+104390,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+218345,int_stack+0,int_stack+115280,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+85910,int_stack+218345,int_stack+193595,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+193595,int_stack+38225,int_stack+33220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+123035,int_stack+193595,int_stack+73040,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+248595,int_stack+123035,int_stack+0,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+284895,int_stack+248595,int_stack+218345,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+193595,int_stack+284895,int_stack+85910,55);
 /*--- compute (lp|lh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+245570,int_stack+193595,int_stack+151070,945);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+46970,int_stack+44000,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+50600,int_stack+46970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+73040,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+86108,int_stack+73040,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107888,int_stack+86108,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+15444,int_stack+0,int_stack+73040,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+137588,int_stack+15444,int_stack+86108,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+373145,int_stack+137588,int_stack+107888,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+73040,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+91058,int_stack+73040,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+41580,int_stack+91058,int_stack+15444,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+417695,int_stack+41580,int_stack+137588,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+417695,int_stack+373145,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+373145,int_stack+0,int_stack+193595,945);
 /*--- compute (ld|lh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+529070,int_stack+373145,int_stack+245570,945);
 return int_stack+529070;}
