/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhmg(Libint_t*, prim_data*);

  /* Computes quartets of (lh|mg) integrals */

REALTYPE *hrr_order_lhmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[9][9] = int_stack + 17775;
 Libint->vrr_classes[9][10] = int_stack + 20800;
 Libint->vrr_classes[9][11] = int_stack + 24430;
 Libint->vrr_classes[9][12] = int_stack + 28720;
 Libint->vrr_classes[9][13] = int_stack + 33725;
 Libint->vrr_classes[10][9] = int_stack + 39500;
 Libint->vrr_classes[10][10] = int_stack + 43130;
 Libint->vrr_classes[10][11] = int_stack + 47486;
 Libint->vrr_classes[10][12] = int_stack + 52634;
 Libint->vrr_classes[10][13] = int_stack + 58640;
 Libint->vrr_classes[11][9] = int_stack + 65570;
 Libint->vrr_classes[11][10] = int_stack + 69860;
 Libint->vrr_classes[11][11] = int_stack + 75008;
 Libint->vrr_classes[11][12] = int_stack + 81092;
 Libint->vrr_classes[11][13] = int_stack + 88190;
 Libint->vrr_classes[12][9] = int_stack + 96380;
 Libint->vrr_classes[12][10] = int_stack + 101385;
 Libint->vrr_classes[12][11] = int_stack + 107391;
 Libint->vrr_classes[12][12] = int_stack + 114489;
 Libint->vrr_classes[12][13] = int_stack + 122770;
 Libint->vrr_classes[13][9] = int_stack + 132325;
 Libint->vrr_classes[13][10] = int_stack + 138100;
 Libint->vrr_classes[13][11] = int_stack + 145030;
 Libint->vrr_classes[13][12] = int_stack + 153220;
 Libint->vrr_classes[13][13] = int_stack + 162775;
 memset(int_stack,0,173800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 173800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhmg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+173800,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181225,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+190135,int_stack+181225,int_stack+173800,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+204985,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+215515,int_stack+204985,int_stack+181225,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233335,int_stack+215515,int_stack+190135,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+258085,int_stack+173800,int_stack+204985,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+173800,int_stack+258085,int_stack+215515,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+258085,int_stack+173800,int_stack+233335,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+173800,int_stack+20800,int_stack+17775,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+182875,int_stack+24430,int_stack+20800,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+193765,int_stack+182875,int_stack+173800,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+211915,int_stack+28720,int_stack+24430,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+224785,int_stack+211915,int_stack+182875,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+295210,int_stack+224785,int_stack+193765,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+33725,int_stack+28720,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+173800,int_stack+211915,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+173800,int_stack+0,int_stack+224785,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+210100,int_stack+173800,int_stack+295210,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+295210,int_stack+210100,int_stack+258085,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+173800,int_stack+43130,int_stack+39500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+184690,int_stack+47486,int_stack+43130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+184690,int_stack+173800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+21780,int_stack+52634,int_stack+47486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+255475,int_stack+21780,int_stack+184690,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+173800,int_stack+255475,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+58640,int_stack+52634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+406585,int_stack+0,int_stack+21780,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+406585,int_stack+255475,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+406585,int_stack+0,int_stack+173800,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+461035,int_stack+406585,int_stack+210100,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+597160,int_stack+461035,int_stack+295210,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+173800,int_stack+69860,int_stack+65570,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+186670,int_stack+75008,int_stack+69860,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+202114,int_stack+186670,int_stack+173800,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+227854,int_stack+81092,int_stack+75008,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+246106,int_stack+227854,int_stack+186670,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+276994,int_stack+246106,int_stack+202114,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+88190,int_stack+81092,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+319894,int_stack+173800,int_stack+227854,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+173800,int_stack+319894,int_stack+246106,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+319894,int_stack+173800,int_stack+276994,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+819910,int_stack+319894,int_stack+406585,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+983260,int_stack+819910,int_stack+461035,825);
 /*--- compute (lf|mg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1255510,int_stack+983260,int_stack+597160,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+173800,int_stack+101385,int_stack+96380,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+188815,int_stack+107391,int_stack+101385,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+206833,int_stack+188815,int_stack+173800,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+236863,int_stack+114489,int_stack+107391,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+258157,int_stack+236863,int_stack+188815,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+384244,int_stack+258157,int_stack+206833,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+122770,int_stack+114489,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+434294,int_stack+173800,int_stack+236863,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+173800,int_stack+434294,int_stack+258157,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+434294,int_stack+173800,int_stack+384244,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+509369,int_stack+434294,int_stack+319894,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1626760,int_stack+509369,int_stack+819910,825);
 /*--- compute (mf|mg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1953460,int_stack+1626760,int_stack+983260,825);
 /*--- compute (lg|mg) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2407210,int_stack+1953460,int_stack+1255510,825);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+173800,int_stack+138100,int_stack+132325,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+191125,int_stack+145030,int_stack+138100,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+211915,int_stack+191125,int_stack+173800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+246565,int_stack+153220,int_stack+145030,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+271135,int_stack+246565,int_stack+191125,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+312715,int_stack+271135,int_stack+211915,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+162775,int_stack+153220,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+370465,int_stack+173800,int_stack+246565,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+702419,int_stack+370465,int_stack+271135,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+771719,int_stack+702419,int_stack+312715,105);
 /*--- compute (qp|mg) ---*/
 hrr1_build_qp(Libint->AB,int_stack+858344,int_stack+771719,int_stack+434294,825);
 /*--- compute (od|mg) ---*/
 hrr1_build_od(Libint->AB,int_stack+1083569,int_stack+858344,int_stack+509369,825);
 /*--- compute (nf|mg) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+1083569,int_stack+1626760,825);
 /*--- compute (mg|mg) ---*/
 hrr1_build_mg(Libint->AB,int_stack+544500,int_stack+0,int_stack+1953460,825);
 /*--- compute (lh|mg) ---*/
 hrr1_build_lh(Libint->AB,int_stack+1225125,int_stack+544500,int_stack+2407210,825);
 return int_stack+1225125;}
