/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lkmm(Libint_t*, prim_data*);

  /* Computes quartets of (lk|mm) integrals */

REALTYPE *hrr_order_lkmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[8][18] = int_stack + 43875;
 Libint->vrr_classes[9][9] = int_stack + 52425;
 Libint->vrr_classes[9][10] = int_stack + 55450;
 Libint->vrr_classes[9][11] = int_stack + 59080;
 Libint->vrr_classes[9][12] = int_stack + 63370;
 Libint->vrr_classes[9][13] = int_stack + 68375;
 Libint->vrr_classes[9][14] = int_stack + 74150;
 Libint->vrr_classes[9][15] = int_stack + 80750;
 Libint->vrr_classes[9][16] = int_stack + 88230;
 Libint->vrr_classes[9][17] = int_stack + 96645;
 Libint->vrr_classes[9][18] = int_stack + 106050;
 Libint->vrr_classes[10][9] = int_stack + 116500;
 Libint->vrr_classes[10][10] = int_stack + 120130;
 Libint->vrr_classes[10][11] = int_stack + 124486;
 Libint->vrr_classes[10][12] = int_stack + 129634;
 Libint->vrr_classes[10][13] = int_stack + 135640;
 Libint->vrr_classes[10][14] = int_stack + 142570;
 Libint->vrr_classes[10][15] = int_stack + 150490;
 Libint->vrr_classes[10][16] = int_stack + 159466;
 Libint->vrr_classes[10][17] = int_stack + 169564;
 Libint->vrr_classes[10][18] = int_stack + 180850;
 Libint->vrr_classes[11][9] = int_stack + 193390;
 Libint->vrr_classes[11][10] = int_stack + 197680;
 Libint->vrr_classes[11][11] = int_stack + 202828;
 Libint->vrr_classes[11][12] = int_stack + 208912;
 Libint->vrr_classes[11][13] = int_stack + 216010;
 Libint->vrr_classes[11][14] = int_stack + 224200;
 Libint->vrr_classes[11][15] = int_stack + 233560;
 Libint->vrr_classes[11][16] = int_stack + 244168;
 Libint->vrr_classes[11][17] = int_stack + 256102;
 Libint->vrr_classes[11][18] = int_stack + 269440;
 Libint->vrr_classes[12][9] = int_stack + 284260;
 Libint->vrr_classes[12][10] = int_stack + 289265;
 Libint->vrr_classes[12][11] = int_stack + 295271;
 Libint->vrr_classes[12][12] = int_stack + 302369;
 Libint->vrr_classes[12][13] = int_stack + 310650;
 Libint->vrr_classes[12][14] = int_stack + 320205;
 Libint->vrr_classes[12][15] = int_stack + 331125;
 Libint->vrr_classes[12][16] = int_stack + 343501;
 Libint->vrr_classes[12][17] = int_stack + 357424;
 Libint->vrr_classes[12][18] = int_stack + 372985;
 Libint->vrr_classes[13][9] = int_stack + 390275;
 Libint->vrr_classes[13][10] = int_stack + 396050;
 Libint->vrr_classes[13][11] = int_stack + 402980;
 Libint->vrr_classes[13][12] = int_stack + 411170;
 Libint->vrr_classes[13][13] = int_stack + 420725;
 Libint->vrr_classes[13][14] = int_stack + 431750;
 Libint->vrr_classes[13][15] = int_stack + 444350;
 Libint->vrr_classes[13][16] = int_stack + 458630;
 Libint->vrr_classes[13][17] = int_stack + 474695;
 Libint->vrr_classes[13][18] = int_stack + 492650;
 Libint->vrr_classes[14][9] = int_stack + 512600;
 Libint->vrr_classes[14][10] = int_stack + 519200;
 Libint->vrr_classes[14][11] = int_stack + 527120;
 Libint->vrr_classes[14][12] = int_stack + 536480;
 Libint->vrr_classes[14][13] = int_stack + 547400;
 Libint->vrr_classes[14][14] = int_stack + 560000;
 Libint->vrr_classes[14][15] = int_stack + 574400;
 Libint->vrr_classes[14][16] = int_stack + 590720;
 Libint->vrr_classes[14][17] = int_stack + 609080;
 Libint->vrr_classes[14][18] = int_stack + 629600;
 Libint->vrr_classes[15][9] = int_stack + 652400;
 Libint->vrr_classes[15][10] = int_stack + 659880;
 Libint->vrr_classes[15][11] = int_stack + 668856;
 Libint->vrr_classes[15][12] = int_stack + 679464;
 Libint->vrr_classes[15][13] = int_stack + 691840;
 Libint->vrr_classes[15][14] = int_stack + 706120;
 Libint->vrr_classes[15][15] = int_stack + 722440;
 Libint->vrr_classes[15][16] = int_stack + 740936;
 Libint->vrr_classes[15][17] = int_stack + 761744;
 Libint->vrr_classes[15][18] = int_stack + 785000;
 memset(int_stack,0,810840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 810840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lkmm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+810840,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+818265,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+827175,int_stack+818265,int_stack+810840,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+842025,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+852555,int_stack+842025,int_stack+818265,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+870375,int_stack+852555,int_stack+827175,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+810840,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+895125,int_stack+810840,int_stack+842025,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+916185,int_stack+895125,int_stack+852555,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+823125,int_stack+916185,int_stack+870375,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+860250,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+945885,int_stack+860250,int_stack+810840,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+970455,int_stack+945885,int_stack+895125,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1005555,int_stack+970455,int_stack+916185,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+874425,int_stack+1005555,int_stack+823125,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+810840,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+827040,int_stack+810840,int_stack+860250,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1050105,int_stack+827040,int_stack+945885,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1091055,int_stack+1050105,int_stack+970455,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+926400,int_stack+1091055,int_stack+1005555,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1143705,int_stack+926400,int_stack+874425,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+855390,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+873750,int_stack+855390,int_stack+810840,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+988770,int_stack+873750,int_stack+827040,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1213005,int_stack+988770,int_stack+1050105,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1274430,int_stack+1213005,int_stack+1091055,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1036020,int_stack+1274430,int_stack+926400,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1348140,int_stack+1036020,int_stack+1143705,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+906150,int_stack+810840,int_stack+855390,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1119180,int_stack+906150,int_stack+873750,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+831495,int_stack+1119180,int_stack+988770,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+942870,int_stack+831495,int_stack+1213005,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1173180,int_stack+942870,int_stack+1274430,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1437240,int_stack+1173180,int_stack+1036020,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1544160,int_stack+1437240,int_stack+1348140,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1028865,int_stack+43875,int_stack+36180,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1051950,int_stack+1028865,int_stack+810840,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1271460,int_stack+1051950,int_stack+906150,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1028865,int_stack+1271460,int_stack+1119180,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1271460,int_stack+1028865,int_stack+831495,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1028865,int_stack+1271460,int_stack+942870,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1271460,int_stack+1028865,int_stack+1173180,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+810840,int_stack+1271460,int_stack+1437240,45);
 /*--- compute (l0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+944490,int_stack+810840,int_stack+1544160,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+810840,int_stack+55450,int_stack+52425,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+819915,int_stack+59080,int_stack+55450,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+830805,int_stack+819915,int_stack+810840,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+848955,int_stack+63370,int_stack+59080,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+861825,int_stack+848955,int_stack+819915,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+883605,int_stack+861825,int_stack+830805,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+810840,int_stack+68375,int_stack+63370,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+913855,int_stack+810840,int_stack+848955,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1080615,int_stack+913855,int_stack+861825,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+825855,int_stack+1080615,int_stack+883605,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+871230,int_stack+74150,int_stack+68375,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1116915,int_stack+871230,int_stack+810840,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1146945,int_stack+1116915,int_stack+913855,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+888555,int_stack+1146945,int_stack+1080615,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1189845,int_stack+888555,int_stack+825855,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1080615,int_stack+80750,int_stack+74150,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+810840,int_stack+1080615,int_stack+871230,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1253370,int_stack+810840,int_stack+1116915,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1303420,int_stack+1253370,int_stack+1146945,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1100415,int_stack+1303420,int_stack+888555,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+845490,int_stack+1100415,int_stack+1189845,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1176645,int_stack+88230,int_stack+80750,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1199085,int_stack+1176645,int_stack+1080615,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1367770,int_stack+1199085,int_stack+810840,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1425520,int_stack+1367770,int_stack+1253370,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1500595,int_stack+1425520,int_stack+1303420,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1238685,int_stack+1500595,int_stack+1100415,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1590685,int_stack+1238685,int_stack+845490,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+96645,int_stack+88230,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+836085,int_stack+810840,int_stack+1176645,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1080615,int_stack+836085,int_stack+1199085,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1146615,int_stack+1080615,int_stack+1367770,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1699585,int_stack+1146615,int_stack+1425520,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1340325,int_stack+1699585,int_stack+1500595,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1804690,int_stack+1340325,int_stack+1238685,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1935370,int_stack+1804690,int_stack+1590685,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+880965,int_stack+106050,int_stack+96645,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1233240,int_stack+880965,int_stack+810840,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1460445,int_stack+1233240,int_stack+836085,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1233240,int_stack+1460445,int_stack+1080615,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1460445,int_stack+1233240,int_stack+1146615,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1080615,int_stack+1460445,int_stack+1699585,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1460445,int_stack+1080615,int_stack+1340325,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1080615,int_stack+1460445,int_stack+1804690,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1243965,int_stack+1080615,int_stack+1935370,55);
 /*--- compute (lp|mm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1410340,int_stack+1243965,int_stack+944490,3025);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1818715,int_stack+120130,int_stack+116500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1829605,int_stack+124486,int_stack+120130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1842673,int_stack+1829605,int_stack+1818715,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1864453,int_stack+129634,int_stack+124486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1879897,int_stack+1864453,int_stack+1829605,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1906033,int_stack+1879897,int_stack+1842673,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1818715,int_stack+135640,int_stack+129634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1942333,int_stack+1818715,int_stack+1864453,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1973221,int_stack+1942333,int_stack+1879897,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1836733,int_stack+1973221,int_stack+1906033,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1891183,int_stack+142570,int_stack+135640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2016781,int_stack+1891183,int_stack+1818715,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+810840,int_stack+2016781,int_stack+1942333,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+862320,int_stack+810840,int_stack+1973221,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1911973,int_stack+862320,int_stack+1836733,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1818715,int_stack+150490,int_stack+142570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1842475,int_stack+1818715,int_stack+1891183,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+927660,int_stack+1842475,int_stack+2016781,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1988203,int_stack+927660,int_stack+810840,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+987720,int_stack+1988203,int_stack+862320,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+810840,int_stack+987720,int_stack+1911973,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1884055,int_stack+159466,int_stack+150490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1910983,int_stack+1884055,int_stack+1818715,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1079196,int_stack+1910983,int_stack+1842475,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1148496,int_stack+1079196,int_stack+927660,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1148496,int_stack+1988203,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1958503,int_stack+0,int_stack+987720,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+912480,int_stack+1958503,int_stack+810840,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+169564,int_stack+159466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+841134,int_stack+810840,int_stack+1884055,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1818715,int_stack+841134,int_stack+1910983,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2080471,int_stack+1818715,int_stack+1079196,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2184421,int_stack+2080471,int_stack+1148496,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1043160,int_stack+2184421,int_stack+0,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1043160,int_stack+1958503,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1897915,int_stack+0,int_stack+912480,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+894990,int_stack+180850,int_stack+169564,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+928848,int_stack+894990,int_stack+810840,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2310547,int_stack+928848,int_stack+841134,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+810840,int_stack+2310547,int_stack+1818715,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2310547,int_stack+810840,int_stack+2080471,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+810840,int_stack+2310547,int_stack+2184421,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2061265,int_stack+810840,int_stack+1043160,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+810840,int_stack+2061265,int_stack+0,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2061265,int_stack+810840,int_stack+1897915,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+2260915,int_stack+2061265,int_stack+1243965,3025);
 /*--- compute (ld|mm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2760040,int_stack+2260915,int_stack+1410340,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+810840,int_stack+197680,int_stack+193390,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+823710,int_stack+202828,int_stack+197680,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+839154,int_stack+823710,int_stack+810840,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+864894,int_stack+208912,int_stack+202828,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+883146,int_stack+864894,int_stack+823710,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+914034,int_stack+883146,int_stack+839154,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+810840,int_stack+216010,int_stack+208912,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+956934,int_stack+810840,int_stack+864894,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+993438,int_stack+956934,int_stack+883146,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+832134,int_stack+993438,int_stack+914034,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+896484,int_stack+224200,int_stack+216010,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1044918,int_stack+896484,int_stack+810840,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1087506,int_stack+1044918,int_stack+956934,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1148346,int_stack+1087506,int_stack+993438,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+921054,int_stack+1148346,int_stack+832134,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+810840,int_stack+233560,int_stack+224200,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+838920,int_stack+810840,int_stack+896484,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1225566,int_stack+838920,int_stack+1044918,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1296546,int_stack+1225566,int_stack+1087506,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1011144,int_stack+1296546,int_stack+1148346,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1387806,int_stack+1011144,int_stack+921054,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+888060,int_stack+244168,int_stack+233560,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+919884,int_stack+888060,int_stack+810840,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1119252,int_stack+919884,int_stack+838920,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1507926,int_stack+1119252,int_stack+1225566,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1614396,int_stack+1507926,int_stack+1296546,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1201152,int_stack+1614396,int_stack+1011144,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1742160,int_stack+1201152,int_stack+1387806,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+256102,int_stack+244168,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+976044,int_stack+810840,int_stack+888060,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1345296,int_stack+976044,int_stack+919884,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+846642,int_stack+1345296,int_stack+1119252,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1039692,int_stack+846642,int_stack+1507926,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1438896,int_stack+1039692,int_stack+1614396,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1438896,int_stack+1201152,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3576790,int_stack+0,int_stack+1742160,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1188750,int_stack+269440,int_stack+256102,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1228764,int_stack+1188750,int_stack+810840,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1609248,int_stack+1228764,int_stack+976044,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1188750,int_stack+1609248,int_stack+1345296,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1609248,int_stack+1188750,int_stack+846642,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1188750,int_stack+1609248,int_stack+1039692,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1609248,int_stack+1188750,int_stack+1438896,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1828272,int_stack+1609248,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+1828272,int_stack+3576790,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+810840,int_stack+0,int_stack+2061265,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3576790,int_stack+810840,int_stack+2260915,3025);
 /*--- compute (lf|mm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4575040,int_stack+3576790,int_stack+2760040,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+235950,int_stack+289265,int_stack+284260,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+250965,int_stack+295271,int_stack+289265,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1409790,int_stack+250965,int_stack+235950,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+268983,int_stack+302369,int_stack+295271,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1439820,int_stack+268983,int_stack+250965,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1475856,int_stack+1439820,int_stack+1409790,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1409790,int_stack+310650,int_stack+302369,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1525906,int_stack+1409790,int_stack+268983,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+235950,int_stack+1525906,int_stack+1439820,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1568494,int_stack+235950,int_stack+1475856,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1434633,int_stack+320205,int_stack+310650,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1463298,int_stack+1434633,int_stack+1409790,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1643569,int_stack+1463298,int_stack+1525906,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1714549,int_stack+1643569,int_stack+235950,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1804639,int_stack+1714549,int_stack+1568494,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+235950,int_stack+331125,int_stack+320205,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+268710,int_stack+235950,int_stack+1434633,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1512984,int_stack+268710,int_stack+1463298,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1909744,int_stack+1512984,int_stack+1643569,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2016214,int_stack+1909744,int_stack+1714549,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1595794,int_stack+2016214,int_stack+1804639,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1409790,int_stack+343501,int_stack+331125,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1446918,int_stack+1409790,int_stack+235950,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1735934,int_stack+1446918,int_stack+268710,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2142340,int_stack+1735934,int_stack+1512984,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2266555,int_stack+2142340,int_stack+1909744,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1831484,int_stack+2266555,int_stack+2016214,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2415613,int_stack+1831484,int_stack+1595794,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+235950,int_stack+357424,int_stack+343501,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+277719,int_stack+235950,int_stack+1409790,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1512438,int_stack+277719,int_stack+1446918,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2595793,int_stack+1512438,int_stack+1735934,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1621638,int_stack+2595793,int_stack+2142340,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1999652,int_stack+1621638,int_stack+2266555,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2198396,int_stack+1999652,int_stack+1831484,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2739118,int_stack+2198396,int_stack+2415613,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1409790,int_stack+372985,int_stack+357424,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1795539,int_stack+1409790,int_stack+235950,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2414612,int_stack+1795539,int_stack+277719,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1795539,int_stack+2414612,int_stack+1512438,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1409790,int_stack+1795539,int_stack+2595793,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2414612,int_stack+1409790,int_stack+1621638,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1409790,int_stack+2414612,int_stack+1999652,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2414612,int_stack+1409790,int_stack+2198396,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1409790,int_stack+2414612,int_stack+2739118,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1685065,int_stack+1409790,int_stack+0,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5936290,int_stack+1685065,int_stack+810840,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+7134190,int_stack+5936290,int_stack+3576790,3025);
 /*--- compute (lg|mm) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2392915,int_stack+7134190,int_stack+4575040,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+810840,int_stack+396050,int_stack+390275,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+828165,int_stack+402980,int_stack+396050,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+848955,int_stack+828165,int_stack+810840,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+883605,int_stack+411170,int_stack+402980,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+908175,int_stack+883605,int_stack+828165,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+949755,int_stack+908175,int_stack+848955,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+810840,int_stack+420725,int_stack+411170,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1007505,int_stack+810840,int_stack+883605,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1056645,int_stack+1007505,int_stack+908175,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+839505,int_stack+1056645,int_stack+949755,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+926130,int_stack+431750,int_stack+420725,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1125945,int_stack+926130,int_stack+810840,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1183275,int_stack+1125945,int_stack+1007505,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1265175,int_stack+1183275,int_stack+1056645,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+959205,int_stack+1265175,int_stack+839505,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+810840,int_stack+444350,int_stack+431750,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+848640,int_stack+810840,int_stack+926130,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+848640,int_stack+1125945,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95550,int_stack+0,int_stack+1183275,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1080480,int_stack+95550,int_stack+1265175,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1226010,int_stack+1080480,int_stack+959205,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+914790,int_stack+458630,int_stack+444350,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+957630,int_stack+914790,int_stack+810840,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+218400,int_stack+957630,int_stack+848640,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4434790,int_stack+218400,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4578115,int_stack+4434790,int_stack+95550,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+4578115,int_stack+1080480,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4750105,int_stack+0,int_stack+1226010,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+474695,int_stack+458630,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1033230,int_stack+810840,int_stack+914790,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1118910,int_stack+1033230,int_stack+957630,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+859035,int_stack+1118910,int_stack+218400,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+194040,int_stack+859035,int_stack+4434790,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4958005,int_stack+194040,int_stack+4578115,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4434790,int_stack+4958005,int_stack+0,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+5187325,int_stack+4434790,int_stack+4750105,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+492650,int_stack+474695,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+53865,int_stack+0,int_stack+810840,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4684270,int_stack+53865,int_stack+1033230,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+4684270,int_stack+1118910,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4684270,int_stack+0,int_stack+859035,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+810840,int_stack+4684270,int_stack+194040,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+810840,int_stack+4958005,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+810840,int_stack+0,int_stack+4434790,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+4434790,int_stack+810840,int_stack+5187325,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+4752415,int_stack+4434790,int_stack+1409790,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+8797940,int_stack+4752415,int_stack+1685065,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+10213640,int_stack+8797940,int_stack+5936290,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+12210140,int_stack+10213640,int_stack+7134190,3025);
 /*--- compute (lh|mm) ---*/
 hrr1_build_lh(Libint->AB,int_stack+5578240,int_stack+12210140,int_stack+2392915,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+810840,int_stack+519200,int_stack+512600,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+830640,int_stack+527120,int_stack+519200,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+854400,int_stack+830640,int_stack+810840,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+894000,int_stack+536480,int_stack+527120,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+922080,int_stack+894000,int_stack+830640,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+969600,int_stack+922080,int_stack+854400,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+810840,int_stack+547400,int_stack+536480,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1035600,int_stack+810840,int_stack+894000,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1091760,int_stack+1035600,int_stack+922080,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+843600,int_stack+1091760,int_stack+969600,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+942600,int_stack+560000,int_stack+547400,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1170960,int_stack+942600,int_stack+810840,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1236480,int_stack+1170960,int_stack+1035600,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1330080,int_stack+1236480,int_stack+1091760,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+980400,int_stack+1330080,int_stack+843600,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+810840,int_stack+574400,int_stack+560000,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+854040,int_stack+810840,int_stack+942600,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1448880,int_stack+854040,int_stack+1170960,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1558080,int_stack+1448880,int_stack+1236480,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1119000,int_stack+1558080,int_stack+1330080,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1698480,int_stack+1119000,int_stack+980400,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+929640,int_stack+590720,int_stack+574400,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+978600,int_stack+929640,int_stack+810840,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1285320,int_stack+978600,int_stack+854040,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1883280,int_stack+1285320,int_stack+1448880,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2047080,int_stack+1883280,int_stack+1558080,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1411320,int_stack+2047080,int_stack+1119000,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2243640,int_stack+1411320,int_stack+1698480,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+609080,int_stack+590720,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1065000,int_stack+810840,int_stack+929640,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1633080,int_stack+1065000,int_stack+978600,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+865920,int_stack+1633080,int_stack+1285320,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1162920,int_stack+865920,int_stack+1883280,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1777080,int_stack+1162920,int_stack+2047080,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2481240,int_stack+1777080,int_stack+1411320,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2766360,int_stack+2481240,int_stack+2243640,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1392240,int_stack+629600,int_stack+609080,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1453800,int_stack+1392240,int_stack+810840,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2039160,int_stack+1453800,int_stack+1065000,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1392240,int_stack+2039160,int_stack+1633080,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2039160,int_stack+1392240,int_stack+865920,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1392240,int_stack+2039160,int_stack+1162920,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2039160,int_stack+1392240,int_stack+1777080,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+810840,int_stack+2039160,int_stack+2481240,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1167240,int_stack+810840,int_stack+2766360,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1530240,int_stack+1167240,int_stack+4434790,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+2483115,int_stack+1530240,int_stack+4752415,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+14705765,int_stack+2483115,int_stack+8797940,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+17065265,int_stack+14705765,int_stack+10213640,3025);
 /*--- compute (mh|mm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+8436865,int_stack+17065265,int_stack+12210140,3025);
 /*--- compute (li|mm) ---*/
 hrr1_build_li(Libint->AB,int_stack+20060015,int_stack+8436865,int_stack+5578240,3025);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+810840,int_stack+659880,int_stack+652400,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+833280,int_stack+668856,int_stack+659880,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+860208,int_stack+833280,int_stack+810840,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+905088,int_stack+679464,int_stack+668856,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+936912,int_stack+905088,int_stack+833280,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+990768,int_stack+936912,int_stack+860208,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+810840,int_stack+691840,int_stack+679464,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1065568,int_stack+810840,int_stack+905088,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4134765,int_stack+1065568,int_stack+936912,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+847968,int_stack+4134765,int_stack+990768,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+960168,int_stack+706120,int_stack+691840,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4224525,int_stack+960168,int_stack+810840,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4298781,int_stack+4224525,int_stack+1065568,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1003008,int_stack+4298781,int_stack+4134765,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+4404861,int_stack+1003008,int_stack+847968,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4134765,int_stack+722440,int_stack+706120,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+810840,int_stack+4134765,int_stack+960168,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4561941,int_stack+810840,int_stack+4224525,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4685701,int_stack+4561941,int_stack+4298781,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4183725,int_stack+4685701,int_stack+1003008,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+896520,int_stack+4183725,int_stack+4404861,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4372221,int_stack+740936,int_stack+722440,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+4427709,int_stack+4372221,int_stack+4134765,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4844821,int_stack+4427709,int_stack+810840,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4987621,int_stack+4844821,int_stack+4561941,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5173261,int_stack+4987621,int_stack+4685701,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4525629,int_stack+5173261,int_stack+4183725,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+5396029,int_stack+4525629,int_stack+896520,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+810840,int_stack+761744,int_stack+740936,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+873264,int_stack+810840,int_stack+4372221,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+984240,int_stack+873264,int_stack+4427709,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4134765,int_stack+984240,int_stack+4844821,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5665309,int_stack+4134765,int_stack+4987621,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4776957,int_stack+5665309,int_stack+5173261,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5925205,int_stack+4776957,int_stack+4525629,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4348965,int_stack+5925205,int_stack+5396029,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+4685565,int_stack+785000,int_stack+761744,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+5073981,int_stack+4685565,int_stack+810840,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5198829,int_stack+5073981,int_stack+873264,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5383789,int_stack+5198829,int_stack+984240,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+5073981,int_stack+5383789,int_stack+4134765,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6248341,int_stack+5073981,int_stack+5665309,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5073981,int_stack+6248341,int_stack+4776957,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6248341,int_stack+5073981,int_stack+5925205,136);
 /*--- compute (u0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+6652261,int_stack+6248341,int_stack+4348965,136);
 /*--- compute (tp|mm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+7063661,int_stack+6652261,int_stack+1167240,3025);
 /*--- compute (rd|mm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+4134765,int_stack+7063661,int_stack+1530240,3025);
 /*--- compute (qf|mm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+11930740,int_stack+4134765,int_stack+2483115,3025);
 /*--- compute (og|mm) ---*/
 hrr1_build_og(Libint->AB,int_stack+0,int_stack+11930740,int_stack+14705765,3025);
 /*--- compute (nh|mm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+11930740,int_stack+0,int_stack+17065265,3025);
 /*--- compute (mi|mm) ---*/
 hrr1_build_mi(Libint->AB,int_stack+0,int_stack+11930740,int_stack+8436865,3025);
 /*--- compute (lk|mm) ---*/
 hrr1_build_lk(Libint->AB,int_stack+4658500,int_stack+0,int_stack+20060015,3025);
 return int_stack+4658500;}
