/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lkni(Libint_t*, prim_data*);

  /* Computes quartets of (lk|ni) integrals */

REALTYPE *hrr_order_lkni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[9][10] = int_stack + 33705;
 Libint->vrr_classes[9][11] = int_stack + 37335;
 Libint->vrr_classes[9][12] = int_stack + 41625;
 Libint->vrr_classes[9][13] = int_stack + 46630;
 Libint->vrr_classes[9][14] = int_stack + 52405;
 Libint->vrr_classes[9][15] = int_stack + 59005;
 Libint->vrr_classes[9][16] = int_stack + 66485;
 Libint->vrr_classes[10][10] = int_stack + 74900;
 Libint->vrr_classes[10][11] = int_stack + 79256;
 Libint->vrr_classes[10][12] = int_stack + 84404;
 Libint->vrr_classes[10][13] = int_stack + 90410;
 Libint->vrr_classes[10][14] = int_stack + 97340;
 Libint->vrr_classes[10][15] = int_stack + 105260;
 Libint->vrr_classes[10][16] = int_stack + 114236;
 Libint->vrr_classes[11][10] = int_stack + 124334;
 Libint->vrr_classes[11][11] = int_stack + 129482;
 Libint->vrr_classes[11][12] = int_stack + 135566;
 Libint->vrr_classes[11][13] = int_stack + 142664;
 Libint->vrr_classes[11][14] = int_stack + 150854;
 Libint->vrr_classes[11][15] = int_stack + 160214;
 Libint->vrr_classes[11][16] = int_stack + 170822;
 Libint->vrr_classes[12][10] = int_stack + 182756;
 Libint->vrr_classes[12][11] = int_stack + 188762;
 Libint->vrr_classes[12][12] = int_stack + 195860;
 Libint->vrr_classes[12][13] = int_stack + 204141;
 Libint->vrr_classes[12][14] = int_stack + 213696;
 Libint->vrr_classes[12][15] = int_stack + 224616;
 Libint->vrr_classes[12][16] = int_stack + 236992;
 Libint->vrr_classes[13][10] = int_stack + 250915;
 Libint->vrr_classes[13][11] = int_stack + 257845;
 Libint->vrr_classes[13][12] = int_stack + 266035;
 Libint->vrr_classes[13][13] = int_stack + 275590;
 Libint->vrr_classes[13][14] = int_stack + 286615;
 Libint->vrr_classes[13][15] = int_stack + 299215;
 Libint->vrr_classes[13][16] = int_stack + 313495;
 Libint->vrr_classes[14][10] = int_stack + 329560;
 Libint->vrr_classes[14][11] = int_stack + 337480;
 Libint->vrr_classes[14][12] = int_stack + 346840;
 Libint->vrr_classes[14][13] = int_stack + 357760;
 Libint->vrr_classes[14][14] = int_stack + 370360;
 Libint->vrr_classes[14][15] = int_stack + 384760;
 Libint->vrr_classes[14][16] = int_stack + 401080;
 Libint->vrr_classes[15][10] = int_stack + 419440;
 Libint->vrr_classes[15][11] = int_stack + 428416;
 Libint->vrr_classes[15][12] = int_stack + 439024;
 Libint->vrr_classes[15][13] = int_stack + 451400;
 Libint->vrr_classes[15][14] = int_stack + 465680;
 Libint->vrr_classes[15][15] = int_stack + 482000;
 Libint->vrr_classes[15][16] = int_stack + 500496;
 memset(int_stack,0,521304*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 521304;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lkni(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521304,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+530214,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+540744,int_stack+530214,int_stack+521304,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+558564,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+570849,int_stack+558564,int_stack+530214,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+591909,int_stack+570849,int_stack+540744,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521304,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+621609,int_stack+521304,int_stack+558564,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+535479,int_stack+621609,int_stack+570849,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+646179,int_stack+535479,int_stack+591909,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+570579,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+586779,int_stack+570579,int_stack+521304,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+690729,int_stack+586779,int_stack+621609,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+731679,int_stack+690729,int_stack+535479,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+784329,int_stack+731679,int_stack+646179,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521304,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+615129,int_stack+521304,int_stack+570579,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+521304,int_stack+615129,int_stack+586779,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+568554,int_stack+521304,int_stack+690729,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+629979,int_stack+568554,int_stack+731679,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+521304,int_stack+629979,int_stack+784329,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+604464,int_stack+37335,int_stack+33705,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+615354,int_stack+41625,int_stack+37335,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+628224,int_stack+615354,int_stack+604464,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+650004,int_stack+46630,int_stack+41625,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+665019,int_stack+650004,int_stack+615354,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+690759,int_stack+665019,int_stack+628224,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+604464,int_stack+52405,int_stack+46630,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+727059,int_stack+604464,int_stack+650004,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+621789,int_stack+727059,int_stack+665019,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+757089,int_stack+621789,int_stack+690759,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+664689,int_stack+59005,int_stack+52405,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+684489,int_stack+664689,int_stack+604464,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+684489,int_stack+727059,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+811539,int_stack+0,int_stack+621789,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+875889,int_stack+811539,int_stack+757089,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+604464,int_stack+66485,int_stack+59005,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+719139,int_stack+604464,int_stack+664689,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+604464,int_stack+719139,int_stack+684489,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+662214,int_stack+604464,int_stack+0,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+952119,int_stack+662214,int_stack+811539,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+604464,int_stack+952119,int_stack+875889,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+706104,int_stack+604464,int_stack+521304,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521304,int_stack+79256,int_stack+74900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+534372,int_stack+84404,int_stack+79256,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+549816,int_stack+534372,int_stack+521304,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+575952,int_stack+90410,int_stack+84404,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+575952,int_stack+534372,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30888,int_stack+0,int_stack+549816,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521304,int_stack+97340,int_stack+90410,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+955584,int_stack+521304,int_stack+575952,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+542094,int_stack+955584,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+991620,int_stack+542094,int_stack+30888,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+105260,int_stack+97340,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23760,int_stack+0,int_stack+521304,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1056960,int_stack+23760,int_stack+955584,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1117020,int_stack+1056960,int_stack+542094,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1194240,int_stack+1117020,int_stack+991620,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+955584,int_stack+114236,int_stack+105260,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+982512,int_stack+955584,int_stack+0,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+521304,int_stack+982512,int_stack+23760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+521304,int_stack+1056960,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+955584,int_stack+0,int_stack+1117020,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+955584,int_stack+1194240,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+955584,int_stack+0,int_stack+604464,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1260504,int_stack+955584,int_stack+706104,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521304,int_stack+129482,int_stack+124334,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+536748,int_stack+135566,int_stack+129482,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+555000,int_stack+536748,int_stack+521304,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+585888,int_stack+142664,int_stack+135566,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+607182,int_stack+585888,int_stack+536748,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+643686,int_stack+607182,int_stack+555000,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521304,int_stack+150854,int_stack+142664,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+695166,int_stack+521304,int_stack+585888,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+545874,int_stack+695166,int_stack+607182,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+737754,int_stack+545874,int_stack+643686,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+606714,int_stack+160214,int_stack+150854,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+634794,int_stack+606714,int_stack+521304,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+814974,int_stack+634794,int_stack+695166,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1759464,int_stack+814974,int_stack+545874,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1850724,int_stack+1759464,int_stack+737754,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521304,int_stack+170822,int_stack+160214,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+683934,int_stack+521304,int_stack+606714,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+521304,int_stack+683934,int_stack+634794,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+603204,int_stack+521304,int_stack+814974,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+709674,int_stack+603204,int_stack+1759464,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+521304,int_stack+709674,int_stack+1850724,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+1759464,int_stack+521304,int_stack+0,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+2125368,int_stack+1759464,int_stack+955584,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2735208,int_stack+2125368,int_stack+1260504,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+188762,int_stack+182756,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+195860,int_stack+188762,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204141,int_stack+195860,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+213696,int_stack+204141,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+665448,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+665448,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+715134,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224616,int_stack+213696,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+805224,int_stack+132405,int_stack+665448,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+888034,int_stack+805224,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+994504,int_stack+888034,int_stack+715134,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+665448,int_stack+236992,int_stack+224616,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+702576,int_stack+665448,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+702576,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+665448,int_stack+0,int_stack+805224,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+665448,int_stack+888034,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+665448,int_stack+0,int_stack+994504,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+833616,int_stack+665448,int_stack+521304,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3566808,int_stack+833616,int_stack+1759464,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4298616,int_stack+3566808,int_stack+2125368,1848);
 /*--- compute (lg|ni) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1266048,int_stack+4298616,int_stack+2735208,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+521304,int_stack+257845,int_stack+250915,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+542094,int_stack+266035,int_stack+257845,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+566664,int_stack+542094,int_stack+521304,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+608244,int_stack+275590,int_stack+266035,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+608244,int_stack+542094,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+566664,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+521304,int_stack+286615,int_stack+275590,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+118440,int_stack+521304,int_stack+608244,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+554379,int_stack+118440,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175770,int_stack+554379,int_stack+49140,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+299215,int_stack+286615,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+521304,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2513448,int_stack+37800,int_stack+118440,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2608998,int_stack+2513448,int_stack+554379,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2731848,int_stack+2608998,int_stack+175770,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521304,int_stack+313495,int_stack+299215,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+564144,int_stack+521304,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+103950,int_stack+564144,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+521304,int_stack+103950,int_stack+2513448,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+521304,int_stack+2608998,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2513448,int_stack+0,int_stack+2731848,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2707488,int_stack+2513448,int_stack+665448,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+5315016,int_stack+2707488,int_stack+833616,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6179880,int_stack+5315016,int_stack+3566808,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+7399560,int_stack+6179880,int_stack+4298616,1848);
 /*--- compute (lh|ni) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3211992,int_stack+7399560,int_stack+1266048,1848);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+337480,int_stack+329560,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+346840,int_stack+337480,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+357760,int_stack+346840,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+370360,int_stack+357760,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+521304,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+384760,int_stack+370360,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+640104,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+749304,int_stack+640104,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+889704,int_stack+749304,int_stack+521304,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+521304,int_stack+401080,int_stack+384760,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+521304,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+250200,int_stack+0,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+250200,int_stack+640104,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+163800,int_stack+0,int_stack+749304,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+521304,int_stack+163800,int_stack+889704,120);
 /*--- compute (rp|ni) ---*/
 hrr1_build_rp(Libint->AB,int_stack+743064,int_stack+521304,int_stack+2513448,1848);
 /*--- compute (qd|ni) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1325184,int_stack+743064,int_stack+2707488,1848);
 /*--- compute (of|ni) ---*/
 hrr1_build_of(Libint->AB,int_stack+8924160,int_stack+1325184,int_stack+5315016,1848);
 /*--- compute (ng|ni) ---*/
 hrr1_build_ng(Libint->AB,int_stack+10365600,int_stack+8924160,int_stack+6179880,1848);
 /*--- compute (mh|ni) ---*/
 hrr1_build_mh(Libint->AB,int_stack+4958352,int_stack+10365600,int_stack+7399560,1848);
 /*--- compute (li|ni) ---*/
 hrr1_build_li(Libint->AB,int_stack+12195120,int_stack+4958352,int_stack+3211992,1848);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+428416,int_stack+419440,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+439024,int_stack+428416,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+451400,int_stack+439024,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+465680,int_stack+451400,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2334192,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+482000,int_stack+465680,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2468832,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+283560,int_stack+2468832,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2592592,int_stack+283560,int_stack+2334192,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2334192,int_stack+500496,int_stack+482000,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+2334192,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2781088,int_stack+0,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+2781088,int_stack+2468832,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2781088,int_stack+0,int_stack+283560,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2781088,int_stack+2592592,136);
 /*--- compute (tp|ni) ---*/
 hrr1_build_tp(Libint->AB,int_stack+2334192,int_stack+0,int_stack+521304,1848);
 /*--- compute (rd|ni) ---*/
 hrr1_build_rd(Libint->AB,int_stack+2999472,int_stack+2334192,int_stack+743064,1848);
 /*--- compute (qf|ni) ---*/
 hrr1_build_qf(Libint->AB,int_stack+7092792,int_stack+2999472,int_stack+1325184,1848);
 /*--- compute (og|ni) ---*/
 hrr1_build_og(Libint->AB,int_stack+0,int_stack+7092792,int_stack+8924160,1848);
 /*--- compute (nh|ni) ---*/
 hrr1_build_nh(Libint->AB,int_stack+7092792,int_stack+0,int_stack+10365600,1848);
 /*--- compute (mi|ni) ---*/
 hrr1_build_mi(Libint->AB,int_stack+0,int_stack+7092792,int_stack+4958352,1848);
 /*--- compute (lk|ni) ---*/
 hrr1_build_lk(Libint->AB,int_stack+2845920,int_stack+0,int_stack+12195120,1848);
 return int_stack+2845920;}
