/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpml(Libint_t*, prim_data*);

  /* Computes quartets of (lp|ml) integrals */

REALTYPE *hrr_order_lpml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[9][9] = int_stack + 43875;
 Libint->vrr_classes[9][10] = int_stack + 46900;
 Libint->vrr_classes[9][11] = int_stack + 50530;
 Libint->vrr_classes[9][12] = int_stack + 54820;
 Libint->vrr_classes[9][13] = int_stack + 59825;
 Libint->vrr_classes[9][14] = int_stack + 65600;
 Libint->vrr_classes[9][15] = int_stack + 72200;
 Libint->vrr_classes[9][16] = int_stack + 79680;
 Libint->vrr_classes[9][17] = int_stack + 88095;
 memset(int_stack,0,97500*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 97500;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpml(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97500,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+104925,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+113835,int_stack+104925,int_stack+97500,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+128685,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+139215,int_stack+128685,int_stack+104925,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+157035,int_stack+139215,int_stack+113835,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+97500,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+181785,int_stack+97500,int_stack+128685,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+202845,int_stack+181785,int_stack+139215,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+109785,int_stack+202845,int_stack+157035,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+146910,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+232545,int_stack+146910,int_stack+97500,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+257115,int_stack+232545,int_stack+181785,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+292215,int_stack+257115,int_stack+202845,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+161085,int_stack+292215,int_stack+109785,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+97500,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113700,int_stack+97500,int_stack+146910,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+336765,int_stack+113700,int_stack+232545,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+377715,int_stack+336765,int_stack+257115,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+213060,int_stack+377715,int_stack+292215,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+430365,int_stack+213060,int_stack+161085,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+142050,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+160410,int_stack+142050,int_stack+97500,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+275430,int_stack+160410,int_stack+113700,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+499665,int_stack+275430,int_stack+336765,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+561090,int_stack+499665,int_stack+377715,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+322680,int_stack+561090,int_stack+213060,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+634800,int_stack+322680,int_stack+430365,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+97500,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+192810,int_stack+97500,int_stack+142050,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+97500,int_stack+192810,int_stack+160410,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+151500,int_stack+97500,int_stack+275430,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+222375,int_stack+151500,int_stack+499665,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+97500,int_stack+222375,int_stack+561090,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+195780,int_stack+97500,int_stack+322680,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+302700,int_stack+195780,int_stack+634800,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97500,int_stack+46900,int_stack+43875,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+106575,int_stack+50530,int_stack+46900,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+117465,int_stack+106575,int_stack+97500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+135615,int_stack+54820,int_stack+50530,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+148485,int_stack+135615,int_stack+106575,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+170265,int_stack+148485,int_stack+117465,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+97500,int_stack+59825,int_stack+54820,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+200515,int_stack+97500,int_stack+135615,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+226255,int_stack+200515,int_stack+148485,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+112515,int_stack+226255,int_stack+170265,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+157890,int_stack+65600,int_stack+59825,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+262555,int_stack+157890,int_stack+97500,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+414075,int_stack+262555,int_stack+200515,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+456975,int_stack+414075,int_stack+226255,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+175215,int_stack+456975,int_stack+112515,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+97500,int_stack+72200,int_stack+65600,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+117300,int_stack+97500,int_stack+157890,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+511425,int_stack+117300,int_stack+262555,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+561475,int_stack+511425,int_stack+414075,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+625825,int_stack+561475,int_stack+456975,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+414075,int_stack+625825,int_stack+175215,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+151950,int_stack+79680,int_stack+72200,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+174390,int_stack+151950,int_stack+97500,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+213990,int_stack+174390,int_stack+117300,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+213990,int_stack+511425,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+702055,int_stack+0,int_stack+561475,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+498775,int_stack+702055,int_stack+625825,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+792145,int_stack+498775,int_stack+414075,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+414075,int_stack+88095,int_stack+79680,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+439320,int_stack+414075,int_stack+151950,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+600415,int_stack+439320,int_stack+174390,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+75075,int_stack+600415,int_stack+213990,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+161700,int_stack+75075,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+161700,int_stack+702055,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+120120,int_stack+0,int_stack+498775,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+414075,int_stack+120120,int_stack+792145,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+550200,int_stack+414075,int_stack+302700,2475);
 return int_stack+550200;}
