/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpnp(Libint_t*, prim_data*);

  /* Computes quartets of (lp|np) integrals */

REALTYPE *hrr_order_lpnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[9][10] = int_stack + 6480;
 Libint->vrr_classes[9][11] = int_stack + 10110;
 memset(int_stack,0,14400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpnp(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14400,int_stack+2970,int_stack+0,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23310,int_stack+10110,int_stack+6480,55);
 /*--- compute (lp|np) ---*/
 hrr1_build_lp(Libint->AB,int_stack+34200,int_stack+23310,int_stack+14400,198);
 return int_stack+34200;}
