/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_m0ll(Libint_t*, prim_data*);

  /* Computes quartets of (m0|ll) integrals */

REALTYPE *hrr_order_m0ll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[9][16] = int_stack + 38280;
 memset(int_stack,0,46695*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 46695;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_m0ll(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+46695,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+54120,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+63195,int_stack+54120,int_stack+46695,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78045,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+88935,int_stack+78045,int_stack+54120,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+107085,int_stack+88935,int_stack+63195,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+46695,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+131835,int_stack+46695,int_stack+78045,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+153615,int_stack+131835,int_stack+88935,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+59565,int_stack+153615,int_stack+107085,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+96690,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+183865,int_stack+96690,int_stack+46695,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+209605,int_stack+183865,int_stack+131835,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+245905,int_stack+209605,int_stack+153615,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+111705,int_stack+245905,int_stack+59565,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+46695,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+64020,int_stack+46695,int_stack+96690,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+291280,int_stack+64020,int_stack+183865,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+334180,int_stack+291280,int_stack+209605,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+163680,int_stack+334180,int_stack+245905,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+388630,int_stack+163680,int_stack+111705,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+94050,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113850,int_stack+94050,int_stack+46695,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+227205,int_stack+113850,int_stack+64020,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+457930,int_stack+227205,int_stack+291280,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+522280,int_stack+457930,int_stack+334180,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+277255,int_stack+522280,int_stack+163680,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+598510,int_stack+277255,int_stack+388630,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+46695,int_stack+38280,int_stack+30800,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+148500,int_stack+46695,int_stack+94050,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+361955,int_stack+148500,int_stack+113850,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+361955,int_stack+227205,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+361955,int_stack+0,int_stack+457930,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+361955,int_stack+522280,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+361955,int_stack+0,int_stack+277255,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+361955,int_stack+598510,55);
 return int_stack+0;}
