/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdll(Libint_t*, prim_data*);

  /* Computes quartets of (md|ll) integrals */

REALTYPE *hrr_order_mdll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[9][16] = int_stack + 38280;
 Libint->vrr_classes[10][8] = int_stack + 46695;
 Libint->vrr_classes[10][9] = int_stack + 49665;
 Libint->vrr_classes[10][10] = int_stack + 53295;
 Libint->vrr_classes[10][11] = int_stack + 57651;
 Libint->vrr_classes[10][12] = int_stack + 62799;
 Libint->vrr_classes[10][13] = int_stack + 68805;
 Libint->vrr_classes[10][14] = int_stack + 75735;
 Libint->vrr_classes[10][15] = int_stack + 83655;
 Libint->vrr_classes[10][16] = int_stack + 92631;
 Libint->vrr_classes[11][8] = int_stack + 102729;
 Libint->vrr_classes[11][9] = int_stack + 106239;
 Libint->vrr_classes[11][10] = int_stack + 110529;
 Libint->vrr_classes[11][11] = int_stack + 115677;
 Libint->vrr_classes[11][12] = int_stack + 121761;
 Libint->vrr_classes[11][13] = int_stack + 128859;
 Libint->vrr_classes[11][14] = int_stack + 137049;
 Libint->vrr_classes[11][15] = int_stack + 146409;
 Libint->vrr_classes[11][16] = int_stack + 157017;
 memset(int_stack,0,168951*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 168951;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdll(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+168951,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+176376,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+185451,int_stack+176376,int_stack+168951,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+200301,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+211191,int_stack+200301,int_stack+176376,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+229341,int_stack+211191,int_stack+185451,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+168951,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+254091,int_stack+168951,int_stack+200301,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+275871,int_stack+254091,int_stack+211191,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+181821,int_stack+275871,int_stack+229341,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+218946,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+306121,int_stack+218946,int_stack+168951,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+331861,int_stack+306121,int_stack+254091,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+368161,int_stack+331861,int_stack+275871,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+233961,int_stack+368161,int_stack+181821,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+168951,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+186276,int_stack+168951,int_stack+218946,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+413536,int_stack+186276,int_stack+306121,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+456436,int_stack+413536,int_stack+331861,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+285936,int_stack+456436,int_stack+368161,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+510886,int_stack+285936,int_stack+233961,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+216306,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+236106,int_stack+216306,int_stack+168951,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+349461,int_stack+236106,int_stack+186276,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+580186,int_stack+349461,int_stack+413536,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+644536,int_stack+580186,int_stack+456436,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+399511,int_stack+644536,int_stack+285936,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+720766,int_stack+399511,int_stack+510886,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+168951,int_stack+38280,int_stack+30800,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+270756,int_stack+168951,int_stack+216306,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+168951,int_stack+270756,int_stack+236106,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+226701,int_stack+168951,int_stack+349461,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+301776,int_stack+226701,int_stack+580186,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+168951,int_stack+301776,int_stack+644536,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+270591,int_stack+168951,int_stack+399511,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+379491,int_stack+270591,int_stack+720766,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+168951,int_stack+49665,int_stack+46695,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+177861,int_stack+53295,int_stack+49665,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+188751,int_stack+177861,int_stack+168951,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+206571,int_stack+57651,int_stack+53295,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+219639,int_stack+206571,int_stack+177861,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+241419,int_stack+219639,int_stack+188751,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+168951,int_stack+62799,int_stack+57651,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+271119,int_stack+168951,int_stack+206571,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+297255,int_stack+271119,int_stack+219639,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+184395,int_stack+297255,int_stack+241419,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+228945,int_stack+68805,int_stack+62799,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+333555,int_stack+228945,int_stack+168951,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+490866,int_stack+333555,int_stack+271119,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+534426,int_stack+490866,int_stack+297255,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+246963,int_stack+534426,int_stack+184395,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+168951,int_stack+75735,int_stack+68805,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+189741,int_stack+168951,int_stack+228945,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+588876,int_stack+189741,int_stack+333555,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+309333,int_stack+588876,int_stack+490866,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+640356,int_stack+309333,int_stack+534426,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+490866,int_stack+640356,int_stack+246963,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+225777,int_stack+83655,int_stack+75735,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+249537,int_stack+225777,int_stack+168951,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+716586,int_stack+249537,int_stack+189741,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+716586,int_stack+588876,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+776646,int_stack+0,int_stack+309333,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+868122,int_stack+776646,int_stack+640356,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+574026,int_stack+868122,int_stack+490866,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+490866,int_stack+92631,int_stack+83655,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+517794,int_stack+490866,int_stack+225777,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+168951,int_stack+517794,int_stack+249537,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+238251,int_stack+168951,int_stack+716586,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+969762,int_stack+238251,int_stack+0,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+168951,int_stack+969762,int_stack+776646,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+680946,int_stack+168951,int_stack+868122,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+168951,int_stack+680946,int_stack+574026,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+490866,int_stack+168951,int_stack+379491,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+302601,int_stack+106239,int_stack+102729,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+313131,int_stack+110529,int_stack+106239,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+326001,int_stack+313131,int_stack+302601,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+347061,int_stack+115677,int_stack+110529,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+362505,int_stack+347061,int_stack+313131,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+388245,int_stack+362505,int_stack+326001,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+302601,int_stack+121761,int_stack+115677,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+423345,int_stack+302601,int_stack+347061,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+423345,int_stack+362505,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+320853,int_stack+0,int_stack+388245,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+373503,int_stack+128859,int_stack+121761,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+454233,int_stack+373503,int_stack+302601,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42900,int_stack+454233,int_stack+423345,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+824991,int_stack+42900,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+889341,int_stack+824991,int_stack+320853,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137049,int_stack+128859,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+302601,int_stack+0,int_stack+373503,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+345189,int_stack+302601,int_stack+454233,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+406029,int_stack+345189,int_stack+42900,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+24570,int_stack+406029,int_stack+824991,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+963051,int_stack+24570,int_stack+889341,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+824991,int_stack+146409,int_stack+137049,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+853071,int_stack+824991,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1061331,int_stack+853071,int_stack+302601,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1132311,int_stack+1061331,int_stack+345189,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1223571,int_stack+1132311,int_stack+406029,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+302601,int_stack+1223571,int_stack+24570,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+302601,int_stack+963051,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+422721,int_stack+157017,int_stack+146409,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+902211,int_stack+422721,int_stack+824991,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+958371,int_stack+902211,int_stack+853071,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+824991,int_stack+958371,int_stack+1061331,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+931461,int_stack+824991,int_stack+1132311,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1059225,int_stack+931461,int_stack+1223571,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+824991,int_stack+1059225,int_stack+302601,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+302601,int_stack+824991,int_stack+0,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+824991,int_stack+302601,int_stack+168951,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+1225941,int_stack+824991,int_stack+490866,2025);
 return int_stack+1225941;}
