/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfmg(Libint_t*, prim_data*);

  /* Computes quartets of (mf|mg) integrals */

REALTYPE *hrr_order_mfmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[10][9] = int_stack + 21725;
 Libint->vrr_classes[10][10] = int_stack + 25355;
 Libint->vrr_classes[10][11] = int_stack + 29711;
 Libint->vrr_classes[10][12] = int_stack + 34859;
 Libint->vrr_classes[10][13] = int_stack + 40865;
 Libint->vrr_classes[11][9] = int_stack + 47795;
 Libint->vrr_classes[11][10] = int_stack + 52085;
 Libint->vrr_classes[11][11] = int_stack + 57233;
 Libint->vrr_classes[11][12] = int_stack + 63317;
 Libint->vrr_classes[11][13] = int_stack + 70415;
 Libint->vrr_classes[12][9] = int_stack + 78605;
 Libint->vrr_classes[12][10] = int_stack + 83610;
 Libint->vrr_classes[12][11] = int_stack + 89616;
 Libint->vrr_classes[12][12] = int_stack + 96714;
 Libint->vrr_classes[12][13] = int_stack + 104995;
 memset(int_stack,0,114550*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 114550;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfmg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+114550,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123625,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+134515,int_stack+123625,int_stack+114550,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+152665,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+165535,int_stack+152665,int_stack+123625,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+187315,int_stack+165535,int_stack+134515,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+114550,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+217565,int_stack+114550,int_stack+152665,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+114550,int_stack+217565,int_stack+165535,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+217565,int_stack+114550,int_stack+187315,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+114550,int_stack+25355,int_stack+21725,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125440,int_stack+29711,int_stack+25355,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+138508,int_stack+125440,int_stack+114550,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+160288,int_stack+34859,int_stack+29711,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+175732,int_stack+160288,int_stack+125440,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+262940,int_stack+175732,int_stack+138508,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+114550,int_stack+40865,int_stack+34859,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+114550,int_stack+160288,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+114550,int_stack+0,int_stack+175732,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+158110,int_stack+114550,int_stack+262940,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+262940,int_stack+158110,int_stack+217565,825);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+114550,int_stack+52085,int_stack+47795,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+127420,int_stack+57233,int_stack+52085,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+127420,int_stack+114550,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+25740,int_stack+63317,int_stack+57233,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+212560,int_stack+25740,int_stack+127420,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+114550,int_stack+212560,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+70415,int_stack+63317,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+399065,int_stack+0,int_stack+25740,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+399065,int_stack+212560,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+399065,int_stack+0,int_stack+114550,78);
 /*--- compute (np|mg) ---*/
 hrr1_build_np(Libint->AB,int_stack+463415,int_stack+399065,int_stack+158110,825);
 /*--- compute (md|mg) ---*/
 hrr1_build_md(Libint->AB,int_stack+626765,int_stack+463415,int_stack+262940,825);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+114550,int_stack+83610,int_stack+78605,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+129565,int_stack+89616,int_stack+83610,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+147583,int_stack+129565,int_stack+114550,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+177613,int_stack+96714,int_stack+89616,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+198907,int_stack+177613,int_stack+129565,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+234943,int_stack+198907,int_stack+147583,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+114550,int_stack+104995,int_stack+96714,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+284993,int_stack+114550,int_stack+177613,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+327581,int_stack+284993,int_stack+198907,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+327581,int_stack+234943,91);
 /*--- compute (op|mg) ---*/
 hrr1_build_op(Libint->AB,int_stack+75075,int_stack+0,int_stack+399065,825);
 /*--- compute (nd|mg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+899015,int_stack+75075,int_stack+463415,825);
 /*--- compute (mf|mg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+899015,int_stack+626765,825);
 return int_stack+0;}
