/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mglk(Libint_t*, prim_data*);

  /* Computes quartets of (mg|lk) integrals */

REALTYPE *hrr_order_mglk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[10][8] = int_stack + 38280;
 Libint->vrr_classes[10][9] = int_stack + 41250;
 Libint->vrr_classes[10][10] = int_stack + 44880;
 Libint->vrr_classes[10][11] = int_stack + 49236;
 Libint->vrr_classes[10][12] = int_stack + 54384;
 Libint->vrr_classes[10][13] = int_stack + 60390;
 Libint->vrr_classes[10][14] = int_stack + 67320;
 Libint->vrr_classes[10][15] = int_stack + 75240;
 Libint->vrr_classes[11][8] = int_stack + 84216;
 Libint->vrr_classes[11][9] = int_stack + 87726;
 Libint->vrr_classes[11][10] = int_stack + 92016;
 Libint->vrr_classes[11][11] = int_stack + 97164;
 Libint->vrr_classes[11][12] = int_stack + 103248;
 Libint->vrr_classes[11][13] = int_stack + 110346;
 Libint->vrr_classes[11][14] = int_stack + 118536;
 Libint->vrr_classes[11][15] = int_stack + 127896;
 Libint->vrr_classes[12][8] = int_stack + 138504;
 Libint->vrr_classes[12][9] = int_stack + 142599;
 Libint->vrr_classes[12][10] = int_stack + 147604;
 Libint->vrr_classes[12][11] = int_stack + 153610;
 Libint->vrr_classes[12][12] = int_stack + 160708;
 Libint->vrr_classes[12][13] = int_stack + 168989;
 Libint->vrr_classes[12][14] = int_stack + 178544;
 Libint->vrr_classes[12][15] = int_stack + 189464;
 Libint->vrr_classes[13][8] = int_stack + 201840;
 Libint->vrr_classes[13][9] = int_stack + 206565;
 Libint->vrr_classes[13][10] = int_stack + 212340;
 Libint->vrr_classes[13][11] = int_stack + 219270;
 Libint->vrr_classes[13][12] = int_stack + 227460;
 Libint->vrr_classes[13][13] = int_stack + 237015;
 Libint->vrr_classes[13][14] = int_stack + 248040;
 Libint->vrr_classes[13][15] = int_stack + 260640;
 memset(int_stack,0,274920*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 274920;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mglk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+274920,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+282345,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+291420,int_stack+282345,int_stack+274920,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+306270,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+317160,int_stack+306270,int_stack+282345,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+335310,int_stack+317160,int_stack+291420,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+274920,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+360060,int_stack+274920,int_stack+306270,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+381840,int_stack+360060,int_stack+317160,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+287790,int_stack+381840,int_stack+335310,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+324915,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+412090,int_stack+324915,int_stack+274920,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+437830,int_stack+412090,int_stack+360060,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+474130,int_stack+437830,int_stack+381840,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+339930,int_stack+474130,int_stack+287790,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274920,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+292245,int_stack+274920,int_stack+324915,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+519505,int_stack+292245,int_stack+412090,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+562405,int_stack+519505,int_stack+437830,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+391905,int_stack+562405,int_stack+474130,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+616855,int_stack+391905,int_stack+339930,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+322275,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+342075,int_stack+322275,int_stack+274920,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+455430,int_stack+342075,int_stack+292245,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+274920,int_stack+455430,int_stack+519505,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+455430,int_stack+274920,int_stack+562405,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+274920,int_stack+455430,int_stack+391905,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+359620,int_stack+274920,int_stack+616855,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+274920,int_stack+41250,int_stack+38280,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+283830,int_stack+44880,int_stack+41250,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+294720,int_stack+283830,int_stack+274920,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+312540,int_stack+49236,int_stack+44880,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+325608,int_stack+312540,int_stack+283830,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+448720,int_stack+325608,int_stack+294720,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+274920,int_stack+54384,int_stack+49236,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+478420,int_stack+274920,int_stack+312540,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+504556,int_stack+478420,int_stack+325608,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+290364,int_stack+504556,int_stack+448720,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+448720,int_stack+60390,int_stack+54384,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+540856,int_stack+448720,int_stack+274920,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+571744,int_stack+540856,int_stack+478420,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+615304,int_stack+571744,int_stack+504556,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+466738,int_stack+615304,int_stack+290364,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274920,int_stack+67320,int_stack+60390,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+295710,int_stack+274920,int_stack+448720,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+295710,int_stack+540856,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+669754,int_stack+0,int_stack+571744,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+529108,int_stack+669754,int_stack+615304,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+735094,int_stack+529108,int_stack+466738,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+448720,int_stack+75240,int_stack+67320,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+472480,int_stack+448720,int_stack+274920,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+605338,int_stack+472480,int_stack+295710,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+274920,int_stack+605338,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+818254,int_stack+274920,int_stack+669754,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+605338,int_stack+818254,int_stack+529108,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+448720,int_stack+605338,int_stack+735094,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+555640,int_stack+448720,int_stack+359620,1620);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+274920,int_stack+87726,int_stack+84216,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+285450,int_stack+92016,int_stack+87726,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+298320,int_stack+285450,int_stack+274920,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+319380,int_stack+97164,int_stack+92016,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+334824,int_stack+319380,int_stack+285450,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+360564,int_stack+334824,int_stack+298320,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+274920,int_stack+103248,int_stack+97164,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+395664,int_stack+274920,int_stack+319380,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+395664,int_stack+334824,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+293172,int_stack+0,int_stack+360564,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+345822,int_stack+110346,int_stack+103248,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+42900,int_stack+345822,int_stack+274920,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+822940,int_stack+42900,int_stack+395664,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+367116,int_stack+822940,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+874420,int_stack+367116,int_stack+293172,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+118536,int_stack+110346,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+274920,int_stack+0,int_stack+345822,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+948130,int_stack+274920,int_stack+42900,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+24570,int_stack+948130,int_stack+822940,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1008970,int_stack+24570,int_stack+367116,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+317508,int_stack+1008970,int_stack+874420,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+822940,int_stack+127896,int_stack+118536,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+851020,int_stack+822940,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1099060,int_stack+851020,int_stack+274920,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+822940,int_stack+1099060,int_stack+948130,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1099060,int_stack+822940,int_stack+24570,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+822940,int_stack+1099060,int_stack+1008970,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+943060,int_stack+822940,int_stack+317508,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1069420,int_stack+943060,int_stack+448720,1620);
 /*--- compute (md|lk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1390180,int_stack+1069420,int_stack+555640,1620);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+274920,int_stack+142599,int_stack+138504,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+287205,int_stack+147604,int_stack+142599,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+302220,int_stack+287205,int_stack+274920,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+326790,int_stack+153610,int_stack+147604,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+344808,int_stack+326790,int_stack+287205,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+374838,int_stack+344808,int_stack+302220,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+274920,int_stack+160708,int_stack+153610,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+415788,int_stack+274920,int_stack+326790,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+451824,int_stack+415788,int_stack+344808,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+296214,int_stack+451824,int_stack+374838,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+357639,int_stack+168989,int_stack+160708,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+501874,int_stack+357639,int_stack+274920,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+544462,int_stack+501874,int_stack+415788,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+604522,int_stack+544462,int_stack+451824,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+382482,int_stack+604522,int_stack+296214,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274920,int_stack+178544,int_stack+168989,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303585,int_stack+274920,int_stack+357639,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+679597,int_stack+303585,int_stack+501874,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+750577,int_stack+679597,int_stack+544462,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+468477,int_stack+750577,int_stack+604522,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+468477,int_stack+382482,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+353271,int_stack+189464,int_stack+178544,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+386031,int_stack+353271,int_stack+274920,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+573582,int_stack+386031,int_stack+303585,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+274920,int_stack+573582,int_stack+679597,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+573582,int_stack+274920,int_stack+750577,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+274920,int_stack+573582,int_stack+468477,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+415060,int_stack+274920,int_stack+0,91);
 /*--- compute (op|lk) ---*/
 hrr1_build_op(Libint->AB,int_stack+562480,int_stack+415060,int_stack+943060,1620);
 /*--- compute (nd|lk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1924780,int_stack+562480,int_stack+1069420,1620);
 /*--- compute (mf|lk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2566300,int_stack+1924780,int_stack+1390180,1620);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+206565,int_stack+201840,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+212340,int_stack+206565,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+219270,int_stack+212340,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115290,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+227460,int_stack+219270,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162540,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+274920,int_stack+162540,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+274920,int_stack+115290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95445,int_stack+237015,int_stack+227460,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+332670,int_stack+95445,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+941560,int_stack+332670,int_stack+162540,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+124110,int_stack+941560,int_stack+274920,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1010860,int_stack+124110,int_stack+24570,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+274920,int_stack+248040,int_stack+237015,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+274920,int_stack+95445,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1110085,int_stack+0,int_stack+332670,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+307995,int_stack+1110085,int_stack+941560,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1191985,int_stack+307995,int_stack+124110,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+57330,int_stack+1191985,int_stack+1010860,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+941560,int_stack+260640,int_stack+248040,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+979360,int_stack+941560,int_stack+274920,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+189630,int_stack+979360,int_stack+0,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+941560,int_stack+189630,int_stack+1110085,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1313260,int_stack+941560,int_stack+307995,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+941560,int_stack+1313260,int_stack+1191985,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1103260,int_stack+941560,int_stack+57330,105);
 /*--- compute (qp|lk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1273360,int_stack+1103260,int_stack+415060,1620);
 /*--- compute (od|lk) ---*/
 hrr1_build_od(Libint->AB,int_stack+3457300,int_stack+1273360,int_stack+562480,1620);
 /*--- compute (nf|lk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+3457300,int_stack+1924780,1620);
 /*--- compute (mg|lk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1069200,int_stack+0,int_stack+2566300,1620);
 return int_stack+1069200;}
