/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgmm(Libint_t*, prim_data*);

  /* Computes quartets of (mg|mm) integrals */

REALTYPE *hrr_order_mgmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 Libint->vrr_classes[12][9] = int_stack + 231835;
 Libint->vrr_classes[12][10] = int_stack + 236840;
 Libint->vrr_classes[12][11] = int_stack + 242846;
 Libint->vrr_classes[12][12] = int_stack + 249944;
 Libint->vrr_classes[12][13] = int_stack + 258225;
 Libint->vrr_classes[12][14] = int_stack + 267780;
 Libint->vrr_classes[12][15] = int_stack + 278700;
 Libint->vrr_classes[12][16] = int_stack + 291076;
 Libint->vrr_classes[12][17] = int_stack + 304999;
 Libint->vrr_classes[12][18] = int_stack + 320560;
 Libint->vrr_classes[13][9] = int_stack + 337850;
 Libint->vrr_classes[13][10] = int_stack + 343625;
 Libint->vrr_classes[13][11] = int_stack + 350555;
 Libint->vrr_classes[13][12] = int_stack + 358745;
 Libint->vrr_classes[13][13] = int_stack + 368300;
 Libint->vrr_classes[13][14] = int_stack + 379325;
 Libint->vrr_classes[13][15] = int_stack + 391925;
 Libint->vrr_classes[13][16] = int_stack + 406205;
 Libint->vrr_classes[13][17] = int_stack + 422270;
 Libint->vrr_classes[13][18] = int_stack + 440225;
 memset(int_stack,0,460175*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 460175;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+460175,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+469250,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+480140,int_stack+469250,int_stack+460175,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+498290,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+511160,int_stack+498290,int_stack+469250,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+532940,int_stack+511160,int_stack+480140,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+460175,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+563190,int_stack+460175,int_stack+498290,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+588930,int_stack+563190,int_stack+511160,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+475190,int_stack+588930,int_stack+532940,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+520565,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+625230,int_stack+520565,int_stack+460175,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+655260,int_stack+625230,int_stack+563190,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+698160,int_stack+655260,int_stack+588930,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+537890,int_stack+698160,int_stack+475190,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+460175,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+479975,int_stack+460175,int_stack+520565,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+752610,int_stack+479975,int_stack+625230,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+802660,int_stack+752610,int_stack+655260,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+601415,int_stack+802660,int_stack+698160,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+867010,int_stack+601415,int_stack+537890,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+514625,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+537065,int_stack+514625,int_stack+460175,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+677645,int_stack+537065,int_stack+479975,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+951710,int_stack+677645,int_stack+752610,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1026785,int_stack+951710,int_stack+802660,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+735395,int_stack+1026785,int_stack+601415,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1116875,int_stack+735395,int_stack+867010,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+460175,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+576665,int_stack+460175,int_stack+514625,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+837035,int_stack+576665,int_stack+537065,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+485420,int_stack+837035,int_stack+677645,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+621545,int_stack+485420,int_stack+951710,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+903035,int_stack+621545,int_stack+1026785,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1225775,int_stack+903035,int_stack+735395,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1356455,int_stack+1225775,int_stack+1116875,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+726650,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+754865,int_stack+726650,int_stack+460175,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1023155,int_stack+754865,int_stack+576665,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+726650,int_stack+1023155,int_stack+837035,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1023155,int_stack+726650,int_stack+485420,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+726650,int_stack+1023155,int_stack+621545,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1023155,int_stack+726650,int_stack+903035,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+460175,int_stack+1023155,int_stack+1225775,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+623525,int_stack+460175,int_stack+1356455,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+460175,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+471065,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+484133,int_stack+471065,int_stack+460175,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+505913,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+521357,int_stack+505913,int_stack+471065,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+547493,int_stack+521357,int_stack+484133,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+460175,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+583793,int_stack+460175,int_stack+505913,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+789900,int_stack+583793,int_stack+521357,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+478193,int_stack+789900,int_stack+547493,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+532643,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+833460,int_stack+532643,int_stack+460175,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+869496,int_stack+833460,int_stack+583793,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+553433,int_stack+869496,int_stack+789900,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+920976,int_stack+553433,int_stack+478193,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+789900,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+460175,int_stack+789900,int_stack+532643,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+997206,int_stack+460175,int_stack+833460,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1057266,int_stack+997206,int_stack+869496,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+813660,int_stack+1057266,int_stack+553433,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+501755,int_stack+813660,int_stack+920976,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+905136,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+932064,int_stack+905136,int_stack+789900,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1134486,int_stack+932064,int_stack+460175,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1203786,int_stack+1134486,int_stack+997206,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1293876,int_stack+1203786,int_stack+1057266,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+979584,int_stack+1293876,int_stack+813660,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1401984,int_stack+979584,int_stack+501755,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+460175,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+490469,int_stack+460175,int_stack+905136,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+544325,int_stack+490469,int_stack+932064,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+789900,int_stack+544325,int_stack+1134486,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1532664,int_stack+789900,int_stack+1203786,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1101552,int_stack+1532664,int_stack+1293876,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1658790,int_stack+1101552,int_stack+979584,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+893850,int_stack+1658790,int_stack+1401984,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1057200,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1245696,int_stack+1057200,int_stack+460175,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1306284,int_stack+1245696,int_stack+490469,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1396044,int_stack+1306284,int_stack+544325,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1245696,int_stack+1396044,int_stack+789900,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1815606,int_stack+1245696,int_stack+1532664,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1245696,int_stack+1815606,int_stack+1101552,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1431024,int_stack+1245696,int_stack+1658790,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1627044,int_stack+1431024,int_stack+893850,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+789900,int_stack+1627044,int_stack+623525,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1826694,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1839564,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1855008,int_stack+1839564,int_stack+1826694,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1880748,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1899000,int_stack+1880748,int_stack+1839564,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1929888,int_stack+1899000,int_stack+1855008,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1826694,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1289025,int_stack+1826694,int_stack+1880748,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1325529,int_stack+1289025,int_stack+1899000,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1847988,int_stack+1325529,int_stack+1929888,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1912338,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1936908,int_stack+1912338,int_stack+1826694,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1377009,int_stack+1936908,int_stack+1289025,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1437849,int_stack+1377009,int_stack+1325529,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1515069,int_stack+1437849,int_stack+1847988,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1289025,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1317105,int_stack+1289025,int_stack+1912338,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1826694,int_stack+1317105,int_stack+1936908,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+460175,int_stack+1826694,int_stack+1377009,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+551435,int_stack+460175,int_stack+1437849,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1366245,int_stack+551435,int_stack+1515069,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1486365,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1518189,int_stack+1486365,int_stack+1289025,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1897674,int_stack+1518189,int_stack+1317105,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+659543,int_stack+1897674,int_stack+1826694,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+659543,int_stack+460175,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1979574,int_stack+0,int_stack+551435,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+460175,int_stack+1979574,int_stack+1366245,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+614615,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1826694,int_stack+614615,int_stack+1486365,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1289025,int_stack+1826694,int_stack+1518189,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1382625,int_stack+1289025,int_stack+1897674,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2123718,int_stack+1382625,int_stack+659543,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2272776,int_stack+2123718,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2272776,int_stack+1979574,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1890342,int_stack+0,int_stack+460175,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+460175,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+500189,int_stack+460175,int_stack+614615,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+571793,int_stack+500189,int_stack+1826694,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2443128,int_stack+571793,int_stack+1289025,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+460175,int_stack+2443128,int_stack+1382625,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1289025,int_stack+460175,int_stack+2123718,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+460175,int_stack+1289025,int_stack+2272776,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1289025,int_stack+460175,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+460175,int_stack+1289025,int_stack+1890342,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1826694,int_stack+460175,int_stack+1627044,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2425644,int_stack+1826694,int_stack+789900,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+236840,int_stack+231835,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+242846,int_stack+236840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+249944,int_stack+242846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+258225,int_stack+249944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+696125,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+696125,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+267780,int_stack+258225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+756185,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+827165,int_stack+756185,int_stack+696125,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+917255,int_stack+827165,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+696125,int_stack+278700,int_stack+267780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+696125,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+756185,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1022360,int_stack+140140,int_stack+827165,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+728885,int_stack+1022360,int_stack+917255,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+869025,int_stack+291076,int_stack+278700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+906153,int_stack+869025,int_stack+696125,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1148486,int_stack+906153,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1244036,int_stack+1148486,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1368251,int_stack+1244036,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1368251,int_stack+1022360,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1517309,int_stack+0,int_stack+728885,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+304999,int_stack+291076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+869025,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+696125,int_stack+209937,int_stack+906153,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+805325,int_stack+696125,int_stack+1148486,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+948650,int_stack+805325,int_stack+1244036,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1122551,int_stack+948650,int_stack+1368251,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3423894,int_stack+1122551,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3640110,int_stack+3423894,int_stack+1517309,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+320560,int_stack+304999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+46683,int_stack+0,int_stack+168168,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1321295,int_stack+46683,int_stack+209937,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1321295,int_stack+696125,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1321295,int_stack+0,int_stack+805325,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1321295,int_stack+948650,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1321295,int_stack+0,int_stack+1122551,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1321295,int_stack+3423894,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+696125,int_stack+0,int_stack+3640110,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+971400,int_stack+696125,int_stack+460175,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3423894,int_stack+971400,int_stack+1826694,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4621794,int_stack+3423894,int_stack+2425644,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+460175,int_stack+343625,int_stack+337850,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+477500,int_stack+350555,int_stack+343625,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+498290,int_stack+477500,int_stack+460175,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+532940,int_stack+358745,int_stack+350555,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+557510,int_stack+532940,int_stack+477500,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+599090,int_stack+557510,int_stack+498290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+460175,int_stack+368300,int_stack+358745,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+460175,int_stack+532940,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+557510,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+488840,int_stack+49140,int_stack+599090,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+575465,int_stack+379325,int_stack+368300,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+608540,int_stack+575465,int_stack+460175,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118440,int_stack+608540,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200340,int_stack+118440,int_stack+49140,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1679250,int_stack+200340,int_stack+488840,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+391925,int_stack+379325,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+575465,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+460175,int_stack+37800,int_stack+608540,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+555725,int_stack+460175,int_stack+118440,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1800525,int_stack+555725,int_stack+200340,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103950,int_stack+1800525,int_stack+1679250,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1679250,int_stack+406205,int_stack+391925,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1722090,int_stack+1679250,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+265650,int_stack+1722090,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1946055,int_stack+265650,int_stack+460175,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2089380,int_stack+1946055,int_stack+555725,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+460175,int_stack+2089380,int_stack+1800525,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2261370,int_stack+460175,int_stack+103950,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+422270,int_stack+406205,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48195,int_stack+0,int_stack+1679250,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133875,int_stack+48195,int_stack+1722090,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1679250,int_stack+133875,int_stack+265650,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2469270,int_stack+1679250,int_stack+1946055,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1844625,int_stack+2469270,int_stack+2089380,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2669925,int_stack+1844625,int_stack+460175,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2919405,int_stack+2669925,int_stack+2261370,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+460175,int_stack+440225,int_stack+422270,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+514040,int_stack+460175,int_stack+0,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2073945,int_stack+514040,int_stack+48195,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2216745,int_stack+2073945,int_stack+133875,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+2216745,int_stack+1679250,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2073945,int_stack+0,int_stack+2469270,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+2073945,int_stack+1844625,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+294840,int_stack+0,int_stack+2669925,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1679250,int_stack+294840,int_stack+2919405,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1996875,int_stack+1679250,int_stack+696125,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+6285544,int_stack+1996875,int_stack+971400,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+6285544,int_stack+3423894,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1996500,int_stack+0,int_stack+4621794,3025);
 return int_stack+1996500;}
