/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mgni(Libint_t*, prim_data*);

  /* Computes quartets of (mg|ni) integrals */

REALTYPE *hrr_order_mgni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[10][10] = int_stack + 41195;
 Libint->vrr_classes[10][11] = int_stack + 45551;
 Libint->vrr_classes[10][12] = int_stack + 50699;
 Libint->vrr_classes[10][13] = int_stack + 56705;
 Libint->vrr_classes[10][14] = int_stack + 63635;
 Libint->vrr_classes[10][15] = int_stack + 71555;
 Libint->vrr_classes[10][16] = int_stack + 80531;
 Libint->vrr_classes[11][10] = int_stack + 90629;
 Libint->vrr_classes[11][11] = int_stack + 95777;
 Libint->vrr_classes[11][12] = int_stack + 101861;
 Libint->vrr_classes[11][13] = int_stack + 108959;
 Libint->vrr_classes[11][14] = int_stack + 117149;
 Libint->vrr_classes[11][15] = int_stack + 126509;
 Libint->vrr_classes[11][16] = int_stack + 137117;
 Libint->vrr_classes[12][10] = int_stack + 149051;
 Libint->vrr_classes[12][11] = int_stack + 155057;
 Libint->vrr_classes[12][12] = int_stack + 162155;
 Libint->vrr_classes[12][13] = int_stack + 170436;
 Libint->vrr_classes[12][14] = int_stack + 179991;
 Libint->vrr_classes[12][15] = int_stack + 190911;
 Libint->vrr_classes[12][16] = int_stack + 203287;
 Libint->vrr_classes[13][10] = int_stack + 217210;
 Libint->vrr_classes[13][11] = int_stack + 224140;
 Libint->vrr_classes[13][12] = int_stack + 232330;
 Libint->vrr_classes[13][13] = int_stack + 241885;
 Libint->vrr_classes[13][14] = int_stack + 252910;
 Libint->vrr_classes[13][15] = int_stack + 265510;
 Libint->vrr_classes[13][16] = int_stack + 279790;
 memset(int_stack,0,295855*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 295855;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mgni(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+295855,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+306745,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+319615,int_stack+306745,int_stack+295855,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+341395,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+356410,int_stack+341395,int_stack+306745,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+382150,int_stack+356410,int_stack+319615,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+295855,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+418450,int_stack+295855,int_stack+341395,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+313180,int_stack+418450,int_stack+356410,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+448480,int_stack+313180,int_stack+382150,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+356080,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+375880,int_stack+356080,int_stack+295855,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+502930,int_stack+375880,int_stack+418450,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+552980,int_stack+502930,int_stack+313180,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+617330,int_stack+552980,int_stack+448480,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+295855,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+410530,int_stack+295855,int_stack+356080,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+295855,int_stack+410530,int_stack+375880,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+353605,int_stack+295855,int_stack+502930,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+428680,int_stack+353605,int_stack+552980,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+295855,int_stack+428680,int_stack+617330,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+397495,int_stack+45551,int_stack+41195,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+410563,int_stack+50699,int_stack+45551,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+426007,int_stack+410563,int_stack+397495,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+452143,int_stack+56705,int_stack+50699,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+470161,int_stack+452143,int_stack+410563,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+501049,int_stack+470161,int_stack+426007,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+397495,int_stack+63635,int_stack+56705,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+544609,int_stack+397495,int_stack+452143,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+418285,int_stack+544609,int_stack+470161,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+580645,int_stack+418285,int_stack+501049,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+469765,int_stack+71555,int_stack+63635,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+493525,int_stack+469765,int_stack+397495,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+493525,int_stack+544609,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+645985,int_stack+0,int_stack+418285,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+723205,int_stack+645985,int_stack+580645,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+397495,int_stack+80531,int_stack+71555,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+535105,int_stack+397495,int_stack+469765,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+397495,int_stack+535105,int_stack+493525,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+466795,int_stack+397495,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+814681,int_stack+466795,int_stack+645985,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+397495,int_stack+814681,int_stack+723205,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+519463,int_stack+397495,int_stack+295855,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+295855,int_stack+95777,int_stack+90629,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+311299,int_stack+101861,int_stack+95777,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+329551,int_stack+311299,int_stack+295855,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+360439,int_stack+108959,int_stack+101861,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+360439,int_stack+311299,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+36504,int_stack+0,int_stack+329551,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+295855,int_stack+117149,int_stack+108959,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+824383,int_stack+295855,int_stack+360439,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+320425,int_stack+824383,int_stack+0,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+866971,int_stack+320425,int_stack+36504,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+126509,int_stack+117149,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+28080,int_stack+0,int_stack+295855,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+944191,int_stack+28080,int_stack+824383,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1015171,int_stack+944191,int_stack+320425,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1106431,int_stack+1015171,int_stack+866971,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+824383,int_stack+137117,int_stack+126509,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+856207,int_stack+824383,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+295855,int_stack+856207,int_stack+28080,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+295855,int_stack+944191,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+824383,int_stack+0,int_stack+1015171,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+824383,int_stack+1106431,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+824383,int_stack+0,int_stack+397495,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+1190287,int_stack+824383,int_stack+519463,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+295855,int_stack+155057,int_stack+149051,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+313873,int_stack+162155,int_stack+155057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+335167,int_stack+313873,int_stack+295855,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+371203,int_stack+170436,int_stack+162155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+396046,int_stack+371203,int_stack+313873,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+438634,int_stack+396046,int_stack+335167,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+295855,int_stack+179991,int_stack+170436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+498694,int_stack+295855,int_stack+371203,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+324520,int_stack+498694,int_stack+396046,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+548380,int_stack+324520,int_stack+438634,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+395500,int_stack+190911,int_stack+179991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+428260,int_stack+395500,int_stack+295855,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+638470,int_stack+428260,int_stack+498694,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1800127,int_stack+638470,int_stack+324520,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1906597,int_stack+1800127,int_stack+548380,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+295855,int_stack+203287,int_stack+190911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+485590,int_stack+295855,int_stack+395500,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+295855,int_stack+485590,int_stack+428260,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+391405,int_stack+295855,int_stack+638470,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+515620,int_stack+391405,int_stack+1800127,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+295855,int_stack+515620,int_stack+1906597,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1800127,int_stack+295855,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2232559,int_stack+1800127,int_stack+824383,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+2964367,int_stack+2232559,int_stack+1190287,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+224140,int_stack+217210,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+232330,int_stack+224140,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+241885,int_stack+232330,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+252910,int_stack+241885,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+464023,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+464023,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+521353,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+265510,int_stack+252910,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+625303,int_stack+152775,int_stack+464023,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+720853,int_stack+625303,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+843703,int_stack+720853,int_stack+521353,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+464023,int_stack+279790,int_stack+265510,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+506863,int_stack+464023,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+506863,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+464023,int_stack+0,int_stack+625303,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+464023,int_stack+720853,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+464023,int_stack+0,int_stack+843703,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+658063,int_stack+464023,int_stack+295855,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+3980767,int_stack+658063,int_stack+1800127,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+3980767,int_stack+2232559,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1219680,int_stack+0,int_stack+2964367,1848);
 return int_stack+1219680;}
