/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mill(Libint_t*, prim_data*);

  /* Computes quartets of (mi|ll) integrals */

REALTYPE *hrr_order_mill(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[9][16] = int_stack + 38280;
 Libint->vrr_classes[10][8] = int_stack + 46695;
 Libint->vrr_classes[10][9] = int_stack + 49665;
 Libint->vrr_classes[10][10] = int_stack + 53295;
 Libint->vrr_classes[10][11] = int_stack + 57651;
 Libint->vrr_classes[10][12] = int_stack + 62799;
 Libint->vrr_classes[10][13] = int_stack + 68805;
 Libint->vrr_classes[10][14] = int_stack + 75735;
 Libint->vrr_classes[10][15] = int_stack + 83655;
 Libint->vrr_classes[10][16] = int_stack + 92631;
 Libint->vrr_classes[11][8] = int_stack + 102729;
 Libint->vrr_classes[11][9] = int_stack + 106239;
 Libint->vrr_classes[11][10] = int_stack + 110529;
 Libint->vrr_classes[11][11] = int_stack + 115677;
 Libint->vrr_classes[11][12] = int_stack + 121761;
 Libint->vrr_classes[11][13] = int_stack + 128859;
 Libint->vrr_classes[11][14] = int_stack + 137049;
 Libint->vrr_classes[11][15] = int_stack + 146409;
 Libint->vrr_classes[11][16] = int_stack + 157017;
 Libint->vrr_classes[12][8] = int_stack + 168951;
 Libint->vrr_classes[12][9] = int_stack + 173046;
 Libint->vrr_classes[12][10] = int_stack + 178051;
 Libint->vrr_classes[12][11] = int_stack + 184057;
 Libint->vrr_classes[12][12] = int_stack + 191155;
 Libint->vrr_classes[12][13] = int_stack + 199436;
 Libint->vrr_classes[12][14] = int_stack + 208991;
 Libint->vrr_classes[12][15] = int_stack + 219911;
 Libint->vrr_classes[12][16] = int_stack + 232287;
 Libint->vrr_classes[13][8] = int_stack + 246210;
 Libint->vrr_classes[13][9] = int_stack + 250935;
 Libint->vrr_classes[13][10] = int_stack + 256710;
 Libint->vrr_classes[13][11] = int_stack + 263640;
 Libint->vrr_classes[13][12] = int_stack + 271830;
 Libint->vrr_classes[13][13] = int_stack + 281385;
 Libint->vrr_classes[13][14] = int_stack + 292410;
 Libint->vrr_classes[13][15] = int_stack + 305010;
 Libint->vrr_classes[13][16] = int_stack + 319290;
 Libint->vrr_classes[14][8] = int_stack + 335355;
 Libint->vrr_classes[14][9] = int_stack + 340755;
 Libint->vrr_classes[14][10] = int_stack + 347355;
 Libint->vrr_classes[14][11] = int_stack + 355275;
 Libint->vrr_classes[14][12] = int_stack + 364635;
 Libint->vrr_classes[14][13] = int_stack + 375555;
 Libint->vrr_classes[14][14] = int_stack + 388155;
 Libint->vrr_classes[14][15] = int_stack + 402555;
 Libint->vrr_classes[14][16] = int_stack + 418875;
 Libint->vrr_classes[15][8] = int_stack + 437235;
 Libint->vrr_classes[15][9] = int_stack + 443355;
 Libint->vrr_classes[15][10] = int_stack + 450835;
 Libint->vrr_classes[15][11] = int_stack + 459811;
 Libint->vrr_classes[15][12] = int_stack + 470419;
 Libint->vrr_classes[15][13] = int_stack + 482795;
 Libint->vrr_classes[15][14] = int_stack + 497075;
 Libint->vrr_classes[15][15] = int_stack + 513395;
 Libint->vrr_classes[15][16] = int_stack + 531891;
 memset(int_stack,0,552699*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 552699;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mill(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+552699,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+560124,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+569199,int_stack+560124,int_stack+552699,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+584049,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+594939,int_stack+584049,int_stack+560124,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+613089,int_stack+594939,int_stack+569199,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+552699,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+637839,int_stack+552699,int_stack+584049,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+659619,int_stack+637839,int_stack+594939,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+565569,int_stack+659619,int_stack+613089,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+602694,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+689869,int_stack+602694,int_stack+552699,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+715609,int_stack+689869,int_stack+637839,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+751909,int_stack+715609,int_stack+659619,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+617709,int_stack+751909,int_stack+565569,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+552699,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+570024,int_stack+552699,int_stack+602694,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+797284,int_stack+570024,int_stack+689869,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+840184,int_stack+797284,int_stack+715609,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+669684,int_stack+840184,int_stack+751909,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+894634,int_stack+669684,int_stack+617709,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+600054,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+619854,int_stack+600054,int_stack+552699,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+733209,int_stack+619854,int_stack+570024,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+963934,int_stack+733209,int_stack+797284,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1028284,int_stack+963934,int_stack+840184,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+783259,int_stack+1028284,int_stack+669684,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1104514,int_stack+783259,int_stack+894634,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+552699,int_stack+38280,int_stack+30800,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+654504,int_stack+552699,int_stack+600054,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+552699,int_stack+654504,int_stack+619854,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+610449,int_stack+552699,int_stack+733209,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+685524,int_stack+610449,int_stack+963934,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+552699,int_stack+685524,int_stack+1028284,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+654339,int_stack+552699,int_stack+783259,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+763239,int_stack+654339,int_stack+1104514,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+552699,int_stack+49665,int_stack+46695,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+561609,int_stack+53295,int_stack+49665,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+572499,int_stack+561609,int_stack+552699,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+590319,int_stack+57651,int_stack+53295,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+603387,int_stack+590319,int_stack+561609,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+625167,int_stack+603387,int_stack+572499,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+552699,int_stack+62799,int_stack+57651,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+654867,int_stack+552699,int_stack+590319,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+681003,int_stack+654867,int_stack+603387,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+568143,int_stack+681003,int_stack+625167,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+612693,int_stack+68805,int_stack+62799,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+717303,int_stack+612693,int_stack+552699,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+874614,int_stack+717303,int_stack+654867,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+918174,int_stack+874614,int_stack+681003,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+630711,int_stack+918174,int_stack+568143,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+552699,int_stack+75735,int_stack+68805,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+573489,int_stack+552699,int_stack+612693,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+972624,int_stack+573489,int_stack+717303,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+693081,int_stack+972624,int_stack+874614,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1024104,int_stack+693081,int_stack+918174,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+874614,int_stack+1024104,int_stack+630711,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+609525,int_stack+83655,int_stack+75735,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+633285,int_stack+609525,int_stack+552699,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1100334,int_stack+633285,int_stack+573489,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+1100334,int_stack+972624,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1160394,int_stack+0,int_stack+693081,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1251870,int_stack+1160394,int_stack+1024104,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+957774,int_stack+1251870,int_stack+874614,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+874614,int_stack+92631,int_stack+83655,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+901542,int_stack+874614,int_stack+609525,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+552699,int_stack+901542,int_stack+633285,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+621999,int_stack+552699,int_stack+1100334,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1353510,int_stack+621999,int_stack+0,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+552699,int_stack+1353510,int_stack+1160394,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1064694,int_stack+552699,int_stack+1251870,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+552699,int_stack+1064694,int_stack+957774,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+874614,int_stack+552699,int_stack+763239,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+686349,int_stack+106239,int_stack+102729,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+696879,int_stack+110529,int_stack+106239,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+709749,int_stack+696879,int_stack+686349,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+730809,int_stack+115677,int_stack+110529,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+746253,int_stack+730809,int_stack+696879,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+771993,int_stack+746253,int_stack+709749,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+686349,int_stack+121761,int_stack+115677,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+807093,int_stack+686349,int_stack+730809,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+807093,int_stack+746253,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+704601,int_stack+0,int_stack+771993,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+757251,int_stack+128859,int_stack+121761,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+837981,int_stack+757251,int_stack+686349,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42900,int_stack+837981,int_stack+807093,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1208739,int_stack+42900,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1273089,int_stack+1208739,int_stack+704601,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137049,int_stack+128859,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+686349,int_stack+0,int_stack+757251,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+728937,int_stack+686349,int_stack+837981,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+789777,int_stack+728937,int_stack+42900,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+24570,int_stack+789777,int_stack+1208739,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1346799,int_stack+24570,int_stack+1273089,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1208739,int_stack+146409,int_stack+137049,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1236819,int_stack+1208739,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1445079,int_stack+1236819,int_stack+686349,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1516059,int_stack+1445079,int_stack+728937,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1607319,int_stack+1516059,int_stack+789777,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+686349,int_stack+1607319,int_stack+24570,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+686349,int_stack+1346799,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+806469,int_stack+157017,int_stack+146409,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1285959,int_stack+806469,int_stack+1208739,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1342119,int_stack+1285959,int_stack+1236819,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1208739,int_stack+1342119,int_stack+1445079,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1315209,int_stack+1208739,int_stack+1516059,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1442973,int_stack+1315209,int_stack+1607319,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1208739,int_stack+1442973,int_stack+686349,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+686349,int_stack+1208739,int_stack+0,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+1208739,int_stack+686349,int_stack+552699,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+1609689,int_stack+1208739,int_stack+874614,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+552699,int_stack+173046,int_stack+168951,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+564984,int_stack+178051,int_stack+173046,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+579999,int_stack+564984,int_stack+552699,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+604569,int_stack+184057,int_stack+178051,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+622587,int_stack+604569,int_stack+564984,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+622587,int_stack+579999,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+552699,int_stack+191155,int_stack+184057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40950,int_stack+552699,int_stack+604569,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+76986,int_stack+40950,int_stack+622587,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+573993,int_stack+76986,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+199436,int_stack+191155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+635418,int_stack+0,int_stack+552699,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+127036,int_stack+635418,int_stack+40950,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+844299,int_stack+127036,int_stack+76986,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+24843,int_stack+844299,int_stack+573993,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+552699,int_stack+208991,int_stack+199436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+581364,int_stack+552699,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+919374,int_stack+581364,int_stack+635418,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+990354,int_stack+919374,int_stack+127036,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1080444,int_stack+990354,int_stack+844299,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2277939,int_stack+1080444,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+844299,int_stack+219911,int_stack+208991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+844299,int_stack+552699,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+581364,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+552699,int_stack+57330,int_stack+919374,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2392599,int_stack+552699,int_stack+990354,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+877059,int_stack+2392599,int_stack+1080444,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1017199,int_stack+877059,int_stack+2277939,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2277939,int_stack+232287,int_stack+219911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2315067,int_stack+2277939,int_stack+844299,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140140,int_stack+2315067,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2518725,int_stack+140140,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+2518725,int_stack+552699,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2518725,int_stack+0,int_stack+2392599,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+2518725,int_stack+877059,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+2277939,int_stack+0,int_stack+1017199,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+2462214,int_stack+2277939,int_stack+686349,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2936064,int_stack+2462214,int_stack+1208739,2025);
 /*--- compute (mf|ll) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3737964,int_stack+2936064,int_stack+1609689,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+250935,int_stack+246210,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+256710,int_stack+250935,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+263640,int_stack+256710,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115290,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+271830,int_stack+263640,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162540,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+204120,int_stack+162540,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+204120,int_stack+115290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95445,int_stack+281385,int_stack+271830,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+552699,int_stack+95445,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+601839,int_stack+552699,int_stack+162540,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+671139,int_stack+601839,int_stack+204120,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+124110,int_stack+671139,int_stack+24570,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+292410,int_stack+281385,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+33075,int_stack+0,int_stack+95445,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+757764,int_stack+33075,int_stack+552699,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+839664,int_stack+757764,int_stack+601839,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+943614,int_stack+839664,int_stack+671139,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+552699,int_stack+943614,int_stack+124110,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+684999,int_stack+305010,int_stack+292410,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90405,int_stack+684999,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+156555,int_stack+90405,int_stack+33075,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1064889,int_stack+156555,int_stack+757764,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1187739,int_stack+1064889,int_stack+839664,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+722799,int_stack+1187739,int_stack+943614,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+884499,int_stack+722799,int_stack+552699,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+552699,int_stack+319290,int_stack+305010,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+595539,int_stack+552699,int_stack+684999,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1333269,int_stack+595539,int_stack+90405,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+552699,int_stack+1333269,int_stack+156555,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1333269,int_stack+552699,int_stack+1064889,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1505259,int_stack+1333269,int_stack+1187739,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1699299,int_stack+1505259,int_stack+722799,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+552699,int_stack+1699299,int_stack+884499,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+765324,int_stack+552699,int_stack+2277939,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+1318149,int_stack+765324,int_stack+2462214,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4851714,int_stack+1318149,int_stack+2936064,2025);
 /*--- compute (mg|ll) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6188214,int_stack+4851714,int_stack+3737964,2025);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2265849,int_stack+340755,int_stack+335355,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2282049,int_stack+347355,int_stack+340755,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2301849,int_stack+2282049,int_stack+2265849,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2334249,int_stack+355275,int_stack+347355,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2358009,int_stack+2334249,int_stack+2282049,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+2397609,int_stack+2358009,int_stack+2301849,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2265849,int_stack+364635,int_stack+355275,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2451609,int_stack+2265849,int_stack+2334249,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2499129,int_stack+2451609,int_stack+2358009,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2293929,int_stack+2499129,int_stack+2397609,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2374929,int_stack+375555,int_stack+364635,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2565129,int_stack+2374929,int_stack+2265849,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2621289,int_stack+2565129,int_stack+2451609,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2700489,int_stack+2621289,int_stack+2499129,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2407689,int_stack+2700489,int_stack+2293929,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2265849,int_stack+388155,int_stack+375555,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2303649,int_stack+2265849,int_stack+2374929,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2799489,int_stack+2303649,int_stack+2565129,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2893089,int_stack+2799489,int_stack+2621289,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2521089,int_stack+2893089,int_stack+2700489,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+3011889,int_stack+2521089,int_stack+2407689,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2369169,int_stack+402555,int_stack+388155,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2412369,int_stack+2369169,int_stack+2265849,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2659689,int_stack+2412369,int_stack+2303649,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3163089,int_stack+2659689,int_stack+2799489,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3303489,int_stack+3163089,int_stack+2893089,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2768889,int_stack+3303489,int_stack+2521089,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+3469809,int_stack+2768889,int_stack+3011889,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2265849,int_stack+418875,int_stack+402555,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2487969,int_stack+2265849,int_stack+2369169,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2265849,int_stack+2487969,int_stack+2412369,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2391849,int_stack+2265849,int_stack+2659689,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2555649,int_stack+2391849,int_stack+3163089,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2265849,int_stack+2555649,int_stack+3303489,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2487609,int_stack+2265849,int_stack+2768889,120);
 /*--- compute (t0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+2725209,int_stack+2487609,int_stack+3469809,120);
 /*--- compute (rp|ll) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2968209,int_stack+2725209,int_stack+552699,2025);
 /*--- compute (qd|ll) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3606084,int_stack+2968209,int_stack+765324,2025);
 /*--- compute (of|ll) ---*/
 hrr1_build_of(Libint->AB,int_stack+7858839,int_stack+3606084,int_stack+1318149,2025);
 /*--- compute (ng|ll) ---*/
 hrr1_build_ng(Libint->AB,int_stack+552699,int_stack+7858839,int_stack+4851714,2025);
 /*--- compute (mh|ll) ---*/
 hrr1_build_mh(Libint->AB,int_stack+9438339,int_stack+552699,int_stack+6188214,2025);
 /*--- compute (u0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2557449,int_stack+443355,int_stack+437235,136);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2575809,int_stack+450835,int_stack+443355,136);
 /*--- compute (u0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2598249,int_stack+2575809,int_stack+2557449,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2634969,int_stack+459811,int_stack+450835,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2661897,int_stack+2634969,int_stack+2575809,136);
 /*--- compute (u0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+4711734,int_stack+2661897,int_stack+2598249,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2557449,int_stack+470419,int_stack+459811,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4772934,int_stack+2557449,int_stack+2634969,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+4826790,int_stack+4772934,int_stack+2661897,136);
 /*--- compute (u0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2589273,int_stack+4826790,int_stack+4711734,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4711734,int_stack+482795,int_stack+470419,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+4901590,int_stack+4711734,int_stack+2557449,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4965238,int_stack+4901590,int_stack+4772934,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5054998,int_stack+4965238,int_stack+4826790,136);
 /*--- compute (u0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+4748862,int_stack+5054998,int_stack+2589273,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2557449,int_stack+497075,int_stack+482795,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2600289,int_stack+2557449,int_stack+4711734,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5167198,int_stack+2600289,int_stack+4901590,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5273278,int_stack+5167198,int_stack+4965238,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+4877382,int_stack+5273278,int_stack+5054998,136);
 /*--- compute (u0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+5407918,int_stack+4877382,int_stack+4748862,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4711734,int_stack+513395,int_stack+497075,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4760694,int_stack+4711734,int_stack+2557449,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+5034462,int_stack+4760694,int_stack+2600289,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2557449,int_stack+5034462,int_stack+5167198,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5579278,int_stack+2557449,int_stack+5273278,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+5158222,int_stack+5579278,int_stack+4877382,136);
 /*--- compute (u0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+5767774,int_stack+5158222,int_stack+5407918,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4846374,int_stack+531891,int_stack+513395,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+4901862,int_stack+4846374,int_stack+4711734,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5367662,int_stack+4901862,int_stack+4760694,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4711734,int_stack+5367662,int_stack+5034462,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4897374,int_stack+4711734,int_stack+2557449,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5988094,int_stack+4897374,int_stack+5579278,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4711734,int_stack+5988094,int_stack+5158222,136);
 /*--- compute (u0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+5988094,int_stack+4711734,int_stack+5767774,136);
 /*--- compute (tp|ll) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4711734,int_stack+5988094,int_stack+2725209,2025);
 /*--- compute (rd|ll) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5440734,int_stack+4711734,int_stack+2968209,2025);
 /*--- compute (qf|ll) ---*/
 hrr1_build_qf(Libint->AB,int_stack+11777214,int_stack+5440734,int_stack+3606084,2025);
 /*--- compute (og|ll) ---*/
 hrr1_build_og(Libint->AB,int_stack+2557449,int_stack+11777214,int_stack+7858839,2025);
 /*--- compute (nh|ll) ---*/
 hrr1_build_nh(Libint->AB,int_stack+4926699,int_stack+2557449,int_stack+552699,2025);
 /*--- compute (mi|ll) ---*/
 hrr1_build_mi(Libint->AB,int_stack+0,int_stack+4926699,int_stack+9438339,2025);
 return int_stack+0;}
