/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mkll(Libint_t*, prim_data*);

  /* Computes quartets of (mk|ll) integrals */

REALTYPE *hrr_order_mkll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[9][16] = int_stack + 38280;
 Libint->vrr_classes[10][8] = int_stack + 46695;
 Libint->vrr_classes[10][9] = int_stack + 49665;
 Libint->vrr_classes[10][10] = int_stack + 53295;
 Libint->vrr_classes[10][11] = int_stack + 57651;
 Libint->vrr_classes[10][12] = int_stack + 62799;
 Libint->vrr_classes[10][13] = int_stack + 68805;
 Libint->vrr_classes[10][14] = int_stack + 75735;
 Libint->vrr_classes[10][15] = int_stack + 83655;
 Libint->vrr_classes[10][16] = int_stack + 92631;
 Libint->vrr_classes[11][8] = int_stack + 102729;
 Libint->vrr_classes[11][9] = int_stack + 106239;
 Libint->vrr_classes[11][10] = int_stack + 110529;
 Libint->vrr_classes[11][11] = int_stack + 115677;
 Libint->vrr_classes[11][12] = int_stack + 121761;
 Libint->vrr_classes[11][13] = int_stack + 128859;
 Libint->vrr_classes[11][14] = int_stack + 137049;
 Libint->vrr_classes[11][15] = int_stack + 146409;
 Libint->vrr_classes[11][16] = int_stack + 157017;
 Libint->vrr_classes[12][8] = int_stack + 168951;
 Libint->vrr_classes[12][9] = int_stack + 173046;
 Libint->vrr_classes[12][10] = int_stack + 178051;
 Libint->vrr_classes[12][11] = int_stack + 184057;
 Libint->vrr_classes[12][12] = int_stack + 191155;
 Libint->vrr_classes[12][13] = int_stack + 199436;
 Libint->vrr_classes[12][14] = int_stack + 208991;
 Libint->vrr_classes[12][15] = int_stack + 219911;
 Libint->vrr_classes[12][16] = int_stack + 232287;
 Libint->vrr_classes[13][8] = int_stack + 246210;
 Libint->vrr_classes[13][9] = int_stack + 250935;
 Libint->vrr_classes[13][10] = int_stack + 256710;
 Libint->vrr_classes[13][11] = int_stack + 263640;
 Libint->vrr_classes[13][12] = int_stack + 271830;
 Libint->vrr_classes[13][13] = int_stack + 281385;
 Libint->vrr_classes[13][14] = int_stack + 292410;
 Libint->vrr_classes[13][15] = int_stack + 305010;
 Libint->vrr_classes[13][16] = int_stack + 319290;
 Libint->vrr_classes[14][8] = int_stack + 335355;
 Libint->vrr_classes[14][9] = int_stack + 340755;
 Libint->vrr_classes[14][10] = int_stack + 347355;
 Libint->vrr_classes[14][11] = int_stack + 355275;
 Libint->vrr_classes[14][12] = int_stack + 364635;
 Libint->vrr_classes[14][13] = int_stack + 375555;
 Libint->vrr_classes[14][14] = int_stack + 388155;
 Libint->vrr_classes[14][15] = int_stack + 402555;
 Libint->vrr_classes[14][16] = int_stack + 418875;
 Libint->vrr_classes[15][8] = int_stack + 437235;
 Libint->vrr_classes[15][9] = int_stack + 443355;
 Libint->vrr_classes[15][10] = int_stack + 450835;
 Libint->vrr_classes[15][11] = int_stack + 459811;
 Libint->vrr_classes[15][12] = int_stack + 470419;
 Libint->vrr_classes[15][13] = int_stack + 482795;
 Libint->vrr_classes[15][14] = int_stack + 497075;
 Libint->vrr_classes[15][15] = int_stack + 513395;
 Libint->vrr_classes[15][16] = int_stack + 531891;
 Libint->vrr_classes[16][8] = int_stack + 552699;
 Libint->vrr_classes[16][9] = int_stack + 559584;
 Libint->vrr_classes[16][10] = int_stack + 567999;
 Libint->vrr_classes[16][11] = int_stack + 578097;
 Libint->vrr_classes[16][12] = int_stack + 590031;
 Libint->vrr_classes[16][13] = int_stack + 603954;
 Libint->vrr_classes[16][14] = int_stack + 620019;
 Libint->vrr_classes[16][15] = int_stack + 638379;
 Libint->vrr_classes[16][16] = int_stack + 659187;
 memset(int_stack,0,682596*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 682596;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mkll(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+682596,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+690021,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+699096,int_stack+690021,int_stack+682596,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+713946,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+724836,int_stack+713946,int_stack+690021,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+742986,int_stack+724836,int_stack+699096,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+682596,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+767736,int_stack+682596,int_stack+713946,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+789516,int_stack+767736,int_stack+724836,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+695466,int_stack+789516,int_stack+742986,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+732591,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+819766,int_stack+732591,int_stack+682596,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+845506,int_stack+819766,int_stack+767736,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+881806,int_stack+845506,int_stack+789516,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+747606,int_stack+881806,int_stack+695466,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682596,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+699921,int_stack+682596,int_stack+732591,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+927181,int_stack+699921,int_stack+819766,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+970081,int_stack+927181,int_stack+845506,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+799581,int_stack+970081,int_stack+881806,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1024531,int_stack+799581,int_stack+747606,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+729951,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+749751,int_stack+729951,int_stack+682596,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+863106,int_stack+749751,int_stack+699921,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1093831,int_stack+863106,int_stack+927181,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1158181,int_stack+1093831,int_stack+970081,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+913156,int_stack+1158181,int_stack+799581,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1234411,int_stack+913156,int_stack+1024531,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682596,int_stack+38280,int_stack+30800,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+784401,int_stack+682596,int_stack+729951,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+682596,int_stack+784401,int_stack+749751,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+740346,int_stack+682596,int_stack+863106,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+815421,int_stack+740346,int_stack+1093831,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+682596,int_stack+815421,int_stack+1158181,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+784236,int_stack+682596,int_stack+913156,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+893136,int_stack+784236,int_stack+1234411,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+682596,int_stack+49665,int_stack+46695,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+691506,int_stack+53295,int_stack+49665,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+702396,int_stack+691506,int_stack+682596,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+720216,int_stack+57651,int_stack+53295,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+733284,int_stack+720216,int_stack+691506,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+755064,int_stack+733284,int_stack+702396,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+682596,int_stack+62799,int_stack+57651,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+784764,int_stack+682596,int_stack+720216,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+810900,int_stack+784764,int_stack+733284,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+698040,int_stack+810900,int_stack+755064,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+742590,int_stack+68805,int_stack+62799,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+847200,int_stack+742590,int_stack+682596,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1004511,int_stack+847200,int_stack+784764,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1048071,int_stack+1004511,int_stack+810900,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+760608,int_stack+1048071,int_stack+698040,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682596,int_stack+75735,int_stack+68805,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+703386,int_stack+682596,int_stack+742590,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1102521,int_stack+703386,int_stack+847200,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+822978,int_stack+1102521,int_stack+1004511,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1154001,int_stack+822978,int_stack+1048071,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1004511,int_stack+1154001,int_stack+760608,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+739422,int_stack+83655,int_stack+75735,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+763182,int_stack+739422,int_stack+682596,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1230231,int_stack+763182,int_stack+703386,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+1230231,int_stack+1102521,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1290291,int_stack+0,int_stack+822978,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1381767,int_stack+1290291,int_stack+1154001,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1087671,int_stack+1381767,int_stack+1004511,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1004511,int_stack+92631,int_stack+83655,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1031439,int_stack+1004511,int_stack+739422,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+682596,int_stack+1031439,int_stack+763182,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+751896,int_stack+682596,int_stack+1230231,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1483407,int_stack+751896,int_stack+0,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+682596,int_stack+1483407,int_stack+1290291,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1194591,int_stack+682596,int_stack+1381767,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+682596,int_stack+1194591,int_stack+1087671,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1004511,int_stack+682596,int_stack+893136,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+816246,int_stack+106239,int_stack+102729,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+826776,int_stack+110529,int_stack+106239,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+839646,int_stack+826776,int_stack+816246,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+860706,int_stack+115677,int_stack+110529,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+876150,int_stack+860706,int_stack+826776,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+901890,int_stack+876150,int_stack+839646,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+816246,int_stack+121761,int_stack+115677,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+936990,int_stack+816246,int_stack+860706,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+936990,int_stack+876150,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+834498,int_stack+0,int_stack+901890,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+887148,int_stack+128859,int_stack+121761,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+967878,int_stack+887148,int_stack+816246,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42900,int_stack+967878,int_stack+936990,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1338636,int_stack+42900,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1402986,int_stack+1338636,int_stack+834498,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137049,int_stack+128859,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+816246,int_stack+0,int_stack+887148,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+858834,int_stack+816246,int_stack+967878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+919674,int_stack+858834,int_stack+42900,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+24570,int_stack+919674,int_stack+1338636,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1476696,int_stack+24570,int_stack+1402986,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1338636,int_stack+146409,int_stack+137049,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1366716,int_stack+1338636,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1574976,int_stack+1366716,int_stack+816246,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1645956,int_stack+1574976,int_stack+858834,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1737216,int_stack+1645956,int_stack+919674,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+816246,int_stack+1737216,int_stack+24570,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+816246,int_stack+1476696,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+936366,int_stack+157017,int_stack+146409,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1415856,int_stack+936366,int_stack+1338636,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1472016,int_stack+1415856,int_stack+1366716,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1338636,int_stack+1472016,int_stack+1574976,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1445106,int_stack+1338636,int_stack+1645956,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1572870,int_stack+1445106,int_stack+1737216,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1338636,int_stack+1572870,int_stack+816246,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+816246,int_stack+1338636,int_stack+0,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+1338636,int_stack+816246,int_stack+682596,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+1739586,int_stack+1338636,int_stack+1004511,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+682596,int_stack+173046,int_stack+168951,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+694881,int_stack+178051,int_stack+173046,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+709896,int_stack+694881,int_stack+682596,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+734466,int_stack+184057,int_stack+178051,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+752484,int_stack+734466,int_stack+694881,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+752484,int_stack+709896,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+682596,int_stack+191155,int_stack+184057,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+40950,int_stack+682596,int_stack+734466,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+76986,int_stack+40950,int_stack+752484,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+703890,int_stack+76986,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+199436,int_stack+191155,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+765315,int_stack+0,int_stack+682596,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+127036,int_stack+765315,int_stack+40950,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+974196,int_stack+127036,int_stack+76986,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+24843,int_stack+974196,int_stack+703890,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+682596,int_stack+208991,int_stack+199436,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+711261,int_stack+682596,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1049271,int_stack+711261,int_stack+765315,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1120251,int_stack+1049271,int_stack+127036,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1210341,int_stack+1120251,int_stack+974196,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+2407836,int_stack+1210341,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+974196,int_stack+219911,int_stack+208991,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+974196,int_stack+682596,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+711261,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+682596,int_stack+57330,int_stack+1049271,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2522496,int_stack+682596,int_stack+1120251,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1006956,int_stack+2522496,int_stack+1210341,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1147096,int_stack+1006956,int_stack+2407836,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2407836,int_stack+232287,int_stack+219911,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2444964,int_stack+2407836,int_stack+974196,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+140140,int_stack+2444964,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2648622,int_stack+140140,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+2648622,int_stack+682596,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2648622,int_stack+0,int_stack+2522496,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+2648622,int_stack+1006956,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+2407836,int_stack+0,int_stack+1147096,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+2592111,int_stack+2407836,int_stack+816246,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3065961,int_stack+2592111,int_stack+1338636,2025);
 /*--- compute (mf|ll) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3867861,int_stack+3065961,int_stack+1739586,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+250935,int_stack+246210,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+256710,int_stack+250935,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+263640,int_stack+256710,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115290,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+271830,int_stack+263640,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162540,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+204120,int_stack+162540,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+204120,int_stack+115290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95445,int_stack+281385,int_stack+271830,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+682596,int_stack+95445,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+731736,int_stack+682596,int_stack+162540,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+801036,int_stack+731736,int_stack+204120,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+124110,int_stack+801036,int_stack+24570,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+292410,int_stack+281385,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+33075,int_stack+0,int_stack+95445,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+887661,int_stack+33075,int_stack+682596,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+969561,int_stack+887661,int_stack+731736,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1073511,int_stack+969561,int_stack+801036,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+682596,int_stack+1073511,int_stack+124110,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+814896,int_stack+305010,int_stack+292410,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90405,int_stack+814896,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+156555,int_stack+90405,int_stack+33075,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1194786,int_stack+156555,int_stack+887661,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1317636,int_stack+1194786,int_stack+969561,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+852696,int_stack+1317636,int_stack+1073511,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1014396,int_stack+852696,int_stack+682596,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682596,int_stack+319290,int_stack+305010,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+725436,int_stack+682596,int_stack+814896,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1463166,int_stack+725436,int_stack+90405,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+682596,int_stack+1463166,int_stack+156555,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1463166,int_stack+682596,int_stack+1194786,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1635156,int_stack+1463166,int_stack+1317636,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1829196,int_stack+1635156,int_stack+852696,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+682596,int_stack+1829196,int_stack+1014396,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+895221,int_stack+682596,int_stack+2407836,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+1448046,int_stack+895221,int_stack+2592111,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4981611,int_stack+1448046,int_stack+3065961,2025);
 /*--- compute (mg|ll) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6318111,int_stack+4981611,int_stack+3867861,2025);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2395746,int_stack+340755,int_stack+335355,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2411946,int_stack+347355,int_stack+340755,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2431746,int_stack+2411946,int_stack+2395746,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2464146,int_stack+355275,int_stack+347355,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2487906,int_stack+2464146,int_stack+2411946,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+2527506,int_stack+2487906,int_stack+2431746,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2395746,int_stack+364635,int_stack+355275,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2581506,int_stack+2395746,int_stack+2464146,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2629026,int_stack+2581506,int_stack+2487906,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2423826,int_stack+2629026,int_stack+2527506,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2504826,int_stack+375555,int_stack+364635,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2695026,int_stack+2504826,int_stack+2395746,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2751186,int_stack+2695026,int_stack+2581506,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2830386,int_stack+2751186,int_stack+2629026,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+2537586,int_stack+2830386,int_stack+2423826,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2395746,int_stack+388155,int_stack+375555,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2433546,int_stack+2395746,int_stack+2504826,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2929386,int_stack+2433546,int_stack+2695026,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3022986,int_stack+2929386,int_stack+2751186,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2650986,int_stack+3022986,int_stack+2830386,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+3141786,int_stack+2650986,int_stack+2537586,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2499066,int_stack+402555,int_stack+388155,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2542266,int_stack+2499066,int_stack+2395746,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2789586,int_stack+2542266,int_stack+2433546,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3292986,int_stack+2789586,int_stack+2929386,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3433386,int_stack+3292986,int_stack+3022986,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2898786,int_stack+3433386,int_stack+2650986,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+3599706,int_stack+2898786,int_stack+3141786,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2395746,int_stack+418875,int_stack+402555,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2617866,int_stack+2395746,int_stack+2499066,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2395746,int_stack+2617866,int_stack+2542266,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2521746,int_stack+2395746,int_stack+2789586,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2685546,int_stack+2521746,int_stack+3292986,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2395746,int_stack+2685546,int_stack+3433386,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2617506,int_stack+2395746,int_stack+2898786,120);
 /*--- compute (t0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+2855106,int_stack+2617506,int_stack+3599706,120);
 /*--- compute (rp|ll) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3098106,int_stack+2855106,int_stack+682596,2025);
 /*--- compute (qd|ll) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3735981,int_stack+3098106,int_stack+895221,2025);
 /*--- compute (of|ll) ---*/
 hrr1_build_of(Libint->AB,int_stack+7988736,int_stack+3735981,int_stack+1448046,2025);
 /*--- compute (ng|ll) ---*/
 hrr1_build_ng(Libint->AB,int_stack+682596,int_stack+7988736,int_stack+4981611,2025);
 /*--- compute (mh|ll) ---*/
 hrr1_build_mh(Libint->AB,int_stack+9568236,int_stack+682596,int_stack+6318111,2025);
 /*--- compute (u0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+2687346,int_stack+443355,int_stack+437235,136);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2705706,int_stack+450835,int_stack+443355,136);
 /*--- compute (u0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2728146,int_stack+2705706,int_stack+2687346,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2764866,int_stack+459811,int_stack+450835,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2791794,int_stack+2764866,int_stack+2705706,136);
 /*--- compute (u0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+4841631,int_stack+2791794,int_stack+2728146,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2687346,int_stack+470419,int_stack+459811,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4902831,int_stack+2687346,int_stack+2764866,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+4956687,int_stack+4902831,int_stack+2791794,136);
 /*--- compute (u0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2719170,int_stack+4956687,int_stack+4841631,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4841631,int_stack+482795,int_stack+470419,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5031487,int_stack+4841631,int_stack+2687346,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5095135,int_stack+5031487,int_stack+4902831,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5184895,int_stack+5095135,int_stack+4956687,136);
 /*--- compute (u0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+4878759,int_stack+5184895,int_stack+2719170,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2687346,int_stack+497075,int_stack+482795,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2730186,int_stack+2687346,int_stack+4841631,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5297095,int_stack+2730186,int_stack+5031487,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5403175,int_stack+5297095,int_stack+5095135,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+5007279,int_stack+5403175,int_stack+5184895,136);
 /*--- compute (u0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+5537815,int_stack+5007279,int_stack+4878759,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4841631,int_stack+513395,int_stack+497075,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4890591,int_stack+4841631,int_stack+2687346,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+5164359,int_stack+4890591,int_stack+2730186,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2687346,int_stack+5164359,int_stack+5297095,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5709175,int_stack+2687346,int_stack+5403175,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+5288119,int_stack+5709175,int_stack+5007279,136);
 /*--- compute (u0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+5897671,int_stack+5288119,int_stack+5537815,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4976271,int_stack+531891,int_stack+513395,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5031759,int_stack+4976271,int_stack+4841631,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5497559,int_stack+5031759,int_stack+4890591,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4841631,int_stack+5497559,int_stack+5164359,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5027271,int_stack+4841631,int_stack+2687346,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+6117991,int_stack+5027271,int_stack+5709175,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4841631,int_stack+6117991,int_stack+5288119,136);
 /*--- compute (u0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+6117991,int_stack+4841631,int_stack+5897671,136);
 /*--- compute (tp|ll) ---*/
 hrr1_build_tp(Libint->AB,int_stack+4841631,int_stack+6117991,int_stack+2855106,2025);
 /*--- compute (rd|ll) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6393391,int_stack+4841631,int_stack+3098106,2025);
 /*--- compute (qf|ll) ---*/
 hrr1_build_qf(Libint->AB,int_stack+11907111,int_stack+6393391,int_stack+3735981,2025);
 /*--- compute (og|ll) ---*/
 hrr1_build_og(Libint->AB,int_stack+13749861,int_stack+11907111,int_stack+7988736,2025);
 /*--- compute (nh|ll) ---*/
 hrr1_build_nh(Libint->AB,int_stack+16119111,int_stack+13749861,int_stack+682596,2025);
 /*--- compute (mi|ll) ---*/
 hrr1_build_mi(Libint->AB,int_stack+682596,int_stack+16119111,int_stack+9568236,2025);
 /*--- compute (v0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3801096,int_stack+559584,int_stack+552699,153);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3821751,int_stack+567999,int_stack+559584,153);
 /*--- compute (v0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+3846996,int_stack+3821751,int_stack+3801096,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3888306,int_stack+578097,int_stack+567999,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3918600,int_stack+3888306,int_stack+3821751,153);
 /*--- compute (v0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+3969090,int_stack+3918600,int_stack+3846996,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3801096,int_stack+590031,int_stack+578097,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4037940,int_stack+3801096,int_stack+3888306,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+4098528,int_stack+4037940,int_stack+3918600,153);
 /*--- compute (v0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+3836898,int_stack+4098528,int_stack+3969090,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3940173,int_stack+603954,int_stack+590031,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+4182678,int_stack+3940173,int_stack+3801096,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4254282,int_stack+4182678,int_stack+4037940,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+4355262,int_stack+4254282,int_stack+4098528,153);
 /*--- compute (v0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+3981942,int_stack+4355262,int_stack+3836898,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3801096,int_stack+620019,int_stack+603954,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3849291,int_stack+3801096,int_stack+3940173,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4481487,int_stack+3849291,int_stack+4182678,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+4600827,int_stack+4481487,int_stack+4254282,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+4126527,int_stack+4600827,int_stack+4355262,153);
 /*--- compute (v0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+5570631,int_stack+4126527,int_stack+3981942,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3932829,int_stack+638379,int_stack+620019,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3987909,int_stack+3932829,int_stack+3801096,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4303242,int_stack+3987909,int_stack+3849291,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5763411,int_stack+4303242,int_stack+4481487,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+7669141,int_stack+5763411,int_stack+4600827,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4442472,int_stack+7669141,int_stack+4126527,153);
 /*--- compute (v0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+7881199,int_stack+4442472,int_stack+5570631,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5570631,int_stack+659187,int_stack+638379,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5633055,int_stack+5570631,int_stack+3932829,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3801096,int_stack+5633055,int_stack+3987909,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3961746,int_stack+3801096,int_stack+4303242,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4170591,int_stack+3961746,int_stack+5763411,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3801096,int_stack+4170591,int_stack+7669141,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4083840,int_stack+3801096,int_stack+4442472,153);
 /*--- compute (v0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+4386780,int_stack+4083840,int_stack+7881199,153);
 /*--- compute (up|ll) ---*/
 hrr1_build_up(Libint->AB,int_stack+7669141,int_stack+4386780,int_stack+6117991,2025);
 /*--- compute (td|ll) ---*/
 hrr1_build_td(Libint->AB,int_stack+8495341,int_stack+7669141,int_stack+4841631,2025);
 /*--- compute (rf|ll) ---*/
 hrr1_build_rf(Libint->AB,int_stack+3801096,int_stack+8495341,int_stack+6393391,2025);
 /*--- compute (qg|ll) ---*/
 hrr1_build_qg(Libint->AB,int_stack+5927346,int_stack+3801096,int_stack+11907111,2025);
 /*--- compute (oh|ll) ---*/
 hrr1_build_oh(Libint->AB,int_stack+8691471,int_stack+5927346,int_stack+13749861,2025);
 /*--- compute (ni|ll) ---*/
 hrr1_build_ni(Libint->AB,int_stack+3801096,int_stack+8691471,int_stack+16119111,2025);
 /*--- compute (mk|ll) ---*/
 hrr1_build_mk(Libint->AB,int_stack+7543296,int_stack+3801096,int_stack+682596,2025);
 return int_stack+7543296;}
