/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mphh(Libint_t*, prim_data*);

  /* Computes quartets of (mp|hh) integrals */

REALTYPE *hrr_order_mphh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][5] = int_stack + 0;
 Libint->vrr_classes[9][6] = int_stack + 1155;
 Libint->vrr_classes[9][7] = int_stack + 2695;
 Libint->vrr_classes[9][8] = int_stack + 4675;
 Libint->vrr_classes[9][9] = int_stack + 7150;
 Libint->vrr_classes[9][10] = int_stack + 10175;
 Libint->vrr_classes[10][5] = int_stack + 13805;
 Libint->vrr_classes[10][6] = int_stack + 15191;
 Libint->vrr_classes[10][7] = int_stack + 17039;
 Libint->vrr_classes[10][8] = int_stack + 19415;
 Libint->vrr_classes[10][9] = int_stack + 22385;
 Libint->vrr_classes[10][10] = int_stack + 26015;
 memset(int_stack,0,30371*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 30371;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mphh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+30371,int_stack+1155,int_stack+0,55);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33836,int_stack+2695,int_stack+1155,55);
 /*--- compute (m0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+38456,int_stack+33836,int_stack+30371,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45386,int_stack+4675,int_stack+2695,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+51326,int_stack+45386,int_stack+33836,55);
 /*--- compute (m0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+60566,int_stack+51326,int_stack+38456,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30371,int_stack+7150,int_stack+4675,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+72116,int_stack+30371,int_stack+45386,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+83996,int_stack+72116,int_stack+51326,55);
 /*--- compute (m0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+37796,int_stack+83996,int_stack+60566,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+55121,int_stack+10175,int_stack+7150,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+99396,int_stack+55121,int_stack+30371,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+114246,int_stack+99396,int_stack+72116,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+55121,int_stack+114246,int_stack+83996,55);
 /*--- compute (m0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+78221,int_stack+55121,int_stack+37796,55);
 /*--- compute (n0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+30371,int_stack+15191,int_stack+13805,66);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+34529,int_stack+17039,int_stack+15191,66);
 /*--- compute (n0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+40073,int_stack+34529,int_stack+30371,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+48389,int_stack+19415,int_stack+17039,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+55517,int_stack+48389,int_stack+34529,66);
 /*--- compute (n0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+102476,int_stack+55517,int_stack+40073,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30371,int_stack+22385,int_stack+19415,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+116336,int_stack+30371,int_stack+48389,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+116336,int_stack+55517,66);
 /*--- compute (n0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+39281,int_stack+0,int_stack+102476,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+102476,int_stack+26015,int_stack+22385,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+60071,int_stack+102476,int_stack+30371,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+130592,int_stack+60071,int_stack+116336,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+102476,int_stack+130592,int_stack+0,66);
 /*--- compute (n0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+102476,int_stack+39281,66);
 /*--- compute (mp|hh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+102476,int_stack+0,int_stack+78221,441);
 return int_stack+102476;}
