/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpmh(Libint_t*, prim_data*);

  /* Computes quartets of (mp|mh) integrals */

REALTYPE *hrr_order_mpmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[10][9] = int_stack + 28325;
 Libint->vrr_classes[10][10] = int_stack + 31955;
 Libint->vrr_classes[10][11] = int_stack + 36311;
 Libint->vrr_classes[10][12] = int_stack + 41459;
 Libint->vrr_classes[10][13] = int_stack + 47465;
 Libint->vrr_classes[10][14] = int_stack + 54395;
 memset(int_stack,0,62315*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 62315;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpmh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62315,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71390,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+82280,int_stack+71390,int_stack+62315,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100430,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113300,int_stack+100430,int_stack+71390,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+135080,int_stack+113300,int_stack+82280,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62315,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+165330,int_stack+62315,int_stack+100430,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+191070,int_stack+165330,int_stack+113300,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+77330,int_stack+191070,int_stack+135080,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+122705,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+227370,int_stack+122705,int_stack+62315,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+257400,int_stack+227370,int_stack+165330,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+122705,int_stack+257400,int_stack+191070,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+177155,int_stack+122705,int_stack+77330,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62315,int_stack+31955,int_stack+28325,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+73205,int_stack+36311,int_stack+31955,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+86273,int_stack+73205,int_stack+62315,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+108053,int_stack+41459,int_stack+36311,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+123497,int_stack+108053,int_stack+73205,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+240680,int_stack+123497,int_stack+86273,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62315,int_stack+47465,int_stack+41459,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+62315,int_stack+108053,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+276980,int_stack+0,int_stack+123497,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+80333,int_stack+276980,int_stack+240680,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+240680,int_stack+54395,int_stack+47465,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+134783,int_stack+240680,int_stack+62315,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+320540,int_stack+134783,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+320540,int_stack+276980,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+240680,int_stack+0,int_stack+80333,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+316910,int_stack+240680,int_stack+177155,1155);
 return int_stack+316910;}
