/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_n0ml(Libint_t*, prim_data*);

  /* Computes quartets of (n0|ml) integrals */

REALTYPE *hrr_order_n0ml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 memset(int_stack,0,64350*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 64350;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_n0ml(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64350,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75240,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+88308,int_stack+75240,int_stack+64350,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110088,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+125532,int_stack+110088,int_stack+75240,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+151668,int_stack+125532,int_stack+88308,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64350,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+187968,int_stack+64350,int_stack+110088,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+218856,int_stack+187968,int_stack+125532,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+82368,int_stack+218856,int_stack+151668,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+136818,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+262416,int_stack+136818,int_stack+64350,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+298452,int_stack+262416,int_stack+187968,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+349932,int_stack+298452,int_stack+218856,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+157608,int_stack+349932,int_stack+82368,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+64350,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+88110,int_stack+64350,int_stack+136818,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+415272,int_stack+88110,int_stack+262416,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+475332,int_stack+415272,int_stack+298452,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+233838,int_stack+475332,int_stack+349932,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+552552,int_stack+233838,int_stack+157608,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+129690,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+156618,int_stack+129690,int_stack+64350,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+325314,int_stack+156618,int_stack+88110,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+654192,int_stack+325314,int_stack+415272,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+744282,int_stack+654192,int_stack+475332,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+394614,int_stack+744282,int_stack+233838,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+852390,int_stack+394614,int_stack+552552,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+64350,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+204138,int_stack+64350,int_stack+129690,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+516582,int_stack+204138,int_stack+156618,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+516582,int_stack+325314,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+516582,int_stack+0,int_stack+654192,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+516582,int_stack+744282,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+516582,int_stack+0,int_stack+394614,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+516582,int_stack+852390,66);
 return int_stack+0;}
