/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndlg(Libint_t*, prim_data*);

  /* Computes quartets of (nd|lg) integrals */

REALTYPE *hrr_order_ndlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[11][8] = int_stack + 22110;
 Libint->vrr_classes[11][9] = int_stack + 25620;
 Libint->vrr_classes[11][10] = int_stack + 29910;
 Libint->vrr_classes[11][11] = int_stack + 35058;
 Libint->vrr_classes[11][12] = int_stack + 41142;
 Libint->vrr_classes[12][8] = int_stack + 48240;
 Libint->vrr_classes[12][9] = int_stack + 52335;
 Libint->vrr_classes[12][10] = int_stack + 57340;
 Libint->vrr_classes[12][11] = int_stack + 63346;
 Libint->vrr_classes[12][12] = int_stack + 70444;
 memset(int_stack,0,78725*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 78725;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndlg(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+78725,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+87635,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98525,int_stack+87635,int_stack+78725,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+116345,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+129413,int_stack+116345,int_stack+87635,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+151193,int_stack+129413,int_stack+98525,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+78725,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+180893,int_stack+78725,int_stack+116345,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+78725,int_stack+180893,int_stack+129413,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+180893,int_stack+78725,int_stack+151193,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+78725,int_stack+25620,int_stack+22110,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+89255,int_stack+29910,int_stack+25620,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+102125,int_stack+89255,int_stack+78725,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123185,int_stack+35058,int_stack+29910,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+138629,int_stack+123185,int_stack+89255,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+225443,int_stack+138629,int_stack+102125,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+78725,int_stack+41142,int_stack+35058,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+78725,int_stack+123185,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+78725,int_stack+0,int_stack+138629,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+121625,int_stack+78725,int_stack+225443,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+225443,int_stack+121625,int_stack+180893,675);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+78725,int_stack+52335,int_stack+48240,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91010,int_stack+57340,int_stack+52335,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+91010,int_stack+78725,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+24570,int_stack+63346,int_stack+57340,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+174275,int_stack+24570,int_stack+91010,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+78725,int_stack+174275,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+70444,int_stack+63346,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42588,int_stack+0,int_stack+24570,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+359093,int_stack+42588,int_stack+174275,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+359093,int_stack+78725,91);
 /*--- compute (op|lg) ---*/
 hrr1_build_op(Libint->AB,int_stack+359093,int_stack+0,int_stack+121625,675);
 /*--- compute (nd|lg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+517043,int_stack+359093,int_stack+225443,675);
 return int_stack+517043;}
