/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndnf(Libint_t*, prim_data*);

  /* Computes quartets of (nd|nf) integrals */

REALTYPE *hrr_order_ndnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[11][10] = int_stack + 22440;
 Libint->vrr_classes[11][11] = int_stack + 27588;
 Libint->vrr_classes[11][12] = int_stack + 33672;
 Libint->vrr_classes[11][13] = int_stack + 40770;
 Libint->vrr_classes[12][10] = int_stack + 48960;
 Libint->vrr_classes[12][11] = int_stack + 54966;
 Libint->vrr_classes[12][12] = int_stack + 62064;
 Libint->vrr_classes[12][13] = int_stack + 70345;
 memset(int_stack,0,79900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 79900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndnf(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+79900,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92968,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108412,int_stack+92968,int_stack+79900,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+134548,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+152566,int_stack+134548,int_stack+92968,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+183454,int_stack+152566,int_stack+108412,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+79900,int_stack+27588,int_stack+22440,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+95344,int_stack+33672,int_stack+27588,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+113596,int_stack+95344,int_stack+79900,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+144484,int_stack+40770,int_stack+33672,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+144484,int_stack+95344,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+227014,int_stack+0,int_stack+113596,78);
 /*--- compute (np|nf) ---*/
 hrr1_build_np(Libint->AB,int_stack+278494,int_stack+227014,int_stack+183454,660);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+54966,int_stack+48960,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+62064,int_stack+54966,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79900,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+115936,int_stack+70345,int_stack+62064,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+140779,int_stack+115936,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+140779,int_stack+79900,91);
 /*--- compute (op|nf) ---*/
 hrr1_build_op(Libint->AB,int_stack+60060,int_stack+0,int_stack+227014,660);
 /*--- compute (nd|nf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+409174,int_stack+60060,int_stack+278494,660);
 return int_stack+409174;}
