/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nhll(Libint_t*, prim_data*);

  /* Computes quartets of (nh|ll) integrals */

REALTYPE *hrr_order_nhll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[10][15] = int_stack + 36960;
 Libint->vrr_classes[10][16] = int_stack + 45936;
 Libint->vrr_classes[11][8] = int_stack + 56034;
 Libint->vrr_classes[11][9] = int_stack + 59544;
 Libint->vrr_classes[11][10] = int_stack + 63834;
 Libint->vrr_classes[11][11] = int_stack + 68982;
 Libint->vrr_classes[11][12] = int_stack + 75066;
 Libint->vrr_classes[11][13] = int_stack + 82164;
 Libint->vrr_classes[11][14] = int_stack + 90354;
 Libint->vrr_classes[11][15] = int_stack + 99714;
 Libint->vrr_classes[11][16] = int_stack + 110322;
 Libint->vrr_classes[12][8] = int_stack + 122256;
 Libint->vrr_classes[12][9] = int_stack + 126351;
 Libint->vrr_classes[12][10] = int_stack + 131356;
 Libint->vrr_classes[12][11] = int_stack + 137362;
 Libint->vrr_classes[12][12] = int_stack + 144460;
 Libint->vrr_classes[12][13] = int_stack + 152741;
 Libint->vrr_classes[12][14] = int_stack + 162296;
 Libint->vrr_classes[12][15] = int_stack + 173216;
 Libint->vrr_classes[12][16] = int_stack + 185592;
 Libint->vrr_classes[13][8] = int_stack + 199515;
 Libint->vrr_classes[13][9] = int_stack + 204240;
 Libint->vrr_classes[13][10] = int_stack + 210015;
 Libint->vrr_classes[13][11] = int_stack + 216945;
 Libint->vrr_classes[13][12] = int_stack + 225135;
 Libint->vrr_classes[13][13] = int_stack + 234690;
 Libint->vrr_classes[13][14] = int_stack + 245715;
 Libint->vrr_classes[13][15] = int_stack + 258315;
 Libint->vrr_classes[13][16] = int_stack + 272595;
 Libint->vrr_classes[14][8] = int_stack + 288660;
 Libint->vrr_classes[14][9] = int_stack + 294060;
 Libint->vrr_classes[14][10] = int_stack + 300660;
 Libint->vrr_classes[14][11] = int_stack + 308580;
 Libint->vrr_classes[14][12] = int_stack + 317940;
 Libint->vrr_classes[14][13] = int_stack + 328860;
 Libint->vrr_classes[14][14] = int_stack + 341460;
 Libint->vrr_classes[14][15] = int_stack + 355860;
 Libint->vrr_classes[14][16] = int_stack + 372180;
 Libint->vrr_classes[15][8] = int_stack + 390540;
 Libint->vrr_classes[15][9] = int_stack + 396660;
 Libint->vrr_classes[15][10] = int_stack + 404140;
 Libint->vrr_classes[15][11] = int_stack + 413116;
 Libint->vrr_classes[15][12] = int_stack + 423724;
 Libint->vrr_classes[15][13] = int_stack + 436100;
 Libint->vrr_classes[15][14] = int_stack + 450380;
 Libint->vrr_classes[15][15] = int_stack + 466700;
 Libint->vrr_classes[15][16] = int_stack + 485196;
 memset(int_stack,0,506004*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 506004;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nhll(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+514914,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+525804,int_stack+514914,int_stack+506004,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+543624,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+556692,int_stack+543624,int_stack+514914,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+578472,int_stack+556692,int_stack+525804,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+608172,int_stack+506004,int_stack+543624,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+634308,int_stack+608172,int_stack+556692,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+521448,int_stack+634308,int_stack+578472,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+565998,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+670608,int_stack+565998,int_stack+506004,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+701496,int_stack+670608,int_stack+608172,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+745056,int_stack+701496,int_stack+634308,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+584016,int_stack+745056,int_stack+521448,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+526794,int_stack+506004,int_stack+565998,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+799506,int_stack+526794,int_stack+670608,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+850986,int_stack+799506,int_stack+701496,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+646386,int_stack+850986,int_stack+745056,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+916326,int_stack+646386,int_stack+584016,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+562830,int_stack+36960,int_stack+29040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+586590,int_stack+562830,int_stack+506004,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+722616,int_stack+586590,int_stack+526794,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+999486,int_stack+722616,int_stack+799506,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1076706,int_stack+999486,int_stack+850986,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+782676,int_stack+1076706,int_stack+646386,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1168182,int_stack+782676,int_stack+916326,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+506004,int_stack+45936,int_stack+36960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+628170,int_stack+506004,int_stack+562830,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+506004,int_stack+628170,int_stack+586590,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+575304,int_stack+506004,int_stack+722616,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+665394,int_stack+575304,int_stack+999486,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+506004,int_stack+665394,int_stack+1076706,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+627972,int_stack+506004,int_stack+782676,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+758652,int_stack+627972,int_stack+1168182,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+59544,int_stack+56034,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+516534,int_stack+63834,int_stack+59544,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+529404,int_stack+516534,int_stack+506004,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+550464,int_stack+68982,int_stack+63834,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+565908,int_stack+550464,int_stack+516534,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+591648,int_stack+565908,int_stack+529404,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+75066,int_stack+68982,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+626748,int_stack+506004,int_stack+550464,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+657636,int_stack+626748,int_stack+565908,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+524256,int_stack+657636,int_stack+591648,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+576906,int_stack+82164,int_stack+75066,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+700536,int_stack+576906,int_stack+506004,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+892302,int_stack+700536,int_stack+626748,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+943782,int_stack+892302,int_stack+657636,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+598200,int_stack+943782,int_stack+524256,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+90354,int_stack+82164,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+530574,int_stack+506004,int_stack+576906,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1008132,int_stack+530574,int_stack+700536,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+671910,int_stack+1008132,int_stack+892302,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1068972,int_stack+671910,int_stack+943782,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+892302,int_stack+1068972,int_stack+598200,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+573162,int_stack+99714,int_stack+90354,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+601242,int_stack+573162,int_stack+506004,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1159062,int_stack+601242,int_stack+530574,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+1159062,int_stack+1008132,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1230042,int_stack+0,int_stack+671910,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1338150,int_stack+1230042,int_stack+1068972,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+990582,int_stack+1338150,int_stack+892302,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+892302,int_stack+110322,int_stack+99714,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+924126,int_stack+892302,int_stack+573162,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+506004,int_stack+924126,int_stack+601242,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+587904,int_stack+506004,int_stack+1159062,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1458270,int_stack+587904,int_stack+0,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+506004,int_stack+1458270,int_stack+1230042,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1116942,int_stack+506004,int_stack+1338150,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+506004,int_stack+1116942,int_stack+990582,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+892302,int_stack+506004,int_stack+758652,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+663954,int_stack+126351,int_stack+122256,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+676239,int_stack+131356,int_stack+126351,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+691254,int_stack+676239,int_stack+663954,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+715824,int_stack+137362,int_stack+131356,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+733842,int_stack+715824,int_stack+676239,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+763872,int_stack+733842,int_stack+691254,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+663954,int_stack+144460,int_stack+137362,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+804822,int_stack+663954,int_stack+715824,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+840858,int_stack+804822,int_stack+733842,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+685248,int_stack+840858,int_stack+763872,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+746673,int_stack+152741,int_stack+144460,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+746673,int_stack+663954,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42588,int_stack+0,int_stack+804822,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1293252,int_stack+42588,int_stack+840858,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+771516,int_stack+1293252,int_stack+685248,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+663954,int_stack+162296,int_stack+152741,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+692619,int_stack+663954,int_stack+746673,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1368327,int_stack+692619,int_stack+0,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1439307,int_stack+1368327,int_stack+42588,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1439307,int_stack+1293252,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1529397,int_stack+0,int_stack+771516,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1293252,int_stack+173216,int_stack+162296,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+105105,int_stack+1293252,int_stack+663954,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+742305,int_stack+105105,int_stack+692619,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1644057,int_stack+742305,int_stack+1368327,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1750527,int_stack+1644057,int_stack+1439307,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1326012,int_stack+1750527,int_stack+0,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1876653,int_stack+1326012,int_stack+1529397,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+185592,int_stack+173216,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37128,int_stack+0,int_stack+1293252,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1466152,int_stack+37128,int_stack+105105,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1466152,int_stack+742305,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1466152,int_stack+0,int_stack+1644057,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1466152,int_stack+1750527,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1466152,int_stack+0,int_stack+1326012,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1466152,int_stack+1876653,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+1293252,int_stack+0,int_stack+506004,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1767102,int_stack+1293252,int_stack+892302,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+204240,int_stack+199515,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+520179,int_stack+210015,int_stack+204240,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+537504,int_stack+520179,int_stack+506004,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+565854,int_stack+216945,int_stack+210015,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+586644,int_stack+565854,int_stack+520179,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+621294,int_stack+586644,int_stack+537504,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+225135,int_stack+216945,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+668544,int_stack+506004,int_stack+565854,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+710124,int_stack+668544,int_stack+586644,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+530574,int_stack+710124,int_stack+621294,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+601449,int_stack+234690,int_stack+225135,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+767874,int_stack+601449,int_stack+506004,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+817014,int_stack+767874,int_stack+668544,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+886314,int_stack+817014,int_stack+710124,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+630114,int_stack+886314,int_stack+530574,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+245715,int_stack+234690,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+539079,int_stack+506004,int_stack+601449,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+972939,int_stack+539079,int_stack+767874,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1054839,int_stack+972939,int_stack+817014,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+729339,int_stack+1054839,int_stack+886314,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1158789,int_stack+729339,int_stack+630114,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+596409,int_stack+258315,int_stack+245715,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+634209,int_stack+596409,int_stack+506004,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+850614,int_stack+634209,int_stack+539079,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2569002,int_stack+850614,int_stack+972939,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2691852,int_stack+2569002,int_stack+1054839,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+946164,int_stack+2691852,int_stack+729339,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2837382,int_stack+946164,int_stack+1158789,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+506004,int_stack+272595,int_stack+258315,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+700359,int_stack+506004,int_stack+596409,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+506004,int_stack+700359,int_stack+634209,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+616254,int_stack+506004,int_stack+850614,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+759579,int_stack+616254,int_stack+2569002,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+506004,int_stack+759579,int_stack+2691852,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2569002,int_stack+506004,int_stack+946164,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+506004,int_stack+2569002,int_stack+2837382,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+718629,int_stack+506004,int_stack+0,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+2569002,int_stack+718629,int_stack+1293252,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+3516702,int_stack+2569002,int_stack+1767102,2025);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+294060,int_stack+288660,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16200,int_stack+300660,int_stack+294060,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+36000,int_stack+16200,int_stack+0,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68400,int_stack+308580,int_stack+300660,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92160,int_stack+68400,int_stack+16200,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+131760,int_stack+92160,int_stack+36000,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+317940,int_stack+308580,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+185760,int_stack+0,int_stack+68400,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233280,int_stack+185760,int_stack+92160,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+28080,int_stack+233280,int_stack+131760,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+109080,int_stack+328860,int_stack+317940,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1271454,int_stack+109080,int_stack+0,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1327614,int_stack+1271454,int_stack+185760,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1406814,int_stack+1327614,int_stack+233280,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+141840,int_stack+1406814,int_stack+28080,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+341460,int_stack+328860,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+37800,int_stack+0,int_stack+109080,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1505814,int_stack+37800,int_stack+1271454,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1599414,int_stack+1505814,int_stack+1327614,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1718214,int_stack+1599414,int_stack+1406814,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1271454,int_stack+1718214,int_stack+141840,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1422654,int_stack+355860,int_stack+341460,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+103320,int_stack+1422654,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+178920,int_stack+103320,int_stack+37800,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1856814,int_stack+178920,int_stack+1505814,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1997214,int_stack+1856814,int_stack+1599414,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1465854,int_stack+1997214,int_stack+1718214,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1650654,int_stack+1465854,int_stack+1271454,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1271454,int_stack+372180,int_stack+355860,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1320414,int_stack+1271454,int_stack+1422654,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2163534,int_stack+1320414,int_stack+103320,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1271454,int_stack+2163534,int_stack+178920,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2163534,int_stack+1271454,int_stack+1856814,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+2163534,int_stack+1997214,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1845054,int_stack+0,int_stack+1465854,120);
 /*--- compute (t0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1845054,int_stack+1650654,120);
 /*--- compute (rp|ll) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1271454,int_stack+0,int_stack+506004,2025);
 /*--- compute (qd|ll) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4853202,int_stack+1271454,int_stack+718629,2025);
 /*--- compute (of|ll) ---*/
 hrr1_build_of(Libint->AB,int_stack+5958852,int_stack+4853202,int_stack+2569002,2025);
 /*--- compute (ng|ll) ---*/
 hrr1_build_ng(Libint->AB,int_stack+7538352,int_stack+5958852,int_stack+3516702,2025);
 /*--- compute (u0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+396660,int_stack+390540,136);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+524364,int_stack+404140,int_stack+396660,136);
 /*--- compute (u0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+546804,int_stack+524364,int_stack+506004,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+583524,int_stack+413116,int_stack+404140,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+610452,int_stack+583524,int_stack+524364,136);
 /*--- compute (u0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+655332,int_stack+610452,int_stack+546804,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+423724,int_stack+413116,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+716532,int_stack+506004,int_stack+583524,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+770388,int_stack+716532,int_stack+610452,136);
 /*--- compute (u0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+537828,int_stack+770388,int_stack+655332,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+629628,int_stack+436100,int_stack+423724,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+845188,int_stack+629628,int_stack+506004,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+908836,int_stack+845188,int_stack+716532,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+998596,int_stack+908836,int_stack+770388,136);
 /*--- compute (u0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+666756,int_stack+998596,int_stack+537828,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+450380,int_stack+436100,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+548844,int_stack+506004,int_stack+629628,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1110796,int_stack+548844,int_stack+845188,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+243000,int_stack+1110796,int_stack+908836,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+795276,int_stack+243000,int_stack+998596,136);
 /*--- compute (u0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1909329,int_stack+795276,int_stack+666756,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+623100,int_stack+466700,int_stack+450380,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+672060,int_stack+623100,int_stack+506004,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+952356,int_stack+672060,int_stack+548844,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2080689,int_stack+952356,int_stack+1110796,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1076116,int_stack+2080689,int_stack+243000,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+243000,int_stack+1076116,int_stack+795276,136);
 /*--- compute (u0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2239809,int_stack+243000,int_stack+1909329,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1909329,int_stack+485196,int_stack+466700,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1964817,int_stack+1909329,int_stack+623100,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+452440,int_stack+1964817,int_stack+672060,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+595240,int_stack+452440,int_stack+952356,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+780880,int_stack+595240,int_stack+2080689,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+452440,int_stack+780880,int_stack+1076116,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+703768,int_stack+452440,int_stack+243000,136);
 /*--- compute (u0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+243000,int_stack+703768,int_stack+2239809,136);
 /*--- compute (tp|ll) ---*/
 hrr1_build_tp(Libint->AB,int_stack+518400,int_stack+243000,int_stack+0,2025);
 /*--- compute (rd|ll) ---*/
 hrr1_build_rd(Libint->AB,int_stack+1909329,int_stack+518400,int_stack+1271454,2025);
 /*--- compute (qf|ll) ---*/
 hrr1_build_qf(Libint->AB,int_stack+0,int_stack+1909329,int_stack+4853202,2025);
 /*--- compute (og|ll) ---*/
 hrr1_build_og(Libint->AB,int_stack+1842750,int_stack+0,int_stack+5958852,2025);
 /*--- compute (nh|ll) ---*/
 hrr1_build_nh(Libint->AB,int_stack+4212000,int_stack+1842750,int_stack+7538352,2025);
 return int_stack+4212000;}
