/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppmk(Libint_t*, prim_data*);

  /* Computes quartets of (pp|mk) integrals */

REALTYPE *hrr_order_ppmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 Libint->vrr_classes[1][14] = int_stack + 1185;
 Libint->vrr_classes[1][15] = int_stack + 1545;
 Libint->vrr_classes[1][16] = int_stack + 1953;
 Libint->vrr_classes[2][9] = int_stack + 2412;
 Libint->vrr_classes[2][10] = int_stack + 2742;
 Libint->vrr_classes[2][11] = int_stack + 3138;
 Libint->vrr_classes[2][12] = int_stack + 3606;
 Libint->vrr_classes[2][13] = int_stack + 4152;
 Libint->vrr_classes[2][14] = int_stack + 4782;
 Libint->vrr_classes[2][15] = int_stack + 5502;
 Libint->vrr_classes[2][16] = int_stack + 6318;
 memset(int_stack,0,7236*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7236;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppmk(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7236,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7731,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8325,int_stack+7731,int_stack+7236,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+9315,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10017,int_stack+9315,int_stack+7731,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+11205,int_stack+10017,int_stack+8325,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+7236,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+12855,int_stack+7236,int_stack+9315,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+14259,int_stack+12855,int_stack+10017,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+8055,int_stack+14259,int_stack+11205,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+10530,int_stack+1185,int_stack+870,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+16239,int_stack+10530,int_stack+7236,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17877,int_stack+16239,int_stack+12855,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+20217,int_stack+17877,int_stack+14259,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+11475,int_stack+20217,int_stack+8055,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+7236,int_stack+1545,int_stack+1185,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+8316,int_stack+7236,int_stack+10530,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+23187,int_stack+8316,int_stack+16239,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+25917,int_stack+23187,int_stack+17877,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+14940,int_stack+25917,int_stack+20217,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+29427,int_stack+14940,int_stack+11475,3);
 /*--- compute (p0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+10206,int_stack+1953,int_stack+1545,3);
 /*--- compute (p0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+11430,int_stack+10206,int_stack+7236,3);
 /*--- compute (p0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+19098,int_stack+11430,int_stack+8316,3);
 /*--- compute (p0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+7236,int_stack+19098,int_stack+23187,3);
 /*--- compute (p0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+19098,int_stack+7236,int_stack+25917,3);
 /*--- compute (p0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+7236,int_stack+19098,int_stack+14940,3);
 /*--- compute (p0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+12780,int_stack+7236,int_stack+29427,3);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7236,int_stack+2742,int_stack+2412,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8226,int_stack+3138,int_stack+2742,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+9414,int_stack+8226,int_stack+7236,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18720,int_stack+3606,int_stack+3138,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+20124,int_stack+18720,int_stack+8226,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+22500,int_stack+20124,int_stack+9414,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+7236,int_stack+4152,int_stack+3606,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+8874,int_stack+7236,int_stack+18720,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25800,int_stack+8874,int_stack+20124,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+29760,int_stack+25800,int_stack+22500,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+18720,int_stack+4782,int_stack+4152,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20610,int_stack+18720,int_stack+7236,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+20610,int_stack+8874,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+34710,int_stack+0,int_stack+25800,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+40650,int_stack+34710,int_stack+29760,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+7236,int_stack+5502,int_stack+4782,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+23886,int_stack+7236,int_stack+18720,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+27666,int_stack+23886,int_stack+20610,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+47580,int_stack+27666,int_stack+0,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+54600,int_stack+47580,int_stack+34710,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+62916,int_stack+54600,int_stack+40650,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+6318,int_stack+5502,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2448,int_stack+0,int_stack+7236,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+33126,int_stack+2448,int_stack+23886,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+33126,int_stack+27666,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+18720,int_stack+0,int_stack+47580,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+18720,int_stack+54600,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+18720,int_stack+0,int_stack+62916,6);
 /*--- compute (pp|mk) ---*/
 hrr1_build_pp(Libint->AB,int_stack+30600,int_stack+18720,int_stack+12780,1980);
 return int_stack+30600;}
