/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fd|ih) integrals */

void vrr_order_fdih(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_p0d0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+6, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+49, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+52, vrr_stack+49, vrr_stack+12, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+58, vrr_stack+52, vrr_stack+15, vrr_stack+49, vrr_stack+12, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+68, vrr_stack+3, vrr_stack+12, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+74, vrr_stack+6, vrr_stack+68, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+84, vrr_stack+39, vrr_stack+74, NULL, NULL, vrr_stack+6);
 _BUILD_p0f0(Data,vrr_stack+114, vrr_stack+58, vrr_stack+39, NULL, NULL, vrr_stack+15);
 _BUILD_d0f0(Data,vrr_stack+144, vrr_stack+114, vrr_stack+84, vrr_stack+58, vrr_stack+39, vrr_stack+21);
 _BUILD_00g0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+74, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+204, vrr_stack+58, vrr_stack+39, vrr_stack+52, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+219, vrr_stack+204, vrr_stack+21, NULL, NULL, vrr_stack+39);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+36, vrr_stack+49, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+264, vrr_stack+15, vrr_stack+52, vrr_stack+36, vrr_stack+49, NULL);
 _BUILD_00g0(Data,vrr_stack+274, vrr_stack+264, vrr_stack+58, vrr_stack+15, vrr_stack+52, NULL);
 _BUILD_p0g0(Data,vrr_stack+289, vrr_stack+274, vrr_stack+204, NULL, NULL, vrr_stack+58);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49, vrr_stack+12, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+334, vrr_stack+68, vrr_stack+49, vrr_stack+3, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+344, vrr_stack+74, vrr_stack+334, vrr_stack+6, vrr_stack+68, NULL);
 _BUILD_p0g0(Data,vrr_stack+359, vrr_stack+21, vrr_stack+344, NULL, NULL, vrr_stack+74);
 _BUILD_d0g0(Data,vrr_stack+404, vrr_stack+219, vrr_stack+359, vrr_stack+204, vrr_stack+21, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+494, vrr_stack+289, vrr_stack+219, vrr_stack+274, vrr_stack+204, vrr_stack+114);
 _BUILD_f0g0(Data,vrr_stack+584, vrr_stack+494, vrr_stack+404, vrr_stack+289, vrr_stack+219, vrr_stack+144);
 _BUILD_00h0(Data,vrr_stack+84, vrr_stack+204, vrr_stack+21, vrr_stack+58, vrr_stack+39, NULL);
 _BUILD_00h0(Data,vrr_stack+105, vrr_stack+274, vrr_stack+204, vrr_stack+264, vrr_stack+58, NULL);
 _BUILD_00h0(Data,vrr_stack+126, vrr_stack+21, vrr_stack+344, vrr_stack+39, vrr_stack+74, NULL);
 _BUILD_p0h0(Data,vrr_stack+734, vrr_stack+84, vrr_stack+126, NULL, NULL, vrr_stack+21);
 _BUILD_p0h0(Data,vrr_stack+797, vrr_stack+105, vrr_stack+84, NULL, NULL, vrr_stack+204);
 _BUILD_d0h0(Data,vrr_stack+860, vrr_stack+797, vrr_stack+734, vrr_stack+105, vrr_stack+84, vrr_stack+219);
 _BUILD_00p0(Data,vrr_stack+219, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+222, vrr_stack+219, vrr_stack+36, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+222, vrr_stack+15, vrr_stack+219, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+986, vrr_stack+39, vrr_stack+264, vrr_stack+222, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+228, vrr_stack+986, vrr_stack+274, vrr_stack+39, vrr_stack+264, NULL);
 _BUILD_p0h0(Data,vrr_stack+1001, vrr_stack+228, vrr_stack+105, NULL, NULL, vrr_stack+274);
 _BUILD_d0h0(Data,vrr_stack+1064, vrr_stack+1001, vrr_stack+797, vrr_stack+228, vrr_stack+105, vrr_stack+289);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+36, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+289, vrr_stack+49, vrr_stack+15, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+299, vrr_stack+334, vrr_stack+289, vrr_stack+68, vrr_stack+49, NULL);
 _BUILD_00h0(Data,vrr_stack+249, vrr_stack+344, vrr_stack+299, vrr_stack+74, vrr_stack+334, NULL);
 _BUILD_p0h0(Data,vrr_stack+1190, vrr_stack+126, vrr_stack+249, NULL, NULL, vrr_stack+344);
 _BUILD_d0h0(Data,vrr_stack+1253, vrr_stack+734, vrr_stack+1190, vrr_stack+84, vrr_stack+126, vrr_stack+359);
 _BUILD_f0h0(Data,vrr_stack+1379, vrr_stack+860, vrr_stack+1253, vrr_stack+797, vrr_stack+734, vrr_stack+404);
 _BUILD_f0h0(Data,vrr_stack+1589, vrr_stack+1064, vrr_stack+860, vrr_stack+1001, vrr_stack+797, vrr_stack+494);
 _BUILD_g0h0(Data,vrr_stack+1799, vrr_stack+1589, vrr_stack+1379, vrr_stack+1064, vrr_stack+860, vrr_stack+584);
 _BUILD_00i0(Data,vrr_stack+359, vrr_stack+84, vrr_stack+126, vrr_stack+204, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+387, vrr_stack+105, vrr_stack+84, vrr_stack+274, vrr_stack+204, NULL);
 _BUILD_p0i0(Data,vrr_stack+415, vrr_stack+387, vrr_stack+359, NULL, NULL, vrr_stack+84);
 _BUILD_00i0(Data,vrr_stack+499, vrr_stack+228, vrr_stack+105, vrr_stack+986, vrr_stack+274, NULL);
 _BUILD_p0i0(Data,vrr_stack+527, vrr_stack+499, vrr_stack+387, NULL, NULL, vrr_stack+105);
 _BUILD_00i0(Data,vrr_stack+611, vrr_stack+126, vrr_stack+249, vrr_stack+21, vrr_stack+344, NULL);
 _BUILD_p0i0(Data,vrr_stack+639, vrr_stack+359, vrr_stack+611, NULL, NULL, vrr_stack+126);
 _BUILD_d0i0(Data,vrr_stack+2114, vrr_stack+415, vrr_stack+639, vrr_stack+387, vrr_stack+359, vrr_stack+734);
 _BUILD_d0i0(Data,vrr_stack+2282, vrr_stack+527, vrr_stack+415, vrr_stack+499, vrr_stack+387, vrr_stack+797);
 _BUILD_f0i0(Data,vrr_stack+2450, vrr_stack+2282, vrr_stack+2114, vrr_stack+527, vrr_stack+415, vrr_stack+860);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+219, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+723, vrr_stack+24, vrr_stack+222, vrr_stack+21, vrr_stack+219, NULL);
 _BUILD_00g0(Data,vrr_stack+733, vrr_stack+723, vrr_stack+39, vrr_stack+24, vrr_stack+222, NULL);
 _BUILD_00h0(Data,vrr_stack+748, vrr_stack+733, vrr_stack+986, vrr_stack+723, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+769, vrr_stack+748, vrr_stack+228, vrr_stack+733, vrr_stack+986, NULL);
 _BUILD_p0i0(Data,vrr_stack+797, vrr_stack+769, vrr_stack+499, NULL, NULL, vrr_stack+228);
 _BUILD_d0i0(Data,vrr_stack+2730, vrr_stack+797, vrr_stack+527, vrr_stack+769, vrr_stack+499, vrr_stack+1001);
 _BUILD_f0i0(Data,vrr_stack+2898, vrr_stack+2730, vrr_stack+2282, vrr_stack+797, vrr_stack+527, vrr_stack+1064);
   tmp = vrr_stack + 2898;
   target_ptr = Libint->vrr_classes[3][6];
   for(i=0;i<280;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+797, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+800, vrr_stack+36, vrr_stack+797, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+800, vrr_stack+0, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+289, vrr_stack+39, vrr_stack+49, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+49, vrr_stack+299, vrr_stack+0, vrr_stack+334, vrr_stack+289, NULL);
 _BUILD_00i0(Data,vrr_stack+806, vrr_stack+249, vrr_stack+49, vrr_stack+344, vrr_stack+299, NULL);
 _BUILD_p0i0(Data,vrr_stack+834, vrr_stack+611, vrr_stack+806, NULL, NULL, vrr_stack+249);
 _BUILD_d0i0(Data,vrr_stack+918, vrr_stack+639, vrr_stack+834, vrr_stack+359, vrr_stack+611, vrr_stack+1190);
 _BUILD_f0i0(Data,vrr_stack+3178, vrr_stack+2114, vrr_stack+918, vrr_stack+415, vrr_stack+639, vrr_stack+1253);
 _BUILD_g0i0(Data,vrr_stack+3458, vrr_stack+2450, vrr_stack+3178, vrr_stack+2282, vrr_stack+2114, vrr_stack+1379);
 _BUILD_g0i0(Data,vrr_stack+1086, vrr_stack+2898, vrr_stack+2450, vrr_stack+2730, vrr_stack+2282, vrr_stack+1589);
   tmp = vrr_stack + 1086;
   target_ptr = Libint->vrr_classes[4][6];
   for(i=0;i<420;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+2730, vrr_stack+359, vrr_stack+611, vrr_stack+84, vrr_stack+126, NULL);
 _BUILD_00k0(Data,vrr_stack+2766, vrr_stack+387, vrr_stack+359, vrr_stack+105, vrr_stack+84, NULL);
 _BUILD_p0k0(Data,vrr_stack+1506, vrr_stack+2766, vrr_stack+2730, NULL, NULL, vrr_stack+359);
 _BUILD_00k0(Data,vrr_stack+2802, vrr_stack+499, vrr_stack+387, vrr_stack+228, vrr_stack+105, NULL);
 _BUILD_p0k0(Data,vrr_stack+1614, vrr_stack+2802, vrr_stack+2766, NULL, NULL, vrr_stack+387);
 _BUILD_00k0(Data,vrr_stack+2838, vrr_stack+611, vrr_stack+806, vrr_stack+126, vrr_stack+249, NULL);
 _BUILD_p0k0(Data,vrr_stack+70, vrr_stack+2730, vrr_stack+2838, NULL, NULL, vrr_stack+611);
 _BUILD_d0k0(Data,vrr_stack+3878, vrr_stack+1506, vrr_stack+70, vrr_stack+2766, vrr_stack+2730, vrr_stack+639);
 _BUILD_d0k0(Data,vrr_stack+4094, vrr_stack+1614, vrr_stack+1506, vrr_stack+2802, vrr_stack+2766, vrr_stack+415);
 _BUILD_f0k0(Data,vrr_stack+4310, vrr_stack+4094, vrr_stack+3878, vrr_stack+1614, vrr_stack+1506, vrr_stack+2114);
 _BUILD_00k0(Data,vrr_stack+2114, vrr_stack+769, vrr_stack+499, vrr_stack+748, vrr_stack+228, NULL);
 _BUILD_p0k0(Data,vrr_stack+2150, vrr_stack+2114, vrr_stack+2802, NULL, NULL, vrr_stack+499);
 _BUILD_d0k0(Data,vrr_stack+4670, vrr_stack+2150, vrr_stack+1614, vrr_stack+2114, vrr_stack+2802, vrr_stack+527);
 _BUILD_f0k0(Data,vrr_stack+4886, vrr_stack+4670, vrr_stack+4094, vrr_stack+2150, vrr_stack+1614, vrr_stack+2282);
   tmp = vrr_stack + 4886;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2150, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2153, vrr_stack+797, vrr_stack+2150, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+2159, vrr_stack+800, vrr_stack+2153, vrr_stack+36, vrr_stack+797, NULL);
 _BUILD_00g0(Data,vrr_stack+2169, vrr_stack+39, vrr_stack+2159, vrr_stack+15, vrr_stack+800, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+2169, vrr_stack+289, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+2184, vrr_stack+49, vrr_stack+15, vrr_stack+299, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+2212, vrr_stack+806, vrr_stack+2184, vrr_stack+249, vrr_stack+49, NULL);
 _BUILD_p0k0(Data,vrr_stack+2248, vrr_stack+2838, vrr_stack+2212, NULL, NULL, vrr_stack+806);
 _BUILD_d0k0(Data,vrr_stack+5246, vrr_stack+70, vrr_stack+2248, vrr_stack+2730, vrr_stack+2838, vrr_stack+834);
 _BUILD_f0k0(Data,vrr_stack+5462, vrr_stack+3878, vrr_stack+5246, vrr_stack+1506, vrr_stack+70, vrr_stack+918);
 _BUILD_g0k0(Data,vrr_stack+5822, vrr_stack+4310, vrr_stack+5462, vrr_stack+4094, vrr_stack+3878, vrr_stack+3178);
 _BUILD_g0k0(Data,vrr_stack+6362, vrr_stack+4886, vrr_stack+4310, vrr_stack+4670, vrr_stack+4094, vrr_stack+2450);
   tmp = vrr_stack + 6362;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+4670, vrr_stack+2730, vrr_stack+2838, vrr_stack+359, vrr_stack+611, NULL);
 _BUILD_00l0(Data,vrr_stack+4715, vrr_stack+2766, vrr_stack+2730, vrr_stack+387, vrr_stack+359, NULL);
 _BUILD_p0l0(Data,vrr_stack+3178, vrr_stack+4715, vrr_stack+4670, NULL, NULL, vrr_stack+2730);
 _BUILD_00l0(Data,vrr_stack+4760, vrr_stack+2802, vrr_stack+2766, vrr_stack+499, vrr_stack+387, NULL);
 _BUILD_p0l0(Data,vrr_stack+3313, vrr_stack+4760, vrr_stack+4715, NULL, NULL, vrr_stack+2766);
 _BUILD_00l0(Data,vrr_stack+4805, vrr_stack+2838, vrr_stack+2212, vrr_stack+611, vrr_stack+806, NULL);
 _BUILD_p0l0(Data,vrr_stack+834, vrr_stack+4670, vrr_stack+4805, NULL, NULL, vrr_stack+2838);
 _BUILD_d0l0(Data,vrr_stack+178, vrr_stack+3178, vrr_stack+834, vrr_stack+4715, vrr_stack+4670, vrr_stack+70);
 _BUILD_d0l0(Data,vrr_stack+6902, vrr_stack+3313, vrr_stack+3178, vrr_stack+4760, vrr_stack+4715, vrr_stack+1506);
 _BUILD_f0l0(Data,vrr_stack+7172, vrr_stack+6902, vrr_stack+178, vrr_stack+3313, vrr_stack+3178, vrr_stack+3878);
 _BUILD_00l0(Data,vrr_stack+3878, vrr_stack+2114, vrr_stack+2802, vrr_stack+769, vrr_stack+499, NULL);
 _BUILD_p0l0(Data,vrr_stack+3923, vrr_stack+3878, vrr_stack+4760, NULL, NULL, vrr_stack+2802);
 _BUILD_d0l0(Data,vrr_stack+448, vrr_stack+3923, vrr_stack+3313, vrr_stack+3878, vrr_stack+4760, vrr_stack+1614);
 _BUILD_f0l0(Data,vrr_stack+7622, vrr_stack+448, vrr_stack+6902, vrr_stack+3923, vrr_stack+3313, vrr_stack+4094);
   tmp = vrr_stack + 7622;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+36, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3923, vrr_stack+2150, vrr_stack+36, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+3448, vrr_stack+2153, vrr_stack+3923, vrr_stack+797, vrr_stack+2150, NULL);
 _BUILD_00g0(Data,vrr_stack+3929, vrr_stack+2159, vrr_stack+3448, vrr_stack+800, vrr_stack+2153, NULL);
 _BUILD_00h0(Data,vrr_stack+3944, vrr_stack+2169, vrr_stack+3929, vrr_stack+39, vrr_stack+2159, NULL);
 _BUILD_00i0(Data,vrr_stack+3965, vrr_stack+15, vrr_stack+3944, vrr_stack+0, vrr_stack+2169, NULL);
 _BUILD_00k0(Data,vrr_stack+4850, vrr_stack+2184, vrr_stack+3965, vrr_stack+49, vrr_stack+15, NULL);
 _BUILD_00l0(Data,vrr_stack+39, vrr_stack+2212, vrr_stack+4850, vrr_stack+806, vrr_stack+2184, NULL);
 _BUILD_p0l0(Data,vrr_stack+3993, vrr_stack+4805, vrr_stack+39, NULL, NULL, vrr_stack+2212);
 _BUILD_d0l0(Data,vrr_stack+1506, vrr_stack+834, vrr_stack+3993, vrr_stack+4670, vrr_stack+4805, vrr_stack+2248);
 _BUILD_f0l0(Data,vrr_stack+8072, vrr_stack+178, vrr_stack+1506, vrr_stack+3178, vrr_stack+834, vrr_stack+5246);
 _BUILD_g0l0(Data,vrr_stack+8522, vrr_stack+7172, vrr_stack+8072, vrr_stack+6902, vrr_stack+178, vrr_stack+5462);
 _BUILD_g0l0(Data,vrr_stack+9197, vrr_stack+7622, vrr_stack+7172, vrr_stack+448, vrr_stack+6902, vrr_stack+4310);
   tmp = vrr_stack + 9197;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+448, vrr_stack+4670, vrr_stack+4805, vrr_stack+2730, vrr_stack+2838, NULL);
 _BUILD_00m0(Data,vrr_stack+503, vrr_stack+4715, vrr_stack+4670, vrr_stack+2766, vrr_stack+2730, NULL);
 _BUILD_p0m0(Data,vrr_stack+558, vrr_stack+503, vrr_stack+448, NULL, NULL, vrr_stack+4670);
 _BUILD_00m0(Data,vrr_stack+723, vrr_stack+4760, vrr_stack+4715, vrr_stack+2802, vrr_stack+2766, NULL);
 _BUILD_p0m0(Data,vrr_stack+5246, vrr_stack+723, vrr_stack+503, NULL, NULL, vrr_stack+4715);
 _BUILD_00m0(Data,vrr_stack+2730, vrr_stack+4805, vrr_stack+39, vrr_stack+2838, vrr_stack+2212, NULL);
 _BUILD_p0m0(Data,vrr_stack+5411, vrr_stack+448, vrr_stack+2730, NULL, NULL, vrr_stack+4805);
 _BUILD_d0m0(Data,vrr_stack+9872, vrr_stack+558, vrr_stack+5411, vrr_stack+503, vrr_stack+448, vrr_stack+834);
 _BUILD_d0m0(Data,vrr_stack+10202, vrr_stack+5246, vrr_stack+558, vrr_stack+723, vrr_stack+503, vrr_stack+3178);
 _BUILD_f0m0(Data,vrr_stack+10532, vrr_stack+10202, vrr_stack+9872, vrr_stack+5246, vrr_stack+558, vrr_stack+178);
 _BUILD_00m0(Data,vrr_stack+3178, vrr_stack+3878, vrr_stack+4760, vrr_stack+2114, vrr_stack+2802, NULL);
 _BUILD_p0m0(Data,vrr_stack+778, vrr_stack+3178, vrr_stack+723, NULL, NULL, vrr_stack+4760);
 _BUILD_d0m0(Data,vrr_stack+84, vrr_stack+778, vrr_stack+5246, vrr_stack+3178, vrr_stack+723, vrr_stack+3313);
 _BUILD_f0m0(Data,vrr_stack+11082, vrr_stack+84, vrr_stack+10202, vrr_stack+778, vrr_stack+5246, vrr_stack+6902);
   tmp = vrr_stack + 11082;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6902, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6905, vrr_stack+36, vrr_stack+6902, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+6911, vrr_stack+3923, vrr_stack+6905, vrr_stack+2150, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+3448, vrr_stack+6911, vrr_stack+2153, vrr_stack+3923, NULL);
 _BUILD_00h0(Data,vrr_stack+6921, vrr_stack+3929, vrr_stack+0, vrr_stack+2159, vrr_stack+3448, NULL);
 _BUILD_00i0(Data,vrr_stack+6942, vrr_stack+3944, vrr_stack+6921, vrr_stack+2169, vrr_stack+3929, NULL);
 _BUILD_00k0(Data,vrr_stack+6970, vrr_stack+3965, vrr_stack+6942, vrr_stack+15, vrr_stack+3944, NULL);
 _BUILD_00l0(Data,vrr_stack+7006, vrr_stack+4850, vrr_stack+6970, vrr_stack+2184, vrr_stack+3965, NULL);
 _BUILD_00m0(Data,vrr_stack+7051, vrr_stack+39, vrr_stack+7006, vrr_stack+2212, vrr_stack+4850, NULL);
 _BUILD_p0m0(Data,vrr_stack+778, vrr_stack+2730, vrr_stack+7051, NULL, NULL, vrr_stack+39);
 _BUILD_d0m0(Data,vrr_stack+2114, vrr_stack+5411, vrr_stack+778, vrr_stack+448, vrr_stack+2730, vrr_stack+3993);
 _BUILD_f0m0(Data,vrr_stack+11632, vrr_stack+9872, vrr_stack+2114, vrr_stack+558, vrr_stack+5411, vrr_stack+1506);
 _BUILD_g0m0(Data,vrr_stack+12182, vrr_stack+10532, vrr_stack+11632, vrr_stack+10202, vrr_stack+9872, vrr_stack+8072);
 _BUILD_g0m0(Data,vrr_stack+13007, vrr_stack+11082, vrr_stack+10532, vrr_stack+84, vrr_stack+10202, vrr_stack+7172);
   tmp = vrr_stack + 13007;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+7106, vrr_stack+448, vrr_stack+2730, vrr_stack+4670, vrr_stack+4805, NULL);
 _BUILD_00n0(Data,vrr_stack+84, vrr_stack+503, vrr_stack+448, vrr_stack+4715, vrr_stack+4670, NULL);
 _BUILD_p0n0(Data,vrr_stack+150, vrr_stack+84, vrr_stack+7106, NULL, NULL, vrr_stack+448);
 _BUILD_00n0(Data,vrr_stack+348, vrr_stack+723, vrr_stack+503, vrr_stack+4760, vrr_stack+4715, NULL);
 _BUILD_p0n0(Data,vrr_stack+8072, vrr_stack+348, vrr_stack+84, NULL, NULL, vrr_stack+503);
 _BUILD_00n0(Data,vrr_stack+4670, vrr_stack+2730, vrr_stack+7051, vrr_stack+4805, vrr_stack+39, NULL);
 _BUILD_p0n0(Data,vrr_stack+8270, vrr_stack+7106, vrr_stack+4670, NULL, NULL, vrr_stack+2730);
 _BUILD_d0n0(Data,vrr_stack+13832, vrr_stack+150, vrr_stack+8270, vrr_stack+84, vrr_stack+7106, vrr_stack+5411);
 _BUILD_d0n0(Data,vrr_stack+5411, vrr_stack+8072, vrr_stack+150, vrr_stack+348, vrr_stack+84, vrr_stack+558);
 _BUILD_f0n0(Data,vrr_stack+14228, vrr_stack+5411, vrr_stack+13832, vrr_stack+8072, vrr_stack+150, vrr_stack+9872);
 _BUILD_00n0(Data,vrr_stack+9872, vrr_stack+3178, vrr_stack+723, vrr_stack+3878, vrr_stack+4760, NULL);
 _BUILD_p0n0(Data,vrr_stack+9938, vrr_stack+9872, vrr_stack+348, NULL, NULL, vrr_stack+723);
 _BUILD_d0n0(Data,vrr_stack+14888, vrr_stack+9938, vrr_stack+8072, vrr_stack+9872, vrr_stack+348, vrr_stack+5246);
 _BUILD_f0n0(Data,vrr_stack+15284, vrr_stack+14888, vrr_stack+5411, vrr_stack+9938, vrr_stack+8072, vrr_stack+10202);
   tmp = vrr_stack + 15284;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+9938, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2444, vrr_stack+6902, vrr_stack+9938, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+9941, vrr_stack+6905, vrr_stack+2444, vrr_stack+36, vrr_stack+6902, NULL);
 _BUILD_00g0(Data,vrr_stack+5807, vrr_stack+6911, vrr_stack+9941, vrr_stack+3923, vrr_stack+6905, NULL);
 _BUILD_00h0(Data,vrr_stack+9951, vrr_stack+0, vrr_stack+5807, vrr_stack+3448, vrr_stack+6911, NULL);
 _BUILD_00i0(Data,vrr_stack+9972, vrr_stack+6921, vrr_stack+9951, vrr_stack+3929, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+10000, vrr_stack+6942, vrr_stack+9972, vrr_stack+3944, vrr_stack+6921, NULL);
 _BUILD_00l0(Data,vrr_stack+10036, vrr_stack+6970, vrr_stack+10000, vrr_stack+3965, vrr_stack+6942, NULL);
 _BUILD_00m0(Data,vrr_stack+10081, vrr_stack+7006, vrr_stack+10036, vrr_stack+4850, vrr_stack+6970, NULL);
 _BUILD_00n0(Data,vrr_stack+10136, vrr_stack+7051, vrr_stack+10081, vrr_stack+39, vrr_stack+7006, NULL);
 _BUILD_p0n0(Data,vrr_stack+10202, vrr_stack+4670, vrr_stack+10136, NULL, NULL, vrr_stack+7051);
 _BUILD_d0n0(Data,vrr_stack+3878, vrr_stack+8270, vrr_stack+10202, vrr_stack+7106, vrr_stack+4670, vrr_stack+778);
 _BUILD_f0n0(Data,vrr_stack+15944, vrr_stack+13832, vrr_stack+3878, vrr_stack+150, vrr_stack+8270, vrr_stack+2114);
 _BUILD_g0n0(Data,vrr_stack+16604, vrr_stack+14228, vrr_stack+15944, vrr_stack+5411, vrr_stack+13832, vrr_stack+11632);
 _BUILD_g0n0(Data,vrr_stack+17594, vrr_stack+15284, vrr_stack+14228, vrr_stack+14888, vrr_stack+5411, vrr_stack+10532);
   tmp = vrr_stack + 17594;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+14888, vrr_stack+7106, vrr_stack+4670, vrr_stack+448, vrr_stack+2730, NULL);
 _BUILD_00o0(Data,vrr_stack+14966, vrr_stack+84, vrr_stack+7106, vrr_stack+503, vrr_stack+448, NULL);
 _BUILD_p0o0(Data,vrr_stack+15044, vrr_stack+14966, vrr_stack+14888, NULL, NULL, vrr_stack+7106);
 _BUILD_00o0(Data,vrr_stack+11632, vrr_stack+348, vrr_stack+84, vrr_stack+723, vrr_stack+503, NULL);
 _BUILD_p0o0(Data,vrr_stack+11710, vrr_stack+11632, vrr_stack+14966, NULL, NULL, vrr_stack+84);
 _BUILD_00o0(Data,vrr_stack+11944, vrr_stack+4670, vrr_stack+10136, vrr_stack+2730, vrr_stack+7051, NULL);
 _BUILD_p0o0(Data,vrr_stack+2114, vrr_stack+14888, vrr_stack+11944, NULL, NULL, vrr_stack+4670);
 _BUILD_d0o0(Data,vrr_stack+18584, vrr_stack+15044, vrr_stack+2114, vrr_stack+14966, vrr_stack+14888, vrr_stack+8270);
 _BUILD_d0o0(Data,vrr_stack+19052, vrr_stack+11710, vrr_stack+15044, vrr_stack+11632, vrr_stack+14966, vrr_stack+150);
 _BUILD_f0o0(Data,vrr_stack+19520, vrr_stack+19052, vrr_stack+18584, vrr_stack+11710, vrr_stack+15044, vrr_stack+13832);
 _BUILD_00o0(Data,vrr_stack+14966, vrr_stack+9872, vrr_stack+348, vrr_stack+3178, vrr_stack+723, NULL);
 _BUILD_p0o0(Data,vrr_stack+3178, vrr_stack+14966, vrr_stack+11632, NULL, NULL, vrr_stack+348);
 _BUILD_d0o0(Data,vrr_stack+15, vrr_stack+3178, vrr_stack+11710, vrr_stack+14966, vrr_stack+11632, vrr_stack+8072);
 _BUILD_f0o0(Data,vrr_stack+20300, vrr_stack+15, vrr_stack+19052, vrr_stack+3178, vrr_stack+11710, vrr_stack+5411);
   tmp = vrr_stack + 20300;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+3178, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15278, vrr_stack+9938, vrr_stack+3178, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+3178, vrr_stack+2444, vrr_stack+15278, vrr_stack+6902, vrr_stack+9938, NULL);
 _BUILD_00g0(Data,vrr_stack+3188, vrr_stack+9941, vrr_stack+3178, vrr_stack+6905, vrr_stack+2444, NULL);
 _BUILD_00h0(Data,vrr_stack+3203, vrr_stack+5807, vrr_stack+3188, vrr_stack+6911, vrr_stack+9941, NULL);
 _BUILD_00i0(Data,vrr_stack+3224, vrr_stack+9951, vrr_stack+3203, vrr_stack+0, vrr_stack+5807, NULL);
 _BUILD_00k0(Data,vrr_stack+4274, vrr_stack+9972, vrr_stack+3224, vrr_stack+6921, vrr_stack+9951, NULL);
 _BUILD_00l0(Data,vrr_stack+3178, vrr_stack+10000, vrr_stack+4274, vrr_stack+6942, vrr_stack+9972, NULL);
 _BUILD_00m0(Data,vrr_stack+3223, vrr_stack+10036, vrr_stack+3178, vrr_stack+6970, vrr_stack+10000, NULL);
 _BUILD_00n0(Data,vrr_stack+7106, vrr_stack+10081, vrr_stack+3223, vrr_stack+7006, vrr_stack+10036, NULL);
 _BUILD_00o0(Data,vrr_stack+14966, vrr_stack+10136, vrr_stack+7106, vrr_stack+7051, vrr_stack+10081, NULL);
 _BUILD_p0o0(Data,vrr_stack+3178, vrr_stack+11944, vrr_stack+14966, NULL, NULL, vrr_stack+10136);
 _BUILD_d0o0(Data,vrr_stack+5246, vrr_stack+2114, vrr_stack+3178, vrr_stack+14888, vrr_stack+11944, vrr_stack+10202);
 _BUILD_f0o0(Data,vrr_stack+21080, vrr_stack+18584, vrr_stack+5246, vrr_stack+15044, vrr_stack+2114, vrr_stack+3878);
 _BUILD_g0o0(Data,vrr_stack+21860, vrr_stack+19520, vrr_stack+21080, vrr_stack+19052, vrr_stack+18584, vrr_stack+15944);
 _BUILD_g0o0(Data,vrr_stack+23030, vrr_stack+20300, vrr_stack+19520, vrr_stack+15, vrr_stack+19052, vrr_stack+14228);
   tmp = vrr_stack + 23030;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0i0(Data,vrr_stack+15944, vrr_stack+1086, vrr_stack+3458, vrr_stack+2898, vrr_stack+2450, vrr_stack+1799);
   tmp = vrr_stack + 15944;
   target_ptr = Libint->vrr_classes[5][6];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0k0(Data,vrr_stack+18584, vrr_stack+6362, vrr_stack+5822, vrr_stack+4886, vrr_stack+4310, vrr_stack+3458);
   tmp = vrr_stack + 18584;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0l0(Data,vrr_stack+0, vrr_stack+9197, vrr_stack+8522, vrr_stack+7622, vrr_stack+7172, vrr_stack+5822);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0m0(Data,vrr_stack+9197, vrr_stack+13007, vrr_stack+12182, vrr_stack+11082, vrr_stack+10532, vrr_stack+8522);
   tmp = vrr_stack + 9197;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0n0(Data,vrr_stack+10352, vrr_stack+17594, vrr_stack+16604, vrr_stack+15284, vrr_stack+14228, vrr_stack+12182);
   tmp = vrr_stack + 10352;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0o0(Data,vrr_stack+11738, vrr_stack+23030, vrr_stack+21860, vrr_stack+20300, vrr_stack+19520, vrr_stack+16604);
   tmp = vrr_stack + 11738;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];

}

