/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fd|nn) integrals */

void vrr_order_fdnn(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+50, vrr_stack+15, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+56, vrr_stack+117, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+66, vrr_stack+127, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+96, vrr_stack+142, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+31, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+191, vrr_stack+24, vrr_stack+34, vrr_stack+21, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+201, vrr_stack+191, vrr_stack+40, vrr_stack+24, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+216, vrr_stack+201, vrr_stack+81, vrr_stack+191, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+237, vrr_stack+216, vrr_stack+96, vrr_stack+201, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+265, vrr_stack+237, vrr_stack+163, NULL, NULL, vrr_stack+96);
 _BUILD_00k0(Data,vrr_stack+349, vrr_stack+237, vrr_stack+163, vrr_stack+216, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+21, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+84, vrr_stack+24, vrr_stack+81, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+30, vrr_stack+191, vrr_stack+84, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+400, vrr_stack+385, vrr_stack+201, vrr_stack+30, vrr_stack+191, NULL);
 _BUILD_00i0(Data,vrr_stack+421, vrr_stack+400, vrr_stack+216, vrr_stack+385, vrr_stack+201, NULL);
 _BUILD_00k0(Data,vrr_stack+449, vrr_stack+421, vrr_stack+237, vrr_stack+400, vrr_stack+216, NULL);
 _BUILD_00p0(Data,vrr_stack+191, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+191, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+90, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+117, vrr_stack+40, vrr_stack+50, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+209, vrr_stack+127, vrr_stack+194, vrr_stack+56, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+485, vrr_stack+142, vrr_stack+209, vrr_stack+66, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+513, vrr_stack+163, vrr_stack+485, vrr_stack+96, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+549, vrr_stack+349, vrr_stack+513, NULL, NULL, vrr_stack+163);
 _BUILD_p0k0(Data,vrr_stack+657, vrr_stack+449, vrr_stack+349, NULL, NULL, vrr_stack+237);
 _BUILD_d0k0(Data,vrr_stack+765, vrr_stack+657, vrr_stack+549, vrr_stack+449, vrr_stack+349, vrr_stack+265);
 _BUILD_00l0(Data,vrr_stack+265, vrr_stack+349, vrr_stack+513, vrr_stack+237, vrr_stack+163, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+449, vrr_stack+349, vrr_stack+421, vrr_stack+237, NULL);
 _BUILD_p0l0(Data,vrr_stack+1026, vrr_stack+981, vrr_stack+265, NULL, NULL, vrr_stack+349);
 _BUILD_00p0(Data,vrr_stack+310, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+313, vrr_stack+310, vrr_stack+81, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+319, vrr_stack+313, vrr_stack+84, vrr_stack+310, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+329, vrr_stack+319, vrr_stack+30, vrr_stack+313, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+329, vrr_stack+385, vrr_stack+319, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+400, vrr_stack+329, vrr_stack+385, NULL);
 _BUILD_00k0(Data,vrr_stack+1161, vrr_stack+50, vrr_stack+421, vrr_stack+96, vrr_stack+400, NULL);
 _BUILD_00l0(Data,vrr_stack+1197, vrr_stack+1161, vrr_stack+449, vrr_stack+50, vrr_stack+421, NULL);
 _BUILD_p0l0(Data,vrr_stack+1242, vrr_stack+1197, vrr_stack+981, NULL, NULL, vrr_stack+449);
 _BUILD_00p0(Data,vrr_stack+385, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+388, vrr_stack+191, vrr_stack+385, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+394, vrr_stack+90, vrr_stack+388, vrr_stack+0, vrr_stack+191, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+40, vrr_stack+394, vrr_stack+15, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+194, vrr_stack+0, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+404, vrr_stack+209, vrr_stack+15, vrr_stack+127, vrr_stack+194, NULL);
 _BUILD_00k0(Data,vrr_stack+1377, vrr_stack+485, vrr_stack+404, vrr_stack+142, vrr_stack+209, NULL);
 _BUILD_00l0(Data,vrr_stack+117, vrr_stack+513, vrr_stack+1377, vrr_stack+163, vrr_stack+485, NULL);
 _BUILD_p0l0(Data,vrr_stack+1413, vrr_stack+265, vrr_stack+117, NULL, NULL, vrr_stack+513);
 _BUILD_d0l0(Data,vrr_stack+1548, vrr_stack+1026, vrr_stack+1413, vrr_stack+981, vrr_stack+265, vrr_stack+549);
 _BUILD_d0l0(Data,vrr_stack+1818, vrr_stack+1242, vrr_stack+1026, vrr_stack+1197, vrr_stack+981, vrr_stack+657);
 _BUILD_f0l0(Data,vrr_stack+2088, vrr_stack+1818, vrr_stack+1548, vrr_stack+1242, vrr_stack+1026, vrr_stack+765);
 _BUILD_00m0(Data,vrr_stack+549, vrr_stack+981, vrr_stack+265, vrr_stack+449, vrr_stack+349, NULL);
 _BUILD_00m0(Data,vrr_stack+604, vrr_stack+1197, vrr_stack+981, vrr_stack+1161, vrr_stack+449, NULL);
 _BUILD_00m0(Data,vrr_stack+659, vrr_stack+265, vrr_stack+117, vrr_stack+349, vrr_stack+513, NULL);
 _BUILD_p0m0(Data,vrr_stack+714, vrr_stack+549, vrr_stack+659, NULL, NULL, vrr_stack+265);
 _BUILD_p0m0(Data,vrr_stack+2538, vrr_stack+604, vrr_stack+549, NULL, NULL, vrr_stack+981);
 _BUILD_d0m0(Data,vrr_stack+2703, vrr_stack+2538, vrr_stack+714, vrr_stack+604, vrr_stack+549, vrr_stack+1026);
 _BUILD_00p0(Data,vrr_stack+1026, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1029, vrr_stack+1026, vrr_stack+310, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1035, vrr_stack+1029, vrr_stack+313, vrr_stack+1026, vrr_stack+310, NULL);
 _BUILD_00g0(Data,vrr_stack+1045, vrr_stack+1035, vrr_stack+319, vrr_stack+1029, vrr_stack+313, NULL);
 _BUILD_00h0(Data,vrr_stack+1060, vrr_stack+1045, vrr_stack+329, vrr_stack+1035, vrr_stack+319, NULL);
 _BUILD_00i0(Data,vrr_stack+1081, vrr_stack+1060, vrr_stack+96, vrr_stack+1045, vrr_stack+329, NULL);
 _BUILD_00k0(Data,vrr_stack+310, vrr_stack+1081, vrr_stack+50, vrr_stack+1060, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+1109, vrr_stack+310, vrr_stack+1161, vrr_stack+1081, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+879, vrr_stack+1109, vrr_stack+1197, vrr_stack+310, vrr_stack+1161, NULL);
 _BUILD_p0m0(Data,vrr_stack+3033, vrr_stack+879, vrr_stack+604, NULL, NULL, vrr_stack+1197);
 _BUILD_d0m0(Data,vrr_stack+3198, vrr_stack+3033, vrr_stack+2538, vrr_stack+879, vrr_stack+604, vrr_stack+1242);
 _BUILD_00p0(Data,vrr_stack+1242, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1245, vrr_stack+385, vrr_stack+1242, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+1251, vrr_stack+388, vrr_stack+1245, vrr_stack+191, vrr_stack+385, NULL);
 _BUILD_00g0(Data,vrr_stack+1261, vrr_stack+394, vrr_stack+1251, vrr_stack+90, vrr_stack+388, NULL);
 _BUILD_00h0(Data,vrr_stack+1276, vrr_stack+0, vrr_stack+1261, vrr_stack+40, vrr_stack+394, NULL);
 _BUILD_00i0(Data,vrr_stack+1297, vrr_stack+15, vrr_stack+1276, vrr_stack+194, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1325, vrr_stack+404, vrr_stack+1297, vrr_stack+209, vrr_stack+15, NULL);
 _BUILD_00l0(Data,vrr_stack+934, vrr_stack+1377, vrr_stack+1325, vrr_stack+485, vrr_stack+404, NULL);
 _BUILD_00m0(Data,vrr_stack+162, vrr_stack+117, vrr_stack+934, vrr_stack+513, vrr_stack+1377, NULL);
 _BUILD_p0m0(Data,vrr_stack+3528, vrr_stack+659, vrr_stack+162, NULL, NULL, vrr_stack+117);
 _BUILD_d0m0(Data,vrr_stack+3693, vrr_stack+714, vrr_stack+3528, vrr_stack+549, vrr_stack+659, vrr_stack+1413);
 _BUILD_f0m0(Data,vrr_stack+4023, vrr_stack+2703, vrr_stack+3693, vrr_stack+2538, vrr_stack+714, vrr_stack+1548);
 _BUILD_f0m0(Data,vrr_stack+4573, vrr_stack+3198, vrr_stack+2703, vrr_stack+3033, vrr_stack+2538, vrr_stack+1818);
 _BUILD_g0m0(Data,vrr_stack+5123, vrr_stack+4573, vrr_stack+4023, vrr_stack+3198, vrr_stack+2703, vrr_stack+2088);
 _BUILD_00n0(Data,vrr_stack+1413, vrr_stack+549, vrr_stack+659, vrr_stack+981, vrr_stack+265, NULL);
 _BUILD_00n0(Data,vrr_stack+1479, vrr_stack+604, vrr_stack+549, vrr_stack+1197, vrr_stack+981, NULL);
 _BUILD_p0n0(Data,vrr_stack+1545, vrr_stack+1479, vrr_stack+1413, NULL, NULL, vrr_stack+549);
 _BUILD_00n0(Data,vrr_stack+1743, vrr_stack+879, vrr_stack+604, vrr_stack+1109, vrr_stack+1197, NULL);
 _BUILD_p0n0(Data,vrr_stack+1809, vrr_stack+1743, vrr_stack+1479, NULL, NULL, vrr_stack+604);
 _BUILD_00n0(Data,vrr_stack+2007, vrr_stack+659, vrr_stack+162, vrr_stack+265, vrr_stack+117, NULL);
 _BUILD_p0n0(Data,vrr_stack+2073, vrr_stack+1413, vrr_stack+2007, NULL, NULL, vrr_stack+659);
 _BUILD_d0n0(Data,vrr_stack+5948, vrr_stack+1545, vrr_stack+2073, vrr_stack+1479, vrr_stack+1413, vrr_stack+714);
 _BUILD_d0n0(Data,vrr_stack+6344, vrr_stack+1809, vrr_stack+1545, vrr_stack+1743, vrr_stack+1479, vrr_stack+2538);
 _BUILD_f0n0(Data,vrr_stack+6740, vrr_stack+6344, vrr_stack+5948, vrr_stack+1809, vrr_stack+1545, vrr_stack+2703);
 _BUILD_00p0(Data,vrr_stack+714, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+717, vrr_stack+714, vrr_stack+1026, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+723, vrr_stack+717, vrr_stack+1029, vrr_stack+714, vrr_stack+1026, NULL);
 _BUILD_00g0(Data,vrr_stack+733, vrr_stack+723, vrr_stack+1035, vrr_stack+717, vrr_stack+1029, NULL);
 _BUILD_00h0(Data,vrr_stack+748, vrr_stack+733, vrr_stack+1045, vrr_stack+723, vrr_stack+1035, NULL);
 _BUILD_00i0(Data,vrr_stack+769, vrr_stack+748, vrr_stack+1060, vrr_stack+733, vrr_stack+1045, NULL);
 _BUILD_00k0(Data,vrr_stack+797, vrr_stack+769, vrr_stack+1081, vrr_stack+748, vrr_stack+1060, NULL);
 _BUILD_00l0(Data,vrr_stack+714, vrr_stack+797, vrr_stack+310, vrr_stack+769, vrr_stack+1081, NULL);
 _BUILD_00m0(Data,vrr_stack+2271, vrr_stack+714, vrr_stack+1109, vrr_stack+797, vrr_stack+310, NULL);
 _BUILD_00n0(Data,vrr_stack+759, vrr_stack+2271, vrr_stack+879, vrr_stack+714, vrr_stack+1109, NULL);
 _BUILD_p0n0(Data,vrr_stack+2326, vrr_stack+759, vrr_stack+1743, NULL, NULL, vrr_stack+879);
 _BUILD_d0n0(Data,vrr_stack+2524, vrr_stack+2326, vrr_stack+1809, vrr_stack+759, vrr_stack+1743, vrr_stack+3033);
 _BUILD_f0n0(Data,vrr_stack+7400, vrr_stack+2524, vrr_stack+6344, vrr_stack+2326, vrr_stack+1809, vrr_stack+3198);
   tmp = vrr_stack + 7400;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2326, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2329, vrr_stack+1242, vrr_stack+2326, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+2335, vrr_stack+1245, vrr_stack+2329, vrr_stack+385, vrr_stack+1242, NULL);
 _BUILD_00g0(Data,vrr_stack+2345, vrr_stack+1251, vrr_stack+2335, vrr_stack+388, vrr_stack+1245, NULL);
 _BUILD_00h0(Data,vrr_stack+2360, vrr_stack+1261, vrr_stack+2345, vrr_stack+394, vrr_stack+1251, NULL);
 _BUILD_00i0(Data,vrr_stack+2381, vrr_stack+1276, vrr_stack+2360, vrr_stack+0, vrr_stack+1261, NULL);
 _BUILD_00k0(Data,vrr_stack+2409, vrr_stack+1297, vrr_stack+2381, vrr_stack+15, vrr_stack+1276, NULL);
 _BUILD_00l0(Data,vrr_stack+714, vrr_stack+1325, vrr_stack+2409, vrr_stack+404, vrr_stack+1297, NULL);
 _BUILD_00m0(Data,vrr_stack+0, vrr_stack+934, vrr_stack+714, vrr_stack+1377, vrr_stack+1325, NULL);
 _BUILD_00n0(Data,vrr_stack+2445, vrr_stack+162, vrr_stack+0, vrr_stack+117, vrr_stack+934, NULL);
 _BUILD_p0n0(Data,vrr_stack+2920, vrr_stack+2007, vrr_stack+2445, NULL, NULL, vrr_stack+162);
 _BUILD_d0n0(Data,vrr_stack+3118, vrr_stack+2073, vrr_stack+2920, vrr_stack+1413, vrr_stack+2007, vrr_stack+3528);
 _BUILD_f0n0(Data,vrr_stack+8060, vrr_stack+5948, vrr_stack+3118, vrr_stack+1545, vrr_stack+2073, vrr_stack+3693);
 _BUILD_g0n0(Data,vrr_stack+8720, vrr_stack+6740, vrr_stack+8060, vrr_stack+6344, vrr_stack+5948, vrr_stack+4023);
 _BUILD_g0n0(Data,vrr_stack+3514, vrr_stack+7400, vrr_stack+6740, vrr_stack+2524, vrr_stack+6344, vrr_stack+4573);
   tmp = vrr_stack + 3514;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+55, vrr_stack+1413, vrr_stack+2007, vrr_stack+549, vrr_stack+659, NULL);
 _BUILD_00o0(Data,vrr_stack+2511, vrr_stack+1479, vrr_stack+1413, vrr_stack+604, vrr_stack+549, NULL);
 _BUILD_p0o0(Data,vrr_stack+2589, vrr_stack+2511, vrr_stack+55, NULL, NULL, vrr_stack+1413);
 _BUILD_00o0(Data,vrr_stack+2823, vrr_stack+1743, vrr_stack+1479, vrr_stack+879, vrr_stack+604, NULL);
 _BUILD_p0o0(Data,vrr_stack+4504, vrr_stack+2823, vrr_stack+2511, NULL, NULL, vrr_stack+1479);
 _BUILD_00o0(Data,vrr_stack+4738, vrr_stack+2007, vrr_stack+2445, vrr_stack+659, vrr_stack+162, NULL);
 _BUILD_p0o0(Data,vrr_stack+4816, vrr_stack+55, vrr_stack+4738, NULL, NULL, vrr_stack+2007);
 _BUILD_d0o0(Data,vrr_stack+217, vrr_stack+2589, vrr_stack+4816, vrr_stack+2511, vrr_stack+55, vrr_stack+2073);
 _BUILD_d0o0(Data,vrr_stack+9710, vrr_stack+4504, vrr_stack+2589, vrr_stack+2823, vrr_stack+2511, vrr_stack+1545);
 _BUILD_f0o0(Data,vrr_stack+10178, vrr_stack+9710, vrr_stack+217, vrr_stack+4504, vrr_stack+2589, vrr_stack+5948);
 _BUILD_00o0(Data,vrr_stack+5948, vrr_stack+759, vrr_stack+1743, vrr_stack+2271, vrr_stack+879, NULL);
 _BUILD_p0o0(Data,vrr_stack+6026, vrr_stack+5948, vrr_stack+2823, NULL, NULL, vrr_stack+1743);
 _BUILD_d0o0(Data,vrr_stack+10958, vrr_stack+6026, vrr_stack+4504, vrr_stack+5948, vrr_stack+2823, vrr_stack+1809);
 _BUILD_f0o0(Data,vrr_stack+11426, vrr_stack+10958, vrr_stack+9710, vrr_stack+6026, vrr_stack+4504, vrr_stack+6344);
   tmp = vrr_stack + 11426;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6026, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6029, vrr_stack+2326, vrr_stack+6026, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+6035, vrr_stack+2329, vrr_stack+6029, vrr_stack+1242, vrr_stack+2326, NULL);
 _BUILD_00g0(Data,vrr_stack+6045, vrr_stack+2335, vrr_stack+6035, vrr_stack+1245, vrr_stack+2329, NULL);
 _BUILD_00h0(Data,vrr_stack+6060, vrr_stack+2345, vrr_stack+6045, vrr_stack+1251, vrr_stack+2335, NULL);
 _BUILD_00i0(Data,vrr_stack+6081, vrr_stack+2360, vrr_stack+6060, vrr_stack+1261, vrr_stack+2345, NULL);
 _BUILD_00k0(Data,vrr_stack+6109, vrr_stack+2381, vrr_stack+6081, vrr_stack+1276, vrr_stack+2360, NULL);
 _BUILD_00l0(Data,vrr_stack+6145, vrr_stack+2409, vrr_stack+6109, vrr_stack+1297, vrr_stack+2381, NULL);
 _BUILD_00m0(Data,vrr_stack+6190, vrr_stack+714, vrr_stack+6145, vrr_stack+1325, vrr_stack+2409, NULL);
 _BUILD_00n0(Data,vrr_stack+6245, vrr_stack+0, vrr_stack+6190, vrr_stack+934, vrr_stack+714, NULL);
 _BUILD_00o0(Data,vrr_stack+6311, vrr_stack+2445, vrr_stack+6245, vrr_stack+162, vrr_stack+0, NULL);
 _BUILD_p0o0(Data,vrr_stack+6389, vrr_stack+4738, vrr_stack+6311, NULL, NULL, vrr_stack+2445);
 _BUILD_d0o0(Data,vrr_stack+825, vrr_stack+4816, vrr_stack+6389, vrr_stack+55, vrr_stack+4738, vrr_stack+2920);
 _BUILD_f0o0(Data,vrr_stack+12206, vrr_stack+217, vrr_stack+825, vrr_stack+2589, vrr_stack+4816, vrr_stack+3118);
 _BUILD_g0o0(Data,vrr_stack+12986, vrr_stack+10178, vrr_stack+12206, vrr_stack+9710, vrr_stack+217, vrr_stack+8060);
 _BUILD_g0o0(Data,vrr_stack+14156, vrr_stack+11426, vrr_stack+10178, vrr_stack+10958, vrr_stack+9710, vrr_stack+6740);
   tmp = vrr_stack + 14156;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+10958, vrr_stack+55, vrr_stack+4738, vrr_stack+1413, vrr_stack+2007, NULL);
 _BUILD_00q0(Data,vrr_stack+11049, vrr_stack+2511, vrr_stack+55, vrr_stack+1479, vrr_stack+1413, NULL);
 _BUILD_p0q0(Data,vrr_stack+11140, vrr_stack+11049, vrr_stack+10958, NULL, NULL, vrr_stack+55);
 _BUILD_00q0(Data,vrr_stack+8060, vrr_stack+2823, vrr_stack+2511, vrr_stack+1743, vrr_stack+1479, NULL);
 _BUILD_p0q0(Data,vrr_stack+8151, vrr_stack+8060, vrr_stack+11049, NULL, NULL, vrr_stack+2511);
 _BUILD_00q0(Data,vrr_stack+8424, vrr_stack+4738, vrr_stack+6311, vrr_stack+2007, vrr_stack+2445, NULL);
 _BUILD_p0q0(Data,vrr_stack+1809, vrr_stack+10958, vrr_stack+8424, NULL, NULL, vrr_stack+4738);
 _BUILD_d0q0(Data,vrr_stack+2901, vrr_stack+11140, vrr_stack+1809, vrr_stack+11049, vrr_stack+10958, vrr_stack+4816);
 _BUILD_d0q0(Data,vrr_stack+15326, vrr_stack+8151, vrr_stack+11140, vrr_stack+8060, vrr_stack+11049, vrr_stack+2589);
 _BUILD_f0q0(Data,vrr_stack+15872, vrr_stack+15326, vrr_stack+2901, vrr_stack+8151, vrr_stack+11140, vrr_stack+217);
 _BUILD_00q0(Data,vrr_stack+2589, vrr_stack+5948, vrr_stack+2823, vrr_stack+759, vrr_stack+1743, NULL);
 _BUILD_p0q0(Data,vrr_stack+4816, vrr_stack+2589, vrr_stack+8060, NULL, NULL, vrr_stack+2823);
 _BUILD_d0q0(Data,vrr_stack+133, vrr_stack+4816, vrr_stack+8151, vrr_stack+2589, vrr_stack+8060, vrr_stack+4504);
 _BUILD_f0q0(Data,vrr_stack+16782, vrr_stack+133, vrr_stack+15326, vrr_stack+4816, vrr_stack+8151, vrr_stack+9710);
   tmp = vrr_stack + 16782;
   target_ptr = Libint->vrr_classes[3][12];
   for(i=0;i<910;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+9710, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9713, vrr_stack+6026, vrr_stack+9710, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+9719, vrr_stack+6029, vrr_stack+9713, vrr_stack+2326, vrr_stack+6026, NULL);
 _BUILD_00g0(Data,vrr_stack+9729, vrr_stack+6035, vrr_stack+9719, vrr_stack+2329, vrr_stack+6029, NULL);
 _BUILD_00h0(Data,vrr_stack+9744, vrr_stack+6045, vrr_stack+9729, vrr_stack+2335, vrr_stack+6035, NULL);
 _BUILD_00i0(Data,vrr_stack+9765, vrr_stack+6060, vrr_stack+9744, vrr_stack+2345, vrr_stack+6045, NULL);
 _BUILD_00k0(Data,vrr_stack+9793, vrr_stack+6081, vrr_stack+9765, vrr_stack+2360, vrr_stack+6060, NULL);
 _BUILD_00l0(Data,vrr_stack+9829, vrr_stack+6109, vrr_stack+9793, vrr_stack+2381, vrr_stack+6081, NULL);
 _BUILD_00m0(Data,vrr_stack+9874, vrr_stack+6145, vrr_stack+9829, vrr_stack+2409, vrr_stack+6109, NULL);
 _BUILD_00n0(Data,vrr_stack+759, vrr_stack+6190, vrr_stack+9874, vrr_stack+714, vrr_stack+6145, NULL);
 _BUILD_00o0(Data,vrr_stack+9929, vrr_stack+6245, vrr_stack+759, vrr_stack+0, vrr_stack+6190, NULL);
 _BUILD_00q0(Data,vrr_stack+10007, vrr_stack+6311, vrr_stack+9929, vrr_stack+2445, vrr_stack+6245, NULL);
 _BUILD_p0q0(Data,vrr_stack+4816, vrr_stack+8424, vrr_stack+10007, NULL, NULL, vrr_stack+6311);
 _BUILD_d0q0(Data,vrr_stack+17692, vrr_stack+1809, vrr_stack+4816, vrr_stack+10958, vrr_stack+8424, vrr_stack+6389);
 _BUILD_f0q0(Data,vrr_stack+18238, vrr_stack+2901, vrr_stack+17692, vrr_stack+11140, vrr_stack+1809, vrr_stack+825);
 _BUILD_g0q0(Data,vrr_stack+19148, vrr_stack+15872, vrr_stack+18238, vrr_stack+15326, vrr_stack+2901, vrr_stack+12206);
 _BUILD_g0q0(Data,vrr_stack+20513, vrr_stack+16782, vrr_stack+15872, vrr_stack+133, vrr_stack+15326, vrr_stack+10178);
   tmp = vrr_stack + 20513;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+133, vrr_stack+10958, vrr_stack+8424, vrr_stack+55, vrr_stack+4738, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+238, vrr_stack+11049, vrr_stack+10958, vrr_stack+2511, vrr_stack+55, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+343, vrr_stack+238, vrr_stack+133, NULL, NULL, vrr_stack+10958);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12206, vrr_stack+8060, vrr_stack+11049, vrr_stack+2823, vrr_stack+2511, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12311, vrr_stack+12206, vrr_stack+238, NULL, NULL, vrr_stack+11049);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12626, vrr_stack+8424, vrr_stack+10007, vrr_stack+4738, vrr_stack+6311, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+825, vrr_stack+133, vrr_stack+12626, NULL, NULL, vrr_stack+8424);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1140, vrr_stack+343, vrr_stack+825, vrr_stack+238, vrr_stack+133, vrr_stack+1809);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1770, vrr_stack+12311, vrr_stack+343, vrr_stack+12206, vrr_stack+238, vrr_stack+11140);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21878, vrr_stack+1770, vrr_stack+1140, vrr_stack+12311, vrr_stack+343, vrr_stack+2901);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2901, vrr_stack+2589, vrr_stack+8060, vrr_stack+5948, vrr_stack+2823, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3006, vrr_stack+2901, vrr_stack+12206, NULL, NULL, vrr_stack+8060);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+22928, vrr_stack+3006, vrr_stack+12311, vrr_stack+2901, vrr_stack+12206, vrr_stack+8151);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+23558, vrr_stack+22928, vrr_stack+1770, vrr_stack+3006, vrr_stack+12311, vrr_stack+15326);
   tmp = vrr_stack + 23558;
   target_ptr = Libint->vrr_classes[3][13];
   for(i=0;i<1050;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+15326, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15329, vrr_stack+9710, vrr_stack+15326, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+15335, vrr_stack+9713, vrr_stack+15329, vrr_stack+6026, vrr_stack+9710, NULL);
 _BUILD_00g0(Data,vrr_stack+15345, vrr_stack+9719, vrr_stack+15335, vrr_stack+6029, vrr_stack+9713, NULL);
 _BUILD_00h0(Data,vrr_stack+15360, vrr_stack+9729, vrr_stack+15345, vrr_stack+6035, vrr_stack+9719, NULL);
 _BUILD_00i0(Data,vrr_stack+15381, vrr_stack+9744, vrr_stack+15360, vrr_stack+6045, vrr_stack+9729, NULL);
 _BUILD_00k0(Data,vrr_stack+15409, vrr_stack+9765, vrr_stack+15381, vrr_stack+6060, vrr_stack+9744, NULL);
 _BUILD_00l0(Data,vrr_stack+15445, vrr_stack+9793, vrr_stack+15409, vrr_stack+6081, vrr_stack+9765, NULL);
 _BUILD_00m0(Data,vrr_stack+15490, vrr_stack+9829, vrr_stack+15445, vrr_stack+6109, vrr_stack+9793, NULL);
 _BUILD_00n0(Data,vrr_stack+15545, vrr_stack+9874, vrr_stack+15490, vrr_stack+6145, vrr_stack+9829, NULL);
 _BUILD_00o0(Data,vrr_stack+15611, vrr_stack+759, vrr_stack+15545, vrr_stack+6190, vrr_stack+9874, NULL);
 _BUILD_00q0(Data,vrr_stack+15689, vrr_stack+9929, vrr_stack+15611, vrr_stack+6245, vrr_stack+759, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3006, vrr_stack+10007, vrr_stack+15689, vrr_stack+6311, vrr_stack+9929, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3111, vrr_stack+12626, vrr_stack+3006, NULL, NULL, vrr_stack+10007);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5948, vrr_stack+825, vrr_stack+3111, vrr_stack+133, vrr_stack+12626, vrr_stack+4816);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+24608, vrr_stack+1140, vrr_stack+5948, vrr_stack+343, vrr_stack+825, vrr_stack+17692);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25658, vrr_stack+21878, vrr_stack+24608, vrr_stack+1770, vrr_stack+1140, vrr_stack+18238);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+27233, vrr_stack+23558, vrr_stack+21878, vrr_stack+22928, vrr_stack+1770, vrr_stack+15872);
   tmp = vrr_stack + 27233;
   target_ptr = Libint->vrr_classes[4][13];
   for(i=0;i<1575;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+22928, vrr_stack+133, vrr_stack+12626, vrr_stack+10958, vrr_stack+8424, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23048, vrr_stack+238, vrr_stack+133, vrr_stack+11049, vrr_stack+10958, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23168, vrr_stack+23048, vrr_stack+22928, NULL, NULL, vrr_stack+133);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+17692, vrr_stack+12206, vrr_stack+238, vrr_stack+8060, vrr_stack+11049, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+10958, vrr_stack+17692, vrr_stack+23048, NULL, NULL, vrr_stack+238);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+17812, vrr_stack+12626, vrr_stack+3006, vrr_stack+8424, vrr_stack+10007, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+17932, vrr_stack+22928, vrr_stack+17812, NULL, NULL, vrr_stack+12626);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+18292, vrr_stack+23168, vrr_stack+17932, vrr_stack+23048, vrr_stack+22928, vrr_stack+825);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+28808, vrr_stack+10958, vrr_stack+23168, vrr_stack+17692, vrr_stack+23048, vrr_stack+343);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+29528, vrr_stack+28808, vrr_stack+18292, vrr_stack+10958, vrr_stack+23168, vrr_stack+1140);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+343, vrr_stack+2901, vrr_stack+12206, vrr_stack+2589, vrr_stack+8060, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8060, vrr_stack+343, vrr_stack+17692, NULL, NULL, vrr_stack+12206);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+825, vrr_stack+8060, vrr_stack+10958, vrr_stack+343, vrr_stack+17692, vrr_stack+12311);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+30728, vrr_stack+825, vrr_stack+28808, vrr_stack+8060, vrr_stack+10958, vrr_stack+1770);
   tmp = vrr_stack + 30728;
   target_ptr = Libint->vrr_classes[3][14];
   for(i=0;i<1200;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+8060, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+8063, vrr_stack+15326, vrr_stack+8060, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+8069, vrr_stack+15329, vrr_stack+8063, vrr_stack+9710, vrr_stack+15326, NULL);
 _BUILD_00g0(Data,vrr_stack+8079, vrr_stack+15335, vrr_stack+8069, vrr_stack+9713, vrr_stack+15329, NULL);
 _BUILD_00h0(Data,vrr_stack+8094, vrr_stack+15345, vrr_stack+8079, vrr_stack+9719, vrr_stack+15335, NULL);
 _BUILD_00i0(Data,vrr_stack+8115, vrr_stack+15360, vrr_stack+8094, vrr_stack+9729, vrr_stack+15345, NULL);
 _BUILD_00k0(Data,vrr_stack+8143, vrr_stack+15381, vrr_stack+8115, vrr_stack+9744, vrr_stack+15360, NULL);
 _BUILD_00l0(Data,vrr_stack+9710, vrr_stack+15409, vrr_stack+8143, vrr_stack+9765, vrr_stack+15381, NULL);
 _BUILD_00m0(Data,vrr_stack+8179, vrr_stack+15445, vrr_stack+9710, vrr_stack+9793, vrr_stack+15409, NULL);
 _BUILD_00n0(Data,vrr_stack+9755, vrr_stack+15490, vrr_stack+8179, vrr_stack+9829, vrr_stack+15445, NULL);
 _BUILD_00o0(Data,vrr_stack+8234, vrr_stack+15545, vrr_stack+9755, vrr_stack+9874, vrr_stack+15490, NULL);
 _BUILD_00q0(Data,vrr_stack+9821, vrr_stack+15611, vrr_stack+8234, vrr_stack+759, vrr_stack+15545, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8312, vrr_stack+15689, vrr_stack+9821, vrr_stack+9929, vrr_stack+15611, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8417, vrr_stack+3006, vrr_stack+8312, vrr_stack+10007, vrr_stack+15689, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+463, vrr_stack+17812, vrr_stack+8417, NULL, NULL, vrr_stack+3006);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1545, vrr_stack+17932, vrr_stack+463, vrr_stack+22928, vrr_stack+17812, vrr_stack+3111);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+31928, vrr_stack+18292, vrr_stack+1545, vrr_stack+23168, vrr_stack+17932, vrr_stack+5948);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+33128, vrr_stack+29528, vrr_stack+31928, vrr_stack+28808, vrr_stack+18292, vrr_stack+24608);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+34928, vrr_stack+30728, vrr_stack+29528, vrr_stack+825, vrr_stack+28808, vrr_stack+21878);
   tmp = vrr_stack + 34928;
   target_ptr = Libint->vrr_classes[4][14];
   for(i=0;i<1800;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+19012, vrr_stack+22928, vrr_stack+17812, vrr_stack+133, vrr_stack+12626, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+24608, vrr_stack+23048, vrr_stack+22928, vrr_stack+238, vrr_stack+133, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+24744, vrr_stack+24608, vrr_stack+19012, NULL, NULL, vrr_stack+22928);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25152, vrr_stack+17692, vrr_stack+23048, vrr_stack+12206, vrr_stack+238, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+5948, vrr_stack+25152, vrr_stack+24608, NULL, NULL, vrr_stack+23048);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25288, vrr_stack+17812, vrr_stack+8417, vrr_stack+12626, vrr_stack+3006, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+12311, vrr_stack+19012, vrr_stack+25288, NULL, NULL, vrr_stack+17812);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+36728, vrr_stack+24744, vrr_stack+12311, vrr_stack+24608, vrr_stack+19012, vrr_stack+17932);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+37544, vrr_stack+5948, vrr_stack+24744, vrr_stack+25152, vrr_stack+24608, vrr_stack+23168);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+38360, vrr_stack+37544, vrr_stack+36728, vrr_stack+5948, vrr_stack+24744, vrr_stack+18292);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+23168, vrr_stack+343, vrr_stack+17692, vrr_stack+2901, vrr_stack+12206, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+17932, vrr_stack+23168, vrr_stack+25152, NULL, NULL, vrr_stack+17692);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+39720, vrr_stack+17932, vrr_stack+5948, vrr_stack+23168, vrr_stack+25152, vrr_stack+10958);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+40536, vrr_stack+39720, vrr_stack+37544, vrr_stack+17932, vrr_stack+5948, vrr_stack+28808);
   tmp = vrr_stack + 40536;
   target_ptr = Libint->vrr_classes[3][15];
   for(i=0;i<1360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+28808, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+28811, vrr_stack+8060, vrr_stack+28808, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+28817, vrr_stack+8063, vrr_stack+28811, vrr_stack+15326, vrr_stack+8060, NULL);
 _BUILD_00g0(Data,vrr_stack+28827, vrr_stack+8069, vrr_stack+28817, vrr_stack+15329, vrr_stack+8063, NULL);
 _BUILD_00h0(Data,vrr_stack+28842, vrr_stack+8079, vrr_stack+28827, vrr_stack+15335, vrr_stack+8069, NULL);
 _BUILD_00i0(Data,vrr_stack+28863, vrr_stack+8094, vrr_stack+28842, vrr_stack+15345, vrr_stack+8079, NULL);
 _BUILD_00k0(Data,vrr_stack+28891, vrr_stack+8115, vrr_stack+28863, vrr_stack+15360, vrr_stack+8094, NULL);
 _BUILD_00l0(Data,vrr_stack+15326, vrr_stack+8143, vrr_stack+28891, vrr_stack+15381, vrr_stack+8115, NULL);
 _BUILD_00m0(Data,vrr_stack+28927, vrr_stack+9710, vrr_stack+15326, vrr_stack+15409, vrr_stack+8143, NULL);
 _BUILD_00n0(Data,vrr_stack+15371, vrr_stack+8179, vrr_stack+28927, vrr_stack+15445, vrr_stack+9710, NULL);
 _BUILD_00o0(Data,vrr_stack+28982, vrr_stack+9755, vrr_stack+15371, vrr_stack+15490, vrr_stack+8179, NULL);
 _BUILD_00q0(Data,vrr_stack+15437, vrr_stack+8234, vrr_stack+28982, vrr_stack+15545, vrr_stack+9755, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12206, vrr_stack+9821, vrr_stack+15437, vrr_stack+15611, vrr_stack+8234, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+15528, vrr_stack+8312, vrr_stack+12206, vrr_stack+15689, vrr_stack+9821, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15648, vrr_stack+8417, vrr_stack+15528, vrr_stack+3006, vrr_stack+8312, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+29060, vrr_stack+25288, vrr_stack+15648, NULL, NULL, vrr_stack+8417);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+17932, vrr_stack+12311, vrr_stack+29060, vrr_stack+19012, vrr_stack+25288, vrr_stack+463);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+41896, vrr_stack+36728, vrr_stack+17932, vrr_stack+24744, vrr_stack+12311, vrr_stack+1545);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+463, vrr_stack+38360, vrr_stack+41896, vrr_stack+37544, vrr_stack+36728, vrr_stack+31928);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+43256, vrr_stack+40536, vrr_stack+38360, vrr_stack+39720, vrr_stack+37544, vrr_stack+29528);
   tmp = vrr_stack + 43256;
   target_ptr = Libint->vrr_classes[4][15];
   for(i=0;i<2040;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+39720, vrr_stack+19012, vrr_stack+25288, vrr_stack+22928, vrr_stack+17812, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+39873, vrr_stack+24608, vrr_stack+19012, vrr_stack+23048, vrr_stack+22928, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+40026, vrr_stack+39873, vrr_stack+39720, NULL, NULL, vrr_stack+19012);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+31928, vrr_stack+25152, vrr_stack+24608, vrr_stack+17692, vrr_stack+23048, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+32081, vrr_stack+31928, vrr_stack+39873, NULL, NULL, vrr_stack+24608);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+22928, vrr_stack+25288, vrr_stack+15648, vrr_stack+17812, vrr_stack+8417, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+32540, vrr_stack+39720, vrr_stack+22928, NULL, NULL, vrr_stack+25288);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2503, vrr_stack+40026, vrr_stack+32540, vrr_stack+39873, vrr_stack+39720, vrr_stack+12311);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+45296, vrr_stack+32081, vrr_stack+40026, vrr_stack+31928, vrr_stack+39873, vrr_stack+24744);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+46214, vrr_stack+45296, vrr_stack+2503, vrr_stack+32081, vrr_stack+40026, vrr_stack+36728);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+36728, vrr_stack+23168, vrr_stack+25152, vrr_stack+343, vrr_stack+17692, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+36881, vrr_stack+36728, vrr_stack+31928, NULL, NULL, vrr_stack+25152);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+47744, vrr_stack+36881, vrr_stack+32081, vrr_stack+36728, vrr_stack+31928, vrr_stack+5948);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+48662, vrr_stack+47744, vrr_stack+45296, vrr_stack+36881, vrr_stack+32081, vrr_stack+37544);
   tmp = vrr_stack + 48662;
   target_ptr = Libint->vrr_classes[3][16];
   for(i=0;i<1530;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+36881, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+36884, vrr_stack+28808, vrr_stack+36881, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+36890, vrr_stack+28811, vrr_stack+36884, vrr_stack+8060, vrr_stack+28808, NULL);
 _BUILD_00g0(Data,vrr_stack+36900, vrr_stack+28817, vrr_stack+36890, vrr_stack+8063, vrr_stack+28811, NULL);
 _BUILD_00h0(Data,vrr_stack+36915, vrr_stack+28827, vrr_stack+36900, vrr_stack+8069, vrr_stack+28817, NULL);
 _BUILD_00i0(Data,vrr_stack+36936, vrr_stack+28842, vrr_stack+36915, vrr_stack+8079, vrr_stack+28827, NULL);
 _BUILD_00k0(Data,vrr_stack+36964, vrr_stack+28863, vrr_stack+36936, vrr_stack+8094, vrr_stack+28842, NULL);
 _BUILD_00l0(Data,vrr_stack+8060, vrr_stack+28891, vrr_stack+36964, vrr_stack+8115, vrr_stack+28863, NULL);
 _BUILD_00m0(Data,vrr_stack+37000, vrr_stack+15326, vrr_stack+8060, vrr_stack+8143, vrr_stack+28891, NULL);
 _BUILD_00n0(Data,vrr_stack+8105, vrr_stack+28927, vrr_stack+37000, vrr_stack+9710, vrr_stack+15326, NULL);
 _BUILD_00o0(Data,vrr_stack+37055, vrr_stack+15371, vrr_stack+8105, vrr_stack+8179, vrr_stack+28927, NULL);
 _BUILD_00q0(Data,vrr_stack+37133, vrr_stack+28982, vrr_stack+37055, vrr_stack+9755, vrr_stack+15371, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9710, vrr_stack+15437, vrr_stack+37133, vrr_stack+8234, vrr_stack+28982, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8171, vrr_stack+12206, vrr_stack+9710, vrr_stack+9821, vrr_stack+15437, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+9815, vrr_stack+15528, vrr_stack+8171, vrr_stack+8312, vrr_stack+12206, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+9951, vrr_stack+15648, vrr_stack+9815, vrr_stack+8417, vrr_stack+15528, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+37224, vrr_stack+22928, vrr_stack+9951, NULL, NULL, vrr_stack+15648);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+50192, vrr_stack+32540, vrr_stack+37224, vrr_stack+39720, vrr_stack+22928, vrr_stack+29060);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+51110, vrr_stack+2503, vrr_stack+50192, vrr_stack+40026, vrr_stack+32540, vrr_stack+17932);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+52640, vrr_stack+46214, vrr_stack+51110, vrr_stack+45296, vrr_stack+2503, vrr_stack+41896);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+54935, vrr_stack+48662, vrr_stack+46214, vrr_stack+47744, vrr_stack+45296, vrr_stack+38360);
   tmp = vrr_stack + 54935;
   target_ptr = Libint->vrr_classes[4][16];
   for(i=0;i<2295;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+47744, vrr_stack+39720, vrr_stack+22928, vrr_stack+19012, vrr_stack+25288, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+47915, vrr_stack+39873, vrr_stack+39720, vrr_stack+24608, vrr_stack+19012, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+48086, vrr_stack+47915, vrr_stack+47744, NULL, NULL, vrr_stack+39720);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+41896, vrr_stack+31928, vrr_stack+39873, vrr_stack+25152, vrr_stack+24608, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+24608, vrr_stack+41896, vrr_stack+47915, NULL, NULL, vrr_stack+39873);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+42067, vrr_stack+22928, vrr_stack+9951, vrr_stack+25288, vrr_stack+15648, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+42238, vrr_stack+47744, vrr_stack+42067, NULL, NULL, vrr_stack+22928);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+17692, vrr_stack+48086, vrr_stack+42238, vrr_stack+47915, vrr_stack+47744, vrr_stack+32540);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+57230, vrr_stack+24608, vrr_stack+48086, vrr_stack+41896, vrr_stack+47915, vrr_stack+40026);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+58256, vrr_stack+57230, vrr_stack+17692, vrr_stack+24608, vrr_stack+48086, vrr_stack+2503);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2503, vrr_stack+36728, vrr_stack+31928, vrr_stack+23168, vrr_stack+25152, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2674, vrr_stack+2503, vrr_stack+41896, NULL, NULL, vrr_stack+31928);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+59966, vrr_stack+2674, vrr_stack+24608, vrr_stack+2503, vrr_stack+41896, vrr_stack+32081);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+60992, vrr_stack+59966, vrr_stack+57230, vrr_stack+2674, vrr_stack+24608, vrr_stack+45296);
   tmp = vrr_stack + 60992;
   target_ptr = Libint->vrr_classes[3][17];
   for(i=0;i<1710;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+45296, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+45299, vrr_stack+36881, vrr_stack+45296, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+45305, vrr_stack+36884, vrr_stack+45299, vrr_stack+28808, vrr_stack+36881, NULL);
 _BUILD_00g0(Data,vrr_stack+45315, vrr_stack+36890, vrr_stack+45305, vrr_stack+28811, vrr_stack+36884, NULL);
 _BUILD_00h0(Data,vrr_stack+45330, vrr_stack+36900, vrr_stack+45315, vrr_stack+28817, vrr_stack+36890, NULL);
 _BUILD_00i0(Data,vrr_stack+45351, vrr_stack+36915, vrr_stack+45330, vrr_stack+28827, vrr_stack+36900, NULL);
 _BUILD_00k0(Data,vrr_stack+45379, vrr_stack+36936, vrr_stack+45351, vrr_stack+28842, vrr_stack+36915, NULL);
 _BUILD_00l0(Data,vrr_stack+28808, vrr_stack+36964, vrr_stack+45379, vrr_stack+28863, vrr_stack+36936, NULL);
 _BUILD_00m0(Data,vrr_stack+45415, vrr_stack+8060, vrr_stack+28808, vrr_stack+28891, vrr_stack+36964, NULL);
 _BUILD_00n0(Data,vrr_stack+28853, vrr_stack+37000, vrr_stack+45415, vrr_stack+15326, vrr_stack+8060, NULL);
 _BUILD_00o0(Data,vrr_stack+45470, vrr_stack+8105, vrr_stack+28853, vrr_stack+28927, vrr_stack+37000, NULL);
 _BUILD_00q0(Data,vrr_stack+45548, vrr_stack+37055, vrr_stack+45470, vrr_stack+15371, vrr_stack+8105, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15326, vrr_stack+37133, vrr_stack+45548, vrr_stack+28982, vrr_stack+37055, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+28919, vrr_stack+9710, vrr_stack+15326, vrr_stack+15437, vrr_stack+37133, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+29039, vrr_stack+8171, vrr_stack+28919, vrr_stack+12206, vrr_stack+9710, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+12206, vrr_stack+9815, vrr_stack+29039, vrr_stack+15528, vrr_stack+8171, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+12359, vrr_stack+9951, vrr_stack+12206, vrr_stack+15648, vrr_stack+9815, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+45639, vrr_stack+42067, vrr_stack+12359, NULL, NULL, vrr_stack+9951);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+32081, vrr_stack+42238, vrr_stack+45639, vrr_stack+47744, vrr_stack+42067, vrr_stack+37224);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+62702, vrr_stack+17692, vrr_stack+32081, vrr_stack+48086, vrr_stack+42238, vrr_stack+50192);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+64412, vrr_stack+58256, vrr_stack+62702, vrr_stack+57230, vrr_stack+17692, vrr_stack+51110);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+66977, vrr_stack+60992, vrr_stack+58256, vrr_stack+59966, vrr_stack+57230, vrr_stack+46214);
   tmp = vrr_stack + 66977;
   target_ptr = Libint->vrr_classes[4][17];
   for(i=0;i<2565;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+59966, vrr_stack+47744, vrr_stack+42067, vrr_stack+39720, vrr_stack+22928, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+60156, vrr_stack+47915, vrr_stack+47744, vrr_stack+39873, vrr_stack+39720, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+60346, vrr_stack+60156, vrr_stack+59966, NULL, NULL, vrr_stack+47744);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+50192, vrr_stack+41896, vrr_stack+47915, vrr_stack+31928, vrr_stack+39873, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+39720, vrr_stack+50192, vrr_stack+60156, NULL, NULL, vrr_stack+47915);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+40290, vrr_stack+42067, vrr_stack+12359, vrr_stack+22928, vrr_stack+9951, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+22928, vrr_stack+59966, vrr_stack+40290, NULL, NULL, vrr_stack+42067);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+50382, vrr_stack+60346, vrr_stack+22928, vrr_stack+60156, vrr_stack+59966, vrr_stack+42238);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+69542, vrr_stack+39720, vrr_stack+60346, vrr_stack+50192, vrr_stack+60156, vrr_stack+48086);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+70682, vrr_stack+69542, vrr_stack+50382, vrr_stack+39720, vrr_stack+60346, vrr_stack+17692);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+17692, vrr_stack+2503, vrr_stack+41896, vrr_stack+36728, vrr_stack+31928, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+17882, vrr_stack+17692, vrr_stack+50192, NULL, NULL, vrr_stack+41896);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+72582, vrr_stack+17882, vrr_stack+39720, vrr_stack+17692, vrr_stack+50192, vrr_stack+24608);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+73722, vrr_stack+72582, vrr_stack+69542, vrr_stack+17882, vrr_stack+39720, vrr_stack+57230);
   tmp = vrr_stack + 73722;
   target_ptr = Libint->vrr_classes[3][18];
   for(i=0;i<1900;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+57230, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+57233, vrr_stack+45296, vrr_stack+57230, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+57239, vrr_stack+45299, vrr_stack+57233, vrr_stack+36881, vrr_stack+45296, NULL);
 _BUILD_00g0(Data,vrr_stack+57249, vrr_stack+45305, vrr_stack+57239, vrr_stack+36884, vrr_stack+45299, NULL);
 _BUILD_00h0(Data,vrr_stack+33107, vrr_stack+45315, vrr_stack+57249, vrr_stack+36890, vrr_stack+45305, NULL);
 _BUILD_00i0(Data,vrr_stack+57264, vrr_stack+45330, vrr_stack+33107, vrr_stack+36900, vrr_stack+45315, NULL);
 _BUILD_00k0(Data,vrr_stack+57292, vrr_stack+45351, vrr_stack+57264, vrr_stack+36915, vrr_stack+45330, NULL);
 _BUILD_00l0(Data,vrr_stack+57328, vrr_stack+45379, vrr_stack+57292, vrr_stack+36936, vrr_stack+45351, NULL);
 _BUILD_00m0(Data,vrr_stack+57373, vrr_stack+28808, vrr_stack+57328, vrr_stack+36964, vrr_stack+45379, NULL);
 _BUILD_00n0(Data,vrr_stack+57428, vrr_stack+45415, vrr_stack+57373, vrr_stack+8060, vrr_stack+28808, NULL);
 _BUILD_00o0(Data,vrr_stack+57494, vrr_stack+28853, vrr_stack+57428, vrr_stack+37000, vrr_stack+45415, NULL);
 _BUILD_00q0(Data,vrr_stack+57572, vrr_stack+45470, vrr_stack+57494, vrr_stack+8105, vrr_stack+28853, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8060, vrr_stack+45548, vrr_stack+57572, vrr_stack+37055, vrr_stack+45470, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+57663, vrr_stack+15326, vrr_stack+8060, vrr_stack+37133, vrr_stack+45548, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+57783, vrr_stack+28919, vrr_stack+57663, vrr_stack+9710, vrr_stack+15326, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+31928, vrr_stack+29039, vrr_stack+57783, vrr_stack+8171, vrr_stack+28919, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+8165, vrr_stack+12206, vrr_stack+31928, vrr_stack+9815, vrr_stack+29039, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+9710, vrr_stack+12359, vrr_stack+8165, vrr_stack+9951, vrr_stack+12206, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+17882, vrr_stack+40290, vrr_stack+9710, NULL, NULL, vrr_stack+12359);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+36728, vrr_stack+22928, vrr_stack+17882, vrr_stack+59966, vrr_stack+40290, vrr_stack+45639);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+75622, vrr_stack+50382, vrr_stack+36728, vrr_stack+60346, vrr_stack+22928, vrr_stack+32081);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+77522, vrr_stack+70682, vrr_stack+75622, vrr_stack+69542, vrr_stack+50382, vrr_stack+62702);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+80372, vrr_stack+73722, vrr_stack+70682, vrr_stack+72582, vrr_stack+69542, vrr_stack+58256);
   tmp = vrr_stack + 80372;
   target_ptr = Libint->vrr_classes[4][18];
   for(i=0;i<2850;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+72582, vrr_stack+59966, vrr_stack+40290, vrr_stack+47744, vrr_stack+42067, NULL);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+72792, vrr_stack+60156, vrr_stack+59966, vrr_stack+47915, vrr_stack+47744, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+73002, vrr_stack+72792, vrr_stack+72582, NULL, NULL, vrr_stack+59966);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+62702, vrr_stack+50192, vrr_stack+60156, vrr_stack+41896, vrr_stack+47915, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+47744, vrr_stack+62702, vrr_stack+72792, NULL, NULL, vrr_stack+60156);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+48374, vrr_stack+40290, vrr_stack+9710, vrr_stack+42067, vrr_stack+12359, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+42067, vrr_stack+72582, vrr_stack+48374, NULL, NULL, vrr_stack+40290);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+62912, vrr_stack+73002, vrr_stack+42067, vrr_stack+72792, vrr_stack+72582, vrr_stack+22928);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+83222, vrr_stack+47744, vrr_stack+73002, vrr_stack+62702, vrr_stack+72792, vrr_stack+60346);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+84482, vrr_stack+83222, vrr_stack+62912, vrr_stack+47744, vrr_stack+73002, vrr_stack+50382);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+50382, vrr_stack+17692, vrr_stack+50192, vrr_stack+2503, vrr_stack+41896, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+22928, vrr_stack+50382, vrr_stack+62702, NULL, NULL, vrr_stack+50192);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+50592, vrr_stack+22928, vrr_stack+47744, vrr_stack+50382, vrr_stack+62702, vrr_stack+39720);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+86582, vrr_stack+50592, vrr_stack+83222, vrr_stack+22928, vrr_stack+47744, vrr_stack+69542);
   tmp = vrr_stack + 86582;
   target_ptr = Libint->vrr_classes[3][19];
   for(i=0;i<2100;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+69542, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+69545, vrr_stack+57230, vrr_stack+69542, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+69551, vrr_stack+57233, vrr_stack+69545, vrr_stack+45296, vrr_stack+57230, NULL);
 _BUILD_00g0(Data,vrr_stack+69561, vrr_stack+57239, vrr_stack+69551, vrr_stack+45299, vrr_stack+57233, NULL);
 _BUILD_00h0(Data,vrr_stack+69576, vrr_stack+57249, vrr_stack+69561, vrr_stack+45305, vrr_stack+57239, NULL);
 _BUILD_00i0(Data,vrr_stack+69597, vrr_stack+33107, vrr_stack+69576, vrr_stack+45315, vrr_stack+57249, NULL);
 _BUILD_00k0(Data,vrr_stack+69625, vrr_stack+57264, vrr_stack+69597, vrr_stack+45330, vrr_stack+33107, NULL);
 _BUILD_00l0(Data,vrr_stack+45296, vrr_stack+57292, vrr_stack+69625, vrr_stack+45351, vrr_stack+57264, NULL);
 _BUILD_00m0(Data,vrr_stack+69661, vrr_stack+57328, vrr_stack+45296, vrr_stack+45379, vrr_stack+57292, NULL);
 _BUILD_00n0(Data,vrr_stack+45341, vrr_stack+57373, vrr_stack+69661, vrr_stack+28808, vrr_stack+57328, NULL);
 _BUILD_00o0(Data,vrr_stack+48584, vrr_stack+57428, vrr_stack+45341, vrr_stack+45415, vrr_stack+57373, NULL);
 _BUILD_00q0(Data,vrr_stack+69716, vrr_stack+57494, vrr_stack+48584, vrr_stack+28853, vrr_stack+57428, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+28808, vrr_stack+57572, vrr_stack+69716, vrr_stack+45470, vrr_stack+57494, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+45407, vrr_stack+8060, vrr_stack+28808, vrr_stack+45548, vrr_stack+57572, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+45527, vrr_stack+57663, vrr_stack+45407, vrr_stack+15326, vrr_stack+8060, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+15326, vrr_stack+57783, vrr_stack+45527, vrr_stack+28919, vrr_stack+57663, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+41896, vrr_stack+31928, vrr_stack+15326, vrr_stack+29039, vrr_stack+57783, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+15479, vrr_stack+8165, vrr_stack+41896, vrr_stack+12206, vrr_stack+31928, NULL);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+28913, vrr_stack+9710, vrr_stack+15479, vrr_stack+12359, vrr_stack+8165, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+22928, vrr_stack+48374, vrr_stack+28913, NULL, NULL, vrr_stack+9710);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+88682, vrr_stack+42067, vrr_stack+22928, vrr_stack+72582, vrr_stack+48374, vrr_stack+17882);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+89942, vrr_stack+62912, vrr_stack+88682, vrr_stack+73002, vrr_stack+42067, vrr_stack+36728);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+92042, vrr_stack+84482, vrr_stack+89942, vrr_stack+83222, vrr_stack+62912, vrr_stack+75622);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+95192, vrr_stack+86582, vrr_stack+84482, vrr_stack+50592, vrr_stack+83222, vrr_stack+70682);
   tmp = vrr_stack + 95192;
   target_ptr = Libint->vrr_classes[4][19];
   for(i=0;i<3150;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+50592, vrr_stack+72582, vrr_stack+48374, vrr_stack+59966, vrr_stack+40290, NULL);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+50823, vrr_stack+72792, vrr_stack+72582, vrr_stack+60156, vrr_stack+59966, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+51054, vrr_stack+50823, vrr_stack+50592, NULL, NULL, vrr_stack+72582);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+51747, vrr_stack+62702, vrr_stack+72792, vrr_stack+50192, vrr_stack+60156, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+59966, vrr_stack+51747, vrr_stack+50823, NULL, NULL, vrr_stack+72792);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+72582, vrr_stack+48374, vrr_stack+28913, vrr_stack+40290, vrr_stack+9710, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+75622, vrr_stack+50592, vrr_stack+72582, NULL, NULL, vrr_stack+48374);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+36728, vrr_stack+51054, vrr_stack+75622, vrr_stack+50823, vrr_stack+50592, vrr_stack+42067);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+98342, vrr_stack+59966, vrr_stack+51054, vrr_stack+51747, vrr_stack+50823, vrr_stack+73002);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+99728, vrr_stack+98342, vrr_stack+36728, vrr_stack+59966, vrr_stack+51054, vrr_stack+62912);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+50823, vrr_stack+50382, vrr_stack+62702, vrr_stack+17692, vrr_stack+50192, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+17692, vrr_stack+50823, vrr_stack+51747, NULL, NULL, vrr_stack+62702);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+62702, vrr_stack+17692, vrr_stack+59966, vrr_stack+50823, vrr_stack+51747, vrr_stack+47744);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+102038, vrr_stack+62702, vrr_stack+98342, vrr_stack+17692, vrr_stack+59966, vrr_stack+83222);
   tmp = vrr_stack + 102038;
   target_ptr = Libint->vrr_classes[3][20];
   for(i=0;i<2310;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+83222, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+83225, vrr_stack+69542, vrr_stack+83222, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+83231, vrr_stack+69545, vrr_stack+83225, vrr_stack+57230, vrr_stack+69542, NULL);
 _BUILD_00g0(Data,vrr_stack+83241, vrr_stack+69551, vrr_stack+83231, vrr_stack+57233, vrr_stack+69545, NULL);
 _BUILD_00h0(Data,vrr_stack+83256, vrr_stack+69561, vrr_stack+83241, vrr_stack+57239, vrr_stack+69551, NULL);
 _BUILD_00i0(Data,vrr_stack+83222, vrr_stack+69576, vrr_stack+83256, vrr_stack+57249, vrr_stack+69561, NULL);
 _BUILD_00k0(Data,vrr_stack+83250, vrr_stack+69597, vrr_stack+83222, vrr_stack+33107, vrr_stack+69576, NULL);
 _BUILD_00l0(Data,vrr_stack+69542, vrr_stack+69625, vrr_stack+83250, vrr_stack+57264, vrr_stack+69597, NULL);
 _BUILD_00m0(Data,vrr_stack+83222, vrr_stack+45296, vrr_stack+69542, vrr_stack+57292, vrr_stack+69625, NULL);
 _BUILD_00n0(Data,vrr_stack+69542, vrr_stack+69661, vrr_stack+83222, vrr_stack+57328, vrr_stack+45296, NULL);
 _BUILD_00o0(Data,vrr_stack+83222, vrr_stack+45341, vrr_stack+69542, vrr_stack+57373, vrr_stack+69661, NULL);
 _BUILD_00q0(Data,vrr_stack+69542, vrr_stack+48584, vrr_stack+83222, vrr_stack+57428, vrr_stack+45341, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+83222, vrr_stack+69716, vrr_stack+69542, vrr_stack+57494, vrr_stack+48584, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+69542, vrr_stack+28808, vrr_stack+83222, vrr_stack+57572, vrr_stack+69716, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+83222, vrr_stack+45407, vrr_stack+69542, vrr_stack+8060, vrr_stack+28808, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+69542, vrr_stack+45527, vrr_stack+83222, vrr_stack+57663, vrr_stack+45407, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+83222, vrr_stack+15326, vrr_stack+69542, vrr_stack+57783, vrr_stack+45527, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+69542, vrr_stack+41896, vrr_stack+83222, vrr_stack+31928, vrr_stack+15326, NULL);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+31928, vrr_stack+15479, vrr_stack+69542, vrr_stack+8165, vrr_stack+41896, NULL);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+50823, vrr_stack+28913, vrr_stack+31928, vrr_stack+9710, vrr_stack+15479, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+31928, vrr_stack+72582, vrr_stack+50823, NULL, NULL, vrr_stack+28913);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+17692, vrr_stack+75622, vrr_stack+31928, vrr_stack+50592, vrr_stack+72582, vrr_stack+22928);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+104348, vrr_stack+36728, vrr_stack+17692, vrr_stack+51054, vrr_stack+75622, vrr_stack+88682);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+106658, vrr_stack+99728, vrr_stack+104348, vrr_stack+98342, vrr_stack+36728, vrr_stack+89942);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+110123, vrr_stack+102038, vrr_stack+99728, vrr_stack+62702, vrr_stack+98342, vrr_stack+84482);
   tmp = vrr_stack + 110123;
   target_ptr = Libint->vrr_classes[4][20];
   for(i=0;i<3465;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0n0(Data,vrr_stack+98342, vrr_stack+3514, vrr_stack+8720, vrr_stack+7400, vrr_stack+6740, vrr_stack+5123);
   tmp = vrr_stack + 98342;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0o0(Data,vrr_stack+62702, vrr_stack+14156, vrr_stack+12986, vrr_stack+11426, vrr_stack+10178, vrr_stack+8720);
   tmp = vrr_stack + 62702;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0q0(Data,vrr_stack+104348, vrr_stack+20513, vrr_stack+19148, vrr_stack+16782, vrr_stack+15872, vrr_stack+12986);
   tmp = vrr_stack + 104348;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+88682, vrr_stack+27233, vrr_stack+25658, vrr_stack+23558, vrr_stack+21878, vrr_stack+19148);
   tmp = vrr_stack + 88682;
   target_ptr = Libint->vrr_classes[5][13];
   for(i=0;i<2205;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2503, vrr_stack+34928, vrr_stack+33128, vrr_stack+30728, vrr_stack+29528, vrr_stack+25658);
   tmp = vrr_stack + 2503;
   target_ptr = Libint->vrr_classes[5][14];
   for(i=0;i<2520;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+34928, vrr_stack+43256, vrr_stack+463, vrr_stack+40536, vrr_stack+38360, vrr_stack+33128);
   tmp = vrr_stack + 34928;
   target_ptr = Libint->vrr_classes[5][15];
   for(i=0;i<2856;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+37784, vrr_stack+54935, vrr_stack+52640, vrr_stack+48662, vrr_stack+46214, vrr_stack+463);
   tmp = vrr_stack + 37784;
   target_ptr = Libint->vrr_classes[5][16];
   for(i=0;i<3213;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+40997, vrr_stack+66977, vrr_stack+64412, vrr_stack+60992, vrr_stack+58256, vrr_stack+52640);
   tmp = vrr_stack + 40997;
   target_ptr = Libint->vrr_classes[5][17];
   for(i=0;i<3591;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+44588, vrr_stack+80372, vrr_stack+77522, vrr_stack+73722, vrr_stack+70682, vrr_stack+64412);
   tmp = vrr_stack + 44588;
   target_ptr = Libint->vrr_classes[5][18];
   for(i=0;i<3990;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+48578, vrr_stack+95192, vrr_stack+92042, vrr_stack+86582, vrr_stack+84482, vrr_stack+77522);
   tmp = vrr_stack + 48578;
   target_ptr = Libint->vrr_classes[5][19];
   for(i=0;i<4410;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+52988, vrr_stack+110123, vrr_stack+106658, vrr_stack+102038, vrr_stack+99728, vrr_stack+92042);
   tmp = vrr_stack + 52988;
   target_ptr = Libint->vrr_classes[5][20];
   for(i=0;i<4851;i++)
     target_ptr[i] += tmp[i];

}

