/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (gd|nl) integrals */

void vrr_order_gdnl(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+21, vrr_stack+3, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+24, vrr_stack+65, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+30, vrr_stack+71, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+50, vrr_stack+81, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+12, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+6, vrr_stack+15, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+50, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+96, NULL, NULL, vrr_stack+50);
 _BUILD_00i0(Data,vrr_stack+226, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+254, vrr_stack+43, vrr_stack+6, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+264, vrr_stack+254, vrr_stack+117, vrr_stack+43, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+279, vrr_stack+264, vrr_stack+127, vrr_stack+254, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+300, vrr_stack+279, vrr_stack+142, vrr_stack+264, vrr_stack+127, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+3, vrr_stack+0, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+65, vrr_stack+117, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+71, vrr_stack+123, vrr_stack+24, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+328, vrr_stack+81, vrr_stack+6, vrr_stack+30, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+349, vrr_stack+96, vrr_stack+328, vrr_stack+50, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+377, vrr_stack+226, vrr_stack+349, NULL, NULL, vrr_stack+96);
 _BUILD_p0i0(Data,vrr_stack+461, vrr_stack+300, vrr_stack+226, NULL, NULL, vrr_stack+142);
 _BUILD_d0i0(Data,vrr_stack+545, vrr_stack+461, vrr_stack+377, vrr_stack+300, vrr_stack+226, vrr_stack+163);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+226, vrr_stack+349, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00k0(Data,vrr_stack+713, vrr_stack+300, vrr_stack+226, vrr_stack+279, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+749, vrr_stack+713, vrr_stack+163, NULL, NULL, vrr_stack+226);
 _BUILD_00p0(Data,vrr_stack+199, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+202, vrr_stack+199, vrr_stack+40, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+208, vrr_stack+202, vrr_stack+43, vrr_stack+199, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+208, vrr_stack+254, vrr_stack+202, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+133, vrr_stack+264, vrr_stack+208, vrr_stack+254, NULL);
 _BUILD_00i0(Data,vrr_stack+857, vrr_stack+21, vrr_stack+279, vrr_stack+133, vrr_stack+264, NULL);
 _BUILD_00k0(Data,vrr_stack+885, vrr_stack+857, vrr_stack+300, vrr_stack+21, vrr_stack+279, NULL);
 _BUILD_p0k0(Data,vrr_stack+921, vrr_stack+885, vrr_stack+713, NULL, NULL, vrr_stack+300);
 _BUILD_00p0(Data,vrr_stack+254, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+257, vrr_stack+0, vrr_stack+254, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+263, vrr_stack+117, vrr_stack+257, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+123, vrr_stack+263, vrr_stack+65, vrr_stack+117, NULL);
 _BUILD_00h0(Data,vrr_stack+273, vrr_stack+6, vrr_stack+148, vrr_stack+71, vrr_stack+123, NULL);
 _BUILD_00i0(Data,vrr_stack+42, vrr_stack+328, vrr_stack+273, vrr_stack+81, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+1029, vrr_stack+349, vrr_stack+42, vrr_stack+96, vrr_stack+328, NULL);
 _BUILD_p0k0(Data,vrr_stack+1065, vrr_stack+163, vrr_stack+1029, NULL, NULL, vrr_stack+349);
 _BUILD_d0k0(Data,vrr_stack+1173, vrr_stack+749, vrr_stack+1065, vrr_stack+713, vrr_stack+163, vrr_stack+377);
 _BUILD_d0k0(Data,vrr_stack+1389, vrr_stack+921, vrr_stack+749, vrr_stack+885, vrr_stack+713, vrr_stack+461);
 _BUILD_f0k0(Data,vrr_stack+1605, vrr_stack+1389, vrr_stack+1173, vrr_stack+921, vrr_stack+749, vrr_stack+545);
 _BUILD_00l0(Data,vrr_stack+377, vrr_stack+713, vrr_stack+163, vrr_stack+300, vrr_stack+226, NULL);
 _BUILD_00l0(Data,vrr_stack+422, vrr_stack+885, vrr_stack+713, vrr_stack+857, vrr_stack+300, NULL);
 _BUILD_00l0(Data,vrr_stack+467, vrr_stack+163, vrr_stack+1029, vrr_stack+226, vrr_stack+349, NULL);
 _BUILD_p0l0(Data,vrr_stack+512, vrr_stack+377, vrr_stack+467, NULL, NULL, vrr_stack+163);
 _BUILD_p0l0(Data,vrr_stack+1965, vrr_stack+422, vrr_stack+377, NULL, NULL, vrr_stack+713);
 _BUILD_d0l0(Data,vrr_stack+2100, vrr_stack+1965, vrr_stack+512, vrr_stack+422, vrr_stack+377, vrr_stack+749);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+749, vrr_stack+3, vrr_stack+199, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+755, vrr_stack+749, vrr_stack+202, vrr_stack+3, vrr_stack+199, NULL);
 _BUILD_00g0(Data,vrr_stack+765, vrr_stack+755, vrr_stack+208, vrr_stack+749, vrr_stack+202, NULL);
 _BUILD_00h0(Data,vrr_stack+780, vrr_stack+765, vrr_stack+133, vrr_stack+755, vrr_stack+208, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+780, vrr_stack+21, vrr_stack+765, vrr_stack+133, NULL);
 _BUILD_00k0(Data,vrr_stack+801, vrr_stack+199, vrr_stack+857, vrr_stack+780, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+647, vrr_stack+801, vrr_stack+885, vrr_stack+199, vrr_stack+857, NULL);
 _BUILD_p0l0(Data,vrr_stack+2370, vrr_stack+647, vrr_stack+422, NULL, NULL, vrr_stack+885);
 _BUILD_d0l0(Data,vrr_stack+2505, vrr_stack+2370, vrr_stack+1965, vrr_stack+647, vrr_stack+422, vrr_stack+921);
 _BUILD_00p0(Data,vrr_stack+921, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+924, vrr_stack+254, vrr_stack+921, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+930, vrr_stack+257, vrr_stack+924, vrr_stack+0, vrr_stack+254, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+263, vrr_stack+930, vrr_stack+117, vrr_stack+257, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+148, vrr_stack+133, vrr_stack+123, vrr_stack+263, NULL);
 _BUILD_00i0(Data,vrr_stack+940, vrr_stack+273, vrr_stack+21, vrr_stack+6, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+968, vrr_stack+42, vrr_stack+940, vrr_stack+328, vrr_stack+273, NULL);
 _BUILD_00l0(Data,vrr_stack+837, vrr_stack+1029, vrr_stack+968, vrr_stack+349, vrr_stack+42, NULL);
 _BUILD_p0l0(Data,vrr_stack+2775, vrr_stack+467, vrr_stack+837, NULL, NULL, vrr_stack+1029);
 _BUILD_d0l0(Data,vrr_stack+2910, vrr_stack+512, vrr_stack+2775, vrr_stack+377, vrr_stack+467, vrr_stack+1065);
 _BUILD_f0l0(Data,vrr_stack+3180, vrr_stack+2100, vrr_stack+2910, vrr_stack+1965, vrr_stack+512, vrr_stack+1173);
 _BUILD_f0l0(Data,vrr_stack+3630, vrr_stack+2505, vrr_stack+2100, vrr_stack+2370, vrr_stack+1965, vrr_stack+1389);
 _BUILD_g0l0(Data,vrr_stack+4080, vrr_stack+3630, vrr_stack+3180, vrr_stack+2505, vrr_stack+2100, vrr_stack+1605);
 _BUILD_00m0(Data,vrr_stack+1065, vrr_stack+377, vrr_stack+467, vrr_stack+713, vrr_stack+163, NULL);
 _BUILD_00m0(Data,vrr_stack+1120, vrr_stack+422, vrr_stack+377, vrr_stack+885, vrr_stack+713, NULL);
 _BUILD_p0m0(Data,vrr_stack+1175, vrr_stack+1120, vrr_stack+1065, NULL, NULL, vrr_stack+377);
 _BUILD_00m0(Data,vrr_stack+1340, vrr_stack+647, vrr_stack+422, vrr_stack+801, vrr_stack+885, NULL);
 _BUILD_p0m0(Data,vrr_stack+1395, vrr_stack+1340, vrr_stack+1120, NULL, NULL, vrr_stack+422);
 _BUILD_00m0(Data,vrr_stack+1560, vrr_stack+467, vrr_stack+837, vrr_stack+163, vrr_stack+1029, NULL);
 _BUILD_p0m0(Data,vrr_stack+1615, vrr_stack+1065, vrr_stack+1560, NULL, NULL, vrr_stack+467);
 _BUILD_d0m0(Data,vrr_stack+4755, vrr_stack+1175, vrr_stack+1615, vrr_stack+1120, vrr_stack+1065, vrr_stack+512);
 _BUILD_d0m0(Data,vrr_stack+5085, vrr_stack+1395, vrr_stack+1175, vrr_stack+1340, vrr_stack+1120, vrr_stack+1965);
 _BUILD_f0m0(Data,vrr_stack+5415, vrr_stack+5085, vrr_stack+4755, vrr_stack+1395, vrr_stack+1175, vrr_stack+2100);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+512, vrr_stack+0, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+518, vrr_stack+512, vrr_stack+749, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+518, vrr_stack+755, vrr_stack+512, vrr_stack+749, NULL);
 _BUILD_00h0(Data,vrr_stack+528, vrr_stack+3, vrr_stack+765, vrr_stack+518, vrr_stack+755, NULL);
 _BUILD_00i0(Data,vrr_stack+549, vrr_stack+528, vrr_stack+780, vrr_stack+3, vrr_stack+765, NULL);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+549, vrr_stack+199, vrr_stack+528, vrr_stack+780, NULL);
 _BUILD_00l0(Data,vrr_stack+577, vrr_stack+163, vrr_stack+801, vrr_stack+549, vrr_stack+199, NULL);
 _BUILD_00m0(Data,vrr_stack+199, vrr_stack+577, vrr_stack+647, vrr_stack+163, vrr_stack+801, NULL);
 _BUILD_p0m0(Data,vrr_stack+1780, vrr_stack+199, vrr_stack+1340, NULL, NULL, vrr_stack+647);
 _BUILD_d0m0(Data,vrr_stack+1945, vrr_stack+1780, vrr_stack+1395, vrr_stack+199, vrr_stack+1340, vrr_stack+2370);
 _BUILD_f0m0(Data,vrr_stack+5965, vrr_stack+1945, vrr_stack+5085, vrr_stack+1780, vrr_stack+1395, vrr_stack+2505);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+622, vrr_stack+921, vrr_stack+18, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+628, vrr_stack+924, vrr_stack+622, vrr_stack+254, vrr_stack+921, NULL);
 _BUILD_00g0(Data,vrr_stack+2275, vrr_stack+930, vrr_stack+628, vrr_stack+257, vrr_stack+924, NULL);
 _BUILD_00h0(Data,vrr_stack+2290, vrr_stack+133, vrr_stack+2275, vrr_stack+263, vrr_stack+930, NULL);
 _BUILD_00i0(Data,vrr_stack+2311, vrr_stack+21, vrr_stack+2290, vrr_stack+148, vrr_stack+133, NULL);
 _BUILD_00k0(Data,vrr_stack+2339, vrr_stack+940, vrr_stack+2311, vrr_stack+273, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+254, vrr_stack+968, vrr_stack+2339, vrr_stack+42, vrr_stack+940, NULL);
 _BUILD_00m0(Data,vrr_stack+42, vrr_stack+837, vrr_stack+254, vrr_stack+1029, vrr_stack+968, NULL);
 _BUILD_p0m0(Data,vrr_stack+2375, vrr_stack+1560, vrr_stack+42, NULL, NULL, vrr_stack+837);
 _BUILD_d0m0(Data,vrr_stack+6515, vrr_stack+1615, vrr_stack+2375, vrr_stack+1065, vrr_stack+1560, vrr_stack+2775);
 _BUILD_f0m0(Data,vrr_stack+6845, vrr_stack+4755, vrr_stack+6515, vrr_stack+1175, vrr_stack+1615, vrr_stack+2910);
 _BUILD_g0m0(Data,vrr_stack+7395, vrr_stack+5415, vrr_stack+6845, vrr_stack+5085, vrr_stack+4755, vrr_stack+3180);
 _BUILD_g0m0(Data,vrr_stack+2540, vrr_stack+5965, vrr_stack+5415, vrr_stack+1945, vrr_stack+5085, vrr_stack+3630);
 _BUILD_h0m0(Data,vrr_stack+8220, vrr_stack+2540, vrr_stack+7395, vrr_stack+5965, vrr_stack+5415, vrr_stack+4080);
 _BUILD_00n0(Data,vrr_stack+299, vrr_stack+1120, vrr_stack+1065, vrr_stack+422, vrr_stack+377, NULL);
 _BUILD_00n0(Data,vrr_stack+3365, vrr_stack+1340, vrr_stack+1120, vrr_stack+647, vrr_stack+422, NULL);
 _BUILD_00n0(Data,vrr_stack+3431, vrr_stack+1065, vrr_stack+1560, vrr_stack+377, vrr_stack+467, NULL);
 _BUILD_p0n0(Data,vrr_stack+3497, vrr_stack+299, vrr_stack+3431, NULL, NULL, vrr_stack+1065);
 _BUILD_p0n0(Data,vrr_stack+3695, vrr_stack+3365, vrr_stack+299, NULL, NULL, vrr_stack+1120);
 _BUILD_d0n0(Data,vrr_stack+3893, vrr_stack+3695, vrr_stack+3497, vrr_stack+3365, vrr_stack+299, vrr_stack+1175);
 _BUILD_00n0(Data,vrr_stack+1175, vrr_stack+199, vrr_stack+1340, vrr_stack+577, vrr_stack+647, NULL);
 _BUILD_p0n0(Data,vrr_stack+638, vrr_stack+1175, vrr_stack+3365, NULL, NULL, vrr_stack+1340);
 _BUILD_d0n0(Data,vrr_stack+4289, vrr_stack+638, vrr_stack+3695, vrr_stack+1175, vrr_stack+3365, vrr_stack+1395);
 _BUILD_00n0(Data,vrr_stack+1395, vrr_stack+1560, vrr_stack+42, vrr_stack+467, vrr_stack+837, NULL);
 _BUILD_p0n0(Data,vrr_stack+9375, vrr_stack+3431, vrr_stack+1395, NULL, NULL, vrr_stack+1560);
 _BUILD_d0n0(Data,vrr_stack+9573, vrr_stack+3497, vrr_stack+9375, vrr_stack+299, vrr_stack+3431, vrr_stack+1615);
 _BUILD_f0n0(Data,vrr_stack+9969, vrr_stack+3893, vrr_stack+9573, vrr_stack+3695, vrr_stack+3497, vrr_stack+4755);
 _BUILD_f0n0(Data,vrr_stack+10629, vrr_stack+4289, vrr_stack+3893, vrr_stack+638, vrr_stack+3695, vrr_stack+5085);
 _BUILD_g0n0(Data,vrr_stack+11289, vrr_stack+10629, vrr_stack+9969, vrr_stack+4289, vrr_stack+3893, vrr_stack+5415);
 _BUILD_00p0(Data,vrr_stack+1615, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1618, vrr_stack+1615, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+1624, vrr_stack+1618, vrr_stack+512, vrr_stack+1615, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+1624, vrr_stack+518, vrr_stack+1618, vrr_stack+512, NULL);
 _BUILD_00h0(Data,vrr_stack+1634, vrr_stack+148, vrr_stack+3, vrr_stack+1624, vrr_stack+518, NULL);
 _BUILD_00i0(Data,vrr_stack+1655, vrr_stack+1634, vrr_stack+528, vrr_stack+148, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+97, vrr_stack+1655, vrr_stack+549, vrr_stack+1634, vrr_stack+528, NULL);
 _BUILD_00l0(Data,vrr_stack+1683, vrr_stack+97, vrr_stack+163, vrr_stack+1655, vrr_stack+549, NULL);
 _BUILD_00m0(Data,vrr_stack+1615, vrr_stack+1683, vrr_stack+577, vrr_stack+97, vrr_stack+163, NULL);
 _BUILD_00n0(Data,vrr_stack+1461, vrr_stack+1615, vrr_stack+199, vrr_stack+1683, vrr_stack+577, NULL);
 _BUILD_p0n0(Data,vrr_stack+365, vrr_stack+1461, vrr_stack+1175, NULL, NULL, vrr_stack+199);
 _BUILD_d0n0(Data,vrr_stack+4685, vrr_stack+365, vrr_stack+638, vrr_stack+1461, vrr_stack+1175, vrr_stack+1780);
 _BUILD_f0n0(Data,vrr_stack+5081, vrr_stack+4685, vrr_stack+4289, vrr_stack+365, vrr_stack+638, vrr_stack+1945);
 _BUILD_g0n0(Data,vrr_stack+12279, vrr_stack+5081, vrr_stack+10629, vrr_stack+4685, vrr_stack+4289, vrr_stack+5965);
   tmp = vrr_stack + 12279;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+4685, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4688, vrr_stack+18, vrr_stack+4685, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+4694, vrr_stack+622, vrr_stack+4688, vrr_stack+921, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+4704, vrr_stack+628, vrr_stack+4694, vrr_stack+924, vrr_stack+622, NULL);
 _BUILD_00h0(Data,vrr_stack+4719, vrr_stack+2275, vrr_stack+4704, vrr_stack+930, vrr_stack+628, NULL);
 _BUILD_00i0(Data,vrr_stack+4740, vrr_stack+2290, vrr_stack+4719, vrr_stack+133, vrr_stack+2275, NULL);
 _BUILD_00k0(Data,vrr_stack+4768, vrr_stack+2311, vrr_stack+4740, vrr_stack+21, vrr_stack+2290, NULL);
 _BUILD_00l0(Data,vrr_stack+4804, vrr_stack+2339, vrr_stack+4768, vrr_stack+940, vrr_stack+2311, NULL);
 _BUILD_00m0(Data,vrr_stack+4849, vrr_stack+254, vrr_stack+4804, vrr_stack+968, vrr_stack+2339, NULL);
 _BUILD_00n0(Data,vrr_stack+4904, vrr_stack+42, vrr_stack+4849, vrr_stack+837, vrr_stack+254, NULL);
 _BUILD_p0n0(Data,vrr_stack+365, vrr_stack+1395, vrr_stack+4904, NULL, NULL, vrr_stack+42);
 _BUILD_d0n0(Data,vrr_stack+1670, vrr_stack+9375, vrr_stack+365, vrr_stack+3431, vrr_stack+1395, vrr_stack+2375);
 _BUILD_f0n0(Data,vrr_stack+5741, vrr_stack+9573, vrr_stack+1670, vrr_stack+3497, vrr_stack+9375, vrr_stack+6515);
 _BUILD_g0n0(Data,vrr_stack+13269, vrr_stack+9969, vrr_stack+5741, vrr_stack+3893, vrr_stack+9573, vrr_stack+6845);
 _BUILD_h0n0(Data,vrr_stack+14259, vrr_stack+11289, vrr_stack+13269, vrr_stack+10629, vrr_stack+9969, vrr_stack+7395);
 _BUILD_h0n0(Data,vrr_stack+6401, vrr_stack+12279, vrr_stack+11289, vrr_stack+5081, vrr_stack+10629, vrr_stack+2540);
   tmp = vrr_stack + 6401;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+2375, vrr_stack+299, vrr_stack+3431, vrr_stack+1120, vrr_stack+1065, NULL);
 _BUILD_00o0(Data,vrr_stack+2453, vrr_stack+3365, vrr_stack+299, vrr_stack+1340, vrr_stack+1120, NULL);
 _BUILD_00o0(Data,vrr_stack+2531, vrr_stack+3431, vrr_stack+1395, vrr_stack+1065, vrr_stack+1560, NULL);
 _BUILD_p0o0(Data,vrr_stack+2609, vrr_stack+2375, vrr_stack+2531, NULL, NULL, vrr_stack+3431);
 _BUILD_p0o0(Data,vrr_stack+2843, vrr_stack+2453, vrr_stack+2375, NULL, NULL, vrr_stack+299);
 _BUILD_d0o0(Data,vrr_stack+4970, vrr_stack+2843, vrr_stack+2609, vrr_stack+2453, vrr_stack+2375, vrr_stack+3497);
 _BUILD_00o0(Data,vrr_stack+3497, vrr_stack+1175, vrr_stack+3365, vrr_stack+199, vrr_stack+1340, NULL);
 _BUILD_p0o0(Data,vrr_stack+3077, vrr_stack+3497, vrr_stack+2453, NULL, NULL, vrr_stack+3365);
 _BUILD_d0o0(Data,vrr_stack+15645, vrr_stack+3077, vrr_stack+2843, vrr_stack+3497, vrr_stack+2453, vrr_stack+3695);
 _BUILD_00o0(Data,vrr_stack+3575, vrr_stack+1395, vrr_stack+4904, vrr_stack+1560, vrr_stack+42, NULL);
 _BUILD_p0o0(Data,vrr_stack+3653, vrr_stack+2531, vrr_stack+3575, NULL, NULL, vrr_stack+1395);
 _BUILD_d0o0(Data,vrr_stack+16113, vrr_stack+2609, vrr_stack+3653, vrr_stack+2375, vrr_stack+2531, vrr_stack+9375);
 _BUILD_f0o0(Data,vrr_stack+16581, vrr_stack+4970, vrr_stack+16113, vrr_stack+2843, vrr_stack+2609, vrr_stack+9573);
 _BUILD_f0o0(Data,vrr_stack+17361, vrr_stack+15645, vrr_stack+4970, vrr_stack+3077, vrr_stack+2843, vrr_stack+3893);
 _BUILD_g0o0(Data,vrr_stack+18141, vrr_stack+17361, vrr_stack+16581, vrr_stack+15645, vrr_stack+4970, vrr_stack+9969);
 _BUILD_00o0(Data,vrr_stack+9375, vrr_stack+1461, vrr_stack+1175, vrr_stack+1615, vrr_stack+199, NULL);
 _BUILD_p0o0(Data,vrr_stack+9453, vrr_stack+9375, vrr_stack+3497, NULL, NULL, vrr_stack+1175);
 _BUILD_d0o0(Data,vrr_stack+9687, vrr_stack+9453, vrr_stack+3077, vrr_stack+9375, vrr_stack+3497, vrr_stack+638);
 _BUILD_f0o0(Data,vrr_stack+19311, vrr_stack+9687, vrr_stack+15645, vrr_stack+9453, vrr_stack+3077, vrr_stack+4289);
 _BUILD_g0o0(Data,vrr_stack+20091, vrr_stack+19311, vrr_stack+17361, vrr_stack+9687, vrr_stack+15645, vrr_stack+10629);
   tmp = vrr_stack + 20091;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+9453, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9456, vrr_stack+4685, vrr_stack+9453, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+9462, vrr_stack+4688, vrr_stack+9456, vrr_stack+18, vrr_stack+4685, NULL);
 _BUILD_00g0(Data,vrr_stack+9472, vrr_stack+4694, vrr_stack+9462, vrr_stack+622, vrr_stack+4688, NULL);
 _BUILD_00h0(Data,vrr_stack+9487, vrr_stack+4704, vrr_stack+9472, vrr_stack+628, vrr_stack+4694, NULL);
 _BUILD_00i0(Data,vrr_stack+9508, vrr_stack+4719, vrr_stack+9487, vrr_stack+2275, vrr_stack+4704, NULL);
 _BUILD_00k0(Data,vrr_stack+9536, vrr_stack+4740, vrr_stack+9508, vrr_stack+2290, vrr_stack+4719, NULL);
 _BUILD_00l0(Data,vrr_stack+9572, vrr_stack+4768, vrr_stack+9536, vrr_stack+2311, vrr_stack+4740, NULL);
 _BUILD_00m0(Data,vrr_stack+9617, vrr_stack+4804, vrr_stack+9572, vrr_stack+2339, vrr_stack+4768, NULL);
 _BUILD_00n0(Data,vrr_stack+9672, vrr_stack+4849, vrr_stack+9617, vrr_stack+254, vrr_stack+4804, NULL);
 _BUILD_00o0(Data,vrr_stack+9738, vrr_stack+4904, vrr_stack+9672, vrr_stack+42, vrr_stack+4849, NULL);
 _BUILD_p0o0(Data,vrr_stack+9816, vrr_stack+3575, vrr_stack+9738, NULL, NULL, vrr_stack+4904);
 _BUILD_d0o0(Data,vrr_stack+10050, vrr_stack+3653, vrr_stack+9816, vrr_stack+2531, vrr_stack+3575, vrr_stack+365);
 _BUILD_f0o0(Data,vrr_stack+365, vrr_stack+16113, vrr_stack+10050, vrr_stack+2609, vrr_stack+3653, vrr_stack+1670);
 _BUILD_g0o0(Data,vrr_stack+21261, vrr_stack+16581, vrr_stack+365, vrr_stack+4970, vrr_stack+16113, vrr_stack+5741);
 _BUILD_h0o0(Data,vrr_stack+22431, vrr_stack+18141, vrr_stack+21261, vrr_stack+17361, vrr_stack+16581, vrr_stack+13269);
 _BUILD_h0o0(Data,vrr_stack+24069, vrr_stack+20091, vrr_stack+18141, vrr_stack+19311, vrr_stack+17361, vrr_stack+11289);
   tmp = vrr_stack + 24069;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+19311, vrr_stack+2375, vrr_stack+2531, vrr_stack+299, vrr_stack+3431, NULL);
 _BUILD_00q0(Data,vrr_stack+19402, vrr_stack+2453, vrr_stack+2375, vrr_stack+3365, vrr_stack+299, NULL);
 _BUILD_00q0(Data,vrr_stack+19493, vrr_stack+2531, vrr_stack+3575, vrr_stack+3431, vrr_stack+1395, NULL);
 _BUILD_p0q0(Data,vrr_stack+19584, vrr_stack+19311, vrr_stack+19493, NULL, NULL, vrr_stack+2531);
 _BUILD_p0q0(Data,vrr_stack+13269, vrr_stack+19402, vrr_stack+19311, NULL, NULL, vrr_stack+2375);
 _BUILD_d0q0(Data,vrr_stack+13542, vrr_stack+13269, vrr_stack+19584, vrr_stack+19402, vrr_stack+19311, vrr_stack+2609);
 _BUILD_00q0(Data,vrr_stack+2609, vrr_stack+3497, vrr_stack+2453, vrr_stack+1175, vrr_stack+3365, NULL);
 _BUILD_p0q0(Data,vrr_stack+10518, vrr_stack+2609, vrr_stack+19402, NULL, NULL, vrr_stack+2453);
 _BUILD_d0q0(Data,vrr_stack+3887, vrr_stack+10518, vrr_stack+13269, vrr_stack+2609, vrr_stack+19402, vrr_stack+2843);
 _BUILD_00q0(Data,vrr_stack+2700, vrr_stack+3575, vrr_stack+9738, vrr_stack+1395, vrr_stack+4904, NULL);
 _BUILD_p0q0(Data,vrr_stack+2791, vrr_stack+19493, vrr_stack+2700, NULL, NULL, vrr_stack+3575);
 _BUILD_d0q0(Data,vrr_stack+5438, vrr_stack+19584, vrr_stack+2791, vrr_stack+19311, vrr_stack+19493, vrr_stack+3653);
 _BUILD_f0q0(Data,vrr_stack+25707, vrr_stack+13542, vrr_stack+5438, vrr_stack+13269, vrr_stack+19584, vrr_stack+16113);
 _BUILD_f0q0(Data,vrr_stack+26617, vrr_stack+3887, vrr_stack+13542, vrr_stack+10518, vrr_stack+13269, vrr_stack+4970);
 _BUILD_g0q0(Data,vrr_stack+27527, vrr_stack+26617, vrr_stack+25707, vrr_stack+3887, vrr_stack+13542, vrr_stack+16581);
 _BUILD_00q0(Data,vrr_stack+4970, vrr_stack+9375, vrr_stack+3497, vrr_stack+1461, vrr_stack+1175, NULL);
 _BUILD_p0q0(Data,vrr_stack+5061, vrr_stack+4970, vrr_stack+2609, NULL, NULL, vrr_stack+3497);
 _BUILD_d0q0(Data,vrr_stack+16113, vrr_stack+5061, vrr_stack+10518, vrr_stack+4970, vrr_stack+2609, vrr_stack+3077);
 _BUILD_f0q0(Data,vrr_stack+1145, vrr_stack+16113, vrr_stack+3887, vrr_stack+5061, vrr_stack+10518, vrr_stack+15645);
 _BUILD_g0q0(Data,vrr_stack+28892, vrr_stack+1145, vrr_stack+26617, vrr_stack+16113, vrr_stack+3887, vrr_stack+17361);
   tmp = vrr_stack + 28892;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+15645, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15648, vrr_stack+9453, vrr_stack+15645, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+15654, vrr_stack+9456, vrr_stack+15648, vrr_stack+4685, vrr_stack+9453, NULL);
 _BUILD_00g0(Data,vrr_stack+15664, vrr_stack+9462, vrr_stack+15654, vrr_stack+4688, vrr_stack+9456, NULL);
 _BUILD_00h0(Data,vrr_stack+15679, vrr_stack+9472, vrr_stack+15664, vrr_stack+4694, vrr_stack+9462, NULL);
 _BUILD_00i0(Data,vrr_stack+15700, vrr_stack+9487, vrr_stack+15679, vrr_stack+4704, vrr_stack+9472, NULL);
 _BUILD_00k0(Data,vrr_stack+15728, vrr_stack+9508, vrr_stack+15700, vrr_stack+4719, vrr_stack+9487, NULL);
 _BUILD_00l0(Data,vrr_stack+15764, vrr_stack+9536, vrr_stack+15728, vrr_stack+4740, vrr_stack+9508, NULL);
 _BUILD_00m0(Data,vrr_stack+15809, vrr_stack+9572, vrr_stack+15764, vrr_stack+4768, vrr_stack+9536, NULL);
 _BUILD_00n0(Data,vrr_stack+15864, vrr_stack+9617, vrr_stack+15809, vrr_stack+4804, vrr_stack+9572, NULL);
 _BUILD_00o0(Data,vrr_stack+15930, vrr_stack+9672, vrr_stack+15864, vrr_stack+4849, vrr_stack+9617, NULL);
 _BUILD_00q0(Data,vrr_stack+16008, vrr_stack+9738, vrr_stack+15930, vrr_stack+4904, vrr_stack+9672, NULL);
 _BUILD_p0q0(Data,vrr_stack+16099, vrr_stack+2700, vrr_stack+16008, NULL, NULL, vrr_stack+9738);
 _BUILD_d0q0(Data,vrr_stack+16372, vrr_stack+2791, vrr_stack+16099, vrr_stack+19493, vrr_stack+2700, vrr_stack+9816);
 _BUILD_f0q0(Data,vrr_stack+16918, vrr_stack+5438, vrr_stack+16372, vrr_stack+19584, vrr_stack+2791, vrr_stack+10050);
 _BUILD_g0q0(Data,vrr_stack+30257, vrr_stack+25707, vrr_stack+16918, vrr_stack+13542, vrr_stack+5438, vrr_stack+365);
 _BUILD_h0q0(Data,vrr_stack+31622, vrr_stack+27527, vrr_stack+30257, vrr_stack+26617, vrr_stack+25707, vrr_stack+21261);
 _BUILD_h0q0(Data,vrr_stack+33533, vrr_stack+28892, vrr_stack+27527, vrr_stack+1145, vrr_stack+26617, vrr_stack+18141);
   tmp = vrr_stack + 33533;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21261, vrr_stack+19311, vrr_stack+19493, vrr_stack+2375, vrr_stack+2531, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21366, vrr_stack+19402, vrr_stack+19311, vrr_stack+2453, vrr_stack+2375, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21471, vrr_stack+19493, vrr_stack+2700, vrr_stack+2531, vrr_stack+3575, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21576, vrr_stack+21261, vrr_stack+21471, NULL, NULL, vrr_stack+19493);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+21891, vrr_stack+21366, vrr_stack+21261, NULL, NULL, vrr_stack+19311);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9816, vrr_stack+21891, vrr_stack+21576, vrr_stack+21366, vrr_stack+21261, vrr_stack+19584);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+19584, vrr_stack+2609, vrr_stack+19402, vrr_stack+3497, vrr_stack+2453, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+19689, vrr_stack+19584, vrr_stack+21366, NULL, NULL, vrr_stack+19402);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+19689, vrr_stack+21891, vrr_stack+19584, vrr_stack+21366, vrr_stack+13269);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+13269, vrr_stack+2700, vrr_stack+16008, vrr_stack+3575, vrr_stack+9738, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5061, vrr_stack+21471, vrr_stack+13269, NULL, NULL, vrr_stack+2700);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+630, vrr_stack+21576, vrr_stack+5061, vrr_stack+21261, vrr_stack+21471, vrr_stack+2791);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1260, vrr_stack+9816, vrr_stack+630, vrr_stack+21891, vrr_stack+21576, vrr_stack+5438);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+35444, vrr_stack+0, vrr_stack+9816, vrr_stack+19689, vrr_stack+21891, vrr_stack+13542);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+36494, vrr_stack+35444, vrr_stack+1260, vrr_stack+0, vrr_stack+9816, vrr_stack+25707);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25707, vrr_stack+4970, vrr_stack+2609, vrr_stack+9375, vrr_stack+3497, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25812, vrr_stack+25707, vrr_stack+19584, NULL, NULL, vrr_stack+2609);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2791, vrr_stack+25812, vrr_stack+19689, vrr_stack+25707, vrr_stack+19584, vrr_stack+10518);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+38069, vrr_stack+2791, vrr_stack+0, vrr_stack+25812, vrr_stack+19689, vrr_stack+3887);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+39119, vrr_stack+38069, vrr_stack+35444, vrr_stack+2791, vrr_stack+0, vrr_stack+26617);
   tmp = vrr_stack + 39119;
   target_ptr = Libint->vrr_classes[4][13];
   for(i=0;i<1575;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2791, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2794, vrr_stack+15645, vrr_stack+2791, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+2800, vrr_stack+15648, vrr_stack+2794, vrr_stack+9453, vrr_stack+15645, NULL);
 _BUILD_00g0(Data,vrr_stack+2810, vrr_stack+15654, vrr_stack+2800, vrr_stack+9456, vrr_stack+15648, NULL);
 _BUILD_00h0(Data,vrr_stack+2825, vrr_stack+15664, vrr_stack+2810, vrr_stack+9462, vrr_stack+15654, NULL);
 _BUILD_00i0(Data,vrr_stack+2846, vrr_stack+15679, vrr_stack+2825, vrr_stack+9472, vrr_stack+15664, NULL);
 _BUILD_00k0(Data,vrr_stack+2874, vrr_stack+15700, vrr_stack+2846, vrr_stack+9487, vrr_stack+15679, NULL);
 _BUILD_00l0(Data,vrr_stack+2910, vrr_stack+15728, vrr_stack+2874, vrr_stack+9508, vrr_stack+15700, NULL);
 _BUILD_00m0(Data,vrr_stack+2955, vrr_stack+15764, vrr_stack+2910, vrr_stack+9536, vrr_stack+15728, NULL);
 _BUILD_00n0(Data,vrr_stack+3010, vrr_stack+15809, vrr_stack+2955, vrr_stack+9572, vrr_stack+15764, NULL);
 _BUILD_00o0(Data,vrr_stack+3076, vrr_stack+15864, vrr_stack+3010, vrr_stack+9617, vrr_stack+15809, NULL);
 _BUILD_00q0(Data,vrr_stack+3154, vrr_stack+15930, vrr_stack+3076, vrr_stack+9672, vrr_stack+15864, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3245, vrr_stack+16008, vrr_stack+3154, vrr_stack+9738, vrr_stack+15930, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3350, vrr_stack+13269, vrr_stack+3245, NULL, NULL, vrr_stack+16008);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3665, vrr_stack+5061, vrr_stack+3350, vrr_stack+21471, vrr_stack+13269, vrr_stack+16099);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25812, vrr_stack+630, vrr_stack+3665, vrr_stack+21576, vrr_stack+5061, vrr_stack+16372);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+40694, vrr_stack+1260, vrr_stack+25812, vrr_stack+9816, vrr_stack+630, vrr_stack+16918);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+42269, vrr_stack+36494, vrr_stack+40694, vrr_stack+35444, vrr_stack+1260, vrr_stack+30257);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+44474, vrr_stack+39119, vrr_stack+36494, vrr_stack+38069, vrr_stack+35444, vrr_stack+27527);
   tmp = vrr_stack + 44474;
   target_ptr = Libint->vrr_classes[5][13];
   for(i=0;i<2205;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+38069, vrr_stack+21261, vrr_stack+21471, vrr_stack+19311, vrr_stack+19493, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+38189, vrr_stack+21366, vrr_stack+21261, vrr_stack+19402, vrr_stack+19311, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+38309, vrr_stack+21471, vrr_stack+13269, vrr_stack+19493, vrr_stack+2700, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+38429, vrr_stack+38069, vrr_stack+38309, NULL, NULL, vrr_stack+21471);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+30257, vrr_stack+38189, vrr_stack+38069, NULL, NULL, vrr_stack+21261);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+30617, vrr_stack+30257, vrr_stack+38429, vrr_stack+38189, vrr_stack+38069, vrr_stack+21576);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21576, vrr_stack+19584, vrr_stack+21366, vrr_stack+2609, vrr_stack+19402, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+16099, vrr_stack+21576, vrr_stack+38189, NULL, NULL, vrr_stack+21366);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+16459, vrr_stack+16099, vrr_stack+30257, vrr_stack+21576, vrr_stack+38189, vrr_stack+21891);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21696, vrr_stack+13269, vrr_stack+3245, vrr_stack+2700, vrr_stack+16008, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21816, vrr_stack+38309, vrr_stack+21696, NULL, NULL, vrr_stack+13269);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+17179, vrr_stack+38429, vrr_stack+21816, vrr_stack+38069, vrr_stack+38309, vrr_stack+5061);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5061, vrr_stack+30617, vrr_stack+17179, vrr_stack+30257, vrr_stack+38429, vrr_stack+630);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+46679, vrr_stack+16459, vrr_stack+30617, vrr_stack+16099, vrr_stack+30257, vrr_stack+9816);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+9375, vrr_stack+46679, vrr_stack+5061, vrr_stack+16459, vrr_stack+30617, vrr_stack+1260);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+630, vrr_stack+25707, vrr_stack+19584, vrr_stack+4970, vrr_stack+2609, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+750, vrr_stack+630, vrr_stack+21576, NULL, NULL, vrr_stack+19584);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1110, vrr_stack+750, vrr_stack+16099, vrr_stack+630, vrr_stack+21576, vrr_stack+19689);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+47879, vrr_stack+1110, vrr_stack+16459, vrr_stack+750, vrr_stack+16099, vrr_stack+0);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49079, vrr_stack+47879, vrr_stack+46679, vrr_stack+1110, vrr_stack+16459, vrr_stack+35444);
   tmp = vrr_stack + 49079;
   target_ptr = Libint->vrr_classes[4][14];
   for(i=0;i<1800;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+35444, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+35447, vrr_stack+2791, vrr_stack+35444, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+35453, vrr_stack+2794, vrr_stack+35447, vrr_stack+15645, vrr_stack+2791, NULL);
 _BUILD_00g0(Data,vrr_stack+35463, vrr_stack+2800, vrr_stack+35453, vrr_stack+15648, vrr_stack+2794, NULL);
 _BUILD_00h0(Data,vrr_stack+35478, vrr_stack+2810, vrr_stack+35463, vrr_stack+15654, vrr_stack+2800, NULL);
 _BUILD_00i0(Data,vrr_stack+35499, vrr_stack+2825, vrr_stack+35478, vrr_stack+15664, vrr_stack+2810, NULL);
 _BUILD_00k0(Data,vrr_stack+35527, vrr_stack+2846, vrr_stack+35499, vrr_stack+15679, vrr_stack+2825, NULL);
 _BUILD_00l0(Data,vrr_stack+15645, vrr_stack+2874, vrr_stack+35527, vrr_stack+15700, vrr_stack+2846, NULL);
 _BUILD_00m0(Data,vrr_stack+35563, vrr_stack+2910, vrr_stack+15645, vrr_stack+15728, vrr_stack+2874, NULL);
 _BUILD_00n0(Data,vrr_stack+15690, vrr_stack+2955, vrr_stack+35563, vrr_stack+15764, vrr_stack+2910, NULL);
 _BUILD_00o0(Data,vrr_stack+35618, vrr_stack+3010, vrr_stack+15690, vrr_stack+15809, vrr_stack+2955, NULL);
 _BUILD_00q0(Data,vrr_stack+15756, vrr_stack+3076, vrr_stack+35618, vrr_stack+15864, vrr_stack+3010, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+35696, vrr_stack+3154, vrr_stack+15756, vrr_stack+15930, vrr_stack+3076, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+15847, vrr_stack+3245, vrr_stack+35696, vrr_stack+16008, vrr_stack+3154, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+35801, vrr_stack+21696, vrr_stack+15847, NULL, NULL, vrr_stack+3245);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+750, vrr_stack+21816, vrr_stack+35801, vrr_stack+38309, vrr_stack+21696, vrr_stack+3350);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1470, vrr_stack+17179, vrr_stack+750, vrr_stack+38429, vrr_stack+21816, vrr_stack+3665);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+50879, vrr_stack+5061, vrr_stack+1470, vrr_stack+30617, vrr_stack+17179, vrr_stack+25812);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+52679, vrr_stack+9375, vrr_stack+50879, vrr_stack+46679, vrr_stack+5061, vrr_stack+40694);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+55199, vrr_stack+49079, vrr_stack+9375, vrr_stack+47879, vrr_stack+46679, vrr_stack+36494);
   tmp = vrr_stack + 55199;
   target_ptr = Libint->vrr_classes[5][14];
   for(i=0;i<2520;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47879, vrr_stack+38069, vrr_stack+38309, vrr_stack+21261, vrr_stack+21471, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48015, vrr_stack+38189, vrr_stack+38069, vrr_stack+21366, vrr_stack+21261, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48151, vrr_stack+38309, vrr_stack+21696, vrr_stack+21471, vrr_stack+13269, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48287, vrr_stack+47879, vrr_stack+48151, NULL, NULL, vrr_stack+38309);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+40694, vrr_stack+48015, vrr_stack+47879, NULL, NULL, vrr_stack+38069);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+41102, vrr_stack+40694, vrr_stack+48287, vrr_stack+48015, vrr_stack+47879, vrr_stack+38429);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+38429, vrr_stack+21576, vrr_stack+38189, vrr_stack+19584, vrr_stack+21366, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+38565, vrr_stack+38429, vrr_stack+48015, NULL, NULL, vrr_stack+38189);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25812, vrr_stack+38565, vrr_stack+40694, vrr_stack+38429, vrr_stack+48015, vrr_stack+30257);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+30257, vrr_stack+21696, vrr_stack+15847, vrr_stack+13269, vrr_stack+3245, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+13269, vrr_stack+48151, vrr_stack+30257, NULL, NULL, vrr_stack+21696);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+26628, vrr_stack+48287, vrr_stack+13269, vrr_stack+47879, vrr_stack+48151, vrr_stack+21816);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+3350, vrr_stack+41102, vrr_stack+26628, vrr_stack+40694, vrr_stack+48287, vrr_stack+17179);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+57719, vrr_stack+25812, vrr_stack+41102, vrr_stack+38565, vrr_stack+40694, vrr_stack+30617);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+59079, vrr_stack+57719, vrr_stack+3350, vrr_stack+25812, vrr_stack+41102, vrr_stack+5061);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+17179, vrr_stack+630, vrr_stack+21576, vrr_stack+25707, vrr_stack+19584, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+17315, vrr_stack+17179, vrr_stack+38429, NULL, NULL, vrr_stack+21576);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+30393, vrr_stack+17315, vrr_stack+38565, vrr_stack+17179, vrr_stack+38429, vrr_stack+16099);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+4710, vrr_stack+30393, vrr_stack+25812, vrr_stack+17315, vrr_stack+38565, vrr_stack+16459);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+61119, vrr_stack+4710, vrr_stack+57719, vrr_stack+30393, vrr_stack+25812, vrr_stack+46679);
   tmp = vrr_stack + 61119;
   target_ptr = Libint->vrr_classes[4][15];
   for(i=0;i<2040;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+46679, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+46682, vrr_stack+35444, vrr_stack+46679, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+46688, vrr_stack+35447, vrr_stack+46682, vrr_stack+2791, vrr_stack+35444, NULL);
 _BUILD_00g0(Data,vrr_stack+46698, vrr_stack+35453, vrr_stack+46688, vrr_stack+2794, vrr_stack+35447, NULL);
 _BUILD_00h0(Data,vrr_stack+46713, vrr_stack+35463, vrr_stack+46698, vrr_stack+2800, vrr_stack+35453, NULL);
 _BUILD_00i0(Data,vrr_stack+46734, vrr_stack+35478, vrr_stack+46713, vrr_stack+2810, vrr_stack+35463, NULL);
 _BUILD_00k0(Data,vrr_stack+46762, vrr_stack+35499, vrr_stack+46734, vrr_stack+2825, vrr_stack+35478, NULL);
 _BUILD_00l0(Data,vrr_stack+46798, vrr_stack+35527, vrr_stack+46762, vrr_stack+2846, vrr_stack+35499, NULL);
 _BUILD_00m0(Data,vrr_stack+46843, vrr_stack+15645, vrr_stack+46798, vrr_stack+2874, vrr_stack+35527, NULL);
 _BUILD_00n0(Data,vrr_stack+46898, vrr_stack+35563, vrr_stack+46843, vrr_stack+2910, vrr_stack+15645, NULL);
 _BUILD_00o0(Data,vrr_stack+46964, vrr_stack+15690, vrr_stack+46898, vrr_stack+2955, vrr_stack+35563, NULL);
 _BUILD_00q0(Data,vrr_stack+47042, vrr_stack+35618, vrr_stack+46964, vrr_stack+3010, vrr_stack+15690, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25707, vrr_stack+15756, vrr_stack+47042, vrr_stack+3076, vrr_stack+35618, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+47133, vrr_stack+35696, vrr_stack+25707, vrr_stack+3154, vrr_stack+15756, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47253, vrr_stack+15847, vrr_stack+47133, vrr_stack+3245, vrr_stack+35696, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47389, vrr_stack+30257, vrr_stack+47253, NULL, NULL, vrr_stack+15847);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+30393, vrr_stack+13269, vrr_stack+47389, vrr_stack+48151, vrr_stack+30257, vrr_stack+35801);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+63159, vrr_stack+26628, vrr_stack+30393, vrr_stack+48287, vrr_stack+13269, vrr_stack+750);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+64519, vrr_stack+3350, vrr_stack+63159, vrr_stack+41102, vrr_stack+26628, vrr_stack+1470);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+66559, vrr_stack+59079, vrr_stack+64519, vrr_stack+57719, vrr_stack+3350, vrr_stack+50879);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+69415, vrr_stack+61119, vrr_stack+59079, vrr_stack+4710, vrr_stack+57719, vrr_stack+9375);
   tmp = vrr_stack + 69415;
   target_ptr = Libint->vrr_classes[5][15];
   for(i=0;i<2856;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+4710, vrr_stack+47879, vrr_stack+48151, vrr_stack+38069, vrr_stack+38309, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+4863, vrr_stack+48015, vrr_stack+47879, vrr_stack+38189, vrr_stack+38069, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+5016, vrr_stack+48151, vrr_stack+30257, vrr_stack+38309, vrr_stack+21696, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+5169, vrr_stack+4710, vrr_stack+5016, NULL, NULL, vrr_stack+48151);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+5628, vrr_stack+4863, vrr_stack+4710, NULL, NULL, vrr_stack+47879);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+50879, vrr_stack+5628, vrr_stack+5169, vrr_stack+4863, vrr_stack+4710, vrr_stack+48287);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+48287, vrr_stack+38429, vrr_stack+48015, vrr_stack+21576, vrr_stack+38189, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+48440, vrr_stack+48287, vrr_stack+4863, NULL, NULL, vrr_stack+48015);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+750, vrr_stack+48440, vrr_stack+5628, vrr_stack+48287, vrr_stack+4863, vrr_stack+40694);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+40694, vrr_stack+30257, vrr_stack+47253, vrr_stack+21696, vrr_stack+15847, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+21696, vrr_stack+5016, vrr_stack+40694, NULL, NULL, vrr_stack+30257);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+1668, vrr_stack+5169, vrr_stack+21696, vrr_stack+4710, vrr_stack+5016, vrr_stack+13269);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+72271, vrr_stack+50879, vrr_stack+1668, vrr_stack+5628, vrr_stack+5169, vrr_stack+26628);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+73801, vrr_stack+750, vrr_stack+50879, vrr_stack+48440, vrr_stack+5628, vrr_stack+41102);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+75331, vrr_stack+73801, vrr_stack+72271, vrr_stack+750, vrr_stack+50879, vrr_stack+3350);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+26628, vrr_stack+17179, vrr_stack+38429, vrr_stack+630, vrr_stack+21576, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+26781, vrr_stack+26628, vrr_stack+48287, NULL, NULL, vrr_stack+38429);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+13269, vrr_stack+26781, vrr_stack+48440, vrr_stack+26628, vrr_stack+48287, vrr_stack+38565);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2586, vrr_stack+13269, vrr_stack+750, vrr_stack+26781, vrr_stack+48440, vrr_stack+25812);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+77626, vrr_stack+2586, vrr_stack+73801, vrr_stack+13269, vrr_stack+750, vrr_stack+57719);
   tmp = vrr_stack + 77626;
   target_ptr = Libint->vrr_classes[4][16];
   for(i=0;i<2295;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+57719, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+57722, vrr_stack+46679, vrr_stack+57719, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+57728, vrr_stack+46682, vrr_stack+57722, vrr_stack+35444, vrr_stack+46679, NULL);
 _BUILD_00g0(Data,vrr_stack+57738, vrr_stack+46688, vrr_stack+57728, vrr_stack+35447, vrr_stack+46682, NULL);
 _BUILD_00h0(Data,vrr_stack+57753, vrr_stack+46698, vrr_stack+57738, vrr_stack+35453, vrr_stack+46688, NULL);
 _BUILD_00i0(Data,vrr_stack+57774, vrr_stack+46713, vrr_stack+57753, vrr_stack+35463, vrr_stack+46698, NULL);
 _BUILD_00k0(Data,vrr_stack+57802, vrr_stack+46734, vrr_stack+57774, vrr_stack+35478, vrr_stack+46713, NULL);
 _BUILD_00l0(Data,vrr_stack+35444, vrr_stack+46762, vrr_stack+57802, vrr_stack+35499, vrr_stack+46734, NULL);
 _BUILD_00m0(Data,vrr_stack+57838, vrr_stack+46798, vrr_stack+35444, vrr_stack+35527, vrr_stack+46762, NULL);
 _BUILD_00n0(Data,vrr_stack+35489, vrr_stack+46843, vrr_stack+57838, vrr_stack+15645, vrr_stack+46798, NULL);
 _BUILD_00o0(Data,vrr_stack+57893, vrr_stack+46898, vrr_stack+35489, vrr_stack+35563, vrr_stack+46843, NULL);
 _BUILD_00q0(Data,vrr_stack+57971, vrr_stack+46964, vrr_stack+57893, vrr_stack+15690, vrr_stack+46898, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15645, vrr_stack+47042, vrr_stack+57971, vrr_stack+35618, vrr_stack+46964, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+35555, vrr_stack+25707, vrr_stack+15645, vrr_stack+15756, vrr_stack+47042, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+58062, vrr_stack+47133, vrr_stack+35555, vrr_stack+35696, vrr_stack+25707, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+35675, vrr_stack+47253, vrr_stack+58062, vrr_stack+15847, vrr_stack+47133, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+15750, vrr_stack+40694, vrr_stack+35675, NULL, NULL, vrr_stack+47253);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+16209, vrr_stack+21696, vrr_stack+15750, vrr_stack+5016, vrr_stack+40694, vrr_stack+47389);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+79921, vrr_stack+1668, vrr_stack+16209, vrr_stack+5169, vrr_stack+21696, vrr_stack+30393);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+81451, vrr_stack+72271, vrr_stack+79921, vrr_stack+50879, vrr_stack+1668, vrr_stack+63159);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+83746, vrr_stack+75331, vrr_stack+81451, vrr_stack+73801, vrr_stack+72271, vrr_stack+64519);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+63159, vrr_stack+77626, vrr_stack+75331, vrr_stack+2586, vrr_stack+73801, vrr_stack+59079);
   tmp = vrr_stack + 63159;
   target_ptr = Libint->vrr_classes[5][16];
   for(i=0;i<3213;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2586, vrr_stack+4710, vrr_stack+5016, vrr_stack+47879, vrr_stack+48151, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2757, vrr_stack+4863, vrr_stack+4710, vrr_stack+48015, vrr_stack+47879, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2928, vrr_stack+5016, vrr_stack+40694, vrr_stack+48151, vrr_stack+30257, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+3099, vrr_stack+2586, vrr_stack+2928, NULL, NULL, vrr_stack+5016);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+3612, vrr_stack+2757, vrr_stack+2586, NULL, NULL, vrr_stack+4710);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+30393, vrr_stack+3612, vrr_stack+3099, vrr_stack+2757, vrr_stack+2586, vrr_stack+5169);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+5169, vrr_stack+48287, vrr_stack+4863, vrr_stack+38429, vrr_stack+48015, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+4125, vrr_stack+5169, vrr_stack+2757, NULL, NULL, vrr_stack+4863);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+40847, vrr_stack+4125, vrr_stack+3612, vrr_stack+5169, vrr_stack+2757, vrr_stack+5628);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+5340, vrr_stack+40694, vrr_stack+35675, vrr_stack+30257, vrr_stack+47253, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+5511, vrr_stack+2928, vrr_stack+5340, NULL, NULL, vrr_stack+40694);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+86959, vrr_stack+3099, vrr_stack+5511, vrr_stack+2586, vrr_stack+2928, vrr_stack+21696);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+87985, vrr_stack+30393, vrr_stack+86959, vrr_stack+3612, vrr_stack+3099, vrr_stack+1668);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+89695, vrr_stack+40847, vrr_stack+30393, vrr_stack+4125, vrr_stack+3612, vrr_stack+50879);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+91405, vrr_stack+89695, vrr_stack+87985, vrr_stack+40847, vrr_stack+30393, vrr_stack+72271);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72271, vrr_stack+26628, vrr_stack+48287, vrr_stack+17179, vrr_stack+38429, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72442, vrr_stack+72271, vrr_stack+5169, NULL, NULL, vrr_stack+48287);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+50879, vrr_stack+72442, vrr_stack+4125, vrr_stack+72271, vrr_stack+5169, vrr_stack+48440);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+93970, vrr_stack+50879, vrr_stack+40847, vrr_stack+72442, vrr_stack+4125, vrr_stack+750);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+93970, vrr_stack+89695, vrr_stack+50879, vrr_stack+40847, vrr_stack+73801);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[4][17];
   for(i=0;i<2565;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+50879, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50882, vrr_stack+57719, vrr_stack+50879, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+50888, vrr_stack+57722, vrr_stack+50882, vrr_stack+46679, vrr_stack+57719, NULL);
 _BUILD_00g0(Data,vrr_stack+50898, vrr_stack+57728, vrr_stack+50888, vrr_stack+46682, vrr_stack+57722, NULL);
 _BUILD_00h0(Data,vrr_stack+2565, vrr_stack+57738, vrr_stack+50898, vrr_stack+46688, vrr_stack+57728, NULL);
 _BUILD_00i0(Data,vrr_stack+50913, vrr_stack+57753, vrr_stack+2565, vrr_stack+46698, vrr_stack+57738, NULL);
 _BUILD_00k0(Data,vrr_stack+50941, vrr_stack+57774, vrr_stack+50913, vrr_stack+46713, vrr_stack+57753, NULL);
 _BUILD_00l0(Data,vrr_stack+46679, vrr_stack+57802, vrr_stack+50941, vrr_stack+46734, vrr_stack+57774, NULL);
 _BUILD_00m0(Data,vrr_stack+50977, vrr_stack+35444, vrr_stack+46679, vrr_stack+46762, vrr_stack+57802, NULL);
 _BUILD_00n0(Data,vrr_stack+46724, vrr_stack+57838, vrr_stack+50977, vrr_stack+46798, vrr_stack+35444, NULL);
 _BUILD_00o0(Data,vrr_stack+51032, vrr_stack+35489, vrr_stack+46724, vrr_stack+46843, vrr_stack+57838, NULL);
 _BUILD_00q0(Data,vrr_stack+46790, vrr_stack+57893, vrr_stack+51032, vrr_stack+46898, vrr_stack+35489, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+51110, vrr_stack+57971, vrr_stack+46790, vrr_stack+46964, vrr_stack+57893, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+46881, vrr_stack+15645, vrr_stack+51110, vrr_stack+47042, vrr_stack+57971, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+30257, vrr_stack+35555, vrr_stack+46881, vrr_stack+25707, vrr_stack+15645, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+25707, vrr_stack+58062, vrr_stack+30257, vrr_stack+47133, vrr_stack+35555, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+25860, vrr_stack+35675, vrr_stack+25707, vrr_stack+47253, vrr_stack+58062, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+26031, vrr_stack+5340, vrr_stack+25860, NULL, NULL, vrr_stack+35675);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+47001, vrr_stack+5511, vrr_stack+26031, vrr_stack+2928, vrr_stack+5340, vrr_stack+15750);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72442, vrr_stack+86959, vrr_stack+47001, vrr_stack+3099, vrr_stack+5511, vrr_stack+16209);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+95680, vrr_stack+87985, vrr_stack+72442, vrr_stack+30393, vrr_stack+86959, vrr_stack+79921);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+98245, vrr_stack+91405, vrr_stack+95680, vrr_stack+89695, vrr_stack+87985, vrr_stack+81451);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+79921, vrr_stack+0, vrr_stack+91405, vrr_stack+93970, vrr_stack+89695, vrr_stack+75331);
   tmp = vrr_stack + 79921;
   target_ptr = Libint->vrr_classes[5][17];
   for(i=0;i<3591;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+93970, vrr_stack+2586, vrr_stack+2928, vrr_stack+4710, vrr_stack+5016, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+94160, vrr_stack+2757, vrr_stack+2586, vrr_stack+4863, vrr_stack+4710, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+94350, vrr_stack+2928, vrr_stack+5340, vrr_stack+5016, vrr_stack+40694, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+94540, vrr_stack+93970, vrr_stack+94350, NULL, NULL, vrr_stack+2928);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+95110, vrr_stack+94160, vrr_stack+93970, NULL, NULL, vrr_stack+2586);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+15750, vrr_stack+95110, vrr_stack+94540, vrr_stack+94160, vrr_stack+93970, vrr_stack+3099);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+2928, vrr_stack+5169, vrr_stack+2757, vrr_stack+48287, vrr_stack+4863, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+16890, vrr_stack+2928, vrr_stack+94160, NULL, NULL, vrr_stack+2757);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+51215, vrr_stack+16890, vrr_stack+95110, vrr_stack+2928, vrr_stack+94160, vrr_stack+3612);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+94160, vrr_stack+5340, vrr_stack+25860, vrr_stack+40694, vrr_stack+35675, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+3118, vrr_stack+94350, vrr_stack+94160, NULL, NULL, vrr_stack+5340);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+74152, vrr_stack+94540, vrr_stack+3118, vrr_stack+93970, vrr_stack+94350, vrr_stack+5511);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+101836, vrr_stack+15750, vrr_stack+74152, vrr_stack+95110, vrr_stack+94540, vrr_stack+86959);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+103736, vrr_stack+51215, vrr_stack+15750, vrr_stack+16890, vrr_stack+95110, vrr_stack+30393);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+105636, vrr_stack+103736, vrr_stack+101836, vrr_stack+51215, vrr_stack+15750, vrr_stack+87985);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+93970, vrr_stack+72271, vrr_stack+5169, vrr_stack+26628, vrr_stack+48287, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+95110, vrr_stack+93970, vrr_stack+2928, NULL, NULL, vrr_stack+5169);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+30393, vrr_stack+95110, vrr_stack+16890, vrr_stack+93970, vrr_stack+2928, vrr_stack+4125);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+86959, vrr_stack+30393, vrr_stack+51215, vrr_stack+95110, vrr_stack+16890, vrr_stack+40847);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+108486, vrr_stack+86959, vrr_stack+103736, vrr_stack+30393, vrr_stack+51215, vrr_stack+89695);
   tmp = vrr_stack + 108486;
   target_ptr = Libint->vrr_classes[4][18];
   for(i=0;i<2850;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+51215, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+51218, vrr_stack+50879, vrr_stack+51215, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+51224, vrr_stack+50882, vrr_stack+51218, vrr_stack+57719, vrr_stack+50879, NULL);
 _BUILD_00g0(Data,vrr_stack+51234, vrr_stack+50888, vrr_stack+51224, vrr_stack+57722, vrr_stack+50882, NULL);
 _BUILD_00h0(Data,vrr_stack+51249, vrr_stack+50898, vrr_stack+51234, vrr_stack+57728, vrr_stack+50888, NULL);
 _BUILD_00i0(Data,vrr_stack+51215, vrr_stack+2565, vrr_stack+51249, vrr_stack+57738, vrr_stack+50898, NULL);
 _BUILD_00k0(Data,vrr_stack+51243, vrr_stack+50913, vrr_stack+51215, vrr_stack+57753, vrr_stack+2565, NULL);
 _BUILD_00l0(Data,vrr_stack+2565, vrr_stack+50941, vrr_stack+51243, vrr_stack+57774, vrr_stack+50913, NULL);
 _BUILD_00m0(Data,vrr_stack+2610, vrr_stack+46679, vrr_stack+2565, vrr_stack+57802, vrr_stack+50941, NULL);
 _BUILD_00n0(Data,vrr_stack+2665, vrr_stack+50977, vrr_stack+2610, vrr_stack+35444, vrr_stack+46679, NULL);
 _BUILD_00o0(Data,vrr_stack+2565, vrr_stack+46724, vrr_stack+2665, vrr_stack+57838, vrr_stack+50977, NULL);
 _BUILD_00q0(Data,vrr_stack+2643, vrr_stack+51032, vrr_stack+2565, vrr_stack+35489, vrr_stack+46724, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+46679, vrr_stack+46790, vrr_stack+2643, vrr_stack+57893, vrr_stack+51032, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2565, vrr_stack+51110, vrr_stack+46679, vrr_stack+57971, vrr_stack+46790, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+46679, vrr_stack+46881, vrr_stack+2565, vrr_stack+15645, vrr_stack+51110, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2565, vrr_stack+30257, vrr_stack+46679, vrr_stack+35555, vrr_stack+46881, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72271, vrr_stack+25707, vrr_stack+2565, vrr_stack+58062, vrr_stack+30257, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+93970, vrr_stack+25860, vrr_stack+72271, vrr_stack+35675, vrr_stack+25707, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+95110, vrr_stack+94160, vrr_stack+93970, NULL, NULL, vrr_stack+25860);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+30257, vrr_stack+3118, vrr_stack+95110, vrr_stack+94350, vrr_stack+94160, vrr_stack+26031);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+88859, vrr_stack+74152, vrr_stack+30257, vrr_stack+94540, vrr_stack+3118, vrr_stack+47001);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+2565, vrr_stack+101836, vrr_stack+88859, vrr_stack+15750, vrr_stack+74152, vrr_stack+72442);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+111336, vrr_stack+105636, vrr_stack+2565, vrr_stack+103736, vrr_stack+101836, vrr_stack+95680);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+93970, vrr_stack+108486, vrr_stack+105636, vrr_stack+86959, vrr_stack+103736, vrr_stack+91405);
   tmp = vrr_stack + 93970;
   target_ptr = Libint->vrr_classes[5][18];
   for(i=0;i<3990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+86959, vrr_stack+6401, vrr_stack+14259, vrr_stack+12279, vrr_stack+11289, vrr_stack+8220);
   tmp = vrr_stack + 86959;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0o0(Data,vrr_stack+88807, vrr_stack+24069, vrr_stack+22431, vrr_stack+20091, vrr_stack+18141, vrr_stack+14259);
   tmp = vrr_stack + 88807;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0q0(Data,vrr_stack+24069, vrr_stack+33533, vrr_stack+31622, vrr_stack+28892, vrr_stack+27527, vrr_stack+22431);
   tmp = vrr_stack + 24069;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+33533, vrr_stack+44474, vrr_stack+42269, vrr_stack+39119, vrr_stack+36494, vrr_stack+31622);
   tmp = vrr_stack + 33533;
   target_ptr = Libint->vrr_classes[6][13];
   for(i=0;i<2940;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+44474, vrr_stack+55199, vrr_stack+52679, vrr_stack+49079, vrr_stack+9375, vrr_stack+42269);
   tmp = vrr_stack + 44474;
   target_ptr = Libint->vrr_classes[6][14];
   for(i=0;i<3360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+55199, vrr_stack+69415, vrr_stack+66559, vrr_stack+61119, vrr_stack+59079, vrr_stack+52679);
   tmp = vrr_stack + 55199;
   target_ptr = Libint->vrr_classes[6][15];
   for(i=0;i<3808;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+69415, vrr_stack+63159, vrr_stack+83746, vrr_stack+77626, vrr_stack+75331, vrr_stack+66559);
   tmp = vrr_stack + 69415;
   target_ptr = Libint->vrr_classes[6][16];
   for(i=0;i<4284;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+73699, vrr_stack+79921, vrr_stack+98245, vrr_stack+0, vrr_stack+91405, vrr_stack+83746);
   tmp = vrr_stack + 73699;
   target_ptr = Libint->vrr_classes[6][17];
   for(i=0;i<4788;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+93970, vrr_stack+111336, vrr_stack+108486, vrr_stack+105636, vrr_stack+98245);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[6][18];
   for(i=0;i<5320;i++)
     target_ptr[i] += tmp[i];

}

