/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hh|hh) integrals */

void vrr_order_hhhh(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+6, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+7, Data->F+8, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_f000(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_p000(Data,vrr_stack+31, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_f000(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p000(Data,vrr_stack+50, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+53, vrr_stack+6, vrr_stack+50, Data->F+8, Data->F+9, NULL);
 _BUILD_f000(Data,vrr_stack+59, vrr_stack+9, vrr_stack+53, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_g000(Data,vrr_stack+69, vrr_stack+21, vrr_stack+59, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_g000(Data,vrr_stack+84, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_h000(Data,vrr_stack+99, vrr_stack+84, vrr_stack+69, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+120, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+123, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+126, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+129, vrr_stack+120, vrr_stack+126, NULL, NULL, Data->F+8);
 _BUILD_p0p0(Data,vrr_stack+138, vrr_stack+123, vrr_stack+120, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+147, vrr_stack+138, vrr_stack+129, vrr_stack+123, vrr_stack+120, vrr_stack+0);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+165, vrr_stack+0, vrr_stack+123, NULL, NULL, Data->F+6);
 _BUILD_d0p0(Data,vrr_stack+174, vrr_stack+165, vrr_stack+138, vrr_stack+0, vrr_stack+123, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+192, vrr_stack+126, vrr_stack+3, NULL, NULL, Data->F+9);
 _BUILD_d0p0(Data,vrr_stack+201, vrr_stack+129, vrr_stack+192, vrr_stack+120, vrr_stack+126, vrr_stack+6);
 _BUILD_f0p0(Data,vrr_stack+219, vrr_stack+147, vrr_stack+201, vrr_stack+138, vrr_stack+129, vrr_stack+9);
 _BUILD_f0p0(Data,vrr_stack+249, vrr_stack+174, vrr_stack+147, vrr_stack+165, vrr_stack+138, vrr_stack+15);
 _BUILD_g0p0(Data,vrr_stack+279, vrr_stack+249, vrr_stack+219, vrr_stack+174, vrr_stack+147, vrr_stack+21);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+9, vrr_stack+6, vrr_stack+0, NULL, NULL, Data->F+5);
 _BUILD_d0p0(Data,vrr_stack+324, vrr_stack+9, vrr_stack+165, vrr_stack+6, vrr_stack+0, vrr_stack+31);
 _BUILD_f0p0(Data,vrr_stack+342, vrr_stack+324, vrr_stack+174, vrr_stack+9, vrr_stack+165, vrr_stack+34);
 _BUILD_g0p0(Data,vrr_stack+372, vrr_stack+342, vrr_stack+249, vrr_stack+324, vrr_stack+174, vrr_stack+40);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+3, vrr_stack+18, NULL, NULL, Data->F+10);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+192, vrr_stack+21, vrr_stack+126, vrr_stack+3, vrr_stack+50);
 _BUILD_f0p0(Data,vrr_stack+417, vrr_stack+201, vrr_stack+30, vrr_stack+129, vrr_stack+192, vrr_stack+53);
 _BUILD_g0p0(Data,vrr_stack+447, vrr_stack+219, vrr_stack+417, vrr_stack+147, vrr_stack+201, vrr_stack+59);
 _BUILD_h0p0(Data,vrr_stack+492, vrr_stack+279, vrr_stack+447, vrr_stack+249, vrr_stack+219, vrr_stack+69);
 _BUILD_h0p0(Data,vrr_stack+555, vrr_stack+372, vrr_stack+279, vrr_stack+342, vrr_stack+249, vrr_stack+84);
 _BUILD_i0p0(Data,vrr_stack+618, vrr_stack+555, vrr_stack+492, vrr_stack+372, vrr_stack+279, vrr_stack+99);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+120, vrr_stack+126, Data->F+7, Data->F+8, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+123, vrr_stack+120, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+120);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+123, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+123);
 _BUILD_00d0(Data,vrr_stack+102, vrr_stack+126, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+702, vrr_stack+48, vrr_stack+102, NULL, NULL, vrr_stack+126);
 _BUILD_d0d0(Data,vrr_stack+720, vrr_stack+60, vrr_stack+702, vrr_stack+54, vrr_stack+48, vrr_stack+129);
 _BUILD_d0d0(Data,vrr_stack+756, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+138);
 _BUILD_f0d0(Data,vrr_stack+792, vrr_stack+756, vrr_stack+720, vrr_stack+84, vrr_stack+60, vrr_stack+147);
 _BUILD_00d0(Data,vrr_stack+129, vrr_stack+6, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_p0d0(Data,vrr_stack+135, vrr_stack+129, vrr_stack+78, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+852, vrr_stack+135, vrr_stack+84, vrr_stack+129, vrr_stack+78, vrr_stack+165);
 _BUILD_f0d0(Data,vrr_stack+888, vrr_stack+852, vrr_stack+756, vrr_stack+135, vrr_stack+84, vrr_stack+174);
 _BUILD_00d0(Data,vrr_stack+153, vrr_stack+3, vrr_stack+18, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+159, vrr_stack+102, vrr_stack+153, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+948, vrr_stack+702, vrr_stack+159, vrr_stack+48, vrr_stack+102, vrr_stack+192);
 _BUILD_f0d0(Data,vrr_stack+984, vrr_stack+720, vrr_stack+948, vrr_stack+60, vrr_stack+702, vrr_stack+201);
 _BUILD_g0d0(Data,vrr_stack+1044, vrr_stack+792, vrr_stack+984, vrr_stack+756, vrr_stack+720, vrr_stack+219);
 _BUILD_g0d0(Data,vrr_stack+1134, vrr_stack+888, vrr_stack+792, vrr_stack+852, vrr_stack+756, vrr_stack+249);
 _BUILD_h0d0(Data,vrr_stack+1224, vrr_stack+1134, vrr_stack+1044, vrr_stack+888, vrr_stack+792, vrr_stack+279);
 _BUILD_00p0(Data,vrr_stack+177, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+180, vrr_stack+177, vrr_stack+6, Data->F+3, Data->F+4, NULL);
 _BUILD_p0d0(Data,vrr_stack+186, vrr_stack+180, vrr_stack+129, NULL, NULL, vrr_stack+6);
 _BUILD_d0d0(Data,vrr_stack+204, vrr_stack+186, vrr_stack+135, vrr_stack+180, vrr_stack+129, vrr_stack+9);
 _BUILD_f0d0(Data,vrr_stack+240, vrr_stack+204, vrr_stack+852, vrr_stack+186, vrr_stack+135, vrr_stack+324);
 _BUILD_g0d0(Data,vrr_stack+1350, vrr_stack+240, vrr_stack+888, vrr_stack+204, vrr_stack+852, vrr_stack+342);
 _BUILD_h0d0(Data,vrr_stack+1440, vrr_stack+1350, vrr_stack+1134, vrr_stack+240, vrr_stack+888, vrr_stack+372);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+18, vrr_stack+9, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+300, vrr_stack+153, vrr_stack+12, NULL, NULL, vrr_stack+18);
 _BUILD_d0d0(Data,vrr_stack+318, vrr_stack+159, vrr_stack+300, vrr_stack+102, vrr_stack+153, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+354, vrr_stack+948, vrr_stack+318, vrr_stack+702, vrr_stack+159, vrr_stack+30);
 _BUILD_g0d0(Data,vrr_stack+1566, vrr_stack+984, vrr_stack+354, vrr_stack+720, vrr_stack+948, vrr_stack+417);
 _BUILD_h0d0(Data,vrr_stack+1656, vrr_stack+1044, vrr_stack+1566, vrr_stack+792, vrr_stack+984, vrr_stack+447);
 _BUILD_i0d0(Data,vrr_stack+1782, vrr_stack+1224, vrr_stack+1656, vrr_stack+1134, vrr_stack+1044, vrr_stack+492);
 _BUILD_i0d0(Data,vrr_stack+1950, vrr_stack+1440, vrr_stack+1224, vrr_stack+1350, vrr_stack+1134, vrr_stack+555);
 _BUILD_k0d0(Data,vrr_stack+2118, vrr_stack+1950, vrr_stack+1782, vrr_stack+1440, vrr_stack+1224, vrr_stack+618);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+54, vrr_stack+48, vrr_stack+123, vrr_stack+120, NULL);
 _BUILD_00f0(Data,vrr_stack+31, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_00f0(Data,vrr_stack+414, vrr_stack+48, vrr_stack+102, vrr_stack+120, vrr_stack+126, NULL);
 _BUILD_p0f0(Data,vrr_stack+424, vrr_stack+21, vrr_stack+414, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+454, vrr_stack+31, vrr_stack+21, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+484, vrr_stack+454, vrr_stack+424, vrr_stack+31, vrr_stack+21, vrr_stack+60);
 _BUILD_00f0(Data,vrr_stack+60, vrr_stack+129, vrr_stack+78, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+544, vrr_stack+60, vrr_stack+31, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+574, vrr_stack+544, vrr_stack+454, vrr_stack+60, vrr_stack+31, vrr_stack+84);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+102, vrr_stack+153, vrr_stack+126, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+634, vrr_stack+414, vrr_stack+84, NULL, NULL, vrr_stack+102);
 _BUILD_d0f0(Data,vrr_stack+2334, vrr_stack+424, vrr_stack+634, vrr_stack+21, vrr_stack+414, vrr_stack+702);
 _BUILD_f0f0(Data,vrr_stack+2394, vrr_stack+484, vrr_stack+2334, vrr_stack+454, vrr_stack+424, vrr_stack+720);
 _BUILD_f0f0(Data,vrr_stack+2494, vrr_stack+574, vrr_stack+484, vrr_stack+544, vrr_stack+454, vrr_stack+756);
 _BUILD_g0f0(Data,vrr_stack+2594, vrr_stack+2494, vrr_stack+2394, vrr_stack+574, vrr_stack+484, vrr_stack+792);
 _BUILD_00f0(Data,vrr_stack+664, vrr_stack+180, vrr_stack+129, vrr_stack+177, vrr_stack+6, NULL);
 _BUILD_p0f0(Data,vrr_stack+674, vrr_stack+664, vrr_stack+60, NULL, NULL, vrr_stack+129);
 _BUILD_d0f0(Data,vrr_stack+704, vrr_stack+674, vrr_stack+544, vrr_stack+664, vrr_stack+60, vrr_stack+135);
 _BUILD_f0f0(Data,vrr_stack+2744, vrr_stack+704, vrr_stack+574, vrr_stack+674, vrr_stack+544, vrr_stack+852);
 _BUILD_g0f0(Data,vrr_stack+2844, vrr_stack+2744, vrr_stack+2494, vrr_stack+704, vrr_stack+574, vrr_stack+888);
 _BUILD_00f0(Data,vrr_stack+135, vrr_stack+153, vrr_stack+12, vrr_stack+3, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+764, vrr_stack+84, vrr_stack+135, NULL, NULL, vrr_stack+153);
 _BUILD_d0f0(Data,vrr_stack+794, vrr_stack+634, vrr_stack+764, vrr_stack+414, vrr_stack+84, vrr_stack+159);
 _BUILD_f0f0(Data,vrr_stack+2994, vrr_stack+2334, vrr_stack+794, vrr_stack+424, vrr_stack+634, vrr_stack+948);
 _BUILD_g0f0(Data,vrr_stack+3094, vrr_stack+2394, vrr_stack+2994, vrr_stack+484, vrr_stack+2334, vrr_stack+984);
 _BUILD_h0f0(Data,vrr_stack+3244, vrr_stack+2594, vrr_stack+3094, vrr_stack+2494, vrr_stack+2394, vrr_stack+1044);
 _BUILD_h0f0(Data,vrr_stack+854, vrr_stack+2844, vrr_stack+2594, vrr_stack+2744, vrr_stack+2494, vrr_stack+1134);
 _BUILD_i0f0(Data,vrr_stack+3454, vrr_stack+854, vrr_stack+3244, vrr_stack+2844, vrr_stack+2594, vrr_stack+1224);
 _BUILD_00p0(Data,vrr_stack+159, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+162, vrr_stack+159, vrr_stack+177, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+1064, vrr_stack+162, vrr_stack+180, vrr_stack+159, vrr_stack+177, NULL);
 _BUILD_p0f0(Data,vrr_stack+1074, vrr_stack+1064, vrr_stack+664, NULL, NULL, vrr_stack+180);
 _BUILD_d0f0(Data,vrr_stack+1104, vrr_stack+1074, vrr_stack+674, vrr_stack+1064, vrr_stack+664, vrr_stack+186);
 _BUILD_f0f0(Data,vrr_stack+1164, vrr_stack+1104, vrr_stack+704, vrr_stack+1074, vrr_stack+674, vrr_stack+204);
 _BUILD_g0f0(Data,vrr_stack+3734, vrr_stack+1164, vrr_stack+2744, vrr_stack+1104, vrr_stack+704, vrr_stack+240);
 _BUILD_h0f0(Data,vrr_stack+3884, vrr_stack+3734, vrr_stack+2844, vrr_stack+1164, vrr_stack+2744, vrr_stack+1350);
 _BUILD_i0f0(Data,vrr_stack+4094, vrr_stack+3884, vrr_stack+854, vrr_stack+3734, vrr_stack+2844, vrr_stack+1440);
 _BUILD_00p0(Data,vrr_stack+186, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+189, vrr_stack+9, vrr_stack+186, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+195, vrr_stack+12, vrr_stack+189, vrr_stack+18, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+205, vrr_stack+135, vrr_stack+195, NULL, NULL, vrr_stack+12);
 _BUILD_d0f0(Data,vrr_stack+235, vrr_stack+764, vrr_stack+205, vrr_stack+84, vrr_stack+135, vrr_stack+300);
 _BUILD_f0f0(Data,vrr_stack+1264, vrr_stack+794, vrr_stack+235, vrr_stack+634, vrr_stack+764, vrr_stack+318);
 _BUILD_g0f0(Data,vrr_stack+1364, vrr_stack+2994, vrr_stack+1264, vrr_stack+2334, vrr_stack+794, vrr_stack+354);
 _BUILD_h0f0(Data,vrr_stack+4374, vrr_stack+3094, vrr_stack+1364, vrr_stack+2394, vrr_stack+2994, vrr_stack+1566);
 _BUILD_i0f0(Data,vrr_stack+4584, vrr_stack+3244, vrr_stack+4374, vrr_stack+2594, vrr_stack+3094, vrr_stack+1656);
 _BUILD_k0f0(Data,vrr_stack+4864, vrr_stack+3454, vrr_stack+4584, vrr_stack+854, vrr_stack+3244, vrr_stack+1782);
 _BUILD_k0f0(Data,vrr_stack+1514, vrr_stack+4094, vrr_stack+3454, vrr_stack+3884, vrr_stack+854, vrr_stack+1950);
 _BUILD_l0f0(Data,vrr_stack+5224, vrr_stack+1514, vrr_stack+4864, vrr_stack+4094, vrr_stack+3454, vrr_stack+2118);
 _BUILD_00g0(Data,vrr_stack+295, vrr_stack+21, vrr_stack+414, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+310, vrr_stack+31, vrr_stack+21, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+325, vrr_stack+310, vrr_stack+295, NULL, NULL, vrr_stack+21);
 _BUILD_00g0(Data,vrr_stack+370, vrr_stack+60, vrr_stack+31, vrr_stack+129, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+1874, vrr_stack+370, vrr_stack+310, NULL, NULL, vrr_stack+31);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+414, vrr_stack+84, vrr_stack+48, vrr_stack+102, NULL);
 _BUILD_p0g0(Data,vrr_stack+1919, vrr_stack+295, vrr_stack+385, NULL, NULL, vrr_stack+414);
 _BUILD_d0g0(Data,vrr_stack+1964, vrr_stack+325, vrr_stack+1919, vrr_stack+310, vrr_stack+295, vrr_stack+424);
 _BUILD_d0g0(Data,vrr_stack+2054, vrr_stack+1874, vrr_stack+325, vrr_stack+370, vrr_stack+310, vrr_stack+454);
 _BUILD_f0g0(Data,vrr_stack+2144, vrr_stack+2054, vrr_stack+1964, vrr_stack+1874, vrr_stack+325, vrr_stack+484);
 _BUILD_00g0(Data,vrr_stack+424, vrr_stack+664, vrr_stack+60, vrr_stack+180, vrr_stack+129, NULL);
 _BUILD_p0g0(Data,vrr_stack+439, vrr_stack+424, vrr_stack+370, NULL, NULL, vrr_stack+60);
 _BUILD_d0g0(Data,vrr_stack+5674, vrr_stack+439, vrr_stack+1874, vrr_stack+424, vrr_stack+370, vrr_stack+544);
 _BUILD_f0g0(Data,vrr_stack+5764, vrr_stack+5674, vrr_stack+2054, vrr_stack+439, vrr_stack+1874, vrr_stack+574);
 _BUILD_00g0(Data,vrr_stack+484, vrr_stack+84, vrr_stack+135, vrr_stack+102, vrr_stack+153, NULL);
 _BUILD_p0g0(Data,vrr_stack+499, vrr_stack+385, vrr_stack+484, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+544, vrr_stack+1919, vrr_stack+499, vrr_stack+295, vrr_stack+385, vrr_stack+634);
 _BUILD_f0g0(Data,vrr_stack+5914, vrr_stack+1964, vrr_stack+544, vrr_stack+325, vrr_stack+1919, vrr_stack+2334);
 _BUILD_g0g0(Data,vrr_stack+6064, vrr_stack+2144, vrr_stack+5914, vrr_stack+2054, vrr_stack+1964, vrr_stack+2394);
 _BUILD_g0g0(Data,vrr_stack+6289, vrr_stack+5764, vrr_stack+2144, vrr_stack+5674, vrr_stack+2054, vrr_stack+2494);
 _BUILD_h0g0(Data,vrr_stack+6514, vrr_stack+6289, vrr_stack+6064, vrr_stack+5764, vrr_stack+2144, vrr_stack+2594);
 _BUILD_00g0(Data,vrr_stack+634, vrr_stack+1064, vrr_stack+664, vrr_stack+162, vrr_stack+180, NULL);
 _BUILD_p0g0(Data,vrr_stack+2294, vrr_stack+634, vrr_stack+424, NULL, NULL, vrr_stack+664);
 _BUILD_d0g0(Data,vrr_stack+2339, vrr_stack+2294, vrr_stack+439, vrr_stack+634, vrr_stack+424, vrr_stack+674);
 _BUILD_f0g0(Data,vrr_stack+2429, vrr_stack+2339, vrr_stack+5674, vrr_stack+2294, vrr_stack+439, vrr_stack+704);
 _BUILD_g0g0(Data,vrr_stack+6829, vrr_stack+2429, vrr_stack+5764, vrr_stack+2339, vrr_stack+5674, vrr_stack+2744);
 _BUILD_h0g0(Data,vrr_stack+7054, vrr_stack+6829, vrr_stack+6289, vrr_stack+2429, vrr_stack+5764, vrr_stack+2844);
 _BUILD_00g0(Data,vrr_stack+649, vrr_stack+135, vrr_stack+195, vrr_stack+153, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+674, vrr_stack+484, vrr_stack+649, NULL, NULL, vrr_stack+135);
 _BUILD_d0g0(Data,vrr_stack+2579, vrr_stack+499, vrr_stack+674, vrr_stack+385, vrr_stack+484, vrr_stack+764);
 _BUILD_f0g0(Data,vrr_stack+2669, vrr_stack+544, vrr_stack+2579, vrr_stack+1919, vrr_stack+499, vrr_stack+794);
 _BUILD_g0g0(Data,vrr_stack+7369, vrr_stack+5914, vrr_stack+2669, vrr_stack+1964, vrr_stack+544, vrr_stack+2994);
 _BUILD_h0g0(Data,vrr_stack+7594, vrr_stack+6064, vrr_stack+7369, vrr_stack+2144, vrr_stack+5914, vrr_stack+3094);
 _BUILD_i0g0(Data,vrr_stack+2819, vrr_stack+6514, vrr_stack+7594, vrr_stack+6289, vrr_stack+6064, vrr_stack+3244);
 _BUILD_i0g0(Data,vrr_stack+7909, vrr_stack+7054, vrr_stack+6514, vrr_stack+6829, vrr_stack+6289, vrr_stack+854);
 _BUILD_k0g0(Data,vrr_stack+8329, vrr_stack+7909, vrr_stack+2819, vrr_stack+7054, vrr_stack+6514, vrr_stack+3454);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+719, vrr_stack+18, vrr_stack+159, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+725, vrr_stack+719, vrr_stack+162, vrr_stack+18, vrr_stack+159, NULL);
 _BUILD_00g0(Data,vrr_stack+735, vrr_stack+725, vrr_stack+1064, vrr_stack+719, vrr_stack+162, NULL);
 _BUILD_p0g0(Data,vrr_stack+750, vrr_stack+735, vrr_stack+634, NULL, NULL, vrr_stack+1064);
 _BUILD_d0g0(Data,vrr_stack+795, vrr_stack+750, vrr_stack+2294, vrr_stack+735, vrr_stack+634, vrr_stack+1074);
 _BUILD_f0g0(Data,vrr_stack+885, vrr_stack+795, vrr_stack+2339, vrr_stack+750, vrr_stack+2294, vrr_stack+1104);
 _BUILD_g0g0(Data,vrr_stack+3239, vrr_stack+885, vrr_stack+2429, vrr_stack+795, vrr_stack+2339, vrr_stack+1164);
 _BUILD_h0g0(Data,vrr_stack+8869, vrr_stack+3239, vrr_stack+6829, vrr_stack+885, vrr_stack+2429, vrr_stack+3734);
 _BUILD_i0g0(Data,vrr_stack+3464, vrr_stack+8869, vrr_stack+7054, vrr_stack+3239, vrr_stack+6829, vrr_stack+3884);
 _BUILD_k0g0(Data,vrr_stack+9184, vrr_stack+3464, vrr_stack+7909, vrr_stack+8869, vrr_stack+7054, vrr_stack+4094);
 _BUILD_00p0(Data,vrr_stack+3884, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3887, vrr_stack+186, vrr_stack+3884, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+3893, vrr_stack+189, vrr_stack+3887, vrr_stack+9, vrr_stack+186, NULL);
 _BUILD_00g0(Data,vrr_stack+3903, vrr_stack+195, vrr_stack+3893, vrr_stack+12, vrr_stack+189, NULL);
 _BUILD_p0g0(Data,vrr_stack+3918, vrr_stack+649, vrr_stack+3903, NULL, NULL, vrr_stack+195);
 _BUILD_d0g0(Data,vrr_stack+3963, vrr_stack+674, vrr_stack+3918, vrr_stack+484, vrr_stack+649, vrr_stack+205);
 _BUILD_f0g0(Data,vrr_stack+4053, vrr_stack+2579, vrr_stack+3963, vrr_stack+499, vrr_stack+674, vrr_stack+235);
 _BUILD_g0g0(Data,vrr_stack+9724, vrr_stack+2669, vrr_stack+4053, vrr_stack+544, vrr_stack+2579, vrr_stack+1264);
 _BUILD_h0g0(Data,vrr_stack+9949, vrr_stack+7369, vrr_stack+9724, vrr_stack+5914, vrr_stack+2669, vrr_stack+1364);
 _BUILD_i0g0(Data,vrr_stack+1074, vrr_stack+7594, vrr_stack+9949, vrr_stack+6064, vrr_stack+7369, vrr_stack+4374);
 _BUILD_k0g0(Data,vrr_stack+10264, vrr_stack+2819, vrr_stack+1074, vrr_stack+6514, vrr_stack+7594, vrr_stack+4584);
 _BUILD_l0g0(Data,vrr_stack+10804, vrr_stack+8329, vrr_stack+10264, vrr_stack+7909, vrr_stack+2819, vrr_stack+4864);
 _BUILD_l0g0(Data,vrr_stack+4203, vrr_stack+9184, vrr_stack+8329, vrr_stack+3464, vrr_stack+7909, vrr_stack+1514);
 _BUILD_m0g0(Data,vrr_stack+11479, vrr_stack+4203, vrr_stack+10804, vrr_stack+9184, vrr_stack+8329, vrr_stack+5224);
 _BUILD_00h0(Data,vrr_stack+205, vrr_stack+310, vrr_stack+295, vrr_stack+31, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+226, vrr_stack+370, vrr_stack+310, vrr_stack+60, vrr_stack+31, NULL);
 _BUILD_00h0(Data,vrr_stack+31, vrr_stack+295, vrr_stack+385, vrr_stack+21, vrr_stack+414, NULL);
 _BUILD_p0h0(Data,vrr_stack+4878, vrr_stack+205, vrr_stack+31, NULL, NULL, vrr_stack+295);
 _BUILD_p0h0(Data,vrr_stack+4941, vrr_stack+226, vrr_stack+205, NULL, NULL, vrr_stack+310);
 _BUILD_d0h0(Data,vrr_stack+5004, vrr_stack+4941, vrr_stack+4878, vrr_stack+226, vrr_stack+205, vrr_stack+325);
 _BUILD_00h0(Data,vrr_stack+325, vrr_stack+424, vrr_stack+370, vrr_stack+664, vrr_stack+60, NULL);
 _BUILD_p0h0(Data,vrr_stack+5130, vrr_stack+325, vrr_stack+226, NULL, NULL, vrr_stack+370);
 _BUILD_d0h0(Data,vrr_stack+5193, vrr_stack+5130, vrr_stack+4941, vrr_stack+325, vrr_stack+226, vrr_stack+1874);
 _BUILD_00h0(Data,vrr_stack+346, vrr_stack+385, vrr_stack+484, vrr_stack+414, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+5319, vrr_stack+31, vrr_stack+346, NULL, NULL, vrr_stack+385);
 _BUILD_d0h0(Data,vrr_stack+5382, vrr_stack+4878, vrr_stack+5319, vrr_stack+205, vrr_stack+31, vrr_stack+1919);
 _BUILD_f0h0(Data,vrr_stack+1494, vrr_stack+5004, vrr_stack+5382, vrr_stack+4941, vrr_stack+4878, vrr_stack+1964);
 _BUILD_f0h0(Data,vrr_stack+1704, vrr_stack+5193, vrr_stack+5004, vrr_stack+5130, vrr_stack+4941, vrr_stack+2054);
 _BUILD_g0h0(Data,vrr_stack+12304, vrr_stack+1704, vrr_stack+1494, vrr_stack+5193, vrr_stack+5004, vrr_stack+2144);
 _BUILD_00h0(Data,vrr_stack+52, vrr_stack+634, vrr_stack+424, vrr_stack+1064, vrr_stack+664, NULL);
 _BUILD_p0h0(Data,vrr_stack+5508, vrr_stack+52, vrr_stack+325, NULL, NULL, vrr_stack+424);
 _BUILD_d0h0(Data,vrr_stack+1914, vrr_stack+5508, vrr_stack+5130, vrr_stack+52, vrr_stack+325, vrr_stack+439);
 _BUILD_f0h0(Data,vrr_stack+2040, vrr_stack+1914, vrr_stack+5193, vrr_stack+5508, vrr_stack+5130, vrr_stack+5674);
 _BUILD_g0h0(Data,vrr_stack+12619, vrr_stack+2040, vrr_stack+1704, vrr_stack+1914, vrr_stack+5193, vrr_stack+5764);
 _BUILD_00h0(Data,vrr_stack+439, vrr_stack+484, vrr_stack+649, vrr_stack+84, vrr_stack+135, NULL);
 _BUILD_p0h0(Data,vrr_stack+5571, vrr_stack+346, vrr_stack+439, NULL, NULL, vrr_stack+484);
 _BUILD_d0h0(Data,vrr_stack+5634, vrr_stack+5319, vrr_stack+5571, vrr_stack+31, vrr_stack+346, vrr_stack+499);
 _BUILD_f0h0(Data,vrr_stack+12934, vrr_stack+5382, vrr_stack+5634, vrr_stack+4878, vrr_stack+5319, vrr_stack+544);
 _BUILD_g0h0(Data,vrr_stack+13144, vrr_stack+1494, vrr_stack+12934, vrr_stack+5004, vrr_stack+5382, vrr_stack+5914);
 _BUILD_h0h0(Data,vrr_stack+13459, vrr_stack+12304, vrr_stack+13144, vrr_stack+1704, vrr_stack+1494, vrr_stack+6064);
 _BUILD_h0h0(Data,vrr_stack+5760, vrr_stack+12619, vrr_stack+12304, vrr_stack+2040, vrr_stack+1704, vrr_stack+6289);
 _BUILD_i0h0(Data,vrr_stack+13900, vrr_stack+5760, vrr_stack+13459, vrr_stack+12619, vrr_stack+12304, vrr_stack+6514);
 _BUILD_00h0(Data,vrr_stack+499, vrr_stack+735, vrr_stack+634, vrr_stack+725, vrr_stack+1064, NULL);
 _BUILD_p0h0(Data,vrr_stack+520, vrr_stack+499, vrr_stack+52, NULL, NULL, vrr_stack+634);
 _BUILD_d0h0(Data,vrr_stack+6201, vrr_stack+520, vrr_stack+5508, vrr_stack+499, vrr_stack+52, vrr_stack+2294);
 _BUILD_f0h0(Data,vrr_stack+6327, vrr_stack+6201, vrr_stack+1914, vrr_stack+520, vrr_stack+5508, vrr_stack+2339);
 _BUILD_g0h0(Data,vrr_stack+14488, vrr_stack+6327, vrr_stack+2040, vrr_stack+6201, vrr_stack+1914, vrr_stack+2429);
 _BUILD_h0h0(Data,vrr_stack+14803, vrr_stack+14488, vrr_stack+12619, vrr_stack+6327, vrr_stack+2040, vrr_stack+6829);
 _BUILD_i0h0(Data,vrr_stack+15244, vrr_stack+14803, vrr_stack+5760, vrr_stack+14488, vrr_stack+12619, vrr_stack+7054);
 _BUILD_00h0(Data,vrr_stack+583, vrr_stack+649, vrr_stack+3903, vrr_stack+135, vrr_stack+195, NULL);
 _BUILD_p0h0(Data,vrr_stack+73, vrr_stack+439, vrr_stack+583, NULL, NULL, vrr_stack+649);
 _BUILD_d0h0(Data,vrr_stack+6537, vrr_stack+5571, vrr_stack+73, vrr_stack+346, vrr_stack+439, vrr_stack+674);
 _BUILD_f0h0(Data,vrr_stack+6663, vrr_stack+5634, vrr_stack+6537, vrr_stack+5319, vrr_stack+5571, vrr_stack+2579);
 _BUILD_g0h0(Data,vrr_stack+6873, vrr_stack+12934, vrr_stack+6663, vrr_stack+5382, vrr_stack+5634, vrr_stack+2669);
 _BUILD_h0h0(Data,vrr_stack+2250, vrr_stack+13144, vrr_stack+6873, vrr_stack+1494, vrr_stack+12934, vrr_stack+7369);
 _BUILD_i0h0(Data,vrr_stack+15832, vrr_stack+13459, vrr_stack+2250, vrr_stack+12304, vrr_stack+13144, vrr_stack+7594);
 _BUILD_k0h0(Data,vrr_stack+16420, vrr_stack+13900, vrr_stack+15832, vrr_stack+5760, vrr_stack+13459, vrr_stack+2819);
 _BUILD_k0h0(Data,vrr_stack+17176, vrr_stack+15244, vrr_stack+13900, vrr_stack+14803, vrr_stack+5760, vrr_stack+7909);
 _BUILD_l0h0(Data,vrr_stack+7188, vrr_stack+17176, vrr_stack+16420, vrr_stack+15244, vrr_stack+13900, vrr_stack+8329);
 _BUILD_00p0(Data,vrr_stack+367, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+604, vrr_stack+367, vrr_stack+18, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+604, vrr_stack+719, vrr_stack+367, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+610, vrr_stack+21, vrr_stack+725, vrr_stack+604, vrr_stack+719, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+610, vrr_stack+735, vrr_stack+21, vrr_stack+725, NULL);
 _BUILD_p0h0(Data,vrr_stack+664, vrr_stack+0, vrr_stack+499, NULL, NULL, vrr_stack+735);
 _BUILD_d0h0(Data,vrr_stack+8133, vrr_stack+664, vrr_stack+520, vrr_stack+0, vrr_stack+499, vrr_stack+750);
 _BUILD_f0h0(Data,vrr_stack+8259, vrr_stack+8133, vrr_stack+6201, vrr_stack+664, vrr_stack+520, vrr_stack+795);
 _BUILD_g0h0(Data,vrr_stack+8469, vrr_stack+8259, vrr_stack+6327, vrr_stack+8133, vrr_stack+6201, vrr_stack+885);
 _BUILD_h0h0(Data,vrr_stack+2691, vrr_stack+8469, vrr_stack+14488, vrr_stack+8259, vrr_stack+6327, vrr_stack+3239);
   tmp = vrr_stack + 2691;
   target_ptr = Libint->vrr_classes[5][5];
   for(i=0;i<441;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0h0(Data,vrr_stack+17932, vrr_stack+2691, vrr_stack+14803, vrr_stack+8469, vrr_stack+14488, vrr_stack+8869);
   tmp = vrr_stack + 17932;
   target_ptr = Libint->vrr_classes[6][5];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0h0(Data,vrr_stack+8133, vrr_stack+17932, vrr_stack+15244, vrr_stack+2691, vrr_stack+14803, vrr_stack+3464);
   tmp = vrr_stack + 8133;
   target_ptr = Libint->vrr_classes[7][5];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0h0(Data,vrr_stack+2691, vrr_stack+8133, vrr_stack+17176, vrr_stack+17932, vrr_stack+15244, vrr_stack+9184);
   tmp = vrr_stack + 2691;
   target_ptr = Libint->vrr_classes[8][5];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+367, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+604, vrr_stack+3884, vrr_stack+367, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+3887, vrr_stack+604, vrr_stack+186, vrr_stack+3884, NULL);
 _BUILD_00g0(Data,vrr_stack+17932, vrr_stack+3893, vrr_stack+21, vrr_stack+189, vrr_stack+3887, NULL);
 _BUILD_00h0(Data,vrr_stack+17947, vrr_stack+3903, vrr_stack+17932, vrr_stack+195, vrr_stack+3893, NULL);
 _BUILD_p0h0(Data,vrr_stack+17968, vrr_stack+583, vrr_stack+17947, NULL, NULL, vrr_stack+3903);
 _BUILD_d0h0(Data,vrr_stack+18031, vrr_stack+73, vrr_stack+17968, vrr_stack+439, vrr_stack+583, vrr_stack+3918);
 _BUILD_f0h0(Data,vrr_stack+18157, vrr_stack+6537, vrr_stack+18031, vrr_stack+5571, vrr_stack+73, vrr_stack+3963);
 _BUILD_g0h0(Data,vrr_stack+18367, vrr_stack+6663, vrr_stack+18157, vrr_stack+5634, vrr_stack+6537, vrr_stack+4053);
 _BUILD_h0h0(Data,vrr_stack+8889, vrr_stack+6873, vrr_stack+18367, vrr_stack+12934, vrr_stack+6663, vrr_stack+9724);
 _BUILD_i0h0(Data,vrr_stack+9330, vrr_stack+2250, vrr_stack+8889, vrr_stack+13144, vrr_stack+6873, vrr_stack+9949);
 _BUILD_k0h0(Data,vrr_stack+18682, vrr_stack+15832, vrr_stack+9330, vrr_stack+13459, vrr_stack+2250, vrr_stack+1074);
 _BUILD_l0h0(Data,vrr_stack+19438, vrr_stack+16420, vrr_stack+18682, vrr_stack+13900, vrr_stack+15832, vrr_stack+10264);
 _BUILD_m0h0(Data,vrr_stack+20383, vrr_stack+7188, vrr_stack+19438, vrr_stack+17176, vrr_stack+16420, vrr_stack+10804);
 _BUILD_m0h0(Data,vrr_stack+9918, vrr_stack+2691, vrr_stack+7188, vrr_stack+8133, vrr_stack+17176, vrr_stack+4203);
   tmp = vrr_stack + 9918;
   target_ptr = Libint->vrr_classes[9][5];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00i0(Data,vrr_stack+8133, vrr_stack+205, vrr_stack+31, vrr_stack+310, vrr_stack+295, NULL);
 _BUILD_00i0(Data,vrr_stack+8161, vrr_stack+226, vrr_stack+205, vrr_stack+370, vrr_stack+310, NULL);
 _BUILD_00i0(Data,vrr_stack+8189, vrr_stack+31, vrr_stack+346, vrr_stack+295, vrr_stack+385, NULL);
 _BUILD_p0i0(Data,vrr_stack+8217, vrr_stack+8133, vrr_stack+8189, NULL, NULL, vrr_stack+31);
 _BUILD_p0i0(Data,vrr_stack+8301, vrr_stack+8161, vrr_stack+8133, NULL, NULL, vrr_stack+205);
 _BUILD_d0i0(Data,vrr_stack+8385, vrr_stack+8301, vrr_stack+8217, vrr_stack+8161, vrr_stack+8133, vrr_stack+4878);
 _BUILD_00i0(Data,vrr_stack+8553, vrr_stack+325, vrr_stack+226, vrr_stack+424, vrr_stack+370, NULL);
 _BUILD_p0i0(Data,vrr_stack+8581, vrr_stack+8553, vrr_stack+8161, NULL, NULL, vrr_stack+226);
 _BUILD_d0i0(Data,vrr_stack+8665, vrr_stack+8581, vrr_stack+8301, vrr_stack+8553, vrr_stack+8161, vrr_stack+4941);
 _BUILD_00i0(Data,vrr_stack+8833, vrr_stack+346, vrr_stack+439, vrr_stack+385, vrr_stack+484, NULL);
 _BUILD_p0i0(Data,vrr_stack+3918, vrr_stack+8189, vrr_stack+8833, NULL, NULL, vrr_stack+346);
 _BUILD_d0i0(Data,vrr_stack+4002, vrr_stack+8217, vrr_stack+3918, vrr_stack+8133, vrr_stack+8189, vrr_stack+5319);
 _BUILD_f0i0(Data,vrr_stack+4170, vrr_stack+8385, vrr_stack+4002, vrr_stack+8301, vrr_stack+8217, vrr_stack+5382);
 _BUILD_f0i0(Data,vrr_stack+4450, vrr_stack+8665, vrr_stack+8385, vrr_stack+8581, vrr_stack+8301, vrr_stack+5004);
 _BUILD_g0i0(Data,vrr_stack+21538, vrr_stack+4450, vrr_stack+4170, vrr_stack+8665, vrr_stack+8385, vrr_stack+1494);
 _BUILD_00i0(Data,vrr_stack+8861, vrr_stack+52, vrr_stack+325, vrr_stack+634, vrr_stack+424, NULL);
 _BUILD_p0i0(Data,vrr_stack+5319, vrr_stack+8861, vrr_stack+8553, NULL, NULL, vrr_stack+325);
 _BUILD_d0i0(Data,vrr_stack+4730, vrr_stack+5319, vrr_stack+8581, vrr_stack+8861, vrr_stack+8553, vrr_stack+5130);
 _BUILD_f0i0(Data,vrr_stack+4898, vrr_stack+4730, vrr_stack+8665, vrr_stack+5319, vrr_stack+8581, vrr_stack+5193);
 _BUILD_g0i0(Data,vrr_stack+750, vrr_stack+4898, vrr_stack+4450, vrr_stack+4730, vrr_stack+8665, vrr_stack+1704);
 _BUILD_00i0(Data,vrr_stack+5403, vrr_stack+439, vrr_stack+583, vrr_stack+484, vrr_stack+649, NULL);
 _BUILD_p0i0(Data,vrr_stack+5178, vrr_stack+8833, vrr_stack+5403, NULL, NULL, vrr_stack+439);
 _BUILD_d0i0(Data,vrr_stack+3636, vrr_stack+3918, vrr_stack+5178, vrr_stack+8189, vrr_stack+8833, vrr_stack+5571);
 _BUILD_f0i0(Data,vrr_stack+11073, vrr_stack+4002, vrr_stack+3636, vrr_stack+8217, vrr_stack+3918, vrr_stack+5634);
 _BUILD_g0i0(Data,vrr_stack+1170, vrr_stack+4170, vrr_stack+11073, vrr_stack+8385, vrr_stack+4002, vrr_stack+12934);
 _BUILD_h0i0(Data,vrr_stack+21958, vrr_stack+21538, vrr_stack+1170, vrr_stack+4450, vrr_stack+4170, vrr_stack+13144);
 _BUILD_h0i0(Data,vrr_stack+22546, vrr_stack+750, vrr_stack+21538, vrr_stack+4898, vrr_stack+4450, vrr_stack+12304);
 _BUILD_i0i0(Data,vrr_stack+23134, vrr_stack+22546, vrr_stack+21958, vrr_stack+750, vrr_stack+21538, vrr_stack+13459);
 _BUILD_00i0(Data,vrr_stack+12304, vrr_stack+499, vrr_stack+52, vrr_stack+735, vrr_stack+634, NULL);
 _BUILD_p0i0(Data,vrr_stack+12332, vrr_stack+12304, vrr_stack+8861, NULL, NULL, vrr_stack+52);
 _BUILD_d0i0(Data,vrr_stack+12416, vrr_stack+12332, vrr_stack+5319, vrr_stack+12304, vrr_stack+8861, vrr_stack+5508);
 _BUILD_f0i0(Data,vrr_stack+12934, vrr_stack+12416, vrr_stack+4730, vrr_stack+12332, vrr_stack+5319, vrr_stack+1914);
 _BUILD_g0i0(Data,vrr_stack+13214, vrr_stack+12934, vrr_stack+4898, vrr_stack+12416, vrr_stack+4730, vrr_stack+2040);
 _BUILD_h0i0(Data,vrr_stack+1590, vrr_stack+13214, vrr_stack+750, vrr_stack+12934, vrr_stack+4898, vrr_stack+12619);
 _BUILD_i0i0(Data,vrr_stack+23918, vrr_stack+1590, vrr_stack+22546, vrr_stack+13214, vrr_stack+750, vrr_stack+5760);
 _BUILD_00i0(Data,vrr_stack+12584, vrr_stack+583, vrr_stack+17947, vrr_stack+649, vrr_stack+3903, NULL);
 _BUILD_p0i0(Data,vrr_stack+12612, vrr_stack+5403, vrr_stack+12584, NULL, NULL, vrr_stack+583);
 _BUILD_d0i0(Data,vrr_stack+12696, vrr_stack+5178, vrr_stack+12612, vrr_stack+8833, vrr_stack+5403, vrr_stack+73);
 _BUILD_f0i0(Data,vrr_stack+5431, vrr_stack+3636, vrr_stack+12696, vrr_stack+3918, vrr_stack+5178, vrr_stack+6537);
 _BUILD_g0i0(Data,vrr_stack+5711, vrr_stack+11073, vrr_stack+5431, vrr_stack+4002, vrr_stack+3636, vrr_stack+6663);
 _BUILD_h0i0(Data,vrr_stack+24702, vrr_stack+1170, vrr_stack+5711, vrr_stack+4170, vrr_stack+11073, vrr_stack+6873);
 _BUILD_i0i0(Data,vrr_stack+25290, vrr_stack+21958, vrr_stack+24702, vrr_stack+21538, vrr_stack+1170, vrr_stack+2250);
 _BUILD_k0i0(Data,vrr_stack+26074, vrr_stack+23134, vrr_stack+25290, vrr_stack+22546, vrr_stack+21958, vrr_stack+15832);
 _BUILD_k0i0(Data,vrr_stack+27082, vrr_stack+23918, vrr_stack+23134, vrr_stack+1590, vrr_stack+22546, vrr_stack+13900);
 _BUILD_l0i0(Data,vrr_stack+28090, vrr_stack+27082, vrr_stack+26074, vrr_stack+23918, vrr_stack+23134, vrr_stack+16420);
 _BUILD_00i0(Data,vrr_stack+15832, vrr_stack+0, vrr_stack+499, vrr_stack+610, vrr_stack+735, NULL);
 _BUILD_p0i0(Data,vrr_stack+610, vrr_stack+15832, vrr_stack+12304, NULL, NULL, vrr_stack+499);
 _BUILD_d0i0(Data,vrr_stack+15860, vrr_stack+610, vrr_stack+12332, vrr_stack+15832, vrr_stack+12304, vrr_stack+520);
 _BUILD_f0i0(Data,vrr_stack+16028, vrr_stack+15860, vrr_stack+12416, vrr_stack+610, vrr_stack+12332, vrr_stack+6201);
 _BUILD_g0i0(Data,vrr_stack+16308, vrr_stack+16028, vrr_stack+12934, vrr_stack+15860, vrr_stack+12416, vrr_stack+6327);
 _BUILD_h0i0(Data,vrr_stack+13634, vrr_stack+16308, vrr_stack+13214, vrr_stack+16028, vrr_stack+12934, vrr_stack+14488);
   tmp = vrr_stack + 13634;
   target_ptr = Libint->vrr_classes[5][6];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0i0(Data,vrr_stack+6131, vrr_stack+13634, vrr_stack+1590, vrr_stack+16308, vrr_stack+13214, vrr_stack+14803);
   tmp = vrr_stack + 6131;
   target_ptr = Libint->vrr_classes[6][6];
   for(i=0;i<784;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0i0(Data,vrr_stack+15860, vrr_stack+6131, vrr_stack+23918, vrr_stack+13634, vrr_stack+1590, vrr_stack+15244);
   tmp = vrr_stack + 15860;
   target_ptr = Libint->vrr_classes[7][6];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0i0(Data,vrr_stack+13634, vrr_stack+15860, vrr_stack+27082, vrr_stack+6131, vrr_stack+23918, vrr_stack+17176);
   tmp = vrr_stack + 13634;
   target_ptr = Libint->vrr_classes[8][6];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6131, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6134, vrr_stack+367, vrr_stack+6131, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+6140, vrr_stack+604, vrr_stack+6134, vrr_stack+3884, vrr_stack+367, NULL);
 _BUILD_00g0(Data,vrr_stack+6150, vrr_stack+21, vrr_stack+6140, vrr_stack+3887, vrr_stack+604, NULL);
 _BUILD_00h0(Data,vrr_stack+6165, vrr_stack+17932, vrr_stack+6150, vrr_stack+3893, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+6186, vrr_stack+17947, vrr_stack+6165, vrr_stack+3903, vrr_stack+17932, NULL);
 _BUILD_p0i0(Data,vrr_stack+6214, vrr_stack+12584, vrr_stack+6186, NULL, NULL, vrr_stack+17947);
 _BUILD_d0i0(Data,vrr_stack+6298, vrr_stack+12612, vrr_stack+6214, vrr_stack+5403, vrr_stack+12584, vrr_stack+17968);
 _BUILD_f0i0(Data,vrr_stack+6466, vrr_stack+12696, vrr_stack+6298, vrr_stack+5178, vrr_stack+12612, vrr_stack+18031);
 _BUILD_g0i0(Data,vrr_stack+6746, vrr_stack+5431, vrr_stack+6466, vrr_stack+3636, vrr_stack+12696, vrr_stack+18157);
 _BUILD_h0i0(Data,vrr_stack+14894, vrr_stack+5711, vrr_stack+6746, vrr_stack+11073, vrr_stack+5431, vrr_stack+18367);
 _BUILD_i0i0(Data,vrr_stack+16868, vrr_stack+24702, vrr_stack+14894, vrr_stack+1170, vrr_stack+5711, vrr_stack+8889);
 _BUILD_k0i0(Data,vrr_stack+29350, vrr_stack+25290, vrr_stack+16868, vrr_stack+21958, vrr_stack+24702, vrr_stack+9330);
 _BUILD_l0i0(Data,vrr_stack+30358, vrr_stack+26074, vrr_stack+29350, vrr_stack+23134, vrr_stack+25290, vrr_stack+18682);
 _BUILD_m0i0(Data,vrr_stack+31618, vrr_stack+28090, vrr_stack+30358, vrr_stack+27082, vrr_stack+26074, vrr_stack+19438);
 _BUILD_m0i0(Data,vrr_stack+17968, vrr_stack+13634, vrr_stack+28090, vrr_stack+15860, vrr_stack+27082, vrr_stack+7188);
   tmp = vrr_stack + 17968;
   target_ptr = Libint->vrr_classes[9][6];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+15860, vrr_stack+8133, vrr_stack+8189, vrr_stack+205, vrr_stack+31, NULL);
 _BUILD_00k0(Data,vrr_stack+15896, vrr_stack+8161, vrr_stack+8133, vrr_stack+226, vrr_stack+205, NULL);
 _BUILD_00k0(Data,vrr_stack+15932, vrr_stack+8189, vrr_stack+8833, vrr_stack+31, vrr_stack+346, NULL);
 _BUILD_p0k0(Data,vrr_stack+15968, vrr_stack+15860, vrr_stack+15932, NULL, NULL, vrr_stack+8189);
 _BUILD_p0k0(Data,vrr_stack+16076, vrr_stack+15896, vrr_stack+15860, NULL, NULL, vrr_stack+8133);
 _BUILD_d0k0(Data,vrr_stack+16184, vrr_stack+16076, vrr_stack+15968, vrr_stack+15896, vrr_stack+15860, vrr_stack+8217);
 _BUILD_00k0(Data,vrr_stack+8217, vrr_stack+8553, vrr_stack+8161, vrr_stack+325, vrr_stack+226, NULL);
 _BUILD_p0k0(Data,vrr_stack+16400, vrr_stack+8217, vrr_stack+15896, NULL, NULL, vrr_stack+8161);
 _BUILD_d0k0(Data,vrr_stack+16508, vrr_stack+16400, vrr_stack+16076, vrr_stack+8217, vrr_stack+15896, vrr_stack+8301);
 _BUILD_00k0(Data,vrr_stack+8253, vrr_stack+8833, vrr_stack+5403, vrr_stack+346, vrr_stack+439, NULL);
 _BUILD_p0k0(Data,vrr_stack+16724, vrr_stack+15932, vrr_stack+8253, NULL, NULL, vrr_stack+8833);
 _BUILD_d0k0(Data,vrr_stack+8889, vrr_stack+15968, vrr_stack+16724, vrr_stack+15860, vrr_stack+15932, vrr_stack+3918);
 _BUILD_f0k0(Data,vrr_stack+9105, vrr_stack+16184, vrr_stack+8889, vrr_stack+16076, vrr_stack+15968, vrr_stack+4002);
 _BUILD_f0k0(Data,vrr_stack+9465, vrr_stack+16508, vrr_stack+16184, vrr_stack+16400, vrr_stack+16076, vrr_stack+8385);
 _BUILD_g0k0(Data,vrr_stack+19508, vrr_stack+9465, vrr_stack+9105, vrr_stack+16508, vrr_stack+16184, vrr_stack+4170);
 _BUILD_00k0(Data,vrr_stack+16832, vrr_stack+8861, vrr_stack+8553, vrr_stack+52, vrr_stack+325, NULL);
 _BUILD_p0k0(Data,vrr_stack+8289, vrr_stack+16832, vrr_stack+8217, NULL, NULL, vrr_stack+8553);
 _BUILD_d0k0(Data,vrr_stack+20048, vrr_stack+8289, vrr_stack+16400, vrr_stack+16832, vrr_stack+8217, vrr_stack+8581);
 _BUILD_f0k0(Data,vrr_stack+33158, vrr_stack+20048, vrr_stack+16508, vrr_stack+8289, vrr_stack+16400, vrr_stack+8665);
 _BUILD_g0k0(Data,vrr_stack+3804, vrr_stack+33158, vrr_stack+9465, vrr_stack+20048, vrr_stack+16508, vrr_stack+4450);
 _BUILD_00k0(Data,vrr_stack+8581, vrr_stack+5403, vrr_stack+12584, vrr_stack+439, vrr_stack+583, NULL);
 _BUILD_p0k0(Data,vrr_stack+8617, vrr_stack+8253, vrr_stack+8581, NULL, NULL, vrr_stack+5403);
 _BUILD_d0k0(Data,vrr_stack+15482, vrr_stack+16724, vrr_stack+8617, vrr_stack+15932, vrr_stack+8253, vrr_stack+5178);
 _BUILD_f0k0(Data,vrr_stack+33518, vrr_stack+8889, vrr_stack+15482, vrr_stack+15968, vrr_stack+16724, vrr_stack+3636);
 _BUILD_g0k0(Data,vrr_stack+33878, vrr_stack+9105, vrr_stack+33518, vrr_stack+16184, vrr_stack+8889, vrr_stack+11073);
 _BUILD_h0k0(Data,vrr_stack+34418, vrr_stack+19508, vrr_stack+33878, vrr_stack+9465, vrr_stack+9105, vrr_stack+1170);
 _BUILD_h0k0(Data,vrr_stack+35174, vrr_stack+3804, vrr_stack+19508, vrr_stack+33158, vrr_stack+9465, vrr_stack+21538);
 _BUILD_i0k0(Data,vrr_stack+35930, vrr_stack+35174, vrr_stack+34418, vrr_stack+3804, vrr_stack+19508, vrr_stack+21958);
 _BUILD_00k0(Data,vrr_stack+21538, vrr_stack+12304, vrr_stack+8861, vrr_stack+499, vrr_stack+52, NULL);
 _BUILD_p0k0(Data,vrr_stack+8725, vrr_stack+21538, vrr_stack+16832, NULL, NULL, vrr_stack+8861);
 _BUILD_d0k0(Data,vrr_stack+21574, vrr_stack+8725, vrr_stack+8289, vrr_stack+21538, vrr_stack+16832, vrr_stack+5319);
 _BUILD_f0k0(Data,vrr_stack+21790, vrr_stack+21574, vrr_stack+20048, vrr_stack+8725, vrr_stack+8289, vrr_stack+4730);
 _BUILD_g0k0(Data,vrr_stack+4344, vrr_stack+21790, vrr_stack+33158, vrr_stack+21574, vrr_stack+20048, vrr_stack+4898);
 _BUILD_h0k0(Data,vrr_stack+36938, vrr_stack+4344, vrr_stack+3804, vrr_stack+21790, vrr_stack+33158, vrr_stack+750);
 _BUILD_i0k0(Data,vrr_stack+37694, vrr_stack+36938, vrr_stack+35174, vrr_stack+4344, vrr_stack+3804, vrr_stack+22546);
 _BUILD_00k0(Data,vrr_stack+22150, vrr_stack+12584, vrr_stack+6186, vrr_stack+583, vrr_stack+17947, NULL);
 _BUILD_p0k0(Data,vrr_stack+22186, vrr_stack+8581, vrr_stack+22150, NULL, NULL, vrr_stack+12584);
 _BUILD_d0k0(Data,vrr_stack+22294, vrr_stack+8617, vrr_stack+22186, vrr_stack+8253, vrr_stack+8581, vrr_stack+12612);
 _BUILD_f0k0(Data,vrr_stack+22510, vrr_stack+15482, vrr_stack+22294, vrr_stack+16724, vrr_stack+8617, vrr_stack+12696);
 _BUILD_g0k0(Data,vrr_stack+610, vrr_stack+33518, vrr_stack+22510, vrr_stack+8889, vrr_stack+15482, vrr_stack+5431);
 _BUILD_h0k0(Data,vrr_stack+38702, vrr_stack+33878, vrr_stack+610, vrr_stack+9105, vrr_stack+33518, vrr_stack+5711);
 _BUILD_i0k0(Data,vrr_stack+39458, vrr_stack+34418, vrr_stack+38702, vrr_stack+19508, vrr_stack+33878, vrr_stack+24702);
 _BUILD_k0k0(Data,vrr_stack+40466, vrr_stack+35930, vrr_stack+39458, vrr_stack+35174, vrr_stack+34418, vrr_stack+25290);
 _BUILD_k0k0(Data,vrr_stack+24702, vrr_stack+37694, vrr_stack+35930, vrr_stack+36938, vrr_stack+35174, vrr_stack+23134);
 _BUILD_l0k0(Data,vrr_stack+41762, vrr_stack+24702, vrr_stack+40466, vrr_stack+37694, vrr_stack+35930, vrr_stack+26074);
 _BUILD_00k0(Data,vrr_stack+25998, vrr_stack+15832, vrr_stack+12304, vrr_stack+0, vrr_stack+499, NULL);
 _BUILD_p0k0(Data,vrr_stack+26034, vrr_stack+25998, vrr_stack+21538, NULL, NULL, vrr_stack+12304);
 _BUILD_d0k0(Data,vrr_stack+26142, vrr_stack+26034, vrr_stack+8725, vrr_stack+25998, vrr_stack+21538, vrr_stack+12332);
 _BUILD_f0k0(Data,vrr_stack+26358, vrr_stack+26142, vrr_stack+21574, vrr_stack+26034, vrr_stack+8725, vrr_stack+12416);
 _BUILD_g0k0(Data,vrr_stack+5431, vrr_stack+26358, vrr_stack+21790, vrr_stack+26142, vrr_stack+21574, vrr_stack+12934);
 _BUILD_h0k0(Data,vrr_stack+22870, vrr_stack+5431, vrr_stack+4344, vrr_stack+26358, vrr_stack+21790, vrr_stack+13214);
   tmp = vrr_stack + 22870;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0k0(Data,vrr_stack+26034, vrr_stack+22870, vrr_stack+36938, vrr_stack+5431, vrr_stack+4344, vrr_stack+1590);
   tmp = vrr_stack + 26034;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0k0(Data,vrr_stack+1150, vrr_stack+26034, vrr_stack+37694, vrr_stack+22870, vrr_stack+36938, vrr_stack+23918);
   tmp = vrr_stack + 1150;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0k0(Data,vrr_stack+22870, vrr_stack+1150, vrr_stack+24702, vrr_stack+26034, vrr_stack+37694, vrr_stack+27082);
   tmp = vrr_stack + 22870;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+26034, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+26037, vrr_stack+6131, vrr_stack+26034, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+26043, vrr_stack+6134, vrr_stack+26037, vrr_stack+367, vrr_stack+6131, NULL);
 _BUILD_00g0(Data,vrr_stack+26053, vrr_stack+6140, vrr_stack+26043, vrr_stack+604, vrr_stack+6134, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+6150, vrr_stack+26053, vrr_stack+21, vrr_stack+6140, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+6165, vrr_stack+0, vrr_stack+17932, vrr_stack+6150, NULL);
 _BUILD_00k0(Data,vrr_stack+49, vrr_stack+6186, vrr_stack+21, vrr_stack+17947, vrr_stack+6165, NULL);
 _BUILD_p0k0(Data,vrr_stack+85, vrr_stack+22150, vrr_stack+49, NULL, NULL, vrr_stack+6186);
 _BUILD_d0k0(Data,vrr_stack+193, vrr_stack+22186, vrr_stack+85, vrr_stack+8581, vrr_stack+22150, vrr_stack+6214);
 _BUILD_f0k0(Data,vrr_stack+26068, vrr_stack+22294, vrr_stack+193, vrr_stack+8617, vrr_stack+22186, vrr_stack+6298);
 _BUILD_g0k0(Data,vrr_stack+26428, vrr_stack+22510, vrr_stack+26068, vrr_stack+15482, vrr_stack+22294, vrr_stack+6466);
 _BUILD_h0k0(Data,vrr_stack+26968, vrr_stack+610, vrr_stack+26428, vrr_stack+33518, vrr_stack+22510, vrr_stack+6746);
 _BUILD_i0k0(Data,vrr_stack+12612, vrr_stack+38702, vrr_stack+26968, vrr_stack+33878, vrr_stack+610, vrr_stack+14894);
 _BUILD_k0k0(Data,vrr_stack+43382, vrr_stack+39458, vrr_stack+12612, vrr_stack+34418, vrr_stack+38702, vrr_stack+16868);
 _BUILD_l0k0(Data,vrr_stack+44678, vrr_stack+40466, vrr_stack+43382, vrr_stack+35930, vrr_stack+39458, vrr_stack+29350);
 _BUILD_m0k0(Data,vrr_stack+46298, vrr_stack+41762, vrr_stack+44678, vrr_stack+24702, vrr_stack+40466, vrr_stack+30358);
 _BUILD_m0k0(Data,vrr_stack+29350, vrr_stack+22870, vrr_stack+41762, vrr_stack+1150, vrr_stack+24702, vrr_stack+28090);
   tmp = vrr_stack + 29350;
   target_ptr = Libint->vrr_classes[9][7];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+1150, vrr_stack+15860, vrr_stack+15932, vrr_stack+8133, vrr_stack+8189, NULL);
 _BUILD_00l0(Data,vrr_stack+1195, vrr_stack+15896, vrr_stack+15860, vrr_stack+8161, vrr_stack+8133, NULL);
 _BUILD_00l0(Data,vrr_stack+1240, vrr_stack+15932, vrr_stack+8253, vrr_stack+8189, vrr_stack+8833, NULL);
 _BUILD_p0l0(Data,vrr_stack+1285, vrr_stack+1150, vrr_stack+1240, NULL, NULL, vrr_stack+15932);
 _BUILD_p0l0(Data,vrr_stack+1420, vrr_stack+1195, vrr_stack+1150, NULL, NULL, vrr_stack+15860);
 _BUILD_d0l0(Data,vrr_stack+1555, vrr_stack+1420, vrr_stack+1285, vrr_stack+1195, vrr_stack+1150, vrr_stack+15968);
 _BUILD_00l0(Data,vrr_stack+15968, vrr_stack+8217, vrr_stack+15896, vrr_stack+8553, vrr_stack+8161, NULL);
 _BUILD_p0l0(Data,vrr_stack+1825, vrr_stack+15968, vrr_stack+1195, NULL, NULL, vrr_stack+15896);
 _BUILD_d0l0(Data,vrr_stack+1960, vrr_stack+1825, vrr_stack+1420, vrr_stack+15968, vrr_stack+1195, vrr_stack+16076);
 _BUILD_00l0(Data,vrr_stack+16013, vrr_stack+8253, vrr_stack+8581, vrr_stack+8833, vrr_stack+5403, NULL);
 _BUILD_p0l0(Data,vrr_stack+2230, vrr_stack+1240, vrr_stack+16013, NULL, NULL, vrr_stack+8253);
 _BUILD_d0l0(Data,vrr_stack+2365, vrr_stack+1285, vrr_stack+2230, vrr_stack+1150, vrr_stack+1240, vrr_stack+16724);
 _BUILD_f0l0(Data,vrr_stack+16868, vrr_stack+1555, vrr_stack+2365, vrr_stack+1420, vrr_stack+1285, vrr_stack+8889);
 _BUILD_f0l0(Data,vrr_stack+17318, vrr_stack+1960, vrr_stack+1555, vrr_stack+1825, vrr_stack+1420, vrr_stack+16184);
 _BUILD_g0l0(Data,vrr_stack+6214, vrr_stack+17318, vrr_stack+16868, vrr_stack+1960, vrr_stack+1555, vrr_stack+9105);
 _BUILD_00l0(Data,vrr_stack+8889, vrr_stack+16832, vrr_stack+8217, vrr_stack+8861, vrr_stack+8553, NULL);
 _BUILD_p0l0(Data,vrr_stack+8934, vrr_stack+8889, vrr_stack+15968, NULL, NULL, vrr_stack+8217);
 _BUILD_d0l0(Data,vrr_stack+9069, vrr_stack+8934, vrr_stack+1825, vrr_stack+8889, vrr_stack+15968, vrr_stack+16400);
 _BUILD_f0l0(Data,vrr_stack+16058, vrr_stack+9069, vrr_stack+1960, vrr_stack+8934, vrr_stack+1825, vrr_stack+16508);
 _BUILD_g0l0(Data,vrr_stack+5431, vrr_stack+16058, vrr_stack+17318, vrr_stack+9069, vrr_stack+1960, vrr_stack+9465);
 _BUILD_00l0(Data,vrr_stack+16508, vrr_stack+8581, vrr_stack+22150, vrr_stack+5403, vrr_stack+12584, NULL);
 _BUILD_p0l0(Data,vrr_stack+16553, vrr_stack+16013, vrr_stack+16508, NULL, NULL, vrr_stack+8581);
 _BUILD_d0l0(Data,vrr_stack+9339, vrr_stack+2230, vrr_stack+16553, vrr_stack+1240, vrr_stack+16013, vrr_stack+8617);
 _BUILD_f0l0(Data,vrr_stack+14894, vrr_stack+2365, vrr_stack+9339, vrr_stack+1285, vrr_stack+2230, vrr_stack+15482);
 _BUILD_g0l0(Data,vrr_stack+48278, vrr_stack+16868, vrr_stack+14894, vrr_stack+1555, vrr_stack+2365, vrr_stack+33518);
 _BUILD_h0l0(Data,vrr_stack+48953, vrr_stack+6214, vrr_stack+48278, vrr_stack+17318, vrr_stack+16868, vrr_stack+33878);
 _BUILD_h0l0(Data,vrr_stack+49898, vrr_stack+5431, vrr_stack+6214, vrr_stack+16058, vrr_stack+17318, vrr_stack+19508);
 _BUILD_i0l0(Data,vrr_stack+50843, vrr_stack+49898, vrr_stack+48953, vrr_stack+5431, vrr_stack+6214, vrr_stack+34418);
 _BUILD_00l0(Data,vrr_stack+19508, vrr_stack+21538, vrr_stack+16832, vrr_stack+12304, vrr_stack+8861, NULL);
 _BUILD_p0l0(Data,vrr_stack+19553, vrr_stack+19508, vrr_stack+8889, NULL, NULL, vrr_stack+16832);
 _BUILD_d0l0(Data,vrr_stack+19688, vrr_stack+19553, vrr_stack+8934, vrr_stack+19508, vrr_stack+8889, vrr_stack+8289);
 _BUILD_f0l0(Data,vrr_stack+33518, vrr_stack+19688, vrr_stack+9069, vrr_stack+19553, vrr_stack+8934, vrr_stack+20048);
 _BUILD_g0l0(Data,vrr_stack+33968, vrr_stack+33518, vrr_stack+16058, vrr_stack+19688, vrr_stack+9069, vrr_stack+33158);
 _BUILD_h0l0(Data,vrr_stack+52103, vrr_stack+33968, vrr_stack+5431, vrr_stack+33518, vrr_stack+16058, vrr_stack+3804);
 _BUILD_i0l0(Data,vrr_stack+53048, vrr_stack+52103, vrr_stack+49898, vrr_stack+33968, vrr_stack+5431, vrr_stack+35174);
 _BUILD_00l0(Data,vrr_stack+33158, vrr_stack+22150, vrr_stack+49, vrr_stack+12584, vrr_stack+6186, NULL);
 _BUILD_p0l0(Data,vrr_stack+33203, vrr_stack+16508, vrr_stack+33158, NULL, NULL, vrr_stack+22150);
 _BUILD_d0l0(Data,vrr_stack+8289, vrr_stack+16553, vrr_stack+33203, vrr_stack+16013, vrr_stack+16508, vrr_stack+22186);
 _BUILD_f0l0(Data,vrr_stack+34643, vrr_stack+9339, vrr_stack+8289, vrr_stack+2230, vrr_stack+16553, vrr_stack+22294);
 _BUILD_g0l0(Data,vrr_stack+35093, vrr_stack+14894, vrr_stack+34643, vrr_stack+2365, vrr_stack+9339, vrr_stack+22510);
 _BUILD_h0l0(Data,vrr_stack+54308, vrr_stack+48278, vrr_stack+35093, vrr_stack+16868, vrr_stack+14894, vrr_stack+610);
 _BUILD_i0l0(Data,vrr_stack+55253, vrr_stack+48953, vrr_stack+54308, vrr_stack+6214, vrr_stack+48278, vrr_stack+38702);
 _BUILD_k0l0(Data,vrr_stack+56513, vrr_stack+50843, vrr_stack+55253, vrr_stack+49898, vrr_stack+48953, vrr_stack+39458);
 _BUILD_k0l0(Data,vrr_stack+38702, vrr_stack+53048, vrr_stack+50843, vrr_stack+52103, vrr_stack+49898, vrr_stack+35930);
 _BUILD_l0l0(Data,vrr_stack+58133, vrr_stack+38702, vrr_stack+56513, vrr_stack+53048, vrr_stack+50843, vrr_stack+40466);
 _BUILD_00l0(Data,vrr_stack+40322, vrr_stack+25998, vrr_stack+21538, vrr_stack+15832, vrr_stack+12304, NULL);
 _BUILD_p0l0(Data,vrr_stack+12304, vrr_stack+40322, vrr_stack+19508, NULL, NULL, vrr_stack+21538);
 _BUILD_d0l0(Data,vrr_stack+40367, vrr_stack+12304, vrr_stack+19553, vrr_stack+40322, vrr_stack+19508, vrr_stack+8725);
 _BUILD_f0l0(Data,vrr_stack+40637, vrr_stack+40367, vrr_stack+19688, vrr_stack+12304, vrr_stack+19553, vrr_stack+21574);
 _BUILD_g0l0(Data,vrr_stack+41087, vrr_stack+40637, vrr_stack+33518, vrr_stack+40367, vrr_stack+19688, vrr_stack+21790);
 _BUILD_h0l0(Data,vrr_stack+35768, vrr_stack+41087, vrr_stack+33968, vrr_stack+40637, vrr_stack+33518, vrr_stack+4344);
   tmp = vrr_stack + 35768;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0l0(Data,vrr_stack+3636, vrr_stack+35768, vrr_stack+52103, vrr_stack+41087, vrr_stack+33968, vrr_stack+36938);
   tmp = vrr_stack + 3636;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0l0(Data,vrr_stack+60158, vrr_stack+3636, vrr_stack+53048, vrr_stack+35768, vrr_stack+52103, vrr_stack+37694);
   tmp = vrr_stack + 60158;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0l0(Data,vrr_stack+35768, vrr_stack+60158, vrr_stack+38702, vrr_stack+3636, vrr_stack+53048, vrr_stack+24702);
   tmp = vrr_stack + 35768;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+3636, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3639, vrr_stack+26034, vrr_stack+3636, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+3645, vrr_stack+26037, vrr_stack+3639, vrr_stack+6131, vrr_stack+26034, NULL);
 _BUILD_00g0(Data,vrr_stack+3655, vrr_stack+26043, vrr_stack+3645, vrr_stack+6134, vrr_stack+26037, NULL);
 _BUILD_00h0(Data,vrr_stack+3670, vrr_stack+26053, vrr_stack+3655, vrr_stack+6140, vrr_stack+26043, NULL);
 _BUILD_00i0(Data,vrr_stack+3691, vrr_stack+0, vrr_stack+3670, vrr_stack+6150, vrr_stack+26053, NULL);
 _BUILD_00k0(Data,vrr_stack+3719, vrr_stack+21, vrr_stack+3691, vrr_stack+6165, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+3755, vrr_stack+49, vrr_stack+3719, vrr_stack+6186, vrr_stack+21, NULL);
 _BUILD_p0l0(Data,vrr_stack+3800, vrr_stack+33158, vrr_stack+3755, NULL, NULL, vrr_stack+49);
 _BUILD_d0l0(Data,vrr_stack+3935, vrr_stack+33203, vrr_stack+3800, vrr_stack+16508, vrr_stack+33158, vrr_stack+85);
 _BUILD_f0l0(Data,vrr_stack+4205, vrr_stack+8289, vrr_stack+3935, vrr_stack+16553, vrr_stack+33203, vrr_stack+193);
 _BUILD_g0l0(Data,vrr_stack+85, vrr_stack+34643, vrr_stack+4205, vrr_stack+9339, vrr_stack+8289, vrr_stack+26068);
 _BUILD_h0l0(Data,vrr_stack+40367, vrr_stack+35093, vrr_stack+85, vrr_stack+14894, vrr_stack+34643, vrr_stack+26428);
 _BUILD_i0l0(Data,vrr_stack+24490, vrr_stack+54308, vrr_stack+40367, vrr_stack+48278, vrr_stack+35093, vrr_stack+26968);
 _BUILD_k0l0(Data,vrr_stack+26068, vrr_stack+55253, vrr_stack+24490, vrr_stack+48953, vrr_stack+54308, vrr_stack+12612);
 _BUILD_l0l0(Data,vrr_stack+61778, vrr_stack+56513, vrr_stack+26068, vrr_stack+50843, vrr_stack+55253, vrr_stack+43382);
 _BUILD_m0l0(Data,vrr_stack+63803, vrr_stack+58133, vrr_stack+61778, vrr_stack+38702, vrr_stack+56513, vrr_stack+44678);
 _BUILD_m0l0(Data,vrr_stack+43382, vrr_stack+35768, vrr_stack+58133, vrr_stack+60158, vrr_stack+38702, vrr_stack+41762);
   tmp = vrr_stack + 43382;
   target_ptr = Libint->vrr_classes[9][8];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+60158, vrr_stack+1150, vrr_stack+1240, vrr_stack+15860, vrr_stack+15932, NULL);
 _BUILD_00m0(Data,vrr_stack+60213, vrr_stack+1195, vrr_stack+1150, vrr_stack+15896, vrr_stack+15860, NULL);
 _BUILD_00m0(Data,vrr_stack+60268, vrr_stack+1240, vrr_stack+16013, vrr_stack+15932, vrr_stack+8253, NULL);
 _BUILD_p0m0(Data,vrr_stack+60323, vrr_stack+60158, vrr_stack+60268, NULL, NULL, vrr_stack+1240);
 _BUILD_p0m0(Data,vrr_stack+60488, vrr_stack+60213, vrr_stack+60158, NULL, NULL, vrr_stack+1150);
 _BUILD_d0m0(Data,vrr_stack+60653, vrr_stack+60488, vrr_stack+60323, vrr_stack+60213, vrr_stack+60158, vrr_stack+1285);
 _BUILD_00m0(Data,vrr_stack+1285, vrr_stack+15968, vrr_stack+1195, vrr_stack+8217, vrr_stack+15896, NULL);
 _BUILD_p0m0(Data,vrr_stack+60983, vrr_stack+1285, vrr_stack+60213, NULL, NULL, vrr_stack+1195);
 _BUILD_d0m0(Data,vrr_stack+61148, vrr_stack+60983, vrr_stack+60488, vrr_stack+1285, vrr_stack+60213, vrr_stack+1420);
 _BUILD_00m0(Data,vrr_stack+1340, vrr_stack+16013, vrr_stack+16508, vrr_stack+8253, vrr_stack+8581, NULL);
 _BUILD_p0m0(Data,vrr_stack+61478, vrr_stack+60268, vrr_stack+1340, NULL, NULL, vrr_stack+16013);
 _BUILD_d0m0(Data,vrr_stack+45857, vrr_stack+60323, vrr_stack+61478, vrr_stack+60158, vrr_stack+60268, vrr_stack+2230);
 _BUILD_f0m0(Data,vrr_stack+4655, vrr_stack+60653, vrr_stack+45857, vrr_stack+60488, vrr_stack+60323, vrr_stack+2365);
 _BUILD_f0m0(Data,vrr_stack+37793, vrr_stack+61148, vrr_stack+60653, vrr_stack+60983, vrr_stack+60488, vrr_stack+1555);
 _BUILD_g0m0(Data,vrr_stack+12304, vrr_stack+37793, vrr_stack+4655, vrr_stack+61148, vrr_stack+60653, vrr_stack+16868);
 _BUILD_00m0(Data,vrr_stack+16868, vrr_stack+8889, vrr_stack+15968, vrr_stack+16832, vrr_stack+8217, NULL);
 _BUILD_p0m0(Data,vrr_stack+16923, vrr_stack+16868, vrr_stack+1285, NULL, NULL, vrr_stack+15968);
 _BUILD_d0m0(Data,vrr_stack+2230, vrr_stack+16923, vrr_stack+60983, vrr_stack+16868, vrr_stack+1285, vrr_stack+1825);
 _BUILD_f0m0(Data,vrr_stack+1395, vrr_stack+2230, vrr_stack+61148, vrr_stack+16923, vrr_stack+60983, vrr_stack+1960);
 _BUILD_g0m0(Data,vrr_stack+66278, vrr_stack+1395, vrr_stack+37793, vrr_stack+2230, vrr_stack+61148, vrr_stack+17318);
 _BUILD_00m0(Data,vrr_stack+17088, vrr_stack+16508, vrr_stack+33158, vrr_stack+8581, vrr_stack+22150, NULL);
 _BUILD_p0m0(Data,vrr_stack+17143, vrr_stack+1340, vrr_stack+17088, NULL, NULL, vrr_stack+16508);
 _BUILD_d0m0(Data,vrr_stack+8559, vrr_stack+61478, vrr_stack+17143, vrr_stack+60268, vrr_stack+1340, vrr_stack+16553);
 _BUILD_f0m0(Data,vrr_stack+17308, vrr_stack+45857, vrr_stack+8559, vrr_stack+60323, vrr_stack+61478, vrr_stack+9339);
 _BUILD_g0m0(Data,vrr_stack+67103, vrr_stack+4655, vrr_stack+17308, vrr_stack+60653, vrr_stack+45857, vrr_stack+14894);
 _BUILD_h0m0(Data,vrr_stack+67928, vrr_stack+12304, vrr_stack+67103, vrr_stack+37793, vrr_stack+4655, vrr_stack+48278);
 _BUILD_h0m0(Data,vrr_stack+69083, vrr_stack+66278, vrr_stack+12304, vrr_stack+1395, vrr_stack+37793, vrr_stack+6214);
 _BUILD_i0m0(Data,vrr_stack+70238, vrr_stack+69083, vrr_stack+67928, vrr_stack+66278, vrr_stack+12304, vrr_stack+48953);
 _BUILD_00m0(Data,vrr_stack+48278, vrr_stack+19508, vrr_stack+8889, vrr_stack+21538, vrr_stack+16832, NULL);
 _BUILD_p0m0(Data,vrr_stack+48333, vrr_stack+48278, vrr_stack+16868, NULL, NULL, vrr_stack+8889);
 _BUILD_d0m0(Data,vrr_stack+48498, vrr_stack+48333, vrr_stack+16923, vrr_stack+48278, vrr_stack+16868, vrr_stack+8934);
 _BUILD_f0m0(Data,vrr_stack+48828, vrr_stack+48498, vrr_stack+2230, vrr_stack+48333, vrr_stack+16923, vrr_stack+9069);
 _BUILD_g0m0(Data,vrr_stack+8934, vrr_stack+48828, vrr_stack+1395, vrr_stack+48498, vrr_stack+2230, vrr_stack+16058);
 _BUILD_h0m0(Data,vrr_stack+71778, vrr_stack+8934, vrr_stack+66278, vrr_stack+48828, vrr_stack+1395, vrr_stack+5431);
 _BUILD_i0m0(Data,vrr_stack+5205, vrr_stack+71778, vrr_stack+69083, vrr_stack+8934, vrr_stack+66278, vrr_stack+49898);
 _BUILD_00m0(Data,vrr_stack+16058, vrr_stack+33158, vrr_stack+3755, vrr_stack+22150, vrr_stack+49, NULL);
 _BUILD_p0m0(Data,vrr_stack+16113, vrr_stack+17088, vrr_stack+16058, NULL, NULL, vrr_stack+33158);
 _BUILD_d0m0(Data,vrr_stack+49378, vrr_stack+17143, vrr_stack+16113, vrr_stack+1340, vrr_stack+17088, vrr_stack+33203);
 _BUILD_f0m0(Data,vrr_stack+49708, vrr_stack+8559, vrr_stack+49378, vrr_stack+61478, vrr_stack+17143, vrr_stack+8289);
 _BUILD_g0m0(Data,vrr_stack+14894, vrr_stack+17308, vrr_stack+49708, vrr_stack+45857, vrr_stack+8559, vrr_stack+34643);
 _BUILD_h0m0(Data,vrr_stack+21574, vrr_stack+67103, vrr_stack+14894, vrr_stack+4655, vrr_stack+17308, vrr_stack+35093);
 _BUILD_i0m0(Data,vrr_stack+72933, vrr_stack+67928, vrr_stack+21574, vrr_stack+12304, vrr_stack+67103, vrr_stack+54308);
 _BUILD_k0m0(Data,vrr_stack+74473, vrr_stack+70238, vrr_stack+72933, vrr_stack+69083, vrr_stack+67928, vrr_stack+55253);
 _BUILD_k0m0(Data,vrr_stack+54308, vrr_stack+5205, vrr_stack+70238, vrr_stack+71778, vrr_stack+69083, vrr_stack+50843);
 _BUILD_l0m0(Data,vrr_stack+76453, vrr_stack+54308, vrr_stack+74473, vrr_stack+5205, vrr_stack+70238, vrr_stack+56513);
 _BUILD_00m0(Data,vrr_stack+56288, vrr_stack+40322, vrr_stack+19508, vrr_stack+25998, vrr_stack+21538, NULL);
 _BUILD_p0m0(Data,vrr_stack+56343, vrr_stack+56288, vrr_stack+48278, NULL, NULL, vrr_stack+19508);
 _BUILD_d0m0(Data,vrr_stack+56508, vrr_stack+56343, vrr_stack+48333, vrr_stack+56288, vrr_stack+48278, vrr_stack+19553);
 _BUILD_f0m0(Data,vrr_stack+56838, vrr_stack+56508, vrr_stack+48498, vrr_stack+56343, vrr_stack+48333, vrr_stack+19688);
 _BUILD_g0m0(Data,vrr_stack+19553, vrr_stack+56838, vrr_stack+48828, vrr_stack+56508, vrr_stack+48498, vrr_stack+33518);
 _BUILD_h0m0(Data,vrr_stack+50258, vrr_stack+19553, vrr_stack+8934, vrr_stack+56838, vrr_stack+48828, vrr_stack+33968);
   tmp = vrr_stack + 50258;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0m0(Data,vrr_stack+56343, vrr_stack+50258, vrr_stack+71778, vrr_stack+19553, vrr_stack+8934, vrr_stack+52103);
   tmp = vrr_stack + 56343;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0m0(Data,vrr_stack+33203, vrr_stack+56343, vrr_stack+5205, vrr_stack+50258, vrr_stack+71778, vrr_stack+53048);
   tmp = vrr_stack + 33203;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+50258, vrr_stack+33203, vrr_stack+54308, vrr_stack+56343, vrr_stack+5205, vrr_stack+38702);
   tmp = vrr_stack + 50258;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+56343, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+56346, vrr_stack+3636, vrr_stack+56343, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+56352, vrr_stack+3639, vrr_stack+56346, vrr_stack+26034, vrr_stack+3636, NULL);
 _BUILD_00g0(Data,vrr_stack+56362, vrr_stack+3645, vrr_stack+56352, vrr_stack+26037, vrr_stack+3639, NULL);
 _BUILD_00h0(Data,vrr_stack+56377, vrr_stack+3655, vrr_stack+56362, vrr_stack+26043, vrr_stack+3645, NULL);
 _BUILD_00i0(Data,vrr_stack+56398, vrr_stack+3670, vrr_stack+56377, vrr_stack+26053, vrr_stack+3655, NULL);
 _BUILD_00k0(Data,vrr_stack+21538, vrr_stack+3691, vrr_stack+56398, vrr_stack+0, vrr_stack+3670, NULL);
 _BUILD_00l0(Data,vrr_stack+56426, vrr_stack+3719, vrr_stack+21538, vrr_stack+21, vrr_stack+3691, NULL);
 _BUILD_00m0(Data,vrr_stack+56471, vrr_stack+3755, vrr_stack+56426, vrr_stack+49, vrr_stack+3719, NULL);
 _BUILD_p0m0(Data,vrr_stack+56526, vrr_stack+16058, vrr_stack+56471, NULL, NULL, vrr_stack+3755);
 _BUILD_d0m0(Data,vrr_stack+56691, vrr_stack+16113, vrr_stack+56526, vrr_stack+17088, vrr_stack+16058, vrr_stack+3800);
 _BUILD_f0m0(Data,vrr_stack+57021, vrr_stack+49378, vrr_stack+56691, vrr_stack+17143, vrr_stack+16113, vrr_stack+3935);
 _BUILD_g0m0(Data,vrr_stack+52733, vrr_stack+49708, vrr_stack+57021, vrr_stack+8559, vrr_stack+49378, vrr_stack+4205);
 _BUILD_h0m0(Data,vrr_stack+38343, vrr_stack+14894, vrr_stack+52733, vrr_stack+17308, vrr_stack+49708, vrr_stack+85);
 _BUILD_i0m0(Data,vrr_stack+78928, vrr_stack+21574, vrr_stack+38343, vrr_stack+67103, vrr_stack+14894, vrr_stack+40367);
 _BUILD_k0m0(Data,vrr_stack+80468, vrr_stack+72933, vrr_stack+78928, vrr_stack+67928, vrr_stack+21574, vrr_stack+24490);
 _BUILD_l0m0(Data,vrr_stack+82448, vrr_stack+74473, vrr_stack+80468, vrr_stack+70238, vrr_stack+72933, vrr_stack+26068);
 _BUILD_m0m0(Data,vrr_stack+24490, vrr_stack+76453, vrr_stack+82448, vrr_stack+54308, vrr_stack+74473, vrr_stack+61778);
 _BUILD_m0m0(Data,vrr_stack+84923, vrr_stack+50258, vrr_stack+76453, vrr_stack+33203, vrr_stack+54308, vrr_stack+58133);
   tmp = vrr_stack + 84923;
   target_ptr = Libint->vrr_classes[9][9];
   for(i=0;i<3025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+33203, vrr_stack+60158, vrr_stack+60268, vrr_stack+1150, vrr_stack+1240, NULL);
 _BUILD_00n0(Data,vrr_stack+33269, vrr_stack+60213, vrr_stack+60158, vrr_stack+1195, vrr_stack+1150, NULL);
 _BUILD_00n0(Data,vrr_stack+33335, vrr_stack+60268, vrr_stack+1340, vrr_stack+1240, vrr_stack+16013, NULL);
 _BUILD_p0n0(Data,vrr_stack+33401, vrr_stack+33203, vrr_stack+33335, NULL, NULL, vrr_stack+60268);
 _BUILD_p0n0(Data,vrr_stack+33599, vrr_stack+33269, vrr_stack+33203, NULL, NULL, vrr_stack+60158);
 _BUILD_d0n0(Data,vrr_stack+33797, vrr_stack+33599, vrr_stack+33401, vrr_stack+33269, vrr_stack+33203, vrr_stack+60323);
 _BUILD_00n0(Data,vrr_stack+60268, vrr_stack+1285, vrr_stack+60213, vrr_stack+15968, vrr_stack+1195, NULL);
 _BUILD_p0n0(Data,vrr_stack+34193, vrr_stack+60268, vrr_stack+33269, NULL, NULL, vrr_stack+60213);
 _BUILD_d0n0(Data,vrr_stack+34391, vrr_stack+34193, vrr_stack+33599, vrr_stack+60268, vrr_stack+33269, vrr_stack+60488);
 _BUILD_00n0(Data,vrr_stack+33269, vrr_stack+1340, vrr_stack+17088, vrr_stack+16013, vrr_stack+16508, NULL);
 _BUILD_p0n0(Data,vrr_stack+60334, vrr_stack+33335, vrr_stack+33269, NULL, NULL, vrr_stack+1340);
 _BUILD_d0n0(Data,vrr_stack+34787, vrr_stack+33401, vrr_stack+60334, vrr_stack+33203, vrr_stack+33335, vrr_stack+61478);
 _BUILD_f0n0(Data,vrr_stack+61478, vrr_stack+33797, vrr_stack+34787, vrr_stack+33599, vrr_stack+33401, vrr_stack+45857);
 _BUILD_f0n0(Data,vrr_stack+62138, vrr_stack+34391, vrr_stack+33797, vrr_stack+34193, vrr_stack+33599, vrr_stack+60653);
 _BUILD_g0n0(Data,vrr_stack+62798, vrr_stack+62138, vrr_stack+61478, vrr_stack+34391, vrr_stack+33797, vrr_stack+4655);
 _BUILD_00n0(Data,vrr_stack+33203, vrr_stack+16868, vrr_stack+1285, vrr_stack+8889, vrr_stack+15968, NULL);
 _BUILD_p0n0(Data,vrr_stack+33599, vrr_stack+33203, vrr_stack+60268, NULL, NULL, vrr_stack+1285);
 _BUILD_d0n0(Data,vrr_stack+45857, vrr_stack+33599, vrr_stack+34193, vrr_stack+33203, vrr_stack+60268, vrr_stack+60983);
 _BUILD_f0n0(Data,vrr_stack+40367, vrr_stack+45857, vrr_stack+34391, vrr_stack+33599, vrr_stack+34193, vrr_stack+61148);
 _BUILD_g0n0(Data,vrr_stack+3800, vrr_stack+40367, vrr_stack+62138, vrr_stack+45857, vrr_stack+34391, vrr_stack+37793);
 _BUILD_00n0(Data,vrr_stack+37793, vrr_stack+17088, vrr_stack+16058, vrr_stack+16508, vrr_stack+33158, NULL);
 _BUILD_p0n0(Data,vrr_stack+37859, vrr_stack+33269, vrr_stack+37793, NULL, NULL, vrr_stack+17088);
 _BUILD_d0n0(Data,vrr_stack+34193, vrr_stack+60334, vrr_stack+37859, vrr_stack+33335, vrr_stack+33269, vrr_stack+17143);
 _BUILD_f0n0(Data,vrr_stack+60532, vrr_stack+34787, vrr_stack+34193, vrr_stack+33401, vrr_stack+60334, vrr_stack+8559);
 _BUILD_g0n0(Data,vrr_stack+0, vrr_stack+61478, vrr_stack+60532, vrr_stack+33797, vrr_stack+34787, vrr_stack+17308);
 _BUILD_h0n0(Data,vrr_stack+87948, vrr_stack+62798, vrr_stack+0, vrr_stack+62138, vrr_stack+61478, vrr_stack+67103);
 _BUILD_h0n0(Data,vrr_stack+89334, vrr_stack+3800, vrr_stack+62798, vrr_stack+40367, vrr_stack+62138, vrr_stack+12304);
 _BUILD_i0n0(Data,vrr_stack+90720, vrr_stack+89334, vrr_stack+87948, vrr_stack+3800, vrr_stack+62798, vrr_stack+67928);
 _BUILD_00n0(Data,vrr_stack+12304, vrr_stack+48278, vrr_stack+16868, vrr_stack+19508, vrr_stack+8889, NULL);
 _BUILD_p0n0(Data,vrr_stack+34589, vrr_stack+12304, vrr_stack+33203, NULL, NULL, vrr_stack+16868);
 _BUILD_d0n0(Data,vrr_stack+33797, vrr_stack+34589, vrr_stack+33599, vrr_stack+12304, vrr_stack+33203, vrr_stack+16923);
 _BUILD_f0n0(Data,vrr_stack+62138, vrr_stack+33797, vrr_stack+45857, vrr_stack+34589, vrr_stack+33599, vrr_stack+2230);
 _BUILD_g0n0(Data,vrr_stack+12370, vrr_stack+62138, vrr_stack+40367, vrr_stack+33797, vrr_stack+45857, vrr_stack+1395);
 _BUILD_h0n0(Data,vrr_stack+67103, vrr_stack+12370, vrr_stack+3800, vrr_stack+62138, vrr_stack+40367, vrr_stack+66278);
 _BUILD_i0n0(Data,vrr_stack+92568, vrr_stack+67103, vrr_stack+89334, vrr_stack+12370, vrr_stack+3800, vrr_stack+69083);
 _BUILD_00n0(Data,vrr_stack+33203, vrr_stack+16058, vrr_stack+56471, vrr_stack+33158, vrr_stack+3755, NULL);
 _BUILD_p0n0(Data,vrr_stack+3800, vrr_stack+37793, vrr_stack+33203, NULL, NULL, vrr_stack+16058);
 _BUILD_d0n0(Data,vrr_stack+3998, vrr_stack+37859, vrr_stack+3800, vrr_stack+33269, vrr_stack+37793, vrr_stack+16113);
 _BUILD_f0n0(Data,vrr_stack+4394, vrr_stack+34193, vrr_stack+3998, vrr_stack+60334, vrr_stack+37859, vrr_stack+49378);
 _BUILD_g0n0(Data,vrr_stack+40367, vrr_stack+60532, vrr_stack+4394, vrr_stack+34787, vrr_stack+34193, vrr_stack+49708);
 _BUILD_h0n0(Data,vrr_stack+68489, vrr_stack+0, vrr_stack+40367, vrr_stack+61478, vrr_stack+60532, vrr_stack+14894);
 _BUILD_i0n0(Data,vrr_stack+14894, vrr_stack+87948, vrr_stack+68489, vrr_stack+62798, vrr_stack+0, vrr_stack+21574);
 _BUILD_k0n0(Data,vrr_stack+94416, vrr_stack+90720, vrr_stack+14894, vrr_stack+89334, vrr_stack+87948, vrr_stack+72933);
 _BUILD_k0n0(Data,vrr_stack+96792, vrr_stack+92568, vrr_stack+90720, vrr_stack+67103, vrr_stack+89334, vrr_stack+70238);
 _BUILD_l0n0(Data,vrr_stack+99168, vrr_stack+96792, vrr_stack+94416, vrr_stack+92568, vrr_stack+90720, vrr_stack+74473);
 _BUILD_00n0(Data,vrr_stack+89334, vrr_stack+56288, vrr_stack+48278, vrr_stack+40322, vrr_stack+19508, NULL);
 _BUILD_p0n0(Data,vrr_stack+19508, vrr_stack+89334, vrr_stack+12304, NULL, NULL, vrr_stack+48278);
 _BUILD_d0n0(Data,vrr_stack+19706, vrr_stack+19508, vrr_stack+34589, vrr_stack+89334, vrr_stack+12304, vrr_stack+48333);
 _BUILD_f0n0(Data,vrr_stack+89334, vrr_stack+19706, vrr_stack+33797, vrr_stack+19508, vrr_stack+34589, vrr_stack+48498);
 _BUILD_g0n0(Data,vrr_stack+34589, vrr_stack+89334, vrr_stack+62138, vrr_stack+19706, vrr_stack+33797, vrr_stack+48828);
 _BUILD_h0n0(Data,vrr_stack+48278, vrr_stack+34589, vrr_stack+12370, vrr_stack+89334, vrr_stack+62138, vrr_stack+8934);
   tmp = vrr_stack + 48278;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+72933, vrr_stack+48278, vrr_stack+67103, vrr_stack+34589, vrr_stack+12370, vrr_stack+71778);
   tmp = vrr_stack + 72933;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0n0(Data,vrr_stack+69875, vrr_stack+72933, vrr_stack+92568, vrr_stack+48278, vrr_stack+67103, vrr_stack+5205);
   tmp = vrr_stack + 69875;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+102138, vrr_stack+69875, vrr_stack+96792, vrr_stack+72933, vrr_stack+92568, vrr_stack+54308);
   tmp = vrr_stack + 102138;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+92568, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+92571, vrr_stack+56343, vrr_stack+92568, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+92577, vrr_stack+56346, vrr_stack+92571, vrr_stack+3636, vrr_stack+56343, NULL);
 _BUILD_00g0(Data,vrr_stack+92587, vrr_stack+56352, vrr_stack+92577, vrr_stack+3639, vrr_stack+56346, NULL);
 _BUILD_00h0(Data,vrr_stack+92602, vrr_stack+56362, vrr_stack+92587, vrr_stack+3645, vrr_stack+56352, NULL);
 _BUILD_00i0(Data,vrr_stack+92568, vrr_stack+56377, vrr_stack+92602, vrr_stack+3655, vrr_stack+56362, NULL);
 _BUILD_00k0(Data,vrr_stack+92596, vrr_stack+56398, vrr_stack+92568, vrr_stack+3670, vrr_stack+56377, NULL);
 _BUILD_00l0(Data,vrr_stack+33158, vrr_stack+21538, vrr_stack+92596, vrr_stack+3691, vrr_stack+56398, NULL);
 _BUILD_00m0(Data,vrr_stack+92568, vrr_stack+56426, vrr_stack+33158, vrr_stack+3719, vrr_stack+21538, NULL);
 _BUILD_00n0(Data,vrr_stack+21538, vrr_stack+56471, vrr_stack+92568, vrr_stack+3755, vrr_stack+56426, NULL);
 _BUILD_p0n0(Data,vrr_stack+92568, vrr_stack+33203, vrr_stack+21538, NULL, NULL, vrr_stack+56471);
 _BUILD_d0n0(Data,vrr_stack+21538, vrr_stack+3800, vrr_stack+92568, vrr_stack+37793, vrr_stack+33203, vrr_stack+56526);
 _BUILD_f0n0(Data,vrr_stack+92568, vrr_stack+3998, vrr_stack+21538, vrr_stack+37859, vrr_stack+3800, vrr_stack+56691);
 _BUILD_g0n0(Data,vrr_stack+21538, vrr_stack+4394, vrr_stack+92568, vrr_stack+34193, vrr_stack+3998, vrr_stack+57021);
 _BUILD_h0n0(Data,vrr_stack+89334, vrr_stack+40367, vrr_stack+21538, vrr_stack+60532, vrr_stack+4394, vrr_stack+52733);
 _BUILD_i0n0(Data,vrr_stack+92568, vrr_stack+68489, vrr_stack+89334, vrr_stack+0, vrr_stack+40367, vrr_stack+38343);
 _BUILD_k0n0(Data,vrr_stack+0, vrr_stack+14894, vrr_stack+92568, vrr_stack+87948, vrr_stack+68489, vrr_stack+78928);
 _BUILD_l0n0(Data,vrr_stack+52733, vrr_stack+94416, vrr_stack+0, vrr_stack+90720, vrr_stack+14894, vrr_stack+80468);
 _BUILD_m0n0(Data,vrr_stack+87948, vrr_stack+99168, vrr_stack+52733, vrr_stack+96792, vrr_stack+94416, vrr_stack+82448);
 _BUILD_m0n0(Data,vrr_stack+52733, vrr_stack+102138, vrr_stack+99168, vrr_stack+69875, vrr_stack+96792, vrr_stack+76453);
   tmp = vrr_stack + 52733;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0h0(Data,vrr_stack+56363, vrr_stack+9918, vrr_stack+20383, vrr_stack+2691, vrr_stack+7188, vrr_stack+11479);
   tmp = vrr_stack + 56363;
   target_ptr = Libint->vrr_classes[10][5];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0i0(Data,vrr_stack+14894, vrr_stack+17968, vrr_stack+31618, vrr_stack+13634, vrr_stack+28090, vrr_stack+20383);
   tmp = vrr_stack + 14894;
   target_ptr = Libint->vrr_classes[10][6];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0k0(Data,vrr_stack+16742, vrr_stack+29350, vrr_stack+46298, vrr_stack+22870, vrr_stack+41762, vrr_stack+31618);
   tmp = vrr_stack + 16742;
   target_ptr = Libint->vrr_classes[10][7];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0l0(Data,vrr_stack+19118, vrr_stack+43382, vrr_stack+63803, vrr_stack+35768, vrr_stack+58133, vrr_stack+46298);
   tmp = vrr_stack + 19118;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0m0(Data,vrr_stack+57749, vrr_stack+84923, vrr_stack+24490, vrr_stack+50258, vrr_stack+76453, vrr_stack+63803);
   tmp = vrr_stack + 57749;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+61379, vrr_stack+52733, vrr_stack+87948, vrr_stack+102138, vrr_stack+99168, vrr_stack+24490);
   tmp = vrr_stack + 61379;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];

}

