/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (id|ii) integrals */

void vrr_order_idii(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+15, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+18, vrr_stack+15, vrr_stack+12, NULL, NULL, Data->F+7);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+30, vrr_stack+27, vrr_stack+15, NULL, NULL, Data->F+6);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+42, vrr_stack+12, vrr_stack+39, NULL, NULL, Data->F+8);
 _BUILD_d0p0(Data,vrr_stack+51, vrr_stack+18, vrr_stack+42, vrr_stack+15, vrr_stack+12, vrr_stack+0);
 _BUILD_d0p0(Data,vrr_stack+69, vrr_stack+30, vrr_stack+18, vrr_stack+27, vrr_stack+15, vrr_stack+3);
 _BUILD_f0p0(Data,vrr_stack+87, vrr_stack+69, vrr_stack+51, vrr_stack+30, vrr_stack+18, vrr_stack+6);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+15, vrr_stack+12, Data->F+6, Data->F+7, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+27, vrr_stack+15, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+12, vrr_stack+39, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+123, vrr_stack+0, vrr_stack+117, NULL, NULL, vrr_stack+12);
 _BUILD_p0d0(Data,vrr_stack+141, vrr_stack+6, vrr_stack+0, NULL, NULL, vrr_stack+15);
 _BUILD_d0d0(Data,vrr_stack+159, vrr_stack+141, vrr_stack+123, vrr_stack+6, vrr_stack+0, vrr_stack+18);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+18, vrr_stack+27, Data->F+4, Data->F+5, NULL);
 _BUILD_p0d0(Data,vrr_stack+195, vrr_stack+21, vrr_stack+6, NULL, NULL, vrr_stack+27);
 _BUILD_d0d0(Data,vrr_stack+213, vrr_stack+195, vrr_stack+141, vrr_stack+21, vrr_stack+6, vrr_stack+30);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+39, vrr_stack+30, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+249, vrr_stack+117, vrr_stack+33, NULL, NULL, vrr_stack+39);
 _BUILD_d0d0(Data,vrr_stack+267, vrr_stack+123, vrr_stack+249, vrr_stack+0, vrr_stack+117, vrr_stack+42);
 _BUILD_f0d0(Data,vrr_stack+303, vrr_stack+159, vrr_stack+267, vrr_stack+141, vrr_stack+123, vrr_stack+51);
 _BUILD_f0d0(Data,vrr_stack+363, vrr_stack+213, vrr_stack+159, vrr_stack+195, vrr_stack+141, vrr_stack+69);
 _BUILD_g0d0(Data,vrr_stack+423, vrr_stack+363, vrr_stack+303, vrr_stack+213, vrr_stack+159, vrr_stack+87);
 _BUILD_00f0(Data,vrr_stack+42, vrr_stack+0, vrr_stack+117, vrr_stack+15, vrr_stack+12, NULL);
 _BUILD_00f0(Data,vrr_stack+52, vrr_stack+6, vrr_stack+0, vrr_stack+27, vrr_stack+15, NULL);
 _BUILD_p0f0(Data,vrr_stack+62, vrr_stack+52, vrr_stack+42, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+92, vrr_stack+21, vrr_stack+6, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_p0f0(Data,vrr_stack+513, vrr_stack+92, vrr_stack+52, NULL, NULL, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+102, vrr_stack+117, vrr_stack+33, vrr_stack+12, vrr_stack+39, NULL);
 _BUILD_p0f0(Data,vrr_stack+543, vrr_stack+42, vrr_stack+102, NULL, NULL, vrr_stack+117);
 _BUILD_d0f0(Data,vrr_stack+573, vrr_stack+62, vrr_stack+543, vrr_stack+52, vrr_stack+42, vrr_stack+123);
 _BUILD_d0f0(Data,vrr_stack+633, vrr_stack+513, vrr_stack+62, vrr_stack+92, vrr_stack+52, vrr_stack+141);
 _BUILD_f0f0(Data,vrr_stack+693, vrr_stack+633, vrr_stack+573, vrr_stack+513, vrr_stack+62, vrr_stack+159);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+27, vrr_stack+18, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+12, vrr_stack+21, vrr_stack+27, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+133, vrr_stack+123, vrr_stack+92, NULL, NULL, vrr_stack+21);
 _BUILD_d0f0(Data,vrr_stack+793, vrr_stack+133, vrr_stack+513, vrr_stack+123, vrr_stack+92, vrr_stack+195);
 _BUILD_f0f0(Data,vrr_stack+853, vrr_stack+793, vrr_stack+633, vrr_stack+133, vrr_stack+513, vrr_stack+213);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+163, vrr_stack+30, vrr_stack+18, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+169, vrr_stack+33, vrr_stack+163, vrr_stack+39, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+179, vrr_stack+102, vrr_stack+169, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+953, vrr_stack+543, vrr_stack+179, vrr_stack+42, vrr_stack+102, vrr_stack+249);
 _BUILD_f0f0(Data,vrr_stack+1013, vrr_stack+573, vrr_stack+953, vrr_stack+62, vrr_stack+543, vrr_stack+267);
 _BUILD_g0f0(Data,vrr_stack+1113, vrr_stack+693, vrr_stack+1013, vrr_stack+633, vrr_stack+573, vrr_stack+303);
 _BUILD_g0f0(Data,vrr_stack+209, vrr_stack+853, vrr_stack+693, vrr_stack+793, vrr_stack+633, vrr_stack+363);
 _BUILD_h0f0(Data,vrr_stack+1263, vrr_stack+209, vrr_stack+1113, vrr_stack+853, vrr_stack+693, vrr_stack+423);
 _BUILD_00g0(Data,vrr_stack+359, vrr_stack+52, vrr_stack+42, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+374, vrr_stack+92, vrr_stack+52, vrr_stack+21, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+389, vrr_stack+42, vrr_stack+102, vrr_stack+0, vrr_stack+117, NULL);
 _BUILD_p0g0(Data,vrr_stack+404, vrr_stack+359, vrr_stack+389, NULL, NULL, vrr_stack+42);
 _BUILD_p0g0(Data,vrr_stack+449, vrr_stack+374, vrr_stack+359, NULL, NULL, vrr_stack+52);
 _BUILD_d0g0(Data,vrr_stack+1473, vrr_stack+449, vrr_stack+404, vrr_stack+374, vrr_stack+359, vrr_stack+62);
 _BUILD_00g0(Data,vrr_stack+62, vrr_stack+123, vrr_stack+92, vrr_stack+12, vrr_stack+21, NULL);
 _BUILD_p0g0(Data,vrr_stack+1563, vrr_stack+62, vrr_stack+374, NULL, NULL, vrr_stack+92);
 _BUILD_d0g0(Data,vrr_stack+1608, vrr_stack+1563, vrr_stack+449, vrr_stack+62, vrr_stack+374, vrr_stack+513);
 _BUILD_00g0(Data,vrr_stack+77, vrr_stack+102, vrr_stack+169, vrr_stack+117, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+494, vrr_stack+389, vrr_stack+77, NULL, NULL, vrr_stack+102);
 _BUILD_d0g0(Data,vrr_stack+1698, vrr_stack+404, vrr_stack+494, vrr_stack+359, vrr_stack+389, vrr_stack+543);
 _BUILD_f0g0(Data,vrr_stack+1788, vrr_stack+1473, vrr_stack+1698, vrr_stack+449, vrr_stack+404, vrr_stack+573);
 _BUILD_f0g0(Data,vrr_stack+1938, vrr_stack+1608, vrr_stack+1473, vrr_stack+1563, vrr_stack+449, vrr_stack+633);
 _BUILD_g0g0(Data,vrr_stack+2088, vrr_stack+1938, vrr_stack+1788, vrr_stack+1608, vrr_stack+1473, vrr_stack+693);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+27, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+0, vrr_stack+21, vrr_stack+12, vrr_stack+39, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+539, vrr_stack+0, vrr_stack+123, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+554, vrr_stack+539, vrr_stack+62, NULL, NULL, vrr_stack+123);
 _BUILD_d0g0(Data,vrr_stack+599, vrr_stack+554, vrr_stack+1563, vrr_stack+539, vrr_stack+62, vrr_stack+133);
 _BUILD_f0g0(Data,vrr_stack+2313, vrr_stack+599, vrr_stack+1608, vrr_stack+554, vrr_stack+1563, vrr_stack+793);
 _BUILD_g0g0(Data,vrr_stack+2463, vrr_stack+2313, vrr_stack+1938, vrr_stack+599, vrr_stack+1608, vrr_stack+853);
 _BUILD_00p0(Data,vrr_stack+27, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+133, vrr_stack+18, vrr_stack+27, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+139, vrr_stack+163, vrr_stack+133, vrr_stack+30, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+689, vrr_stack+169, vrr_stack+139, vrr_stack+33, vrr_stack+163, NULL);
 _BUILD_p0g0(Data,vrr_stack+704, vrr_stack+77, vrr_stack+689, NULL, NULL, vrr_stack+169);
 _BUILD_d0g0(Data,vrr_stack+749, vrr_stack+494, vrr_stack+704, vrr_stack+389, vrr_stack+77, vrr_stack+179);
 _BUILD_f0g0(Data,vrr_stack+2688, vrr_stack+1698, vrr_stack+749, vrr_stack+404, vrr_stack+494, vrr_stack+953);
 _BUILD_g0g0(Data,vrr_stack+2838, vrr_stack+1788, vrr_stack+2688, vrr_stack+1473, vrr_stack+1698, vrr_stack+1013);
 _BUILD_h0g0(Data,vrr_stack+3063, vrr_stack+2088, vrr_stack+2838, vrr_stack+1938, vrr_stack+1788, vrr_stack+1113);
 _BUILD_h0g0(Data,vrr_stack+839, vrr_stack+2463, vrr_stack+2088, vrr_stack+2313, vrr_stack+1938, vrr_stack+209);
 _BUILD_i0g0(Data,vrr_stack+3378, vrr_stack+839, vrr_stack+3063, vrr_stack+2463, vrr_stack+2088, vrr_stack+1263);
 _BUILD_00h0(Data,vrr_stack+179, vrr_stack+359, vrr_stack+389, vrr_stack+52, vrr_stack+42, NULL);
 _BUILD_00h0(Data,vrr_stack+200, vrr_stack+374, vrr_stack+359, vrr_stack+92, vrr_stack+52, NULL);
 _BUILD_p0h0(Data,vrr_stack+221, vrr_stack+200, vrr_stack+179, NULL, NULL, vrr_stack+359);
 _BUILD_00h0(Data,vrr_stack+284, vrr_stack+62, vrr_stack+374, vrr_stack+123, vrr_stack+92, NULL);
 _BUILD_p0h0(Data,vrr_stack+1154, vrr_stack+284, vrr_stack+200, NULL, NULL, vrr_stack+374);
 _BUILD_00h0(Data,vrr_stack+305, vrr_stack+389, vrr_stack+77, vrr_stack+42, vrr_stack+102, NULL);
 _BUILD_p0h0(Data,vrr_stack+1217, vrr_stack+179, vrr_stack+305, NULL, NULL, vrr_stack+389);
 _BUILD_d0h0(Data,vrr_stack+1280, vrr_stack+221, vrr_stack+1217, vrr_stack+200, vrr_stack+179, vrr_stack+404);
 _BUILD_d0h0(Data,vrr_stack+3798, vrr_stack+1154, vrr_stack+221, vrr_stack+284, vrr_stack+200, vrr_stack+449);
 _BUILD_f0h0(Data,vrr_stack+3924, vrr_stack+3798, vrr_stack+1280, vrr_stack+1154, vrr_stack+221, vrr_stack+1473);
 _BUILD_00h0(Data,vrr_stack+404, vrr_stack+539, vrr_stack+62, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_p0h0(Data,vrr_stack+425, vrr_stack+404, vrr_stack+284, NULL, NULL, vrr_stack+62);
 _BUILD_d0h0(Data,vrr_stack+1406, vrr_stack+425, vrr_stack+1154, vrr_stack+404, vrr_stack+284, vrr_stack+1563);
 _BUILD_f0h0(Data,vrr_stack+4134, vrr_stack+1406, vrr_stack+3798, vrr_stack+425, vrr_stack+1154, vrr_stack+1608);
 _BUILD_00h0(Data,vrr_stack+112, vrr_stack+77, vrr_stack+689, vrr_stack+102, vrr_stack+169, NULL);
 _BUILD_p0h0(Data,vrr_stack+1532, vrr_stack+305, vrr_stack+112, NULL, NULL, vrr_stack+77);
 _BUILD_d0h0(Data,vrr_stack+4344, vrr_stack+1217, vrr_stack+1532, vrr_stack+179, vrr_stack+305, vrr_stack+494);
 _BUILD_f0h0(Data,vrr_stack+4470, vrr_stack+1280, vrr_stack+4344, vrr_stack+221, vrr_stack+1217, vrr_stack+1698);
 _BUILD_g0h0(Data,vrr_stack+4680, vrr_stack+3924, vrr_stack+4470, vrr_stack+3798, vrr_stack+1280, vrr_stack+1788);
 _BUILD_g0h0(Data,vrr_stack+1595, vrr_stack+4134, vrr_stack+3924, vrr_stack+1406, vrr_stack+3798, vrr_stack+1938);
 _BUILD_h0h0(Data,vrr_stack+4995, vrr_stack+1595, vrr_stack+4680, vrr_stack+4134, vrr_stack+3924, vrr_stack+2088);
 _BUILD_00p0(Data,vrr_stack+488, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+491, vrr_stack+488, vrr_stack+39, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+497, vrr_stack+491, vrr_stack+21, vrr_stack+488, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+507, vrr_stack+497, vrr_stack+0, vrr_stack+491, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+326, vrr_stack+507, vrr_stack+539, vrr_stack+497, vrr_stack+0, NULL);
 _BUILD_p0h0(Data,vrr_stack+1910, vrr_stack+326, vrr_stack+404, NULL, NULL, vrr_stack+539);
 _BUILD_d0h0(Data,vrr_stack+1973, vrr_stack+1910, vrr_stack+425, vrr_stack+326, vrr_stack+404, vrr_stack+554);
 _BUILD_f0h0(Data,vrr_stack+2099, vrr_stack+1973, vrr_stack+1406, vrr_stack+1910, vrr_stack+425, vrr_stack+599);
 _BUILD_g0h0(Data,vrr_stack+5436, vrr_stack+2099, vrr_stack+4134, vrr_stack+1973, vrr_stack+1406, vrr_stack+2313);
 _BUILD_h0h0(Data,vrr_stack+5751, vrr_stack+5436, vrr_stack+1595, vrr_stack+2099, vrr_stack+4134, vrr_stack+2463);
 _BUILD_00p0(Data,vrr_stack+554, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+27, vrr_stack+554, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+557, vrr_stack+133, vrr_stack+21, vrr_stack+18, vrr_stack+27, NULL);
 _BUILD_00g0(Data,vrr_stack+567, vrr_stack+139, vrr_stack+557, vrr_stack+163, vrr_stack+133, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+689, vrr_stack+567, vrr_stack+169, vrr_stack+139, NULL);
 _BUILD_p0h0(Data,vrr_stack+582, vrr_stack+112, vrr_stack+0, NULL, NULL, vrr_stack+689);
 _BUILD_d0h0(Data,vrr_stack+2309, vrr_stack+1532, vrr_stack+582, vrr_stack+305, vrr_stack+112, vrr_stack+704);
 _BUILD_f0h0(Data,vrr_stack+2435, vrr_stack+4344, vrr_stack+2309, vrr_stack+1217, vrr_stack+1532, vrr_stack+749);
 _BUILD_g0h0(Data,vrr_stack+6192, vrr_stack+4470, vrr_stack+2435, vrr_stack+1280, vrr_stack+4344, vrr_stack+2688);
 _BUILD_h0h0(Data,vrr_stack+6507, vrr_stack+4680, vrr_stack+6192, vrr_stack+3924, vrr_stack+4470, vrr_stack+2838);
 _BUILD_i0h0(Data,vrr_stack+6948, vrr_stack+4995, vrr_stack+6507, vrr_stack+1595, vrr_stack+4680, vrr_stack+3063);
 _BUILD_i0h0(Data,vrr_stack+2645, vrr_stack+5751, vrr_stack+4995, vrr_stack+5436, vrr_stack+1595, vrr_stack+839);
 _BUILD_k0h0(Data,vrr_stack+7536, vrr_stack+2645, vrr_stack+6948, vrr_stack+5751, vrr_stack+4995, vrr_stack+3378);
 _BUILD_00i0(Data,vrr_stack+704, vrr_stack+200, vrr_stack+179, vrr_stack+374, vrr_stack+359, NULL);
 _BUILD_00i0(Data,vrr_stack+732, vrr_stack+284, vrr_stack+200, vrr_stack+62, vrr_stack+374, NULL);
 _BUILD_00i0(Data,vrr_stack+760, vrr_stack+179, vrr_stack+305, vrr_stack+359, vrr_stack+389, NULL);
 _BUILD_p0i0(Data,vrr_stack+788, vrr_stack+704, vrr_stack+760, NULL, NULL, vrr_stack+179);
 _BUILD_p0i0(Data,vrr_stack+872, vrr_stack+732, vrr_stack+704, NULL, NULL, vrr_stack+200);
 _BUILD_d0i0(Data,vrr_stack+956, vrr_stack+872, vrr_stack+788, vrr_stack+732, vrr_stack+704, vrr_stack+221);
 _BUILD_00i0(Data,vrr_stack+221, vrr_stack+404, vrr_stack+284, vrr_stack+539, vrr_stack+62, NULL);
 _BUILD_p0i0(Data,vrr_stack+3233, vrr_stack+221, vrr_stack+732, NULL, NULL, vrr_stack+284);
 _BUILD_d0i0(Data,vrr_stack+3317, vrr_stack+3233, vrr_stack+872, vrr_stack+221, vrr_stack+732, vrr_stack+1154);
 _BUILD_00i0(Data,vrr_stack+249, vrr_stack+305, vrr_stack+112, vrr_stack+389, vrr_stack+77, NULL);
 _BUILD_p0i0(Data,vrr_stack+1124, vrr_stack+760, vrr_stack+249, NULL, NULL, vrr_stack+305);
 _BUILD_d0i0(Data,vrr_stack+3485, vrr_stack+788, vrr_stack+1124, vrr_stack+704, vrr_stack+760, vrr_stack+1217);
 _BUILD_f0i0(Data,vrr_stack+8292, vrr_stack+956, vrr_stack+3485, vrr_stack+872, vrr_stack+788, vrr_stack+1280);
 _BUILD_f0i0(Data,vrr_stack+8572, vrr_stack+3317, vrr_stack+956, vrr_stack+3233, vrr_stack+872, vrr_stack+3798);
 _BUILD_g0i0(Data,vrr_stack+8852, vrr_stack+8572, vrr_stack+8292, vrr_stack+3317, vrr_stack+956, vrr_stack+3924);
 _BUILD_00i0(Data,vrr_stack+1208, vrr_stack+326, vrr_stack+404, vrr_stack+507, vrr_stack+539, NULL);
 _BUILD_p0i0(Data,vrr_stack+1236, vrr_stack+1208, vrr_stack+221, NULL, NULL, vrr_stack+404);
 _BUILD_d0i0(Data,vrr_stack+3653, vrr_stack+1236, vrr_stack+3233, vrr_stack+1208, vrr_stack+221, vrr_stack+425);
 _BUILD_f0i0(Data,vrr_stack+3821, vrr_stack+3653, vrr_stack+3317, vrr_stack+1236, vrr_stack+3233, vrr_stack+1406);
 _BUILD_g0i0(Data,vrr_stack+9272, vrr_stack+3821, vrr_stack+8572, vrr_stack+3653, vrr_stack+3317, vrr_stack+4134);
 _BUILD_00i0(Data,vrr_stack+425, vrr_stack+112, vrr_stack+0, vrr_stack+77, vrr_stack+689, NULL);
 _BUILD_p0i0(Data,vrr_stack+1320, vrr_stack+249, vrr_stack+425, NULL, NULL, vrr_stack+112);
 _BUILD_d0i0(Data,vrr_stack+4101, vrr_stack+1124, vrr_stack+1320, vrr_stack+760, vrr_stack+249, vrr_stack+1532);
 _BUILD_f0i0(Data,vrr_stack+9692, vrr_stack+3485, vrr_stack+4101, vrr_stack+788, vrr_stack+1124, vrr_stack+4344);
 _BUILD_g0i0(Data,vrr_stack+9972, vrr_stack+8292, vrr_stack+9692, vrr_stack+956, vrr_stack+3485, vrr_stack+4470);
 _BUILD_h0i0(Data,vrr_stack+10392, vrr_stack+8852, vrr_stack+9972, vrr_stack+8572, vrr_stack+8292, vrr_stack+4680);
 _BUILD_h0i0(Data,vrr_stack+4269, vrr_stack+9272, vrr_stack+8852, vrr_stack+3821, vrr_stack+8572, vrr_stack+1595);
 _BUILD_i0i0(Data,vrr_stack+10980, vrr_stack+4269, vrr_stack+10392, vrr_stack+9272, vrr_stack+8852, vrr_stack+4995);
 _BUILD_00p0(Data,vrr_stack+453, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+456, vrr_stack+453, vrr_stack+488, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+462, vrr_stack+456, vrr_stack+491, vrr_stack+453, vrr_stack+488, NULL);
 _BUILD_00g0(Data,vrr_stack+472, vrr_stack+462, vrr_stack+497, vrr_stack+456, vrr_stack+491, NULL);
 _BUILD_00h0(Data,vrr_stack+1404, vrr_stack+472, vrr_stack+507, vrr_stack+462, vrr_stack+497, NULL);
 _BUILD_00i0(Data,vrr_stack+1425, vrr_stack+1404, vrr_stack+326, vrr_stack+472, vrr_stack+507, NULL);
 _BUILD_p0i0(Data,vrr_stack+453, vrr_stack+1425, vrr_stack+1208, NULL, NULL, vrr_stack+326);
 _BUILD_d0i0(Data,vrr_stack+1453, vrr_stack+453, vrr_stack+1236, vrr_stack+1425, vrr_stack+1208, vrr_stack+1910);
 _BUILD_f0i0(Data,vrr_stack+1621, vrr_stack+1453, vrr_stack+3653, vrr_stack+453, vrr_stack+1236, vrr_stack+1973);
 _BUILD_g0i0(Data,vrr_stack+4857, vrr_stack+1621, vrr_stack+3821, vrr_stack+1453, vrr_stack+3653, vrr_stack+2099);
 _BUILD_h0i0(Data,vrr_stack+11764, vrr_stack+4857, vrr_stack+9272, vrr_stack+1621, vrr_stack+3821, vrr_stack+5436);
 _BUILD_i0i0(Data,vrr_stack+1453, vrr_stack+11764, vrr_stack+4269, vrr_stack+4857, vrr_stack+9272, vrr_stack+5751);
   tmp = vrr_stack + 1453;
   target_ptr = Libint->vrr_classes[6][6];
   for(i=0;i<784;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+4857, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4860, vrr_stack+554, vrr_stack+4857, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+4866, vrr_stack+21, vrr_stack+4860, vrr_stack+27, vrr_stack+554, NULL);
 _BUILD_00g0(Data,vrr_stack+27, vrr_stack+557, vrr_stack+4866, vrr_stack+133, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+567, vrr_stack+27, vrr_stack+139, vrr_stack+557, NULL);
 _BUILD_00i0(Data,vrr_stack+133, vrr_stack+0, vrr_stack+42, vrr_stack+689, vrr_stack+567, NULL);
 _BUILD_p0i0(Data,vrr_stack+4876, vrr_stack+425, vrr_stack+133, NULL, NULL, vrr_stack+0);
 _BUILD_d0i0(Data,vrr_stack+4960, vrr_stack+1320, vrr_stack+4876, vrr_stack+249, vrr_stack+425, vrr_stack+582);
 _BUILD_f0i0(Data,vrr_stack+5128, vrr_stack+4101, vrr_stack+4960, vrr_stack+1124, vrr_stack+1320, vrr_stack+2309);
 _BUILD_g0i0(Data,vrr_stack+5408, vrr_stack+9692, vrr_stack+5128, vrr_stack+3485, vrr_stack+4101, vrr_stack+2435);
 _BUILD_h0i0(Data,vrr_stack+12352, vrr_stack+9972, vrr_stack+5408, vrr_stack+8292, vrr_stack+9692, vrr_stack+6192);
 _BUILD_i0i0(Data,vrr_stack+12940, vrr_stack+10392, vrr_stack+12352, vrr_stack+8852, vrr_stack+9972, vrr_stack+6507);
 _BUILD_k0i0(Data,vrr_stack+5828, vrr_stack+10980, vrr_stack+12940, vrr_stack+4269, vrr_stack+10392, vrr_stack+6948);
 _BUILD_k0i0(Data,vrr_stack+13724, vrr_stack+1453, vrr_stack+10980, vrr_stack+11764, vrr_stack+4269, vrr_stack+2645);
   tmp = vrr_stack + 13724;
   target_ptr = Libint->vrr_classes[7][6];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+11764, vrr_stack+704, vrr_stack+760, vrr_stack+200, vrr_stack+179, NULL);
 _BUILD_00k0(Data,vrr_stack+11800, vrr_stack+732, vrr_stack+704, vrr_stack+284, vrr_stack+200, NULL);
 _BUILD_00k0(Data,vrr_stack+11836, vrr_stack+760, vrr_stack+249, vrr_stack+179, vrr_stack+305, NULL);
 _BUILD_p0k0(Data,vrr_stack+11872, vrr_stack+11764, vrr_stack+11836, NULL, NULL, vrr_stack+760);
 _BUILD_p0k0(Data,vrr_stack+11980, vrr_stack+11800, vrr_stack+11764, NULL, NULL, vrr_stack+704);
 _BUILD_d0k0(Data,vrr_stack+12088, vrr_stack+11980, vrr_stack+11872, vrr_stack+11800, vrr_stack+11764, vrr_stack+788);
 _BUILD_00k0(Data,vrr_stack+788, vrr_stack+221, vrr_stack+732, vrr_stack+404, vrr_stack+284, NULL);
 _BUILD_p0k0(Data,vrr_stack+582, vrr_stack+788, vrr_stack+11800, NULL, NULL, vrr_stack+732);
 _BUILD_d0k0(Data,vrr_stack+6836, vrr_stack+582, vrr_stack+11980, vrr_stack+788, vrr_stack+11800, vrr_stack+872);
 _BUILD_00k0(Data,vrr_stack+824, vrr_stack+249, vrr_stack+425, vrr_stack+305, vrr_stack+112, NULL);
 _BUILD_p0k0(Data,vrr_stack+7052, vrr_stack+11836, vrr_stack+824, NULL, NULL, vrr_stack+249);
 _BUILD_d0k0(Data,vrr_stack+7160, vrr_stack+11872, vrr_stack+7052, vrr_stack+11764, vrr_stack+11836, vrr_stack+1124);
 _BUILD_f0k0(Data,vrr_stack+2237, vrr_stack+12088, vrr_stack+7160, vrr_stack+11980, vrr_stack+11872, vrr_stack+3485);
 _BUILD_f0k0(Data,vrr_stack+2597, vrr_stack+6836, vrr_stack+12088, vrr_stack+582, vrr_stack+11980, vrr_stack+956);
 _BUILD_g0k0(Data,vrr_stack+14732, vrr_stack+2597, vrr_stack+2237, vrr_stack+6836, vrr_stack+12088, vrr_stack+8292);
 _BUILD_00k0(Data,vrr_stack+8292, vrr_stack+1208, vrr_stack+221, vrr_stack+326, vrr_stack+404, NULL);
 _BUILD_p0k0(Data,vrr_stack+8328, vrr_stack+8292, vrr_stack+788, NULL, NULL, vrr_stack+221);
 _BUILD_d0k0(Data,vrr_stack+860, vrr_stack+8328, vrr_stack+582, vrr_stack+8292, vrr_stack+788, vrr_stack+3233);
 _BUILD_f0k0(Data,vrr_stack+2957, vrr_stack+860, vrr_stack+6836, vrr_stack+8328, vrr_stack+582, vrr_stack+3317);
 _BUILD_g0k0(Data,vrr_stack+15272, vrr_stack+2957, vrr_stack+2597, vrr_stack+860, vrr_stack+6836, vrr_stack+8572);
 _BUILD_00k0(Data,vrr_stack+3317, vrr_stack+425, vrr_stack+133, vrr_stack+112, vrr_stack+0, NULL);
 _BUILD_p0k0(Data,vrr_stack+3353, vrr_stack+824, vrr_stack+3317, NULL, NULL, vrr_stack+425);
 _BUILD_d0k0(Data,vrr_stack+8436, vrr_stack+7052, vrr_stack+3353, vrr_stack+11836, vrr_stack+824, vrr_stack+1320);
 _BUILD_f0k0(Data,vrr_stack+15812, vrr_stack+7160, vrr_stack+8436, vrr_stack+11872, vrr_stack+7052, vrr_stack+4101);
 _BUILD_g0k0(Data,vrr_stack+16172, vrr_stack+2237, vrr_stack+15812, vrr_stack+12088, vrr_stack+7160, vrr_stack+9692);
 _BUILD_h0k0(Data,vrr_stack+16712, vrr_stack+14732, vrr_stack+16172, vrr_stack+2597, vrr_stack+2237, vrr_stack+9972);
 _BUILD_h0k0(Data,vrr_stack+17468, vrr_stack+15272, vrr_stack+14732, vrr_stack+2957, vrr_stack+2597, vrr_stack+8852);
 _BUILD_i0k0(Data,vrr_stack+18224, vrr_stack+17468, vrr_stack+16712, vrr_stack+15272, vrr_stack+14732, vrr_stack+10392);
 _BUILD_00k0(Data,vrr_stack+9692, vrr_stack+1425, vrr_stack+1208, vrr_stack+1404, vrr_stack+326, NULL);
 _BUILD_p0k0(Data,vrr_stack+9728, vrr_stack+9692, vrr_stack+8292, NULL, NULL, vrr_stack+1208);
 _BUILD_d0k0(Data,vrr_stack+9836, vrr_stack+9728, vrr_stack+8328, vrr_stack+9692, vrr_stack+8292, vrr_stack+1236);
 _BUILD_f0k0(Data,vrr_stack+10052, vrr_stack+9836, vrr_stack+860, vrr_stack+9728, vrr_stack+8328, vrr_stack+3653);
 _BUILD_g0k0(Data,vrr_stack+10412, vrr_stack+10052, vrr_stack+2957, vrr_stack+9836, vrr_stack+860, vrr_stack+3821);
 _BUILD_h0k0(Data,vrr_stack+3461, vrr_stack+10412, vrr_stack+15272, vrr_stack+10052, vrr_stack+2957, vrr_stack+9272);
 _BUILD_i0k0(Data,vrr_stack+8652, vrr_stack+3461, vrr_stack+17468, vrr_stack+10412, vrr_stack+15272, vrr_stack+4269);
   tmp = vrr_stack + 8652;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+9728, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9731, vrr_stack+4857, vrr_stack+9728, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+9737, vrr_stack+4860, vrr_stack+9731, vrr_stack+554, vrr_stack+4857, NULL);
 _BUILD_00g0(Data,vrr_stack+9747, vrr_stack+4866, vrr_stack+9737, vrr_stack+21, vrr_stack+4860, NULL);
 _BUILD_00h0(Data,vrr_stack+9762, vrr_stack+27, vrr_stack+9747, vrr_stack+557, vrr_stack+4866, NULL);
 _BUILD_00i0(Data,vrr_stack+9783, vrr_stack+42, vrr_stack+9762, vrr_stack+567, vrr_stack+27, NULL);
 _BUILD_00k0(Data,vrr_stack+9811, vrr_stack+133, vrr_stack+9783, vrr_stack+0, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+9847, vrr_stack+3317, vrr_stack+9811, NULL, NULL, vrr_stack+133);
 _BUILD_d0k0(Data,vrr_stack+9955, vrr_stack+3353, vrr_stack+9847, vrr_stack+824, vrr_stack+3317, vrr_stack+4876);
 _BUILD_f0k0(Data,vrr_stack+10171, vrr_stack+8436, vrr_stack+9955, vrr_stack+7052, vrr_stack+3353, vrr_stack+4960);
 _BUILD_g0k0(Data,vrr_stack+4217, vrr_stack+15812, vrr_stack+10171, vrr_stack+7160, vrr_stack+8436, vrr_stack+5128);
 _BUILD_h0k0(Data,vrr_stack+19232, vrr_stack+16172, vrr_stack+4217, vrr_stack+2237, vrr_stack+15812, vrr_stack+5408);
 _BUILD_i0k0(Data,vrr_stack+19988, vrr_stack+16712, vrr_stack+19232, vrr_stack+14732, vrr_stack+16172, vrr_stack+12352);
 _BUILD_k0k0(Data,vrr_stack+20996, vrr_stack+18224, vrr_stack+19988, vrr_stack+17468, vrr_stack+16712, vrr_stack+12940);
 _BUILD_k0k0(Data,vrr_stack+12304, vrr_stack+8652, vrr_stack+18224, vrr_stack+3461, vrr_stack+17468, vrr_stack+10980);
   tmp = vrr_stack + 12304;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+3461, vrr_stack+11764, vrr_stack+11836, vrr_stack+704, vrr_stack+760, NULL);
 _BUILD_00l0(Data,vrr_stack+3506, vrr_stack+11800, vrr_stack+11764, vrr_stack+732, vrr_stack+704, NULL);
 _BUILD_00l0(Data,vrr_stack+3551, vrr_stack+11836, vrr_stack+824, vrr_stack+760, vrr_stack+249, NULL);
 _BUILD_p0l0(Data,vrr_stack+3596, vrr_stack+3461, vrr_stack+3551, NULL, NULL, vrr_stack+11836);
 _BUILD_p0l0(Data,vrr_stack+3731, vrr_stack+3506, vrr_stack+3461, NULL, NULL, vrr_stack+11764);
 _BUILD_d0l0(Data,vrr_stack+3866, vrr_stack+3731, vrr_stack+3596, vrr_stack+3506, vrr_stack+3461, vrr_stack+11872);
 _BUILD_00l0(Data,vrr_stack+11872, vrr_stack+788, vrr_stack+11800, vrr_stack+221, vrr_stack+732, NULL);
 _BUILD_p0l0(Data,vrr_stack+4876, vrr_stack+11872, vrr_stack+3506, NULL, NULL, vrr_stack+11800);
 _BUILD_d0l0(Data,vrr_stack+5011, vrr_stack+4876, vrr_stack+3731, vrr_stack+11872, vrr_stack+3506, vrr_stack+11980);
 _BUILD_00l0(Data,vrr_stack+11917, vrr_stack+824, vrr_stack+3317, vrr_stack+249, vrr_stack+425, NULL);
 _BUILD_p0l0(Data,vrr_stack+249, vrr_stack+3551, vrr_stack+11917, NULL, NULL, vrr_stack+824);
 _BUILD_d0l0(Data,vrr_stack+5281, vrr_stack+3596, vrr_stack+249, vrr_stack+3461, vrr_stack+3551, vrr_stack+7052);
 _BUILD_f0l0(Data,vrr_stack+22292, vrr_stack+3866, vrr_stack+5281, vrr_stack+3731, vrr_stack+3596, vrr_stack+7160);
 _BUILD_f0l0(Data,vrr_stack+7052, vrr_stack+5011, vrr_stack+3866, vrr_stack+4876, vrr_stack+3731, vrr_stack+12088);
 _BUILD_g0l0(Data,vrr_stack+22742, vrr_stack+7052, vrr_stack+22292, vrr_stack+5011, vrr_stack+3866, vrr_stack+2237);
 _BUILD_00l0(Data,vrr_stack+2237, vrr_stack+8292, vrr_stack+788, vrr_stack+1208, vrr_stack+221, NULL);
 _BUILD_p0l0(Data,vrr_stack+2282, vrr_stack+2237, vrr_stack+11872, NULL, NULL, vrr_stack+788);
 _BUILD_d0l0(Data,vrr_stack+11962, vrr_stack+2282, vrr_stack+4876, vrr_stack+2237, vrr_stack+11872, vrr_stack+582);
 _BUILD_f0l0(Data,vrr_stack+23417, vrr_stack+11962, vrr_stack+5011, vrr_stack+2282, vrr_stack+4876, vrr_stack+6836);
 _BUILD_g0l0(Data,vrr_stack+23867, vrr_stack+23417, vrr_stack+7052, vrr_stack+11962, vrr_stack+5011, vrr_stack+2597);
 _BUILD_00l0(Data,vrr_stack+6836, vrr_stack+3317, vrr_stack+9811, vrr_stack+425, vrr_stack+133, NULL);
 _BUILD_p0l0(Data,vrr_stack+6881, vrr_stack+11917, vrr_stack+6836, NULL, NULL, vrr_stack+3317);
 _BUILD_d0l0(Data,vrr_stack+2417, vrr_stack+249, vrr_stack+6881, vrr_stack+3551, vrr_stack+11917, vrr_stack+3353);
 _BUILD_f0l0(Data,vrr_stack+24542, vrr_stack+5281, vrr_stack+2417, vrr_stack+3596, vrr_stack+249, vrr_stack+8436);
 _BUILD_g0l0(Data,vrr_stack+24992, vrr_stack+22292, vrr_stack+24542, vrr_stack+3866, vrr_stack+5281, vrr_stack+15812);
 _BUILD_h0l0(Data,vrr_stack+25667, vrr_stack+22742, vrr_stack+24992, vrr_stack+7052, vrr_stack+22292, vrr_stack+16172);
 _BUILD_h0l0(Data,vrr_stack+26612, vrr_stack+23867, vrr_stack+22742, vrr_stack+23417, vrr_stack+7052, vrr_stack+14732);
 _BUILD_i0l0(Data,vrr_stack+27557, vrr_stack+26612, vrr_stack+25667, vrr_stack+23867, vrr_stack+22742, vrr_stack+16712);
 _BUILD_00l0(Data,vrr_stack+14732, vrr_stack+9692, vrr_stack+8292, vrr_stack+1425, vrr_stack+1208, NULL);
 _BUILD_p0l0(Data,vrr_stack+14777, vrr_stack+14732, vrr_stack+2237, NULL, NULL, vrr_stack+8292);
 _BUILD_d0l0(Data,vrr_stack+2687, vrr_stack+14777, vrr_stack+2282, vrr_stack+14732, vrr_stack+2237, vrr_stack+8328);
 _BUILD_f0l0(Data,vrr_stack+15812, vrr_stack+2687, vrr_stack+11962, vrr_stack+14777, vrr_stack+2282, vrr_stack+860);
 _BUILD_g0l0(Data,vrr_stack+16262, vrr_stack+15812, vrr_stack+23417, vrr_stack+2687, vrr_stack+11962, vrr_stack+2957);
 _BUILD_h0l0(Data,vrr_stack+28817, vrr_stack+16262, vrr_stack+23867, vrr_stack+15812, vrr_stack+23417, vrr_stack+15272);
 _BUILD_i0l0(Data,vrr_stack+14777, vrr_stack+28817, vrr_stack+26612, vrr_stack+16262, vrr_stack+23867, vrr_stack+17468);
   tmp = vrr_stack + 14777;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2687, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2690, vrr_stack+9728, vrr_stack+2687, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+2696, vrr_stack+9731, vrr_stack+2690, vrr_stack+4857, vrr_stack+9728, NULL);
 _BUILD_00g0(Data,vrr_stack+2706, vrr_stack+9737, vrr_stack+2696, vrr_stack+4860, vrr_stack+9731, NULL);
 _BUILD_00h0(Data,vrr_stack+2721, vrr_stack+9747, vrr_stack+2706, vrr_stack+4866, vrr_stack+9737, NULL);
 _BUILD_00i0(Data,vrr_stack+2742, vrr_stack+9762, vrr_stack+2721, vrr_stack+27, vrr_stack+9747, NULL);
 _BUILD_00k0(Data,vrr_stack+7016, vrr_stack+9783, vrr_stack+2742, vrr_stack+42, vrr_stack+9762, NULL);
 _BUILD_00l0(Data,vrr_stack+2770, vrr_stack+9811, vrr_stack+7016, vrr_stack+133, vrr_stack+9783, NULL);
 _BUILD_p0l0(Data,vrr_stack+2815, vrr_stack+6836, vrr_stack+2770, NULL, NULL, vrr_stack+9811);
 _BUILD_d0l0(Data,vrr_stack+2950, vrr_stack+6881, vrr_stack+2815, vrr_stack+11917, vrr_stack+6836, vrr_stack+9847);
 _BUILD_f0l0(Data,vrr_stack+860, vrr_stack+2417, vrr_stack+2950, vrr_stack+249, vrr_stack+6881, vrr_stack+9955);
 _BUILD_g0l0(Data,vrr_stack+16037, vrr_stack+24542, vrr_stack+860, vrr_stack+5281, vrr_stack+2417, vrr_stack+10171);
 _BUILD_h0l0(Data,vrr_stack+9847, vrr_stack+24992, vrr_stack+16037, vrr_stack+22292, vrr_stack+24542, vrr_stack+4217);
 _BUILD_i0l0(Data,vrr_stack+16712, vrr_stack+25667, vrr_stack+9847, vrr_stack+22742, vrr_stack+24992, vrr_stack+19232);
 _BUILD_k0l0(Data,vrr_stack+29762, vrr_stack+27557, vrr_stack+16712, vrr_stack+26612, vrr_stack+25667, vrr_stack+19988);
 _BUILD_k0l0(Data,vrr_stack+19232, vrr_stack+14777, vrr_stack+27557, vrr_stack+28817, vrr_stack+26612, vrr_stack+18224);
   tmp = vrr_stack + 19232;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+28817, vrr_stack+3461, vrr_stack+3551, vrr_stack+11764, vrr_stack+11836, NULL);
 _BUILD_00m0(Data,vrr_stack+28872, vrr_stack+3506, vrr_stack+3461, vrr_stack+11800, vrr_stack+11764, NULL);
 _BUILD_00m0(Data,vrr_stack+28927, vrr_stack+3551, vrr_stack+11917, vrr_stack+11836, vrr_stack+824, NULL);
 _BUILD_p0m0(Data,vrr_stack+28982, vrr_stack+28817, vrr_stack+28927, NULL, NULL, vrr_stack+3551);
 _BUILD_p0m0(Data,vrr_stack+29147, vrr_stack+28872, vrr_stack+28817, NULL, NULL, vrr_stack+3461);
 _BUILD_d0m0(Data,vrr_stack+29312, vrr_stack+29147, vrr_stack+28982, vrr_stack+28872, vrr_stack+28817, vrr_stack+3596);
 _BUILD_00m0(Data,vrr_stack+3596, vrr_stack+11872, vrr_stack+3506, vrr_stack+788, vrr_stack+11800, NULL);
 _BUILD_p0m0(Data,vrr_stack+10792, vrr_stack+3596, vrr_stack+28872, NULL, NULL, vrr_stack+3506);
 _BUILD_d0m0(Data,vrr_stack+384, vrr_stack+10792, vrr_stack+29147, vrr_stack+3596, vrr_stack+28872, vrr_stack+3731);
 _BUILD_00m0(Data,vrr_stack+3651, vrr_stack+11917, vrr_stack+6836, vrr_stack+824, vrr_stack+3317, NULL);
 _BUILD_p0m0(Data,vrr_stack+17972, vrr_stack+28927, vrr_stack+3651, NULL, NULL, vrr_stack+11917);
 _BUILD_d0m0(Data,vrr_stack+4136, vrr_stack+28982, vrr_stack+17972, vrr_stack+28817, vrr_stack+28927, vrr_stack+249);
 _BUILD_f0m0(Data,vrr_stack+31382, vrr_stack+29312, vrr_stack+4136, vrr_stack+29147, vrr_stack+28982, vrr_stack+5281);
 _BUILD_f0m0(Data,vrr_stack+31932, vrr_stack+384, vrr_stack+29312, vrr_stack+10792, vrr_stack+29147, vrr_stack+3866);
 _BUILD_g0m0(Data,vrr_stack+32482, vrr_stack+31932, vrr_stack+31382, vrr_stack+384, vrr_stack+29312, vrr_stack+22292);
 _BUILD_00m0(Data,vrr_stack+22292, vrr_stack+2237, vrr_stack+11872, vrr_stack+8292, vrr_stack+788, NULL);
 _BUILD_p0m0(Data,vrr_stack+22347, vrr_stack+22292, vrr_stack+3596, NULL, NULL, vrr_stack+11872);
 _BUILD_d0m0(Data,vrr_stack+5281, vrr_stack+22347, vrr_stack+10792, vrr_stack+22292, vrr_stack+3596, vrr_stack+4876);
 _BUILD_f0m0(Data,vrr_stack+33307, vrr_stack+5281, vrr_stack+384, vrr_stack+22347, vrr_stack+10792, vrr_stack+5011);
 _BUILD_g0m0(Data,vrr_stack+33857, vrr_stack+33307, vrr_stack+31932, vrr_stack+5281, vrr_stack+384, vrr_stack+7052);
 _BUILD_00m0(Data,vrr_stack+7052, vrr_stack+6836, vrr_stack+2770, vrr_stack+3317, vrr_stack+9811, NULL);
 _BUILD_p0m0(Data,vrr_stack+7107, vrr_stack+3651, vrr_stack+7052, NULL, NULL, vrr_stack+6836);
 _BUILD_d0m0(Data,vrr_stack+3706, vrr_stack+17972, vrr_stack+7107, vrr_stack+28927, vrr_stack+3651, vrr_stack+6881);
 _BUILD_f0m0(Data,vrr_stack+4466, vrr_stack+4136, vrr_stack+3706, vrr_stack+28982, vrr_stack+17972, vrr_stack+2417);
 _BUILD_g0m0(Data,vrr_stack+34682, vrr_stack+31382, vrr_stack+4466, vrr_stack+29312, vrr_stack+4136, vrr_stack+24542);
 _BUILD_h0m0(Data,vrr_stack+35507, vrr_stack+32482, vrr_stack+34682, vrr_stack+31932, vrr_stack+31382, vrr_stack+24992);
 _BUILD_h0m0(Data,vrr_stack+36662, vrr_stack+33857, vrr_stack+32482, vrr_stack+33307, vrr_stack+31932, vrr_stack+22742);
 _BUILD_i0m0(Data,vrr_stack+37817, vrr_stack+36662, vrr_stack+35507, vrr_stack+33857, vrr_stack+32482, vrr_stack+25667);
 _BUILD_00m0(Data,vrr_stack+24542, vrr_stack+14732, vrr_stack+2237, vrr_stack+9692, vrr_stack+8292, NULL);
 _BUILD_p0m0(Data,vrr_stack+8292, vrr_stack+24542, vrr_stack+22292, NULL, NULL, vrr_stack+2237);
 _BUILD_d0m0(Data,vrr_stack+24597, vrr_stack+8292, vrr_stack+22347, vrr_stack+24542, vrr_stack+22292, vrr_stack+2282);
 _BUILD_f0m0(Data,vrr_stack+24927, vrr_stack+24597, vrr_stack+5281, vrr_stack+8292, vrr_stack+22347, vrr_stack+11962);
 _BUILD_g0m0(Data,vrr_stack+25477, vrr_stack+24927, vrr_stack+33307, vrr_stack+24597, vrr_stack+5281, vrr_stack+23417);
 _BUILD_h0m0(Data,vrr_stack+22512, vrr_stack+25477, vrr_stack+33857, vrr_stack+24927, vrr_stack+33307, vrr_stack+23867);
 _BUILD_i0m0(Data,vrr_stack+39357, vrr_stack+22512, vrr_stack+36662, vrr_stack+25477, vrr_stack+33857, vrr_stack+26612);
   tmp = vrr_stack + 39357;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+24597, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24600, vrr_stack+2687, vrr_stack+24597, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+24606, vrr_stack+2690, vrr_stack+24600, vrr_stack+9728, vrr_stack+2687, NULL);
 _BUILD_00g0(Data,vrr_stack+24616, vrr_stack+2696, vrr_stack+24606, vrr_stack+9731, vrr_stack+2690, NULL);
 _BUILD_00h0(Data,vrr_stack+24631, vrr_stack+2706, vrr_stack+24616, vrr_stack+9737, vrr_stack+2696, NULL);
 _BUILD_00i0(Data,vrr_stack+24652, vrr_stack+2721, vrr_stack+24631, vrr_stack+9747, vrr_stack+2706, NULL);
 _BUILD_00k0(Data,vrr_stack+24680, vrr_stack+2742, vrr_stack+24652, vrr_stack+9762, vrr_stack+2721, NULL);
 _BUILD_00l0(Data,vrr_stack+24716, vrr_stack+7016, vrr_stack+24680, vrr_stack+9783, vrr_stack+2742, NULL);
 _BUILD_00m0(Data,vrr_stack+24761, vrr_stack+2770, vrr_stack+24716, vrr_stack+9811, vrr_stack+7016, NULL);
 _BUILD_p0m0(Data,vrr_stack+24816, vrr_stack+7052, vrr_stack+24761, NULL, NULL, vrr_stack+2770);
 _BUILD_d0m0(Data,vrr_stack+24981, vrr_stack+7107, vrr_stack+24816, vrr_stack+3651, vrr_stack+7052, vrr_stack+2815);
 _BUILD_f0m0(Data,vrr_stack+25311, vrr_stack+3706, vrr_stack+24981, vrr_stack+17972, vrr_stack+7107, vrr_stack+2950);
 _BUILD_g0m0(Data,vrr_stack+25861, vrr_stack+4466, vrr_stack+25311, vrr_stack+4136, vrr_stack+3706, vrr_stack+860);
 _BUILD_h0m0(Data,vrr_stack+40897, vrr_stack+34682, vrr_stack+25861, vrr_stack+31382, vrr_stack+4466, vrr_stack+16037);
 _BUILD_i0m0(Data,vrr_stack+42052, vrr_stack+35507, vrr_stack+40897, vrr_stack+32482, vrr_stack+34682, vrr_stack+9847);
 _BUILD_k0m0(Data,vrr_stack+43592, vrr_stack+37817, vrr_stack+42052, vrr_stack+36662, vrr_stack+35507, vrr_stack+16712);
 _BUILD_k0m0(Data,vrr_stack+45572, vrr_stack+39357, vrr_stack+37817, vrr_stack+22512, vrr_stack+36662, vrr_stack+27557);
   tmp = vrr_stack + 45572;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+22512, vrr_stack+28817, vrr_stack+28927, vrr_stack+3461, vrr_stack+3551, NULL);
 _BUILD_00n0(Data,vrr_stack+22578, vrr_stack+28872, vrr_stack+28817, vrr_stack+3506, vrr_stack+3461, NULL);
 _BUILD_00n0(Data,vrr_stack+22644, vrr_stack+28927, vrr_stack+3651, vrr_stack+3551, vrr_stack+11917, NULL);
 _BUILD_p0n0(Data,vrr_stack+22710, vrr_stack+22512, vrr_stack+22644, NULL, NULL, vrr_stack+28927);
 _BUILD_p0n0(Data,vrr_stack+22908, vrr_stack+22578, vrr_stack+22512, NULL, NULL, vrr_stack+28817);
 _BUILD_d0n0(Data,vrr_stack+23106, vrr_stack+22908, vrr_stack+22710, vrr_stack+22578, vrr_stack+22512, vrr_stack+28982);
 _BUILD_00n0(Data,vrr_stack+28982, vrr_stack+3596, vrr_stack+28872, vrr_stack+11872, vrr_stack+3506, NULL);
 _BUILD_p0n0(Data,vrr_stack+23502, vrr_stack+28982, vrr_stack+22578, NULL, NULL, vrr_stack+28872);
 _BUILD_d0n0(Data,vrr_stack+23700, vrr_stack+23502, vrr_stack+22908, vrr_stack+28982, vrr_stack+22578, vrr_stack+29147);
 _BUILD_00n0(Data,vrr_stack+29048, vrr_stack+3651, vrr_stack+7052, vrr_stack+11917, vrr_stack+6836, NULL);
 _BUILD_p0n0(Data,vrr_stack+29114, vrr_stack+22644, vrr_stack+29048, NULL, NULL, vrr_stack+3651);
 _BUILD_d0n0(Data,vrr_stack+24096, vrr_stack+22710, vrr_stack+29114, vrr_stack+22512, vrr_stack+22644, vrr_stack+17972);
 _BUILD_f0n0(Data,vrr_stack+16037, vrr_stack+23106, vrr_stack+24096, vrr_stack+22908, vrr_stack+22710, vrr_stack+4136);
 _BUILD_f0n0(Data,vrr_stack+16697, vrr_stack+23700, vrr_stack+23106, vrr_stack+23502, vrr_stack+22908, vrr_stack+29312);
 _BUILD_g0n0(Data,vrr_stack+9660, vrr_stack+16697, vrr_stack+16037, vrr_stack+23700, vrr_stack+23106, vrr_stack+31382);
 _BUILD_00n0(Data,vrr_stack+31382, vrr_stack+22292, vrr_stack+3596, vrr_stack+2237, vrr_stack+11872, NULL);
 _BUILD_p0n0(Data,vrr_stack+31448, vrr_stack+31382, vrr_stack+28982, NULL, NULL, vrr_stack+3596);
 _BUILD_d0n0(Data,vrr_stack+29312, vrr_stack+31448, vrr_stack+23502, vrr_stack+31382, vrr_stack+28982, vrr_stack+10792);
 _BUILD_f0n0(Data,vrr_stack+17357, vrr_stack+29312, vrr_stack+23700, vrr_stack+31448, vrr_stack+23502, vrr_stack+384);
 _BUILD_g0n0(Data,vrr_stack+0, vrr_stack+17357, vrr_stack+16697, vrr_stack+29312, vrr_stack+23700, vrr_stack+31932);
 _BUILD_00n0(Data,vrr_stack+31646, vrr_stack+7052, vrr_stack+24761, vrr_stack+6836, vrr_stack+2770, NULL);
 _BUILD_p0n0(Data,vrr_stack+31712, vrr_stack+29048, vrr_stack+31646, NULL, NULL, vrr_stack+7052);
 _BUILD_d0n0(Data,vrr_stack+31910, vrr_stack+29114, vrr_stack+31712, vrr_stack+22644, vrr_stack+29048, vrr_stack+7107);
 _BUILD_f0n0(Data,vrr_stack+2815, vrr_stack+24096, vrr_stack+31910, vrr_stack+22710, vrr_stack+29114, vrr_stack+3706);
 _BUILD_g0n0(Data,vrr_stack+47552, vrr_stack+16037, vrr_stack+2815, vrr_stack+23106, vrr_stack+24096, vrr_stack+4466);
 _BUILD_h0n0(Data,vrr_stack+3706, vrr_stack+9660, vrr_stack+47552, vrr_stack+16697, vrr_stack+16037, vrr_stack+34682);
 _BUILD_h0n0(Data,vrr_stack+48542, vrr_stack+0, vrr_stack+9660, vrr_stack+17357, vrr_stack+16697, vrr_stack+32482);
 _BUILD_i0n0(Data,vrr_stack+49928, vrr_stack+48542, vrr_stack+3706, vrr_stack+0, vrr_stack+9660, vrr_stack+35507);
 _BUILD_00n0(Data,vrr_stack+34682, vrr_stack+24542, vrr_stack+22292, vrr_stack+14732, vrr_stack+2237, NULL);
 _BUILD_p0n0(Data,vrr_stack+2237, vrr_stack+34682, vrr_stack+31382, NULL, NULL, vrr_stack+22292);
 _BUILD_d0n0(Data,vrr_stack+34748, vrr_stack+2237, vrr_stack+31448, vrr_stack+34682, vrr_stack+31382, vrr_stack+22347);
 _BUILD_f0n0(Data,vrr_stack+35144, vrr_stack+34748, vrr_stack+29312, vrr_stack+2237, vrr_stack+31448, vrr_stack+5281);
 _BUILD_g0n0(Data,vrr_stack+32306, vrr_stack+35144, vrr_stack+17357, vrr_stack+34748, vrr_stack+29312, vrr_stack+33307);
 _BUILD_h0n0(Data,vrr_stack+51776, vrr_stack+32306, vrr_stack+0, vrr_stack+35144, vrr_stack+17357, vrr_stack+33857);
 _BUILD_i0n0(Data,vrr_stack+34748, vrr_stack+51776, vrr_stack+48542, vrr_stack+32306, vrr_stack+0, vrr_stack+36662);
   tmp = vrr_stack + 34748;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+32306, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+32309, vrr_stack+24597, vrr_stack+32306, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+32315, vrr_stack+24600, vrr_stack+32309, vrr_stack+2687, vrr_stack+24597, NULL);
 _BUILD_00g0(Data,vrr_stack+32325, vrr_stack+24606, vrr_stack+32315, vrr_stack+2690, vrr_stack+24600, NULL);
 _BUILD_00h0(Data,vrr_stack+32340, vrr_stack+24616, vrr_stack+32325, vrr_stack+2696, vrr_stack+24606, NULL);
 _BUILD_00i0(Data,vrr_stack+32361, vrr_stack+24631, vrr_stack+32340, vrr_stack+2706, vrr_stack+24616, NULL);
 _BUILD_00k0(Data,vrr_stack+32389, vrr_stack+24652, vrr_stack+32361, vrr_stack+2721, vrr_stack+24631, NULL);
 _BUILD_00l0(Data,vrr_stack+14732, vrr_stack+24680, vrr_stack+32389, vrr_stack+2742, vrr_stack+24652, NULL);
 _BUILD_00m0(Data,vrr_stack+32425, vrr_stack+24716, vrr_stack+14732, vrr_stack+7016, vrr_stack+24680, NULL);
 _BUILD_00n0(Data,vrr_stack+32480, vrr_stack+24761, vrr_stack+32425, vrr_stack+2770, vrr_stack+24716, NULL);
 _BUILD_p0n0(Data,vrr_stack+32546, vrr_stack+31646, vrr_stack+32480, NULL, NULL, vrr_stack+24761);
 _BUILD_d0n0(Data,vrr_stack+32744, vrr_stack+31712, vrr_stack+32546, vrr_stack+29048, vrr_stack+31646, vrr_stack+24816);
 _BUILD_f0n0(Data,vrr_stack+33140, vrr_stack+31910, vrr_stack+32744, vrr_stack+29114, vrr_stack+31712, vrr_stack+24981);
 _BUILD_g0n0(Data,vrr_stack+36596, vrr_stack+2815, vrr_stack+33140, vrr_stack+24096, vrr_stack+31910, vrr_stack+25311);
 _BUILD_h0n0(Data,vrr_stack+53162, vrr_stack+47552, vrr_stack+36596, vrr_stack+16037, vrr_stack+2815, vrr_stack+25861);
 _BUILD_i0n0(Data,vrr_stack+24816, vrr_stack+3706, vrr_stack+53162, vrr_stack+9660, vrr_stack+47552, vrr_stack+40897);
 _BUILD_k0n0(Data,vrr_stack+54548, vrr_stack+49928, vrr_stack+24816, vrr_stack+48542, vrr_stack+3706, vrr_stack+42052);
 _BUILD_k0n0(Data,vrr_stack+40897, vrr_stack+34748, vrr_stack+49928, vrr_stack+51776, vrr_stack+48542, vrr_stack+37817);
   tmp = vrr_stack + 40897;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+51776, vrr_stack+22512, vrr_stack+22644, vrr_stack+28817, vrr_stack+28927, NULL);
 _BUILD_00o0(Data,vrr_stack+51854, vrr_stack+22578, vrr_stack+22512, vrr_stack+28872, vrr_stack+28817, NULL);
 _BUILD_00o0(Data,vrr_stack+51932, vrr_stack+22644, vrr_stack+29048, vrr_stack+28927, vrr_stack+3651, NULL);
 _BUILD_p0o0(Data,vrr_stack+52010, vrr_stack+51776, vrr_stack+51932, NULL, NULL, vrr_stack+22644);
 _BUILD_p0o0(Data,vrr_stack+52244, vrr_stack+51854, vrr_stack+51776, NULL, NULL, vrr_stack+22512);
 _BUILD_d0o0(Data,vrr_stack+52478, vrr_stack+52244, vrr_stack+52010, vrr_stack+51854, vrr_stack+51776, vrr_stack+22710);
 _BUILD_00o0(Data,vrr_stack+22710, vrr_stack+28982, vrr_stack+22578, vrr_stack+3596, vrr_stack+28872, NULL);
 _BUILD_p0o0(Data,vrr_stack+43273, vrr_stack+22710, vrr_stack+51854, NULL, NULL, vrr_stack+22578);
 _BUILD_d0o0(Data,vrr_stack+26664, vrr_stack+43273, vrr_stack+52244, vrr_stack+22710, vrr_stack+51854, vrr_stack+22908);
 _BUILD_00o0(Data,vrr_stack+22788, vrr_stack+29048, vrr_stack+31646, vrr_stack+3651, vrr_stack+7052, NULL);
 _BUILD_p0o0(Data,vrr_stack+22866, vrr_stack+51932, vrr_stack+22788, NULL, NULL, vrr_stack+29048);
 _BUILD_d0o0(Data,vrr_stack+33800, vrr_stack+52010, vrr_stack+22866, vrr_stack+51776, vrr_stack+51932, vrr_stack+29114);
 _BUILD_f0o0(Data,vrr_stack+56924, vrr_stack+52478, vrr_stack+33800, vrr_stack+52244, vrr_stack+52010, vrr_stack+24096);
 _BUILD_f0o0(Data,vrr_stack+57704, vrr_stack+26664, vrr_stack+52478, vrr_stack+43273, vrr_stack+52244, vrr_stack+23106);
 _BUILD_g0o0(Data,vrr_stack+58484, vrr_stack+57704, vrr_stack+56924, vrr_stack+26664, vrr_stack+52478, vrr_stack+16037);
 _BUILD_00o0(Data,vrr_stack+16037, vrr_stack+31382, vrr_stack+28982, vrr_stack+22292, vrr_stack+3596, NULL);
 _BUILD_p0o0(Data,vrr_stack+16115, vrr_stack+16037, vrr_stack+22710, NULL, NULL, vrr_stack+28982);
 _BUILD_d0o0(Data,vrr_stack+2237, vrr_stack+16115, vrr_stack+43273, vrr_stack+16037, vrr_stack+22710, vrr_stack+23502);
 _BUILD_f0o0(Data,vrr_stack+59654, vrr_stack+2237, vrr_stack+26664, vrr_stack+16115, vrr_stack+43273, vrr_stack+23700);
 _BUILD_g0o0(Data,vrr_stack+23100, vrr_stack+59654, vrr_stack+57704, vrr_stack+2237, vrr_stack+26664, vrr_stack+16697);
 _BUILD_00o0(Data,vrr_stack+16349, vrr_stack+31646, vrr_stack+32480, vrr_stack+7052, vrr_stack+24761, NULL);
 _BUILD_p0o0(Data,vrr_stack+16427, vrr_stack+22788, vrr_stack+16349, NULL, NULL, vrr_stack+31646);
 _BUILD_d0o0(Data,vrr_stack+16661, vrr_stack+22866, vrr_stack+16427, vrr_stack+51932, vrr_stack+22788, vrr_stack+31712);
 _BUILD_f0o0(Data,vrr_stack+60434, vrr_stack+33800, vrr_stack+16661, vrr_stack+52010, vrr_stack+22866, vrr_stack+31910);
 _BUILD_g0o0(Data,vrr_stack+61214, vrr_stack+56924, vrr_stack+60434, vrr_stack+52478, vrr_stack+33800, vrr_stack+2815);
 _BUILD_h0o0(Data,vrr_stack+62384, vrr_stack+58484, vrr_stack+61214, vrr_stack+57704, vrr_stack+56924, vrr_stack+47552);
 _BUILD_h0o0(Data,vrr_stack+64022, vrr_stack+23100, vrr_stack+58484, vrr_stack+59654, vrr_stack+57704, vrr_stack+9660);
 _BUILD_i0o0(Data,vrr_stack+65660, vrr_stack+64022, vrr_stack+62384, vrr_stack+23100, vrr_stack+58484, vrr_stack+3706);
 _BUILD_00o0(Data,vrr_stack+9660, vrr_stack+34682, vrr_stack+31382, vrr_stack+24542, vrr_stack+22292, NULL);
 _BUILD_p0o0(Data,vrr_stack+9738, vrr_stack+9660, vrr_stack+16037, NULL, NULL, vrr_stack+31382);
 _BUILD_d0o0(Data,vrr_stack+9972, vrr_stack+9738, vrr_stack+16115, vrr_stack+9660, vrr_stack+16037, vrr_stack+31448);
 _BUILD_f0o0(Data,vrr_stack+47552, vrr_stack+9972, vrr_stack+2237, vrr_stack+9738, vrr_stack+16115, vrr_stack+29312);
 _BUILD_g0o0(Data,vrr_stack+2705, vrr_stack+47552, vrr_stack+59654, vrr_stack+9972, vrr_stack+2237, vrr_stack+17357);
 _BUILD_h0o0(Data,vrr_stack+3875, vrr_stack+2705, vrr_stack+23100, vrr_stack+47552, vrr_stack+59654, vrr_stack+0);
 _BUILD_i0o0(Data,vrr_stack+67844, vrr_stack+3875, vrr_stack+64022, vrr_stack+2705, vrr_stack+23100, vrr_stack+48542);
   tmp = vrr_stack + 67844;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2705, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2708, vrr_stack+32306, vrr_stack+2705, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+2714, vrr_stack+32309, vrr_stack+2708, vrr_stack+24597, vrr_stack+32306, NULL);
 _BUILD_00g0(Data,vrr_stack+2724, vrr_stack+32315, vrr_stack+2714, vrr_stack+24600, vrr_stack+32309, NULL);
 _BUILD_00h0(Data,vrr_stack+2739, vrr_stack+32325, vrr_stack+2724, vrr_stack+24606, vrr_stack+32315, NULL);
 _BUILD_00i0(Data,vrr_stack+2760, vrr_stack+32340, vrr_stack+2739, vrr_stack+24616, vrr_stack+32325, NULL);
 _BUILD_00k0(Data,vrr_stack+2788, vrr_stack+32361, vrr_stack+2760, vrr_stack+24631, vrr_stack+32340, NULL);
 _BUILD_00l0(Data,vrr_stack+2824, vrr_stack+32389, vrr_stack+2788, vrr_stack+24652, vrr_stack+32361, NULL);
 _BUILD_00m0(Data,vrr_stack+2869, vrr_stack+14732, vrr_stack+2824, vrr_stack+24680, vrr_stack+32389, NULL);
 _BUILD_00n0(Data,vrr_stack+2924, vrr_stack+32425, vrr_stack+2869, vrr_stack+24716, vrr_stack+14732, NULL);
 _BUILD_00o0(Data,vrr_stack+2990, vrr_stack+32480, vrr_stack+2924, vrr_stack+24761, vrr_stack+32425, NULL);
 _BUILD_p0o0(Data,vrr_stack+3068, vrr_stack+16349, vrr_stack+2990, NULL, NULL, vrr_stack+32480);
 _BUILD_d0o0(Data,vrr_stack+3302, vrr_stack+16427, vrr_stack+3068, vrr_stack+22788, vrr_stack+16349, vrr_stack+32546);
 _BUILD_f0o0(Data,vrr_stack+0, vrr_stack+16661, vrr_stack+3302, vrr_stack+22866, vrr_stack+16427, vrr_stack+32744);
 _BUILD_g0o0(Data,vrr_stack+47552, vrr_stack+60434, vrr_stack+0, vrr_stack+33800, vrr_stack+16661, vrr_stack+33140);
 _BUILD_h0o0(Data,vrr_stack+70028, vrr_stack+61214, vrr_stack+47552, vrr_stack+56924, vrr_stack+60434, vrr_stack+36596);
 _BUILD_i0o0(Data,vrr_stack+71666, vrr_stack+62384, vrr_stack+70028, vrr_stack+58484, vrr_stack+61214, vrr_stack+53162);
 _BUILD_k0o0(Data,vrr_stack+73850, vrr_stack+65660, vrr_stack+71666, vrr_stack+64022, vrr_stack+62384, vrr_stack+24816);
 _BUILD_k0o0(Data,vrr_stack+76658, vrr_stack+67844, vrr_stack+65660, vrr_stack+3875, vrr_stack+64022, vrr_stack+49928);
   tmp = vrr_stack + 76658;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+36596, vrr_stack+51776, vrr_stack+51932, vrr_stack+22512, vrr_stack+22644, NULL);
 _BUILD_00q0(Data,vrr_stack+36687, vrr_stack+51854, vrr_stack+51776, vrr_stack+22578, vrr_stack+22512, NULL);
 _BUILD_00q0(Data,vrr_stack+36778, vrr_stack+51932, vrr_stack+22788, vrr_stack+22644, vrr_stack+29048, NULL);
 _BUILD_p0q0(Data,vrr_stack+36869, vrr_stack+36596, vrr_stack+36778, NULL, NULL, vrr_stack+51932);
 _BUILD_p0q0(Data,vrr_stack+37142, vrr_stack+36687, vrr_stack+36596, NULL, NULL, vrr_stack+51776);
 _BUILD_d0q0(Data,vrr_stack+32546, vrr_stack+37142, vrr_stack+36869, vrr_stack+36687, vrr_stack+36596, vrr_stack+52010);
 _BUILD_00q0(Data,vrr_stack+51932, vrr_stack+22710, vrr_stack+51854, vrr_stack+28982, vrr_stack+22578, NULL);
 _BUILD_p0q0(Data,vrr_stack+37415, vrr_stack+51932, vrr_stack+36687, NULL, NULL, vrr_stack+51854);
 _BUILD_d0q0(Data,vrr_stack+33092, vrr_stack+37415, vrr_stack+37142, vrr_stack+51932, vrr_stack+36687, vrr_stack+52244);
 _BUILD_00q0(Data,vrr_stack+36687, vrr_stack+22788, vrr_stack+16349, vrr_stack+29048, vrr_stack+31646, NULL);
 _BUILD_p0q0(Data,vrr_stack+29048, vrr_stack+36778, vrr_stack+36687, NULL, NULL, vrr_stack+22788);
 _BUILD_d0q0(Data,vrr_stack+3770, vrr_stack+36869, vrr_stack+29048, vrr_stack+36596, vrr_stack+36778, vrr_stack+22866);
 _BUILD_f0q0(Data,vrr_stack+4316, vrr_stack+32546, vrr_stack+3770, vrr_stack+37142, vrr_stack+36869, vrr_stack+33800);
 _BUILD_f0q0(Data,vrr_stack+33638, vrr_stack+33092, vrr_stack+32546, vrr_stack+37415, vrr_stack+37142, vrr_stack+52478);
 _BUILD_g0q0(Data,vrr_stack+52023, vrr_stack+33638, vrr_stack+4316, vrr_stack+33092, vrr_stack+32546, vrr_stack+56924);
 _BUILD_00q0(Data,vrr_stack+36596, vrr_stack+16037, vrr_stack+22710, vrr_stack+31382, vrr_stack+28982, NULL);
 _BUILD_p0q0(Data,vrr_stack+37142, vrr_stack+36596, vrr_stack+51932, NULL, NULL, vrr_stack+22710);
 _BUILD_d0q0(Data,vrr_stack+56924, vrr_stack+37142, vrr_stack+37415, vrr_stack+36596, vrr_stack+51932, vrr_stack+43273);
 _BUILD_f0q0(Data,vrr_stack+53388, vrr_stack+56924, vrr_stack+33092, vrr_stack+37142, vrr_stack+37415, vrr_stack+26664);
 _BUILD_g0q0(Data,vrr_stack+24270, vrr_stack+53388, vrr_stack+33638, vrr_stack+56924, vrr_stack+33092, vrr_stack+57704);
 _BUILD_00q0(Data,vrr_stack+33092, vrr_stack+16349, vrr_stack+2990, vrr_stack+31646, vrr_stack+32480, NULL);
 _BUILD_p0q0(Data,vrr_stack+33183, vrr_stack+36687, vrr_stack+33092, NULL, NULL, vrr_stack+16349);
 _BUILD_d0q0(Data,vrr_stack+57470, vrr_stack+29048, vrr_stack+33183, vrr_stack+36778, vrr_stack+36687, vrr_stack+16427);
 _BUILD_f0q0(Data,vrr_stack+48722, vrr_stack+3770, vrr_stack+57470, vrr_stack+36869, vrr_stack+29048, vrr_stack+16661);
 _BUILD_g0q0(Data,vrr_stack+16349, vrr_stack+4316, vrr_stack+48722, vrr_stack+32546, vrr_stack+3770, vrr_stack+60434);
 _BUILD_h0q0(Data,vrr_stack+25635, vrr_stack+52023, vrr_stack+16349, vrr_stack+33638, vrr_stack+4316, vrr_stack+61214);
 _BUILD_h0q0(Data,vrr_stack+60434, vrr_stack+24270, vrr_stack+52023, vrr_stack+53388, vrr_stack+33638, vrr_stack+58484);
 _BUILD_i0q0(Data,vrr_stack+79466, vrr_stack+60434, vrr_stack+25635, vrr_stack+24270, vrr_stack+52023, vrr_stack+62384);
 _BUILD_00q0(Data,vrr_stack+62345, vrr_stack+9660, vrr_stack+16037, vrr_stack+34682, vrr_stack+31382, NULL);
 _BUILD_p0q0(Data,vrr_stack+31382, vrr_stack+62345, vrr_stack+36596, NULL, NULL, vrr_stack+16037);
 _BUILD_d0q0(Data,vrr_stack+32546, vrr_stack+31382, vrr_stack+37142, vrr_stack+62345, vrr_stack+36596, vrr_stack+16115);
 _BUILD_f0q0(Data,vrr_stack+62345, vrr_stack+32546, vrr_stack+56924, vrr_stack+31382, vrr_stack+37142, vrr_stack+2237);
 _BUILD_g0q0(Data,vrr_stack+58016, vrr_stack+62345, vrr_stack+53388, vrr_stack+32546, vrr_stack+56924, vrr_stack+59654);
 _BUILD_h0q0(Data,vrr_stack+82014, vrr_stack+58016, vrr_stack+24270, vrr_stack+62345, vrr_stack+53388, vrr_stack+23100);
 _BUILD_i0q0(Data,vrr_stack+83925, vrr_stack+82014, vrr_stack+60434, vrr_stack+58016, vrr_stack+24270, vrr_stack+64022);
   tmp = vrr_stack + 83925;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+58016, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+58019, vrr_stack+2705, vrr_stack+58016, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+58025, vrr_stack+2708, vrr_stack+58019, vrr_stack+32306, vrr_stack+2705, NULL);
 _BUILD_00g0(Data,vrr_stack+58035, vrr_stack+2714, vrr_stack+58025, vrr_stack+32309, vrr_stack+2708, NULL);
 _BUILD_00h0(Data,vrr_stack+58050, vrr_stack+2724, vrr_stack+58035, vrr_stack+32315, vrr_stack+2714, NULL);
 _BUILD_00i0(Data,vrr_stack+58016, vrr_stack+2739, vrr_stack+58050, vrr_stack+32325, vrr_stack+2724, NULL);
 _BUILD_00k0(Data,vrr_stack+58044, vrr_stack+2760, vrr_stack+58016, vrr_stack+32340, vrr_stack+2739, NULL);
 _BUILD_00l0(Data,vrr_stack+58080, vrr_stack+2788, vrr_stack+58044, vrr_stack+32361, vrr_stack+2760, NULL);
 _BUILD_00m0(Data,vrr_stack+58016, vrr_stack+2824, vrr_stack+58080, vrr_stack+32389, vrr_stack+2788, NULL);
 _BUILD_00n0(Data,vrr_stack+58071, vrr_stack+2869, vrr_stack+58016, vrr_stack+14732, vrr_stack+2824, NULL);
 _BUILD_00o0(Data,vrr_stack+58137, vrr_stack+2924, vrr_stack+58071, vrr_stack+32425, vrr_stack+2869, NULL);
 _BUILD_00q0(Data,vrr_stack+36596, vrr_stack+2990, vrr_stack+58137, vrr_stack+32480, vrr_stack+2924, NULL);
 _BUILD_p0q0(Data,vrr_stack+58016, vrr_stack+33092, vrr_stack+36596, NULL, NULL, vrr_stack+2990);
 _BUILD_d0q0(Data,vrr_stack+56924, vrr_stack+33183, vrr_stack+58016, vrr_stack+36687, vrr_stack+33092, vrr_stack+3068);
 _BUILD_f0q0(Data,vrr_stack+58016, vrr_stack+57470, vrr_stack+56924, vrr_stack+29048, vrr_stack+33183, vrr_stack+3302);
 _BUILD_g0q0(Data,vrr_stack+58926, vrr_stack+48722, vrr_stack+58016, vrr_stack+3770, vrr_stack+57470, vrr_stack+0);
 _BUILD_h0q0(Data,vrr_stack+56924, vrr_stack+16349, vrr_stack+58926, vrr_stack+4316, vrr_stack+48722, vrr_stack+47552);
 _BUILD_i0q0(Data,vrr_stack+62345, vrr_stack+25635, vrr_stack+56924, vrr_stack+52023, vrr_stack+16349, vrr_stack+70028);
 _BUILD_k0q0(Data,vrr_stack+56924, vrr_stack+79466, vrr_stack+62345, vrr_stack+60434, vrr_stack+25635, vrr_stack+71666);
 _BUILD_k0q0(Data,vrr_stack+62345, vrr_stack+83925, vrr_stack+79466, vrr_stack+82014, vrr_stack+60434, vrr_stack+65660);
   tmp = vrr_stack + 62345;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0i0(Data,vrr_stack+82014, vrr_stack+13724, vrr_stack+5828, vrr_stack+1453, vrr_stack+10980, vrr_stack+7536);
   tmp = vrr_stack + 82014;
   target_ptr = Libint->vrr_classes[8][6];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0k0(Data,vrr_stack+70028, vrr_stack+12304, vrr_stack+20996, vrr_stack+8652, vrr_stack+18224, vrr_stack+5828);
   tmp = vrr_stack + 70028;
   target_ptr = Libint->vrr_classes[8][7];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0l0(Data,vrr_stack+71648, vrr_stack+19232, vrr_stack+29762, vrr_stack+14777, vrr_stack+27557, vrr_stack+20996);
   tmp = vrr_stack + 71648;
   target_ptr = Libint->vrr_classes[8][8];
   for(i=0;i<2025;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0m0(Data,vrr_stack+0, vrr_stack+45572, vrr_stack+43592, vrr_stack+39357, vrr_stack+37817, vrr_stack+29762);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[8][9];
   for(i=0;i<2475;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+45572, vrr_stack+40897, vrr_stack+54548, vrr_stack+34748, vrr_stack+49928, vrr_stack+43592);
   tmp = vrr_stack + 45572;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0o0(Data,vrr_stack+48542, vrr_stack+76658, vrr_stack+73850, vrr_stack+67844, vrr_stack+65660, vrr_stack+54548);
   tmp = vrr_stack + 48542;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0q0(Data,vrr_stack+52052, vrr_stack+62345, vrr_stack+56924, vrr_stack+83925, vrr_stack+79466, vrr_stack+73850);
   tmp = vrr_stack + 52052;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];

}

