/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (ig|nk) integrals */

void vrr_order_ignk(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, NULL, NULL, Data->F+10);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+0, vrr_stack+30, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+33, NULL, NULL, vrr_stack+0);
 _BUILD_p0d0(Data,vrr_stack+57, vrr_stack+24, vrr_stack+15, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+75, vrr_stack+57, vrr_stack+39, vrr_stack+24, vrr_stack+15, vrr_stack+6);
 _BUILD_00f0(Data,vrr_stack+111, vrr_stack+15, vrr_stack+33, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+121, vrr_stack+24, vrr_stack+15, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+131, vrr_stack+121, vrr_stack+111, NULL, NULL, vrr_stack+15);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+21, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+161, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+21, NULL);
 _BUILD_p0f0(Data,vrr_stack+171, vrr_stack+161, vrr_stack+121, NULL, NULL, vrr_stack+24);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+30, vrr_stack+21, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+33, vrr_stack+201, vrr_stack+0, vrr_stack+30, NULL);
 _BUILD_p0f0(Data,vrr_stack+217, vrr_stack+111, vrr_stack+207, NULL, NULL, vrr_stack+33);
 _BUILD_d0f0(Data,vrr_stack+247, vrr_stack+131, vrr_stack+217, vrr_stack+121, vrr_stack+111, vrr_stack+39);
 _BUILD_d0f0(Data,vrr_stack+307, vrr_stack+171, vrr_stack+131, vrr_stack+161, vrr_stack+121, vrr_stack+57);
 _BUILD_f0f0(Data,vrr_stack+367, vrr_stack+307, vrr_stack+247, vrr_stack+171, vrr_stack+131, vrr_stack+75);
 _BUILD_00g0(Data,vrr_stack+39, vrr_stack+121, vrr_stack+111, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+54, vrr_stack+161, vrr_stack+121, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00g0(Data,vrr_stack+69, vrr_stack+111, vrr_stack+207, vrr_stack+15, vrr_stack+33, NULL);
 _BUILD_p0g0(Data,vrr_stack+467, vrr_stack+39, vrr_stack+69, NULL, NULL, vrr_stack+111);
 _BUILD_p0g0(Data,vrr_stack+512, vrr_stack+54, vrr_stack+39, NULL, NULL, vrr_stack+121);
 _BUILD_d0g0(Data,vrr_stack+557, vrr_stack+512, vrr_stack+467, vrr_stack+54, vrr_stack+39, vrr_stack+131);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+131, vrr_stack+24, vrr_stack+6, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+141, vrr_stack+131, vrr_stack+161, vrr_stack+24, vrr_stack+6, NULL);
 _BUILD_p0g0(Data,vrr_stack+647, vrr_stack+141, vrr_stack+54, NULL, NULL, vrr_stack+161);
 _BUILD_d0g0(Data,vrr_stack+692, vrr_stack+647, vrr_stack+512, vrr_stack+141, vrr_stack+54, vrr_stack+171);
 _BUILD_00p0(Data,vrr_stack+171, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+174, vrr_stack+21, vrr_stack+171, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+180, vrr_stack+201, vrr_stack+174, vrr_stack+30, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+207, vrr_stack+180, vrr_stack+33, vrr_stack+201, NULL);
 _BUILD_p0g0(Data,vrr_stack+782, vrr_stack+69, vrr_stack+3, NULL, NULL, vrr_stack+207);
 _BUILD_d0g0(Data,vrr_stack+827, vrr_stack+467, vrr_stack+782, vrr_stack+39, vrr_stack+69, vrr_stack+217);
 _BUILD_f0g0(Data,vrr_stack+917, vrr_stack+557, vrr_stack+827, vrr_stack+512, vrr_stack+467, vrr_stack+247);
 _BUILD_f0g0(Data,vrr_stack+1067, vrr_stack+692, vrr_stack+557, vrr_stack+647, vrr_stack+512, vrr_stack+307);
 _BUILD_g0g0(Data,vrr_stack+1217, vrr_stack+1067, vrr_stack+917, vrr_stack+692, vrr_stack+557, vrr_stack+367);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+39, vrr_stack+69, vrr_stack+121, vrr_stack+111, NULL);
 _BUILD_00h0(Data,vrr_stack+238, vrr_stack+54, vrr_stack+39, vrr_stack+161, vrr_stack+121, NULL);
 _BUILD_p0h0(Data,vrr_stack+259, vrr_stack+238, vrr_stack+217, NULL, NULL, vrr_stack+39);
 _BUILD_00h0(Data,vrr_stack+322, vrr_stack+141, vrr_stack+54, vrr_stack+131, vrr_stack+161, NULL);
 _BUILD_p0h0(Data,vrr_stack+343, vrr_stack+322, vrr_stack+238, NULL, NULL, vrr_stack+54);
 _BUILD_00h0(Data,vrr_stack+406, vrr_stack+69, vrr_stack+3, vrr_stack+111, vrr_stack+207, NULL);
 _BUILD_p0h0(Data,vrr_stack+1442, vrr_stack+217, vrr_stack+406, NULL, NULL, vrr_stack+69);
 _BUILD_d0h0(Data,vrr_stack+1505, vrr_stack+259, vrr_stack+1442, vrr_stack+238, vrr_stack+217, vrr_stack+467);
 _BUILD_d0h0(Data,vrr_stack+1631, vrr_stack+343, vrr_stack+259, vrr_stack+322, vrr_stack+238, vrr_stack+512);
 _BUILD_f0h0(Data,vrr_stack+1757, vrr_stack+1631, vrr_stack+1505, vrr_stack+343, vrr_stack+259, vrr_stack+557);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+427, vrr_stack+18, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+433, vrr_stack+427, vrr_stack+24, vrr_stack+18, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+156, vrr_stack+433, vrr_stack+131, vrr_stack+427, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+443, vrr_stack+156, vrr_stack+141, vrr_stack+433, vrr_stack+131, NULL);
 _BUILD_p0h0(Data,vrr_stack+464, vrr_stack+443, vrr_stack+322, NULL, NULL, vrr_stack+141);
 _BUILD_d0h0(Data,vrr_stack+1967, vrr_stack+464, vrr_stack+343, vrr_stack+443, vrr_stack+322, vrr_stack+647);
 _BUILD_f0h0(Data,vrr_stack+2093, vrr_stack+1967, vrr_stack+1631, vrr_stack+464, vrr_stack+343, vrr_stack+692);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+171, vrr_stack+0, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+527, vrr_stack+174, vrr_stack+24, vrr_stack+21, vrr_stack+171, NULL);
 _BUILD_00g0(Data,vrr_stack+537, vrr_stack+180, vrr_stack+527, vrr_stack+201, vrr_stack+174, NULL);
 _BUILD_00h0(Data,vrr_stack+552, vrr_stack+3, vrr_stack+537, vrr_stack+207, vrr_stack+180, NULL);
 _BUILD_p0h0(Data,vrr_stack+573, vrr_stack+406, vrr_stack+552, NULL, NULL, vrr_stack+3);
 _BUILD_d0h0(Data,vrr_stack+636, vrr_stack+1442, vrr_stack+573, vrr_stack+217, vrr_stack+406, vrr_stack+782);
 _BUILD_f0h0(Data,vrr_stack+2303, vrr_stack+1505, vrr_stack+636, vrr_stack+259, vrr_stack+1442, vrr_stack+827);
 _BUILD_g0h0(Data,vrr_stack+2513, vrr_stack+1757, vrr_stack+2303, vrr_stack+1631, vrr_stack+1505, vrr_stack+917);
 _BUILD_g0h0(Data,vrr_stack+2828, vrr_stack+2093, vrr_stack+1757, vrr_stack+1967, vrr_stack+1631, vrr_stack+1067);
 _BUILD_h0h0(Data,vrr_stack+762, vrr_stack+2828, vrr_stack+2513, vrr_stack+2093, vrr_stack+1757, vrr_stack+1217);
 _BUILD_00i0(Data,vrr_stack+1203, vrr_stack+238, vrr_stack+217, vrr_stack+54, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+1231, vrr_stack+322, vrr_stack+238, vrr_stack+141, vrr_stack+54, NULL);
 _BUILD_00i0(Data,vrr_stack+1259, vrr_stack+217, vrr_stack+406, vrr_stack+39, vrr_stack+69, NULL);
 _BUILD_p0i0(Data,vrr_stack+1287, vrr_stack+1203, vrr_stack+1259, NULL, NULL, vrr_stack+217);
 _BUILD_p0i0(Data,vrr_stack+3143, vrr_stack+1231, vrr_stack+1203, NULL, NULL, vrr_stack+238);
 _BUILD_d0i0(Data,vrr_stack+3227, vrr_stack+3143, vrr_stack+1287, vrr_stack+1231, vrr_stack+1203, vrr_stack+259);
 _BUILD_00i0(Data,vrr_stack+259, vrr_stack+443, vrr_stack+322, vrr_stack+156, vrr_stack+141, NULL);
 _BUILD_p0i0(Data,vrr_stack+3395, vrr_stack+259, vrr_stack+1231, NULL, NULL, vrr_stack+322);
 _BUILD_d0i0(Data,vrr_stack+3479, vrr_stack+3395, vrr_stack+3143, vrr_stack+259, vrr_stack+1231, vrr_stack+343);
 _BUILD_00i0(Data,vrr_stack+343, vrr_stack+406, vrr_stack+552, vrr_stack+69, vrr_stack+3, NULL);
 _BUILD_p0i0(Data,vrr_stack+30, vrr_stack+1259, vrr_stack+343, NULL, NULL, vrr_stack+406);
 _BUILD_d0i0(Data,vrr_stack+3647, vrr_stack+1287, vrr_stack+30, vrr_stack+1203, vrr_stack+1259, vrr_stack+1442);
 _BUILD_f0i0(Data,vrr_stack+3815, vrr_stack+3227, vrr_stack+3647, vrr_stack+3143, vrr_stack+1287, vrr_stack+1505);
 _BUILD_f0i0(Data,vrr_stack+4095, vrr_stack+3479, vrr_stack+3227, vrr_stack+3395, vrr_stack+3143, vrr_stack+1631);
 _BUILD_g0i0(Data,vrr_stack+4375, vrr_stack+4095, vrr_stack+3815, vrr_stack+3479, vrr_stack+3227, vrr_stack+1757);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+371, vrr_stack+21, vrr_stack+18, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+377, vrr_stack+371, vrr_stack+427, vrr_stack+21, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+387, vrr_stack+377, vrr_stack+433, vrr_stack+371, vrr_stack+427, NULL);
 _BUILD_00h0(Data,vrr_stack+287, vrr_stack+387, vrr_stack+156, vrr_stack+377, vrr_stack+433, NULL);
 _BUILD_00i0(Data,vrr_stack+114, vrr_stack+287, vrr_stack+443, vrr_stack+387, vrr_stack+156, NULL);
 _BUILD_p0i0(Data,vrr_stack+1371, vrr_stack+114, vrr_stack+259, NULL, NULL, vrr_stack+443);
 _BUILD_d0i0(Data,vrr_stack+1455, vrr_stack+1371, vrr_stack+3395, vrr_stack+114, vrr_stack+259, vrr_stack+464);
 _BUILD_f0i0(Data,vrr_stack+1623, vrr_stack+1455, vrr_stack+3479, vrr_stack+1371, vrr_stack+3395, vrr_stack+1967);
 _BUILD_g0i0(Data,vrr_stack+4795, vrr_stack+1623, vrr_stack+4095, vrr_stack+1455, vrr_stack+3479, vrr_stack+2093);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+464, vrr_stack+0, vrr_stack+18, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+470, vrr_stack+24, vrr_stack+464, vrr_stack+171, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+480, vrr_stack+527, vrr_stack+470, vrr_stack+174, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+495, vrr_stack+537, vrr_stack+480, vrr_stack+180, vrr_stack+527, NULL);
 _BUILD_00i0(Data,vrr_stack+142, vrr_stack+552, vrr_stack+495, vrr_stack+3, vrr_stack+537, NULL);
 _BUILD_p0i0(Data,vrr_stack+1903, vrr_stack+343, vrr_stack+142, NULL, NULL, vrr_stack+552);
 _BUILD_d0i0(Data,vrr_stack+1987, vrr_stack+30, vrr_stack+1903, vrr_stack+1259, vrr_stack+343, vrr_stack+573);
 _BUILD_f0i0(Data,vrr_stack+5215, vrr_stack+3647, vrr_stack+1987, vrr_stack+1287, vrr_stack+30, vrr_stack+636);
 _BUILD_g0i0(Data,vrr_stack+5495, vrr_stack+3815, vrr_stack+5215, vrr_stack+3227, vrr_stack+3647, vrr_stack+2303);
 _BUILD_h0i0(Data,vrr_stack+5915, vrr_stack+4375, vrr_stack+5495, vrr_stack+4095, vrr_stack+3815, vrr_stack+2513);
 _BUILD_h0i0(Data,vrr_stack+2155, vrr_stack+4795, vrr_stack+4375, vrr_stack+1623, vrr_stack+4095, vrr_stack+2828);
 _BUILD_i0i0(Data,vrr_stack+6503, vrr_stack+2155, vrr_stack+5915, vrr_stack+4795, vrr_stack+4375, vrr_stack+762);
 _BUILD_00k0(Data,vrr_stack+573, vrr_stack+1203, vrr_stack+1259, vrr_stack+238, vrr_stack+217, NULL);
 _BUILD_00k0(Data,vrr_stack+609, vrr_stack+1231, vrr_stack+1203, vrr_stack+322, vrr_stack+238, NULL);
 _BUILD_p0k0(Data,vrr_stack+645, vrr_stack+609, vrr_stack+573, NULL, NULL, vrr_stack+1203);
 _BUILD_00k0(Data,vrr_stack+753, vrr_stack+259, vrr_stack+1231, vrr_stack+443, vrr_stack+322, NULL);
 _BUILD_p0k0(Data,vrr_stack+789, vrr_stack+753, vrr_stack+609, NULL, NULL, vrr_stack+1231);
 _BUILD_00k0(Data,vrr_stack+897, vrr_stack+1259, vrr_stack+343, vrr_stack+217, vrr_stack+406, NULL);
 _BUILD_p0k0(Data,vrr_stack+933, vrr_stack+573, vrr_stack+897, NULL, NULL, vrr_stack+1259);
 _BUILD_d0k0(Data,vrr_stack+2743, vrr_stack+645, vrr_stack+933, vrr_stack+609, vrr_stack+573, vrr_stack+1287);
 _BUILD_d0k0(Data,vrr_stack+7287, vrr_stack+789, vrr_stack+645, vrr_stack+753, vrr_stack+609, vrr_stack+3143);
 _BUILD_f0k0(Data,vrr_stack+7503, vrr_stack+7287, vrr_stack+2743, vrr_stack+789, vrr_stack+645, vrr_stack+3227);
 _BUILD_00k0(Data,vrr_stack+1287, vrr_stack+114, vrr_stack+259, vrr_stack+287, vrr_stack+443, NULL);
 _BUILD_p0k0(Data,vrr_stack+1041, vrr_stack+1287, vrr_stack+753, NULL, NULL, vrr_stack+259);
 _BUILD_d0k0(Data,vrr_stack+2959, vrr_stack+1041, vrr_stack+789, vrr_stack+1287, vrr_stack+753, vrr_stack+3395);
 _BUILD_f0k0(Data,vrr_stack+7863, vrr_stack+2959, vrr_stack+7287, vrr_stack+1041, vrr_stack+789, vrr_stack+3479);
 _BUILD_00k0(Data,vrr_stack+1323, vrr_stack+343, vrr_stack+142, vrr_stack+406, vrr_stack+552, NULL);
 _BUILD_p0k0(Data,vrr_stack+3175, vrr_stack+897, vrr_stack+1323, NULL, NULL, vrr_stack+343);
 _BUILD_d0k0(Data,vrr_stack+3283, vrr_stack+933, vrr_stack+3175, vrr_stack+573, vrr_stack+897, vrr_stack+30);
 _BUILD_f0k0(Data,vrr_stack+8223, vrr_stack+2743, vrr_stack+3283, vrr_stack+645, vrr_stack+933, vrr_stack+3647);
 _BUILD_g0k0(Data,vrr_stack+8583, vrr_stack+7503, vrr_stack+8223, vrr_stack+7287, vrr_stack+2743, vrr_stack+3815);
 _BUILD_g0k0(Data,vrr_stack+3499, vrr_stack+7863, vrr_stack+7503, vrr_stack+2959, vrr_stack+7287, vrr_stack+4095);
 _BUILD_h0k0(Data,vrr_stack+9123, vrr_stack+3499, vrr_stack+8583, vrr_stack+7863, vrr_stack+7503, vrr_stack+4375);
 _BUILD_00p0(Data,vrr_stack+30, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+33, vrr_stack+30, vrr_stack+21, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+33, vrr_stack+371, vrr_stack+30, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+39, vrr_stack+377, vrr_stack+33, vrr_stack+371, NULL);
 _BUILD_00h0(Data,vrr_stack+49, vrr_stack+3, vrr_stack+387, vrr_stack+39, vrr_stack+377, NULL);
 _BUILD_00i0(Data,vrr_stack+70, vrr_stack+49, vrr_stack+287, vrr_stack+3, vrr_stack+387, NULL);
 _BUILD_00k0(Data,vrr_stack+371, vrr_stack+70, vrr_stack+114, vrr_stack+49, vrr_stack+287, NULL);
 _BUILD_p0k0(Data,vrr_stack+4039, vrr_stack+371, vrr_stack+1287, NULL, NULL, vrr_stack+114);
 _BUILD_d0k0(Data,vrr_stack+4147, vrr_stack+4039, vrr_stack+1041, vrr_stack+371, vrr_stack+1287, vrr_stack+1371);
 _BUILD_f0k0(Data,vrr_stack+4363, vrr_stack+4147, vrr_stack+2959, vrr_stack+4039, vrr_stack+1041, vrr_stack+1455);
 _BUILD_g0k0(Data,vrr_stack+9879, vrr_stack+4363, vrr_stack+7863, vrr_stack+4147, vrr_stack+2959, vrr_stack+1623);
 _BUILD_h0k0(Data,vrr_stack+10419, vrr_stack+9879, vrr_stack+3499, vrr_stack+4363, vrr_stack+7863, vrr_stack+4795);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+287, vrr_stack+18, vrr_stack+21, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+293, vrr_stack+464, vrr_stack+287, vrr_stack+0, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+303, vrr_stack+470, vrr_stack+293, vrr_stack+24, vrr_stack+464, NULL);
 _BUILD_00h0(Data,vrr_stack+318, vrr_stack+480, vrr_stack+303, vrr_stack+527, vrr_stack+470, NULL);
 _BUILD_00i0(Data,vrr_stack+407, vrr_stack+495, vrr_stack+318, vrr_stack+537, vrr_stack+480, NULL);
 _BUILD_00k0(Data,vrr_stack+516, vrr_stack+142, vrr_stack+407, vrr_stack+552, vrr_stack+495, NULL);
 _BUILD_p0k0(Data,vrr_stack+1359, vrr_stack+1323, vrr_stack+516, NULL, NULL, vrr_stack+142);
 _BUILD_d0k0(Data,vrr_stack+1467, vrr_stack+3175, vrr_stack+1359, vrr_stack+897, vrr_stack+1323, vrr_stack+1903);
 _BUILD_f0k0(Data,vrr_stack+4723, vrr_stack+3283, vrr_stack+1467, vrr_stack+933, vrr_stack+3175, vrr_stack+1987);
 _BUILD_g0k0(Data,vrr_stack+11175, vrr_stack+8223, vrr_stack+4723, vrr_stack+2743, vrr_stack+3283, vrr_stack+5215);
 _BUILD_h0k0(Data,vrr_stack+11715, vrr_stack+8583, vrr_stack+11175, vrr_stack+7503, vrr_stack+8223, vrr_stack+5495);
 _BUILD_i0k0(Data,vrr_stack+12471, vrr_stack+9123, vrr_stack+11715, vrr_stack+3499, vrr_stack+8583, vrr_stack+5915);
 _BUILD_i0k0(Data,vrr_stack+5083, vrr_stack+10419, vrr_stack+9123, vrr_stack+9879, vrr_stack+3499, vrr_stack+2155);
 _BUILD_k0k0(Data,vrr_stack+13479, vrr_stack+5083, vrr_stack+12471, vrr_stack+10419, vrr_stack+9123, vrr_stack+6503);
 _BUILD_00l0(Data,vrr_stack+1683, vrr_stack+609, vrr_stack+573, vrr_stack+1231, vrr_stack+1203, NULL);
 _BUILD_00l0(Data,vrr_stack+1728, vrr_stack+753, vrr_stack+609, vrr_stack+259, vrr_stack+1231, NULL);
 _BUILD_00l0(Data,vrr_stack+1773, vrr_stack+573, vrr_stack+897, vrr_stack+1203, vrr_stack+1259, NULL);
 _BUILD_p0l0(Data,vrr_stack+1818, vrr_stack+1683, vrr_stack+1773, NULL, NULL, vrr_stack+573);
 _BUILD_p0l0(Data,vrr_stack+1953, vrr_stack+1728, vrr_stack+1683, NULL, NULL, vrr_stack+609);
 _BUILD_d0l0(Data,vrr_stack+2088, vrr_stack+1953, vrr_stack+1818, vrr_stack+1728, vrr_stack+1683, vrr_stack+645);
 _BUILD_00l0(Data,vrr_stack+645, vrr_stack+1287, vrr_stack+753, vrr_stack+114, vrr_stack+259, NULL);
 _BUILD_p0l0(Data,vrr_stack+2358, vrr_stack+645, vrr_stack+1728, NULL, NULL, vrr_stack+753);
 _BUILD_d0l0(Data,vrr_stack+6091, vrr_stack+2358, vrr_stack+1953, vrr_stack+645, vrr_stack+1728, vrr_stack+789);
 _BUILD_00l0(Data,vrr_stack+789, vrr_stack+897, vrr_stack+1323, vrr_stack+1259, vrr_stack+343, NULL);
 _BUILD_p0l0(Data,vrr_stack+2493, vrr_stack+1773, vrr_stack+789, NULL, NULL, vrr_stack+897);
 _BUILD_d0l0(Data,vrr_stack+6361, vrr_stack+1818, vrr_stack+2493, vrr_stack+1683, vrr_stack+1773, vrr_stack+933);
 _BUILD_f0l0(Data,vrr_stack+6631, vrr_stack+2088, vrr_stack+6361, vrr_stack+1953, vrr_stack+1818, vrr_stack+2743);
 _BUILD_f0l0(Data,vrr_stack+14775, vrr_stack+6091, vrr_stack+2088, vrr_stack+2358, vrr_stack+1953, vrr_stack+7287);
 _BUILD_g0l0(Data,vrr_stack+15225, vrr_stack+14775, vrr_stack+6631, vrr_stack+6091, vrr_stack+2088, vrr_stack+7503);
 _BUILD_00l0(Data,vrr_stack+933, vrr_stack+371, vrr_stack+1287, vrr_stack+70, vrr_stack+114, NULL);
 _BUILD_p0l0(Data,vrr_stack+2628, vrr_stack+933, vrr_stack+645, NULL, NULL, vrr_stack+1287);
 _BUILD_d0l0(Data,vrr_stack+7081, vrr_stack+2628, vrr_stack+2358, vrr_stack+933, vrr_stack+645, vrr_stack+1041);
 _BUILD_f0l0(Data,vrr_stack+7351, vrr_stack+7081, vrr_stack+6091, vrr_stack+2628, vrr_stack+2358, vrr_stack+2959);
 _BUILD_g0l0(Data,vrr_stack+15900, vrr_stack+7351, vrr_stack+14775, vrr_stack+7081, vrr_stack+6091, vrr_stack+7863);
 _BUILD_00l0(Data,vrr_stack+978, vrr_stack+1323, vrr_stack+516, vrr_stack+343, vrr_stack+142, NULL);
 _BUILD_p0l0(Data,vrr_stack+1023, vrr_stack+789, vrr_stack+978, NULL, NULL, vrr_stack+1323);
 _BUILD_d0l0(Data,vrr_stack+2763, vrr_stack+2493, vrr_stack+1023, vrr_stack+1773, vrr_stack+789, vrr_stack+3175);
 _BUILD_f0l0(Data,vrr_stack+16575, vrr_stack+6361, vrr_stack+2763, vrr_stack+1818, vrr_stack+2493, vrr_stack+3283);
 _BUILD_g0l0(Data,vrr_stack+17025, vrr_stack+6631, vrr_stack+16575, vrr_stack+2088, vrr_stack+6361, vrr_stack+8223);
 _BUILD_h0l0(Data,vrr_stack+17700, vrr_stack+15225, vrr_stack+17025, vrr_stack+14775, vrr_stack+6631, vrr_stack+8583);
 _BUILD_h0l0(Data,vrr_stack+7801, vrr_stack+15900, vrr_stack+15225, vrr_stack+7351, vrr_stack+14775, vrr_stack+3499);
 _BUILD_i0l0(Data,vrr_stack+18645, vrr_stack+7801, vrr_stack+17700, vrr_stack+15900, vrr_stack+15225, vrr_stack+9123);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+30, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+1158, vrr_stack+24, vrr_stack+33, vrr_stack+0, vrr_stack+30, NULL);
 _BUILD_00g0(Data,vrr_stack+1168, vrr_stack+1158, vrr_stack+39, vrr_stack+24, vrr_stack+33, NULL);
 _BUILD_00h0(Data,vrr_stack+552, vrr_stack+1168, vrr_stack+3, vrr_stack+1158, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+1183, vrr_stack+552, vrr_stack+49, vrr_stack+1168, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+1211, vrr_stack+1183, vrr_stack+70, vrr_stack+552, vrr_stack+49, NULL);
 _BUILD_00l0(Data,vrr_stack+834, vrr_stack+1211, vrr_stack+371, vrr_stack+1183, vrr_stack+70, NULL);
 _BUILD_p0l0(Data,vrr_stack+3033, vrr_stack+834, vrr_stack+933, NULL, NULL, vrr_stack+371);
 _BUILD_d0l0(Data,vrr_stack+3168, vrr_stack+3033, vrr_stack+2628, vrr_stack+834, vrr_stack+933, vrr_stack+4039);
 _BUILD_f0l0(Data,vrr_stack+3438, vrr_stack+3168, vrr_stack+7081, vrr_stack+3033, vrr_stack+2628, vrr_stack+4147);
 _BUILD_g0l0(Data,vrr_stack+8746, vrr_stack+3438, vrr_stack+7351, vrr_stack+3168, vrr_stack+7081, vrr_stack+4363);
 _BUILD_h0l0(Data,vrr_stack+19905, vrr_stack+8746, vrr_stack+15900, vrr_stack+3438, vrr_stack+7351, vrr_stack+9879);
 _BUILD_i0l0(Data,vrr_stack+20850, vrr_stack+19905, vrr_stack+7801, vrr_stack+8746, vrr_stack+15900, vrr_stack+10419);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+21, vrr_stack+3, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+287, vrr_stack+6, vrr_stack+18, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+40, vrr_stack+293, vrr_stack+30, vrr_stack+464, vrr_stack+287, NULL);
 _BUILD_00h0(Data,vrr_stack+55, vrr_stack+303, vrr_stack+40, vrr_stack+470, vrr_stack+293, NULL);
 _BUILD_00i0(Data,vrr_stack+76, vrr_stack+318, vrr_stack+55, vrr_stack+480, vrr_stack+303, NULL);
 _BUILD_00k0(Data,vrr_stack+104, vrr_stack+407, vrr_stack+76, vrr_stack+495, vrr_stack+318, NULL);
 _BUILD_00l0(Data,vrr_stack+690, vrr_stack+516, vrr_stack+104, vrr_stack+142, vrr_stack+407, NULL);
 _BUILD_p0l0(Data,vrr_stack+140, vrr_stack+978, vrr_stack+690, NULL, NULL, vrr_stack+516);
 _BUILD_d0l0(Data,vrr_stack+3888, vrr_stack+1023, vrr_stack+140, vrr_stack+789, vrr_stack+978, vrr_stack+1359);
 _BUILD_f0l0(Data,vrr_stack+4158, vrr_stack+2763, vrr_stack+3888, vrr_stack+2493, vrr_stack+1023, vrr_stack+1467);
 _BUILD_g0l0(Data,vrr_stack+9421, vrr_stack+16575, vrr_stack+4158, vrr_stack+6361, vrr_stack+2763, vrr_stack+4723);
 _BUILD_h0l0(Data,vrr_stack+10096, vrr_stack+17025, vrr_stack+9421, vrr_stack+6631, vrr_stack+16575, vrr_stack+11175);
 _BUILD_i0l0(Data,vrr_stack+22110, vrr_stack+17700, vrr_stack+10096, vrr_stack+15225, vrr_stack+17025, vrr_stack+11715);
 _BUILD_k0l0(Data,vrr_stack+23370, vrr_stack+18645, vrr_stack+22110, vrr_stack+7801, vrr_stack+17700, vrr_stack+12471);
 _BUILD_k0l0(Data,vrr_stack+11041, vrr_stack+20850, vrr_stack+18645, vrr_stack+19905, vrr_stack+7801, vrr_stack+5083);
 _BUILD_l0l0(Data,vrr_stack+24990, vrr_stack+11041, vrr_stack+23370, vrr_stack+20850, vrr_stack+18645, vrr_stack+13479);
 _BUILD_00m0(Data,vrr_stack+1359, vrr_stack+1683, vrr_stack+1773, vrr_stack+609, vrr_stack+573, NULL);
 _BUILD_00m0(Data,vrr_stack+1414, vrr_stack+1728, vrr_stack+1683, vrr_stack+753, vrr_stack+609, NULL);
 _BUILD_p0m0(Data,vrr_stack+1469, vrr_stack+1414, vrr_stack+1359, NULL, NULL, vrr_stack+1683);
 _BUILD_00m0(Data,vrr_stack+435, vrr_stack+645, vrr_stack+1728, vrr_stack+1287, vrr_stack+753, NULL);
 _BUILD_p0m0(Data,vrr_stack+4608, vrr_stack+435, vrr_stack+1414, NULL, NULL, vrr_stack+1728);
 _BUILD_00m0(Data,vrr_stack+4773, vrr_stack+1773, vrr_stack+789, vrr_stack+573, vrr_stack+897, NULL);
 _BUILD_p0m0(Data,vrr_stack+4828, vrr_stack+1359, vrr_stack+4773, NULL, NULL, vrr_stack+1773);
 _BUILD_d0m0(Data,vrr_stack+4993, vrr_stack+1469, vrr_stack+4828, vrr_stack+1414, vrr_stack+1359, vrr_stack+1818);
 _BUILD_d0m0(Data,vrr_stack+5323, vrr_stack+4608, vrr_stack+1469, vrr_stack+435, vrr_stack+1414, vrr_stack+1953);
 _BUILD_f0m0(Data,vrr_stack+12661, vrr_stack+5323, vrr_stack+4993, vrr_stack+4608, vrr_stack+1469, vrr_stack+2088);
 _BUILD_00m0(Data,vrr_stack+1818, vrr_stack+933, vrr_stack+645, vrr_stack+371, vrr_stack+1287, NULL);
 _BUILD_p0m0(Data,vrr_stack+1873, vrr_stack+1818, vrr_stack+435, NULL, NULL, vrr_stack+645);
 _BUILD_d0m0(Data,vrr_stack+5653, vrr_stack+1873, vrr_stack+4608, vrr_stack+1818, vrr_stack+435, vrr_stack+2358);
 _BUILD_f0m0(Data,vrr_stack+13211, vrr_stack+5653, vrr_stack+5323, vrr_stack+1873, vrr_stack+4608, vrr_stack+6091);
 _BUILD_00m0(Data,vrr_stack+2038, vrr_stack+789, vrr_stack+978, vrr_stack+897, vrr_stack+1323, NULL);
 _BUILD_p0m0(Data,vrr_stack+2093, vrr_stack+4773, vrr_stack+2038, NULL, NULL, vrr_stack+789);
 _BUILD_d0m0(Data,vrr_stack+5983, vrr_stack+4828, vrr_stack+2093, vrr_stack+1359, vrr_stack+4773, vrr_stack+2493);
 _BUILD_f0m0(Data,vrr_stack+13761, vrr_stack+4993, vrr_stack+5983, vrr_stack+1469, vrr_stack+4828, vrr_stack+6361);
 _BUILD_g0m0(Data,vrr_stack+27015, vrr_stack+12661, vrr_stack+13761, vrr_stack+5323, vrr_stack+4993, vrr_stack+6631);
 _BUILD_g0m0(Data,vrr_stack+27840, vrr_stack+13211, vrr_stack+12661, vrr_stack+5653, vrr_stack+5323, vrr_stack+14775);
 _BUILD_h0m0(Data,vrr_stack+28665, vrr_stack+27840, vrr_stack+27015, vrr_stack+13211, vrr_stack+12661, vrr_stack+15225);
 _BUILD_00m0(Data,vrr_stack+2258, vrr_stack+834, vrr_stack+933, vrr_stack+1211, vrr_stack+371, NULL);
 _BUILD_p0m0(Data,vrr_stack+2313, vrr_stack+2258, vrr_stack+1818, NULL, NULL, vrr_stack+933);
 _BUILD_d0m0(Data,vrr_stack+6313, vrr_stack+2313, vrr_stack+1873, vrr_stack+2258, vrr_stack+1818, vrr_stack+2628);
 _BUILD_f0m0(Data,vrr_stack+14311, vrr_stack+6313, vrr_stack+5653, vrr_stack+2313, vrr_stack+1873, vrr_stack+7081);
 _BUILD_g0m0(Data,vrr_stack+14861, vrr_stack+14311, vrr_stack+13211, vrr_stack+6313, vrr_stack+5653, vrr_stack+7351);
 _BUILD_h0m0(Data,vrr_stack+6643, vrr_stack+14861, vrr_stack+27840, vrr_stack+14311, vrr_stack+13211, vrr_stack+15900);
 _BUILD_00m0(Data,vrr_stack+2478, vrr_stack+978, vrr_stack+690, vrr_stack+1323, vrr_stack+516, NULL);
 _BUILD_p0m0(Data,vrr_stack+2533, vrr_stack+2038, vrr_stack+2478, NULL, NULL, vrr_stack+978);
 _BUILD_d0m0(Data,vrr_stack+15686, vrr_stack+2093, vrr_stack+2533, vrr_stack+4773, vrr_stack+2038, vrr_stack+1023);
 _BUILD_f0m0(Data,vrr_stack+16016, vrr_stack+5983, vrr_stack+15686, vrr_stack+4828, vrr_stack+2093, vrr_stack+2763);
 _BUILD_g0m0(Data,vrr_stack+29820, vrr_stack+13761, vrr_stack+16016, vrr_stack+4993, vrr_stack+5983, vrr_stack+16575);
 _BUILD_h0m0(Data,vrr_stack+30645, vrr_stack+27015, vrr_stack+29820, vrr_stack+12661, vrr_stack+13761, vrr_stack+17025);
 _BUILD_i0m0(Data,vrr_stack+31800, vrr_stack+28665, vrr_stack+30645, vrr_stack+27840, vrr_stack+27015, vrr_stack+17700);
 _BUILD_i0m0(Data,vrr_stack+16566, vrr_stack+6643, vrr_stack+28665, vrr_stack+14861, vrr_stack+27840, vrr_stack+7801);
 _BUILD_k0m0(Data,vrr_stack+33340, vrr_stack+16566, vrr_stack+31800, vrr_stack+6643, vrr_stack+28665, vrr_stack+18645);
 _BUILD_00p0(Data,vrr_stack+1023, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1026, vrr_stack+1023, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1032, vrr_stack+1026, vrr_stack+24, vrr_stack+1023, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+1042, vrr_stack+1032, vrr_stack+1158, vrr_stack+1026, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+1057, vrr_stack+1042, vrr_stack+1168, vrr_stack+1032, vrr_stack+1158, NULL);
 _BUILD_00i0(Data,vrr_stack+1078, vrr_stack+1057, vrr_stack+552, vrr_stack+1042, vrr_stack+1168, NULL);
 _BUILD_00k0(Data,vrr_stack+1106, vrr_stack+1078, vrr_stack+1183, vrr_stack+1057, vrr_stack+552, NULL);
 _BUILD_00l0(Data,vrr_stack+552, vrr_stack+1106, vrr_stack+1211, vrr_stack+1078, vrr_stack+1183, NULL);
 _BUILD_00m0(Data,vrr_stack+1142, vrr_stack+552, vrr_stack+834, vrr_stack+1106, vrr_stack+1211, NULL);
 _BUILD_p0m0(Data,vrr_stack+2698, vrr_stack+1142, vrr_stack+2258, NULL, NULL, vrr_stack+834);
 _BUILD_d0m0(Data,vrr_stack+7798, vrr_stack+2698, vrr_stack+2313, vrr_stack+1142, vrr_stack+2258, vrr_stack+3033);
 _BUILD_f0m0(Data,vrr_stack+8128, vrr_stack+7798, vrr_stack+6313, vrr_stack+2698, vrr_stack+2313, vrr_stack+3168);
 _BUILD_g0m0(Data,vrr_stack+18106, vrr_stack+8128, vrr_stack+14311, vrr_stack+7798, vrr_stack+6313, vrr_stack+3438);
 _BUILD_h0m0(Data,vrr_stack+35320, vrr_stack+18106, vrr_stack+14861, vrr_stack+8128, vrr_stack+14311, vrr_stack+8746);
 _BUILD_i0m0(Data,vrr_stack+36475, vrr_stack+35320, vrr_stack+6643, vrr_stack+18106, vrr_stack+14861, vrr_stack+19905);
 _BUILD_k0m0(Data,vrr_stack+38015, vrr_stack+36475, vrr_stack+16566, vrr_stack+35320, vrr_stack+6643, vrr_stack+20850);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+3, vrr_stack+0, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+597, vrr_stack+6, vrr_stack+24, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+607, vrr_stack+30, vrr_stack+597, vrr_stack+287, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+622, vrr_stack+40, vrr_stack+607, vrr_stack+293, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+275, vrr_stack+55, vrr_stack+622, vrr_stack+303, vrr_stack+40, NULL);
 _BUILD_00k0(Data,vrr_stack+1197, vrr_stack+76, vrr_stack+275, vrr_stack+318, vrr_stack+55, NULL);
 _BUILD_00l0(Data,vrr_stack+303, vrr_stack+104, vrr_stack+1197, vrr_stack+407, vrr_stack+76, NULL);
 _BUILD_00m0(Data,vrr_stack+348, vrr_stack+690, vrr_stack+303, vrr_stack+516, vrr_stack+104, NULL);
 _BUILD_p0m0(Data,vrr_stack+2863, vrr_stack+2478, vrr_stack+348, NULL, NULL, vrr_stack+690);
 _BUILD_d0m0(Data,vrr_stack+3028, vrr_stack+2533, vrr_stack+2863, vrr_stack+2038, vrr_stack+2478, vrr_stack+140);
 _BUILD_f0m0(Data,vrr_stack+8678, vrr_stack+15686, vrr_stack+3028, vrr_stack+2093, vrr_stack+2533, vrr_stack+3888);
 _BUILD_g0m0(Data,vrr_stack+18931, vrr_stack+16016, vrr_stack+8678, vrr_stack+5983, vrr_stack+15686, vrr_stack+4158);
 _BUILD_h0m0(Data,vrr_stack+3358, vrr_stack+29820, vrr_stack+18931, vrr_stack+13761, vrr_stack+16016, vrr_stack+9421);
 _BUILD_i0m0(Data,vrr_stack+19756, vrr_stack+30645, vrr_stack+3358, vrr_stack+27015, vrr_stack+29820, vrr_stack+10096);
 _BUILD_k0m0(Data,vrr_stack+39995, vrr_stack+31800, vrr_stack+19756, vrr_stack+28665, vrr_stack+30645, vrr_stack+22110);
 _BUILD_l0m0(Data,vrr_stack+41975, vrr_stack+33340, vrr_stack+39995, vrr_stack+16566, vrr_stack+31800, vrr_stack+23370);
 _BUILD_l0m0(Data,vrr_stack+21296, vrr_stack+38015, vrr_stack+33340, vrr_stack+36475, vrr_stack+16566, vrr_stack+11041);
 _BUILD_m0m0(Data,vrr_stack+9228, vrr_stack+21296, vrr_stack+41975, vrr_stack+38015, vrr_stack+33340, vrr_stack+24990);
 _BUILD_00n0(Data,vrr_stack+140, vrr_stack+1414, vrr_stack+1359, vrr_stack+1728, vrr_stack+1683, NULL);
 _BUILD_00n0(Data,vrr_stack+206, vrr_stack+435, vrr_stack+1414, vrr_stack+645, vrr_stack+1728, NULL);
 _BUILD_00n0(Data,vrr_stack+1233, vrr_stack+1359, vrr_stack+4773, vrr_stack+1683, vrr_stack+1773, NULL);
 _BUILD_p0n0(Data,vrr_stack+12253, vrr_stack+140, vrr_stack+1233, NULL, NULL, vrr_stack+1359);
 _BUILD_p0n0(Data,vrr_stack+12451, vrr_stack+206, vrr_stack+140, NULL, NULL, vrr_stack+1414);
 _BUILD_d0n0(Data,vrr_stack+23771, vrr_stack+12451, vrr_stack+12253, vrr_stack+206, vrr_stack+140, vrr_stack+1469);
 _BUILD_00n0(Data,vrr_stack+1469, vrr_stack+1818, vrr_stack+435, vrr_stack+933, vrr_stack+645, NULL);
 _BUILD_p0n0(Data,vrr_stack+1535, vrr_stack+1469, vrr_stack+206, NULL, NULL, vrr_stack+435);
 _BUILD_d0n0(Data,vrr_stack+24167, vrr_stack+1535, vrr_stack+12451, vrr_stack+1469, vrr_stack+206, vrr_stack+4608);
 _BUILD_00n0(Data,vrr_stack+4513, vrr_stack+4773, vrr_stack+2038, vrr_stack+1773, vrr_stack+789, NULL);
 _BUILD_p0n0(Data,vrr_stack+24563, vrr_stack+1233, vrr_stack+4513, NULL, NULL, vrr_stack+4773);
 _BUILD_d0n0(Data,vrr_stack+24761, vrr_stack+12253, vrr_stack+24563, vrr_stack+140, vrr_stack+1233, vrr_stack+4828);
 _BUILD_f0n0(Data,vrr_stack+25157, vrr_stack+23771, vrr_stack+24761, vrr_stack+12451, vrr_stack+12253, vrr_stack+4993);
 _BUILD_f0n0(Data,vrr_stack+25817, vrr_stack+24167, vrr_stack+23771, vrr_stack+1535, vrr_stack+12451, vrr_stack+5323);
 _BUILD_g0n0(Data,vrr_stack+44450, vrr_stack+25817, vrr_stack+25157, vrr_stack+24167, vrr_stack+23771, vrr_stack+12661);
 _BUILD_00n0(Data,vrr_stack+4828, vrr_stack+2258, vrr_stack+1818, vrr_stack+834, vrr_stack+933, NULL);
 _BUILD_p0n0(Data,vrr_stack+4894, vrr_stack+4828, vrr_stack+1469, NULL, NULL, vrr_stack+1818);
 _BUILD_d0n0(Data,vrr_stack+5092, vrr_stack+4894, vrr_stack+1535, vrr_stack+4828, vrr_stack+1469, vrr_stack+1873);
 _BUILD_f0n0(Data,vrr_stack+45440, vrr_stack+5092, vrr_stack+24167, vrr_stack+4894, vrr_stack+1535, vrr_stack+5653);
 _BUILD_g0n0(Data,vrr_stack+46100, vrr_stack+45440, vrr_stack+25817, vrr_stack+5092, vrr_stack+24167, vrr_stack+13211);
 _BUILD_00n0(Data,vrr_stack+1873, vrr_stack+2038, vrr_stack+2478, vrr_stack+789, vrr_stack+978, NULL);
 _BUILD_p0n0(Data,vrr_stack+5488, vrr_stack+4513, vrr_stack+1873, NULL, NULL, vrr_stack+2038);
 _BUILD_d0n0(Data,vrr_stack+12649, vrr_stack+24563, vrr_stack+5488, vrr_stack+1233, vrr_stack+4513, vrr_stack+2093);
 _BUILD_f0n0(Data,vrr_stack+13045, vrr_stack+24761, vrr_stack+12649, vrr_stack+12253, vrr_stack+24563, vrr_stack+5983);
 _BUILD_g0n0(Data,vrr_stack+47090, vrr_stack+25157, vrr_stack+13045, vrr_stack+23771, vrr_stack+24761, vrr_stack+13761);
 _BUILD_h0n0(Data,vrr_stack+48080, vrr_stack+44450, vrr_stack+47090, vrr_stack+25817, vrr_stack+25157, vrr_stack+27015);
 _BUILD_h0n0(Data,vrr_stack+49466, vrr_stack+46100, vrr_stack+44450, vrr_stack+45440, vrr_stack+25817, vrr_stack+27840);
 _BUILD_i0n0(Data,vrr_stack+26477, vrr_stack+49466, vrr_stack+48080, vrr_stack+46100, vrr_stack+44450, vrr_stack+28665);
 _BUILD_00n0(Data,vrr_stack+2093, vrr_stack+1142, vrr_stack+2258, vrr_stack+552, vrr_stack+834, NULL);
 _BUILD_p0n0(Data,vrr_stack+5686, vrr_stack+2093, vrr_stack+4828, NULL, NULL, vrr_stack+2258);
 _BUILD_d0n0(Data,vrr_stack+5884, vrr_stack+5686, vrr_stack+4894, vrr_stack+2093, vrr_stack+4828, vrr_stack+2313);
 _BUILD_f0n0(Data,vrr_stack+28325, vrr_stack+5884, vrr_stack+5092, vrr_stack+5686, vrr_stack+4894, vrr_stack+6313);
 _BUILD_g0n0(Data,vrr_stack+50852, vrr_stack+28325, vrr_stack+45440, vrr_stack+5884, vrr_stack+5092, vrr_stack+14311);
 _BUILD_h0n0(Data,vrr_stack+51842, vrr_stack+50852, vrr_stack+46100, vrr_stack+28325, vrr_stack+45440, vrr_stack+14861);
 _BUILD_i0n0(Data,vrr_stack+13705, vrr_stack+51842, vrr_stack+49466, vrr_stack+50852, vrr_stack+46100, vrr_stack+6643);
 _BUILD_00n0(Data,vrr_stack+2313, vrr_stack+2478, vrr_stack+348, vrr_stack+978, vrr_stack+690, NULL);
 _BUILD_p0n0(Data,vrr_stack+6280, vrr_stack+1873, vrr_stack+2313, NULL, NULL, vrr_stack+2478);
 _BUILD_d0n0(Data,vrr_stack+6478, vrr_stack+5488, vrr_stack+6280, vrr_stack+4513, vrr_stack+1873, vrr_stack+2533);
 _BUILD_f0n0(Data,vrr_stack+6874, vrr_stack+12649, vrr_stack+6478, vrr_stack+24563, vrr_stack+5488, vrr_stack+15686);
 _BUILD_g0n0(Data,vrr_stack+53228, vrr_stack+13045, vrr_stack+6874, vrr_stack+24761, vrr_stack+12649, vrr_stack+16016);
 _BUILD_h0n0(Data,vrr_stack+54218, vrr_stack+47090, vrr_stack+53228, vrr_stack+25157, vrr_stack+13045, vrr_stack+29820);
 _BUILD_i0n0(Data,vrr_stack+55604, vrr_stack+48080, vrr_stack+54218, vrr_stack+44450, vrr_stack+47090, vrr_stack+30645);
 _BUILD_k0n0(Data,vrr_stack+28985, vrr_stack+26477, vrr_stack+55604, vrr_stack+49466, vrr_stack+48080, vrr_stack+31800);
 _BUILD_k0n0(Data,vrr_stack+57452, vrr_stack+13705, vrr_stack+26477, vrr_stack+51842, vrr_stack+49466, vrr_stack+16566);
 _BUILD_l0n0(Data,vrr_stack+59828, vrr_stack+57452, vrr_stack+28985, vrr_stack+13705, vrr_stack+26477, vrr_stack+33340);
 _BUILD_00p0(Data,vrr_stack+272, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2533, vrr_stack+272, vrr_stack+1023, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+2539, vrr_stack+2533, vrr_stack+1026, vrr_stack+272, vrr_stack+1023, NULL);
 _BUILD_00g0(Data,vrr_stack+2549, vrr_stack+2539, vrr_stack+1032, vrr_stack+2533, vrr_stack+1026, NULL);
 _BUILD_00h0(Data,vrr_stack+2564, vrr_stack+2549, vrr_stack+1042, vrr_stack+2539, vrr_stack+1032, NULL);
 _BUILD_00i0(Data,vrr_stack+2585, vrr_stack+2564, vrr_stack+1057, vrr_stack+2549, vrr_stack+1042, NULL);
 _BUILD_00k0(Data,vrr_stack+2613, vrr_stack+2585, vrr_stack+1078, vrr_stack+2564, vrr_stack+1057, NULL);
 _BUILD_00l0(Data,vrr_stack+2533, vrr_stack+2613, vrr_stack+1106, vrr_stack+2585, vrr_stack+1078, NULL);
 _BUILD_00m0(Data,vrr_stack+2379, vrr_stack+2533, vrr_stack+552, vrr_stack+2613, vrr_stack+1106, NULL);
 _BUILD_00n0(Data,vrr_stack+2578, vrr_stack+2379, vrr_stack+1142, vrr_stack+2533, vrr_stack+552, NULL);
 _BUILD_p0n0(Data,vrr_stack+7534, vrr_stack+2578, vrr_stack+2093, NULL, NULL, vrr_stack+1142);
 _BUILD_d0n0(Data,vrr_stack+735, vrr_stack+7534, vrr_stack+5686, vrr_stack+2578, vrr_stack+2093, vrr_stack+2698);
 _BUILD_f0n0(Data,vrr_stack+15553, vrr_stack+735, vrr_stack+5884, vrr_stack+7534, vrr_stack+5686, vrr_stack+7798);
 _BUILD_g0n0(Data,vrr_stack+16213, vrr_stack+15553, vrr_stack+28325, vrr_stack+735, vrr_stack+5884, vrr_stack+8128);
 _BUILD_h0n0(Data,vrr_stack+31361, vrr_stack+16213, vrr_stack+50852, vrr_stack+15553, vrr_stack+28325, vrr_stack+18106);
 _BUILD_i0n0(Data,vrr_stack+32747, vrr_stack+31361, vrr_stack+51842, vrr_stack+16213, vrr_stack+50852, vrr_stack+35320);
   tmp = vrr_stack + 32747;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0n0(Data,vrr_stack+15553, vrr_stack+32747, vrr_stack+13705, vrr_stack+31361, vrr_stack+51842, vrr_stack+36475);
   tmp = vrr_stack + 15553;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+34595, vrr_stack+15553, vrr_stack+57452, vrr_stack+32747, vrr_stack+13705, vrr_stack+38015);
   tmp = vrr_stack + 34595;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+272, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+31361, vrr_stack+0, vrr_stack+272, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+31367, vrr_stack+24, vrr_stack+31361, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+31377, vrr_stack+597, vrr_stack+31367, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+3, vrr_stack+607, vrr_stack+31377, vrr_stack+30, vrr_stack+597, NULL);
 _BUILD_00i0(Data,vrr_stack+31392, vrr_stack+622, vrr_stack+3, vrr_stack+40, vrr_stack+607, NULL);
 _BUILD_00k0(Data,vrr_stack+31420, vrr_stack+275, vrr_stack+31392, vrr_stack+55, vrr_stack+622, NULL);
 _BUILD_00l0(Data,vrr_stack+2533, vrr_stack+1197, vrr_stack+31420, vrr_stack+76, vrr_stack+275, NULL);
 _BUILD_00m0(Data,vrr_stack+30, vrr_stack+303, vrr_stack+2533, vrr_stack+104, vrr_stack+1197, NULL);
 _BUILD_00n0(Data,vrr_stack+31456, vrr_stack+348, vrr_stack+30, vrr_stack+690, vrr_stack+303, NULL);
 _BUILD_p0n0(Data,vrr_stack+31522, vrr_stack+2313, vrr_stack+31456, NULL, NULL, vrr_stack+348);
 _BUILD_d0n0(Data,vrr_stack+31720, vrr_stack+6280, vrr_stack+31522, vrr_stack+1873, vrr_stack+2313, vrr_stack+2863);
 _BUILD_f0n0(Data,vrr_stack+32116, vrr_stack+6478, vrr_stack+31720, vrr_stack+5488, vrr_stack+6280, vrr_stack+3028);
 _BUILD_g0n0(Data,vrr_stack+32776, vrr_stack+6874, vrr_stack+32116, vrr_stack+12649, vrr_stack+6478, vrr_stack+8678);
 _BUILD_h0n0(Data,vrr_stack+7534, vrr_stack+53228, vrr_stack+32776, vrr_stack+13045, vrr_stack+6874, vrr_stack+18931);
 _BUILD_i0n0(Data,vrr_stack+37565, vrr_stack+54218, vrr_stack+7534, vrr_stack+47090, vrr_stack+53228, vrr_stack+3358);
 _BUILD_k0n0(Data,vrr_stack+62798, vrr_stack+55604, vrr_stack+37565, vrr_stack+48080, vrr_stack+54218, vrr_stack+19756);
 _BUILD_l0n0(Data,vrr_stack+17929, vrr_stack+28985, vrr_stack+62798, vrr_stack+26477, vrr_stack+55604, vrr_stack+39995);
 _BUILD_m0n0(Data,vrr_stack+65174, vrr_stack+59828, vrr_stack+17929, vrr_stack+57452, vrr_stack+28985, vrr_stack+41975);
 _BUILD_m0n0(Data,vrr_stack+39413, vrr_stack+34595, vrr_stack+59828, vrr_stack+15553, vrr_stack+57452, vrr_stack+21296);
   tmp = vrr_stack + 39413;
   target_ptr = Libint->vrr_classes[9][10];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+15553, vrr_stack+140, vrr_stack+1233, vrr_stack+1414, vrr_stack+1359, NULL);
 _BUILD_00o0(Data,vrr_stack+15631, vrr_stack+206, vrr_stack+140, vrr_stack+435, vrr_stack+1414, NULL);
 _BUILD_00o0(Data,vrr_stack+15709, vrr_stack+1233, vrr_stack+4513, vrr_stack+1359, vrr_stack+4773, NULL);
 _BUILD_p0o0(Data,vrr_stack+15787, vrr_stack+15553, vrr_stack+15709, NULL, NULL, vrr_stack+1233);
 _BUILD_p0o0(Data,vrr_stack+16021, vrr_stack+15631, vrr_stack+15553, NULL, NULL, vrr_stack+140);
 _BUILD_d0o0(Data,vrr_stack+16255, vrr_stack+16021, vrr_stack+15787, vrr_stack+15631, vrr_stack+15553, vrr_stack+12253);
 _BUILD_00o0(Data,vrr_stack+12253, vrr_stack+1469, vrr_stack+206, vrr_stack+1818, vrr_stack+435, NULL);
 _BUILD_p0o0(Data,vrr_stack+16723, vrr_stack+12253, vrr_stack+15631, NULL, NULL, vrr_stack+206);
 _BUILD_d0o0(Data,vrr_stack+16957, vrr_stack+16723, vrr_stack+16021, vrr_stack+12253, vrr_stack+15631, vrr_stack+12451);
 _BUILD_00o0(Data,vrr_stack+12331, vrr_stack+4513, vrr_stack+1873, vrr_stack+4773, vrr_stack+2038, NULL);
 _BUILD_p0o0(Data,vrr_stack+12409, vrr_stack+15709, vrr_stack+12331, NULL, NULL, vrr_stack+4513);
 _BUILD_d0o0(Data,vrr_stack+17425, vrr_stack+15787, vrr_stack+12409, vrr_stack+15553, vrr_stack+15709, vrr_stack+24563);
 _BUILD_f0o0(Data,vrr_stack+33766, vrr_stack+16255, vrr_stack+17425, vrr_stack+16021, vrr_stack+15787, vrr_stack+24761);
 _BUILD_f0o0(Data,vrr_stack+20899, vrr_stack+16957, vrr_stack+16255, vrr_stack+16723, vrr_stack+16021, vrr_stack+23771);
 _BUILD_g0o0(Data,vrr_stack+21679, vrr_stack+20899, vrr_stack+33766, vrr_stack+16957, vrr_stack+16255, vrr_stack+25157);
 _BUILD_00o0(Data,vrr_stack+24563, vrr_stack+4828, vrr_stack+1469, vrr_stack+2258, vrr_stack+1818, NULL);
 _BUILD_p0o0(Data,vrr_stack+24641, vrr_stack+24563, vrr_stack+12253, NULL, NULL, vrr_stack+1469);
 _BUILD_d0o0(Data,vrr_stack+24875, vrr_stack+24641, vrr_stack+16723, vrr_stack+24563, vrr_stack+12253, vrr_stack+1535);
 _BUILD_f0o0(Data,vrr_stack+22849, vrr_stack+24875, vrr_stack+16957, vrr_stack+24641, vrr_stack+16723, vrr_stack+24167);
 _BUILD_g0o0(Data,vrr_stack+2644, vrr_stack+22849, vrr_stack+20899, vrr_stack+24875, vrr_stack+16957, vrr_stack+25817);
 _BUILD_00o0(Data,vrr_stack+1535, vrr_stack+1873, vrr_stack+2313, vrr_stack+2038, vrr_stack+2478, NULL);
 _BUILD_p0o0(Data,vrr_stack+1613, vrr_stack+12331, vrr_stack+1535, NULL, NULL, vrr_stack+1873);
 _BUILD_d0o0(Data,vrr_stack+25343, vrr_stack+12409, vrr_stack+1613, vrr_stack+15709, vrr_stack+12331, vrr_stack+5488);
 _BUILD_f0o0(Data,vrr_stack+23629, vrr_stack+17425, vrr_stack+25343, vrr_stack+15787, vrr_stack+12409, vrr_stack+12649);
 _BUILD_g0o0(Data,vrr_stack+43043, vrr_stack+33766, vrr_stack+23629, vrr_stack+16255, vrr_stack+17425, vrr_stack+13045);
 _BUILD_h0o0(Data,vrr_stack+68804, vrr_stack+21679, vrr_stack+43043, vrr_stack+20899, vrr_stack+33766, vrr_stack+47090);
 _BUILD_h0o0(Data,vrr_stack+70442, vrr_stack+2644, vrr_stack+21679, vrr_stack+22849, vrr_stack+20899, vrr_stack+44450);
 _BUILD_i0o0(Data,vrr_stack+72080, vrr_stack+70442, vrr_stack+68804, vrr_stack+2644, vrr_stack+21679, vrr_stack+48080);
 _BUILD_00o0(Data,vrr_stack+47090, vrr_stack+2093, vrr_stack+4828, vrr_stack+1142, vrr_stack+2258, NULL);
 _BUILD_p0o0(Data,vrr_stack+47168, vrr_stack+47090, vrr_stack+24563, NULL, NULL, vrr_stack+4828);
 _BUILD_d0o0(Data,vrr_stack+47402, vrr_stack+47168, vrr_stack+24641, vrr_stack+47090, vrr_stack+24563, vrr_stack+4894);
 _BUILD_f0o0(Data,vrr_stack+47870, vrr_stack+47402, vrr_stack+24875, vrr_stack+47168, vrr_stack+24641, vrr_stack+5092);
 _BUILD_g0o0(Data,vrr_stack+44213, vrr_stack+47870, vrr_stack+22849, vrr_stack+47402, vrr_stack+24875, vrr_stack+45440);
 _BUILD_h0o0(Data,vrr_stack+74264, vrr_stack+44213, vrr_stack+2644, vrr_stack+47870, vrr_stack+22849, vrr_stack+46100);
 _BUILD_i0o0(Data,vrr_stack+75902, vrr_stack+74264, vrr_stack+70442, vrr_stack+44213, vrr_stack+2644, vrr_stack+49466);
 _BUILD_00o0(Data,vrr_stack+4894, vrr_stack+2313, vrr_stack+31456, vrr_stack+2478, vrr_stack+348, NULL);
 _BUILD_p0o0(Data,vrr_stack+4972, vrr_stack+1535, vrr_stack+4894, NULL, NULL, vrr_stack+2313);
 _BUILD_d0o0(Data,vrr_stack+5206, vrr_stack+1613, vrr_stack+4972, vrr_stack+12331, vrr_stack+1535, vrr_stack+6280);
 _BUILD_f0o0(Data,vrr_stack+48650, vrr_stack+25343, vrr_stack+5206, vrr_stack+12409, vrr_stack+1613, vrr_stack+6478);
 _BUILD_g0o0(Data,vrr_stack+49430, vrr_stack+23629, vrr_stack+48650, vrr_stack+17425, vrr_stack+25343, vrr_stack+6874);
 _BUILD_h0o0(Data,vrr_stack+45383, vrr_stack+43043, vrr_stack+49430, vrr_stack+33766, vrr_stack+23629, vrr_stack+53228);
 _BUILD_i0o0(Data,vrr_stack+78086, vrr_stack+68804, vrr_stack+45383, vrr_stack+21679, vrr_stack+43043, vrr_stack+54218);
 _BUILD_k0o0(Data,vrr_stack+80270, vrr_stack+72080, vrr_stack+78086, vrr_stack+70442, vrr_stack+68804, vrr_stack+55604);
 _BUILD_k0o0(Data,vrr_stack+53228, vrr_stack+75902, vrr_stack+72080, vrr_stack+74264, vrr_stack+70442, vrr_stack+26477);
 _BUILD_l0o0(Data,vrr_stack+83078, vrr_stack+53228, vrr_stack+80270, vrr_stack+75902, vrr_stack+72080, vrr_stack+28985);
 _BUILD_00o0(Data,vrr_stack+28985, vrr_stack+2578, vrr_stack+2093, vrr_stack+2379, vrr_stack+1142, NULL);
 _BUILD_p0o0(Data,vrr_stack+29063, vrr_stack+28985, vrr_stack+47090, NULL, NULL, vrr_stack+2093);
 _BUILD_d0o0(Data,vrr_stack+29297, vrr_stack+29063, vrr_stack+47168, vrr_stack+28985, vrr_stack+47090, vrr_stack+5686);
 _BUILD_f0o0(Data,vrr_stack+29765, vrr_stack+29297, vrr_stack+47402, vrr_stack+29063, vrr_stack+47168, vrr_stack+5884);
 _BUILD_g0o0(Data,vrr_stack+56036, vrr_stack+29765, vrr_stack+47870, vrr_stack+29297, vrr_stack+47402, vrr_stack+28325);
 _BUILD_h0o0(Data,vrr_stack+5674, vrr_stack+56036, vrr_stack+44213, vrr_stack+29765, vrr_stack+47870, vrr_stack+50852);
 _BUILD_i0o0(Data,vrr_stack+29063, vrr_stack+5674, vrr_stack+74264, vrr_stack+56036, vrr_stack+44213, vrr_stack+51842);
   tmp = vrr_stack + 29063;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0o0(Data,vrr_stack+25811, vrr_stack+29063, vrr_stack+75902, vrr_stack+5674, vrr_stack+74264, vrr_stack+13705);
   tmp = vrr_stack + 25811;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0o0(Data,vrr_stack+86588, vrr_stack+25811, vrr_stack+53228, vrr_stack+29063, vrr_stack+75902, vrr_stack+57452);
   tmp = vrr_stack + 86588;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+29063, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+29066, vrr_stack+272, vrr_stack+29063, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+29072, vrr_stack+31361, vrr_stack+29066, vrr_stack+0, vrr_stack+272, NULL);
 _BUILD_00g0(Data,vrr_stack+29082, vrr_stack+31367, vrr_stack+29072, vrr_stack+24, vrr_stack+31361, NULL);
 _BUILD_00h0(Data,vrr_stack+29097, vrr_stack+31377, vrr_stack+29082, vrr_stack+597, vrr_stack+31367, NULL);
 _BUILD_00i0(Data,vrr_stack+29118, vrr_stack+3, vrr_stack+29097, vrr_stack+607, vrr_stack+31377, NULL);
 _BUILD_00k0(Data,vrr_stack+17893, vrr_stack+31392, vrr_stack+29118, vrr_stack+622, vrr_stack+3, NULL);
 _BUILD_00l0(Data,vrr_stack+29146, vrr_stack+31420, vrr_stack+17893, vrr_stack+275, vrr_stack+31392, NULL);
 _BUILD_00m0(Data,vrr_stack+85, vrr_stack+2533, vrr_stack+29146, vrr_stack+1197, vrr_stack+31420, NULL);
 _BUILD_00n0(Data,vrr_stack+29191, vrr_stack+30, vrr_stack+85, vrr_stack+303, vrr_stack+2533, NULL);
 _BUILD_00o0(Data,vrr_stack+29257, vrr_stack+31456, vrr_stack+29191, vrr_stack+348, vrr_stack+30, NULL);
 _BUILD_p0o0(Data,vrr_stack+275, vrr_stack+4894, vrr_stack+29257, NULL, NULL, vrr_stack+31456);
 _BUILD_d0o0(Data,vrr_stack+509, vrr_stack+4972, vrr_stack+275, vrr_stack+1535, vrr_stack+4894, vrr_stack+31522);
 _BUILD_f0o0(Data,vrr_stack+29335, vrr_stack+5206, vrr_stack+509, vrr_stack+1613, vrr_stack+4972, vrr_stack+31720);
 _BUILD_g0o0(Data,vrr_stack+30115, vrr_stack+48650, vrr_stack+29335, vrr_stack+25343, vrr_stack+5206, vrr_stack+32116);
 _BUILD_h0o0(Data,vrr_stack+5674, vrr_stack+49430, vrr_stack+30115, vrr_stack+23629, vrr_stack+48650, vrr_stack+32776);
 _BUILD_i0o0(Data,vrr_stack+31522, vrr_stack+45383, vrr_stack+5674, vrr_stack+43043, vrr_stack+49430, vrr_stack+7534);
 _BUILD_k0o0(Data,vrr_stack+56036, vrr_stack+78086, vrr_stack+31522, vrr_stack+68804, vrr_stack+45383, vrr_stack+37565);
 _BUILD_l0o0(Data,vrr_stack+90098, vrr_stack+80270, vrr_stack+56036, vrr_stack+72080, vrr_stack+78086, vrr_stack+62798);
 _BUILD_m0o0(Data,vrr_stack+93608, vrr_stack+83078, vrr_stack+90098, vrr_stack+53228, vrr_stack+80270, vrr_stack+17929);
 _BUILD_m0o0(Data,vrr_stack+97898, vrr_stack+86588, vrr_stack+83078, vrr_stack+25811, vrr_stack+53228, vrr_stack+59828);
   tmp = vrr_stack + 97898;
   target_ptr = Libint->vrr_classes[9][11];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+25811, vrr_stack+15553, vrr_stack+15709, vrr_stack+140, vrr_stack+1233, NULL);
 _BUILD_00q0(Data,vrr_stack+25902, vrr_stack+15631, vrr_stack+15553, vrr_stack+206, vrr_stack+140, NULL);
 _BUILD_00q0(Data,vrr_stack+25993, vrr_stack+15709, vrr_stack+12331, vrr_stack+1233, vrr_stack+4513, NULL);
 _BUILD_p0q0(Data,vrr_stack+26084, vrr_stack+25811, vrr_stack+25993, NULL, NULL, vrr_stack+15709);
 _BUILD_p0q0(Data,vrr_stack+26357, vrr_stack+25902, vrr_stack+25811, NULL, NULL, vrr_stack+15553);
 _BUILD_d0q0(Data,vrr_stack+26630, vrr_stack+26357, vrr_stack+26084, vrr_stack+25902, vrr_stack+25811, vrr_stack+15787);
 _BUILD_00q0(Data,vrr_stack+15787, vrr_stack+12253, vrr_stack+15631, vrr_stack+1469, vrr_stack+206, NULL);
 _BUILD_p0q0(Data,vrr_stack+27176, vrr_stack+15787, vrr_stack+25902, NULL, NULL, vrr_stack+15631);
 _BUILD_d0q0(Data,vrr_stack+27449, vrr_stack+27176, vrr_stack+26357, vrr_stack+15787, vrr_stack+25902, vrr_stack+16021);
 _BUILD_00q0(Data,vrr_stack+15878, vrr_stack+12331, vrr_stack+1535, vrr_stack+4513, vrr_stack+1873, NULL);
 _BUILD_p0q0(Data,vrr_stack+15969, vrr_stack+25993, vrr_stack+15878, NULL, NULL, vrr_stack+12331);
 _BUILD_d0q0(Data,vrr_stack+27995, vrr_stack+26084, vrr_stack+15969, vrr_stack+25811, vrr_stack+25993, vrr_stack+12409);
 _BUILD_f0q0(Data,vrr_stack+12409, vrr_stack+26630, vrr_stack+27995, vrr_stack+26357, vrr_stack+26084, vrr_stack+17425);
 _BUILD_f0q0(Data,vrr_stack+13319, vrr_stack+27449, vrr_stack+26630, vrr_stack+27176, vrr_stack+26357, vrr_stack+16255);
 _BUILD_g0q0(Data,vrr_stack+17929, vrr_stack+13319, vrr_stack+12409, vrr_stack+27449, vrr_stack+26630, vrr_stack+33766);
 _BUILD_00q0(Data,vrr_stack+17425, vrr_stack+24563, vrr_stack+12253, vrr_stack+4828, vrr_stack+1469, NULL);
 _BUILD_p0q0(Data,vrr_stack+17516, vrr_stack+17425, vrr_stack+15787, NULL, NULL, vrr_stack+12253);
 _BUILD_d0q0(Data,vrr_stack+14229, vrr_stack+17516, vrr_stack+27176, vrr_stack+17425, vrr_stack+15787, vrr_stack+16723);
 _BUILD_f0q0(Data,vrr_stack+19294, vrr_stack+14229, vrr_stack+27449, vrr_stack+17516, vrr_stack+27176, vrr_stack+16957);
 _BUILD_g0q0(Data,vrr_stack+62798, vrr_stack+19294, vrr_stack+13319, vrr_stack+14229, vrr_stack+27449, vrr_stack+20899);
 _BUILD_00q0(Data,vrr_stack+17789, vrr_stack+1535, vrr_stack+4894, vrr_stack+1873, vrr_stack+2313, NULL);
 _BUILD_p0q0(Data,vrr_stack+14775, vrr_stack+15878, vrr_stack+17789, NULL, NULL, vrr_stack+1535);
 _BUILD_d0q0(Data,vrr_stack+16242, vrr_stack+15969, vrr_stack+14775, vrr_stack+25993, vrr_stack+15878, vrr_stack+1613);
 _BUILD_f0q0(Data,vrr_stack+20204, vrr_stack+27995, vrr_stack+16242, vrr_stack+26084, vrr_stack+15969, vrr_stack+25343);
 _BUILD_g0q0(Data,vrr_stack+37565, vrr_stack+12409, vrr_stack+20204, vrr_stack+26630, vrr_stack+27995, vrr_stack+23629);
 _BUILD_h0q0(Data,vrr_stack+7312, vrr_stack+17929, vrr_stack+37565, vrr_stack+13319, vrr_stack+12409, vrr_stack+43043);
 _BUILD_h0q0(Data,vrr_stack+50600, vrr_stack+62798, vrr_stack+17929, vrr_stack+19294, vrr_stack+13319, vrr_stack+21679);
 _BUILD_i0q0(Data,vrr_stack+102188, vrr_stack+50600, vrr_stack+7312, vrr_stack+62798, vrr_stack+17929, vrr_stack+68804);
 _BUILD_00q0(Data,vrr_stack+68804, vrr_stack+47090, vrr_stack+24563, vrr_stack+2093, vrr_stack+4828, NULL);
 _BUILD_p0q0(Data,vrr_stack+68895, vrr_stack+68804, vrr_stack+17425, NULL, NULL, vrr_stack+24563);
 _BUILD_d0q0(Data,vrr_stack+69168, vrr_stack+68895, vrr_stack+17516, vrr_stack+68804, vrr_stack+17425, vrr_stack+24641);
 _BUILD_f0q0(Data,vrr_stack+43043, vrr_stack+69168, vrr_stack+14229, vrr_stack+68895, vrr_stack+17516, vrr_stack+24875);
 _BUILD_g0q0(Data,vrr_stack+21114, vrr_stack+43043, vrr_stack+19294, vrr_stack+69168, vrr_stack+14229, vrr_stack+22849);
 _BUILD_h0q0(Data,vrr_stack+22479, vrr_stack+21114, vrr_stack+62798, vrr_stack+43043, vrr_stack+19294, vrr_stack+2644);
 _BUILD_i0q0(Data,vrr_stack+104736, vrr_stack+22479, vrr_stack+50600, vrr_stack+21114, vrr_stack+62798, vrr_stack+70442);
 _BUILD_00q0(Data,vrr_stack+2644, vrr_stack+4894, vrr_stack+29257, vrr_stack+2313, vrr_stack+31456, NULL);
 _BUILD_p0q0(Data,vrr_stack+2735, vrr_stack+17789, vrr_stack+2644, NULL, NULL, vrr_stack+4894);
 _BUILD_d0q0(Data,vrr_stack+3008, vrr_stack+14775, vrr_stack+2735, vrr_stack+15878, vrr_stack+17789, vrr_stack+4972);
 _BUILD_f0q0(Data,vrr_stack+3554, vrr_stack+16242, vrr_stack+3008, vrr_stack+15969, vrr_stack+14775, vrr_stack+5206);
 _BUILD_g0q0(Data,vrr_stack+69714, vrr_stack+20204, vrr_stack+3554, vrr_stack+27995, vrr_stack+16242, vrr_stack+48650);
 _BUILD_h0q0(Data,vrr_stack+107284, vrr_stack+37565, vrr_stack+69714, vrr_stack+12409, vrr_stack+20204, vrr_stack+49430);
 _BUILD_i0q0(Data,vrr_stack+109195, vrr_stack+7312, vrr_stack+107284, vrr_stack+17929, vrr_stack+37565, vrr_stack+45383);
 _BUILD_k0q0(Data,vrr_stack+111743, vrr_stack+102188, vrr_stack+109195, vrr_stack+50600, vrr_stack+7312, vrr_stack+78086);
 _BUILD_k0q0(Data,vrr_stack+115019, vrr_stack+104736, vrr_stack+102188, vrr_stack+22479, vrr_stack+50600, vrr_stack+72080);
 _BUILD_l0q0(Data,vrr_stack+118295, vrr_stack+115019, vrr_stack+111743, vrr_stack+104736, vrr_stack+102188, vrr_stack+80270);
 _BUILD_00q0(Data,vrr_stack+78086, vrr_stack+28985, vrr_stack+47090, vrr_stack+2578, vrr_stack+2093, NULL);
 _BUILD_p0q0(Data,vrr_stack+78177, vrr_stack+78086, vrr_stack+68804, NULL, NULL, vrr_stack+47090);
 _BUILD_d0q0(Data,vrr_stack+78450, vrr_stack+78177, vrr_stack+68895, vrr_stack+78086, vrr_stack+68804, vrr_stack+47168);
 _BUILD_f0q0(Data,vrr_stack+78996, vrr_stack+78450, vrr_stack+69168, vrr_stack+78177, vrr_stack+68895, vrr_stack+47402);
 _BUILD_g0q0(Data,vrr_stack+79906, vrr_stack+78996, vrr_stack+43043, vrr_stack+78450, vrr_stack+69168, vrr_stack+47870);
 _BUILD_h0q0(Data,vrr_stack+47168, vrr_stack+79906, vrr_stack+21114, vrr_stack+78996, vrr_stack+43043, vrr_stack+44213);
 _BUILD_i0q0(Data,vrr_stack+71079, vrr_stack+47168, vrr_stack+22479, vrr_stack+79906, vrr_stack+21114, vrr_stack+74264);
   tmp = vrr_stack + 71079;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0q0(Data,vrr_stack+78177, vrr_stack+71079, vrr_stack+104736, vrr_stack+47168, vrr_stack+22479, vrr_stack+75902);
   tmp = vrr_stack + 78177;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0q0(Data,vrr_stack+73627, vrr_stack+78177, vrr_stack+115019, vrr_stack+71079, vrr_stack+104736, vrr_stack+53228);
   tmp = vrr_stack + 73627;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+29063, vrr_stack+0, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+71079, vrr_stack+29066, vrr_stack+24, vrr_stack+272, vrr_stack+29063, NULL);
 _BUILD_00g0(Data,vrr_stack+71089, vrr_stack+29072, vrr_stack+71079, vrr_stack+31361, vrr_stack+29066, NULL);
 _BUILD_00h0(Data,vrr_stack+71104, vrr_stack+29082, vrr_stack+71089, vrr_stack+31367, vrr_stack+29072, NULL);
 _BUILD_00i0(Data,vrr_stack+71125, vrr_stack+29097, vrr_stack+71104, vrr_stack+31377, vrr_stack+29082, NULL);
 _BUILD_00k0(Data,vrr_stack+71153, vrr_stack+29118, vrr_stack+71125, vrr_stack+3, vrr_stack+29097, NULL);
 _BUILD_00l0(Data,vrr_stack+71189, vrr_stack+17893, vrr_stack+71153, vrr_stack+31392, vrr_stack+29118, NULL);
 _BUILD_00m0(Data,vrr_stack+71234, vrr_stack+29146, vrr_stack+71189, vrr_stack+31420, vrr_stack+17893, NULL);
 _BUILD_00n0(Data,vrr_stack+2578, vrr_stack+85, vrr_stack+71234, vrr_stack+2533, vrr_stack+29146, NULL);
 _BUILD_00o0(Data,vrr_stack+71289, vrr_stack+29191, vrr_stack+2578, vrr_stack+30, vrr_stack+85, NULL);
 _BUILD_00q0(Data,vrr_stack+71367, vrr_stack+29257, vrr_stack+71289, vrr_stack+31456, vrr_stack+29191, NULL);
 _BUILD_p0q0(Data,vrr_stack+71458, vrr_stack+2644, vrr_stack+71367, NULL, NULL, vrr_stack+29257);
 _BUILD_d0q0(Data,vrr_stack+71731, vrr_stack+2735, vrr_stack+71458, vrr_stack+17789, vrr_stack+2644, vrr_stack+275);
 _BUILD_f0q0(Data,vrr_stack+72277, vrr_stack+3008, vrr_stack+71731, vrr_stack+14775, vrr_stack+2735, vrr_stack+509);
 _BUILD_g0q0(Data,vrr_stack+47168, vrr_stack+3554, vrr_stack+72277, vrr_stack+16242, vrr_stack+3008, vrr_stack+29335);
 _BUILD_h0q0(Data,vrr_stack+48533, vrr_stack+69714, vrr_stack+47168, vrr_stack+20204, vrr_stack+3554, vrr_stack+30115);
 _BUILD_i0q0(Data,vrr_stack+43953, vrr_stack+107284, vrr_stack+48533, vrr_stack+37565, vrr_stack+69714, vrr_stack+5674);
 _BUILD_k0q0(Data,vrr_stack+52511, vrr_stack+109195, vrr_stack+43953, vrr_stack+7312, vrr_stack+107284, vrr_stack+31522);
 _BUILD_l0q0(Data,vrr_stack+29335, vrr_stack+111743, vrr_stack+52511, vrr_stack+102188, vrr_stack+109195, vrr_stack+56036);
 _BUILD_m0q0(Data,vrr_stack+122390, vrr_stack+118295, vrr_stack+29335, vrr_stack+115019, vrr_stack+111743, vrr_stack+90098);
 _BUILD_m0q0(Data,vrr_stack+127395, vrr_stack+73627, vrr_stack+118295, vrr_stack+78177, vrr_stack+115019, vrr_stack+83078);
   tmp = vrr_stack + 127395;
   target_ptr = Libint->vrr_classes[9][12];
   for(i=0;i<5005;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78177, vrr_stack+25811, vrr_stack+25993, vrr_stack+15553, vrr_stack+15709, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78282, vrr_stack+25902, vrr_stack+25811, vrr_stack+15631, vrr_stack+15553, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78387, vrr_stack+25993, vrr_stack+15878, vrr_stack+15709, vrr_stack+12331, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78492, vrr_stack+78177, vrr_stack+78387, NULL, NULL, vrr_stack+25993);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78807, vrr_stack+78282, vrr_stack+78177, NULL, NULL, vrr_stack+25811);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+79122, vrr_stack+78807, vrr_stack+78492, vrr_stack+78282, vrr_stack+78177, vrr_stack+26084);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26084, vrr_stack+15787, vrr_stack+25902, vrr_stack+12253, vrr_stack+15631, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+79752, vrr_stack+26084, vrr_stack+78282, NULL, NULL, vrr_stack+25902);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+80067, vrr_stack+79752, vrr_stack+78807, vrr_stack+26084, vrr_stack+78282, vrr_stack+26357);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26189, vrr_stack+15878, vrr_stack+17789, vrr_stack+12331, vrr_stack+1535, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26294, vrr_stack+78387, vrr_stack+26189, NULL, NULL, vrr_stack+15878);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+80697, vrr_stack+78492, vrr_stack+26294, vrr_stack+78177, vrr_stack+78387, vrr_stack+15969);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+81327, vrr_stack+79122, vrr_stack+80697, vrr_stack+78807, vrr_stack+78492, vrr_stack+27995);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+90098, vrr_stack+80067, vrr_stack+79122, vrr_stack+79752, vrr_stack+78807, vrr_stack+26630);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+91148, vrr_stack+90098, vrr_stack+81327, vrr_stack+80067, vrr_stack+79122, vrr_stack+12409);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+27995, vrr_stack+17425, vrr_stack+15787, vrr_stack+24563, vrr_stack+12253, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12253, vrr_stack+27995, vrr_stack+26084, NULL, NULL, vrr_stack+15787);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12568, vrr_stack+12253, vrr_stack+79752, vrr_stack+27995, vrr_stack+26084, vrr_stack+27176);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+33430, vrr_stack+12568, vrr_stack+80067, vrr_stack+12253, vrr_stack+79752, vrr_stack+27449);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4972, vrr_stack+33430, vrr_stack+90098, vrr_stack+12568, vrr_stack+80067, vrr_stack+13319);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+13198, vrr_stack+17789, vrr_stack+2644, vrr_stack+1535, vrr_stack+4894, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+13303, vrr_stack+26189, vrr_stack+13198, NULL, NULL, vrr_stack+17789);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+28100, vrr_stack+26294, vrr_stack+13303, vrr_stack+78387, vrr_stack+26189, vrr_stack+14775);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26609, vrr_stack+80697, vrr_stack+28100, vrr_stack+78492, vrr_stack+26294, vrr_stack+16242);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+140, vrr_stack+81327, vrr_stack+26609, vrr_stack+79122, vrr_stack+80697, vrr_stack+20204);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+55787, vrr_stack+91148, vrr_stack+140, vrr_stack+90098, vrr_stack+81327, vrr_stack+37565);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+132400, vrr_stack+4972, vrr_stack+91148, vrr_stack+33430, vrr_stack+90098, vrr_stack+17929);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134605, vrr_stack+132400, vrr_stack+55787, vrr_stack+4972, vrr_stack+91148, vrr_stack+7312);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+17929, vrr_stack+68804, vrr_stack+17425, vrr_stack+47090, vrr_stack+24563, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+18034, vrr_stack+17929, vrr_stack+27995, NULL, NULL, vrr_stack+17425);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+18349, vrr_stack+18034, vrr_stack+12253, vrr_stack+17929, vrr_stack+27995, vrr_stack+17516);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37565, vrr_stack+18349, vrr_stack+12568, vrr_stack+18034, vrr_stack+12253, vrr_stack+14229);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+13618, vrr_stack+37565, vrr_stack+33430, vrr_stack+18349, vrr_stack+12568, vrr_stack+19294);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+6547, vrr_stack+13618, vrr_stack+4972, vrr_stack+37565, vrr_stack+33430, vrr_stack+62798);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+137545, vrr_stack+6547, vrr_stack+132400, vrr_stack+13618, vrr_stack+4972, vrr_stack+50600);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+62798, vrr_stack+2644, vrr_stack+71367, vrr_stack+4894, vrr_stack+29257, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+62903, vrr_stack+13198, vrr_stack+62798, NULL, NULL, vrr_stack+2644);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+63218, vrr_stack+13303, vrr_stack+62903, vrr_stack+26189, vrr_stack+13198, vrr_stack+2735);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+63848, vrr_stack+28100, vrr_stack+63218, vrr_stack+26294, vrr_stack+13303, vrr_stack+3008);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+18979, vrr_stack+26609, vrr_stack+63848, vrr_stack+80697, vrr_stack+28100, vrr_stack+3554);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2735, vrr_stack+140, vrr_stack+18979, vrr_stack+81327, vrr_stack+26609, vrr_stack+69714);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+140485, vrr_stack+55787, vrr_stack+2735, vrr_stack+91148, vrr_stack+140, vrr_stack+107284);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+143425, vrr_stack+134605, vrr_stack+140485, vrr_stack+132400, vrr_stack+55787, vrr_stack+109195);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+107284, vrr_stack+137545, vrr_stack+134605, vrr_stack+6547, vrr_stack+132400, vrr_stack+102188);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+147205, vrr_stack+107284, vrr_stack+143425, vrr_stack+137545, vrr_stack+134605, vrr_stack+111743);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102188, vrr_stack+78086, vrr_stack+68804, vrr_stack+28985, vrr_stack+47090, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102293, vrr_stack+102188, vrr_stack+17929, NULL, NULL, vrr_stack+68804);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102608, vrr_stack+102293, vrr_stack+18034, vrr_stack+102188, vrr_stack+17929, vrr_stack+68895);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+103238, vrr_stack+102608, vrr_stack+18349, vrr_stack+102293, vrr_stack+18034, vrr_stack+69168);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+68895, vrr_stack+103238, vrr_stack+37565, vrr_stack+102608, vrr_stack+18349, vrr_stack+43043);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+111064, vrr_stack+68895, vrr_stack+13618, vrr_stack+103238, vrr_stack+37565, vrr_stack+21114);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+151930, vrr_stack+111064, vrr_stack+6547, vrr_stack+68895, vrr_stack+13618, vrr_stack+22479);
   tmp = vrr_stack + 151930;
   target_ptr = Libint->vrr_classes[6][13];
   for(i=0;i<2940;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+20554, vrr_stack+151930, vrr_stack+137545, vrr_stack+111064, vrr_stack+6547, vrr_stack+104736);
   tmp = vrr_stack + 20554;
   target_ptr = Libint->vrr_classes[7][13];
   for(i=0;i<3780;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102293, vrr_stack+20554, vrr_stack+107284, vrr_stack+151930, vrr_stack+137545, vrr_stack+115019);
   tmp = vrr_stack + 102293;
   target_ptr = Libint->vrr_classes[8][13];
   for(i=0;i<4725;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+151930, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+151933, vrr_stack+0, vrr_stack+151930, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+151939, vrr_stack+24, vrr_stack+151933, vrr_stack+29063, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+151949, vrr_stack+71079, vrr_stack+151939, vrr_stack+29066, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+3, vrr_stack+71089, vrr_stack+151949, vrr_stack+29072, vrr_stack+71079, NULL);
 _BUILD_00i0(Data,vrr_stack+151964, vrr_stack+71104, vrr_stack+3, vrr_stack+29082, vrr_stack+71089, NULL);
 _BUILD_00k0(Data,vrr_stack+151992, vrr_stack+71125, vrr_stack+151964, vrr_stack+29097, vrr_stack+71104, NULL);
 _BUILD_00l0(Data,vrr_stack+152028, vrr_stack+71153, vrr_stack+151992, vrr_stack+29118, vrr_stack+71125, NULL);
 _BUILD_00m0(Data,vrr_stack+30, vrr_stack+71189, vrr_stack+152028, vrr_stack+17893, vrr_stack+71153, NULL);
 _BUILD_00n0(Data,vrr_stack+152073, vrr_stack+71234, vrr_stack+30, vrr_stack+29146, vrr_stack+71189, NULL);
 _BUILD_00o0(Data,vrr_stack+152139, vrr_stack+2578, vrr_stack+152073, vrr_stack+85, vrr_stack+71234, NULL);
 _BUILD_00q0(Data,vrr_stack+152217, vrr_stack+71289, vrr_stack+152139, vrr_stack+29191, vrr_stack+2578, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+152308, vrr_stack+71367, vrr_stack+152217, vrr_stack+29257, vrr_stack+71289, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+152413, vrr_stack+62798, vrr_stack+152308, NULL, NULL, vrr_stack+71367);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+152728, vrr_stack+62903, vrr_stack+152413, vrr_stack+13198, vrr_stack+62798, vrr_stack+71458);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+153358, vrr_stack+63218, vrr_stack+152728, vrr_stack+13303, vrr_stack+62903, vrr_stack+71731);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+111064, vrr_stack+63848, vrr_stack+153358, vrr_stack+28100, vrr_stack+63218, vrr_stack+72277);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+112639, vrr_stack+18979, vrr_stack+111064, vrr_stack+26609, vrr_stack+63848, vrr_stack+47168);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+114844, vrr_stack+2735, vrr_stack+112639, vrr_stack+140, vrr_stack+18979, vrr_stack+48533);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+46501, vrr_stack+140485, vrr_stack+114844, vrr_stack+55787, vrr_stack+2735, vrr_stack+43953);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+154408, vrr_stack+143425, vrr_stack+46501, vrr_stack+134605, vrr_stack+140485, vrr_stack+52511);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+159133, vrr_stack+147205, vrr_stack+154408, vrr_stack+107284, vrr_stack+143425, vrr_stack+29335);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+164908, vrr_stack+102293, vrr_stack+147205, vrr_stack+20554, vrr_stack+107284, vrr_stack+118295);
   tmp = vrr_stack + 164908;
   target_ptr = Libint->vrr_classes[9][13];
   for(i=0;i<5775;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20554, vrr_stack+78177, vrr_stack+78387, vrr_stack+25811, vrr_stack+25993, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20674, vrr_stack+78282, vrr_stack+78177, vrr_stack+25902, vrr_stack+25811, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20794, vrr_stack+78387, vrr_stack+26189, vrr_stack+25993, vrr_stack+15878, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20914, vrr_stack+20554, vrr_stack+20794, NULL, NULL, vrr_stack+78387);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21274, vrr_stack+20674, vrr_stack+20554, NULL, NULL, vrr_stack+78177);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21634, vrr_stack+21274, vrr_stack+20914, vrr_stack+20674, vrr_stack+20554, vrr_stack+78492);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+78492, vrr_stack+26084, vrr_stack+78282, vrr_stack+15787, vrr_stack+25902, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+22354, vrr_stack+78492, vrr_stack+20674, NULL, NULL, vrr_stack+78282);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+22714, vrr_stack+22354, vrr_stack+21274, vrr_stack+78492, vrr_stack+20674, vrr_stack+78807);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+78612, vrr_stack+26189, vrr_stack+13198, vrr_stack+15878, vrr_stack+17789, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+15878, vrr_stack+20794, vrr_stack+78612, NULL, NULL, vrr_stack+26189);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+16238, vrr_stack+20914, vrr_stack+15878, vrr_stack+20554, vrr_stack+20794, vrr_stack+26294);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23434, vrr_stack+21634, vrr_stack+16238, vrr_stack+21274, vrr_stack+20914, vrr_stack+80697);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+24634, vrr_stack+22714, vrr_stack+21634, vrr_stack+22354, vrr_stack+21274, vrr_stack+79122);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+71458, vrr_stack+24634, vrr_stack+23434, vrr_stack+22714, vrr_stack+21634, vrr_stack+81327);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+80697, vrr_stack+27995, vrr_stack+26084, vrr_stack+17425, vrr_stack+15787, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+80817, vrr_stack+80697, vrr_stack+78492, NULL, NULL, vrr_stack+26084);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+81177, vrr_stack+80817, vrr_stack+22354, vrr_stack+80697, vrr_stack+78492, vrr_stack+79752);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+78732, vrr_stack+81177, vrr_stack+22714, vrr_stack+80817, vrr_stack+22354, vrr_stack+80067);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+68895, vrr_stack+78732, vrr_stack+24634, vrr_stack+81177, vrr_stack+22714, vrr_stack+90098);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+90098, vrr_stack+13198, vrr_stack+62798, vrr_stack+17789, vrr_stack+2644, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+90218, vrr_stack+78612, vrr_stack+90098, NULL, NULL, vrr_stack+13198);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+81897, vrr_stack+15878, vrr_stack+90218, vrr_stack+20794, vrr_stack+78612, vrr_stack+13303);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+43043, vrr_stack+16238, vrr_stack+81897, vrr_stack+20914, vrr_stack+15878, vrr_stack+28100);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+28100, vrr_stack+23434, vrr_stack+43043, vrr_stack+21634, vrr_stack+16238, vrr_stack+26609);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+29900, vrr_stack+71458, vrr_stack+28100, vrr_stack+24634, vrr_stack+23434, vrr_stack+140);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+50281, vrr_stack+68895, vrr_stack+71458, vrr_stack+78732, vrr_stack+24634, vrr_stack+91148);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+170683, vrr_stack+50281, vrr_stack+29900, vrr_stack+68895, vrr_stack+71458, vrr_stack+55787);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+32420, vrr_stack+17929, vrr_stack+27995, vrr_stack+68804, vrr_stack+17425, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+32540, vrr_stack+32420, vrr_stack+80697, NULL, NULL, vrr_stack+27995);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+90578, vrr_stack+32540, vrr_stack+80817, vrr_stack+32420, vrr_stack+80697, vrr_stack+12253);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+91298, vrr_stack+90578, vrr_stack+81177, vrr_stack+32540, vrr_stack+80817, vrr_stack+12568);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+85, vrr_stack+91298, vrr_stack+78732, vrr_stack+90578, vrr_stack+81177, vrr_stack+33430);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+52801, vrr_stack+85, vrr_stack+68895, vrr_stack+91298, vrr_stack+78732, vrr_stack+4972);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+55321, vrr_stack+52801, vrr_stack+50281, vrr_stack+85, vrr_stack+68895, vrr_stack+132400);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132400, vrr_stack+62798, vrr_stack+152308, vrr_stack+2644, vrr_stack+71367, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132520, vrr_stack+90098, vrr_stack+132400, NULL, NULL, vrr_stack+62798);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132880, vrr_stack+90218, vrr_stack+132520, vrr_stack+78612, vrr_stack+90098, vrr_stack+62903);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+32900, vrr_stack+81897, vrr_stack+132880, vrr_stack+15878, vrr_stack+90218, vrr_stack+63218);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+44243, vrr_stack+43043, vrr_stack+32900, vrr_stack+16238, vrr_stack+81897, vrr_stack+63848);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+174043, vrr_stack+28100, vrr_stack+44243, vrr_stack+23434, vrr_stack+43043, vrr_stack+18979);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+176563, vrr_stack+29900, vrr_stack+174043, vrr_stack+71458, vrr_stack+28100, vrr_stack+2735);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+179923, vrr_stack+170683, vrr_stack+176563, vrr_stack+50281, vrr_stack+29900, vrr_stack+140485);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+184243, vrr_stack+55321, vrr_stack+170683, vrr_stack+52801, vrr_stack+50281, vrr_stack+134605);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+188563, vrr_stack+184243, vrr_stack+179923, vrr_stack+55321, vrr_stack+170683, vrr_stack+143425);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140485, vrr_stack+102188, vrr_stack+17929, vrr_stack+78086, vrr_stack+68804, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140605, vrr_stack+140485, vrr_stack+32420, NULL, NULL, vrr_stack+17929);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140965, vrr_stack+140605, vrr_stack+32540, vrr_stack+140485, vrr_stack+32420, vrr_stack+18034);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+141685, vrr_stack+140965, vrr_stack+90578, vrr_stack+140605, vrr_stack+32540, vrr_stack+18349);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+18034, vrr_stack+141685, vrr_stack+91298, vrr_stack+140965, vrr_stack+90578, vrr_stack+37565);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+142885, vrr_stack+18034, vrr_stack+85, vrr_stack+141685, vrr_stack+91298, vrr_stack+13618);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2644, vrr_stack+142885, vrr_stack+52801, vrr_stack+18034, vrr_stack+85, vrr_stack+6547);
   tmp = vrr_stack + 2644;
   target_ptr = Libint->vrr_classes[6][14];
   for(i=0;i<3360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+193963, vrr_stack+2644, vrr_stack+55321, vrr_stack+142885, vrr_stack+52801, vrr_stack+137545);
   tmp = vrr_stack + 193963;
   target_ptr = Libint->vrr_classes[7][14];
   for(i=0;i<4320;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+140605, vrr_stack+193963, vrr_stack+184243, vrr_stack+2644, vrr_stack+55321, vrr_stack+107284);
   tmp = vrr_stack + 140605;
   target_ptr = Libint->vrr_classes[8][14];
   for(i=0;i<5400;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2644, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2647, vrr_stack+151930, vrr_stack+2644, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+2653, vrr_stack+151933, vrr_stack+2647, vrr_stack+0, vrr_stack+151930, NULL);
 _BUILD_00g0(Data,vrr_stack+2663, vrr_stack+151939, vrr_stack+2653, vrr_stack+24, vrr_stack+151933, NULL);
 _BUILD_00h0(Data,vrr_stack+2678, vrr_stack+151949, vrr_stack+2663, vrr_stack+71079, vrr_stack+151939, NULL);
 _BUILD_00i0(Data,vrr_stack+2699, vrr_stack+3, vrr_stack+2678, vrr_stack+71089, vrr_stack+151949, NULL);
 _BUILD_00k0(Data,vrr_stack+2727, vrr_stack+151964, vrr_stack+2699, vrr_stack+71104, vrr_stack+3, NULL);
 _BUILD_00l0(Data,vrr_stack+2763, vrr_stack+151992, vrr_stack+2727, vrr_stack+71125, vrr_stack+151964, NULL);
 _BUILD_00m0(Data,vrr_stack+2808, vrr_stack+152028, vrr_stack+2763, vrr_stack+71153, vrr_stack+151992, NULL);
 _BUILD_00n0(Data,vrr_stack+2863, vrr_stack+30, vrr_stack+2808, vrr_stack+71189, vrr_stack+152028, NULL);
 _BUILD_00o0(Data,vrr_stack+2929, vrr_stack+152073, vrr_stack+2863, vrr_stack+71234, vrr_stack+30, NULL);
 _BUILD_00q0(Data,vrr_stack+68804, vrr_stack+152139, vrr_stack+2929, vrr_stack+2578, vrr_stack+152073, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3007, vrr_stack+152217, vrr_stack+68804, vrr_stack+71289, vrr_stack+152139, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3112, vrr_stack+152308, vrr_stack+3007, vrr_stack+71367, vrr_stack+152217, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3232, vrr_stack+132400, vrr_stack+3112, NULL, NULL, vrr_stack+152308);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3592, vrr_stack+132520, vrr_stack+3232, vrr_stack+90098, vrr_stack+132400, vrr_stack+152413);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+146005, vrr_stack+132880, vrr_stack+3592, vrr_stack+90218, vrr_stack+132520, vrr_stack+152728);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4312, vrr_stack+32900, vrr_stack+146005, vrr_stack+81897, vrr_stack+132880, vrr_stack+153358);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+18034, vrr_stack+44243, vrr_stack+4312, vrr_stack+43043, vrr_stack+32900, vrr_stack+111064);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+133600, vrr_stack+174043, vrr_stack+18034, vrr_stack+28100, vrr_stack+44243, vrr_stack+112639);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+107018, vrr_stack+176563, vrr_stack+133600, vrr_stack+29900, vrr_stack+174043, vrr_stack+114844);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+111338, vrr_stack+179923, vrr_stack+107018, vrr_stack+170683, vrr_stack+176563, vrr_stack+46501);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+198283, vrr_stack+188563, vrr_stack+111338, vrr_stack+184243, vrr_stack+179923, vrr_stack+154408);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+152413, vrr_stack+140605, vrr_stack+188563, vrr_stack+193963, vrr_stack+184243, vrr_stack+147205);
   tmp = vrr_stack + 152413;
   target_ptr = Libint->vrr_classes[9][14];
   for(i=0;i<6600;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+193963, vrr_stack+20554, vrr_stack+20794, vrr_stack+78177, vrr_stack+78387, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+194099, vrr_stack+20674, vrr_stack+20554, vrr_stack+78282, vrr_stack+78177, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+194235, vrr_stack+20794, vrr_stack+78612, vrr_stack+78387, vrr_stack+26189, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+194371, vrr_stack+193963, vrr_stack+194235, NULL, NULL, vrr_stack+20794);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+194779, vrr_stack+194099, vrr_stack+193963, NULL, NULL, vrr_stack+20554);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+195187, vrr_stack+194779, vrr_stack+194371, vrr_stack+194099, vrr_stack+193963, vrr_stack+20914);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+20914, vrr_stack+78492, vrr_stack+20674, vrr_stack+26084, vrr_stack+78282, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+196003, vrr_stack+20914, vrr_stack+194099, NULL, NULL, vrr_stack+20674);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+196411, vrr_stack+196003, vrr_stack+194779, vrr_stack+20914, vrr_stack+194099, vrr_stack+21274);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+21050, vrr_stack+78612, vrr_stack+90098, vrr_stack+26189, vrr_stack+13198, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+26189, vrr_stack+194235, vrr_stack+21050, NULL, NULL, vrr_stack+78612);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+26597, vrr_stack+194371, vrr_stack+26189, vrr_stack+193963, vrr_stack+194235, vrr_stack+15878);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6112, vrr_stack+195187, vrr_stack+26597, vrr_stack+194779, vrr_stack+194371, vrr_stack+16238);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7472, vrr_stack+196411, vrr_stack+195187, vrr_stack+196003, vrr_stack+194779, vrr_stack+21634);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+62903, vrr_stack+7472, vrr_stack+6112, vrr_stack+196411, vrr_stack+195187, vrr_stack+23434);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+23434, vrr_stack+80697, vrr_stack+78492, vrr_stack+27995, vrr_stack+26084, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+23570, vrr_stack+23434, vrr_stack+20914, NULL, NULL, vrr_stack+78492);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+21186, vrr_stack+23570, vrr_stack+196003, vrr_stack+23434, vrr_stack+20914, vrr_stack+22354);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+37565, vrr_stack+21186, vrr_stack+196411, vrr_stack+23570, vrr_stack+196003, vrr_stack+22714);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+136960, vrr_stack+37565, vrr_stack+7472, vrr_stack+21186, vrr_stack+196411, vrr_stack+24634);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+23978, vrr_stack+90098, vrr_stack+132400, vrr_stack+13198, vrr_stack+62798, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+24114, vrr_stack+21050, vrr_stack+23978, NULL, NULL, vrr_stack+90098);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+24522, vrr_stack+26189, vrr_stack+24114, vrr_stack+194235, vrr_stack+21050, vrr_stack+90218);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+22002, vrr_stack+26597, vrr_stack+24522, vrr_stack+194371, vrr_stack+26189, vrr_stack+81897);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+12253, vrr_stack+6112, vrr_stack+22002, vrr_stack+195187, vrr_stack+26597, vrr_stack+43043);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+14293, vrr_stack+62903, vrr_stack+12253, vrr_stack+7472, vrr_stack+6112, vrr_stack+28100);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+46043, vrr_stack+136960, vrr_stack+62903, vrr_stack+37565, vrr_stack+7472, vrr_stack+71458);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+204883, vrr_stack+46043, vrr_stack+14293, vrr_stack+136960, vrr_stack+62903, vrr_stack+29900);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+28100, vrr_stack+32420, vrr_stack+80697, vrr_stack+17929, vrr_stack+27995, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+28236, vrr_stack+28100, vrr_stack+23434, NULL, NULL, vrr_stack+80697);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+28644, vrr_stack+28236, vrr_stack+23570, vrr_stack+28100, vrr_stack+23434, vrr_stack+80817);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+29460, vrr_stack+28644, vrr_stack+21186, vrr_stack+28236, vrr_stack+23570, vrr_stack+81177);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+80817, vrr_stack+29460, vrr_stack+37565, vrr_stack+28644, vrr_stack+21186, vrr_stack+78732);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+70695, vrr_stack+80817, vrr_stack+136960, vrr_stack+29460, vrr_stack+37565, vrr_stack+68895);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+208691, vrr_stack+70695, vrr_stack+46043, vrr_stack+80817, vrr_stack+136960, vrr_stack+50281);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+68895, vrr_stack+132400, vrr_stack+3112, vrr_stack+62798, vrr_stack+152308, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+69031, vrr_stack+23978, vrr_stack+68895, NULL, NULL, vrr_stack+132400);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+69439, vrr_stack+24114, vrr_stack+69031, vrr_stack+21050, vrr_stack+23978, vrr_stack+132520);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+78732, vrr_stack+24522, vrr_stack+69439, vrr_stack+26189, vrr_stack+24114, vrr_stack+132880);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48899, vrr_stack+22002, vrr_stack+78732, vrr_stack+26597, vrr_stack+24522, vrr_stack+32900);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+212499, vrr_stack+12253, vrr_stack+48899, vrr_stack+6112, vrr_stack+22002, vrr_stack+44243);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+215355, vrr_stack+14293, vrr_stack+212499, vrr_stack+62903, vrr_stack+12253, vrr_stack+174043);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+219163, vrr_stack+204883, vrr_stack+215355, vrr_stack+46043, vrr_stack+14293, vrr_stack+176563);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+174043, vrr_stack+208691, vrr_stack+204883, vrr_stack+70695, vrr_stack+46043, vrr_stack+170683);
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+224059, vrr_stack+174043, vrr_stack+219163, vrr_stack+208691, vrr_stack+204883, vrr_stack+179923);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+170683, vrr_stack+140485, vrr_stack+32420, vrr_stack+102188, vrr_stack+17929, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+170819, vrr_stack+170683, vrr_stack+28100, NULL, NULL, vrr_stack+32420);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+171227, vrr_stack+170819, vrr_stack+28236, vrr_stack+170683, vrr_stack+28100, vrr_stack+32540);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+32540, vrr_stack+171227, vrr_stack+28644, vrr_stack+170819, vrr_stack+28236, vrr_stack+90578);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+178939, vrr_stack+32540, vrr_stack+29460, vrr_stack+171227, vrr_stack+28644, vrr_stack+91298);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+170819, vrr_stack+178939, vrr_stack+80817, vrr_stack+32540, vrr_stack+29460, vrr_stack+85);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+230179, vrr_stack+170819, vrr_stack+70695, vrr_stack+178939, vrr_stack+80817, vrr_stack+52801);
   tmp = vrr_stack + 230179;
   target_ptr = Libint->vrr_classes[6][15];
   for(i=0;i<3808;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+178939, vrr_stack+230179, vrr_stack+208691, vrr_stack+170819, vrr_stack+70695, vrr_stack+55321);
   tmp = vrr_stack + 178939;
   target_ptr = Libint->vrr_classes[7][15];
   for(i=0;i<4896;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+50939, vrr_stack+178939, vrr_stack+174043, vrr_stack+230179, vrr_stack+208691, vrr_stack+184243);
   tmp = vrr_stack + 50939;
   target_ptr = Libint->vrr_classes[8][15];
   for(i=0;i<6120;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+2644, vrr_stack+0, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+230179, vrr_stack+2647, vrr_stack+24, vrr_stack+151930, vrr_stack+2644, NULL);
 _BUILD_00g0(Data,vrr_stack+230189, vrr_stack+2653, vrr_stack+230179, vrr_stack+151933, vrr_stack+2647, NULL);
 _BUILD_00h0(Data,vrr_stack+230204, vrr_stack+2663, vrr_stack+230189, vrr_stack+151939, vrr_stack+2653, NULL);
 _BUILD_00i0(Data,vrr_stack+230225, vrr_stack+2678, vrr_stack+230204, vrr_stack+151949, vrr_stack+2663, NULL);
 _BUILD_00k0(Data,vrr_stack+230253, vrr_stack+2699, vrr_stack+230225, vrr_stack+3, vrr_stack+2678, NULL);
 _BUILD_00l0(Data,vrr_stack+230289, vrr_stack+2727, vrr_stack+230253, vrr_stack+151964, vrr_stack+2699, NULL);
 _BUILD_00m0(Data,vrr_stack+151930, vrr_stack+2763, vrr_stack+230289, vrr_stack+151992, vrr_stack+2727, NULL);
 _BUILD_00n0(Data,vrr_stack+230334, vrr_stack+2808, vrr_stack+151930, vrr_stack+152028, vrr_stack+2763, NULL);
 _BUILD_00o0(Data,vrr_stack+151985, vrr_stack+2863, vrr_stack+230334, vrr_stack+30, vrr_stack+2808, NULL);
 _BUILD_00q0(Data,vrr_stack+30, vrr_stack+2929, vrr_stack+151985, vrr_stack+152073, vrr_stack+2863, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+102188, vrr_stack+68804, vrr_stack+30, vrr_stack+152139, vrr_stack+2929, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+159013, vrr_stack+3007, vrr_stack+102188, vrr_stack+152217, vrr_stack+68804, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+121, vrr_stack+3112, vrr_stack+159013, vrr_stack+152308, vrr_stack+3007, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+257, vrr_stack+68895, vrr_stack+121, NULL, NULL, vrr_stack+3112);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+665, vrr_stack+69031, vrr_stack+257, vrr_stack+23978, vrr_stack+68895, vrr_stack+3232);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+230400, vrr_stack+69439, vrr_stack+665, vrr_stack+24114, vrr_stack+69031, vrr_stack+3592);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+231760, vrr_stack+78732, vrr_stack+230400, vrr_stack+24522, vrr_stack+69439, vrr_stack+146005);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+170819, vrr_stack+48899, vrr_stack+231760, vrr_stack+22002, vrr_stack+78732, vrr_stack+4312);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+183835, vrr_stack+212499, vrr_stack+170819, vrr_stack+12253, vrr_stack+48899, vrr_stack+18034);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+233800, vrr_stack+215355, vrr_stack+183835, vrr_stack+14293, vrr_stack+212499, vrr_stack+133600);
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+238696, vrr_stack+219163, vrr_stack+233800, vrr_stack+204883, vrr_stack+215355, vrr_stack+107018);
 am[0] = 9;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+244816, vrr_stack+224059, vrr_stack+238696, vrr_stack+174043, vrr_stack+219163, vrr_stack+111338);
 am[0] = 9;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+107018, vrr_stack+50939, vrr_stack+224059, vrr_stack+178939, vrr_stack+174043, vrr_stack+188563);
   tmp = vrr_stack + 107018;
   target_ptr = Libint->vrr_classes[9][15];
   for(i=0;i<7480;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+178939, vrr_stack+193963, vrr_stack+194235, vrr_stack+20554, vrr_stack+20794, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+179092, vrr_stack+194099, vrr_stack+193963, vrr_stack+20674, vrr_stack+20554, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+179245, vrr_stack+194235, vrr_stack+21050, vrr_stack+20794, vrr_stack+78612, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+179398, vrr_stack+178939, vrr_stack+179245, NULL, NULL, vrr_stack+194235);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+179857, vrr_stack+179092, vrr_stack+178939, NULL, NULL, vrr_stack+193963);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+180316, vrr_stack+179857, vrr_stack+179398, vrr_stack+179092, vrr_stack+178939, vrr_stack+194371);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+194371, vrr_stack+20914, vrr_stack+194099, vrr_stack+78492, vrr_stack+20674, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+181234, vrr_stack+194371, vrr_stack+179092, NULL, NULL, vrr_stack+194099);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+181693, vrr_stack+181234, vrr_stack+179857, vrr_stack+194371, vrr_stack+179092, vrr_stack+194779);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+194524, vrr_stack+21050, vrr_stack+23978, vrr_stack+78612, vrr_stack+90098, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+194677, vrr_stack+179245, vrr_stack+194524, NULL, NULL, vrr_stack+21050);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+182611, vrr_stack+179398, vrr_stack+194677, vrr_stack+178939, vrr_stack+179245, vrr_stack+26189);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+114498, vrr_stack+180316, vrr_stack+182611, vrr_stack+179857, vrr_stack+179398, vrr_stack+26597);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+116028, vrr_stack+181693, vrr_stack+180316, vrr_stack+181234, vrr_stack+179857, vrr_stack+195187);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3232, vrr_stack+116028, vrr_stack+114498, vrr_stack+181693, vrr_stack+180316, vrr_stack+6112);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+195136, vrr_stack+23434, vrr_stack+20914, vrr_stack+80697, vrr_stack+78492, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+195289, vrr_stack+195136, vrr_stack+194371, NULL, NULL, vrr_stack+20914);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+146005, vrr_stack+195289, vrr_stack+181234, vrr_stack+195136, vrr_stack+194371, vrr_stack+196003);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+5527, vrr_stack+146005, vrr_stack+181693, vrr_stack+195289, vrr_stack+181234, vrr_stack+196411);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+195748, vrr_stack+5527, vrr_stack+116028, vrr_stack+146005, vrr_stack+181693, vrr_stack+7472);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+198043, vrr_stack+23978, vrr_stack+68895, vrr_stack+90098, vrr_stack+132400, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+90098, vrr_stack+194524, vrr_stack+198043, NULL, NULL, vrr_stack+23978);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+90557, vrr_stack+194677, vrr_stack+90098, vrr_stack+179245, vrr_stack+194524, vrr_stack+24114);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+91475, vrr_stack+182611, vrr_stack+90557, vrr_stack+179398, vrr_stack+194677, vrr_stack+24522);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+24114, vrr_stack+114498, vrr_stack+91475, vrr_stack+180316, vrr_stack+182611, vrr_stack+22002);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+132520, vrr_stack+3232, vrr_stack+24114, vrr_stack+116028, vrr_stack+114498, vrr_stack+12253);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+17149, vrr_stack+195748, vrr_stack+3232, vrr_stack+5527, vrr_stack+116028, vrr_stack+62903);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+252296, vrr_stack+17149, vrr_stack+132520, vrr_stack+195748, vrr_stack+3232, vrr_stack+14293);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+12253, vrr_stack+28100, vrr_stack+23434, vrr_stack+32420, vrr_stack+80697, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+12406, vrr_stack+12253, vrr_stack+195136, NULL, NULL, vrr_stack+23434);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+12865, vrr_stack+12406, vrr_stack+195289, vrr_stack+12253, vrr_stack+195136, vrr_stack+23570);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+13783, vrr_stack+12865, vrr_stack+146005, vrr_stack+12406, vrr_stack+195289, vrr_stack+21186);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+62798, vrr_stack+13783, vrr_stack+5527, vrr_stack+12865, vrr_stack+146005, vrr_stack+37565);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+256580, vrr_stack+62798, vrr_stack+195748, vrr_stack+13783, vrr_stack+5527, vrr_stack+136960);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+135733, vrr_stack+256580, vrr_stack+17149, vrr_stack+62798, vrr_stack+195748, vrr_stack+46043);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+37565, vrr_stack+68895, vrr_stack+121, vrr_stack+132400, vrr_stack+3112, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+37718, vrr_stack+198043, vrr_stack+37565, NULL, NULL, vrr_stack+68895);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+38177, vrr_stack+90098, vrr_stack+37718, vrr_stack+194524, vrr_stack+198043, vrr_stack+69031);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+21186, vrr_stack+90557, vrr_stack+38177, vrr_stack+194677, vrr_stack+90098, vrr_stack+69439);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+43043, vrr_stack+91475, vrr_stack+21186, vrr_stack+182611, vrr_stack+90557, vrr_stack+78732);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+45338, vrr_stack+24114, vrr_stack+43043, vrr_stack+114498, vrr_stack+91475, vrr_stack+48899);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+259793, vrr_stack+132520, vrr_stack+45338, vrr_stack+3232, vrr_stack+24114, vrr_stack+212499);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+264077, vrr_stack+252296, vrr_stack+259793, vrr_stack+17149, vrr_stack+132520, vrr_stack+215355);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+212499, vrr_stack+135733, vrr_stack+252296, vrr_stack+256580, vrr_stack+17149, vrr_stack+204883);
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+269585, vrr_stack+212499, vrr_stack+264077, vrr_stack+135733, vrr_stack+252296, vrr_stack+219163);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+204883, vrr_stack+170683, vrr_stack+28100, vrr_stack+140485, vrr_stack+32420, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+205036, vrr_stack+204883, vrr_stack+12253, NULL, NULL, vrr_stack+28100);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+205495, vrr_stack+205036, vrr_stack+12406, vrr_stack+204883, vrr_stack+12253, vrr_stack+28236);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+206413, vrr_stack+205495, vrr_stack+12865, vrr_stack+205036, vrr_stack+12406, vrr_stack+28644);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+218007, vrr_stack+206413, vrr_stack+13783, vrr_stack+205495, vrr_stack+12865, vrr_stack+29460);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+28236, vrr_stack+218007, vrr_stack+62798, vrr_stack+206413, vrr_stack+13783, vrr_stack+80817);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+77722, vrr_stack+28236, vrr_stack+256580, vrr_stack+218007, vrr_stack+62798, vrr_stack+70695);
   tmp = vrr_stack + 77722;
   target_ptr = Libint->vrr_classes[6][16];
   for(i=0;i<4284;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+218007, vrr_stack+77722, vrr_stack+135733, vrr_stack+28236, vrr_stack+256580, vrr_stack+208691);
   tmp = vrr_stack + 218007;
   target_ptr = Libint->vrr_classes[7][16];
   for(i=0;i<5508;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+205036, vrr_stack+218007, vrr_stack+212499, vrr_stack+77722, vrr_stack+135733, vrr_stack+174043);
   tmp = vrr_stack + 205036;
   target_ptr = Libint->vrr_classes[8][16];
   for(i=0;i<6885;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+77722, Data->F+25, Data->F+26, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+77725, vrr_stack+0, vrr_stack+77722, Data->F+24, Data->F+25, NULL);
 _BUILD_00f0(Data,vrr_stack+77731, vrr_stack+24, vrr_stack+77725, vrr_stack+2644, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+77741, vrr_stack+230179, vrr_stack+77731, vrr_stack+2647, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+3, vrr_stack+230189, vrr_stack+77741, vrr_stack+2653, vrr_stack+230179, NULL);
 _BUILD_00i0(Data,vrr_stack+77756, vrr_stack+230204, vrr_stack+3, vrr_stack+2663, vrr_stack+230189, NULL);
 _BUILD_00k0(Data,vrr_stack+77784, vrr_stack+230225, vrr_stack+77756, vrr_stack+2678, vrr_stack+230204, NULL);
 _BUILD_00l0(Data,vrr_stack+77820, vrr_stack+230253, vrr_stack+77784, vrr_stack+2699, vrr_stack+230225, NULL);
 _BUILD_00m0(Data,vrr_stack+77865, vrr_stack+230289, vrr_stack+77820, vrr_stack+2727, vrr_stack+230253, NULL);
 _BUILD_00n0(Data,vrr_stack+77920, vrr_stack+151930, vrr_stack+77865, vrr_stack+2763, vrr_stack+230289, NULL);
 _BUILD_00o0(Data,vrr_stack+77986, vrr_stack+230334, vrr_stack+77920, vrr_stack+2808, vrr_stack+151930, NULL);
 _BUILD_00q0(Data,vrr_stack+78064, vrr_stack+151985, vrr_stack+77986, vrr_stack+2863, vrr_stack+230334, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78155, vrr_stack+30, vrr_stack+78064, vrr_stack+2929, vrr_stack+151985, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+132400, vrr_stack+102188, vrr_stack+78155, vrr_stack+68804, vrr_stack+30, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+78260, vrr_stack+159013, vrr_stack+132400, vrr_stack+3007, vrr_stack+102188, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+78396, vrr_stack+121, vrr_stack+78260, vrr_stack+3112, vrr_stack+159013, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+78549, vrr_stack+37565, vrr_stack+78396, NULL, NULL, vrr_stack+121);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+79008, vrr_stack+37718, vrr_stack+78549, vrr_stack+198043, vrr_stack+37565, vrr_stack+257);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+79926, vrr_stack+38177, vrr_stack+79008, vrr_stack+90098, vrr_stack+37718, vrr_stack+665);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+257, vrr_stack+21186, vrr_stack+79926, vrr_stack+90557, vrr_stack+38177, vrr_stack+230400);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+28236, vrr_stack+43043, vrr_stack+257, vrr_stack+91475, vrr_stack+21186, vrr_stack+231760);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+69031, vrr_stack+45338, vrr_stack+28236, vrr_stack+24114, vrr_stack+43043, vrr_stack+170819);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+170819, vrr_stack+259793, vrr_stack+69031, vrr_stack+132520, vrr_stack+45338, vrr_stack+183835);
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+276470, vrr_stack+264077, vrr_stack+170819, vrr_stack+252296, vrr_stack+259793, vrr_stack+233800);
 am[0] = 9;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+283355, vrr_stack+269585, vrr_stack+276470, vrr_stack+212499, vrr_stack+264077, vrr_stack+238696);
 am[0] = 9;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+230400, vrr_stack+205036, vrr_stack+269585, vrr_stack+218007, vrr_stack+212499, vrr_stack+224059);
   tmp = vrr_stack + 230400;
   target_ptr = Libint->vrr_classes[9][16];
   for(i=0;i<8415;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218007, vrr_stack+178939, vrr_stack+179245, vrr_stack+193963, vrr_stack+194235, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218178, vrr_stack+179092, vrr_stack+178939, vrr_stack+194099, vrr_stack+193963, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218349, vrr_stack+179245, vrr_stack+194524, vrr_stack+194235, vrr_stack+21050, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218520, vrr_stack+218007, vrr_stack+218349, NULL, NULL, vrr_stack+179245);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+219033, vrr_stack+218178, vrr_stack+218007, NULL, NULL, vrr_stack+178939);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+219546, vrr_stack+219033, vrr_stack+218520, vrr_stack+218178, vrr_stack+218007, vrr_stack+179398);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+179245, vrr_stack+194371, vrr_stack+179092, vrr_stack+20914, vrr_stack+194099, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+220572, vrr_stack+179245, vrr_stack+218178, NULL, NULL, vrr_stack+179092);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+221085, vrr_stack+220572, vrr_stack+219033, vrr_stack+179245, vrr_stack+218178, vrr_stack+179857);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218178, vrr_stack+194524, vrr_stack+198043, vrr_stack+21050, vrr_stack+23978, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+179416, vrr_stack+218349, vrr_stack+218178, NULL, NULL, vrr_stack+194524);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+222111, vrr_stack+218520, vrr_stack+179416, vrr_stack+218007, vrr_stack+218349, vrr_stack+194677);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+176327, vrr_stack+219546, vrr_stack+222111, vrr_stack+219033, vrr_stack+218520, vrr_stack+182611);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+182611, vrr_stack+221085, vrr_stack+219546, vrr_stack+220572, vrr_stack+219033, vrr_stack+180316);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+184321, vrr_stack+182611, vrr_stack+176327, vrr_stack+221085, vrr_stack+219546, vrr_stack+114498);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218007, vrr_stack+195136, vrr_stack+194371, vrr_stack+23434, vrr_stack+20914, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+219033, vrr_stack+218007, vrr_stack+179245, NULL, NULL, vrr_stack+194371);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+114498, vrr_stack+219033, vrr_stack+220572, vrr_stack+218007, vrr_stack+179245, vrr_stack+181234);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+179929, vrr_stack+114498, vrr_stack+221085, vrr_stack+219033, vrr_stack+220572, vrr_stack+181693);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+238815, vrr_stack+179929, vrr_stack+182611, vrr_stack+114498, vrr_stack+221085, vrr_stack+116028);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+220572, vrr_stack+198043, vrr_stack+37565, vrr_stack+23978, vrr_stack+68895, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+220743, vrr_stack+218178, vrr_stack+220572, NULL, NULL, vrr_stack+198043);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+115524, vrr_stack+179416, vrr_stack+220743, vrr_stack+218349, vrr_stack+218178, vrr_stack+90098);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+116550, vrr_stack+222111, vrr_stack+115524, vrr_stack+218520, vrr_stack+179416, vrr_stack+90557);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+241380, vrr_stack+176327, vrr_stack+116550, vrr_stack+219546, vrr_stack+222111, vrr_stack+91475);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+291770, vrr_stack+184321, vrr_stack+241380, vrr_stack+182611, vrr_stack+176327, vrr_stack+24114);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+23570, vrr_stack+238815, vrr_stack+184321, vrr_stack+179929, vrr_stack+182611, vrr_stack+3232);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+295361, vrr_stack+23570, vrr_stack+291770, vrr_stack+238815, vrr_stack+184321, vrr_stack+132520);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+132520, vrr_stack+12253, vrr_stack+195136, vrr_stack+28100, vrr_stack+23434, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+132691, vrr_stack+132520, vrr_stack+218007, NULL, NULL, vrr_stack+195136);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+219546, vrr_stack+132691, vrr_stack+219033, vrr_stack+132520, vrr_stack+218007, vrr_stack+195289);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+133204, vrr_stack+219546, vrr_stack+114498, vrr_stack+132691, vrr_stack+219033, vrr_stack+146005);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+90098, vrr_stack+133204, vrr_stack+179929, vrr_stack+219546, vrr_stack+114498, vrr_stack+5527);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2552, vrr_stack+90098, vrr_stack+238815, vrr_stack+133204, vrr_stack+179929, vrr_stack+195748);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+300149, vrr_stack+2552, vrr_stack+23570, vrr_stack+90098, vrr_stack+238815, vrr_stack+17149);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+218007, vrr_stack+37565, vrr_stack+78396, vrr_stack+68895, vrr_stack+121, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+238815, vrr_stack+220572, vrr_stack+218007, NULL, NULL, vrr_stack+37565);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+114498, vrr_stack+220743, vrr_stack+238815, vrr_stack+218178, vrr_stack+220572, vrr_stack+37718);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+239328, vrr_stack+115524, vrr_stack+114498, vrr_stack+179416, vrr_stack+220743, vrr_stack+38177);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+193963, vrr_stack+116550, vrr_stack+239328, vrr_stack+222111, vrr_stack+115524, vrr_stack+21186);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+178037, vrr_stack+241380, vrr_stack+193963, vrr_stack+176327, vrr_stack+116550, vrr_stack+43043);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+15313, vrr_stack+291770, vrr_stack+178037, vrr_stack+184321, vrr_stack+241380, vrr_stack+45338);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+43043, vrr_stack+295361, vrr_stack+15313, vrr_stack+23570, vrr_stack+291770, vrr_stack+259793);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+181628, vrr_stack+300149, vrr_stack+295361, vrr_stack+2552, vrr_stack+23570, vrr_stack+252296);
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+20101, vrr_stack+181628, vrr_stack+43043, vrr_stack+300149, vrr_stack+295361, vrr_stack+264077);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+252296, vrr_stack+204883, vrr_stack+12253, vrr_stack+170683, vrr_stack+28100, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+252467, vrr_stack+252296, vrr_stack+132520, NULL, NULL, vrr_stack+12253);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+252980, vrr_stack+252467, vrr_stack+132691, vrr_stack+252296, vrr_stack+132520, vrr_stack+12406);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+176327, vrr_stack+252980, vrr_stack+219546, vrr_stack+252467, vrr_stack+132691, vrr_stack+12865);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+254006, vrr_stack+176327, vrr_stack+133204, vrr_stack+252980, vrr_stack+219546, vrr_stack+13783);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+259793, vrr_stack+254006, vrr_stack+90098, vrr_stack+176327, vrr_stack+133204, vrr_stack+62798);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+263384, vrr_stack+259793, vrr_stack+2552, vrr_stack+254006, vrr_stack+90098, vrr_stack+256580);
   tmp = vrr_stack + 263384;
   target_ptr = Libint->vrr_classes[6][17];
   for(i=0;i<4788;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+252296, vrr_stack+263384, vrr_stack+300149, vrr_stack+259793, vrr_stack+2552, vrr_stack+135733);
   tmp = vrr_stack + 252296;
   target_ptr = Libint->vrr_classes[7][17];
   for(i=0;i<6156;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+132520, vrr_stack+252296, vrr_stack+181628, vrr_stack+263384, vrr_stack+300149, vrr_stack+212499);
   tmp = vrr_stack + 132520;
   target_ptr = Libint->vrr_classes[8][17];
   for(i=0;i<7695;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+300149, Data->F+26, Data->F+27, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+300152, vrr_stack+77722, vrr_stack+300149, Data->F+25, Data->F+26, NULL);
 _BUILD_00f0(Data,vrr_stack+300158, vrr_stack+77725, vrr_stack+300152, vrr_stack+0, vrr_stack+77722, NULL);
 _BUILD_00g0(Data,vrr_stack+300168, vrr_stack+77731, vrr_stack+300158, vrr_stack+24, vrr_stack+77725, NULL);
 _BUILD_00h0(Data,vrr_stack+300183, vrr_stack+77741, vrr_stack+300168, vrr_stack+230179, vrr_stack+77731, NULL);
 _BUILD_00i0(Data,vrr_stack+300149, vrr_stack+3, vrr_stack+300183, vrr_stack+230189, vrr_stack+77741, NULL);
 _BUILD_00k0(Data,vrr_stack+300177, vrr_stack+77756, vrr_stack+300149, vrr_stack+230204, vrr_stack+3, NULL);
 _BUILD_00l0(Data,vrr_stack+230179, vrr_stack+77784, vrr_stack+300177, vrr_stack+230225, vrr_stack+77756, NULL);
 _BUILD_00m0(Data,vrr_stack+300149, vrr_stack+77820, vrr_stack+230179, vrr_stack+230253, vrr_stack+77784, NULL);
 _BUILD_00n0(Data,vrr_stack+230179, vrr_stack+77865, vrr_stack+300149, vrr_stack+230289, vrr_stack+77820, NULL);
 _BUILD_00o0(Data,vrr_stack+300149, vrr_stack+77920, vrr_stack+230179, vrr_stack+151930, vrr_stack+77865, NULL);
 _BUILD_00q0(Data,vrr_stack+230179, vrr_stack+77986, vrr_stack+300149, vrr_stack+230334, vrr_stack+77920, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+300149, vrr_stack+78064, vrr_stack+230179, vrr_stack+151985, vrr_stack+77986, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+230179, vrr_stack+78155, vrr_stack+300149, vrr_stack+30, vrr_stack+78064, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+170683, vrr_stack+132400, vrr_stack+230179, vrr_stack+102188, vrr_stack+78155, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+204883, vrr_stack+78260, vrr_stack+170683, vrr_stack+159013, vrr_stack+132400, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+230179, vrr_stack+78396, vrr_stack+204883, vrr_stack+121, vrr_stack+78260, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+300149, vrr_stack+218007, vrr_stack+230179, NULL, NULL, vrr_stack+78396);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+300662, vrr_stack+238815, vrr_stack+300149, vrr_stack+220572, vrr_stack+218007, vrr_stack+78549);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+176327, vrr_stack+114498, vrr_stack+300662, vrr_stack+220743, vrr_stack+238815, vrr_stack+79008);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+300149, vrr_stack+239328, vrr_stack+176327, vrr_stack+115524, vrr_stack+114498, vrr_stack+79926);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+77722, vrr_stack+193963, vrr_stack+300149, vrr_stack+116550, vrr_stack+239328, vrr_stack+257);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+300149, vrr_stack+178037, vrr_stack+77722, vrr_stack+241380, vrr_stack+193963, vrr_stack+28236);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+15313, vrr_stack+300149, vrr_stack+291770, vrr_stack+178037, vrr_stack+69031);
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+258452, vrr_stack+43043, vrr_stack+0, vrr_stack+295361, vrr_stack+15313, vrr_stack+170819);
 am[0] = 9;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+291770, vrr_stack+20101, vrr_stack+258452, vrr_stack+181628, vrr_stack+43043, vrr_stack+276470);
 am[0] = 9;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+258452, vrr_stack+132520, vrr_stack+20101, vrr_stack+252296, vrr_stack+181628, vrr_stack+269585);
   tmp = vrr_stack + 258452;
   target_ptr = Libint->vrr_classes[9][17];
   for(i=0;i<9405;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0n0(Data,vrr_stack+252296, vrr_stack+39413, vrr_stack+65174, vrr_stack+34595, vrr_stack+59828, vrr_stack+9228);
   tmp = vrr_stack + 252296;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0o0(Data,vrr_stack+276470, vrr_stack+97898, vrr_stack+93608, vrr_stack+86588, vrr_stack+83078, vrr_stack+65174);
   tmp = vrr_stack + 276470;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_n0q0(Data,vrr_stack+0, vrr_stack+127395, vrr_stack+122390, vrr_stack+73627, vrr_stack+118295, vrr_stack+93608);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+6006, vrr_stack+164908, vrr_stack+159133, vrr_stack+102293, vrr_stack+147205, vrr_stack+122390);
   tmp = vrr_stack + 6006;
   target_ptr = Libint->vrr_classes[10][13];
   for(i=0;i<6930;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+164908, vrr_stack+152413, vrr_stack+198283, vrr_stack+140605, vrr_stack+188563, vrr_stack+159133);
   tmp = vrr_stack + 164908;
   target_ptr = Libint->vrr_classes[10][14];
   for(i=0;i<7920;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+172828, vrr_stack+107018, vrr_stack+244816, vrr_stack+50939, vrr_stack+224059, vrr_stack+198283);
   tmp = vrr_stack + 172828;
   target_ptr = Libint->vrr_classes[10][15];
   for(i=0;i<8976;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+181804, vrr_stack+230400, vrr_stack+283355, vrr_stack+205036, vrr_stack+269585, vrr_stack+244816);
   tmp = vrr_stack + 181804;
   target_ptr = Libint->vrr_classes[10][16];
   for(i=0;i<10098;i++)
     target_ptr[i] += tmp[i];
 am[0] = 10;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+191902, vrr_stack+258452, vrr_stack+291770, vrr_stack+132520, vrr_stack+20101, vrr_stack+283355);
   tmp = vrr_stack + 191902;
   target_ptr = Libint->vrr_classes[10][17];
   for(i=0;i<11286;i++)
     target_ptr[i] += tmp[i];

}

