/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (np|ii) integrals */

void vrr_order_npii(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p000(Data,vrr_stack+6, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+8, Data->F+9, NULL);
 _BUILD_d000(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_f000(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_p000(Data,vrr_stack+31, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_f000(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p000(Data,vrr_stack+50, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_d000(Data,vrr_stack+53, vrr_stack+6, vrr_stack+50, Data->F+9, Data->F+10, NULL);
 _BUILD_f000(Data,vrr_stack+59, vrr_stack+9, vrr_stack+53, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_g000(Data,vrr_stack+69, vrr_stack+21, vrr_stack+59, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_g000(Data,vrr_stack+84, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_h000(Data,vrr_stack+99, vrr_stack+84, vrr_stack+69, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+120, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+123, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+126, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+129, vrr_stack+120, vrr_stack+126, NULL, NULL, Data->F+9);
 _BUILD_p0p0(Data,vrr_stack+138, vrr_stack+123, vrr_stack+120, NULL, NULL, Data->F+8);
 _BUILD_d0p0(Data,vrr_stack+147, vrr_stack+138, vrr_stack+129, vrr_stack+123, vrr_stack+120, vrr_stack+0);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+165, vrr_stack+0, vrr_stack+123, NULL, NULL, Data->F+7);
 _BUILD_d0p0(Data,vrr_stack+174, vrr_stack+165, vrr_stack+138, vrr_stack+0, vrr_stack+123, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+192, vrr_stack+126, vrr_stack+3, NULL, NULL, Data->F+10);
 _BUILD_d0p0(Data,vrr_stack+201, vrr_stack+129, vrr_stack+192, vrr_stack+120, vrr_stack+126, vrr_stack+6);
 _BUILD_f0p0(Data,vrr_stack+219, vrr_stack+147, vrr_stack+201, vrr_stack+138, vrr_stack+129, vrr_stack+9);
 _BUILD_f0p0(Data,vrr_stack+249, vrr_stack+174, vrr_stack+147, vrr_stack+165, vrr_stack+138, vrr_stack+15);
 _BUILD_g0p0(Data,vrr_stack+279, vrr_stack+249, vrr_stack+219, vrr_stack+174, vrr_stack+147, vrr_stack+21);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+9, vrr_stack+6, vrr_stack+0, NULL, NULL, Data->F+6);
 _BUILD_d0p0(Data,vrr_stack+324, vrr_stack+9, vrr_stack+165, vrr_stack+6, vrr_stack+0, vrr_stack+31);
 _BUILD_f0p0(Data,vrr_stack+342, vrr_stack+324, vrr_stack+174, vrr_stack+9, vrr_stack+165, vrr_stack+34);
 _BUILD_g0p0(Data,vrr_stack+372, vrr_stack+342, vrr_stack+249, vrr_stack+324, vrr_stack+174, vrr_stack+40);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+3, vrr_stack+18, NULL, NULL, Data->F+11);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+192, vrr_stack+21, vrr_stack+126, vrr_stack+3, vrr_stack+50);
 _BUILD_f0p0(Data,vrr_stack+417, vrr_stack+201, vrr_stack+30, vrr_stack+129, vrr_stack+192, vrr_stack+53);
 _BUILD_g0p0(Data,vrr_stack+447, vrr_stack+219, vrr_stack+417, vrr_stack+147, vrr_stack+201, vrr_stack+59);
 _BUILD_h0p0(Data,vrr_stack+492, vrr_stack+279, vrr_stack+447, vrr_stack+249, vrr_stack+219, vrr_stack+69);
 _BUILD_h0p0(Data,vrr_stack+555, vrr_stack+372, vrr_stack+279, vrr_stack+342, vrr_stack+249, vrr_stack+84);
 _BUILD_i0p0(Data,vrr_stack+618, vrr_stack+555, vrr_stack+492, vrr_stack+372, vrr_stack+279, vrr_stack+99);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+120, vrr_stack+126, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+123, vrr_stack+120, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+120);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+123, Data->F+6, Data->F+7, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+123);
 _BUILD_00d0(Data,vrr_stack+102, vrr_stack+126, vrr_stack+3, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+702, vrr_stack+48, vrr_stack+102, NULL, NULL, vrr_stack+126);
 _BUILD_d0d0(Data,vrr_stack+720, vrr_stack+60, vrr_stack+702, vrr_stack+54, vrr_stack+48, vrr_stack+129);
 _BUILD_d0d0(Data,vrr_stack+756, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+138);
 _BUILD_f0d0(Data,vrr_stack+792, vrr_stack+756, vrr_stack+720, vrr_stack+84, vrr_stack+60, vrr_stack+147);
 _BUILD_00d0(Data,vrr_stack+129, vrr_stack+6, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+135, vrr_stack+129, vrr_stack+78, NULL, NULL, vrr_stack+0);
 _BUILD_d0d0(Data,vrr_stack+852, vrr_stack+135, vrr_stack+84, vrr_stack+129, vrr_stack+78, vrr_stack+165);
 _BUILD_f0d0(Data,vrr_stack+888, vrr_stack+852, vrr_stack+756, vrr_stack+135, vrr_stack+84, vrr_stack+174);
 _BUILD_00d0(Data,vrr_stack+153, vrr_stack+3, vrr_stack+18, Data->F+10, Data->F+11, NULL);
 _BUILD_p0d0(Data,vrr_stack+159, vrr_stack+102, vrr_stack+153, NULL, NULL, vrr_stack+3);
 _BUILD_d0d0(Data,vrr_stack+948, vrr_stack+702, vrr_stack+159, vrr_stack+48, vrr_stack+102, vrr_stack+192);
 _BUILD_f0d0(Data,vrr_stack+984, vrr_stack+720, vrr_stack+948, vrr_stack+60, vrr_stack+702, vrr_stack+201);
 _BUILD_g0d0(Data,vrr_stack+1044, vrr_stack+792, vrr_stack+984, vrr_stack+756, vrr_stack+720, vrr_stack+219);
 _BUILD_g0d0(Data,vrr_stack+1134, vrr_stack+888, vrr_stack+792, vrr_stack+852, vrr_stack+756, vrr_stack+249);
 _BUILD_h0d0(Data,vrr_stack+1224, vrr_stack+1134, vrr_stack+1044, vrr_stack+888, vrr_stack+792, vrr_stack+279);
 _BUILD_00p0(Data,vrr_stack+177, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+180, vrr_stack+177, vrr_stack+6, Data->F+4, Data->F+5, NULL);
 _BUILD_p0d0(Data,vrr_stack+186, vrr_stack+180, vrr_stack+129, NULL, NULL, vrr_stack+6);
 _BUILD_d0d0(Data,vrr_stack+204, vrr_stack+186, vrr_stack+135, vrr_stack+180, vrr_stack+129, vrr_stack+9);
 _BUILD_f0d0(Data,vrr_stack+240, vrr_stack+204, vrr_stack+852, vrr_stack+186, vrr_stack+135, vrr_stack+324);
 _BUILD_g0d0(Data,vrr_stack+1350, vrr_stack+240, vrr_stack+888, vrr_stack+204, vrr_stack+852, vrr_stack+342);
 _BUILD_h0d0(Data,vrr_stack+1440, vrr_stack+1350, vrr_stack+1134, vrr_stack+240, vrr_stack+888, vrr_stack+372);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12, vrr_stack+18, vrr_stack+9, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+300, vrr_stack+153, vrr_stack+12, NULL, NULL, vrr_stack+18);
 _BUILD_d0d0(Data,vrr_stack+318, vrr_stack+159, vrr_stack+300, vrr_stack+102, vrr_stack+153, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+354, vrr_stack+948, vrr_stack+318, vrr_stack+702, vrr_stack+159, vrr_stack+30);
 _BUILD_g0d0(Data,vrr_stack+1566, vrr_stack+984, vrr_stack+354, vrr_stack+720, vrr_stack+948, vrr_stack+417);
 _BUILD_h0d0(Data,vrr_stack+1656, vrr_stack+1044, vrr_stack+1566, vrr_stack+792, vrr_stack+984, vrr_stack+447);
 _BUILD_i0d0(Data,vrr_stack+1782, vrr_stack+1224, vrr_stack+1656, vrr_stack+1134, vrr_stack+1044, vrr_stack+492);
 _BUILD_i0d0(Data,vrr_stack+1950, vrr_stack+1440, vrr_stack+1224, vrr_stack+1350, vrr_stack+1134, vrr_stack+555);
 _BUILD_k0d0(Data,vrr_stack+2118, vrr_stack+1950, vrr_stack+1782, vrr_stack+1440, vrr_stack+1224, vrr_stack+618);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+54, vrr_stack+48, vrr_stack+123, vrr_stack+120, NULL);
 _BUILD_00f0(Data,vrr_stack+31, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+123, NULL);
 _BUILD_00f0(Data,vrr_stack+414, vrr_stack+48, vrr_stack+102, vrr_stack+120, vrr_stack+126, NULL);
 _BUILD_p0f0(Data,vrr_stack+424, vrr_stack+21, vrr_stack+414, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+454, vrr_stack+31, vrr_stack+21, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+484, vrr_stack+454, vrr_stack+424, vrr_stack+31, vrr_stack+21, vrr_stack+60);
 _BUILD_00f0(Data,vrr_stack+60, vrr_stack+129, vrr_stack+78, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+544, vrr_stack+60, vrr_stack+31, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+574, vrr_stack+544, vrr_stack+454, vrr_stack+60, vrr_stack+31, vrr_stack+84);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+102, vrr_stack+153, vrr_stack+126, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+634, vrr_stack+414, vrr_stack+84, NULL, NULL, vrr_stack+102);
 _BUILD_d0f0(Data,vrr_stack+2334, vrr_stack+424, vrr_stack+634, vrr_stack+21, vrr_stack+414, vrr_stack+702);
 _BUILD_f0f0(Data,vrr_stack+2394, vrr_stack+484, vrr_stack+2334, vrr_stack+454, vrr_stack+424, vrr_stack+720);
 _BUILD_f0f0(Data,vrr_stack+2494, vrr_stack+574, vrr_stack+484, vrr_stack+544, vrr_stack+454, vrr_stack+756);
 _BUILD_g0f0(Data,vrr_stack+2594, vrr_stack+2494, vrr_stack+2394, vrr_stack+574, vrr_stack+484, vrr_stack+792);
 _BUILD_00f0(Data,vrr_stack+664, vrr_stack+180, vrr_stack+129, vrr_stack+177, vrr_stack+6, NULL);
 _BUILD_p0f0(Data,vrr_stack+674, vrr_stack+664, vrr_stack+60, NULL, NULL, vrr_stack+129);
 _BUILD_d0f0(Data,vrr_stack+704, vrr_stack+674, vrr_stack+544, vrr_stack+664, vrr_stack+60, vrr_stack+135);
 _BUILD_f0f0(Data,vrr_stack+2744, vrr_stack+704, vrr_stack+574, vrr_stack+674, vrr_stack+544, vrr_stack+852);
 _BUILD_g0f0(Data,vrr_stack+2844, vrr_stack+2744, vrr_stack+2494, vrr_stack+704, vrr_stack+574, vrr_stack+888);
 _BUILD_00f0(Data,vrr_stack+135, vrr_stack+153, vrr_stack+12, vrr_stack+3, vrr_stack+18, NULL);
 _BUILD_p0f0(Data,vrr_stack+764, vrr_stack+84, vrr_stack+135, NULL, NULL, vrr_stack+153);
 _BUILD_d0f0(Data,vrr_stack+794, vrr_stack+634, vrr_stack+764, vrr_stack+414, vrr_stack+84, vrr_stack+159);
 _BUILD_f0f0(Data,vrr_stack+2994, vrr_stack+2334, vrr_stack+794, vrr_stack+424, vrr_stack+634, vrr_stack+948);
 _BUILD_g0f0(Data,vrr_stack+3094, vrr_stack+2394, vrr_stack+2994, vrr_stack+484, vrr_stack+2334, vrr_stack+984);
 _BUILD_h0f0(Data,vrr_stack+3244, vrr_stack+2594, vrr_stack+3094, vrr_stack+2494, vrr_stack+2394, vrr_stack+1044);
 _BUILD_h0f0(Data,vrr_stack+854, vrr_stack+2844, vrr_stack+2594, vrr_stack+2744, vrr_stack+2494, vrr_stack+1134);
 _BUILD_i0f0(Data,vrr_stack+3454, vrr_stack+854, vrr_stack+3244, vrr_stack+2844, vrr_stack+2594, vrr_stack+1224);
 _BUILD_00p0(Data,vrr_stack+159, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+162, vrr_stack+159, vrr_stack+177, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+1064, vrr_stack+162, vrr_stack+180, vrr_stack+159, vrr_stack+177, NULL);
 _BUILD_p0f0(Data,vrr_stack+1074, vrr_stack+1064, vrr_stack+664, NULL, NULL, vrr_stack+180);
 _BUILD_d0f0(Data,vrr_stack+1104, vrr_stack+1074, vrr_stack+674, vrr_stack+1064, vrr_stack+664, vrr_stack+186);
 _BUILD_f0f0(Data,vrr_stack+1164, vrr_stack+1104, vrr_stack+704, vrr_stack+1074, vrr_stack+674, vrr_stack+204);
 _BUILD_g0f0(Data,vrr_stack+3734, vrr_stack+1164, vrr_stack+2744, vrr_stack+1104, vrr_stack+704, vrr_stack+240);
 _BUILD_h0f0(Data,vrr_stack+3884, vrr_stack+3734, vrr_stack+2844, vrr_stack+1164, vrr_stack+2744, vrr_stack+1350);
 _BUILD_i0f0(Data,vrr_stack+4094, vrr_stack+3884, vrr_stack+854, vrr_stack+3734, vrr_stack+2844, vrr_stack+1440);
 _BUILD_00p0(Data,vrr_stack+186, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+189, vrr_stack+9, vrr_stack+186, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+195, vrr_stack+12, vrr_stack+189, vrr_stack+18, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+205, vrr_stack+135, vrr_stack+195, NULL, NULL, vrr_stack+12);
 _BUILD_d0f0(Data,vrr_stack+235, vrr_stack+764, vrr_stack+205, vrr_stack+84, vrr_stack+135, vrr_stack+300);
 _BUILD_f0f0(Data,vrr_stack+1264, vrr_stack+794, vrr_stack+235, vrr_stack+634, vrr_stack+764, vrr_stack+318);
 _BUILD_g0f0(Data,vrr_stack+1364, vrr_stack+2994, vrr_stack+1264, vrr_stack+2334, vrr_stack+794, vrr_stack+354);
 _BUILD_h0f0(Data,vrr_stack+4374, vrr_stack+3094, vrr_stack+1364, vrr_stack+2394, vrr_stack+2994, vrr_stack+1566);
 _BUILD_i0f0(Data,vrr_stack+4584, vrr_stack+3244, vrr_stack+4374, vrr_stack+2594, vrr_stack+3094, vrr_stack+1656);
 _BUILD_k0f0(Data,vrr_stack+4864, vrr_stack+3454, vrr_stack+4584, vrr_stack+854, vrr_stack+3244, vrr_stack+1782);
 _BUILD_k0f0(Data,vrr_stack+1514, vrr_stack+4094, vrr_stack+3454, vrr_stack+3884, vrr_stack+854, vrr_stack+1950);
 _BUILD_l0f0(Data,vrr_stack+5224, vrr_stack+1514, vrr_stack+4864, vrr_stack+4094, vrr_stack+3454, vrr_stack+2118);
 _BUILD_00g0(Data,vrr_stack+295, vrr_stack+21, vrr_stack+414, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+310, vrr_stack+31, vrr_stack+21, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+325, vrr_stack+310, vrr_stack+295, NULL, NULL, vrr_stack+21);
 _BUILD_00g0(Data,vrr_stack+370, vrr_stack+60, vrr_stack+31, vrr_stack+129, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+1874, vrr_stack+370, vrr_stack+310, NULL, NULL, vrr_stack+31);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+414, vrr_stack+84, vrr_stack+48, vrr_stack+102, NULL);
 _BUILD_p0g0(Data,vrr_stack+1919, vrr_stack+295, vrr_stack+385, NULL, NULL, vrr_stack+414);
 _BUILD_d0g0(Data,vrr_stack+1964, vrr_stack+325, vrr_stack+1919, vrr_stack+310, vrr_stack+295, vrr_stack+424);
 _BUILD_d0g0(Data,vrr_stack+2054, vrr_stack+1874, vrr_stack+325, vrr_stack+370, vrr_stack+310, vrr_stack+454);
 _BUILD_f0g0(Data,vrr_stack+2144, vrr_stack+2054, vrr_stack+1964, vrr_stack+1874, vrr_stack+325, vrr_stack+484);
 _BUILD_00g0(Data,vrr_stack+424, vrr_stack+664, vrr_stack+60, vrr_stack+180, vrr_stack+129, NULL);
 _BUILD_p0g0(Data,vrr_stack+439, vrr_stack+424, vrr_stack+370, NULL, NULL, vrr_stack+60);
 _BUILD_d0g0(Data,vrr_stack+5674, vrr_stack+439, vrr_stack+1874, vrr_stack+424, vrr_stack+370, vrr_stack+544);
 _BUILD_f0g0(Data,vrr_stack+5764, vrr_stack+5674, vrr_stack+2054, vrr_stack+439, vrr_stack+1874, vrr_stack+574);
 _BUILD_00g0(Data,vrr_stack+484, vrr_stack+84, vrr_stack+135, vrr_stack+102, vrr_stack+153, NULL);
 _BUILD_p0g0(Data,vrr_stack+499, vrr_stack+385, vrr_stack+484, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+544, vrr_stack+1919, vrr_stack+499, vrr_stack+295, vrr_stack+385, vrr_stack+634);
 _BUILD_f0g0(Data,vrr_stack+5914, vrr_stack+1964, vrr_stack+544, vrr_stack+325, vrr_stack+1919, vrr_stack+2334);
 _BUILD_g0g0(Data,vrr_stack+6064, vrr_stack+2144, vrr_stack+5914, vrr_stack+2054, vrr_stack+1964, vrr_stack+2394);
 _BUILD_g0g0(Data,vrr_stack+6289, vrr_stack+5764, vrr_stack+2144, vrr_stack+5674, vrr_stack+2054, vrr_stack+2494);
 _BUILD_h0g0(Data,vrr_stack+6514, vrr_stack+6289, vrr_stack+6064, vrr_stack+5764, vrr_stack+2144, vrr_stack+2594);
 _BUILD_00g0(Data,vrr_stack+634, vrr_stack+1064, vrr_stack+664, vrr_stack+162, vrr_stack+180, NULL);
 _BUILD_p0g0(Data,vrr_stack+2294, vrr_stack+634, vrr_stack+424, NULL, NULL, vrr_stack+664);
 _BUILD_d0g0(Data,vrr_stack+2339, vrr_stack+2294, vrr_stack+439, vrr_stack+634, vrr_stack+424, vrr_stack+674);
 _BUILD_f0g0(Data,vrr_stack+2429, vrr_stack+2339, vrr_stack+5674, vrr_stack+2294, vrr_stack+439, vrr_stack+704);
 _BUILD_g0g0(Data,vrr_stack+6829, vrr_stack+2429, vrr_stack+5764, vrr_stack+2339, vrr_stack+5674, vrr_stack+2744);
 _BUILD_h0g0(Data,vrr_stack+7054, vrr_stack+6829, vrr_stack+6289, vrr_stack+2429, vrr_stack+5764, vrr_stack+2844);
 _BUILD_00g0(Data,vrr_stack+649, vrr_stack+135, vrr_stack+195, vrr_stack+153, vrr_stack+12, NULL);
 _BUILD_p0g0(Data,vrr_stack+674, vrr_stack+484, vrr_stack+649, NULL, NULL, vrr_stack+135);
 _BUILD_d0g0(Data,vrr_stack+2579, vrr_stack+499, vrr_stack+674, vrr_stack+385, vrr_stack+484, vrr_stack+764);
 _BUILD_f0g0(Data,vrr_stack+2669, vrr_stack+544, vrr_stack+2579, vrr_stack+1919, vrr_stack+499, vrr_stack+794);
 _BUILD_g0g0(Data,vrr_stack+7369, vrr_stack+5914, vrr_stack+2669, vrr_stack+1964, vrr_stack+544, vrr_stack+2994);
 _BUILD_h0g0(Data,vrr_stack+7594, vrr_stack+6064, vrr_stack+7369, vrr_stack+2144, vrr_stack+5914, vrr_stack+3094);
 _BUILD_i0g0(Data,vrr_stack+2819, vrr_stack+6514, vrr_stack+7594, vrr_stack+6289, vrr_stack+6064, vrr_stack+3244);
 _BUILD_i0g0(Data,vrr_stack+7909, vrr_stack+7054, vrr_stack+6514, vrr_stack+6829, vrr_stack+6289, vrr_stack+854);
 _BUILD_k0g0(Data,vrr_stack+8329, vrr_stack+7909, vrr_stack+2819, vrr_stack+7054, vrr_stack+6514, vrr_stack+3454);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+719, vrr_stack+18, vrr_stack+159, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+725, vrr_stack+719, vrr_stack+162, vrr_stack+18, vrr_stack+159, NULL);
 _BUILD_00g0(Data,vrr_stack+735, vrr_stack+725, vrr_stack+1064, vrr_stack+719, vrr_stack+162, NULL);
 _BUILD_p0g0(Data,vrr_stack+750, vrr_stack+735, vrr_stack+634, NULL, NULL, vrr_stack+1064);
 _BUILD_d0g0(Data,vrr_stack+795, vrr_stack+750, vrr_stack+2294, vrr_stack+735, vrr_stack+634, vrr_stack+1074);
 _BUILD_f0g0(Data,vrr_stack+885, vrr_stack+795, vrr_stack+2339, vrr_stack+750, vrr_stack+2294, vrr_stack+1104);
 _BUILD_g0g0(Data,vrr_stack+3239, vrr_stack+885, vrr_stack+2429, vrr_stack+795, vrr_stack+2339, vrr_stack+1164);
 _BUILD_h0g0(Data,vrr_stack+8869, vrr_stack+3239, vrr_stack+6829, vrr_stack+885, vrr_stack+2429, vrr_stack+3734);
 _BUILD_i0g0(Data,vrr_stack+3464, vrr_stack+8869, vrr_stack+7054, vrr_stack+3239, vrr_stack+6829, vrr_stack+3884);
 _BUILD_k0g0(Data,vrr_stack+9184, vrr_stack+3464, vrr_stack+7909, vrr_stack+8869, vrr_stack+7054, vrr_stack+4094);
 _BUILD_00p0(Data,vrr_stack+3884, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3887, vrr_stack+186, vrr_stack+3884, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+3893, vrr_stack+189, vrr_stack+3887, vrr_stack+9, vrr_stack+186, NULL);
 _BUILD_00g0(Data,vrr_stack+3903, vrr_stack+195, vrr_stack+3893, vrr_stack+12, vrr_stack+189, NULL);
 _BUILD_p0g0(Data,vrr_stack+3918, vrr_stack+649, vrr_stack+3903, NULL, NULL, vrr_stack+195);
 _BUILD_d0g0(Data,vrr_stack+3963, vrr_stack+674, vrr_stack+3918, vrr_stack+484, vrr_stack+649, vrr_stack+205);
 _BUILD_f0g0(Data,vrr_stack+4053, vrr_stack+2579, vrr_stack+3963, vrr_stack+499, vrr_stack+674, vrr_stack+235);
 _BUILD_g0g0(Data,vrr_stack+9724, vrr_stack+2669, vrr_stack+4053, vrr_stack+544, vrr_stack+2579, vrr_stack+1264);
 _BUILD_h0g0(Data,vrr_stack+9949, vrr_stack+7369, vrr_stack+9724, vrr_stack+5914, vrr_stack+2669, vrr_stack+1364);
 _BUILD_i0g0(Data,vrr_stack+1074, vrr_stack+7594, vrr_stack+9949, vrr_stack+6064, vrr_stack+7369, vrr_stack+4374);
 _BUILD_k0g0(Data,vrr_stack+10264, vrr_stack+2819, vrr_stack+1074, vrr_stack+6514, vrr_stack+7594, vrr_stack+4584);
 _BUILD_l0g0(Data,vrr_stack+10804, vrr_stack+8329, vrr_stack+10264, vrr_stack+7909, vrr_stack+2819, vrr_stack+4864);
 _BUILD_l0g0(Data,vrr_stack+4203, vrr_stack+9184, vrr_stack+8329, vrr_stack+3464, vrr_stack+7909, vrr_stack+1514);
 _BUILD_m0g0(Data,vrr_stack+11479, vrr_stack+4203, vrr_stack+10804, vrr_stack+9184, vrr_stack+8329, vrr_stack+5224);
 _BUILD_00h0(Data,vrr_stack+205, vrr_stack+310, vrr_stack+295, vrr_stack+31, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+226, vrr_stack+370, vrr_stack+310, vrr_stack+60, vrr_stack+31, NULL);
 _BUILD_00h0(Data,vrr_stack+31, vrr_stack+295, vrr_stack+385, vrr_stack+21, vrr_stack+414, NULL);
 _BUILD_p0h0(Data,vrr_stack+4878, vrr_stack+205, vrr_stack+31, NULL, NULL, vrr_stack+295);
 _BUILD_p0h0(Data,vrr_stack+4941, vrr_stack+226, vrr_stack+205, NULL, NULL, vrr_stack+310);
 _BUILD_d0h0(Data,vrr_stack+5004, vrr_stack+4941, vrr_stack+4878, vrr_stack+226, vrr_stack+205, vrr_stack+325);
 _BUILD_00h0(Data,vrr_stack+325, vrr_stack+424, vrr_stack+370, vrr_stack+664, vrr_stack+60, NULL);
 _BUILD_p0h0(Data,vrr_stack+5130, vrr_stack+325, vrr_stack+226, NULL, NULL, vrr_stack+370);
 _BUILD_d0h0(Data,vrr_stack+5193, vrr_stack+5130, vrr_stack+4941, vrr_stack+325, vrr_stack+226, vrr_stack+1874);
 _BUILD_00h0(Data,vrr_stack+346, vrr_stack+385, vrr_stack+484, vrr_stack+414, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+5319, vrr_stack+31, vrr_stack+346, NULL, NULL, vrr_stack+385);
 _BUILD_d0h0(Data,vrr_stack+5382, vrr_stack+4878, vrr_stack+5319, vrr_stack+205, vrr_stack+31, vrr_stack+1919);
 _BUILD_f0h0(Data,vrr_stack+1494, vrr_stack+5004, vrr_stack+5382, vrr_stack+4941, vrr_stack+4878, vrr_stack+1964);
 _BUILD_f0h0(Data,vrr_stack+1704, vrr_stack+5193, vrr_stack+5004, vrr_stack+5130, vrr_stack+4941, vrr_stack+2054);
 _BUILD_g0h0(Data,vrr_stack+12304, vrr_stack+1704, vrr_stack+1494, vrr_stack+5193, vrr_stack+5004, vrr_stack+2144);
 _BUILD_00h0(Data,vrr_stack+52, vrr_stack+634, vrr_stack+424, vrr_stack+1064, vrr_stack+664, NULL);
 _BUILD_p0h0(Data,vrr_stack+5508, vrr_stack+52, vrr_stack+325, NULL, NULL, vrr_stack+424);
 _BUILD_d0h0(Data,vrr_stack+1914, vrr_stack+5508, vrr_stack+5130, vrr_stack+52, vrr_stack+325, vrr_stack+439);
 _BUILD_f0h0(Data,vrr_stack+2040, vrr_stack+1914, vrr_stack+5193, vrr_stack+5508, vrr_stack+5130, vrr_stack+5674);
 _BUILD_g0h0(Data,vrr_stack+12619, vrr_stack+2040, vrr_stack+1704, vrr_stack+1914, vrr_stack+5193, vrr_stack+5764);
 _BUILD_00h0(Data,vrr_stack+439, vrr_stack+484, vrr_stack+649, vrr_stack+84, vrr_stack+135, NULL);
 _BUILD_p0h0(Data,vrr_stack+5571, vrr_stack+346, vrr_stack+439, NULL, NULL, vrr_stack+484);
 _BUILD_d0h0(Data,vrr_stack+5634, vrr_stack+5319, vrr_stack+5571, vrr_stack+31, vrr_stack+346, vrr_stack+499);
 _BUILD_f0h0(Data,vrr_stack+12934, vrr_stack+5382, vrr_stack+5634, vrr_stack+4878, vrr_stack+5319, vrr_stack+544);
 _BUILD_g0h0(Data,vrr_stack+13144, vrr_stack+1494, vrr_stack+12934, vrr_stack+5004, vrr_stack+5382, vrr_stack+5914);
 _BUILD_h0h0(Data,vrr_stack+13459, vrr_stack+12304, vrr_stack+13144, vrr_stack+1704, vrr_stack+1494, vrr_stack+6064);
 _BUILD_h0h0(Data,vrr_stack+5760, vrr_stack+12619, vrr_stack+12304, vrr_stack+2040, vrr_stack+1704, vrr_stack+6289);
 _BUILD_i0h0(Data,vrr_stack+13900, vrr_stack+5760, vrr_stack+13459, vrr_stack+12619, vrr_stack+12304, vrr_stack+6514);
 _BUILD_00h0(Data,vrr_stack+499, vrr_stack+735, vrr_stack+634, vrr_stack+725, vrr_stack+1064, NULL);
 _BUILD_p0h0(Data,vrr_stack+520, vrr_stack+499, vrr_stack+52, NULL, NULL, vrr_stack+634);
 _BUILD_d0h0(Data,vrr_stack+6201, vrr_stack+520, vrr_stack+5508, vrr_stack+499, vrr_stack+52, vrr_stack+2294);
 _BUILD_f0h0(Data,vrr_stack+6327, vrr_stack+6201, vrr_stack+1914, vrr_stack+520, vrr_stack+5508, vrr_stack+2339);
 _BUILD_g0h0(Data,vrr_stack+14488, vrr_stack+6327, vrr_stack+2040, vrr_stack+6201, vrr_stack+1914, vrr_stack+2429);
 _BUILD_h0h0(Data,vrr_stack+14803, vrr_stack+14488, vrr_stack+12619, vrr_stack+6327, vrr_stack+2040, vrr_stack+6829);
 _BUILD_i0h0(Data,vrr_stack+15244, vrr_stack+14803, vrr_stack+5760, vrr_stack+14488, vrr_stack+12619, vrr_stack+7054);
 _BUILD_00h0(Data,vrr_stack+583, vrr_stack+649, vrr_stack+3903, vrr_stack+135, vrr_stack+195, NULL);
 _BUILD_p0h0(Data,vrr_stack+73, vrr_stack+439, vrr_stack+583, NULL, NULL, vrr_stack+649);
 _BUILD_d0h0(Data,vrr_stack+6537, vrr_stack+5571, vrr_stack+73, vrr_stack+346, vrr_stack+439, vrr_stack+674);
 _BUILD_f0h0(Data,vrr_stack+6663, vrr_stack+5634, vrr_stack+6537, vrr_stack+5319, vrr_stack+5571, vrr_stack+2579);
 _BUILD_g0h0(Data,vrr_stack+6873, vrr_stack+12934, vrr_stack+6663, vrr_stack+5382, vrr_stack+5634, vrr_stack+2669);
 _BUILD_h0h0(Data,vrr_stack+2250, vrr_stack+13144, vrr_stack+6873, vrr_stack+1494, vrr_stack+12934, vrr_stack+7369);
 _BUILD_i0h0(Data,vrr_stack+15832, vrr_stack+13459, vrr_stack+2250, vrr_stack+12304, vrr_stack+13144, vrr_stack+7594);
 _BUILD_k0h0(Data,vrr_stack+16420, vrr_stack+13900, vrr_stack+15832, vrr_stack+5760, vrr_stack+13459, vrr_stack+2819);
 _BUILD_k0h0(Data,vrr_stack+17176, vrr_stack+15244, vrr_stack+13900, vrr_stack+14803, vrr_stack+5760, vrr_stack+7909);
 _BUILD_l0h0(Data,vrr_stack+7188, vrr_stack+17176, vrr_stack+16420, vrr_stack+15244, vrr_stack+13900, vrr_stack+8329);
 _BUILD_00p0(Data,vrr_stack+367, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+604, vrr_stack+367, vrr_stack+18, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+604, vrr_stack+719, vrr_stack+367, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+610, vrr_stack+21, vrr_stack+725, vrr_stack+604, vrr_stack+719, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+610, vrr_stack+735, vrr_stack+21, vrr_stack+725, NULL);
 _BUILD_p0h0(Data,vrr_stack+664, vrr_stack+0, vrr_stack+499, NULL, NULL, vrr_stack+735);
 _BUILD_d0h0(Data,vrr_stack+8133, vrr_stack+664, vrr_stack+520, vrr_stack+0, vrr_stack+499, vrr_stack+750);
 _BUILD_f0h0(Data,vrr_stack+8259, vrr_stack+8133, vrr_stack+6201, vrr_stack+664, vrr_stack+520, vrr_stack+795);
 _BUILD_g0h0(Data,vrr_stack+8469, vrr_stack+8259, vrr_stack+6327, vrr_stack+8133, vrr_stack+6201, vrr_stack+885);
 _BUILD_h0h0(Data,vrr_stack+2691, vrr_stack+8469, vrr_stack+14488, vrr_stack+8259, vrr_stack+6327, vrr_stack+3239);
 _BUILD_i0h0(Data,vrr_stack+17932, vrr_stack+2691, vrr_stack+14803, vrr_stack+8469, vrr_stack+14488, vrr_stack+8869);
 _BUILD_k0h0(Data,vrr_stack+18520, vrr_stack+17932, vrr_stack+15244, vrr_stack+2691, vrr_stack+14803, vrr_stack+3464);
 _BUILD_l0h0(Data,vrr_stack+19276, vrr_stack+18520, vrr_stack+17176, vrr_stack+17932, vrr_stack+15244, vrr_stack+9184);
 _BUILD_00p0(Data,vrr_stack+750, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+753, vrr_stack+3884, vrr_stack+750, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+759, vrr_stack+3887, vrr_stack+753, vrr_stack+186, vrr_stack+3884, NULL);
 _BUILD_00g0(Data,vrr_stack+769, vrr_stack+3893, vrr_stack+759, vrr_stack+189, vrr_stack+3887, NULL);
 _BUILD_00h0(Data,vrr_stack+784, vrr_stack+3903, vrr_stack+769, vrr_stack+195, vrr_stack+3893, NULL);
 _BUILD_p0h0(Data,vrr_stack+805, vrr_stack+583, vrr_stack+784, NULL, NULL, vrr_stack+3903);
 _BUILD_d0h0(Data,vrr_stack+868, vrr_stack+73, vrr_stack+805, vrr_stack+439, vrr_stack+583, vrr_stack+3918);
 _BUILD_f0h0(Data,vrr_stack+8784, vrr_stack+6537, vrr_stack+868, vrr_stack+5571, vrr_stack+73, vrr_stack+3963);
 _BUILD_g0h0(Data,vrr_stack+8994, vrr_stack+6663, vrr_stack+8784, vrr_stack+5634, vrr_stack+6537, vrr_stack+4053);
 _BUILD_h0h0(Data,vrr_stack+3132, vrr_stack+6873, vrr_stack+8994, vrr_stack+12934, vrr_stack+6663, vrr_stack+9724);
 _BUILD_i0h0(Data,vrr_stack+9309, vrr_stack+2250, vrr_stack+3132, vrr_stack+13144, vrr_stack+6873, vrr_stack+9949);
 _BUILD_k0h0(Data,vrr_stack+20221, vrr_stack+15832, vrr_stack+9309, vrr_stack+13459, vrr_stack+2250, vrr_stack+1074);
 _BUILD_l0h0(Data,vrr_stack+20977, vrr_stack+16420, vrr_stack+20221, vrr_stack+13900, vrr_stack+15832, vrr_stack+10264);
 _BUILD_m0h0(Data,vrr_stack+21922, vrr_stack+7188, vrr_stack+20977, vrr_stack+17176, vrr_stack+16420, vrr_stack+10804);
 _BUILD_m0h0(Data,vrr_stack+9897, vrr_stack+19276, vrr_stack+7188, vrr_stack+18520, vrr_stack+17176, vrr_stack+4203);
 _BUILD_n0h0(Data,vrr_stack+23077, vrr_stack+9897, vrr_stack+21922, vrr_stack+19276, vrr_stack+7188, vrr_stack+11479);
 _BUILD_00i0(Data,vrr_stack+3918, vrr_stack+205, vrr_stack+31, vrr_stack+310, vrr_stack+295, NULL);
 _BUILD_00i0(Data,vrr_stack+3946, vrr_stack+226, vrr_stack+205, vrr_stack+370, vrr_stack+310, NULL);
 _BUILD_p0i0(Data,vrr_stack+3974, vrr_stack+3946, vrr_stack+3918, NULL, NULL, vrr_stack+205);
 _BUILD_00i0(Data,vrr_stack+4058, vrr_stack+325, vrr_stack+226, vrr_stack+424, vrr_stack+370, NULL);
 _BUILD_p0i0(Data,vrr_stack+4086, vrr_stack+4058, vrr_stack+3946, NULL, NULL, vrr_stack+226);
 _BUILD_00i0(Data,vrr_stack+4170, vrr_stack+31, vrr_stack+346, vrr_stack+295, vrr_stack+385, NULL);
 _BUILD_p0i0(Data,vrr_stack+4198, vrr_stack+3918, vrr_stack+4170, NULL, NULL, vrr_stack+31);
 _BUILD_d0i0(Data,vrr_stack+4282, vrr_stack+3974, vrr_stack+4198, vrr_stack+3946, vrr_stack+3918, vrr_stack+4878);
 _BUILD_d0i0(Data,vrr_stack+4450, vrr_stack+4086, vrr_stack+3974, vrr_stack+4058, vrr_stack+3946, vrr_stack+4941);
 _BUILD_f0i0(Data,vrr_stack+4618, vrr_stack+4450, vrr_stack+4282, vrr_stack+4086, vrr_stack+3974, vrr_stack+5004);
 _BUILD_00i0(Data,vrr_stack+4898, vrr_stack+52, vrr_stack+325, vrr_stack+634, vrr_stack+424, NULL);
 _BUILD_p0i0(Data,vrr_stack+4926, vrr_stack+4898, vrr_stack+4058, NULL, NULL, vrr_stack+325);
 _BUILD_d0i0(Data,vrr_stack+994, vrr_stack+4926, vrr_stack+4086, vrr_stack+4898, vrr_stack+4058, vrr_stack+5130);
 _BUILD_f0i0(Data,vrr_stack+1162, vrr_stack+994, vrr_stack+4450, vrr_stack+4926, vrr_stack+4086, vrr_stack+5193);
 _BUILD_00i0(Data,vrr_stack+5010, vrr_stack+346, vrr_stack+439, vrr_stack+385, vrr_stack+484, NULL);
 _BUILD_p0i0(Data,vrr_stack+5038, vrr_stack+4170, vrr_stack+5010, NULL, NULL, vrr_stack+346);
 _BUILD_d0i0(Data,vrr_stack+5122, vrr_stack+4198, vrr_stack+5038, vrr_stack+3918, vrr_stack+4170, vrr_stack+5319);
 _BUILD_f0i0(Data,vrr_stack+11052, vrr_stack+4282, vrr_stack+5122, vrr_stack+3974, vrr_stack+4198, vrr_stack+5382);
 _BUILD_g0i0(Data,vrr_stack+11332, vrr_stack+4618, vrr_stack+11052, vrr_stack+4450, vrr_stack+4282, vrr_stack+1494);
 _BUILD_g0i0(Data,vrr_stack+11752, vrr_stack+1162, vrr_stack+4618, vrr_stack+994, vrr_stack+4450, vrr_stack+1704);
 _BUILD_h0i0(Data,vrr_stack+24463, vrr_stack+11752, vrr_stack+11332, vrr_stack+1162, vrr_stack+4618, vrr_stack+12304);
 _BUILD_00i0(Data,vrr_stack+370, vrr_stack+499, vrr_stack+52, vrr_stack+735, vrr_stack+634, NULL);
 _BUILD_p0i0(Data,vrr_stack+5290, vrr_stack+370, vrr_stack+4898, NULL, NULL, vrr_stack+52);
 _BUILD_d0i0(Data,vrr_stack+1442, vrr_stack+5290, vrr_stack+4926, vrr_stack+370, vrr_stack+4898, vrr_stack+5508);
 _BUILD_f0i0(Data,vrr_stack+1610, vrr_stack+1442, vrr_stack+994, vrr_stack+5290, vrr_stack+4926, vrr_stack+1914);
 _BUILD_g0i0(Data,vrr_stack+12172, vrr_stack+1610, vrr_stack+1162, vrr_stack+1442, vrr_stack+994, vrr_stack+2040);
 _BUILD_h0i0(Data,vrr_stack+25051, vrr_stack+12172, vrr_stack+11752, vrr_stack+1610, vrr_stack+1162, vrr_stack+12619);
 _BUILD_00i0(Data,vrr_stack+398, vrr_stack+439, vrr_stack+583, vrr_stack+484, vrr_stack+649, NULL);
 _BUILD_p0i0(Data,vrr_stack+5374, vrr_stack+5010, vrr_stack+398, NULL, NULL, vrr_stack+439);
 _BUILD_d0i0(Data,vrr_stack+1890, vrr_stack+5038, vrr_stack+5374, vrr_stack+4170, vrr_stack+5010, vrr_stack+5571);
 _BUILD_f0i0(Data,vrr_stack+12592, vrr_stack+5122, vrr_stack+1890, vrr_stack+4198, vrr_stack+5038, vrr_stack+5634);
 _BUILD_g0i0(Data,vrr_stack+25639, vrr_stack+11052, vrr_stack+12592, vrr_stack+4282, vrr_stack+5122, vrr_stack+12934);
 _BUILD_h0i0(Data,vrr_stack+26059, vrr_stack+11332, vrr_stack+25639, vrr_stack+4618, vrr_stack+11052, vrr_stack+13144);
 _BUILD_i0i0(Data,vrr_stack+26647, vrr_stack+24463, vrr_stack+26059, vrr_stack+11752, vrr_stack+11332, vrr_stack+13459);
 _BUILD_i0i0(Data,vrr_stack+12872, vrr_stack+25051, vrr_stack+24463, vrr_stack+12172, vrr_stack+11752, vrr_stack+5760);
 _BUILD_k0i0(Data,vrr_stack+27431, vrr_stack+12872, vrr_stack+26647, vrr_stack+25051, vrr_stack+24463, vrr_stack+13900);
 _BUILD_00i0(Data,vrr_stack+5458, vrr_stack+0, vrr_stack+499, vrr_stack+610, vrr_stack+735, NULL);
 _BUILD_p0i0(Data,vrr_stack+5486, vrr_stack+5458, vrr_stack+370, NULL, NULL, vrr_stack+499);
 _BUILD_d0i0(Data,vrr_stack+5570, vrr_stack+5486, vrr_stack+5290, vrr_stack+5458, vrr_stack+370, vrr_stack+520);
 _BUILD_f0i0(Data,vrr_stack+5738, vrr_stack+5570, vrr_stack+1442, vrr_stack+5486, vrr_stack+5290, vrr_stack+6201);
 _BUILD_g0i0(Data,vrr_stack+13656, vrr_stack+5738, vrr_stack+1610, vrr_stack+5570, vrr_stack+1442, vrr_stack+6327);
 _BUILD_h0i0(Data,vrr_stack+28439, vrr_stack+13656, vrr_stack+12172, vrr_stack+5738, vrr_stack+1610, vrr_stack+14488);
 _BUILD_i0i0(Data,vrr_stack+29027, vrr_stack+28439, vrr_stack+25051, vrr_stack+13656, vrr_stack+12172, vrr_stack+14803);
 _BUILD_k0i0(Data,vrr_stack+14076, vrr_stack+29027, vrr_stack+12872, vrr_stack+28439, vrr_stack+25051, vrr_stack+15244);
 _BUILD_00i0(Data,vrr_stack+520, vrr_stack+583, vrr_stack+784, vrr_stack+649, vrr_stack+3903, NULL);
 _BUILD_p0i0(Data,vrr_stack+6018, vrr_stack+398, vrr_stack+520, NULL, NULL, vrr_stack+583);
 _BUILD_d0i0(Data,vrr_stack+6102, vrr_stack+5374, vrr_stack+6018, vrr_stack+5010, vrr_stack+398, vrr_stack+73);
 _BUILD_f0i0(Data,vrr_stack+15084, vrr_stack+1890, vrr_stack+6102, vrr_stack+5038, vrr_stack+5374, vrr_stack+6537);
 _BUILD_g0i0(Data,vrr_stack+15364, vrr_stack+12592, vrr_stack+15084, vrr_stack+5122, vrr_stack+1890, vrr_stack+6663);
 _BUILD_h0i0(Data,vrr_stack+6270, vrr_stack+25639, vrr_stack+15364, vrr_stack+11052, vrr_stack+12592, vrr_stack+6873);
 _BUILD_i0i0(Data,vrr_stack+29811, vrr_stack+26059, vrr_stack+6270, vrr_stack+11332, vrr_stack+25639, vrr_stack+2250);
 _BUILD_k0i0(Data,vrr_stack+30595, vrr_stack+26647, vrr_stack+29811, vrr_stack+24463, vrr_stack+26059, vrr_stack+15832);
 _BUILD_l0i0(Data,vrr_stack+31603, vrr_stack+27431, vrr_stack+30595, vrr_stack+12872, vrr_stack+26647, vrr_stack+16420);
 _BUILD_l0i0(Data,vrr_stack+15784, vrr_stack+14076, vrr_stack+27431, vrr_stack+29027, vrr_stack+12872, vrr_stack+17176);
 _BUILD_m0i0(Data,vrr_stack+32863, vrr_stack+15784, vrr_stack+31603, vrr_stack+14076, vrr_stack+27431, vrr_stack+7188);
 _BUILD_00p0(Data,vrr_stack+73, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+76, vrr_stack+73, vrr_stack+367, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+82, vrr_stack+76, vrr_stack+604, vrr_stack+73, vrr_stack+367, NULL);
 _BUILD_00g0(Data,vrr_stack+92, vrr_stack+82, vrr_stack+21, vrr_stack+76, vrr_stack+604, NULL);
 _BUILD_00h0(Data,vrr_stack+107, vrr_stack+92, vrr_stack+610, vrr_stack+82, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+128, vrr_stack+107, vrr_stack+0, vrr_stack+92, vrr_stack+610, NULL);
 _BUILD_p0i0(Data,vrr_stack+6858, vrr_stack+128, vrr_stack+5458, NULL, NULL, vrr_stack+0);
 _BUILD_d0i0(Data,vrr_stack+6942, vrr_stack+6858, vrr_stack+5486, vrr_stack+128, vrr_stack+5458, vrr_stack+664);
 _BUILD_f0i0(Data,vrr_stack+7110, vrr_stack+6942, vrr_stack+5570, vrr_stack+6858, vrr_stack+5486, vrr_stack+8133);
 _BUILD_g0i0(Data,vrr_stack+7390, vrr_stack+7110, vrr_stack+5738, vrr_stack+6942, vrr_stack+5570, vrr_stack+8259);
 _BUILD_h0i0(Data,vrr_stack+7810, vrr_stack+7390, vrr_stack+13656, vrr_stack+7110, vrr_stack+5738, vrr_stack+8469);
 _BUILD_i0i0(Data,vrr_stack+17044, vrr_stack+7810, vrr_stack+28439, vrr_stack+7390, vrr_stack+13656, vrr_stack+2691);
 _BUILD_k0i0(Data,vrr_stack+2058, vrr_stack+17044, vrr_stack+29027, vrr_stack+7810, vrr_stack+28439, vrr_stack+17932);
 _BUILD_l0i0(Data,vrr_stack+6858, vrr_stack+2058, vrr_stack+14076, vrr_stack+17044, vrr_stack+29027, vrr_stack+18520);
 _BUILD_m0i0(Data,vrr_stack+17044, vrr_stack+6858, vrr_stack+15784, vrr_stack+2058, vrr_stack+14076, vrr_stack+19276);
 _BUILD_00p0(Data,vrr_stack+367, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2058, vrr_stack+750, vrr_stack+367, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+753, vrr_stack+2058, vrr_stack+3884, vrr_stack+750, NULL);
 _BUILD_00g0(Data,vrr_stack+2064, vrr_stack+759, vrr_stack+21, vrr_stack+3887, vrr_stack+753, NULL);
 _BUILD_00h0(Data,vrr_stack+2079, vrr_stack+769, vrr_stack+2064, vrr_stack+3893, vrr_stack+759, NULL);
 _BUILD_00i0(Data,vrr_stack+2100, vrr_stack+784, vrr_stack+2079, vrr_stack+3903, vrr_stack+769, NULL);
 _BUILD_p0i0(Data,vrr_stack+2128, vrr_stack+520, vrr_stack+2100, NULL, NULL, vrr_stack+784);
 _BUILD_d0i0(Data,vrr_stack+2212, vrr_stack+6018, vrr_stack+2128, vrr_stack+398, vrr_stack+520, vrr_stack+805);
 _BUILD_f0i0(Data,vrr_stack+2380, vrr_stack+6102, vrr_stack+2212, vrr_stack+5374, vrr_stack+6018, vrr_stack+868);
 _BUILD_g0i0(Data,vrr_stack+2660, vrr_stack+15084, vrr_stack+2380, vrr_stack+1890, vrr_stack+6102, vrr_stack+8784);
 _BUILD_h0i0(Data,vrr_stack+18584, vrr_stack+15364, vrr_stack+2660, vrr_stack+12592, vrr_stack+15084, vrr_stack+8994);
 _BUILD_i0i0(Data,vrr_stack+19172, vrr_stack+6270, vrr_stack+18584, vrr_stack+25639, vrr_stack+15364, vrr_stack+3132);
 _BUILD_k0i0(Data,vrr_stack+8118, vrr_stack+29811, vrr_stack+19172, vrr_stack+26059, vrr_stack+6270, vrr_stack+9309);
 _BUILD_l0i0(Data,vrr_stack+34403, vrr_stack+30595, vrr_stack+8118, vrr_stack+26647, vrr_stack+29811, vrr_stack+20221);
 _BUILD_m0i0(Data,vrr_stack+35663, vrr_stack+31603, vrr_stack+34403, vrr_stack+27431, vrr_stack+30595, vrr_stack+20977);
 _BUILD_n0i0(Data,vrr_stack+19956, vrr_stack+32863, vrr_stack+35663, vrr_stack+15784, vrr_stack+31603, vrr_stack+21922);
 _BUILD_n0i0(Data,vrr_stack+37203, vrr_stack+17044, vrr_stack+32863, vrr_stack+6858, vrr_stack+15784, vrr_stack+9897);
   tmp = vrr_stack + 37203;
   target_ptr = Libint->vrr_classes[10][6];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+6858, vrr_stack+3918, vrr_stack+4170, vrr_stack+205, vrr_stack+31, NULL);
 _BUILD_00k0(Data,vrr_stack+6894, vrr_stack+3946, vrr_stack+3918, vrr_stack+226, vrr_stack+205, NULL);
 _BUILD_p0k0(Data,vrr_stack+6930, vrr_stack+6894, vrr_stack+6858, NULL, NULL, vrr_stack+3918);
 _BUILD_00k0(Data,vrr_stack+7038, vrr_stack+4058, vrr_stack+3946, vrr_stack+325, vrr_stack+226, NULL);
 _BUILD_p0k0(Data,vrr_stack+7074, vrr_stack+7038, vrr_stack+6894, NULL, NULL, vrr_stack+3946);
 _BUILD_00k0(Data,vrr_stack+7182, vrr_stack+4170, vrr_stack+5010, vrr_stack+31, vrr_stack+346, NULL);
 _BUILD_p0k0(Data,vrr_stack+7218, vrr_stack+6858, vrr_stack+7182, NULL, NULL, vrr_stack+4170);
 _BUILD_d0k0(Data,vrr_stack+7326, vrr_stack+6930, vrr_stack+7218, vrr_stack+6894, vrr_stack+6858, vrr_stack+4198);
 _BUILD_d0k0(Data,vrr_stack+7542, vrr_stack+7074, vrr_stack+6930, vrr_stack+7038, vrr_stack+6894, vrr_stack+3974);
 _BUILD_f0k0(Data,vrr_stack+7758, vrr_stack+7542, vrr_stack+7326, vrr_stack+7074, vrr_stack+6930, vrr_stack+4282);
 _BUILD_00k0(Data,vrr_stack+3974, vrr_stack+4898, vrr_stack+4058, vrr_stack+52, vrr_stack+325, NULL);
 _BUILD_p0k0(Data,vrr_stack+4198, vrr_stack+3974, vrr_stack+7038, NULL, NULL, vrr_stack+4058);
 _BUILD_d0k0(Data,vrr_stack+3080, vrr_stack+4198, vrr_stack+7074, vrr_stack+3974, vrr_stack+7038, vrr_stack+4086);
 _BUILD_f0k0(Data,vrr_stack+3296, vrr_stack+3080, vrr_stack+7542, vrr_stack+4198, vrr_stack+7074, vrr_stack+4450);
 _BUILD_00k0(Data,vrr_stack+4086, vrr_stack+5010, vrr_stack+398, vrr_stack+346, vrr_stack+439, NULL);
 _BUILD_p0k0(Data,vrr_stack+4306, vrr_stack+7182, vrr_stack+4086, NULL, NULL, vrr_stack+5010);
 _BUILD_d0k0(Data,vrr_stack+3656, vrr_stack+7218, vrr_stack+4306, vrr_stack+6858, vrr_stack+7182, vrr_stack+5038);
 _BUILD_f0k0(Data,vrr_stack+21804, vrr_stack+7326, vrr_stack+3656, vrr_stack+6930, vrr_stack+7218, vrr_stack+5122);
 _BUILD_g0k0(Data,vrr_stack+22164, vrr_stack+7758, vrr_stack+21804, vrr_stack+7542, vrr_stack+7326, vrr_stack+11052);
 _BUILD_g0k0(Data,vrr_stack+9126, vrr_stack+3296, vrr_stack+7758, vrr_stack+3080, vrr_stack+7542, vrr_stack+4618);
 _BUILD_h0k0(Data,vrr_stack+9666, vrr_stack+9126, vrr_stack+22164, vrr_stack+3296, vrr_stack+7758, vrr_stack+11332);
 _BUILD_00k0(Data,vrr_stack+5038, vrr_stack+370, vrr_stack+4898, vrr_stack+499, vrr_stack+52, NULL);
 _BUILD_p0k0(Data,vrr_stack+5074, vrr_stack+5038, vrr_stack+3974, NULL, NULL, vrr_stack+4898);
 _BUILD_d0k0(Data,vrr_stack+4414, vrr_stack+5074, vrr_stack+4198, vrr_stack+5038, vrr_stack+3974, vrr_stack+4926);
 _BUILD_f0k0(Data,vrr_stack+22704, vrr_stack+4414, vrr_stack+3080, vrr_stack+5074, vrr_stack+4198, vrr_stack+994);
 _BUILD_g0k0(Data,vrr_stack+10422, vrr_stack+22704, vrr_stack+3296, vrr_stack+4414, vrr_stack+3080, vrr_stack+1162);
 _BUILD_h0k0(Data,vrr_stack+10962, vrr_stack+10422, vrr_stack+9126, vrr_stack+22704, vrr_stack+3296, vrr_stack+11752);
 _BUILD_00k0(Data,vrr_stack+4926, vrr_stack+398, vrr_stack+520, vrr_stack+439, vrr_stack+583, NULL);
 _BUILD_p0k0(Data,vrr_stack+5182, vrr_stack+4086, vrr_stack+4926, NULL, NULL, vrr_stack+398);
 _BUILD_d0k0(Data,vrr_stack+4630, vrr_stack+4306, vrr_stack+5182, vrr_stack+7182, vrr_stack+4086, vrr_stack+5374);
 _BUILD_f0k0(Data,vrr_stack+805, vrr_stack+3656, vrr_stack+4630, vrr_stack+7218, vrr_stack+4306, vrr_stack+1890);
 _BUILD_g0k0(Data,vrr_stack+39051, vrr_stack+21804, vrr_stack+805, vrr_stack+7326, vrr_stack+3656, vrr_stack+12592);
 _BUILD_h0k0(Data,vrr_stack+39591, vrr_stack+22164, vrr_stack+39051, vrr_stack+7758, vrr_stack+21804, vrr_stack+25639);
 _BUILD_i0k0(Data,vrr_stack+40347, vrr_stack+9666, vrr_stack+39591, vrr_stack+9126, vrr_stack+22164, vrr_stack+26059);
 _BUILD_i0k0(Data,vrr_stack+25639, vrr_stack+10962, vrr_stack+9666, vrr_stack+10422, vrr_stack+9126, vrr_stack+24463);
 _BUILD_k0k0(Data,vrr_stack+41355, vrr_stack+25639, vrr_stack+40347, vrr_stack+10962, vrr_stack+9666, vrr_stack+26647);
 _BUILD_00k0(Data,vrr_stack+26647, vrr_stack+5458, vrr_stack+370, vrr_stack+0, vrr_stack+499, NULL);
 _BUILD_p0k0(Data,vrr_stack+26683, vrr_stack+26647, vrr_stack+5038, NULL, NULL, vrr_stack+370);
 _BUILD_d0k0(Data,vrr_stack+26791, vrr_stack+26683, vrr_stack+5074, vrr_stack+26647, vrr_stack+5038, vrr_stack+5290);
 _BUILD_f0k0(Data,vrr_stack+27007, vrr_stack+26791, vrr_stack+4414, vrr_stack+26683, vrr_stack+5074, vrr_stack+1442);
 _BUILD_g0k0(Data,vrr_stack+24463, vrr_stack+27007, vrr_stack+22704, vrr_stack+26791, vrr_stack+4414, vrr_stack+1610);
 _BUILD_h0k0(Data,vrr_stack+1165, vrr_stack+24463, vrr_stack+10422, vrr_stack+27007, vrr_stack+22704, vrr_stack+12172);
 _BUILD_i0k0(Data,vrr_stack+11718, vrr_stack+1165, vrr_stack+10962, vrr_stack+24463, vrr_stack+10422, vrr_stack+25051);
 _BUILD_k0k0(Data,vrr_stack+42651, vrr_stack+11718, vrr_stack+25639, vrr_stack+1165, vrr_stack+10962, vrr_stack+12872);
 _BUILD_00k0(Data,vrr_stack+5290, vrr_stack+520, vrr_stack+2100, vrr_stack+583, vrr_stack+784, NULL);
 _BUILD_p0k0(Data,vrr_stack+5326, vrr_stack+4926, vrr_stack+5290, NULL, NULL, vrr_stack+520);
 _BUILD_d0k0(Data,vrr_stack+25003, vrr_stack+5182, vrr_stack+5326, vrr_stack+4086, vrr_stack+4926, vrr_stack+6018);
 _BUILD_f0k0(Data,vrr_stack+25219, vrr_stack+4630, vrr_stack+25003, vrr_stack+4306, vrr_stack+5182, vrr_stack+6102);
 _BUILD_g0k0(Data,vrr_stack+12726, vrr_stack+805, vrr_stack+25219, vrr_stack+3656, vrr_stack+4630, vrr_stack+15084);
 _BUILD_h0k0(Data,vrr_stack+43947, vrr_stack+39051, vrr_stack+12726, vrr_stack+21804, vrr_stack+805, vrr_stack+15364);
 _BUILD_i0k0(Data,vrr_stack+44703, vrr_stack+39591, vrr_stack+43947, vrr_stack+22164, vrr_stack+39051, vrr_stack+6270);
 _BUILD_k0k0(Data,vrr_stack+45711, vrr_stack+40347, vrr_stack+44703, vrr_stack+9666, vrr_stack+39591, vrr_stack+29811);
 _BUILD_l0k0(Data,vrr_stack+47007, vrr_stack+41355, vrr_stack+45711, vrr_stack+25639, vrr_stack+40347, vrr_stack+30595);
 _BUILD_l0k0(Data,vrr_stack+29811, vrr_stack+42651, vrr_stack+41355, vrr_stack+11718, vrr_stack+25639, vrr_stack+27431);
 _BUILD_m0k0(Data,vrr_stack+48627, vrr_stack+29811, vrr_stack+47007, vrr_stack+42651, vrr_stack+41355, vrr_stack+31603);
 _BUILD_00k0(Data,vrr_stack+31431, vrr_stack+128, vrr_stack+5458, vrr_stack+107, vrr_stack+0, NULL);
 _BUILD_p0k0(Data,vrr_stack+31467, vrr_stack+31431, vrr_stack+26647, NULL, NULL, vrr_stack+5458);
 _BUILD_d0k0(Data,vrr_stack+31575, vrr_stack+31467, vrr_stack+26683, vrr_stack+31431, vrr_stack+26647, vrr_stack+5486);
 _BUILD_f0k0(Data,vrr_stack+31791, vrr_stack+31575, vrr_stack+26791, vrr_stack+31467, vrr_stack+26683, vrr_stack+5570);
 _BUILD_g0k0(Data,vrr_stack+32151, vrr_stack+31791, vrr_stack+27007, vrr_stack+31575, vrr_stack+26791, vrr_stack+5738);
 _BUILD_h0k0(Data,vrr_stack+5486, vrr_stack+32151, vrr_stack+24463, vrr_stack+31791, vrr_stack+27007, vrr_stack+13656);
 _BUILD_i0k0(Data,vrr_stack+27367, vrr_stack+5486, vrr_stack+1165, vrr_stack+32151, vrr_stack+24463, vrr_stack+28439);
 _BUILD_k0k0(Data,vrr_stack+31467, vrr_stack+27367, vrr_stack+11718, vrr_stack+5486, vrr_stack+1165, vrr_stack+29027);
 _BUILD_l0k0(Data,vrr_stack+50607, vrr_stack+31467, vrr_stack+42651, vrr_stack+27367, vrr_stack+11718, vrr_stack+14076);
 _BUILD_m0k0(Data,vrr_stack+27367, vrr_stack+50607, vrr_stack+29811, vrr_stack+31467, vrr_stack+42651, vrr_stack+15784);
 _BUILD_00p0(Data,vrr_stack+31467, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+31470, vrr_stack+367, vrr_stack+31467, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+31476, vrr_stack+2058, vrr_stack+31470, vrr_stack+750, vrr_stack+367, NULL);
 _BUILD_00g0(Data,vrr_stack+31486, vrr_stack+21, vrr_stack+31476, vrr_stack+753, vrr_stack+2058, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+2064, vrr_stack+31486, vrr_stack+759, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+31501, vrr_stack+2079, vrr_stack+0, vrr_stack+769, vrr_stack+2064, NULL);
 _BUILD_00k0(Data,vrr_stack+31529, vrr_stack+2100, vrr_stack+31501, vrr_stack+784, vrr_stack+2079, NULL);
 _BUILD_p0k0(Data,vrr_stack+31565, vrr_stack+5290, vrr_stack+31529, NULL, NULL, vrr_stack+2100);
 _BUILD_d0k0(Data,vrr_stack+31673, vrr_stack+5326, vrr_stack+31565, vrr_stack+4926, vrr_stack+5290, vrr_stack+2128);
 _BUILD_f0k0(Data,vrr_stack+31889, vrr_stack+25003, vrr_stack+31673, vrr_stack+5182, vrr_stack+5326, vrr_stack+2212);
 _BUILD_g0k0(Data,vrr_stack+32249, vrr_stack+25219, vrr_stack+31889, vrr_stack+4630, vrr_stack+25003, vrr_stack+2380);
 _BUILD_h0k0(Data,vrr_stack+5486, vrr_stack+12726, vrr_stack+32249, vrr_stack+805, vrr_stack+25219, vrr_stack+2660);
 _BUILD_i0k0(Data,vrr_stack+13266, vrr_stack+43947, vrr_stack+5486, vrr_stack+39051, vrr_stack+12726, vrr_stack+18584);
 _BUILD_k0k0(Data,vrr_stack+14274, vrr_stack+44703, vrr_stack+13266, vrr_stack+39591, vrr_stack+43947, vrr_stack+19172);
 _BUILD_l0k0(Data,vrr_stack+52227, vrr_stack+45711, vrr_stack+14274, vrr_stack+40347, vrr_stack+44703, vrr_stack+8118);
 _BUILD_m0k0(Data,vrr_stack+53847, vrr_stack+47007, vrr_stack+52227, vrr_stack+41355, vrr_stack+45711, vrr_stack+34403);
 _BUILD_n0k0(Data,vrr_stack+55827, vrr_stack+48627, vrr_stack+53847, vrr_stack+29811, vrr_stack+47007, vrr_stack+35663);
 _BUILD_n0k0(Data,vrr_stack+34403, vrr_stack+27367, vrr_stack+48627, vrr_stack+50607, vrr_stack+29811, vrr_stack+32863);
   tmp = vrr_stack + 34403;
   target_ptr = Libint->vrr_classes[10][7];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+50607, vrr_stack+6858, vrr_stack+7182, vrr_stack+3918, vrr_stack+4170, NULL);
 _BUILD_00l0(Data,vrr_stack+50652, vrr_stack+6894, vrr_stack+6858, vrr_stack+3946, vrr_stack+3918, NULL);
 _BUILD_p0l0(Data,vrr_stack+50697, vrr_stack+50652, vrr_stack+50607, NULL, NULL, vrr_stack+6858);
 _BUILD_00l0(Data,vrr_stack+50832, vrr_stack+7038, vrr_stack+6894, vrr_stack+4058, vrr_stack+3946, NULL);
 _BUILD_p0l0(Data,vrr_stack+50877, vrr_stack+50832, vrr_stack+50652, NULL, NULL, vrr_stack+6894);
 _BUILD_00l0(Data,vrr_stack+51012, vrr_stack+7182, vrr_stack+4086, vrr_stack+4170, vrr_stack+5010, NULL);
 _BUILD_p0l0(Data,vrr_stack+51057, vrr_stack+50607, vrr_stack+51012, NULL, NULL, vrr_stack+7182);
 _BUILD_d0l0(Data,vrr_stack+51192, vrr_stack+50697, vrr_stack+51057, vrr_stack+50652, vrr_stack+50607, vrr_stack+7218);
 _BUILD_d0l0(Data,vrr_stack+51462, vrr_stack+50877, vrr_stack+50697, vrr_stack+50832, vrr_stack+50652, vrr_stack+6930);
 _BUILD_f0l0(Data,vrr_stack+51732, vrr_stack+51462, vrr_stack+51192, vrr_stack+50877, vrr_stack+50697, vrr_stack+7326);
 _BUILD_00l0(Data,vrr_stack+52182, vrr_stack+3974, vrr_stack+7038, vrr_stack+4898, vrr_stack+4058, NULL);
 _BUILD_p0l0(Data,vrr_stack+7218, vrr_stack+52182, vrr_stack+50832, NULL, NULL, vrr_stack+7038);
 _BUILD_d0l0(Data,vrr_stack+36779, vrr_stack+7218, vrr_stack+50877, vrr_stack+52182, vrr_stack+50832, vrr_stack+7074);
 _BUILD_f0l0(Data,vrr_stack+8118, vrr_stack+36779, vrr_stack+51462, vrr_stack+7218, vrr_stack+50877, vrr_stack+7542);
 _BUILD_00l0(Data,vrr_stack+7074, vrr_stack+4086, vrr_stack+4926, vrr_stack+5010, vrr_stack+398, NULL);
 _BUILD_p0l0(Data,vrr_stack+7353, vrr_stack+51012, vrr_stack+7074, NULL, NULL, vrr_stack+4086);
 _BUILD_d0l0(Data,vrr_stack+7488, vrr_stack+51057, vrr_stack+7353, vrr_stack+50607, vrr_stack+51012, vrr_stack+4306);
 _BUILD_f0l0(Data,vrr_stack+8568, vrr_stack+51192, vrr_stack+7488, vrr_stack+50697, vrr_stack+51057, vrr_stack+3656);
 _BUILD_g0l0(Data,vrr_stack+18584, vrr_stack+51732, vrr_stack+8568, vrr_stack+51462, vrr_stack+51192, vrr_stack+21804);
 _BUILD_g0l0(Data,vrr_stack+19259, vrr_stack+8118, vrr_stack+51732, vrr_stack+36779, vrr_stack+51462, vrr_stack+7758);
 _BUILD_h0l0(Data,vrr_stack+2128, vrr_stack+19259, vrr_stack+18584, vrr_stack+8118, vrr_stack+51732, vrr_stack+22164);
 _BUILD_00l0(Data,vrr_stack+7758, vrr_stack+5038, vrr_stack+3974, vrr_stack+370, vrr_stack+4898, NULL);
 _BUILD_p0l0(Data,vrr_stack+7803, vrr_stack+7758, vrr_stack+52182, NULL, NULL, vrr_stack+3974);
 _BUILD_d0l0(Data,vrr_stack+21804, vrr_stack+7803, vrr_stack+7218, vrr_stack+7758, vrr_stack+52182, vrr_stack+4198);
 _BUILD_f0l0(Data,vrr_stack+22074, vrr_stack+21804, vrr_stack+36779, vrr_stack+7803, vrr_stack+7218, vrr_stack+3080);
 _BUILD_g0l0(Data,vrr_stack+15570, vrr_stack+22074, vrr_stack+8118, vrr_stack+21804, vrr_stack+36779, vrr_stack+3296);
 _BUILD_h0l0(Data,vrr_stack+58203, vrr_stack+15570, vrr_stack+19259, vrr_stack+22074, vrr_stack+8118, vrr_stack+9126);
 _BUILD_00l0(Data,vrr_stack+7938, vrr_stack+4926, vrr_stack+5290, vrr_stack+398, vrr_stack+520, NULL);
 _BUILD_p0l0(Data,vrr_stack+7983, vrr_stack+7074, vrr_stack+7938, NULL, NULL, vrr_stack+4926);
 _BUILD_d0l0(Data,vrr_stack+9018, vrr_stack+7353, vrr_stack+7983, vrr_stack+51012, vrr_stack+7074, vrr_stack+5182);
 _BUILD_f0l0(Data,vrr_stack+3073, vrr_stack+7488, vrr_stack+9018, vrr_stack+51057, vrr_stack+7353, vrr_stack+4630);
 _BUILD_g0l0(Data,vrr_stack+16245, vrr_stack+8568, vrr_stack+3073, vrr_stack+51192, vrr_stack+7488, vrr_stack+805);
 _BUILD_h0l0(Data,vrr_stack+59148, vrr_stack+18584, vrr_stack+16245, vrr_stack+51732, vrr_stack+8568, vrr_stack+39051);
 _BUILD_i0l0(Data,vrr_stack+60093, vrr_stack+2128, vrr_stack+59148, vrr_stack+19259, vrr_stack+18584, vrr_stack+39591);
 _BUILD_i0l0(Data,vrr_stack+39051, vrr_stack+58203, vrr_stack+2128, vrr_stack+15570, vrr_stack+19259, vrr_stack+9666);
 _BUILD_k0l0(Data,vrr_stack+61353, vrr_stack+39051, vrr_stack+60093, vrr_stack+58203, vrr_stack+2128, vrr_stack+40347);
 _BUILD_00l0(Data,vrr_stack+40311, vrr_stack+26647, vrr_stack+5038, vrr_stack+5458, vrr_stack+370, NULL);
 _BUILD_p0l0(Data,vrr_stack+370, vrr_stack+40311, vrr_stack+7758, NULL, NULL, vrr_stack+5038);
 _BUILD_d0l0(Data,vrr_stack+40356, vrr_stack+370, vrr_stack+7803, vrr_stack+40311, vrr_stack+7758, vrr_stack+5074);
 _BUILD_f0l0(Data,vrr_stack+40626, vrr_stack+40356, vrr_stack+21804, vrr_stack+370, vrr_stack+7803, vrr_stack+4414);
 _BUILD_g0l0(Data,vrr_stack+9288, vrr_stack+40626, vrr_stack+22074, vrr_stack+40356, vrr_stack+21804, vrr_stack+22704);
 _BUILD_h0l0(Data,vrr_stack+62973, vrr_stack+9288, vrr_stack+15570, vrr_stack+40626, vrr_stack+22074, vrr_stack+10422);
 _BUILD_i0l0(Data,vrr_stack+63918, vrr_stack+62973, vrr_stack+58203, vrr_stack+9288, vrr_stack+15570, vrr_stack+10962);
 _BUILD_k0l0(Data,vrr_stack+9963, vrr_stack+63918, vrr_stack+39051, vrr_stack+62973, vrr_stack+58203, vrr_stack+25639);
 _BUILD_00l0(Data,vrr_stack+5074, vrr_stack+5290, vrr_stack+31529, vrr_stack+520, vrr_stack+2100, NULL);
 _BUILD_p0l0(Data,vrr_stack+11583, vrr_stack+7938, vrr_stack+5074, NULL, NULL, vrr_stack+5290);
 _BUILD_d0l0(Data,vrr_stack+505, vrr_stack+7983, vrr_stack+11583, vrr_stack+7074, vrr_stack+7938, vrr_stack+5326);
 _BUILD_f0l0(Data,vrr_stack+22524, vrr_stack+9018, vrr_stack+505, vrr_stack+7353, vrr_stack+7983, vrr_stack+25003);
 _BUILD_g0l0(Data,vrr_stack+25579, vrr_stack+3073, vrr_stack+22524, vrr_stack+7488, vrr_stack+9018, vrr_stack+25219);
 _BUILD_h0l0(Data,vrr_stack+65178, vrr_stack+16245, vrr_stack+25579, vrr_stack+8568, vrr_stack+3073, vrr_stack+12726);
 _BUILD_i0l0(Data,vrr_stack+66123, vrr_stack+59148, vrr_stack+65178, vrr_stack+18584, vrr_stack+16245, vrr_stack+43947);
 _BUILD_k0l0(Data,vrr_stack+67383, vrr_stack+60093, vrr_stack+66123, vrr_stack+2128, vrr_stack+59148, vrr_stack+44703);
 _BUILD_l0l0(Data,vrr_stack+69003, vrr_stack+61353, vrr_stack+67383, vrr_stack+39051, vrr_stack+60093, vrr_stack+45711);
 _BUILD_l0l0(Data,vrr_stack+43947, vrr_stack+9963, vrr_stack+61353, vrr_stack+63918, vrr_stack+39051, vrr_stack+41355);
 _BUILD_m0l0(Data,vrr_stack+71028, vrr_stack+43947, vrr_stack+69003, vrr_stack+9963, vrr_stack+61353, vrr_stack+47007);
 _BUILD_00l0(Data,vrr_stack+45972, vrr_stack+31431, vrr_stack+26647, vrr_stack+128, vrr_stack+5458, NULL);
 _BUILD_p0l0(Data,vrr_stack+46017, vrr_stack+45972, vrr_stack+40311, NULL, NULL, vrr_stack+26647);
 _BUILD_d0l0(Data,vrr_stack+46152, vrr_stack+46017, vrr_stack+370, vrr_stack+45972, vrr_stack+40311, vrr_stack+26683);
 _BUILD_f0l0(Data,vrr_stack+46422, vrr_stack+46152, vrr_stack+40356, vrr_stack+46017, vrr_stack+370, vrr_stack+26791);
 _BUILD_g0l0(Data,vrr_stack+46872, vrr_stack+46422, vrr_stack+40626, vrr_stack+46152, vrr_stack+40356, vrr_stack+27007);
 _BUILD_h0l0(Data,vrr_stack+47547, vrr_stack+46872, vrr_stack+9288, vrr_stack+46422, vrr_stack+40626, vrr_stack+24463);
 _BUILD_i0l0(Data,vrr_stack+41076, vrr_stack+47547, vrr_stack+62973, vrr_stack+46872, vrr_stack+9288, vrr_stack+1165);
 _BUILD_k0l0(Data,vrr_stack+73503, vrr_stack+41076, vrr_stack+63918, vrr_stack+47547, vrr_stack+62973, vrr_stack+11718);
 _BUILD_l0l0(Data,vrr_stack+46017, vrr_stack+73503, vrr_stack+9963, vrr_stack+41076, vrr_stack+63918, vrr_stack+42651);
 _BUILD_m0l0(Data,vrr_stack+41076, vrr_stack+46017, vrr_stack+43947, vrr_stack+73503, vrr_stack+9963, vrr_stack+29811);
 _BUILD_00p0(Data,vrr_stack+73503, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+73506, vrr_stack+31467, vrr_stack+73503, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+73512, vrr_stack+31470, vrr_stack+73506, vrr_stack+367, vrr_stack+31467, NULL);
 _BUILD_00g0(Data,vrr_stack+73522, vrr_stack+31476, vrr_stack+73512, vrr_stack+2058, vrr_stack+31470, NULL);
 _BUILD_00h0(Data,vrr_stack+73537, vrr_stack+31486, vrr_stack+73522, vrr_stack+21, vrr_stack+31476, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+0, vrr_stack+73537, vrr_stack+2064, vrr_stack+31486, NULL);
 _BUILD_00k0(Data,vrr_stack+49, vrr_stack+31501, vrr_stack+21, vrr_stack+2079, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+85, vrr_stack+31529, vrr_stack+49, vrr_stack+2100, vrr_stack+31501, NULL);
 _BUILD_p0l0(Data,vrr_stack+130, vrr_stack+5074, vrr_stack+85, NULL, NULL, vrr_stack+31529);
 _BUILD_d0l0(Data,vrr_stack+73558, vrr_stack+11583, vrr_stack+130, vrr_stack+7938, vrr_stack+5074, vrr_stack+31565);
 _BUILD_f0l0(Data,vrr_stack+73828, vrr_stack+505, vrr_stack+73558, vrr_stack+7983, vrr_stack+11583, vrr_stack+31673);
 _BUILD_g0l0(Data,vrr_stack+74278, vrr_stack+22524, vrr_stack+73828, vrr_stack+9018, vrr_stack+505, vrr_stack+31889);
 _BUILD_h0l0(Data,vrr_stack+74953, vrr_stack+25579, vrr_stack+74278, vrr_stack+3073, vrr_stack+22524, vrr_stack+32249);
 _BUILD_i0l0(Data,vrr_stack+31565, vrr_stack+65178, vrr_stack+74953, vrr_stack+16245, vrr_stack+25579, vrr_stack+5486);
 _BUILD_k0l0(Data,vrr_stack+29347, vrr_stack+66123, vrr_stack+31565, vrr_stack+59148, vrr_stack+65178, vrr_stack+13266);
 _BUILD_l0l0(Data,vrr_stack+11718, vrr_stack+67383, vrr_stack+29347, vrr_stack+60093, vrr_stack+66123, vrr_stack+14274);
 _BUILD_m0l0(Data,vrr_stack+75898, vrr_stack+69003, vrr_stack+11718, vrr_stack+61353, vrr_stack+67383, vrr_stack+52227);
 _BUILD_n0l0(Data,vrr_stack+78373, vrr_stack+71028, vrr_stack+75898, vrr_stack+43947, vrr_stack+69003, vrr_stack+53847);
 _BUILD_n0l0(Data,vrr_stack+52227, vrr_stack+41076, vrr_stack+71028, vrr_stack+46017, vrr_stack+43947, vrr_stack+48627);
   tmp = vrr_stack + 52227;
   target_ptr = Libint->vrr_classes[10][8];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+46017, vrr_stack+50607, vrr_stack+51012, vrr_stack+6858, vrr_stack+7182, NULL);
 _BUILD_00m0(Data,vrr_stack+46072, vrr_stack+50652, vrr_stack+50607, vrr_stack+6894, vrr_stack+6858, NULL);
 _BUILD_p0m0(Data,vrr_stack+46127, vrr_stack+46072, vrr_stack+46017, NULL, NULL, vrr_stack+50607);
 _BUILD_00m0(Data,vrr_stack+46292, vrr_stack+50832, vrr_stack+50652, vrr_stack+7038, vrr_stack+6894, NULL);
 _BUILD_p0m0(Data,vrr_stack+46347, vrr_stack+46292, vrr_stack+46072, NULL, NULL, vrr_stack+50652);
 _BUILD_00m0(Data,vrr_stack+46512, vrr_stack+51012, vrr_stack+7074, vrr_stack+7182, vrr_stack+4086, NULL);
 _BUILD_p0m0(Data,vrr_stack+46567, vrr_stack+46017, vrr_stack+46512, NULL, NULL, vrr_stack+51012);
 _BUILD_d0m0(Data,vrr_stack+46732, vrr_stack+46127, vrr_stack+46567, vrr_stack+46072, vrr_stack+46017, vrr_stack+51057);
 _BUILD_d0m0(Data,vrr_stack+47062, vrr_stack+46347, vrr_stack+46127, vrr_stack+46292, vrr_stack+46072, vrr_stack+50697);
 _BUILD_f0m0(Data,vrr_stack+47392, vrr_stack+47062, vrr_stack+46732, vrr_stack+46347, vrr_stack+46127, vrr_stack+51192);
 _BUILD_00m0(Data,vrr_stack+50697, vrr_stack+52182, vrr_stack+50832, vrr_stack+3974, vrr_stack+7038, NULL);
 _BUILD_p0m0(Data,vrr_stack+51057, vrr_stack+50697, vrr_stack+46292, NULL, NULL, vrr_stack+50832);
 _BUILD_d0m0(Data,vrr_stack+47942, vrr_stack+51057, vrr_stack+46347, vrr_stack+50697, vrr_stack+46292, vrr_stack+50877);
 _BUILD_f0m0(Data,vrr_stack+55197, vrr_stack+47942, vrr_stack+47062, vrr_stack+51057, vrr_stack+46347, vrr_stack+51462);
 _BUILD_00m0(Data,vrr_stack+50877, vrr_stack+7074, vrr_stack+7938, vrr_stack+4086, vrr_stack+4926, NULL);
 _BUILD_p0m0(Data,vrr_stack+51222, vrr_stack+46512, vrr_stack+50877, NULL, NULL, vrr_stack+7074);
 _BUILD_d0m0(Data,vrr_stack+51387, vrr_stack+46567, vrr_stack+51222, vrr_stack+46017, vrr_stack+46512, vrr_stack+7353);
 _BUILD_f0m0(Data,vrr_stack+81343, vrr_stack+46732, vrr_stack+51387, vrr_stack+46127, vrr_stack+46567, vrr_stack+7488);
 _BUILD_g0m0(Data,vrr_stack+13743, vrr_stack+47392, vrr_stack+81343, vrr_stack+47062, vrr_stack+46732, vrr_stack+8568);
 _BUILD_g0m0(Data,vrr_stack+14568, vrr_stack+55197, vrr_stack+47392, vrr_stack+47942, vrr_stack+47062, vrr_stack+51732);
 _BUILD_h0m0(Data,vrr_stack+5326, vrr_stack+14568, vrr_stack+13743, vrr_stack+55197, vrr_stack+47392, vrr_stack+18584);
 _BUILD_00m0(Data,vrr_stack+18584, vrr_stack+7758, vrr_stack+52182, vrr_stack+5038, vrr_stack+3974, NULL);
 _BUILD_p0m0(Data,vrr_stack+18639, vrr_stack+18584, vrr_stack+50697, NULL, NULL, vrr_stack+52182);
 _BUILD_d0m0(Data,vrr_stack+18804, vrr_stack+18639, vrr_stack+51057, vrr_stack+18584, vrr_stack+50697, vrr_stack+7218);
 _BUILD_f0m0(Data,vrr_stack+24463, vrr_stack+18804, vrr_stack+47942, vrr_stack+18639, vrr_stack+51057, vrr_stack+36779);
 _BUILD_g0m0(Data,vrr_stack+775, vrr_stack+24463, vrr_stack+55197, vrr_stack+18804, vrr_stack+47942, vrr_stack+8118);
 _BUILD_h0m0(Data,vrr_stack+3523, vrr_stack+775, vrr_stack+14568, vrr_stack+24463, vrr_stack+55197, vrr_stack+19259);
 _BUILD_00m0(Data,vrr_stack+8118, vrr_stack+7938, vrr_stack+5074, vrr_stack+4926, vrr_stack+5290, NULL);
 _BUILD_p0m0(Data,vrr_stack+8173, vrr_stack+50877, vrr_stack+8118, NULL, NULL, vrr_stack+7938);
 _BUILD_d0m0(Data,vrr_stack+8338, vrr_stack+51222, vrr_stack+8173, vrr_stack+46512, vrr_stack+50877, vrr_stack+7983);
 _BUILD_f0m0(Data,vrr_stack+19134, vrr_stack+51387, vrr_stack+8338, vrr_stack+46567, vrr_stack+51222, vrr_stack+9018);
 _BUILD_g0m0(Data,vrr_stack+81893, vrr_stack+81343, vrr_stack+19134, vrr_stack+46732, vrr_stack+51387, vrr_stack+3073);
 _BUILD_h0m0(Data,vrr_stack+82718, vrr_stack+13743, vrr_stack+81893, vrr_stack+47392, vrr_stack+81343, vrr_stack+16245);
 _BUILD_i0m0(Data,vrr_stack+83873, vrr_stack+5326, vrr_stack+82718, vrr_stack+14568, vrr_stack+13743, vrr_stack+59148);
 _BUILD_i0m0(Data,vrr_stack+85413, vrr_stack+3523, vrr_stack+5326, vrr_stack+775, vrr_stack+14568, vrr_stack+2128);
 _BUILD_k0m0(Data,vrr_stack+86953, vrr_stack+85413, vrr_stack+83873, vrr_stack+3523, vrr_stack+5326, vrr_stack+60093);
 _BUILD_00m0(Data,vrr_stack+59148, vrr_stack+40311, vrr_stack+7758, vrr_stack+26647, vrr_stack+5038, NULL);
 _BUILD_p0m0(Data,vrr_stack+59203, vrr_stack+59148, vrr_stack+18584, NULL, NULL, vrr_stack+7758);
 _BUILD_d0m0(Data,vrr_stack+59368, vrr_stack+59203, vrr_stack+18639, vrr_stack+59148, vrr_stack+18584, vrr_stack+7803);
 _BUILD_f0m0(Data,vrr_stack+59698, vrr_stack+59368, vrr_stack+18804, vrr_stack+59203, vrr_stack+18639, vrr_stack+21804);
 _BUILD_g0m0(Data,vrr_stack+60248, vrr_stack+59698, vrr_stack+24463, vrr_stack+59368, vrr_stack+18804, vrr_stack+22074);
 _BUILD_h0m0(Data,vrr_stack+1600, vrr_stack+60248, vrr_stack+775, vrr_stack+59698, vrr_stack+24463, vrr_stack+15570);
 _BUILD_i0m0(Data,vrr_stack+15393, vrr_stack+1600, vrr_stack+3523, vrr_stack+60248, vrr_stack+775, vrr_stack+58203);
 _BUILD_k0m0(Data,vrr_stack+88933, vrr_stack+15393, vrr_stack+85413, vrr_stack+1600, vrr_stack+3523, vrr_stack+39051);
 _BUILD_00m0(Data,vrr_stack+39051, vrr_stack+5074, vrr_stack+85, vrr_stack+5290, vrr_stack+31529, NULL);
 _BUILD_p0m0(Data,vrr_stack+39106, vrr_stack+8118, vrr_stack+39051, NULL, NULL, vrr_stack+5074);
 _BUILD_d0m0(Data,vrr_stack+39271, vrr_stack+8173, vrr_stack+39106, vrr_stack+50877, vrr_stack+8118, vrr_stack+11583);
 _BUILD_f0m0(Data,vrr_stack+39601, vrr_stack+8338, vrr_stack+39271, vrr_stack+51222, vrr_stack+8173, vrr_stack+505);
 _BUILD_g0m0(Data,vrr_stack+58203, vrr_stack+19134, vrr_stack+39601, vrr_stack+51387, vrr_stack+8338, vrr_stack+22524);
 _BUILD_h0m0(Data,vrr_stack+21804, vrr_stack+81893, vrr_stack+58203, vrr_stack+81343, vrr_stack+19134, vrr_stack+25579);
 _BUILD_i0m0(Data,vrr_stack+25013, vrr_stack+82718, vrr_stack+21804, vrr_stack+13743, vrr_stack+81893, vrr_stack+65178);
 _BUILD_k0m0(Data,vrr_stack+90913, vrr_stack+83873, vrr_stack+25013, vrr_stack+5326, vrr_stack+82718, vrr_stack+66123);
 _BUILD_l0m0(Data,vrr_stack+92893, vrr_stack+86953, vrr_stack+90913, vrr_stack+85413, vrr_stack+83873, vrr_stack+67383);
 _BUILD_l0m0(Data,vrr_stack+65178, vrr_stack+88933, vrr_stack+86953, vrr_stack+15393, vrr_stack+85413, vrr_stack+61353);
 _BUILD_m0m0(Data,vrr_stack+95368, vrr_stack+65178, vrr_stack+92893, vrr_stack+88933, vrr_stack+86953, vrr_stack+69003);
 _BUILD_00m0(Data,vrr_stack+67653, vrr_stack+45972, vrr_stack+40311, vrr_stack+31431, vrr_stack+26647, NULL);
 _BUILD_p0m0(Data,vrr_stack+67708, vrr_stack+67653, vrr_stack+59148, NULL, NULL, vrr_stack+40311);
 _BUILD_d0m0(Data,vrr_stack+67873, vrr_stack+67708, vrr_stack+59203, vrr_stack+67653, vrr_stack+59148, vrr_stack+370);
 _BUILD_f0m0(Data,vrr_stack+68203, vrr_stack+67873, vrr_stack+59368, vrr_stack+67708, vrr_stack+59203, vrr_stack+40356);
 _BUILD_g0m0(Data,vrr_stack+68753, vrr_stack+68203, vrr_stack+59698, vrr_stack+67873, vrr_stack+59368, vrr_stack+40626);
 _BUILD_h0m0(Data,vrr_stack+69578, vrr_stack+68753, vrr_stack+60248, vrr_stack+68203, vrr_stack+59698, vrr_stack+9288);
 _BUILD_i0m0(Data,vrr_stack+61073, vrr_stack+69578, vrr_stack+1600, vrr_stack+68753, vrr_stack+60248, vrr_stack+62973);
 _BUILD_k0m0(Data,vrr_stack+98393, vrr_stack+61073, vrr_stack+15393, vrr_stack+69578, vrr_stack+1600, vrr_stack+63918);
 _BUILD_l0m0(Data,vrr_stack+67708, vrr_stack+98393, vrr_stack+88933, vrr_stack+61073, vrr_stack+15393, vrr_stack+9963);
 _BUILD_m0m0(Data,vrr_stack+61073, vrr_stack+67708, vrr_stack+65178, vrr_stack+98393, vrr_stack+88933, vrr_stack+43947);
 _BUILD_00p0(Data,vrr_stack+98393, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+98396, vrr_stack+73503, vrr_stack+98393, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+98402, vrr_stack+73506, vrr_stack+98396, vrr_stack+31467, vrr_stack+73503, NULL);
 _BUILD_00g0(Data,vrr_stack+98412, vrr_stack+73512, vrr_stack+98402, vrr_stack+31470, vrr_stack+73506, NULL);
 _BUILD_00h0(Data,vrr_stack+98427, vrr_stack+73522, vrr_stack+98412, vrr_stack+31476, vrr_stack+73512, NULL);
 _BUILD_00i0(Data,vrr_stack+98448, vrr_stack+73537, vrr_stack+98427, vrr_stack+31486, vrr_stack+73522, NULL);
 _BUILD_00k0(Data,vrr_stack+98476, vrr_stack+21, vrr_stack+98448, vrr_stack+0, vrr_stack+73537, NULL);
 _BUILD_00l0(Data,vrr_stack+98512, vrr_stack+49, vrr_stack+98476, vrr_stack+31501, vrr_stack+21, NULL);
 _BUILD_00m0(Data,vrr_stack+98557, vrr_stack+85, vrr_stack+98512, vrr_stack+31529, vrr_stack+49, NULL);
 _BUILD_p0m0(Data,vrr_stack+98612, vrr_stack+39051, vrr_stack+98557, NULL, NULL, vrr_stack+85);
 _BUILD_d0m0(Data,vrr_stack+98777, vrr_stack+39106, vrr_stack+98612, vrr_stack+8118, vrr_stack+39051, vrr_stack+130);
 _BUILD_f0m0(Data,vrr_stack+130, vrr_stack+39271, vrr_stack+98777, vrr_stack+8173, vrr_stack+39106, vrr_stack+73558);
 _BUILD_g0m0(Data,vrr_stack+99107, vrr_stack+39601, vrr_stack+130, vrr_stack+8338, vrr_stack+39271, vrr_stack+73828);
 _BUILD_h0m0(Data,vrr_stack+8668, vrr_stack+58203, vrr_stack+99107, vrr_stack+19134, vrr_stack+39601, vrr_stack+74278);
 _BUILD_i0m0(Data,vrr_stack+9823, vrr_stack+21804, vrr_stack+8668, vrr_stack+81893, vrr_stack+58203, vrr_stack+74953);
 _BUILD_k0m0(Data,vrr_stack+73558, vrr_stack+25013, vrr_stack+9823, vrr_stack+82718, vrr_stack+21804, vrr_stack+31565);
 _BUILD_l0m0(Data,vrr_stack+99932, vrr_stack+90913, vrr_stack+73558, vrr_stack+83873, vrr_stack+25013, vrr_stack+29347);
 _BUILD_m0m0(Data,vrr_stack+29347, vrr_stack+92893, vrr_stack+99932, vrr_stack+86953, vrr_stack+90913, vrr_stack+11718);
 _BUILD_n0m0(Data,vrr_stack+102407, vrr_stack+95368, vrr_stack+29347, vrr_stack+65178, vrr_stack+92893, vrr_stack+75898);
 _BUILD_n0m0(Data,vrr_stack+106037, vrr_stack+61073, vrr_stack+95368, vrr_stack+67708, vrr_stack+65178, vrr_stack+71028);
   tmp = vrr_stack + 106037;
   target_ptr = Libint->vrr_classes[10][9];
   for(i=0;i<3630;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+67708, vrr_stack+46017, vrr_stack+46512, vrr_stack+50607, vrr_stack+51012, NULL);
 _BUILD_00n0(Data,vrr_stack+67774, vrr_stack+46072, vrr_stack+46017, vrr_stack+50652, vrr_stack+50607, NULL);
 _BUILD_p0n0(Data,vrr_stack+67840, vrr_stack+67774, vrr_stack+67708, NULL, NULL, vrr_stack+46017);
 _BUILD_00n0(Data,vrr_stack+68038, vrr_stack+46292, vrr_stack+46072, vrr_stack+50832, vrr_stack+50652, NULL);
 _BUILD_p0n0(Data,vrr_stack+68104, vrr_stack+68038, vrr_stack+67774, NULL, NULL, vrr_stack+46072);
 _BUILD_00n0(Data,vrr_stack+50607, vrr_stack+46512, vrr_stack+50877, vrr_stack+51012, vrr_stack+7074, NULL);
 _BUILD_p0n0(Data,vrr_stack+68302, vrr_stack+67708, vrr_stack+50607, NULL, NULL, vrr_stack+46512);
 _BUILD_d0n0(Data,vrr_stack+4678, vrr_stack+67840, vrr_stack+68302, vrr_stack+67774, vrr_stack+67708, vrr_stack+46567);
 _BUILD_d0n0(Data,vrr_stack+68500, vrr_stack+68104, vrr_stack+67840, vrr_stack+68038, vrr_stack+67774, vrr_stack+46127);
 _BUILD_f0n0(Data,vrr_stack+68896, vrr_stack+68500, vrr_stack+4678, vrr_stack+68104, vrr_stack+67840, vrr_stack+46732);
 _BUILD_00n0(Data,vrr_stack+46127, vrr_stack+50697, vrr_stack+46292, vrr_stack+52182, vrr_stack+50832, NULL);
 _BUILD_p0n0(Data,vrr_stack+46567, vrr_stack+46127, vrr_stack+68038, NULL, NULL, vrr_stack+46292);
 _BUILD_d0n0(Data,vrr_stack+69556, vrr_stack+46567, vrr_stack+68104, vrr_stack+46127, vrr_stack+68038, vrr_stack+46347);
 _BUILD_f0n0(Data,vrr_stack+69952, vrr_stack+69556, vrr_stack+68500, vrr_stack+46567, vrr_stack+68104, vrr_stack+47062);
 _BUILD_00n0(Data,vrr_stack+46347, vrr_stack+50877, vrr_stack+8118, vrr_stack+7074, vrr_stack+7938, NULL);
 _BUILD_p0n0(Data,vrr_stack+46765, vrr_stack+50607, vrr_stack+46347, NULL, NULL, vrr_stack+50877);
 _BUILD_d0n0(Data,vrr_stack+46963, vrr_stack+68302, vrr_stack+46765, vrr_stack+67708, vrr_stack+50607, vrr_stack+51222);
 _BUILD_f0n0(Data,vrr_stack+75538, vrr_stack+4678, vrr_stack+46963, vrr_stack+67840, vrr_stack+68302, vrr_stack+51387);
 _BUILD_g0n0(Data,vrr_stack+76198, vrr_stack+68896, vrr_stack+75538, vrr_stack+68500, vrr_stack+4678, vrr_stack+81343);
 _BUILD_g0n0(Data,vrr_stack+77188, vrr_stack+69952, vrr_stack+68896, vrr_stack+69556, vrr_stack+68500, vrr_stack+47392);
 _BUILD_h0n0(Data,vrr_stack+11363, vrr_stack+77188, vrr_stack+76198, vrr_stack+69952, vrr_stack+68896, vrr_stack+13743);
 _BUILD_00n0(Data,vrr_stack+81343, vrr_stack+18584, vrr_stack+50697, vrr_stack+7758, vrr_stack+52182, NULL);
 _BUILD_p0n0(Data,vrr_stack+81409, vrr_stack+81343, vrr_stack+46127, NULL, NULL, vrr_stack+50697);
 _BUILD_d0n0(Data,vrr_stack+51222, vrr_stack+81409, vrr_stack+46567, vrr_stack+81343, vrr_stack+46127, vrr_stack+51057);
 _BUILD_f0n0(Data,vrr_stack+64098, vrr_stack+51222, vrr_stack+69556, vrr_stack+81409, vrr_stack+46567, vrr_stack+47942);
 _BUILD_g0n0(Data,vrr_stack+47359, vrr_stack+64098, vrr_stack+69952, vrr_stack+51222, vrr_stack+69556, vrr_stack+55197);
 _BUILD_h0n0(Data,vrr_stack+12749, vrr_stack+47359, vrr_stack+77188, vrr_stack+64098, vrr_stack+69952, vrr_stack+14568);
 _BUILD_00n0(Data,vrr_stack+55197, vrr_stack+8118, vrr_stack+39051, vrr_stack+7938, vrr_stack+5074, NULL);
 _BUILD_p0n0(Data,vrr_stack+55263, vrr_stack+46347, vrr_stack+55197, NULL, NULL, vrr_stack+8118);
 _BUILD_d0n0(Data,vrr_stack+51618, vrr_stack+46765, vrr_stack+55263, vrr_stack+50607, vrr_stack+46347, vrr_stack+8173);
 _BUILD_f0n0(Data,vrr_stack+40356, vrr_stack+46963, vrr_stack+51618, vrr_stack+68302, vrr_stack+46765, vrr_stack+8338);
 _BUILD_g0n0(Data,vrr_stack+14135, vrr_stack+75538, vrr_stack+40356, vrr_stack+4678, vrr_stack+46963, vrr_stack+19134);
 _BUILD_h0n0(Data,vrr_stack+43551, vrr_stack+76198, vrr_stack+14135, vrr_stack+68896, vrr_stack+75538, vrr_stack+81893);
 _BUILD_i0n0(Data,vrr_stack+109667, vrr_stack+11363, vrr_stack+43551, vrr_stack+77188, vrr_stack+76198, vrr_stack+82718);
 _BUILD_i0n0(Data,vrr_stack+81607, vrr_stack+12749, vrr_stack+11363, vrr_stack+47359, vrr_stack+77188, vrr_stack+5326);
 _BUILD_k0n0(Data,vrr_stack+5119, vrr_stack+81607, vrr_stack+109667, vrr_stack+12749, vrr_stack+11363, vrr_stack+83873);
 _BUILD_00n0(Data,vrr_stack+19134, vrr_stack+59148, vrr_stack+18584, vrr_stack+40311, vrr_stack+7758, NULL);
 _BUILD_p0n0(Data,vrr_stack+19200, vrr_stack+19134, vrr_stack+81343, NULL, NULL, vrr_stack+18584);
 _BUILD_d0n0(Data,vrr_stack+19398, vrr_stack+19200, vrr_stack+81409, vrr_stack+19134, vrr_stack+81343, vrr_stack+18639);
 _BUILD_f0n0(Data,vrr_stack+83455, vrr_stack+19398, vrr_stack+51222, vrr_stack+19200, vrr_stack+81409, vrr_stack+18804);
 _BUILD_g0n0(Data,vrr_stack+84115, vrr_stack+83455, vrr_stack+64098, vrr_stack+19398, vrr_stack+51222, vrr_stack+24463);
 _BUILD_h0n0(Data,vrr_stack+111515, vrr_stack+84115, vrr_stack+47359, vrr_stack+83455, vrr_stack+64098, vrr_stack+775);
 _BUILD_i0n0(Data,vrr_stack+112901, vrr_stack+111515, vrr_stack+12749, vrr_stack+84115, vrr_stack+47359, vrr_stack+3523);
 _BUILD_k0n0(Data,vrr_stack+114749, vrr_stack+112901, vrr_stack+81607, vrr_stack+111515, vrr_stack+12749, vrr_stack+85413);
 _BUILD_00n0(Data,vrr_stack+24463, vrr_stack+39051, vrr_stack+98557, vrr_stack+5074, vrr_stack+85, NULL);
 _BUILD_p0n0(Data,vrr_stack+24529, vrr_stack+55197, vrr_stack+24463, NULL, NULL, vrr_stack+39051);
 _BUILD_d0n0(Data,vrr_stack+18639, vrr_stack+55263, vrr_stack+24529, vrr_stack+46347, vrr_stack+55197, vrr_stack+39106);
 _BUILD_f0n0(Data,vrr_stack+85105, vrr_stack+51618, vrr_stack+18639, vrr_stack+46765, vrr_stack+55263, vrr_stack+39271);
 _BUILD_g0n0(Data,vrr_stack+85765, vrr_stack+40356, vrr_stack+85105, vrr_stack+46963, vrr_stack+51618, vrr_stack+39601);
 _BUILD_h0n0(Data,vrr_stack+2755, vrr_stack+14135, vrr_stack+85765, vrr_stack+75538, vrr_stack+40356, vrr_stack+58203);
 _BUILD_i0n0(Data,vrr_stack+117125, vrr_stack+43551, vrr_stack+2755, vrr_stack+76198, vrr_stack+14135, vrr_stack+21804);
 _BUILD_k0n0(Data,vrr_stack+118973, vrr_stack+109667, vrr_stack+117125, vrr_stack+11363, vrr_stack+43551, vrr_stack+25013);
 _BUILD_l0n0(Data,vrr_stack+121349, vrr_stack+5119, vrr_stack+118973, vrr_stack+81607, vrr_stack+109667, vrr_stack+90913);
 _BUILD_l0n0(Data,vrr_stack+124319, vrr_stack+114749, vrr_stack+5119, vrr_stack+112901, vrr_stack+81607, vrr_stack+86953);
 _BUILD_m0n0(Data,vrr_stack+127289, vrr_stack+124319, vrr_stack+121349, vrr_stack+114749, vrr_stack+5119, vrr_stack+92893);
 _BUILD_00n0(Data,vrr_stack+90913, vrr_stack+67653, vrr_stack+59148, vrr_stack+45972, vrr_stack+40311, NULL);
 _BUILD_p0n0(Data,vrr_stack+90979, vrr_stack+90913, vrr_stack+19134, NULL, NULL, vrr_stack+59148);
 _BUILD_d0n0(Data,vrr_stack+91177, vrr_stack+90979, vrr_stack+19200, vrr_stack+90913, vrr_stack+19134, vrr_stack+59203);
 _BUILD_f0n0(Data,vrr_stack+91573, vrr_stack+91177, vrr_stack+19398, vrr_stack+90979, vrr_stack+19200, vrr_stack+59368);
 _BUILD_g0n0(Data,vrr_stack+92233, vrr_stack+91573, vrr_stack+83455, vrr_stack+91177, vrr_stack+19398, vrr_stack+59698);
 _BUILD_h0n0(Data,vrr_stack+93223, vrr_stack+92233, vrr_stack+84115, vrr_stack+91573, vrr_stack+83455, vrr_stack+60248);
 _BUILD_i0n0(Data,vrr_stack+59203, vrr_stack+93223, vrr_stack+111515, vrr_stack+92233, vrr_stack+84115, vrr_stack+1600);
 _BUILD_k0n0(Data,vrr_stack+24727, vrr_stack+59203, vrr_stack+112901, vrr_stack+93223, vrr_stack+111515, vrr_stack+15393);
 _BUILD_l0n0(Data,vrr_stack+90979, vrr_stack+24727, vrr_stack+114749, vrr_stack+59203, vrr_stack+112901, vrr_stack+88933);
 _BUILD_m0n0(Data,vrr_stack+86755, vrr_stack+90979, vrr_stack+124319, vrr_stack+24727, vrr_stack+114749, vrr_stack+65178);
 _BUILD_00p0(Data,vrr_stack+24727, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24730, vrr_stack+98393, vrr_stack+24727, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+24736, vrr_stack+98396, vrr_stack+24730, vrr_stack+73503, vrr_stack+98393, NULL);
 _BUILD_00g0(Data,vrr_stack+24746, vrr_stack+98402, vrr_stack+24736, vrr_stack+73506, vrr_stack+98396, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+98412, vrr_stack+24746, vrr_stack+73512, vrr_stack+98402, NULL);
 _BUILD_00i0(Data,vrr_stack+24761, vrr_stack+98427, vrr_stack+0, vrr_stack+73522, vrr_stack+98412, NULL);
 _BUILD_00k0(Data,vrr_stack+24789, vrr_stack+98448, vrr_stack+24761, vrr_stack+73537, vrr_stack+98427, NULL);
 _BUILD_00l0(Data,vrr_stack+5074, vrr_stack+98476, vrr_stack+24789, vrr_stack+21, vrr_stack+98448, NULL);
 _BUILD_00m0(Data,vrr_stack+73503, vrr_stack+98512, vrr_stack+5074, vrr_stack+49, vrr_stack+98476, NULL);
 _BUILD_00n0(Data,vrr_stack+24825, vrr_stack+98557, vrr_stack+73503, vrr_stack+85, vrr_stack+98512, NULL);
 _BUILD_p0n0(Data,vrr_stack+24891, vrr_stack+24463, vrr_stack+24825, NULL, NULL, vrr_stack+98557);
 _BUILD_d0n0(Data,vrr_stack+25089, vrr_stack+24529, vrr_stack+24891, vrr_stack+55197, vrr_stack+24463, vrr_stack+98612);
 _BUILD_f0n0(Data,vrr_stack+25485, vrr_stack+18639, vrr_stack+25089, vrr_stack+55263, vrr_stack+24529, vrr_stack+98777);
 _BUILD_g0n0(Data,vrr_stack+26145, vrr_stack+85105, vrr_stack+25485, vrr_stack+51618, vrr_stack+18639, vrr_stack+130);
 _BUILD_h0n0(Data,vrr_stack+21, vrr_stack+85765, vrr_stack+26145, vrr_stack+40356, vrr_stack+85105, vrr_stack+99107);
 _BUILD_i0n0(Data,vrr_stack+59203, vrr_stack+2755, vrr_stack+21, vrr_stack+14135, vrr_stack+85765, vrr_stack+8668);
 _BUILD_k0n0(Data,vrr_stack+64758, vrr_stack+117125, vrr_stack+59203, vrr_stack+43551, vrr_stack+2755, vrr_stack+9823);
 _BUILD_l0n0(Data,vrr_stack+8173, vrr_stack+118973, vrr_stack+64758, vrr_stack+109667, vrr_stack+117125, vrr_stack+73558);
 _BUILD_m0n0(Data,vrr_stack+130919, vrr_stack+121349, vrr_stack+8173, vrr_stack+5119, vrr_stack+118973, vrr_stack+99932);
 _BUILD_n0n0(Data,vrr_stack+134549, vrr_stack+127289, vrr_stack+130919, vrr_stack+124319, vrr_stack+121349, vrr_stack+29347);
 _BUILD_n0n0(Data,vrr_stack+138905, vrr_stack+86755, vrr_stack+127289, vrr_stack+90979, vrr_stack+124319, vrr_stack+95368);
   tmp = vrr_stack + 138905;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+90979, vrr_stack+67708, vrr_stack+50607, vrr_stack+46017, vrr_stack+46512, NULL);
 _BUILD_00o0(Data,vrr_stack+91057, vrr_stack+67774, vrr_stack+67708, vrr_stack+46072, vrr_stack+46017, NULL);
 _BUILD_p0o0(Data,vrr_stack+91135, vrr_stack+91057, vrr_stack+90979, NULL, NULL, vrr_stack+67708);
 _BUILD_00o0(Data,vrr_stack+91369, vrr_stack+68038, vrr_stack+67774, vrr_stack+46292, vrr_stack+46072, NULL);
 _BUILD_p0o0(Data,vrr_stack+91447, vrr_stack+91369, vrr_stack+91057, NULL, NULL, vrr_stack+67774);
 _BUILD_00o0(Data,vrr_stack+91681, vrr_stack+50607, vrr_stack+46347, vrr_stack+46512, vrr_stack+50877, NULL);
 _BUILD_p0o0(Data,vrr_stack+91759, vrr_stack+90979, vrr_stack+91681, NULL, NULL, vrr_stack+50607);
 _BUILD_d0o0(Data,vrr_stack+91993, vrr_stack+91135, vrr_stack+91759, vrr_stack+91057, vrr_stack+90979, vrr_stack+68302);
 _BUILD_d0o0(Data,vrr_stack+92461, vrr_stack+91447, vrr_stack+91135, vrr_stack+91369, vrr_stack+91057, vrr_stack+67840);
 _BUILD_f0o0(Data,vrr_stack+92929, vrr_stack+92461, vrr_stack+91993, vrr_stack+91447, vrr_stack+91135, vrr_stack+4678);
 _BUILD_00o0(Data,vrr_stack+67840, vrr_stack+46127, vrr_stack+68038, vrr_stack+50697, vrr_stack+46292, NULL);
 _BUILD_p0o0(Data,vrr_stack+93709, vrr_stack+67840, vrr_stack+91369, NULL, NULL, vrr_stack+68038);
 _BUILD_d0o0(Data,vrr_stack+93943, vrr_stack+93709, vrr_stack+91447, vrr_stack+67840, vrr_stack+91369, vrr_stack+68104);
 _BUILD_f0o0(Data,vrr_stack+94411, vrr_stack+93943, vrr_stack+92461, vrr_stack+93709, vrr_stack+91447, vrr_stack+68500);
 _BUILD_00o0(Data,vrr_stack+68104, vrr_stack+46347, vrr_stack+55197, vrr_stack+50877, vrr_stack+8118, NULL);
 _BUILD_p0o0(Data,vrr_stack+68182, vrr_stack+91681, vrr_stack+68104, NULL, NULL, vrr_stack+46347);
 _BUILD_d0o0(Data,vrr_stack+68416, vrr_stack+91759, vrr_stack+68182, vrr_stack+90979, vrr_stack+91681, vrr_stack+46765);
 _BUILD_f0o0(Data,vrr_stack+29347, vrr_stack+91993, vrr_stack+68416, vrr_stack+91135, vrr_stack+91759, vrr_stack+46963);
 _BUILD_g0o0(Data,vrr_stack+30127, vrr_stack+92929, vrr_stack+29347, vrr_stack+92461, vrr_stack+91993, vrr_stack+75538);
 _BUILD_g0o0(Data,vrr_stack+31297, vrr_stack+94411, vrr_stack+92929, vrr_stack+93943, vrr_stack+92461, vrr_stack+68896);
 _BUILD_h0o0(Data,vrr_stack+73558, vrr_stack+31297, vrr_stack+30127, vrr_stack+94411, vrr_stack+92929, vrr_stack+76198);
 _BUILD_00o0(Data,vrr_stack+46765, vrr_stack+81343, vrr_stack+46127, vrr_stack+18584, vrr_stack+50697, NULL);
 _BUILD_p0o0(Data,vrr_stack+46843, vrr_stack+46765, vrr_stack+67840, NULL, NULL, vrr_stack+46127);
 _BUILD_d0o0(Data,vrr_stack+68884, vrr_stack+46843, vrr_stack+93709, vrr_stack+46765, vrr_stack+67840, vrr_stack+46567);
 _BUILD_f0o0(Data,vrr_stack+75196, vrr_stack+68884, vrr_stack+93943, vrr_stack+46843, vrr_stack+93709, vrr_stack+69556);
 _BUILD_g0o0(Data,vrr_stack+75976, vrr_stack+75196, vrr_stack+94411, vrr_stack+68884, vrr_stack+93943, vrr_stack+69952);
 _BUILD_h0o0(Data,vrr_stack+69352, vrr_stack+75976, vrr_stack+31297, vrr_stack+75196, vrr_stack+94411, vrr_stack+77188);
 _BUILD_00o0(Data,vrr_stack+47077, vrr_stack+55197, vrr_stack+24463, vrr_stack+8118, vrr_stack+39051, NULL);
 _BUILD_p0o0(Data,vrr_stack+32467, vrr_stack+68104, vrr_stack+47077, NULL, NULL, vrr_stack+55197);
 _BUILD_d0o0(Data,vrr_stack+77146, vrr_stack+68182, vrr_stack+32467, vrr_stack+91681, vrr_stack+68104, vrr_stack+55263);
 _BUILD_f0o0(Data,vrr_stack+98612, vrr_stack+68416, vrr_stack+77146, vrr_stack+91759, vrr_stack+68182, vrr_stack+51618);
 _BUILD_g0o0(Data,vrr_stack+99392, vrr_stack+29347, vrr_stack+98612, vrr_stack+91993, vrr_stack+68416, vrr_stack+40356);
 _BUILD_h0o0(Data,vrr_stack+100562, vrr_stack+30127, vrr_stack+99392, vrr_stack+92929, vrr_stack+29347, vrr_stack+14135);
 _BUILD_i0o0(Data,vrr_stack+14135, vrr_stack+73558, vrr_stack+100562, vrr_stack+31297, vrr_stack+30127, vrr_stack+43551);
 _BUILD_i0o0(Data,vrr_stack+43551, vrr_stack+69352, vrr_stack+73558, vrr_stack+75976, vrr_stack+31297, vrr_stack+11363);
 _BUILD_k0o0(Data,vrr_stack+143261, vrr_stack+43551, vrr_stack+14135, vrr_stack+69352, vrr_stack+73558, vrr_stack+109667);
 _BUILD_00o0(Data,vrr_stack+109667, vrr_stack+19134, vrr_stack+81343, vrr_stack+59148, vrr_stack+18584, NULL);
 _BUILD_p0o0(Data,vrr_stack+109745, vrr_stack+109667, vrr_stack+46765, NULL, NULL, vrr_stack+81343);
 _BUILD_d0o0(Data,vrr_stack+109979, vrr_stack+109745, vrr_stack+46843, vrr_stack+109667, vrr_stack+46765, vrr_stack+81409);
 _BUILD_f0o0(Data,vrr_stack+110447, vrr_stack+109979, vrr_stack+68884, vrr_stack+109745, vrr_stack+46843, vrr_stack+51222);
 _BUILD_g0o0(Data,vrr_stack+1407, vrr_stack+110447, vrr_stack+75196, vrr_stack+109979, vrr_stack+68884, vrr_stack+64098);
 _BUILD_h0o0(Data,vrr_stack+39106, vrr_stack+1407, vrr_stack+75976, vrr_stack+110447, vrr_stack+75196, vrr_stack+47359);
 _BUILD_i0o0(Data,vrr_stack+146069, vrr_stack+39106, vrr_stack+69352, vrr_stack+1407, vrr_stack+75976, vrr_stack+12749);
 _BUILD_k0o0(Data,vrr_stack+11143, vrr_stack+146069, vrr_stack+43551, vrr_stack+39106, vrr_stack+69352, vrr_stack+81607);
 _BUILD_00o0(Data,vrr_stack+64098, vrr_stack+24463, vrr_stack+24825, vrr_stack+39051, vrr_stack+98557, NULL);
 _BUILD_p0o0(Data,vrr_stack+64176, vrr_stack+47077, vrr_stack+64098, NULL, NULL, vrr_stack+24463);
 _BUILD_d0o0(Data,vrr_stack+81409, vrr_stack+32467, vrr_stack+64176, vrr_stack+68104, vrr_stack+47077, vrr_stack+24529);
 _BUILD_f0o0(Data,vrr_stack+81877, vrr_stack+77146, vrr_stack+81409, vrr_stack+68182, vrr_stack+32467, vrr_stack+18639);
 _BUILD_g0o0(Data,vrr_stack+47155, vrr_stack+98612, vrr_stack+81877, vrr_stack+68416, vrr_stack+77146, vrr_stack+85105);
 _BUILD_h0o0(Data,vrr_stack+148253, vrr_stack+99392, vrr_stack+47155, vrr_stack+29347, vrr_stack+98612, vrr_stack+85765);
 _BUILD_i0o0(Data,vrr_stack+149891, vrr_stack+100562, vrr_stack+148253, vrr_stack+30127, vrr_stack+99392, vrr_stack+2755);
 _BUILD_k0o0(Data,vrr_stack+152075, vrr_stack+14135, vrr_stack+149891, vrr_stack+73558, vrr_stack+100562, vrr_stack+117125);
 _BUILD_l0o0(Data,vrr_stack+154883, vrr_stack+143261, vrr_stack+152075, vrr_stack+43551, vrr_stack+14135, vrr_stack+118973);
 _BUILD_l0o0(Data,vrr_stack+117125, vrr_stack+11143, vrr_stack+143261, vrr_stack+146069, vrr_stack+43551, vrr_stack+5119);
 _BUILD_m0o0(Data,vrr_stack+158393, vrr_stack+117125, vrr_stack+154883, vrr_stack+11143, vrr_stack+143261, vrr_stack+121349);
 _BUILD_00o0(Data,vrr_stack+5119, vrr_stack+90913, vrr_stack+19134, vrr_stack+67653, vrr_stack+59148, NULL);
 _BUILD_p0o0(Data,vrr_stack+5197, vrr_stack+5119, vrr_stack+109667, NULL, NULL, vrr_stack+19134);
 _BUILD_d0o0(Data,vrr_stack+5431, vrr_stack+5197, vrr_stack+109745, vrr_stack+5119, vrr_stack+109667, vrr_stack+19200);
 _BUILD_f0o0(Data,vrr_stack+5899, vrr_stack+5431, vrr_stack+109979, vrr_stack+5197, vrr_stack+109745, vrr_stack+19398);
 _BUILD_g0o0(Data,vrr_stack+6679, vrr_stack+5899, vrr_stack+110447, vrr_stack+5431, vrr_stack+109979, vrr_stack+83455);
 _BUILD_h0o0(Data,vrr_stack+120635, vrr_stack+6679, vrr_stack+1407, vrr_stack+5899, vrr_stack+110447, vrr_stack+84115);
 _BUILD_i0o0(Data,vrr_stack+82657, vrr_stack+120635, vrr_stack+39106, vrr_stack+6679, vrr_stack+1407, vrr_stack+111515);
 _BUILD_k0o0(Data,vrr_stack+5197, vrr_stack+82657, vrr_stack+146069, vrr_stack+120635, vrr_stack+39106, vrr_stack+112901);
 _BUILD_l0o0(Data,vrr_stack+120635, vrr_stack+5197, vrr_stack+11143, vrr_stack+82657, vrr_stack+146069, vrr_stack+114749);
 _BUILD_m0o0(Data,vrr_stack+111227, vrr_stack+120635, vrr_stack+117125, vrr_stack+5197, vrr_stack+11143, vrr_stack+124319);
 _BUILD_00p0(Data,vrr_stack+5197, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5200, vrr_stack+24727, vrr_stack+5197, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+5206, vrr_stack+24730, vrr_stack+5200, vrr_stack+98393, vrr_stack+24727, NULL);
 _BUILD_00g0(Data,vrr_stack+5216, vrr_stack+24736, vrr_stack+5206, vrr_stack+98396, vrr_stack+24730, NULL);
 _BUILD_00h0(Data,vrr_stack+5231, vrr_stack+24746, vrr_stack+5216, vrr_stack+98402, vrr_stack+24736, NULL);
 _BUILD_00i0(Data,vrr_stack+5252, vrr_stack+0, vrr_stack+5231, vrr_stack+98412, vrr_stack+24746, NULL);
 _BUILD_00k0(Data,vrr_stack+5280, vrr_stack+24761, vrr_stack+5252, vrr_stack+98427, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+98393, vrr_stack+24789, vrr_stack+5280, vrr_stack+98448, vrr_stack+24761, NULL);
 _BUILD_00m0(Data,vrr_stack+39051, vrr_stack+5074, vrr_stack+98393, vrr_stack+98476, vrr_stack+24789, NULL);
 _BUILD_00n0(Data,vrr_stack+98438, vrr_stack+73503, vrr_stack+39051, vrr_stack+98512, vrr_stack+5074, NULL);
 _BUILD_00o0(Data,vrr_stack+5316, vrr_stack+24825, vrr_stack+98438, vrr_stack+98557, vrr_stack+73503, NULL);
 _BUILD_p0o0(Data,vrr_stack+5394, vrr_stack+64098, vrr_stack+5316, NULL, NULL, vrr_stack+24825);
 _BUILD_d0o0(Data,vrr_stack+5628, vrr_stack+64176, vrr_stack+5394, vrr_stack+47077, vrr_stack+64098, vrr_stack+24891);
 _BUILD_f0o0(Data,vrr_stack+6096, vrr_stack+81409, vrr_stack+5628, vrr_stack+32467, vrr_stack+64176, vrr_stack+25089);
 _BUILD_g0o0(Data,vrr_stack+6876, vrr_stack+81877, vrr_stack+6096, vrr_stack+77146, vrr_stack+81409, vrr_stack+25485);
 _BUILD_h0o0(Data,vrr_stack+82657, vrr_stack+47155, vrr_stack+6876, vrr_stack+98612, vrr_stack+81877, vrr_stack+26145);
 _BUILD_i0o0(Data,vrr_stack+24891, vrr_stack+148253, vrr_stack+82657, vrr_stack+99392, vrr_stack+47155, vrr_stack+21);
 _BUILD_k0o0(Data,vrr_stack+124145, vrr_stack+149891, vrr_stack+24891, vrr_stack+100562, vrr_stack+148253, vrr_stack+59203);
 _BUILD_l0o0(Data,vrr_stack+162683, vrr_stack+152075, vrr_stack+124145, vrr_stack+14135, vrr_stack+149891, vrr_stack+64758);
 _BUILD_m0o0(Data,vrr_stack+166193, vrr_stack+154883, vrr_stack+162683, vrr_stack+143261, vrr_stack+152075, vrr_stack+8173);
 _BUILD_n0o0(Data,vrr_stack+170483, vrr_stack+158393, vrr_stack+166193, vrr_stack+117125, vrr_stack+154883, vrr_stack+130919);
 _BUILD_n0o0(Data,vrr_stack+175631, vrr_stack+111227, vrr_stack+158393, vrr_stack+120635, vrr_stack+117125, vrr_stack+127289);
   tmp = vrr_stack + 175631;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+120635, vrr_stack+90979, vrr_stack+91681, vrr_stack+67708, vrr_stack+50607, NULL);
 _BUILD_00q0(Data,vrr_stack+120726, vrr_stack+91057, vrr_stack+90979, vrr_stack+67774, vrr_stack+67708, NULL);
 _BUILD_p0q0(Data,vrr_stack+120817, vrr_stack+120726, vrr_stack+120635, NULL, NULL, vrr_stack+90979);
 _BUILD_00q0(Data,vrr_stack+121090, vrr_stack+91369, vrr_stack+91057, vrr_stack+68038, vrr_stack+67774, NULL);
 _BUILD_p0q0(Data,vrr_stack+121181, vrr_stack+121090, vrr_stack+120726, NULL, NULL, vrr_stack+91057);
 _BUILD_00q0(Data,vrr_stack+90979, vrr_stack+91681, vrr_stack+68104, vrr_stack+50607, vrr_stack+46347, NULL);
 _BUILD_p0q0(Data,vrr_stack+50607, vrr_stack+120635, vrr_stack+90979, NULL, NULL, vrr_stack+91681);
 _BUILD_d0q0(Data,vrr_stack+50880, vrr_stack+120817, vrr_stack+50607, vrr_stack+120726, vrr_stack+120635, vrr_stack+91759);
 _BUILD_d0q0(Data,vrr_stack+51426, vrr_stack+121181, vrr_stack+120817, vrr_stack+121090, vrr_stack+120726, vrr_stack+91135);
 _BUILD_f0q0(Data,vrr_stack+121454, vrr_stack+51426, vrr_stack+50880, vrr_stack+121181, vrr_stack+120817, vrr_stack+91993);
 _BUILD_00q0(Data,vrr_stack+120726, vrr_stack+67840, vrr_stack+91369, vrr_stack+46127, vrr_stack+68038, NULL);
 _BUILD_p0q0(Data,vrr_stack+91681, vrr_stack+120726, vrr_stack+121090, NULL, NULL, vrr_stack+91369);
 _BUILD_d0q0(Data,vrr_stack+122364, vrr_stack+91681, vrr_stack+121181, vrr_stack+120726, vrr_stack+121090, vrr_stack+91447);
 _BUILD_f0q0(Data,vrr_stack+122910, vrr_stack+122364, vrr_stack+51426, vrr_stack+91681, vrr_stack+121181, vrr_stack+92461);
 _BUILD_00q0(Data,vrr_stack+121090, vrr_stack+68104, vrr_stack+47077, vrr_stack+46347, vrr_stack+55197, NULL);
 _BUILD_p0q0(Data,vrr_stack+121181, vrr_stack+90979, vrr_stack+121090, NULL, NULL, vrr_stack+68104);
 _BUILD_d0q0(Data,vrr_stack+91954, vrr_stack+50607, vrr_stack+121181, vrr_stack+120635, vrr_stack+90979, vrr_stack+68182);
 _BUILD_f0q0(Data,vrr_stack+130919, vrr_stack+50880, vrr_stack+91954, vrr_stack+120817, vrr_stack+50607, vrr_stack+68416);
 _BUILD_g0q0(Data,vrr_stack+131829, vrr_stack+121454, vrr_stack+130919, vrr_stack+51426, vrr_stack+50880, vrr_stack+29347);
 _BUILD_g0q0(Data,vrr_stack+21, vrr_stack+122910, vrr_stack+121454, vrr_stack+122364, vrr_stack+51426, vrr_stack+92929);
 _BUILD_h0q0(Data,vrr_stack+8046, vrr_stack+21, vrr_stack+131829, vrr_stack+122910, vrr_stack+121454, vrr_stack+30127);
 _BUILD_00q0(Data,vrr_stack+120635, vrr_stack+46765, vrr_stack+67840, vrr_stack+81343, vrr_stack+46127, NULL);
 _BUILD_p0q0(Data,vrr_stack+120817, vrr_stack+120635, vrr_stack+120726, NULL, NULL, vrr_stack+67840);
 _BUILD_d0q0(Data,vrr_stack+51426, vrr_stack+120817, vrr_stack+91681, vrr_stack+120635, vrr_stack+120726, vrr_stack+93709);
 _BUILD_f0q0(Data,vrr_stack+29347, vrr_stack+51426, vrr_stack+122364, vrr_stack+120817, vrr_stack+91681, vrr_stack+93943);
 _BUILD_g0q0(Data,vrr_stack+92500, vrr_stack+29347, vrr_stack+122910, vrr_stack+51426, vrr_stack+122364, vrr_stack+94411);
 _BUILD_h0q0(Data,vrr_stack+84295, vrr_stack+92500, vrr_stack+21, vrr_stack+29347, vrr_stack+122910, vrr_stack+31297);
 _BUILD_00q0(Data,vrr_stack+120726, vrr_stack+47077, vrr_stack+64098, vrr_stack+55197, vrr_stack+24463, NULL);
 _BUILD_p0q0(Data,vrr_stack+55197, vrr_stack+121090, vrr_stack+120726, NULL, NULL, vrr_stack+47077);
 _BUILD_d0q0(Data,vrr_stack+122364, vrr_stack+121181, vrr_stack+55197, vrr_stack+90979, vrr_stack+121090, vrr_stack+32467);
 _BUILD_f0q0(Data,vrr_stack+90979, vrr_stack+91954, vrr_stack+122364, vrr_stack+50607, vrr_stack+121181, vrr_stack+77146);
 _BUILD_g0q0(Data,vrr_stack+30257, vrr_stack+130919, vrr_stack+90979, vrr_stack+50880, vrr_stack+91954, vrr_stack+98612);
 _BUILD_h0q0(Data,vrr_stack+64410, vrr_stack+131829, vrr_stack+30257, vrr_stack+121454, vrr_stack+130919, vrr_stack+99392);
 _BUILD_i0q0(Data,vrr_stack+66321, vrr_stack+8046, vrr_stack+64410, vrr_stack+21, vrr_stack+131829, vrr_stack+100562);
 _BUILD_i0q0(Data,vrr_stack+98504, vrr_stack+84295, vrr_stack+8046, vrr_stack+92500, vrr_stack+21, vrr_stack+73558);
 _BUILD_k0q0(Data,vrr_stack+180779, vrr_stack+98504, vrr_stack+66321, vrr_stack+84295, vrr_stack+8046, vrr_stack+14135);
 _BUILD_00q0(Data,vrr_stack+73558, vrr_stack+109667, vrr_stack+46765, vrr_stack+19134, vrr_stack+81343, NULL);
 _BUILD_p0q0(Data,vrr_stack+73649, vrr_stack+73558, vrr_stack+120635, NULL, NULL, vrr_stack+46765);
 _BUILD_d0q0(Data,vrr_stack+73922, vrr_stack+73649, vrr_stack+120817, vrr_stack+73558, vrr_stack+120635, vrr_stack+46843);
 _BUILD_f0q0(Data,vrr_stack+121454, vrr_stack+73922, vrr_stack+51426, vrr_stack+73649, vrr_stack+120817, vrr_stack+68884);
 _BUILD_g0q0(Data,vrr_stack+21, vrr_stack+121454, vrr_stack+29347, vrr_stack+73922, vrr_stack+51426, vrr_stack+75196);
 _BUILD_h0q0(Data,vrr_stack+2577, vrr_stack+21, vrr_stack+92500, vrr_stack+121454, vrr_stack+29347, vrr_stack+75976);
 _BUILD_i0q0(Data,vrr_stack+74468, vrr_stack+2577, vrr_stack+84295, vrr_stack+21, vrr_stack+92500, vrr_stack+69352);
 _BUILD_k0q0(Data,vrr_stack+184055, vrr_stack+74468, vrr_stack+98504, vrr_stack+2577, vrr_stack+84295, vrr_stack+43551);
 _BUILD_00q0(Data,vrr_stack+120635, vrr_stack+64098, vrr_stack+5316, vrr_stack+24463, vrr_stack+24825, NULL);
 _BUILD_p0q0(Data,vrr_stack+120817, vrr_stack+120726, vrr_stack+120635, NULL, NULL, vrr_stack+64098);
 _BUILD_d0q0(Data,vrr_stack+43551, vrr_stack+55197, vrr_stack+120817, vrr_stack+121090, vrr_stack+120726, vrr_stack+64176);
 _BUILD_f0q0(Data,vrr_stack+29347, vrr_stack+122364, vrr_stack+43551, vrr_stack+121181, vrr_stack+55197, vrr_stack+81409);
 _BUILD_g0q0(Data,vrr_stack+44097, vrr_stack+90979, vrr_stack+29347, vrr_stack+91954, vrr_stack+122364, vrr_stack+81877);
 _BUILD_h0q0(Data,vrr_stack+84295, vrr_stack+30257, vrr_stack+44097, vrr_stack+130919, vrr_stack+90979, vrr_stack+47155);
 _BUILD_i0q0(Data,vrr_stack+45462, vrr_stack+64410, vrr_stack+84295, vrr_stack+131829, vrr_stack+30257, vrr_stack+148253);
 _BUILD_k0q0(Data,vrr_stack+130919, vrr_stack+66321, vrr_stack+45462, vrr_stack+8046, vrr_stack+64410, vrr_stack+149891);
 _BUILD_l0q0(Data,vrr_stack+187331, vrr_stack+180779, vrr_stack+130919, vrr_stack+98504, vrr_stack+66321, vrr_stack+152075);
 _BUILD_l0q0(Data,vrr_stack+148253, vrr_stack+184055, vrr_stack+180779, vrr_stack+74468, vrr_stack+98504, vrr_stack+143261);
 _BUILD_m0q0(Data,vrr_stack+191426, vrr_stack+148253, vrr_stack+187331, vrr_stack+184055, vrr_stack+180779, vrr_stack+154883);
 _BUILD_00q0(Data,vrr_stack+143261, vrr_stack+5119, vrr_stack+109667, vrr_stack+90913, vrr_stack+19134, NULL);
 _BUILD_p0q0(Data,vrr_stack+143352, vrr_stack+143261, vrr_stack+73558, NULL, NULL, vrr_stack+109667);
 _BUILD_d0q0(Data,vrr_stack+143625, vrr_stack+143352, vrr_stack+73649, vrr_stack+143261, vrr_stack+73558, vrr_stack+109745);
 _BUILD_f0q0(Data,vrr_stack+144171, vrr_stack+143625, vrr_stack+73922, vrr_stack+143352, vrr_stack+73649, vrr_stack+109979);
 _BUILD_g0q0(Data,vrr_stack+98504, vrr_stack+144171, vrr_stack+121454, vrr_stack+143625, vrr_stack+73922, vrr_stack+110447);
 _BUILD_h0q0(Data,vrr_stack+99869, vrr_stack+98504, vrr_stack+21, vrr_stack+144171, vrr_stack+121454, vrr_stack+1407);
 _BUILD_i0q0(Data,vrr_stack+143261, vrr_stack+99869, vrr_stack+2577, vrr_stack+98504, vrr_stack+21, vrr_stack+39106);
 _BUILD_k0q0(Data,vrr_stack+152348, vrr_stack+143261, vrr_stack+74468, vrr_stack+99869, vrr_stack+2577, vrr_stack+146069);
 _BUILD_l0q0(Data,vrr_stack+21, vrr_stack+152348, vrr_stack+184055, vrr_stack+143261, vrr_stack+74468, vrr_stack+11143);
 _BUILD_m0q0(Data,vrr_stack+8046, vrr_stack+21, vrr_stack+148253, vrr_stack+152348, vrr_stack+184055, vrr_stack+117125);
 _BUILD_00p0(Data,vrr_stack+184055, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+184058, vrr_stack+5197, vrr_stack+184055, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+184064, vrr_stack+5200, vrr_stack+184058, vrr_stack+24727, vrr_stack+5197, NULL);
 _BUILD_00g0(Data,vrr_stack+184074, vrr_stack+5206, vrr_stack+184064, vrr_stack+24730, vrr_stack+5200, NULL);
 _BUILD_00h0(Data,vrr_stack+184089, vrr_stack+5216, vrr_stack+184074, vrr_stack+24736, vrr_stack+5206, NULL);
 _BUILD_00i0(Data,vrr_stack+184055, vrr_stack+5231, vrr_stack+184089, vrr_stack+24746, vrr_stack+5216, NULL);
 _BUILD_00k0(Data,vrr_stack+184083, vrr_stack+5252, vrr_stack+184055, vrr_stack+0, vrr_stack+5231, NULL);
 _BUILD_00l0(Data,vrr_stack+184119, vrr_stack+5280, vrr_stack+184083, vrr_stack+24761, vrr_stack+5252, NULL);
 _BUILD_00m0(Data,vrr_stack+184055, vrr_stack+98393, vrr_stack+184119, vrr_stack+24789, vrr_stack+5280, NULL);
 _BUILD_00n0(Data,vrr_stack+184110, vrr_stack+39051, vrr_stack+184055, vrr_stack+5074, vrr_stack+98393, NULL);
 _BUILD_00o0(Data,vrr_stack+184176, vrr_stack+98438, vrr_stack+184110, vrr_stack+73503, vrr_stack+39051, NULL);
 _BUILD_00q0(Data,vrr_stack+39051, vrr_stack+5316, vrr_stack+184176, vrr_stack+24825, vrr_stack+98438, NULL);
 _BUILD_p0q0(Data,vrr_stack+39142, vrr_stack+120635, vrr_stack+39051, NULL, NULL, vrr_stack+5316);
 _BUILD_d0q0(Data,vrr_stack+39415, vrr_stack+120817, vrr_stack+39142, vrr_stack+120726, vrr_stack+120635, vrr_stack+5394);
 _BUILD_f0q0(Data,vrr_stack+39961, vrr_stack+43551, vrr_stack+39415, vrr_stack+55197, vrr_stack+120817, vrr_stack+5628);
 _BUILD_g0q0(Data,vrr_stack+73503, vrr_stack+29347, vrr_stack+39961, vrr_stack+122364, vrr_stack+43551, vrr_stack+6096);
 _BUILD_h0q0(Data,vrr_stack+39051, vrr_stack+44097, vrr_stack+73503, vrr_stack+90979, vrr_stack+29347, vrr_stack+6876);
 _BUILD_i0q0(Data,vrr_stack+73503, vrr_stack+84295, vrr_stack+39051, vrr_stack+30257, vrr_stack+44097, vrr_stack+82657);
 _BUILD_k0q0(Data,vrr_stack+184055, vrr_stack+45462, vrr_stack+73503, vrr_stack+64410, vrr_stack+84295, vrr_stack+24891);
 _BUILD_l0q0(Data,vrr_stack+73503, vrr_stack+130919, vrr_stack+184055, vrr_stack+66321, vrr_stack+45462, vrr_stack+124145);
 _BUILD_m0q0(Data,vrr_stack+43551, vrr_stack+187331, vrr_stack+73503, vrr_stack+180779, vrr_stack+130919, vrr_stack+162683);
 _BUILD_n0q0(Data,vrr_stack+180779, vrr_stack+191426, vrr_stack+43551, vrr_stack+148253, vrr_stack+187331, vrr_stack+166193);
 _BUILD_n0q0(Data,vrr_stack+162683, vrr_stack+8046, vrr_stack+191426, vrr_stack+21, vrr_stack+148253, vrr_stack+158393);
   tmp = vrr_stack + 162683;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0i0(Data,vrr_stack+43551, vrr_stack+37203, vrr_stack+19956, vrr_stack+17044, vrr_stack+32863, vrr_stack+23077);
   tmp = vrr_stack + 43551;
   target_ptr = Libint->vrr_classes[11][6];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0k0(Data,vrr_stack+45735, vrr_stack+34403, vrr_stack+55827, vrr_stack+27367, vrr_stack+48627, vrr_stack+19956);
   tmp = vrr_stack + 45735;
   target_ptr = Libint->vrr_classes[11][7];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0l0(Data,vrr_stack+48543, vrr_stack+52227, vrr_stack+78373, vrr_stack+41076, vrr_stack+71028, vrr_stack+55827);
   tmp = vrr_stack + 48543;
   target_ptr = Libint->vrr_classes[11][8];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0m0(Data,vrr_stack+52053, vrr_stack+106037, vrr_stack+102407, vrr_stack+61073, vrr_stack+95368, vrr_stack+78373);
   tmp = vrr_stack + 52053;
   target_ptr = Libint->vrr_classes[11][9];
   for(i=0;i<4290;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0n0(Data,vrr_stack+106037, vrr_stack+138905, vrr_stack+134549, vrr_stack+86755, vrr_stack+127289, vrr_stack+102407);
   tmp = vrr_stack + 106037;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0o0(Data,vrr_stack+138905, vrr_stack+175631, vrr_stack+170483, vrr_stack+111227, vrr_stack+158393, vrr_stack+134549);
   tmp = vrr_stack + 138905;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0q0(Data,vrr_stack+144989, vrr_stack+162683, vrr_stack+180779, vrr_stack+8046, vrr_stack+191426, vrr_stack+170483);
   tmp = vrr_stack + 144989;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];

}

