/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_00hg(Libr12_t *, prim_data *);

  /* Computes (00|hg) integrals for linear R12-methods */

void hrr_grt_order_00hg(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[1][5] = int_stack + 0;
 Libr12->t2vrr_classes[0][5] = int_stack + 63;
 Libr12->gvrr_classes[1][6] = int_stack + 84;
 Libr12->t2vrr_classes[0][6] = int_stack + 168;
 Libr12->gvrr_classes[1][7] = int_stack + 196;
 Libr12->t2vrr_classes[0][7] = int_stack + 304;
 Libr12->gvrr_classes[1][8] = int_stack + 340;
 Libr12->t2vrr_classes[0][8] = int_stack + 475;
 Libr12->t2vrr_classes[0][9] = int_stack + 520;
 Libr12->t1vrr_classes[0][5] = int_stack + 575;
 Libr12->t1vrr_classes[0][6] = int_stack + 596;
 Libr12->t1vrr_classes[0][7] = int_stack + 624;
 Libr12->t1vrr_classes[0][8] = int_stack + 660;
 Libr12->t1vrr_classes[0][9] = int_stack + 705;
 Libr12->rvrr_classes[0][5] = int_stack + 760;
 Libr12->rvrr_classes[0][6] = int_stack + 781;
 Libr12->rvrr_classes[0][7] = int_stack + 809;
 Libr12->rvrr_classes[0][8] = int_stack + 845;
 Libr12->rvrr_classes[0][9] = int_stack + 890;
 Libr12->gvrr_classes[0][5] = int_stack + 945;
 Libr12->gvrr_classes[0][6] = int_stack + 966;
 Libr12->gvrr_classes[0][7] = int_stack + 994;
 Libr12->gvrr_classes[0][8] = int_stack + 1030;
 Libr12->gvrr_classes[0][9] = int_stack + 1075;
 memset(int_stack,0,1130*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 1130;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_00hg(Libr12, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1130, int_stack+966, int_stack+945, 1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1193, int_stack+994, int_stack+966, 1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1277, int_stack+1193, int_stack+1130, 1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1403, int_stack+1030, int_stack+994, 1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1511, int_stack+1403, int_stack+1193, 1);
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1679, int_stack+1511, int_stack+1277, 1);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1889, int_stack+84, int_stack+0, 3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2078, int_stack+196, int_stack+84, 3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+2330, int_stack+2078, int_stack+1889, 3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+2708, int_stack+340, int_stack+196, 3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+3032, int_stack+2708, int_stack+2078, 3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+3536, int_stack+3032, int_stack+2330, 3);
 /*--- compute (00|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+4166, int_stack+1075, int_stack+1030, 1);
 /*--- compute (00|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+4301, int_stack+4166, int_stack+1403, 1);
 /*--- compute (00|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+4517, int_stack+4301, int_stack+1511, 1);
 /*--- compute (00|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4797, int_stack+168, int_stack+63, int_stack+966, int_stack+0, int_stack+945, 0, 0);
 /*--- compute (00|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+304, int_stack+168, int_stack+994, int_stack+84, int_stack+966, 0, 0);
 /*--- compute (00|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4860, int_stack+0, int_stack+4797, int_stack+1193, int_stack+1889, int_stack+1130, 0, 0);
 /*--- compute (00|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1889, int_stack+475, int_stack+304, int_stack+1030, int_stack+196, int_stack+994, 0, 0);
 /*--- compute (00|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+84, int_stack+1889, int_stack+0, int_stack+1403, int_stack+2078, int_stack+1193, 0, 0);
 /*--- compute (00|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1997, int_stack+84, int_stack+4860, int_stack+1511, int_stack+2330, int_stack+1277, 0, 0);
 /*--- compute (00|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1130, int_stack+520, int_stack+475, int_stack+1075, int_stack+340, int_stack+1030, 0, 0);
 /*--- compute (00|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+2207, int_stack+1130, int_stack+1889, int_stack+4166, int_stack+2708, int_stack+1403, 0, 0);
 /*--- compute (00|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+2423, int_stack+2207, int_stack+84, int_stack+4301, int_stack+3032, int_stack+1511, 0, 0);
 /*--- compute (00|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+2207, int_stack+596, int_stack+575, 1);
 /*--- compute (00|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2270, int_stack+624, int_stack+596, 1);
 /*--- compute (00|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+4166, int_stack+2270, int_stack+2207, 1);
 /*--- compute (00|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1889, int_stack+660, int_stack+624, 1);
 /*--- compute (00|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+4292, int_stack+1889, int_stack+2270, 1);
 /*--- compute (00|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+2207, int_stack+4292, int_stack+4166, 1);
 /*--- compute (00|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+705, int_stack+660, 1);
 /*--- compute (00|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+135, int_stack+0, int_stack+1889, 1);
 /*--- compute (00|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+351, int_stack+135, int_stack+4292, 1);
 /*--- compute (00||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1889, int_stack+781, int_stack+760, 1);
 /*--- compute (00||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+0, int_stack+809, int_stack+781, 1);
 /*--- compute (00||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+84, int_stack+0, int_stack+1889, 1);
 /*--- compute (00||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1889, int_stack+845, int_stack+809, 1);
 /*--- compute (00||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+4166, int_stack+1889, int_stack+0, 1);
 /*--- compute (00||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+631, int_stack+4166, int_stack+84, 1);
 /*--- compute (00||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+890, int_stack+845, 1);
 /*--- compute (00||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+135, int_stack+0, int_stack+1889, 1);
 /*--- compute (00||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+841, int_stack+135, int_stack+4166, 1);
 /*--- compute (00|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4166, int_stack+2423, int_stack+1997, int_stack+4517, int_stack+3536, int_stack+1679, 0, 0);
     Libr12->te_ptr[3] = int_stack + 4166;
 /*--- compute (00|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1889, int_stack+351, int_stack+2207, 1);
     Libr12->te_ptr[2] = int_stack + 1889;
 /*--- compute (00||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+2204, int_stack+841, int_stack+631, 1);
     Libr12->te_ptr[1] = int_stack + 2204;
 /*--- compute (00|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+2519, int_stack+4517, int_stack+1679, 1);
     Libr12->te_ptr[0] = int_stack + 2519;

}
