/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_ffff(Libr12_t *, prim_data *);

  /* Computes (ff|ff) integrals for linear R12-methods */

void hrr_grt_order_ffff(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[3][3] = int_stack + 0;
 Libr12->t2vrr_classes[3][4] = int_stack + 100;
 Libr12->t2vrr_classes[3][5] = int_stack + 250;
 Libr12->t2vrr_classes[3][6] = int_stack + 460;
 Libr12->t2vrr_classes[4][3] = int_stack + 740;
 Libr12->t2vrr_classes[4][4] = int_stack + 890;
 Libr12->t2vrr_classes[4][5] = int_stack + 1115;
 Libr12->t2vrr_classes[4][6] = int_stack + 1430;
 Libr12->t2vrr_classes[5][3] = int_stack + 1850;
 Libr12->t2vrr_classes[5][4] = int_stack + 2060;
 Libr12->t2vrr_classes[5][5] = int_stack + 2375;
 Libr12->t2vrr_classes[5][6] = int_stack + 2816;
 Libr12->gvrr_classes[7][3] = int_stack + 3404;
 Libr12->t2vrr_classes[6][3] = int_stack + 3764;
 Libr12->gvrr_classes[7][4] = int_stack + 4044;
 Libr12->t2vrr_classes[6][4] = int_stack + 4584;
 Libr12->gvrr_classes[7][5] = int_stack + 5004;
 Libr12->t2vrr_classes[6][5] = int_stack + 5760;
 Libr12->t2vrr_classes[6][6] = int_stack + 6348;
 Libr12->gvrr_classes[3][7] = int_stack + 7132;
 Libr12->t1vrr_classes[3][3] = int_stack + 7492;
 Libr12->t1vrr_classes[3][4] = int_stack + 7592;
 Libr12->t1vrr_classes[3][5] = int_stack + 7742;
 Libr12->t1vrr_classes[3][6] = int_stack + 7952;
 Libr12->gvrr_classes[4][7] = int_stack + 8232;
 Libr12->t1vrr_classes[4][3] = int_stack + 8772;
 Libr12->t1vrr_classes[4][4] = int_stack + 8922;
 Libr12->t1vrr_classes[4][5] = int_stack + 9147;
 Libr12->t1vrr_classes[4][6] = int_stack + 9462;
 Libr12->gvrr_classes[5][7] = int_stack + 9882;
 Libr12->t1vrr_classes[5][3] = int_stack + 10638;
 Libr12->t1vrr_classes[5][4] = int_stack + 10848;
 Libr12->t1vrr_classes[5][5] = int_stack + 11163;
 Libr12->t1vrr_classes[5][6] = int_stack + 11604;
 Libr12->t1vrr_classes[6][3] = int_stack + 12192;
 Libr12->t1vrr_classes[6][4] = int_stack + 12472;
 Libr12->t1vrr_classes[6][5] = int_stack + 12892;
 Libr12->t1vrr_classes[6][6] = int_stack + 13480;
 Libr12->rvrr_classes[3][3] = int_stack + 14264;
 Libr12->rvrr_classes[3][4] = int_stack + 14364;
 Libr12->rvrr_classes[3][5] = int_stack + 14514;
 Libr12->rvrr_classes[3][6] = int_stack + 14724;
 Libr12->rvrr_classes[4][3] = int_stack + 15004;
 Libr12->rvrr_classes[4][4] = int_stack + 15154;
 Libr12->rvrr_classes[4][5] = int_stack + 15379;
 Libr12->rvrr_classes[4][6] = int_stack + 15694;
 Libr12->rvrr_classes[5][3] = int_stack + 16114;
 Libr12->rvrr_classes[5][4] = int_stack + 16324;
 Libr12->rvrr_classes[5][5] = int_stack + 16639;
 Libr12->rvrr_classes[5][6] = int_stack + 17080;
 Libr12->rvrr_classes[6][3] = int_stack + 17668;
 Libr12->rvrr_classes[6][4] = int_stack + 17948;
 Libr12->rvrr_classes[6][5] = int_stack + 18368;
 Libr12->rvrr_classes[6][6] = int_stack + 18956;
 Libr12->gvrr_classes[3][3] = int_stack + 19740;
 Libr12->gvrr_classes[3][4] = int_stack + 19840;
 Libr12->gvrr_classes[3][5] = int_stack + 19990;
 Libr12->gvrr_classes[3][6] = int_stack + 20200;
 Libr12->gvrr_classes[4][3] = int_stack + 20480;
 Libr12->gvrr_classes[4][4] = int_stack + 20630;
 Libr12->gvrr_classes[4][5] = int_stack + 20855;
 Libr12->gvrr_classes[4][6] = int_stack + 21170;
 Libr12->gvrr_classes[5][3] = int_stack + 21590;
 Libr12->gvrr_classes[5][4] = int_stack + 21800;
 Libr12->gvrr_classes[5][5] = int_stack + 22115;
 Libr12->gvrr_classes[5][6] = int_stack + 22556;
 Libr12->gvrr_classes[6][3] = int_stack + 23144;
 Libr12->gvrr_classes[6][4] = int_stack + 23424;
 Libr12->gvrr_classes[6][5] = int_stack + 23844;
 Libr12->gvrr_classes[6][6] = int_stack + 24432;
 memset(int_stack,0,25216*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 25216;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_ffff(Libr12, Data);
   Data++;
 }

 /*--- compute (f0|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+25216, int_stack+19840, int_stack+19740, 10);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+25516, int_stack+19990, int_stack+19840, 10);
 /*--- compute (f0|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+25966, int_stack+25516, int_stack+25216, 10);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+26566, int_stack+20630, int_stack+20480, 15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+27016, int_stack+20855, int_stack+20630, 15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+27691, int_stack+27016, int_stack+26566, 15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+28591, int_stack+20200, int_stack+19990, 10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+29221, int_stack+28591, int_stack+25516, 10);
 /*--- compute (f0|[r12,T2]|fp) ---*/
   t2hrr3_build_fp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+30121, int_stack+100, int_stack+0, int_stack+19840, int_stack+20480, int_stack+19740, 3, 0);
 /*--- compute (f0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+30421, int_stack+250, int_stack+100, int_stack+19990, int_stack+20630, int_stack+19840, 3, 0);
 /*--- compute (f0|[r12,T2]|fd) ---*/
   t2hrr3_build_fd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+30871, int_stack+30421, int_stack+30121, int_stack+25516, int_stack+26566, int_stack+25216, 3, 0);
 /*--- compute (f0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+31471, int_stack+460, int_stack+250, int_stack+20200, int_stack+20855, int_stack+19990, 3, 0);
 /*--- compute (f0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+32101, int_stack+31471, int_stack+30421, int_stack+28591, int_stack+27016, int_stack+25516, 3, 0);
 /*--- compute (f0|[r12,T2]|ff) ---*/
   t2hrr3_build_ff(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+33001, int_stack+32101, int_stack+30871, int_stack+29221, int_stack+27691, int_stack+25966, 3, 0);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+25216, int_stack+21800, int_stack+21590, 21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+30121, int_stack+22115, int_stack+21800, 21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+31066, int_stack+30121, int_stack+25216, 21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+34001, int_stack+21170, int_stack+20855, 15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+34946, int_stack+34001, int_stack+27016, 15);
 /*--- compute (g0|[r12,T2]|fp) ---*/
   t2hrr3_build_fp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+32326, int_stack+890, int_stack+740, int_stack+20630, int_stack+21590, int_stack+20480, 4, 0);
 /*--- compute (g0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+1115, int_stack+890, int_stack+20855, int_stack+21800, int_stack+20630, 4, 0);
 /*--- compute (g0|[r12,T2]|fd) ---*/
   t2hrr3_build_fd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+36296, int_stack+0, int_stack+32326, int_stack+27016, int_stack+25216, int_stack+26566, 4, 0);
 /*--- compute (g0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+37196, int_stack+1430, int_stack+1115, int_stack+21170, int_stack+22115, int_stack+20855, 4, 0);
 /*--- compute (g0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+38141, int_stack+37196, int_stack+0, int_stack+34001, int_stack+30121, int_stack+27016, 4, 0);
 /*--- compute (g0|[r12,T2]|ff) ---*/
   t2hrr3_build_ff(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+38141, int_stack+36296, int_stack+34946, int_stack+31066, int_stack+27691, 4, 0);
 /*--- compute (fp|[r12,T2]|ff) ---*/
   hrr1_build_fp(Libr12->ShellQuartet.AB,int_stack+36296, int_stack+0, int_stack+33001, 100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+26566, int_stack+23424, int_stack+23144, 28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+32326, int_stack+23844, int_stack+23424, 28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+39296, int_stack+32326, int_stack+26566, 28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+40976, int_stack+22556, int_stack+22115, 21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+42299, int_stack+40976, int_stack+30121, 21);
 /*--- compute (h0|[r12,T2]|fp) ---*/
   t2hrr3_build_fp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+20480, int_stack+2060, int_stack+1850, int_stack+21800, int_stack+23144, int_stack+21590, 5, 0);
 /*--- compute (h0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+44189, int_stack+2375, int_stack+2060, int_stack+22115, int_stack+23424, int_stack+21800, 5, 0);
 /*--- compute (h0|[r12,T2]|fd) ---*/
   t2hrr3_build_fd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+45134, int_stack+44189, int_stack+20480, int_stack+30121, int_stack+26566, int_stack+25216, 5, 0);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+46394, int_stack+2816, int_stack+2375, int_stack+22556, int_stack+23844, int_stack+22115, 5, 0);
 /*--- compute (h0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1500, int_stack+46394, int_stack+44189, int_stack+40976, int_stack+32326, int_stack+30121, 5, 0);
 /*--- compute (h0|[r12,T2]|ff) ---*/
   t2hrr3_build_ff(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+46394, int_stack+1500, int_stack+45134, int_stack+42299, int_stack+39296, int_stack+31066, 5, 0);
 /*--- compute (gp|[r12,T2]|ff) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+48494, int_stack+46394, int_stack+0, 100);
 /*--- compute (fd|[r12,T2]|ff) ---*/
   hrr1_build_fd(Libr12->ShellQuartet.AB,int_stack+52994, int_stack+48494, int_stack+36296, 100);
 /*--- compute (k0|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+36296, int_stack+4044, int_stack+3404, 36);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+37376, int_stack+5004, int_stack+4044, 36);
 /*--- compute (k0|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+0, int_stack+37376, int_stack+36296, 36);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+44189, int_stack+24432, int_stack+23844, 28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+58994, int_stack+44189, int_stack+32326, 28);
 /*--- compute (i0|[r12,T2]|fp) ---*/
   t2hrr3_build_fp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+2160, int_stack+4584, int_stack+3764, int_stack+23424, int_stack+3404, int_stack+23144, 6, 0);
 /*--- compute (i0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+61514, int_stack+5760, int_stack+4584, int_stack+23844, int_stack+4044, int_stack+23424, 6, 0);
 /*--- compute (i0|[r12,T2]|fd) ---*/
   t2hrr3_build_fd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+3000, int_stack+61514, int_stack+2160, int_stack+32326, int_stack+36296, int_stack+26566, 6, 0);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+62774, int_stack+6348, int_stack+5760, int_stack+24432, int_stack+5004, int_stack+23844, 6, 0);
 /*--- compute (i0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+23144, int_stack+62774, int_stack+61514, int_stack+44189, int_stack+37376, int_stack+32326, 6, 0);
 /*--- compute (i0|[r12,T2]|ff) ---*/
   t2hrr3_build_ff(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+61514, int_stack+23144, int_stack+3000, int_stack+58994, int_stack+0, int_stack+39296, 6, 0);
 /*--- compute (hp|[r12,T2]|ff) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+0, int_stack+61514, int_stack+46394, 100);
 /*--- compute (gd|[r12,T2]|ff) ---*/
   hrr1_build_gd(Libr12->ShellQuartet.AB,int_stack+61514, int_stack+0, int_stack+48494, 100);
 /*--- compute (f0|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+0, int_stack+29221, int_stack+25966, 10);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+1000, int_stack+34946, int_stack+27691, 15);
 /*--- compute (fp|ff) ---*/
   hrr1_build_fp(Libr12->ShellQuartet.AB,int_stack+36296, int_stack+1000, int_stack+0, 100);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+2500, int_stack+42299, int_stack+31066, 21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+23144, int_stack+2500, int_stack+1000, 100);
 /*--- compute (fd|ff) ---*/
   hrr1_build_fd(Libr12->ShellQuartet.AB,int_stack+44189, int_stack+23144, int_stack+36296, 100);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+4600, int_stack+7132, int_stack+20200, 10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+5440, int_stack+4600, int_stack+28591, 10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+27644, int_stack+5440, int_stack+29221, 10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+4600, int_stack+8232, int_stack+21170, 15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+29144, int_stack+4600, int_stack+34001, 15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+4600, int_stack+29144, int_stack+34946, 15);
 /*--- compute (fp|gf) ---*/
   hrr1_build_fp(Libr12->ShellQuartet.AB,int_stack+29144, int_stack+4600, int_stack+27644, 150);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+33644, int_stack+9882, int_stack+22556, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+50189, int_stack+33644, int_stack+40976, 21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+19740, int_stack+50189, int_stack+42299, 21);
 /*--- compute (gp|gf) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+70514, int_stack+19740, int_stack+4600, 150);
 /*--- compute (fd|gf) ---*/
   hrr1_build_fd(Libr12->ShellQuartet.AB,int_stack+77264, int_stack+70514, int_stack+29144, 150);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+50189, int_stack+58994, int_stack+39296, 28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+86264, int_stack+50189, int_stack+2500, 100);
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libr12->ShellQuartet.AB,int_stack+92564, int_stack+86264, int_stack+23144, 100);
 /*--- compute (f0|[r12,T1]|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+39296, int_stack+7592, int_stack+7492, 10);
 /*--- compute (f0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+39596, int_stack+7742, int_stack+7592, 10);
 /*--- compute (f0|[r12,T1]|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+40046, int_stack+39596, int_stack+39296, 10);
 /*--- compute (f0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+40646, int_stack+7952, int_stack+7742, 10);
 /*--- compute (f0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+41276, int_stack+40646, int_stack+39596, 10);
 /*--- compute (f0|[r12,T1]|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+42176, int_stack+41276, int_stack+40046, 10);
 /*--- compute (g0|[r12,T1]|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+39296, int_stack+8922, int_stack+8772, 15);
 /*--- compute (g0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+39746, int_stack+9147, int_stack+8922, 15);
 /*--- compute (g0|[r12,T1]|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+40421, int_stack+39746, int_stack+39296, 15);
 /*--- compute (g0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+43176, int_stack+9462, int_stack+9147, 15);
 /*--- compute (g0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+58994, int_stack+43176, int_stack+39746, 15);
 /*--- compute (g0|[r12,T1]|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+33644, int_stack+58994, int_stack+40421, 15);
 /*--- compute (fp|[r12,T1]|ff) ---*/
   t1hrr1_build_fp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+6850, int_stack+33644, int_stack+42176, int_stack+1000, int_stack+27644, int_stack+0, 3, 3);
 /*--- compute (h0|[r12,T1]|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+10848, int_stack+10638, 21);
 /*--- compute (h0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+27644, int_stack+11163, int_stack+10848, 21);
 /*--- compute (h0|[r12,T1]|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+58994, int_stack+27644, int_stack+0, 21);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+39296, int_stack+11604, int_stack+11163, 21);
 /*--- compute (h0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+40619, int_stack+39296, int_stack+27644, 21);
 /*--- compute (h0|[r12,T1]|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+9850, int_stack+40619, int_stack+58994, 21);
 /*--- compute (gp|[r12,T1]|ff) ---*/
   t1hrr1_build_gp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+39296, int_stack+9850, int_stack+33644, int_stack+2500, int_stack+4600, int_stack+1000, 3, 3);
 /*--- compute (fd|[r12,T1]|ff) ---*/
   t1hrr1_build_fd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+101564, int_stack+39296, int_stack+6850, int_stack+23144, int_stack+29144, int_stack+36296, 3, 3);
 /*--- compute (i0|[r12,T1]|fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+4600, int_stack+12472, int_stack+12192, 28);
 /*--- compute (i0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+5440, int_stack+12892, int_stack+12472, 28);
 /*--- compute (i0|[r12,T1]|fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+6700, int_stack+5440, int_stack+4600, 28);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+58994, int_stack+13480, int_stack+12892, 28);
 /*--- compute (i0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+27644, int_stack+58994, int_stack+5440, 28);
 /*--- compute (i0|[r12,T1]|ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+30164, int_stack+27644, int_stack+6700, 28);
 /*--- compute (hp|[r12,T1]|ff) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+32964, int_stack+30164, int_stack+9850, int_stack+50189, int_stack+19740, int_stack+2500, 3, 3);
 /*--- compute (gd|[r12,T1]|ff) ---*/
   t1hrr1_build_gd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+0, int_stack+32964, int_stack+39296, int_stack+86264, int_stack+70514, int_stack+23144, 3, 3);
 /*--- compute (f0||fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+70514, int_stack+14364, int_stack+14264, 10);
 /*--- compute (f0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+70814, int_stack+14514, int_stack+14364, 10);
 /*--- compute (f0||fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+71264, int_stack+70814, int_stack+70514, 10);
 /*--- compute (f0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+71864, int_stack+14724, int_stack+14514, 10);
 /*--- compute (f0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+72494, int_stack+71864, int_stack+70814, 10);
 /*--- compute (f0||ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+73394, int_stack+72494, int_stack+71264, 10);
 /*--- compute (g0||fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+70514, int_stack+15154, int_stack+15004, 15);
 /*--- compute (g0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+70964, int_stack+15379, int_stack+15154, 15);
 /*--- compute (g0||fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+71639, int_stack+70964, int_stack+70514, 15);
 /*--- compute (g0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+74394, int_stack+15694, int_stack+15379, 15);
 /*--- compute (g0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+75339, int_stack+74394, int_stack+70964, 15);
 /*--- compute (g0||ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+86264, int_stack+75339, int_stack+71639, 15);
 /*--- compute (fp||ff) ---*/
   hrr1_build_fp(Libr12->ShellQuartet.AB,int_stack+87764, int_stack+86264, int_stack+73394, 100);
 /*--- compute (h0||fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+70514, int_stack+16324, int_stack+16114, 21);
 /*--- compute (h0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+71144, int_stack+16639, int_stack+16324, 21);
 /*--- compute (h0||fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+72089, int_stack+71144, int_stack+70514, 21);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+73349, int_stack+17080, int_stack+16639, 21);
 /*--- compute (h0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+74672, int_stack+73349, int_stack+71144, 21);
 /*--- compute (h0||ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+19740, int_stack+74672, int_stack+72089, 21);
 /*--- compute (gp||ff) ---*/
   hrr1_build_gp(Libr12->ShellQuartet.AB,int_stack+70514, int_stack+19740, int_stack+86264, 100);
 /*--- compute (fd||ff) ---*/
   hrr1_build_fd(Libr12->ShellQuartet.AB,int_stack+21840, int_stack+70514, int_stack+87764, 100);
 /*--- compute (i0||fp) ---*/
   hrr3_build_fp(Libr12->ShellQuartet.CD,int_stack+86264, int_stack+17948, int_stack+17668, 28);
 /*--- compute (i0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+87104, int_stack+18368, int_stack+17948, 28);
 /*--- compute (i0||fd) ---*/
   hrr3_build_fd(Libr12->ShellQuartet.CD,int_stack+88364, int_stack+87104, int_stack+86264, 28);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+90044, int_stack+18956, int_stack+18368, 28);
 /*--- compute (i0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+58994, int_stack+90044, int_stack+87104, 28);
 /*--- compute (i0||ff) ---*/
   hrr3_build_ff(Libr12->ShellQuartet.CD,int_stack+27840, int_stack+58994, int_stack+88364, 28);
 /*--- compute (hp||ff) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+86264, int_stack+27840, int_stack+19740, 100);
 /*--- compute (gd||ff) ---*/
   hrr1_build_gd(Libr12->ShellQuartet.AB,int_stack+27840, int_stack+86264, int_stack+70514, 100);
 /*--- compute (ff|[r12,T2]|ff) ---*/
   hrr1_build_ff(Libr12->ShellQuartet.AB,int_stack+9000, int_stack+61514, int_stack+52994, 100);
     Libr12->te_ptr[3] = int_stack + 9000;
 /*--- compute (ff|[r12,T1]|ff) ---*/
   t1hrr1_build_ff(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+50189, int_stack+0, int_stack+101564, int_stack+92564, int_stack+77264, int_stack+44189, 3, 3);
     Libr12->te_ptr[2] = int_stack + 50189;
 /*--- compute (ff||ff) ---*/
   hrr1_build_ff(Libr12->ShellQuartet.AB,int_stack+60189, int_stack+27840, int_stack+21840, 100);
     Libr12->te_ptr[1] = int_stack + 60189;
 /*--- compute (ff|ff) ---*/
   hrr1_build_ff(Libr12->ShellQuartet.AB,int_stack+70189, int_stack+92564, int_stack+44189, 100);
     Libr12->te_ptr[0] = int_stack + 70189;

}
