/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_g0gp(Libr12_t *, prim_data *);

  /* Computes (g0|gp) integrals for linear R12-methods */

void hrr_grt_order_g0gp(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[5][4] = int_stack + 0;
 Libr12->t2vrr_classes[4][4] = int_stack + 315;
 Libr12->t2vrr_classes[4][5] = int_stack + 540;
 Libr12->t1vrr_classes[4][4] = int_stack + 855;
 Libr12->t1vrr_classes[4][5] = int_stack + 1080;
 Libr12->rvrr_classes[4][4] = int_stack + 1395;
 Libr12->rvrr_classes[4][5] = int_stack + 1620;
 Libr12->gvrr_classes[4][4] = int_stack + 1935;
 Libr12->gvrr_classes[4][5] = int_stack + 2160;
 memset(int_stack,0,2475*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 2475;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_g0gp(Libr12, Data);
   Data++;
 }

 /*--- compute (g0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+2475, int_stack+540, int_stack+315, int_stack+2160, int_stack+0, int_stack+1935, 4, 0);
     Libr12->te_ptr[3] = int_stack + 2475;
 /*--- compute (g0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+1080, int_stack+855, 15);
     Libr12->te_ptr[2] = int_stack + 0;
 /*--- compute (g0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+675, int_stack+1620, int_stack+1395, 15);
     Libr12->te_ptr[1] = int_stack + 675;
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+3150, int_stack+2160, int_stack+1935, 15);
     Libr12->te_ptr[0] = int_stack + 3150;

}
