/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_hpgg(Libr12_t *, prim_data *);

  /* Computes (hp|gg) integrals for linear R12-methods */

void hrr_grt_order_hpgg(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[5][4] = int_stack + 0;
 Libr12->t2vrr_classes[5][5] = int_stack + 315;
 Libr12->t2vrr_classes[5][6] = int_stack + 756;
 Libr12->t2vrr_classes[5][7] = int_stack + 1344;
 Libr12->t2vrr_classes[5][8] = int_stack + 2100;
 Libr12->gvrr_classes[7][4] = int_stack + 3045;
 Libr12->t2vrr_classes[6][4] = int_stack + 3585;
 Libr12->gvrr_classes[7][5] = int_stack + 4005;
 Libr12->t2vrr_classes[6][5] = int_stack + 4761;
 Libr12->gvrr_classes[7][6] = int_stack + 5349;
 Libr12->t2vrr_classes[6][6] = int_stack + 6357;
 Libr12->gvrr_classes[7][7] = int_stack + 7141;
 Libr12->t2vrr_classes[6][7] = int_stack + 8437;
 Libr12->t2vrr_classes[6][8] = int_stack + 9445;
 Libr12->gvrr_classes[5][9] = int_stack + 10705;
 Libr12->t1vrr_classes[5][4] = int_stack + 11860;
 Libr12->t1vrr_classes[5][5] = int_stack + 12175;
 Libr12->t1vrr_classes[5][6] = int_stack + 12616;
 Libr12->t1vrr_classes[5][7] = int_stack + 13204;
 Libr12->t1vrr_classes[5][8] = int_stack + 13960;
 Libr12->t1vrr_classes[6][4] = int_stack + 14905;
 Libr12->t1vrr_classes[6][5] = int_stack + 15325;
 Libr12->t1vrr_classes[6][6] = int_stack + 15913;
 Libr12->t1vrr_classes[6][7] = int_stack + 16697;
 Libr12->t1vrr_classes[6][8] = int_stack + 17705;
 Libr12->rvrr_classes[5][4] = int_stack + 18965;
 Libr12->rvrr_classes[5][5] = int_stack + 19280;
 Libr12->rvrr_classes[5][6] = int_stack + 19721;
 Libr12->rvrr_classes[5][7] = int_stack + 20309;
 Libr12->rvrr_classes[5][8] = int_stack + 21065;
 Libr12->rvrr_classes[6][4] = int_stack + 22010;
 Libr12->rvrr_classes[6][5] = int_stack + 22430;
 Libr12->rvrr_classes[6][6] = int_stack + 23018;
 Libr12->rvrr_classes[6][7] = int_stack + 23802;
 Libr12->rvrr_classes[6][8] = int_stack + 24810;
 Libr12->gvrr_classes[5][4] = int_stack + 26070;
 Libr12->gvrr_classes[5][5] = int_stack + 26385;
 Libr12->gvrr_classes[5][6] = int_stack + 26826;
 Libr12->gvrr_classes[5][7] = int_stack + 27414;
 Libr12->gvrr_classes[5][8] = int_stack + 28170;
 Libr12->gvrr_classes[6][4] = int_stack + 29115;
 Libr12->gvrr_classes[6][5] = int_stack + 29535;
 Libr12->gvrr_classes[6][6] = int_stack + 30123;
 Libr12->gvrr_classes[6][7] = int_stack + 30907;
 Libr12->gvrr_classes[6][8] = int_stack + 31915;
 memset(int_stack,0,33175*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 33175;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_hpgg(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+33175, int_stack+26385, int_stack+26070, 21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+34120, int_stack+26826, int_stack+26385, 21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+35443, int_stack+34120, int_stack+33175, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+37333, int_stack+27414, int_stack+26826, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+39097, int_stack+37333, int_stack+34120, 21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+41743, int_stack+39097, int_stack+35443, 21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+44893, int_stack+29535, int_stack+29115, 28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+46153, int_stack+30123, int_stack+29535, 28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+47917, int_stack+46153, int_stack+44893, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+50437, int_stack+30907, int_stack+30123, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+52789, int_stack+50437, int_stack+46153, 28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+56317, int_stack+52789, int_stack+47917, 28);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+60517, int_stack+28170, int_stack+27414, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+62785, int_stack+60517, int_stack+37333, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+66313, int_stack+62785, int_stack+39097, 21);
 /*--- compute (h0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+70723, int_stack+315, int_stack+0, int_stack+26385, int_stack+29115, int_stack+26070, 5, 0);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+71668, int_stack+756, int_stack+315, int_stack+26826, int_stack+29535, int_stack+26385, 5, 0);
 /*--- compute (h0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+72991, int_stack+71668, int_stack+70723, int_stack+34120, int_stack+44893, int_stack+33175, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+74881, int_stack+1344, int_stack+756, int_stack+27414, int_stack+30123, int_stack+26826, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+76645, int_stack+74881, int_stack+71668, int_stack+37333, int_stack+46153, int_stack+34120, 5, 0);
 /*--- compute (h0|[r12,T2]|gf) ---*/
   t2hrr3_build_gf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+79291, int_stack+76645, int_stack+72991, int_stack+39097, int_stack+47917, int_stack+35443, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+33175, int_stack+2100, int_stack+1344, int_stack+28170, int_stack+30907, int_stack+27414, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+70723, int_stack+33175, int_stack+74881, int_stack+60517, int_stack+50437, int_stack+37333, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+33175, int_stack+70723, int_stack+76645, int_stack+62785, int_stack+52789, int_stack+39097, 5, 0);
 /*--- compute (h0|[r12,T2]|gg) ---*/
   t2hrr3_build_gg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+70723, int_stack+33175, int_stack+79291, int_stack+66313, int_stack+56317, int_stack+41743, 5, 0);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+33175, int_stack+4005, int_stack+3045, 36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+34795, int_stack+5349, int_stack+4005, 36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+37063, int_stack+34795, int_stack+33175, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+75448, int_stack+7141, int_stack+5349, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+78472, int_stack+75448, int_stack+34795, 36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+83008, int_stack+78472, int_stack+37063, 36);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+31915, int_stack+30907, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+88408, int_stack+0, int_stack+50437, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+93112, int_stack+88408, int_stack+52789, 28);
 /*--- compute (i0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+40303, int_stack+4761, int_stack+3585, int_stack+29535, int_stack+3045, int_stack+29115, 6, 0);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+26070, int_stack+6357, int_stack+4761, int_stack+30123, int_stack+4005, int_stack+29535, 6, 0);
 /*--- compute (i0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+98992, int_stack+26070, int_stack+40303, int_stack+46153, int_stack+33175, int_stack+44893, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+101512, int_stack+8437, int_stack+6357, int_stack+30907, int_stack+5349, int_stack+30123, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+3024, int_stack+101512, int_stack+26070, int_stack+50437, int_stack+34795, int_stack+46153, 6, 0);
 /*--- compute (i0|[r12,T2]|gf) ---*/
   t2hrr3_build_gf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+103864, int_stack+3024, int_stack+98992, int_stack+52789, int_stack+37063, int_stack+47917, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+44893, int_stack+9445, int_stack+8437, int_stack+31915, int_stack+7141, int_stack+30907, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+29115, int_stack+44893, int_stack+101512, int_stack+0, int_stack+75448, int_stack+50437, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+44893, int_stack+29115, int_stack+3024, int_stack+88408, int_stack+78472, int_stack+52789, 6, 0);
 /*--- compute (i0|[r12,T2]|gg) ---*/
   t2hrr3_build_gg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+29115, int_stack+44893, int_stack+103864, int_stack+93112, int_stack+83008, int_stack+56317, 6, 0);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+44893, int_stack+66313, int_stack+41743, 21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+49618, int_stack+10705, int_stack+28170, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+35415, int_stack+49618, int_stack+60517, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+49618, int_stack+35415, int_stack+62785, 21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+35415, int_stack+49618, int_stack+66313, 21);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+49618, int_stack+93112, int_stack+56317, 28);
 /*--- compute (h0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+12175, int_stack+11860, 21);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+56863, int_stack+12616, int_stack+12175, 21);
 /*--- compute (h0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+58186, int_stack+56863, int_stack+55918, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+60076, int_stack+13204, int_stack+12616, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+61840, int_stack+60076, int_stack+56863, 21);
 /*--- compute (h0|[r12,T1]|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+64486, int_stack+61840, int_stack+58186, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+13960, int_stack+13204, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+75448, int_stack+55918, int_stack+60076, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+75448, int_stack+61840, 21);
 /*--- compute (h0|[r12,T1]|gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+75448, int_stack+55918, int_stack+64486, 21);
 /*--- compute (i0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+15325, int_stack+14905, 28);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+57178, int_stack+15913, int_stack+15325, 28);
 /*--- compute (i0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+58942, int_stack+57178, int_stack+55918, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+61462, int_stack+16697, int_stack+15913, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+63814, int_stack+61462, int_stack+57178, 28);
 /*--- compute (i0|[r12,T1]|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+80173, int_stack+63814, int_stack+58942, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+17705, int_stack+16697, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+84373, int_stack+55918, int_stack+61462, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+84373, int_stack+63814, 28);
 /*--- compute (i0|[r12,T1]|gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+84373, int_stack+55918, int_stack+80173, 28);
 /*--- compute (h0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+80173, int_stack+19280, int_stack+18965, 21);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+81118, int_stack+19721, int_stack+19280, 21);
 /*--- compute (h0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+82441, int_stack+81118, int_stack+80173, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+20309, int_stack+19721, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+57682, int_stack+55918, int_stack+81118, 21);
 /*--- compute (h0||gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+60328, int_stack+57682, int_stack+82441, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+80173, int_stack+21065, int_stack+20309, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+63478, int_stack+80173, int_stack+55918, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+90673, int_stack+63478, int_stack+57682, 21);
 /*--- compute (h0||gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+63478, int_stack+90673, int_stack+60328, 21);
 /*--- compute (i0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+90673, int_stack+22430, int_stack+22010, 28);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+91933, int_stack+23018, int_stack+22430, 28);
 /*--- compute (i0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+68203, int_stack+91933, int_stack+90673, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+93697, int_stack+23802, int_stack+23018, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+96049, int_stack+93697, int_stack+91933, 28);
 /*--- compute (i0||gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+80173, int_stack+96049, int_stack+68203, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+90673, int_stack+24810, int_stack+23802, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+99577, int_stack+90673, int_stack+93697, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+55918, int_stack+99577, int_stack+96049, 28);
 /*--- compute (i0||gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+90673, int_stack+55918, int_stack+80173, 28);
 /*--- compute (hp|[r12,T2]|gg) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+0, int_stack+29115, int_stack+70723, 225);
     Libr12->te_ptr[3] = int_stack + 0;
 /*--- compute (hp|[r12,T1]|gg) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+14175, int_stack+84373, int_stack+75448, int_stack+49618, int_stack+35415, int_stack+44893, 4, 4);
     Libr12->te_ptr[2] = int_stack + 14175;
 /*--- compute (hp||gg) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+68203, int_stack+90673, int_stack+63478, 225);
     Libr12->te_ptr[1] = int_stack + 68203;
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+82378, int_stack+49618, int_stack+44893, 225);
     Libr12->te_ptr[0] = int_stack + 82378;

}
