/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_p0gd(Libr12_t *, prim_data *);

  /* Computes (p0|gd) integrals for linear R12-methods */

void hrr_grt_order_p0gd(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[2][4] = int_stack + 0;
 Libr12->t2vrr_classes[1][4] = int_stack + 90;
 Libr12->gvrr_classes[2][5] = int_stack + 135;
 Libr12->t2vrr_classes[1][5] = int_stack + 261;
 Libr12->t2vrr_classes[1][6] = int_stack + 324;
 Libr12->t1vrr_classes[1][4] = int_stack + 408;
 Libr12->t1vrr_classes[1][5] = int_stack + 453;
 Libr12->t1vrr_classes[1][6] = int_stack + 516;
 Libr12->rvrr_classes[1][4] = int_stack + 600;
 Libr12->rvrr_classes[1][5] = int_stack + 645;
 Libr12->rvrr_classes[1][6] = int_stack + 708;
 Libr12->gvrr_classes[1][4] = int_stack + 792;
 Libr12->gvrr_classes[1][5] = int_stack + 837;
 Libr12->gvrr_classes[1][6] = int_stack + 900;
 memset(int_stack,0,984*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 984;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_p0gd(Libr12, Data);
   Data++;
 }

 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+984, int_stack+837, int_stack+792, 3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+1119, int_stack+135, int_stack+0, 6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1389, int_stack+900, int_stack+837, 3);
 /*--- compute (p0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1578, int_stack+261, int_stack+90, int_stack+837, int_stack+0, int_stack+792, 1, 0);
 /*--- compute (p0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+1713, int_stack+324, int_stack+261, int_stack+900, int_stack+135, int_stack+837, 1, 0);
 /*--- compute (p0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+792, int_stack+453, int_stack+408, 3);
 /*--- compute (p0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+516, int_stack+453, 3);
 /*--- compute (p0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+189, int_stack+645, int_stack+600, 3);
 /*--- compute (p0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+324, int_stack+708, int_stack+645, 3);
 /*--- compute (p0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+513, int_stack+1713, int_stack+1578, int_stack+1389, int_stack+1119, int_stack+984, 1, 0);
     Libr12->te_ptr[3] = int_stack + 513;
 /*--- compute (p0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+1119, int_stack+0, int_stack+792, 3);
     Libr12->te_ptr[2] = int_stack + 1119;
 /*--- compute (p0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+1578, int_stack+324, int_stack+189, 3);
     Libr12->te_ptr[1] = int_stack + 1578;
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+0, int_stack+1389, int_stack+984, 3);
     Libr12->te_ptr[0] = int_stack + 0;

}
