/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_p0gg(Libr12_t *, prim_data *);

  /* Computes (p0|gg) integrals for linear R12-methods */

void hrr_grt_order_p0gg(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->gvrr_classes[2][4] = int_stack + 0;
 Libr12->t2vrr_classes[1][4] = int_stack + 90;
 Libr12->gvrr_classes[2][5] = int_stack + 135;
 Libr12->t2vrr_classes[1][5] = int_stack + 261;
 Libr12->gvrr_classes[2][6] = int_stack + 324;
 Libr12->t2vrr_classes[1][6] = int_stack + 492;
 Libr12->gvrr_classes[2][7] = int_stack + 576;
 Libr12->t2vrr_classes[1][7] = int_stack + 792;
 Libr12->t2vrr_classes[1][8] = int_stack + 900;
 Libr12->t1vrr_classes[1][4] = int_stack + 1035;
 Libr12->t1vrr_classes[1][5] = int_stack + 1080;
 Libr12->t1vrr_classes[1][6] = int_stack + 1143;
 Libr12->t1vrr_classes[1][7] = int_stack + 1227;
 Libr12->t1vrr_classes[1][8] = int_stack + 1335;
 Libr12->rvrr_classes[1][4] = int_stack + 1470;
 Libr12->rvrr_classes[1][5] = int_stack + 1515;
 Libr12->rvrr_classes[1][6] = int_stack + 1578;
 Libr12->rvrr_classes[1][7] = int_stack + 1662;
 Libr12->rvrr_classes[1][8] = int_stack + 1770;
 Libr12->gvrr_classes[1][4] = int_stack + 1905;
 Libr12->gvrr_classes[1][5] = int_stack + 1950;
 Libr12->gvrr_classes[1][6] = int_stack + 2013;
 Libr12->gvrr_classes[1][7] = int_stack + 2097;
 Libr12->gvrr_classes[1][8] = int_stack + 2205;
 memset(int_stack,0,2340*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 2340;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_p0gg(Libr12, Data);
   Data++;
 }

 /*--- compute (p0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+2340, int_stack+1950, int_stack+1905, 3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+2475, int_stack+2013, int_stack+1950, 3);
 /*--- compute (p0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+2664, int_stack+2475, int_stack+2340, 3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2934, int_stack+2097, int_stack+2013, 3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+3186, int_stack+2934, int_stack+2475, 3);
 /*--- compute (p0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+3564, int_stack+3186, int_stack+2664, 3);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+4014, int_stack+135, int_stack+0, 6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+4284, int_stack+324, int_stack+135, 6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+4662, int_stack+4284, int_stack+4014, 6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+5202, int_stack+576, int_stack+324, 6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+5706, int_stack+5202, int_stack+4284, 6);
 /*--- compute (d0|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+6462, int_stack+5706, int_stack+4662, 6);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+7362, int_stack+2205, int_stack+2097, 3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+7686, int_stack+7362, int_stack+2934, 3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+8190, int_stack+7686, int_stack+3186, 3);
 /*--- compute (p0|[r12,T2]|gp) ---*/
   t2hrr3_build_gp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+8820, int_stack+261, int_stack+90, int_stack+1950, int_stack+0, int_stack+1905, 1, 0);
 /*--- compute (p0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+8955, int_stack+492, int_stack+261, int_stack+2013, int_stack+135, int_stack+1950, 1, 0);
 /*--- compute (p0|[r12,T2]|gd) ---*/
   t2hrr3_build_gd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+8955, int_stack+8820, int_stack+2475, int_stack+4014, int_stack+2340, 1, 0);
 /*--- compute (p0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4014, int_stack+792, int_stack+492, int_stack+2097, int_stack+324, int_stack+2013, 1, 0);
 /*--- compute (p0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+9144, int_stack+4014, int_stack+8955, int_stack+2934, int_stack+4284, int_stack+2475, 1, 0);
 /*--- compute (p0|[r12,T2]|gf) ---*/
   t2hrr3_build_gf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+9522, int_stack+9144, int_stack+0, int_stack+3186, int_stack+4662, int_stack+2664, 1, 0);
 /*--- compute (p0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+8820, int_stack+900, int_stack+792, int_stack+2205, int_stack+576, int_stack+2097, 1, 0);
 /*--- compute (p0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+0, int_stack+8820, int_stack+4014, int_stack+7362, int_stack+5202, int_stack+2934, 1, 0);
 /*--- compute (p0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4014, int_stack+0, int_stack+9144, int_stack+7686, int_stack+5706, int_stack+3186, 1, 0);
 /*--- compute (p0|[r12,T1]|gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+1080, int_stack+1035, 3);
 /*--- compute (p0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+135, int_stack+1143, int_stack+1080, 3);
 /*--- compute (p0|[r12,T1]|gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+324, int_stack+135, int_stack+0, 3);
 /*--- compute (p0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+594, int_stack+1227, int_stack+1143, 3);
 /*--- compute (p0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+846, int_stack+594, int_stack+135, 3);
 /*--- compute (p0|[r12,T1]|gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+7362, int_stack+846, int_stack+324, 3);
 /*--- compute (p0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+1335, int_stack+1227, 3);
 /*--- compute (p0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+4644, int_stack+0, int_stack+594, 3);
 /*--- compute (p0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+0, int_stack+4644, int_stack+846, 3);
 /*--- compute (p0||gp) ---*/
   hrr3_build_gp(Libr12->ShellQuartet.CD,int_stack+4644, int_stack+1515, int_stack+1470, 3);
 /*--- compute (p0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+4779, int_stack+1578, int_stack+1515, 3);
 /*--- compute (p0||gd) ---*/
   hrr3_build_gd(Libr12->ShellQuartet.CD,int_stack+4968, int_stack+4779, int_stack+4644, 3);
 /*--- compute (p0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+5238, int_stack+1662, int_stack+1578, 3);
 /*--- compute (p0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+7812, int_stack+5238, int_stack+4779, 3);
 /*--- compute (p0||gf) ---*/
   hrr3_build_gf(Libr12->ShellQuartet.CD,int_stack+5490, int_stack+7812, int_stack+4968, 3);
 /*--- compute (p0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+4644, int_stack+1770, int_stack+1662, 3);
 /*--- compute (p0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+5940, int_stack+4644, int_stack+5238, 3);
 /*--- compute (p0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+4644, int_stack+5940, int_stack+7812, 3);
 /*--- compute (p0|[r12,T2]|gg) ---*/
   t2hrr3_build_gg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+630, int_stack+4014, int_stack+9522, int_stack+8190, int_stack+6462, int_stack+3564, 1, 0);
     Libr12->te_ptr[3] = int_stack + 630;
 /*--- compute (p0|[r12,T1]|gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+5940, int_stack+0, int_stack+7362, 3);
     Libr12->te_ptr[2] = int_stack + 5940;
 /*--- compute (p0||gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+6615, int_stack+4644, int_stack+5490, 3);
     Libr12->te_ptr[1] = int_stack + 6615;
 /*--- compute (p0|gg) ---*/
   hrr3_build_gg(Libr12->ShellQuartet.CD,int_stack+4014, int_stack+8190, int_stack+3564, 3);
     Libr12->te_ptr[0] = int_stack + 4014;

}
