/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (hs||ks) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_h0k0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (fouro2z)*I1[0] - (fouro4zn)*I4[0] - (seveno4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (fouro2z)*I1[1] - (fouro4zn)*I4[1] - (sixo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (fouro2z)*I1[2] - (fouro4zn)*I4[2] - (sixo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (fouro2z)*I1[3] - (fouro4zn)*I4[3] - (fiveo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (fouro2z)*I1[4] - (fouro4zn)*I4[4] - (fiveo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (fouro2z)*I1[5] - (fouro4zn)*I4[5] - (fiveo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (fouro2z)*I1[6] - (fouro4zn)*I4[6] - (fouro4zn)*I5[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (fouro2z)*I1[7] - (fouro4zn)*I4[7] - (fouro4zn)*I5[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (fouro2z)*I1[8] - (fouro4zn)*I4[8] - (fouro4zn)*I5[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (fouro2z)*I1[9] - (fouro4zn)*I4[9] - (fouro4zn)*I5[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (fouro2z)*I1[10] - (fouro4zn)*I4[10] - (threeo4zn)*I5[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (fouro2z)*I1[11] - (fouro4zn)*I4[11] - (threeo4zn)*I5[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (fouro2z)*I1[12] - (fouro4zn)*I4[12] - (threeo4zn)*I5[12];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (fouro2z)*I1[13] - (fouro4zn)*I4[13] - (threeo4zn)*I5[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (fouro2z)*I1[14] - (fouro4zn)*I4[14] - (threeo4zn)*I5[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (fouro2z)*I1[15] - (fouro4zn)*I4[15] - (twoo4zn)*I5[15];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (fouro2z)*I1[16] - (fouro4zn)*I4[16] - (twoo4zn)*I5[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (fouro2z)*I1[17] - (fouro4zn)*I4[17] - (twoo4zn)*I5[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (fouro2z)*I1[18] - (fouro4zn)*I4[18] - (twoo4zn)*I5[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (fouro2z)*I1[19] - (fouro4zn)*I4[19] - (twoo4zn)*I5[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (fouro2z)*I1[20] - (fouro4zn)*I4[20] - (twoo4zn)*I5[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (fouro2z)*I1[21] - (fouro4zn)*I4[21] - (oneo4zn)*I5[21];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (fouro2z)*I1[22] - (fouro4zn)*I4[22] - (oneo4zn)*I5[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (fouro2z)*I1[23] - (fouro4zn)*I4[23] - (oneo4zn)*I5[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (fouro2z)*I1[24] - (fouro4zn)*I4[24] - (oneo4zn)*I5[24];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (fouro2z)*I1[25] - (fouro4zn)*I4[25] - (oneo4zn)*I5[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (fouro2z)*I1[26] - (fouro4zn)*I4[26] - (oneo4zn)*I5[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (fouro2z)*I1[27] - (fouro4zn)*I4[27] - (oneo4zn)*I5[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (fouro2z)*I1[28] - (fouro4zn)*I4[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (fouro2z)*I1[29] - (fouro4zn)*I4[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (fouro2z)*I1[30] - (fouro4zn)*I4[30];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (fouro2z)*I1[31] - (fouro4zn)*I4[31];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (fouro2z)*I1[32] - (fouro4zn)*I4[32];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (fouro2z)*I1[33] - (fouro4zn)*I4[33];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (fouro2z)*I1[34] - (fouro4zn)*I4[34];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (fouro2z)*I1[35] - (fouro4zn)*I4[35];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (threeo2z)*I1[36] - (threeo4zn)*I4[36] - (seveno4zn)*I5[28];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (threeo2z)*I1[37] - (threeo4zn)*I4[37] - (sixo4zn)*I5[29];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (threeo2z)*I1[38] - (threeo4zn)*I4[38] - (sixo4zn)*I5[30];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (threeo2z)*I1[39] - (threeo4zn)*I4[39] - (fiveo4zn)*I5[31];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (threeo2z)*I1[40] - (threeo4zn)*I4[40] - (fiveo4zn)*I5[32];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (threeo2z)*I1[41] - (threeo4zn)*I4[41] - (fiveo4zn)*I5[33];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (threeo2z)*I1[42] - (threeo4zn)*I4[42] - (fouro4zn)*I5[34];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (threeo2z)*I1[43] - (threeo4zn)*I4[43] - (fouro4zn)*I5[35];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (threeo2z)*I1[44] - (threeo4zn)*I4[44] - (fouro4zn)*I5[36];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (threeo2z)*I1[45] - (threeo4zn)*I4[45] - (fouro4zn)*I5[37];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (threeo2z)*I1[46] - (threeo4zn)*I4[46] - (threeo4zn)*I5[38];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (threeo2z)*I1[47] - (threeo4zn)*I4[47] - (threeo4zn)*I5[39];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (threeo2z)*I1[48] - (threeo4zn)*I4[48] - (threeo4zn)*I5[40];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (threeo2z)*I1[49] - (threeo4zn)*I4[49] - (threeo4zn)*I5[41];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (threeo2z)*I1[50] - (threeo4zn)*I4[50] - (threeo4zn)*I5[42];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (threeo2z)*I1[51] - (threeo4zn)*I4[51] - (twoo4zn)*I5[43];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (threeo2z)*I1[52] - (threeo4zn)*I4[52] - (twoo4zn)*I5[44];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (threeo2z)*I1[53] - (threeo4zn)*I4[53] - (twoo4zn)*I5[45];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (threeo2z)*I1[54] - (threeo4zn)*I4[54] - (twoo4zn)*I5[46];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (threeo2z)*I1[55] - (threeo4zn)*I4[55] - (twoo4zn)*I5[47];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (threeo2z)*I1[56] - (threeo4zn)*I4[56] - (twoo4zn)*I5[48];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (threeo2z)*I1[57] - (threeo4zn)*I4[57] - (oneo4zn)*I5[49];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (threeo2z)*I1[58] - (threeo4zn)*I4[58] - (oneo4zn)*I5[50];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (threeo2z)*I1[59] - (threeo4zn)*I4[59] - (oneo4zn)*I5[51];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (threeo2z)*I1[60] - (threeo4zn)*I4[60] - (oneo4zn)*I5[52];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (threeo2z)*I1[61] - (threeo4zn)*I4[61] - (oneo4zn)*I5[53];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (threeo2z)*I1[62] - (threeo4zn)*I4[62] - (oneo4zn)*I5[54];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (threeo2z)*I1[63] - (threeo4zn)*I4[63] - (oneo4zn)*I5[55];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (threeo2z)*I1[64] - (threeo4zn)*I4[64];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (threeo2z)*I1[65] - (threeo4zn)*I4[65];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (threeo2z)*I1[66] - (threeo4zn)*I4[66];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (threeo2z)*I1[67] - (threeo4zn)*I4[67];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (threeo2z)*I1[68] - (threeo4zn)*I4[68];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (threeo2z)*I1[69] - (threeo4zn)*I4[69];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (threeo2z)*I1[70] - (threeo4zn)*I4[70];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (threeo2z)*I1[71] - (threeo4zn)*I4[71];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (threeo2z)*I1[72] - (threeo4zn)*I4[72] - (seveno4zn)*I5[56];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (threeo2z)*I1[73] - (threeo4zn)*I4[73] - (sixo4zn)*I5[57];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (threeo2z)*I1[74] - (threeo4zn)*I4[74] - (sixo4zn)*I5[58];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (threeo2z)*I1[75] - (threeo4zn)*I4[75] - (fiveo4zn)*I5[59];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (threeo2z)*I1[76] - (threeo4zn)*I4[76] - (fiveo4zn)*I5[60];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (threeo2z)*I1[77] - (threeo4zn)*I4[77] - (fiveo4zn)*I5[61];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (threeo2z)*I1[78] - (threeo4zn)*I4[78] - (fouro4zn)*I5[62];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (threeo2z)*I1[79] - (threeo4zn)*I4[79] - (fouro4zn)*I5[63];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (threeo2z)*I1[80] - (threeo4zn)*I4[80] - (fouro4zn)*I5[64];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (threeo2z)*I1[81] - (threeo4zn)*I4[81] - (fouro4zn)*I5[65];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (threeo2z)*I1[82] - (threeo4zn)*I4[82] - (threeo4zn)*I5[66];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (threeo2z)*I1[83] - (threeo4zn)*I4[83] - (threeo4zn)*I5[67];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (threeo2z)*I1[84] - (threeo4zn)*I4[84] - (threeo4zn)*I5[68];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (threeo2z)*I1[85] - (threeo4zn)*I4[85] - (threeo4zn)*I5[69];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (threeo2z)*I1[86] - (threeo4zn)*I4[86] - (threeo4zn)*I5[70];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (threeo2z)*I1[87] - (threeo4zn)*I4[87] - (twoo4zn)*I5[71];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (threeo2z)*I1[88] - (threeo4zn)*I4[88] - (twoo4zn)*I5[72];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (threeo2z)*I1[89] - (threeo4zn)*I4[89] - (twoo4zn)*I5[73];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (threeo2z)*I1[90] - (threeo4zn)*I4[90] - (twoo4zn)*I5[74];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (threeo2z)*I1[91] - (threeo4zn)*I4[91] - (twoo4zn)*I5[75];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (threeo2z)*I1[92] - (threeo4zn)*I4[92] - (twoo4zn)*I5[76];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (threeo2z)*I1[93] - (threeo4zn)*I4[93] - (oneo4zn)*I5[77];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (threeo2z)*I1[94] - (threeo4zn)*I4[94] - (oneo4zn)*I5[78];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (threeo2z)*I1[95] - (threeo4zn)*I4[95] - (oneo4zn)*I5[79];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (threeo2z)*I1[96] - (threeo4zn)*I4[96] - (oneo4zn)*I5[80];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (threeo2z)*I1[97] - (threeo4zn)*I4[97] - (oneo4zn)*I5[81];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (threeo2z)*I1[98] - (threeo4zn)*I4[98] - (oneo4zn)*I5[82];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (threeo2z)*I1[99] - (threeo4zn)*I4[99] - (oneo4zn)*I5[83];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (threeo2z)*I1[100] - (threeo4zn)*I4[100];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (threeo2z)*I1[101] - (threeo4zn)*I4[101];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (threeo2z)*I1[102] - (threeo4zn)*I4[102];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (threeo2z)*I1[103] - (threeo4zn)*I4[103];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (threeo2z)*I1[104] - (threeo4zn)*I4[104];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (threeo2z)*I1[105] - (threeo4zn)*I4[105];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (threeo2z)*I1[106] - (threeo4zn)*I4[106];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (threeo2z)*I1[107] - (threeo4zn)*I4[107];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (twoo2z)*I1[108] - (twoo4zn)*I4[108] - (seveno4zn)*I5[84];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (twoo2z)*I1[109] - (twoo4zn)*I4[109] - (sixo4zn)*I5[85];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (twoo2z)*I1[110] - (twoo4zn)*I4[110] - (sixo4zn)*I5[86];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (twoo2z)*I1[111] - (twoo4zn)*I4[111] - (fiveo4zn)*I5[87];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (twoo2z)*I1[112] - (twoo4zn)*I4[112] - (fiveo4zn)*I5[88];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (twoo2z)*I1[113] - (twoo4zn)*I4[113] - (fiveo4zn)*I5[89];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (twoo2z)*I1[114] - (twoo4zn)*I4[114] - (fouro4zn)*I5[90];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (twoo2z)*I1[115] - (twoo4zn)*I4[115] - (fouro4zn)*I5[91];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (twoo2z)*I1[116] - (twoo4zn)*I4[116] - (fouro4zn)*I5[92];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (twoo2z)*I1[117] - (twoo4zn)*I4[117] - (fouro4zn)*I5[93];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (twoo2z)*I1[118] - (twoo4zn)*I4[118] - (threeo4zn)*I5[94];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (twoo2z)*I1[119] - (twoo4zn)*I4[119] - (threeo4zn)*I5[95];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (twoo2z)*I1[120] - (twoo4zn)*I4[120] - (threeo4zn)*I5[96];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (twoo2z)*I1[121] - (twoo4zn)*I4[121] - (threeo4zn)*I5[97];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (twoo2z)*I1[122] - (twoo4zn)*I4[122] - (threeo4zn)*I5[98];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (twoo2z)*I1[123] - (twoo4zn)*I4[123] - (twoo4zn)*I5[99];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (twoo2z)*I1[124] - (twoo4zn)*I4[124] - (twoo4zn)*I5[100];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (twoo2z)*I1[125] - (twoo4zn)*I4[125] - (twoo4zn)*I5[101];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126]
        + (twoo2z)*I1[126] - (twoo4zn)*I4[126] - (twoo4zn)*I5[102];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127]
        + (twoo2z)*I1[127] - (twoo4zn)*I4[127] - (twoo4zn)*I5[103];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128]
        + (twoo2z)*I1[128] - (twoo4zn)*I4[128] - (twoo4zn)*I5[104];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129]
        + (twoo2z)*I1[129] - (twoo4zn)*I4[129] - (oneo4zn)*I5[105];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130]
        + (twoo2z)*I1[130] - (twoo4zn)*I4[130] - (oneo4zn)*I5[106];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131]
        + (twoo2z)*I1[131] - (twoo4zn)*I4[131] - (oneo4zn)*I5[107];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132]
        + (twoo2z)*I1[132] - (twoo4zn)*I4[132] - (oneo4zn)*I5[108];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133]
        + (twoo2z)*I1[133] - (twoo4zn)*I4[133] - (oneo4zn)*I5[109];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134]
        + (twoo2z)*I1[134] - (twoo4zn)*I4[134] - (oneo4zn)*I5[110];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135]
        + (twoo2z)*I1[135] - (twoo4zn)*I4[135] - (oneo4zn)*I5[111];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136]
        + (twoo2z)*I1[136] - (twoo4zn)*I4[136];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137]
        + (twoo2z)*I1[137] - (twoo4zn)*I4[137];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138]
        + (twoo2z)*I1[138] - (twoo4zn)*I4[138];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139]
        + (twoo2z)*I1[139] - (twoo4zn)*I4[139];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140]
        + (twoo2z)*I1[140] - (twoo4zn)*I4[140];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141]
        + (twoo2z)*I1[141] - (twoo4zn)*I4[141];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142]
        + (twoo2z)*I1[142] - (twoo4zn)*I4[142];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143]
        + (twoo2z)*I1[143] - (twoo4zn)*I4[143];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144]
        + (twoo2z)*I1[144] - (twoo4zn)*I4[144] - (seveno4zn)*I5[112];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145]
        + (twoo2z)*I1[145] - (twoo4zn)*I4[145] - (sixo4zn)*I5[113];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146]
        + (twoo2z)*I1[146] - (twoo4zn)*I4[146] - (sixo4zn)*I5[114];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147]
        + (twoo2z)*I1[147] - (twoo4zn)*I4[147] - (fiveo4zn)*I5[115];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148]
        + (twoo2z)*I1[148] - (twoo4zn)*I4[148] - (fiveo4zn)*I5[116];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149]
        + (twoo2z)*I1[149] - (twoo4zn)*I4[149] - (fiveo4zn)*I5[117];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150]
        + (twoo2z)*I1[150] - (twoo4zn)*I4[150] - (fouro4zn)*I5[118];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151]
        + (twoo2z)*I1[151] - (twoo4zn)*I4[151] - (fouro4zn)*I5[119];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152]
        + (twoo2z)*I1[152] - (twoo4zn)*I4[152] - (fouro4zn)*I5[120];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153]
        + (twoo2z)*I1[153] - (twoo4zn)*I4[153] - (fouro4zn)*I5[121];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154]
        + (twoo2z)*I1[154] - (twoo4zn)*I4[154] - (threeo4zn)*I5[122];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155]
        + (twoo2z)*I1[155] - (twoo4zn)*I4[155] - (threeo4zn)*I5[123];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156]
        + (twoo2z)*I1[156] - (twoo4zn)*I4[156] - (threeo4zn)*I5[124];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157]
        + (twoo2z)*I1[157] - (twoo4zn)*I4[157] - (threeo4zn)*I5[125];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158]
        + (twoo2z)*I1[158] - (twoo4zn)*I4[158] - (threeo4zn)*I5[126];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159]
        + (twoo2z)*I1[159] - (twoo4zn)*I4[159] - (twoo4zn)*I5[127];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160]
        + (twoo2z)*I1[160] - (twoo4zn)*I4[160] - (twoo4zn)*I5[128];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161]
        + (twoo2z)*I1[161] - (twoo4zn)*I4[161] - (twoo4zn)*I5[129];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162]
        + (twoo2z)*I1[162] - (twoo4zn)*I4[162] - (twoo4zn)*I5[130];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163]
        + (twoo2z)*I1[163] - (twoo4zn)*I4[163] - (twoo4zn)*I5[131];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164]
        + (twoo2z)*I1[164] - (twoo4zn)*I4[164] - (twoo4zn)*I5[132];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165]
        + (twoo2z)*I1[165] - (twoo4zn)*I4[165] - (oneo4zn)*I5[133];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166]
        + (twoo2z)*I1[166] - (twoo4zn)*I4[166] - (oneo4zn)*I5[134];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167]
        + (twoo2z)*I1[167] - (twoo4zn)*I4[167] - (oneo4zn)*I5[135];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168]
        + (twoo2z)*I1[168] - (twoo4zn)*I4[168] - (oneo4zn)*I5[136];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169]
        + (twoo2z)*I1[169] - (twoo4zn)*I4[169] - (oneo4zn)*I5[137];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170]
        + (twoo2z)*I1[170] - (twoo4zn)*I4[170] - (oneo4zn)*I5[138];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171]
        + (twoo2z)*I1[171] - (twoo4zn)*I4[171] - (oneo4zn)*I5[139];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172]
        + (twoo2z)*I1[172] - (twoo4zn)*I4[172];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173]
        + (twoo2z)*I1[173] - (twoo4zn)*I4[173];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174]
        + (twoo2z)*I1[174] - (twoo4zn)*I4[174];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175]
        + (twoo2z)*I1[175] - (twoo4zn)*I4[175];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176]
        + (twoo2z)*I1[176] - (twoo4zn)*I4[176];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177]
        + (twoo2z)*I1[177] - (twoo4zn)*I4[177];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178]
        + (twoo2z)*I1[178] - (twoo4zn)*I4[178];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179]
        + (twoo2z)*I1[179] - (twoo4zn)*I4[179];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180]
        + (twoo2z)*I1[180] - (twoo4zn)*I4[180] - (seveno4zn)*I5[140];
*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181]
        + (twoo2z)*I1[181] - (twoo4zn)*I4[181] - (sixo4zn)*I5[141];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182]
        + (twoo2z)*I1[182] - (twoo4zn)*I4[182] - (sixo4zn)*I5[142];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183]
        + (twoo2z)*I1[183] - (twoo4zn)*I4[183] - (fiveo4zn)*I5[143];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184]
        + (twoo2z)*I1[184] - (twoo4zn)*I4[184] - (fiveo4zn)*I5[144];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185]
        + (twoo2z)*I1[185] - (twoo4zn)*I4[185] - (fiveo4zn)*I5[145];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186]
        + (twoo2z)*I1[186] - (twoo4zn)*I4[186] - (fouro4zn)*I5[146];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187]
        + (twoo2z)*I1[187] - (twoo4zn)*I4[187] - (fouro4zn)*I5[147];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188]
        + (twoo2z)*I1[188] - (twoo4zn)*I4[188] - (fouro4zn)*I5[148];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189]
        + (twoo2z)*I1[189] - (twoo4zn)*I4[189] - (fouro4zn)*I5[149];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190]
        + (twoo2z)*I1[190] - (twoo4zn)*I4[190] - (threeo4zn)*I5[150];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191]
        + (twoo2z)*I1[191] - (twoo4zn)*I4[191] - (threeo4zn)*I5[151];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192]
        + (twoo2z)*I1[192] - (twoo4zn)*I4[192] - (threeo4zn)*I5[152];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193]
        + (twoo2z)*I1[193] - (twoo4zn)*I4[193] - (threeo4zn)*I5[153];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194]
        + (twoo2z)*I1[194] - (twoo4zn)*I4[194] - (threeo4zn)*I5[154];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195]
        + (twoo2z)*I1[195] - (twoo4zn)*I4[195] - (twoo4zn)*I5[155];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196]
        + (twoo2z)*I1[196] - (twoo4zn)*I4[196] - (twoo4zn)*I5[156];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197]
        + (twoo2z)*I1[197] - (twoo4zn)*I4[197] - (twoo4zn)*I5[157];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198]
        + (twoo2z)*I1[198] - (twoo4zn)*I4[198] - (twoo4zn)*I5[158];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199]
        + (twoo2z)*I1[199] - (twoo4zn)*I4[199] - (twoo4zn)*I5[159];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200]
        + (twoo2z)*I1[200] - (twoo4zn)*I4[200] - (twoo4zn)*I5[160];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201]
        + (twoo2z)*I1[201] - (twoo4zn)*I4[201] - (oneo4zn)*I5[161];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202]
        + (twoo2z)*I1[202] - (twoo4zn)*I4[202] - (oneo4zn)*I5[162];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203]
        + (twoo2z)*I1[203] - (twoo4zn)*I4[203] - (oneo4zn)*I5[163];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204]
        + (twoo2z)*I1[204] - (twoo4zn)*I4[204] - (oneo4zn)*I5[164];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205]
        + (twoo2z)*I1[205] - (twoo4zn)*I4[205] - (oneo4zn)*I5[165];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206]
        + (twoo2z)*I1[206] - (twoo4zn)*I4[206] - (oneo4zn)*I5[166];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207]
        + (twoo2z)*I1[207] - (twoo4zn)*I4[207] - (oneo4zn)*I5[167];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208]
        + (twoo2z)*I1[208] - (twoo4zn)*I4[208];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209]
        + (twoo2z)*I1[209] - (twoo4zn)*I4[209];
*(vp++) = U00*I0[210] - U10*I3[210] + loo2p*I2[210]
        + (twoo2z)*I1[210] - (twoo4zn)*I4[210];
*(vp++) = U00*I0[211] - U10*I3[211] + loo2p*I2[211]
        + (twoo2z)*I1[211] - (twoo4zn)*I4[211];
*(vp++) = U00*I0[212] - U10*I3[212] + loo2p*I2[212]
        + (twoo2z)*I1[212] - (twoo4zn)*I4[212];
*(vp++) = U00*I0[213] - U10*I3[213] + loo2p*I2[213]
        + (twoo2z)*I1[213] - (twoo4zn)*I4[213];
*(vp++) = U00*I0[214] - U10*I3[214] + loo2p*I2[214]
        + (twoo2z)*I1[214] - (twoo4zn)*I4[214];
*(vp++) = U00*I0[215] - U10*I3[215] + loo2p*I2[215]
        + (twoo2z)*I1[215] - (twoo4zn)*I4[215];
*(vp++) = U00*I0[216] - U10*I3[216] + loo2p*I2[216]
        + (oneo2z)*I1[216] - (oneo4zn)*I4[216] - (seveno4zn)*I5[168];
*(vp++) = U00*I0[217] - U10*I3[217] + loo2p*I2[217]
        + (oneo2z)*I1[217] - (oneo4zn)*I4[217] - (sixo4zn)*I5[169];
*(vp++) = U00*I0[218] - U10*I3[218] + loo2p*I2[218]
        + (oneo2z)*I1[218] - (oneo4zn)*I4[218] - (sixo4zn)*I5[170];
*(vp++) = U00*I0[219] - U10*I3[219] + loo2p*I2[219]
        + (oneo2z)*I1[219] - (oneo4zn)*I4[219] - (fiveo4zn)*I5[171];
*(vp++) = U00*I0[220] - U10*I3[220] + loo2p*I2[220]
        + (oneo2z)*I1[220] - (oneo4zn)*I4[220] - (fiveo4zn)*I5[172];
*(vp++) = U00*I0[221] - U10*I3[221] + loo2p*I2[221]
        + (oneo2z)*I1[221] - (oneo4zn)*I4[221] - (fiveo4zn)*I5[173];
*(vp++) = U00*I0[222] - U10*I3[222] + loo2p*I2[222]
        + (oneo2z)*I1[222] - (oneo4zn)*I4[222] - (fouro4zn)*I5[174];
*(vp++) = U00*I0[223] - U10*I3[223] + loo2p*I2[223]
        + (oneo2z)*I1[223] - (oneo4zn)*I4[223] - (fouro4zn)*I5[175];
*(vp++) = U00*I0[224] - U10*I3[224] + loo2p*I2[224]
        + (oneo2z)*I1[224] - (oneo4zn)*I4[224] - (fouro4zn)*I5[176];
*(vp++) = U00*I0[225] - U10*I3[225] + loo2p*I2[225]
        + (oneo2z)*I1[225] - (oneo4zn)*I4[225] - (fouro4zn)*I5[177];
*(vp++) = U00*I0[226] - U10*I3[226] + loo2p*I2[226]
        + (oneo2z)*I1[226] - (oneo4zn)*I4[226] - (threeo4zn)*I5[178];
*(vp++) = U00*I0[227] - U10*I3[227] + loo2p*I2[227]
        + (oneo2z)*I1[227] - (oneo4zn)*I4[227] - (threeo4zn)*I5[179];
*(vp++) = U00*I0[228] - U10*I3[228] + loo2p*I2[228]
        + (oneo2z)*I1[228] - (oneo4zn)*I4[228] - (threeo4zn)*I5[180];
*(vp++) = U00*I0[229] - U10*I3[229] + loo2p*I2[229]
        + (oneo2z)*I1[229] - (oneo4zn)*I4[229] - (threeo4zn)*I5[181];
*(vp++) = U00*I0[230] - U10*I3[230] + loo2p*I2[230]
        + (oneo2z)*I1[230] - (oneo4zn)*I4[230] - (threeo4zn)*I5[182];
*(vp++) = U00*I0[231] - U10*I3[231] + loo2p*I2[231]
        + (oneo2z)*I1[231] - (oneo4zn)*I4[231] - (twoo4zn)*I5[183];
*(vp++) = U00*I0[232] - U10*I3[232] + loo2p*I2[232]
        + (oneo2z)*I1[232] - (oneo4zn)*I4[232] - (twoo4zn)*I5[184];
*(vp++) = U00*I0[233] - U10*I3[233] + loo2p*I2[233]
        + (oneo2z)*I1[233] - (oneo4zn)*I4[233] - (twoo4zn)*I5[185];
*(vp++) = U00*I0[234] - U10*I3[234] + loo2p*I2[234]
        + (oneo2z)*I1[234] - (oneo4zn)*I4[234] - (twoo4zn)*I5[186];
*(vp++) = U00*I0[235] - U10*I3[235] + loo2p*I2[235]
        + (oneo2z)*I1[235] - (oneo4zn)*I4[235] - (twoo4zn)*I5[187];
*(vp++) = U00*I0[236] - U10*I3[236] + loo2p*I2[236]
        + (oneo2z)*I1[236] - (oneo4zn)*I4[236] - (twoo4zn)*I5[188];
*(vp++) = U00*I0[237] - U10*I3[237] + loo2p*I2[237]
        + (oneo2z)*I1[237] - (oneo4zn)*I4[237] - (oneo4zn)*I5[189];
*(vp++) = U00*I0[238] - U10*I3[238] + loo2p*I2[238]
        + (oneo2z)*I1[238] - (oneo4zn)*I4[238] - (oneo4zn)*I5[190];
*(vp++) = U00*I0[239] - U10*I3[239] + loo2p*I2[239]
        + (oneo2z)*I1[239] - (oneo4zn)*I4[239] - (oneo4zn)*I5[191];
*(vp++) = U00*I0[240] - U10*I3[240] + loo2p*I2[240]
        + (oneo2z)*I1[240] - (oneo4zn)*I4[240] - (oneo4zn)*I5[192];
*(vp++) = U00*I0[241] - U10*I3[241] + loo2p*I2[241]
        + (oneo2z)*I1[241] - (oneo4zn)*I4[241] - (oneo4zn)*I5[193];
*(vp++) = U00*I0[242] - U10*I3[242] + loo2p*I2[242]
        + (oneo2z)*I1[242] - (oneo4zn)*I4[242] - (oneo4zn)*I5[194];
*(vp++) = U00*I0[243] - U10*I3[243] + loo2p*I2[243]
        + (oneo2z)*I1[243] - (oneo4zn)*I4[243] - (oneo4zn)*I5[195];
*(vp++) = U00*I0[244] - U10*I3[244] + loo2p*I2[244]
        + (oneo2z)*I1[244] - (oneo4zn)*I4[244];
*(vp++) = U00*I0[245] - U10*I3[245] + loo2p*I2[245]
        + (oneo2z)*I1[245] - (oneo4zn)*I4[245];
*(vp++) = U00*I0[246] - U10*I3[246] + loo2p*I2[246]
        + (oneo2z)*I1[246] - (oneo4zn)*I4[246];
*(vp++) = U00*I0[247] - U10*I3[247] + loo2p*I2[247]
        + (oneo2z)*I1[247] - (oneo4zn)*I4[247];
*(vp++) = U00*I0[248] - U10*I3[248] + loo2p*I2[248]
        + (oneo2z)*I1[248] - (oneo4zn)*I4[248];
*(vp++) = U00*I0[249] - U10*I3[249] + loo2p*I2[249]
        + (oneo2z)*I1[249] - (oneo4zn)*I4[249];
*(vp++) = U00*I0[250] - U10*I3[250] + loo2p*I2[250]
        + (oneo2z)*I1[250] - (oneo4zn)*I4[250];
*(vp++) = U00*I0[251] - U10*I3[251] + loo2p*I2[251]
        + (oneo2z)*I1[251] - (oneo4zn)*I4[251];
*(vp++) = U00*I0[252] - U10*I3[252] + loo2p*I2[252]
        + (oneo2z)*I1[252] - (oneo4zn)*I4[252] - (seveno4zn)*I5[196];
return vp;
}

REALTYPE *_r_build_h0k0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[253] - U10*I3[253] + loo2p*I2[253]
        + (oneo2z)*I1[253] - (oneo4zn)*I4[253] - (sixo4zn)*I5[197];
*(vp++) = U00*I0[254] - U10*I3[254] + loo2p*I2[254]
        + (oneo2z)*I1[254] - (oneo4zn)*I4[254] - (sixo4zn)*I5[198];
*(vp++) = U00*I0[255] - U10*I3[255] + loo2p*I2[255]
        + (oneo2z)*I1[255] - (oneo4zn)*I4[255] - (fiveo4zn)*I5[199];
*(vp++) = U00*I0[256] - U10*I3[256] + loo2p*I2[256]
        + (oneo2z)*I1[256] - (oneo4zn)*I4[256] - (fiveo4zn)*I5[200];
*(vp++) = U00*I0[257] - U10*I3[257] + loo2p*I2[257]
        + (oneo2z)*I1[257] - (oneo4zn)*I4[257] - (fiveo4zn)*I5[201];
*(vp++) = U00*I0[258] - U10*I3[258] + loo2p*I2[258]
        + (oneo2z)*I1[258] - (oneo4zn)*I4[258] - (fouro4zn)*I5[202];
*(vp++) = U00*I0[259] - U10*I3[259] + loo2p*I2[259]
        + (oneo2z)*I1[259] - (oneo4zn)*I4[259] - (fouro4zn)*I5[203];
*(vp++) = U00*I0[260] - U10*I3[260] + loo2p*I2[260]
        + (oneo2z)*I1[260] - (oneo4zn)*I4[260] - (fouro4zn)*I5[204];
*(vp++) = U00*I0[261] - U10*I3[261] + loo2p*I2[261]
        + (oneo2z)*I1[261] - (oneo4zn)*I4[261] - (fouro4zn)*I5[205];
*(vp++) = U00*I0[262] - U10*I3[262] + loo2p*I2[262]
        + (oneo2z)*I1[262] - (oneo4zn)*I4[262] - (threeo4zn)*I5[206];
*(vp++) = U00*I0[263] - U10*I3[263] + loo2p*I2[263]
        + (oneo2z)*I1[263] - (oneo4zn)*I4[263] - (threeo4zn)*I5[207];
*(vp++) = U00*I0[264] - U10*I3[264] + loo2p*I2[264]
        + (oneo2z)*I1[264] - (oneo4zn)*I4[264] - (threeo4zn)*I5[208];
*(vp++) = U00*I0[265] - U10*I3[265] + loo2p*I2[265]
        + (oneo2z)*I1[265] - (oneo4zn)*I4[265] - (threeo4zn)*I5[209];
*(vp++) = U00*I0[266] - U10*I3[266] + loo2p*I2[266]
        + (oneo2z)*I1[266] - (oneo4zn)*I4[266] - (threeo4zn)*I5[210];
*(vp++) = U00*I0[267] - U10*I3[267] + loo2p*I2[267]
        + (oneo2z)*I1[267] - (oneo4zn)*I4[267] - (twoo4zn)*I5[211];
*(vp++) = U00*I0[268] - U10*I3[268] + loo2p*I2[268]
        + (oneo2z)*I1[268] - (oneo4zn)*I4[268] - (twoo4zn)*I5[212];
*(vp++) = U00*I0[269] - U10*I3[269] + loo2p*I2[269]
        + (oneo2z)*I1[269] - (oneo4zn)*I4[269] - (twoo4zn)*I5[213];
*(vp++) = U00*I0[270] - U10*I3[270] + loo2p*I2[270]
        + (oneo2z)*I1[270] - (oneo4zn)*I4[270] - (twoo4zn)*I5[214];
*(vp++) = U00*I0[271] - U10*I3[271] + loo2p*I2[271]
        + (oneo2z)*I1[271] - (oneo4zn)*I4[271] - (twoo4zn)*I5[215];
*(vp++) = U00*I0[272] - U10*I3[272] + loo2p*I2[272]
        + (oneo2z)*I1[272] - (oneo4zn)*I4[272] - (twoo4zn)*I5[216];
*(vp++) = U00*I0[273] - U10*I3[273] + loo2p*I2[273]
        + (oneo2z)*I1[273] - (oneo4zn)*I4[273] - (oneo4zn)*I5[217];
*(vp++) = U00*I0[274] - U10*I3[274] + loo2p*I2[274]
        + (oneo2z)*I1[274] - (oneo4zn)*I4[274] - (oneo4zn)*I5[218];
*(vp++) = U00*I0[275] - U10*I3[275] + loo2p*I2[275]
        + (oneo2z)*I1[275] - (oneo4zn)*I4[275] - (oneo4zn)*I5[219];
*(vp++) = U00*I0[276] - U10*I3[276] + loo2p*I2[276]
        + (oneo2z)*I1[276] - (oneo4zn)*I4[276] - (oneo4zn)*I5[220];
*(vp++) = U00*I0[277] - U10*I3[277] + loo2p*I2[277]
        + (oneo2z)*I1[277] - (oneo4zn)*I4[277] - (oneo4zn)*I5[221];
*(vp++) = U00*I0[278] - U10*I3[278] + loo2p*I2[278]
        + (oneo2z)*I1[278] - (oneo4zn)*I4[278] - (oneo4zn)*I5[222];
*(vp++) = U00*I0[279] - U10*I3[279] + loo2p*I2[279]
        + (oneo2z)*I1[279] - (oneo4zn)*I4[279] - (oneo4zn)*I5[223];
*(vp++) = U00*I0[280] - U10*I3[280] + loo2p*I2[280]
        + (oneo2z)*I1[280] - (oneo4zn)*I4[280];
*(vp++) = U00*I0[281] - U10*I3[281] + loo2p*I2[281]
        + (oneo2z)*I1[281] - (oneo4zn)*I4[281];
*(vp++) = U00*I0[282] - U10*I3[282] + loo2p*I2[282]
        + (oneo2z)*I1[282] - (oneo4zn)*I4[282];
*(vp++) = U00*I0[283] - U10*I3[283] + loo2p*I2[283]
        + (oneo2z)*I1[283] - (oneo4zn)*I4[283];
*(vp++) = U00*I0[284] - U10*I3[284] + loo2p*I2[284]
        + (oneo2z)*I1[284] - (oneo4zn)*I4[284];
*(vp++) = U00*I0[285] - U10*I3[285] + loo2p*I2[285]
        + (oneo2z)*I1[285] - (oneo4zn)*I4[285];
*(vp++) = U00*I0[286] - U10*I3[286] + loo2p*I2[286]
        + (oneo2z)*I1[286] - (oneo4zn)*I4[286];
*(vp++) = U00*I0[287] - U10*I3[287] + loo2p*I2[287]
        + (oneo2z)*I1[287] - (oneo4zn)*I4[287];
*(vp++) = U00*I0[288] - U10*I3[288] + loo2p*I2[288]
        + (oneo2z)*I1[288] - (oneo4zn)*I4[288] - (seveno4zn)*I5[224];
*(vp++) = U00*I0[289] - U10*I3[289] + loo2p*I2[289]
        + (oneo2z)*I1[289] - (oneo4zn)*I4[289] - (sixo4zn)*I5[225];
*(vp++) = U00*I0[290] - U10*I3[290] + loo2p*I2[290]
        + (oneo2z)*I1[290] - (oneo4zn)*I4[290] - (sixo4zn)*I5[226];
*(vp++) = U00*I0[291] - U10*I3[291] + loo2p*I2[291]
        + (oneo2z)*I1[291] - (oneo4zn)*I4[291] - (fiveo4zn)*I5[227];
*(vp++) = U00*I0[292] - U10*I3[292] + loo2p*I2[292]
        + (oneo2z)*I1[292] - (oneo4zn)*I4[292] - (fiveo4zn)*I5[228];
*(vp++) = U00*I0[293] - U10*I3[293] + loo2p*I2[293]
        + (oneo2z)*I1[293] - (oneo4zn)*I4[293] - (fiveo4zn)*I5[229];
*(vp++) = U00*I0[294] - U10*I3[294] + loo2p*I2[294]
        + (oneo2z)*I1[294] - (oneo4zn)*I4[294] - (fouro4zn)*I5[230];
*(vp++) = U00*I0[295] - U10*I3[295] + loo2p*I2[295]
        + (oneo2z)*I1[295] - (oneo4zn)*I4[295] - (fouro4zn)*I5[231];
*(vp++) = U00*I0[296] - U10*I3[296] + loo2p*I2[296]
        + (oneo2z)*I1[296] - (oneo4zn)*I4[296] - (fouro4zn)*I5[232];
*(vp++) = U00*I0[297] - U10*I3[297] + loo2p*I2[297]
        + (oneo2z)*I1[297] - (oneo4zn)*I4[297] - (fouro4zn)*I5[233];
*(vp++) = U00*I0[298] - U10*I3[298] + loo2p*I2[298]
        + (oneo2z)*I1[298] - (oneo4zn)*I4[298] - (threeo4zn)*I5[234];
*(vp++) = U00*I0[299] - U10*I3[299] + loo2p*I2[299]
        + (oneo2z)*I1[299] - (oneo4zn)*I4[299] - (threeo4zn)*I5[235];
*(vp++) = U00*I0[300] - U10*I3[300] + loo2p*I2[300]
        + (oneo2z)*I1[300] - (oneo4zn)*I4[300] - (threeo4zn)*I5[236];
*(vp++) = U00*I0[301] - U10*I3[301] + loo2p*I2[301]
        + (oneo2z)*I1[301] - (oneo4zn)*I4[301] - (threeo4zn)*I5[237];
*(vp++) = U00*I0[302] - U10*I3[302] + loo2p*I2[302]
        + (oneo2z)*I1[302] - (oneo4zn)*I4[302] - (threeo4zn)*I5[238];
*(vp++) = U00*I0[303] - U10*I3[303] + loo2p*I2[303]
        + (oneo2z)*I1[303] - (oneo4zn)*I4[303] - (twoo4zn)*I5[239];
*(vp++) = U00*I0[304] - U10*I3[304] + loo2p*I2[304]
        + (oneo2z)*I1[304] - (oneo4zn)*I4[304] - (twoo4zn)*I5[240];
*(vp++) = U00*I0[305] - U10*I3[305] + loo2p*I2[305]
        + (oneo2z)*I1[305] - (oneo4zn)*I4[305] - (twoo4zn)*I5[241];
*(vp++) = U00*I0[306] - U10*I3[306] + loo2p*I2[306]
        + (oneo2z)*I1[306] - (oneo4zn)*I4[306] - (twoo4zn)*I5[242];
*(vp++) = U00*I0[307] - U10*I3[307] + loo2p*I2[307]
        + (oneo2z)*I1[307] - (oneo4zn)*I4[307] - (twoo4zn)*I5[243];
*(vp++) = U00*I0[308] - U10*I3[308] + loo2p*I2[308]
        + (oneo2z)*I1[308] - (oneo4zn)*I4[308] - (twoo4zn)*I5[244];
*(vp++) = U00*I0[309] - U10*I3[309] + loo2p*I2[309]
        + (oneo2z)*I1[309] - (oneo4zn)*I4[309] - (oneo4zn)*I5[245];
*(vp++) = U00*I0[310] - U10*I3[310] + loo2p*I2[310]
        + (oneo2z)*I1[310] - (oneo4zn)*I4[310] - (oneo4zn)*I5[246];
*(vp++) = U00*I0[311] - U10*I3[311] + loo2p*I2[311]
        + (oneo2z)*I1[311] - (oneo4zn)*I4[311] - (oneo4zn)*I5[247];
*(vp++) = U00*I0[312] - U10*I3[312] + loo2p*I2[312]
        + (oneo2z)*I1[312] - (oneo4zn)*I4[312] - (oneo4zn)*I5[248];
*(vp++) = U00*I0[313] - U10*I3[313] + loo2p*I2[313]
        + (oneo2z)*I1[313] - (oneo4zn)*I4[313] - (oneo4zn)*I5[249];
*(vp++) = U00*I0[314] - U10*I3[314] + loo2p*I2[314]
        + (oneo2z)*I1[314] - (oneo4zn)*I4[314] - (oneo4zn)*I5[250];
*(vp++) = U00*I0[315] - U10*I3[315] + loo2p*I2[315]
        + (oneo2z)*I1[315] - (oneo4zn)*I4[315] - (oneo4zn)*I5[251];
*(vp++) = U00*I0[316] - U10*I3[316] + loo2p*I2[316]
        + (oneo2z)*I1[316] - (oneo4zn)*I4[316];
*(vp++) = U00*I0[317] - U10*I3[317] + loo2p*I2[317]
        + (oneo2z)*I1[317] - (oneo4zn)*I4[317];
*(vp++) = U00*I0[318] - U10*I3[318] + loo2p*I2[318]
        + (oneo2z)*I1[318] - (oneo4zn)*I4[318];
*(vp++) = U00*I0[319] - U10*I3[319] + loo2p*I2[319]
        + (oneo2z)*I1[319] - (oneo4zn)*I4[319];
*(vp++) = U00*I0[320] - U10*I3[320] + loo2p*I2[320]
        + (oneo2z)*I1[320] - (oneo4zn)*I4[320];
*(vp++) = U00*I0[321] - U10*I3[321] + loo2p*I2[321]
        + (oneo2z)*I1[321] - (oneo4zn)*I4[321];
*(vp++) = U00*I0[322] - U10*I3[322] + loo2p*I2[322]
        + (oneo2z)*I1[322] - (oneo4zn)*I4[322];
*(vp++) = U00*I0[323] - U10*I3[323] + loo2p*I2[323]
        + (oneo2z)*I1[323] - (oneo4zn)*I4[323];
*(vp++) = U00*I0[324] - U10*I3[324] + loo2p*I2[324]
        + (oneo2z)*I1[324] - (oneo4zn)*I4[324] - (seveno4zn)*I5[252];
*(vp++) = U00*I0[325] - U10*I3[325] + loo2p*I2[325]
        + (oneo2z)*I1[325] - (oneo4zn)*I4[325] - (sixo4zn)*I5[253];
*(vp++) = U00*I0[326] - U10*I3[326] + loo2p*I2[326]
        + (oneo2z)*I1[326] - (oneo4zn)*I4[326] - (sixo4zn)*I5[254];
*(vp++) = U00*I0[327] - U10*I3[327] + loo2p*I2[327]
        + (oneo2z)*I1[327] - (oneo4zn)*I4[327] - (fiveo4zn)*I5[255];
*(vp++) = U00*I0[328] - U10*I3[328] + loo2p*I2[328]
        + (oneo2z)*I1[328] - (oneo4zn)*I4[328] - (fiveo4zn)*I5[256];
*(vp++) = U00*I0[329] - U10*I3[329] + loo2p*I2[329]
        + (oneo2z)*I1[329] - (oneo4zn)*I4[329] - (fiveo4zn)*I5[257];
*(vp++) = U00*I0[330] - U10*I3[330] + loo2p*I2[330]
        + (oneo2z)*I1[330] - (oneo4zn)*I4[330] - (fouro4zn)*I5[258];
*(vp++) = U00*I0[331] - U10*I3[331] + loo2p*I2[331]
        + (oneo2z)*I1[331] - (oneo4zn)*I4[331] - (fouro4zn)*I5[259];
*(vp++) = U00*I0[332] - U10*I3[332] + loo2p*I2[332]
        + (oneo2z)*I1[332] - (oneo4zn)*I4[332] - (fouro4zn)*I5[260];
*(vp++) = U00*I0[333] - U10*I3[333] + loo2p*I2[333]
        + (oneo2z)*I1[333] - (oneo4zn)*I4[333] - (fouro4zn)*I5[261];
*(vp++) = U00*I0[334] - U10*I3[334] + loo2p*I2[334]
        + (oneo2z)*I1[334] - (oneo4zn)*I4[334] - (threeo4zn)*I5[262];
*(vp++) = U00*I0[335] - U10*I3[335] + loo2p*I2[335]
        + (oneo2z)*I1[335] - (oneo4zn)*I4[335] - (threeo4zn)*I5[263];
*(vp++) = U00*I0[336] - U10*I3[336] + loo2p*I2[336]
        + (oneo2z)*I1[336] - (oneo4zn)*I4[336] - (threeo4zn)*I5[264];
*(vp++) = U00*I0[337] - U10*I3[337] + loo2p*I2[337]
        + (oneo2z)*I1[337] - (oneo4zn)*I4[337] - (threeo4zn)*I5[265];
*(vp++) = U00*I0[338] - U10*I3[338] + loo2p*I2[338]
        + (oneo2z)*I1[338] - (oneo4zn)*I4[338] - (threeo4zn)*I5[266];
*(vp++) = U00*I0[339] - U10*I3[339] + loo2p*I2[339]
        + (oneo2z)*I1[339] - (oneo4zn)*I4[339] - (twoo4zn)*I5[267];
*(vp++) = U00*I0[340] - U10*I3[340] + loo2p*I2[340]
        + (oneo2z)*I1[340] - (oneo4zn)*I4[340] - (twoo4zn)*I5[268];
*(vp++) = U00*I0[341] - U10*I3[341] + loo2p*I2[341]
        + (oneo2z)*I1[341] - (oneo4zn)*I4[341] - (twoo4zn)*I5[269];
*(vp++) = U00*I0[342] - U10*I3[342] + loo2p*I2[342]
        + (oneo2z)*I1[342] - (oneo4zn)*I4[342] - (twoo4zn)*I5[270];
*(vp++) = U00*I0[343] - U10*I3[343] + loo2p*I2[343]
        + (oneo2z)*I1[343] - (oneo4zn)*I4[343] - (twoo4zn)*I5[271];
*(vp++) = U00*I0[344] - U10*I3[344] + loo2p*I2[344]
        + (oneo2z)*I1[344] - (oneo4zn)*I4[344] - (twoo4zn)*I5[272];
*(vp++) = U00*I0[345] - U10*I3[345] + loo2p*I2[345]
        + (oneo2z)*I1[345] - (oneo4zn)*I4[345] - (oneo4zn)*I5[273];
*(vp++) = U00*I0[346] - U10*I3[346] + loo2p*I2[346]
        + (oneo2z)*I1[346] - (oneo4zn)*I4[346] - (oneo4zn)*I5[274];
*(vp++) = U00*I0[347] - U10*I3[347] + loo2p*I2[347]
        + (oneo2z)*I1[347] - (oneo4zn)*I4[347] - (oneo4zn)*I5[275];
*(vp++) = U00*I0[348] - U10*I3[348] + loo2p*I2[348]
        + (oneo2z)*I1[348] - (oneo4zn)*I4[348] - (oneo4zn)*I5[276];
*(vp++) = U00*I0[349] - U10*I3[349] + loo2p*I2[349]
        + (oneo2z)*I1[349] - (oneo4zn)*I4[349] - (oneo4zn)*I5[277];
*(vp++) = U00*I0[350] - U10*I3[350] + loo2p*I2[350]
        + (oneo2z)*I1[350] - (oneo4zn)*I4[350] - (oneo4zn)*I5[278];
*(vp++) = U00*I0[351] - U10*I3[351] + loo2p*I2[351]
        + (oneo2z)*I1[351] - (oneo4zn)*I4[351] - (oneo4zn)*I5[279];
*(vp++) = U00*I0[352] - U10*I3[352] + loo2p*I2[352]
        + (oneo2z)*I1[352] - (oneo4zn)*I4[352];
*(vp++) = U00*I0[353] - U10*I3[353] + loo2p*I2[353]
        + (oneo2z)*I1[353] - (oneo4zn)*I4[353];
*(vp++) = U00*I0[354] - U10*I3[354] + loo2p*I2[354]
        + (oneo2z)*I1[354] - (oneo4zn)*I4[354];
*(vp++) = U00*I0[355] - U10*I3[355] + loo2p*I2[355]
        + (oneo2z)*I1[355] - (oneo4zn)*I4[355];
*(vp++) = U00*I0[356] - U10*I3[356] + loo2p*I2[356]
        + (oneo2z)*I1[356] - (oneo4zn)*I4[356];
*(vp++) = U00*I0[357] - U10*I3[357] + loo2p*I2[357]
        + (oneo2z)*I1[357] - (oneo4zn)*I4[357];
*(vp++) = U00*I0[358] - U10*I3[358] + loo2p*I2[358]
        + (oneo2z)*I1[358] - (oneo4zn)*I4[358];
*(vp++) = U00*I0[359] - U10*I3[359] + loo2p*I2[359]
        + (oneo2z)*I1[359] - (oneo4zn)*I4[359];
*(vp++) = U00*I0[360] - U10*I3[360] + loo2p*I2[360] - (seveno4zn)*I5[280];
*(vp++) = U00*I0[361] - U10*I3[361] + loo2p*I2[361] - (sixo4zn)*I5[281];
*(vp++) = U00*I0[362] - U10*I3[362] + loo2p*I2[362] - (sixo4zn)*I5[282];
*(vp++) = U00*I0[363] - U10*I3[363] + loo2p*I2[363] - (fiveo4zn)*I5[283];
*(vp++) = U00*I0[364] - U10*I3[364] + loo2p*I2[364] - (fiveo4zn)*I5[284];
*(vp++) = U00*I0[365] - U10*I3[365] + loo2p*I2[365] - (fiveo4zn)*I5[285];
*(vp++) = U00*I0[366] - U10*I3[366] + loo2p*I2[366] - (fouro4zn)*I5[286];
*(vp++) = U00*I0[367] - U10*I3[367] + loo2p*I2[367] - (fouro4zn)*I5[287];
*(vp++) = U00*I0[368] - U10*I3[368] + loo2p*I2[368] - (fouro4zn)*I5[288];
*(vp++) = U00*I0[369] - U10*I3[369] + loo2p*I2[369] - (fouro4zn)*I5[289];
*(vp++) = U00*I0[370] - U10*I3[370] + loo2p*I2[370] - (threeo4zn)*I5[290];
*(vp++) = U00*I0[371] - U10*I3[371] + loo2p*I2[371] - (threeo4zn)*I5[291];
*(vp++) = U00*I0[372] - U10*I3[372] + loo2p*I2[372] - (threeo4zn)*I5[292];
*(vp++) = U00*I0[373] - U10*I3[373] + loo2p*I2[373] - (threeo4zn)*I5[293];
*(vp++) = U00*I0[374] - U10*I3[374] + loo2p*I2[374] - (threeo4zn)*I5[294];
*(vp++) = U00*I0[375] - U10*I3[375] + loo2p*I2[375] - (twoo4zn)*I5[295];
*(vp++) = U00*I0[376] - U10*I3[376] + loo2p*I2[376] - (twoo4zn)*I5[296];
*(vp++) = U00*I0[377] - U10*I3[377] + loo2p*I2[377] - (twoo4zn)*I5[297];
*(vp++) = U00*I0[378] - U10*I3[378] + loo2p*I2[378] - (twoo4zn)*I5[298];
*(vp++) = U00*I0[379] - U10*I3[379] + loo2p*I2[379] - (twoo4zn)*I5[299];
*(vp++) = U00*I0[380] - U10*I3[380] + loo2p*I2[380] - (twoo4zn)*I5[300];
*(vp++) = U00*I0[381] - U10*I3[381] + loo2p*I2[381] - (oneo4zn)*I5[301];
*(vp++) = U00*I0[382] - U10*I3[382] + loo2p*I2[382] - (oneo4zn)*I5[302];
*(vp++) = U00*I0[383] - U10*I3[383] + loo2p*I2[383] - (oneo4zn)*I5[303];
*(vp++) = U00*I0[384] - U10*I3[384] + loo2p*I2[384] - (oneo4zn)*I5[304];
*(vp++) = U00*I0[385] - U10*I3[385] + loo2p*I2[385] - (oneo4zn)*I5[305];
*(vp++) = U00*I0[386] - U10*I3[386] + loo2p*I2[386] - (oneo4zn)*I5[306];
*(vp++) = U00*I0[387] - U10*I3[387] + loo2p*I2[387] - (oneo4zn)*I5[307];
*(vp++) = U00*I0[388] - U10*I3[388] + loo2p*I2[388];
*(vp++) = U00*I0[389] - U10*I3[389] + loo2p*I2[389];
*(vp++) = U00*I0[390] - U10*I3[390] + loo2p*I2[390];
*(vp++) = U00*I0[391] - U10*I3[391] + loo2p*I2[391];
*(vp++) = U00*I0[392] - U10*I3[392] + loo2p*I2[392];
*(vp++) = U00*I0[393] - U10*I3[393] + loo2p*I2[393];
*(vp++) = U00*I0[394] - U10*I3[394] + loo2p*I2[394];
*(vp++) = U00*I0[395] - U10*I3[395] + loo2p*I2[395];
*(vp++) = U00*I0[396] - U10*I3[396] + loo2p*I2[396] - (seveno4zn)*I5[308];
*(vp++) = U00*I0[397] - U10*I3[397] + loo2p*I2[397] - (sixo4zn)*I5[309];
*(vp++) = U00*I0[398] - U10*I3[398] + loo2p*I2[398] - (sixo4zn)*I5[310];
*(vp++) = U00*I0[399] - U10*I3[399] + loo2p*I2[399] - (fiveo4zn)*I5[311];
*(vp++) = U00*I0[400] - U10*I3[400] + loo2p*I2[400] - (fiveo4zn)*I5[312];
*(vp++) = U00*I0[401] - U10*I3[401] + loo2p*I2[401] - (fiveo4zn)*I5[313];
*(vp++) = U00*I0[402] - U10*I3[402] + loo2p*I2[402] - (fouro4zn)*I5[314];
*(vp++) = U00*I0[403] - U10*I3[403] + loo2p*I2[403] - (fouro4zn)*I5[315];
*(vp++) = U00*I0[404] - U10*I3[404] + loo2p*I2[404] - (fouro4zn)*I5[316];
*(vp++) = U00*I0[405] - U10*I3[405] + loo2p*I2[405] - (fouro4zn)*I5[317];
*(vp++) = U00*I0[406] - U10*I3[406] + loo2p*I2[406] - (threeo4zn)*I5[318];
*(vp++) = U00*I0[407] - U10*I3[407] + loo2p*I2[407] - (threeo4zn)*I5[319];
*(vp++) = U00*I0[408] - U10*I3[408] + loo2p*I2[408] - (threeo4zn)*I5[320];
*(vp++) = U00*I0[409] - U10*I3[409] + loo2p*I2[409] - (threeo4zn)*I5[321];
*(vp++) = U00*I0[410] - U10*I3[410] + loo2p*I2[410] - (threeo4zn)*I5[322];
*(vp++) = U00*I0[411] - U10*I3[411] + loo2p*I2[411] - (twoo4zn)*I5[323];
*(vp++) = U00*I0[412] - U10*I3[412] + loo2p*I2[412] - (twoo4zn)*I5[324];
*(vp++) = U00*I0[413] - U10*I3[413] + loo2p*I2[413] - (twoo4zn)*I5[325];
*(vp++) = U00*I0[414] - U10*I3[414] + loo2p*I2[414] - (twoo4zn)*I5[326];
*(vp++) = U00*I0[415] - U10*I3[415] + loo2p*I2[415] - (twoo4zn)*I5[327];
*(vp++) = U00*I0[416] - U10*I3[416] + loo2p*I2[416] - (twoo4zn)*I5[328];
*(vp++) = U00*I0[417] - U10*I3[417] + loo2p*I2[417] - (oneo4zn)*I5[329];
*(vp++) = U00*I0[418] - U10*I3[418] + loo2p*I2[418] - (oneo4zn)*I5[330];
*(vp++) = U00*I0[419] - U10*I3[419] + loo2p*I2[419] - (oneo4zn)*I5[331];
*(vp++) = U00*I0[420] - U10*I3[420] + loo2p*I2[420] - (oneo4zn)*I5[332];
*(vp++) = U00*I0[421] - U10*I3[421] + loo2p*I2[421] - (oneo4zn)*I5[333];
*(vp++) = U00*I0[422] - U10*I3[422] + loo2p*I2[422] - (oneo4zn)*I5[334];
*(vp++) = U00*I0[423] - U10*I3[423] + loo2p*I2[423] - (oneo4zn)*I5[335];
*(vp++) = U00*I0[424] - U10*I3[424] + loo2p*I2[424];
*(vp++) = U00*I0[425] - U10*I3[425] + loo2p*I2[425];
*(vp++) = U00*I0[426] - U10*I3[426] + loo2p*I2[426];
*(vp++) = U00*I0[427] - U10*I3[427] + loo2p*I2[427];
*(vp++) = U00*I0[428] - U10*I3[428] + loo2p*I2[428];
*(vp++) = U00*I0[429] - U10*I3[429] + loo2p*I2[429];
*(vp++) = U00*I0[430] - U10*I3[430] + loo2p*I2[430];
*(vp++) = U00*I0[431] - U10*I3[431] + loo2p*I2[431];
*(vp++) = U00*I0[432] - U10*I3[432] + loo2p*I2[432] - (seveno4zn)*I5[336];
*(vp++) = U00*I0[433] - U10*I3[433] + loo2p*I2[433] - (sixo4zn)*I5[337];
*(vp++) = U00*I0[434] - U10*I3[434] + loo2p*I2[434] - (sixo4zn)*I5[338];
*(vp++) = U00*I0[435] - U10*I3[435] + loo2p*I2[435] - (fiveo4zn)*I5[339];
*(vp++) = U00*I0[436] - U10*I3[436] + loo2p*I2[436] - (fiveo4zn)*I5[340];
*(vp++) = U00*I0[437] - U10*I3[437] + loo2p*I2[437] - (fiveo4zn)*I5[341];
*(vp++) = U00*I0[438] - U10*I3[438] + loo2p*I2[438] - (fouro4zn)*I5[342];
*(vp++) = U00*I0[439] - U10*I3[439] + loo2p*I2[439] - (fouro4zn)*I5[343];
*(vp++) = U00*I0[440] - U10*I3[440] + loo2p*I2[440] - (fouro4zn)*I5[344];
*(vp++) = U00*I0[441] - U10*I3[441] + loo2p*I2[441] - (fouro4zn)*I5[345];
*(vp++) = U00*I0[442] - U10*I3[442] + loo2p*I2[442] - (threeo4zn)*I5[346];
*(vp++) = U00*I0[443] - U10*I3[443] + loo2p*I2[443] - (threeo4zn)*I5[347];
*(vp++) = U00*I0[444] - U10*I3[444] + loo2p*I2[444] - (threeo4zn)*I5[348];
*(vp++) = U00*I0[445] - U10*I3[445] + loo2p*I2[445] - (threeo4zn)*I5[349];
*(vp++) = U00*I0[446] - U10*I3[446] + loo2p*I2[446] - (threeo4zn)*I5[350];
*(vp++) = U00*I0[447] - U10*I3[447] + loo2p*I2[447] - (twoo4zn)*I5[351];
*(vp++) = U00*I0[448] - U10*I3[448] + loo2p*I2[448] - (twoo4zn)*I5[352];
*(vp++) = U00*I0[449] - U10*I3[449] + loo2p*I2[449] - (twoo4zn)*I5[353];
*(vp++) = U00*I0[450] - U10*I3[450] + loo2p*I2[450] - (twoo4zn)*I5[354];
*(vp++) = U00*I0[451] - U10*I3[451] + loo2p*I2[451] - (twoo4zn)*I5[355];
*(vp++) = U00*I0[452] - U10*I3[452] + loo2p*I2[452] - (twoo4zn)*I5[356];
*(vp++) = U00*I0[453] - U10*I3[453] + loo2p*I2[453] - (oneo4zn)*I5[357];
*(vp++) = U00*I0[454] - U10*I3[454] + loo2p*I2[454] - (oneo4zn)*I5[358];
*(vp++) = U00*I0[455] - U10*I3[455] + loo2p*I2[455] - (oneo4zn)*I5[359];
*(vp++) = U00*I0[456] - U10*I3[456] + loo2p*I2[456] - (oneo4zn)*I5[360];
*(vp++) = U00*I0[457] - U10*I3[457] + loo2p*I2[457] - (oneo4zn)*I5[361];
*(vp++) = U00*I0[458] - U10*I3[458] + loo2p*I2[458] - (oneo4zn)*I5[362];
*(vp++) = U00*I0[459] - U10*I3[459] + loo2p*I2[459] - (oneo4zn)*I5[363];
*(vp++) = U00*I0[460] - U10*I3[460] + loo2p*I2[460];
*(vp++) = U00*I0[461] - U10*I3[461] + loo2p*I2[461];
*(vp++) = U00*I0[462] - U10*I3[462] + loo2p*I2[462];
*(vp++) = U00*I0[463] - U10*I3[463] + loo2p*I2[463];
*(vp++) = U00*I0[464] - U10*I3[464] + loo2p*I2[464];
*(vp++) = U00*I0[465] - U10*I3[465] + loo2p*I2[465];
*(vp++) = U00*I0[466] - U10*I3[466] + loo2p*I2[466];
*(vp++) = U00*I0[467] - U10*I3[467] + loo2p*I2[467];
*(vp++) = U00*I0[468] - U10*I3[468] + loo2p*I2[468] - (seveno4zn)*I5[364];
*(vp++) = U00*I0[469] - U10*I3[469] + loo2p*I2[469] - (sixo4zn)*I5[365];
*(vp++) = U00*I0[470] - U10*I3[470] + loo2p*I2[470] - (sixo4zn)*I5[366];
*(vp++) = U00*I0[471] - U10*I3[471] + loo2p*I2[471] - (fiveo4zn)*I5[367];
*(vp++) = U00*I0[472] - U10*I3[472] + loo2p*I2[472] - (fiveo4zn)*I5[368];
*(vp++) = U00*I0[473] - U10*I3[473] + loo2p*I2[473] - (fiveo4zn)*I5[369];
*(vp++) = U00*I0[474] - U10*I3[474] + loo2p*I2[474] - (fouro4zn)*I5[370];
*(vp++) = U00*I0[475] - U10*I3[475] + loo2p*I2[475] - (fouro4zn)*I5[371];
*(vp++) = U00*I0[476] - U10*I3[476] + loo2p*I2[476] - (fouro4zn)*I5[372];
*(vp++) = U00*I0[477] - U10*I3[477] + loo2p*I2[477] - (fouro4zn)*I5[373];
*(vp++) = U00*I0[478] - U10*I3[478] + loo2p*I2[478] - (threeo4zn)*I5[374];
*(vp++) = U00*I0[479] - U10*I3[479] + loo2p*I2[479] - (threeo4zn)*I5[375];
*(vp++) = U00*I0[480] - U10*I3[480] + loo2p*I2[480] - (threeo4zn)*I5[376];
*(vp++) = U00*I0[481] - U10*I3[481] + loo2p*I2[481] - (threeo4zn)*I5[377];
*(vp++) = U00*I0[482] - U10*I3[482] + loo2p*I2[482] - (threeo4zn)*I5[378];
*(vp++) = U00*I0[483] - U10*I3[483] + loo2p*I2[483] - (twoo4zn)*I5[379];
*(vp++) = U00*I0[484] - U10*I3[484] + loo2p*I2[484] - (twoo4zn)*I5[380];
*(vp++) = U00*I0[485] - U10*I3[485] + loo2p*I2[485] - (twoo4zn)*I5[381];
*(vp++) = U00*I0[486] - U10*I3[486] + loo2p*I2[486] - (twoo4zn)*I5[382];
*(vp++) = U00*I0[487] - U10*I3[487] + loo2p*I2[487] - (twoo4zn)*I5[383];
*(vp++) = U00*I0[488] - U10*I3[488] + loo2p*I2[488] - (twoo4zn)*I5[384];
*(vp++) = U00*I0[489] - U10*I3[489] + loo2p*I2[489] - (oneo4zn)*I5[385];
*(vp++) = U00*I0[490] - U10*I3[490] + loo2p*I2[490] - (oneo4zn)*I5[386];
*(vp++) = U00*I0[491] - U10*I3[491] + loo2p*I2[491] - (oneo4zn)*I5[387];
*(vp++) = U00*I0[492] - U10*I3[492] + loo2p*I2[492] - (oneo4zn)*I5[388];
*(vp++) = U00*I0[493] - U10*I3[493] + loo2p*I2[493] - (oneo4zn)*I5[389];
*(vp++) = U00*I0[494] - U10*I3[494] + loo2p*I2[494] - (oneo4zn)*I5[390];
*(vp++) = U00*I0[495] - U10*I3[495] + loo2p*I2[495] - (oneo4zn)*I5[391];
*(vp++) = U00*I0[496] - U10*I3[496] + loo2p*I2[496];
*(vp++) = U00*I0[497] - U10*I3[497] + loo2p*I2[497];
*(vp++) = U00*I0[498] - U10*I3[498] + loo2p*I2[498];
*(vp++) = U00*I0[499] - U10*I3[499] + loo2p*I2[499];
*(vp++) = U00*I0[500] - U10*I3[500] + loo2p*I2[500];
*(vp++) = U00*I0[501] - U10*I3[501] + loo2p*I2[501];
*(vp++) = U00*I0[502] - U10*I3[502] + loo2p*I2[502];
*(vp++) = U00*I0[503] - U10*I3[503] + loo2p*I2[503];
*(vp++) = U00*I0[504] - U10*I3[504] + loo2p*I2[504] - (seveno4zn)*I5[392];
*(vp++) = U00*I0[505] - U10*I3[505] + loo2p*I2[505] - (sixo4zn)*I5[393];
return vp;
}

REALTYPE *_r_build_h0k0_2(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE seveno4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  seveno4zn = 7.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[506] - U10*I3[506] + loo2p*I2[506] - (sixo4zn)*I5[394];
*(vp++) = U00*I0[507] - U10*I3[507] + loo2p*I2[507] - (fiveo4zn)*I5[395];
*(vp++) = U00*I0[508] - U10*I3[508] + loo2p*I2[508] - (fiveo4zn)*I5[396];
*(vp++) = U00*I0[509] - U10*I3[509] + loo2p*I2[509] - (fiveo4zn)*I5[397];
*(vp++) = U00*I0[510] - U10*I3[510] + loo2p*I2[510] - (fouro4zn)*I5[398];
*(vp++) = U00*I0[511] - U10*I3[511] + loo2p*I2[511] - (fouro4zn)*I5[399];
*(vp++) = U00*I0[512] - U10*I3[512] + loo2p*I2[512] - (fouro4zn)*I5[400];
*(vp++) = U00*I0[513] - U10*I3[513] + loo2p*I2[513] - (fouro4zn)*I5[401];
*(vp++) = U00*I0[514] - U10*I3[514] + loo2p*I2[514] - (threeo4zn)*I5[402];
*(vp++) = U00*I0[515] - U10*I3[515] + loo2p*I2[515] - (threeo4zn)*I5[403];
*(vp++) = U00*I0[516] - U10*I3[516] + loo2p*I2[516] - (threeo4zn)*I5[404];
*(vp++) = U00*I0[517] - U10*I3[517] + loo2p*I2[517] - (threeo4zn)*I5[405];
*(vp++) = U00*I0[518] - U10*I3[518] + loo2p*I2[518] - (threeo4zn)*I5[406];
*(vp++) = U00*I0[519] - U10*I3[519] + loo2p*I2[519] - (twoo4zn)*I5[407];
*(vp++) = U00*I0[520] - U10*I3[520] + loo2p*I2[520] - (twoo4zn)*I5[408];
*(vp++) = U00*I0[521] - U10*I3[521] + loo2p*I2[521] - (twoo4zn)*I5[409];
*(vp++) = U00*I0[522] - U10*I3[522] + loo2p*I2[522] - (twoo4zn)*I5[410];
*(vp++) = U00*I0[523] - U10*I3[523] + loo2p*I2[523] - (twoo4zn)*I5[411];
*(vp++) = U00*I0[524] - U10*I3[524] + loo2p*I2[524] - (twoo4zn)*I5[412];
*(vp++) = U00*I0[525] - U10*I3[525] + loo2p*I2[525] - (oneo4zn)*I5[413];
*(vp++) = U00*I0[526] - U10*I3[526] + loo2p*I2[526] - (oneo4zn)*I5[414];
*(vp++) = U00*I0[527] - U10*I3[527] + loo2p*I2[527] - (oneo4zn)*I5[415];
*(vp++) = U00*I0[528] - U10*I3[528] + loo2p*I2[528] - (oneo4zn)*I5[416];
*(vp++) = U00*I0[529] - U10*I3[529] + loo2p*I2[529] - (oneo4zn)*I5[417];
*(vp++) = U00*I0[530] - U10*I3[530] + loo2p*I2[530] - (oneo4zn)*I5[418];
*(vp++) = U00*I0[531] - U10*I3[531] + loo2p*I2[531] - (oneo4zn)*I5[419];
*(vp++) = U00*I0[532] - U10*I3[532] + loo2p*I2[532];
*(vp++) = U00*I0[533] - U10*I3[533] + loo2p*I2[533];
*(vp++) = U00*I0[534] - U10*I3[534] + loo2p*I2[534];
*(vp++) = U00*I0[535] - U10*I3[535] + loo2p*I2[535];
*(vp++) = U00*I0[536] - U10*I3[536] + loo2p*I2[536];
*(vp++) = U00*I0[537] - U10*I3[537] + loo2p*I2[537];
*(vp++) = U00*I0[538] - U10*I3[538] + loo2p*I2[538];
*(vp++) = U00*I0[539] - U10*I3[539] + loo2p*I2[539];
*(vp++) = U01*I0[360] - U11*I3[360] + loo2p*I2[540]
        + (fouro2z)*I1[216] - (fouro4zn)*I4[216];
*(vp++) = U01*I0[361] - U11*I3[361] + loo2p*I2[541]
        + (fouro2z)*I1[217] - (fouro4zn)*I4[217] - (oneo4zn)*I5[280];
*(vp++) = U01*I0[362] - U11*I3[362] + loo2p*I2[542]
        + (fouro2z)*I1[218] - (fouro4zn)*I4[218];
*(vp++) = U01*I0[363] - U11*I3[363] + loo2p*I2[543]
        + (fouro2z)*I1[219] - (fouro4zn)*I4[219] - (twoo4zn)*I5[281];
*(vp++) = U01*I0[364] - U11*I3[364] + loo2p*I2[544]
        + (fouro2z)*I1[220] - (fouro4zn)*I4[220] - (oneo4zn)*I5[282];
*(vp++) = U01*I0[365] - U11*I3[365] + loo2p*I2[545]
        + (fouro2z)*I1[221] - (fouro4zn)*I4[221];
*(vp++) = U01*I0[366] - U11*I3[366] + loo2p*I2[546]
        + (fouro2z)*I1[222] - (fouro4zn)*I4[222] - (threeo4zn)*I5[283];
*(vp++) = U01*I0[367] - U11*I3[367] + loo2p*I2[547]
        + (fouro2z)*I1[223] - (fouro4zn)*I4[223] - (twoo4zn)*I5[284];
*(vp++) = U01*I0[368] - U11*I3[368] + loo2p*I2[548]
        + (fouro2z)*I1[224] - (fouro4zn)*I4[224] - (oneo4zn)*I5[285];
*(vp++) = U01*I0[369] - U11*I3[369] + loo2p*I2[549]
        + (fouro2z)*I1[225] - (fouro4zn)*I4[225];
*(vp++) = U01*I0[370] - U11*I3[370] + loo2p*I2[550]
        + (fouro2z)*I1[226] - (fouro4zn)*I4[226] - (fouro4zn)*I5[286];
*(vp++) = U01*I0[371] - U11*I3[371] + loo2p*I2[551]
        + (fouro2z)*I1[227] - (fouro4zn)*I4[227] - (threeo4zn)*I5[287];
*(vp++) = U01*I0[372] - U11*I3[372] + loo2p*I2[552]
        + (fouro2z)*I1[228] - (fouro4zn)*I4[228] - (twoo4zn)*I5[288];
*(vp++) = U01*I0[373] - U11*I3[373] + loo2p*I2[553]
        + (fouro2z)*I1[229] - (fouro4zn)*I4[229] - (oneo4zn)*I5[289];
*(vp++) = U01*I0[374] - U11*I3[374] + loo2p*I2[554]
        + (fouro2z)*I1[230] - (fouro4zn)*I4[230];
*(vp++) = U01*I0[375] - U11*I3[375] + loo2p*I2[555]
        + (fouro2z)*I1[231] - (fouro4zn)*I4[231] - (fiveo4zn)*I5[290];
*(vp++) = U01*I0[376] - U11*I3[376] + loo2p*I2[556]
        + (fouro2z)*I1[232] - (fouro4zn)*I4[232] - (fouro4zn)*I5[291];
*(vp++) = U01*I0[377] - U11*I3[377] + loo2p*I2[557]
        + (fouro2z)*I1[233] - (fouro4zn)*I4[233] - (threeo4zn)*I5[292];
*(vp++) = U01*I0[378] - U11*I3[378] + loo2p*I2[558]
        + (fouro2z)*I1[234] - (fouro4zn)*I4[234] - (twoo4zn)*I5[293];
*(vp++) = U01*I0[379] - U11*I3[379] + loo2p*I2[559]
        + (fouro2z)*I1[235] - (fouro4zn)*I4[235] - (oneo4zn)*I5[294];
*(vp++) = U01*I0[380] - U11*I3[380] + loo2p*I2[560]
        + (fouro2z)*I1[236] - (fouro4zn)*I4[236];
*(vp++) = U01*I0[381] - U11*I3[381] + loo2p*I2[561]
        + (fouro2z)*I1[237] - (fouro4zn)*I4[237] - (sixo4zn)*I5[295];
*(vp++) = U01*I0[382] - U11*I3[382] + loo2p*I2[562]
        + (fouro2z)*I1[238] - (fouro4zn)*I4[238] - (fiveo4zn)*I5[296];
*(vp++) = U01*I0[383] - U11*I3[383] + loo2p*I2[563]
        + (fouro2z)*I1[239] - (fouro4zn)*I4[239] - (fouro4zn)*I5[297];
*(vp++) = U01*I0[384] - U11*I3[384] + loo2p*I2[564]
        + (fouro2z)*I1[240] - (fouro4zn)*I4[240] - (threeo4zn)*I5[298];
*(vp++) = U01*I0[385] - U11*I3[385] + loo2p*I2[565]
        + (fouro2z)*I1[241] - (fouro4zn)*I4[241] - (twoo4zn)*I5[299];
*(vp++) = U01*I0[386] - U11*I3[386] + loo2p*I2[566]
        + (fouro2z)*I1[242] - (fouro4zn)*I4[242] - (oneo4zn)*I5[300];
*(vp++) = U01*I0[387] - U11*I3[387] + loo2p*I2[567]
        + (fouro2z)*I1[243] - (fouro4zn)*I4[243];
*(vp++) = U01*I0[388] - U11*I3[388] + loo2p*I2[568]
        + (fouro2z)*I1[244] - (fouro4zn)*I4[244] - (seveno4zn)*I5[301];
*(vp++) = U01*I0[389] - U11*I3[389] + loo2p*I2[569]
        + (fouro2z)*I1[245] - (fouro4zn)*I4[245] - (sixo4zn)*I5[302];
*(vp++) = U01*I0[390] - U11*I3[390] + loo2p*I2[570]
        + (fouro2z)*I1[246] - (fouro4zn)*I4[246] - (fiveo4zn)*I5[303];
*(vp++) = U01*I0[391] - U11*I3[391] + loo2p*I2[571]
        + (fouro2z)*I1[247] - (fouro4zn)*I4[247] - (fouro4zn)*I5[304];
*(vp++) = U01*I0[392] - U11*I3[392] + loo2p*I2[572]
        + (fouro2z)*I1[248] - (fouro4zn)*I4[248] - (threeo4zn)*I5[305];
*(vp++) = U01*I0[393] - U11*I3[393] + loo2p*I2[573]
        + (fouro2z)*I1[249] - (fouro4zn)*I4[249] - (twoo4zn)*I5[306];
*(vp++) = U01*I0[394] - U11*I3[394] + loo2p*I2[574]
        + (fouro2z)*I1[250] - (fouro4zn)*I4[250] - (oneo4zn)*I5[307];
*(vp++) = U01*I0[395] - U11*I3[395] + loo2p*I2[575]
        + (fouro2z)*I1[251] - (fouro4zn)*I4[251];
*(vp++) = U01*I0[396] - U11*I3[396] + loo2p*I2[576]
        + (threeo2z)*I1[252] - (threeo4zn)*I4[252];
*(vp++) = U01*I0[397] - U11*I3[397] + loo2p*I2[577]
        + (threeo2z)*I1[253] - (threeo4zn)*I4[253] - (oneo4zn)*I5[308];
*(vp++) = U01*I0[398] - U11*I3[398] + loo2p*I2[578]
        + (threeo2z)*I1[254] - (threeo4zn)*I4[254];
*(vp++) = U01*I0[399] - U11*I3[399] + loo2p*I2[579]
        + (threeo2z)*I1[255] - (threeo4zn)*I4[255] - (twoo4zn)*I5[309];
*(vp++) = U01*I0[400] - U11*I3[400] + loo2p*I2[580]
        + (threeo2z)*I1[256] - (threeo4zn)*I4[256] - (oneo4zn)*I5[310];
*(vp++) = U01*I0[401] - U11*I3[401] + loo2p*I2[581]
        + (threeo2z)*I1[257] - (threeo4zn)*I4[257];
*(vp++) = U01*I0[402] - U11*I3[402] + loo2p*I2[582]
        + (threeo2z)*I1[258] - (threeo4zn)*I4[258] - (threeo4zn)*I5[311];
*(vp++) = U01*I0[403] - U11*I3[403] + loo2p*I2[583]
        + (threeo2z)*I1[259] - (threeo4zn)*I4[259] - (twoo4zn)*I5[312];
*(vp++) = U01*I0[404] - U11*I3[404] + loo2p*I2[584]
        + (threeo2z)*I1[260] - (threeo4zn)*I4[260] - (oneo4zn)*I5[313];
*(vp++) = U01*I0[405] - U11*I3[405] + loo2p*I2[585]
        + (threeo2z)*I1[261] - (threeo4zn)*I4[261];
*(vp++) = U01*I0[406] - U11*I3[406] + loo2p*I2[586]
        + (threeo2z)*I1[262] - (threeo4zn)*I4[262] - (fouro4zn)*I5[314];
*(vp++) = U01*I0[407] - U11*I3[407] + loo2p*I2[587]
        + (threeo2z)*I1[263] - (threeo4zn)*I4[263] - (threeo4zn)*I5[315];
*(vp++) = U01*I0[408] - U11*I3[408] + loo2p*I2[588]
        + (threeo2z)*I1[264] - (threeo4zn)*I4[264] - (twoo4zn)*I5[316];
*(vp++) = U01*I0[409] - U11*I3[409] + loo2p*I2[589]
        + (threeo2z)*I1[265] - (threeo4zn)*I4[265] - (oneo4zn)*I5[317];
*(vp++) = U01*I0[410] - U11*I3[410] + loo2p*I2[590]
        + (threeo2z)*I1[266] - (threeo4zn)*I4[266];
*(vp++) = U01*I0[411] - U11*I3[411] + loo2p*I2[591]
        + (threeo2z)*I1[267] - (threeo4zn)*I4[267] - (fiveo4zn)*I5[318];
*(vp++) = U01*I0[412] - U11*I3[412] + loo2p*I2[592]
        + (threeo2z)*I1[268] - (threeo4zn)*I4[268] - (fouro4zn)*I5[319];
*(vp++) = U01*I0[413] - U11*I3[413] + loo2p*I2[593]
        + (threeo2z)*I1[269] - (threeo4zn)*I4[269] - (threeo4zn)*I5[320];
*(vp++) = U01*I0[414] - U11*I3[414] + loo2p*I2[594]
        + (threeo2z)*I1[270] - (threeo4zn)*I4[270] - (twoo4zn)*I5[321];
*(vp++) = U01*I0[415] - U11*I3[415] + loo2p*I2[595]
        + (threeo2z)*I1[271] - (threeo4zn)*I4[271] - (oneo4zn)*I5[322];
*(vp++) = U01*I0[416] - U11*I3[416] + loo2p*I2[596]
        + (threeo2z)*I1[272] - (threeo4zn)*I4[272];
*(vp++) = U01*I0[417] - U11*I3[417] + loo2p*I2[597]
        + (threeo2z)*I1[273] - (threeo4zn)*I4[273] - (sixo4zn)*I5[323];
*(vp++) = U01*I0[418] - U11*I3[418] + loo2p*I2[598]
        + (threeo2z)*I1[274] - (threeo4zn)*I4[274] - (fiveo4zn)*I5[324];
*(vp++) = U01*I0[419] - U11*I3[419] + loo2p*I2[599]
        + (threeo2z)*I1[275] - (threeo4zn)*I4[275] - (fouro4zn)*I5[325];
*(vp++) = U01*I0[420] - U11*I3[420] + loo2p*I2[600]
        + (threeo2z)*I1[276] - (threeo4zn)*I4[276] - (threeo4zn)*I5[326];
*(vp++) = U01*I0[421] - U11*I3[421] + loo2p*I2[601]
        + (threeo2z)*I1[277] - (threeo4zn)*I4[277] - (twoo4zn)*I5[327];
*(vp++) = U01*I0[422] - U11*I3[422] + loo2p*I2[602]
        + (threeo2z)*I1[278] - (threeo4zn)*I4[278] - (oneo4zn)*I5[328];
*(vp++) = U01*I0[423] - U11*I3[423] + loo2p*I2[603]
        + (threeo2z)*I1[279] - (threeo4zn)*I4[279];
*(vp++) = U01*I0[424] - U11*I3[424] + loo2p*I2[604]
        + (threeo2z)*I1[280] - (threeo4zn)*I4[280] - (seveno4zn)*I5[329];
*(vp++) = U01*I0[425] - U11*I3[425] + loo2p*I2[605]
        + (threeo2z)*I1[281] - (threeo4zn)*I4[281] - (sixo4zn)*I5[330];
*(vp++) = U01*I0[426] - U11*I3[426] + loo2p*I2[606]
        + (threeo2z)*I1[282] - (threeo4zn)*I4[282] - (fiveo4zn)*I5[331];
*(vp++) = U01*I0[427] - U11*I3[427] + loo2p*I2[607]
        + (threeo2z)*I1[283] - (threeo4zn)*I4[283] - (fouro4zn)*I5[332];
*(vp++) = U01*I0[428] - U11*I3[428] + loo2p*I2[608]
        + (threeo2z)*I1[284] - (threeo4zn)*I4[284] - (threeo4zn)*I5[333];
*(vp++) = U01*I0[429] - U11*I3[429] + loo2p*I2[609]
        + (threeo2z)*I1[285] - (threeo4zn)*I4[285] - (twoo4zn)*I5[334];
*(vp++) = U01*I0[430] - U11*I3[430] + loo2p*I2[610]
        + (threeo2z)*I1[286] - (threeo4zn)*I4[286] - (oneo4zn)*I5[335];
*(vp++) = U01*I0[431] - U11*I3[431] + loo2p*I2[611]
        + (threeo2z)*I1[287] - (threeo4zn)*I4[287];
*(vp++) = U01*I0[432] - U11*I3[432] + loo2p*I2[612]
        + (twoo2z)*I1[288] - (twoo4zn)*I4[288];
*(vp++) = U01*I0[433] - U11*I3[433] + loo2p*I2[613]
        + (twoo2z)*I1[289] - (twoo4zn)*I4[289] - (oneo4zn)*I5[336];
*(vp++) = U01*I0[434] - U11*I3[434] + loo2p*I2[614]
        + (twoo2z)*I1[290] - (twoo4zn)*I4[290];
*(vp++) = U01*I0[435] - U11*I3[435] + loo2p*I2[615]
        + (twoo2z)*I1[291] - (twoo4zn)*I4[291] - (twoo4zn)*I5[337];
*(vp++) = U01*I0[436] - U11*I3[436] + loo2p*I2[616]
        + (twoo2z)*I1[292] - (twoo4zn)*I4[292] - (oneo4zn)*I5[338];
*(vp++) = U01*I0[437] - U11*I3[437] + loo2p*I2[617]
        + (twoo2z)*I1[293] - (twoo4zn)*I4[293];
*(vp++) = U01*I0[438] - U11*I3[438] + loo2p*I2[618]
        + (twoo2z)*I1[294] - (twoo4zn)*I4[294] - (threeo4zn)*I5[339];
*(vp++) = U01*I0[439] - U11*I3[439] + loo2p*I2[619]
        + (twoo2z)*I1[295] - (twoo4zn)*I4[295] - (twoo4zn)*I5[340];
*(vp++) = U01*I0[440] - U11*I3[440] + loo2p*I2[620]
        + (twoo2z)*I1[296] - (twoo4zn)*I4[296] - (oneo4zn)*I5[341];
*(vp++) = U01*I0[441] - U11*I3[441] + loo2p*I2[621]
        + (twoo2z)*I1[297] - (twoo4zn)*I4[297];
*(vp++) = U01*I0[442] - U11*I3[442] + loo2p*I2[622]
        + (twoo2z)*I1[298] - (twoo4zn)*I4[298] - (fouro4zn)*I5[342];
*(vp++) = U01*I0[443] - U11*I3[443] + loo2p*I2[623]
        + (twoo2z)*I1[299] - (twoo4zn)*I4[299] - (threeo4zn)*I5[343];
*(vp++) = U01*I0[444] - U11*I3[444] + loo2p*I2[624]
        + (twoo2z)*I1[300] - (twoo4zn)*I4[300] - (twoo4zn)*I5[344];
*(vp++) = U01*I0[445] - U11*I3[445] + loo2p*I2[625]
        + (twoo2z)*I1[301] - (twoo4zn)*I4[301] - (oneo4zn)*I5[345];
*(vp++) = U01*I0[446] - U11*I3[446] + loo2p*I2[626]
        + (twoo2z)*I1[302] - (twoo4zn)*I4[302];
*(vp++) = U01*I0[447] - U11*I3[447] + loo2p*I2[627]
        + (twoo2z)*I1[303] - (twoo4zn)*I4[303] - (fiveo4zn)*I5[346];
*(vp++) = U01*I0[448] - U11*I3[448] + loo2p*I2[628]
        + (twoo2z)*I1[304] - (twoo4zn)*I4[304] - (fouro4zn)*I5[347];
*(vp++) = U01*I0[449] - U11*I3[449] + loo2p*I2[629]
        + (twoo2z)*I1[305] - (twoo4zn)*I4[305] - (threeo4zn)*I5[348];
*(vp++) = U01*I0[450] - U11*I3[450] + loo2p*I2[630]
        + (twoo2z)*I1[306] - (twoo4zn)*I4[306] - (twoo4zn)*I5[349];
*(vp++) = U01*I0[451] - U11*I3[451] + loo2p*I2[631]
        + (twoo2z)*I1[307] - (twoo4zn)*I4[307] - (oneo4zn)*I5[350];
*(vp++) = U01*I0[452] - U11*I3[452] + loo2p*I2[632]
        + (twoo2z)*I1[308] - (twoo4zn)*I4[308];
*(vp++) = U01*I0[453] - U11*I3[453] + loo2p*I2[633]
        + (twoo2z)*I1[309] - (twoo4zn)*I4[309] - (sixo4zn)*I5[351];
*(vp++) = U01*I0[454] - U11*I3[454] + loo2p*I2[634]
        + (twoo2z)*I1[310] - (twoo4zn)*I4[310] - (fiveo4zn)*I5[352];
*(vp++) = U01*I0[455] - U11*I3[455] + loo2p*I2[635]
        + (twoo2z)*I1[311] - (twoo4zn)*I4[311] - (fouro4zn)*I5[353];
*(vp++) = U01*I0[456] - U11*I3[456] + loo2p*I2[636]
        + (twoo2z)*I1[312] - (twoo4zn)*I4[312] - (threeo4zn)*I5[354];
*(vp++) = U01*I0[457] - U11*I3[457] + loo2p*I2[637]
        + (twoo2z)*I1[313] - (twoo4zn)*I4[313] - (twoo4zn)*I5[355];
*(vp++) = U01*I0[458] - U11*I3[458] + loo2p*I2[638]
        + (twoo2z)*I1[314] - (twoo4zn)*I4[314] - (oneo4zn)*I5[356];
*(vp++) = U01*I0[459] - U11*I3[459] + loo2p*I2[639]
        + (twoo2z)*I1[315] - (twoo4zn)*I4[315];
*(vp++) = U01*I0[460] - U11*I3[460] + loo2p*I2[640]
        + (twoo2z)*I1[316] - (twoo4zn)*I4[316] - (seveno4zn)*I5[357];
*(vp++) = U01*I0[461] - U11*I3[461] + loo2p*I2[641]
        + (twoo2z)*I1[317] - (twoo4zn)*I4[317] - (sixo4zn)*I5[358];
*(vp++) = U01*I0[462] - U11*I3[462] + loo2p*I2[642]
        + (twoo2z)*I1[318] - (twoo4zn)*I4[318] - (fiveo4zn)*I5[359];
*(vp++) = U01*I0[463] - U11*I3[463] + loo2p*I2[643]
        + (twoo2z)*I1[319] - (twoo4zn)*I4[319] - (fouro4zn)*I5[360];
*(vp++) = U01*I0[464] - U11*I3[464] + loo2p*I2[644]
        + (twoo2z)*I1[320] - (twoo4zn)*I4[320] - (threeo4zn)*I5[361];
*(vp++) = U01*I0[465] - U11*I3[465] + loo2p*I2[645]
        + (twoo2z)*I1[321] - (twoo4zn)*I4[321] - (twoo4zn)*I5[362];
*(vp++) = U01*I0[466] - U11*I3[466] + loo2p*I2[646]
        + (twoo2z)*I1[322] - (twoo4zn)*I4[322] - (oneo4zn)*I5[363];
*(vp++) = U01*I0[467] - U11*I3[467] + loo2p*I2[647]
        + (twoo2z)*I1[323] - (twoo4zn)*I4[323];
*(vp++) = U01*I0[468] - U11*I3[468] + loo2p*I2[648]
        + (oneo2z)*I1[324] - (oneo4zn)*I4[324];
*(vp++) = U01*I0[469] - U11*I3[469] + loo2p*I2[649]
        + (oneo2z)*I1[325] - (oneo4zn)*I4[325] - (oneo4zn)*I5[364];
*(vp++) = U01*I0[470] - U11*I3[470] + loo2p*I2[650]
        + (oneo2z)*I1[326] - (oneo4zn)*I4[326];
*(vp++) = U01*I0[471] - U11*I3[471] + loo2p*I2[651]
        + (oneo2z)*I1[327] - (oneo4zn)*I4[327] - (twoo4zn)*I5[365];
*(vp++) = U01*I0[472] - U11*I3[472] + loo2p*I2[652]
        + (oneo2z)*I1[328] - (oneo4zn)*I4[328] - (oneo4zn)*I5[366];
*(vp++) = U01*I0[473] - U11*I3[473] + loo2p*I2[653]
        + (oneo2z)*I1[329] - (oneo4zn)*I4[329];
*(vp++) = U01*I0[474] - U11*I3[474] + loo2p*I2[654]
        + (oneo2z)*I1[330] - (oneo4zn)*I4[330] - (threeo4zn)*I5[367];
*(vp++) = U01*I0[475] - U11*I3[475] + loo2p*I2[655]
        + (oneo2z)*I1[331] - (oneo4zn)*I4[331] - (twoo4zn)*I5[368];
*(vp++) = U01*I0[476] - U11*I3[476] + loo2p*I2[656]
        + (oneo2z)*I1[332] - (oneo4zn)*I4[332] - (oneo4zn)*I5[369];
*(vp++) = U01*I0[477] - U11*I3[477] + loo2p*I2[657]
        + (oneo2z)*I1[333] - (oneo4zn)*I4[333];
*(vp++) = U01*I0[478] - U11*I3[478] + loo2p*I2[658]
        + (oneo2z)*I1[334] - (oneo4zn)*I4[334] - (fouro4zn)*I5[370];
*(vp++) = U01*I0[479] - U11*I3[479] + loo2p*I2[659]
        + (oneo2z)*I1[335] - (oneo4zn)*I4[335] - (threeo4zn)*I5[371];
*(vp++) = U01*I0[480] - U11*I3[480] + loo2p*I2[660]
        + (oneo2z)*I1[336] - (oneo4zn)*I4[336] - (twoo4zn)*I5[372];
*(vp++) = U01*I0[481] - U11*I3[481] + loo2p*I2[661]
        + (oneo2z)*I1[337] - (oneo4zn)*I4[337] - (oneo4zn)*I5[373];
*(vp++) = U01*I0[482] - U11*I3[482] + loo2p*I2[662]
        + (oneo2z)*I1[338] - (oneo4zn)*I4[338];
*(vp++) = U01*I0[483] - U11*I3[483] + loo2p*I2[663]
        + (oneo2z)*I1[339] - (oneo4zn)*I4[339] - (fiveo4zn)*I5[374];
*(vp++) = U01*I0[484] - U11*I3[484] + loo2p*I2[664]
        + (oneo2z)*I1[340] - (oneo4zn)*I4[340] - (fouro4zn)*I5[375];
*(vp++) = U01*I0[485] - U11*I3[485] + loo2p*I2[665]
        + (oneo2z)*I1[341] - (oneo4zn)*I4[341] - (threeo4zn)*I5[376];
*(vp++) = U01*I0[486] - U11*I3[486] + loo2p*I2[666]
        + (oneo2z)*I1[342] - (oneo4zn)*I4[342] - (twoo4zn)*I5[377];
*(vp++) = U01*I0[487] - U11*I3[487] + loo2p*I2[667]
        + (oneo2z)*I1[343] - (oneo4zn)*I4[343] - (oneo4zn)*I5[378];
*(vp++) = U01*I0[488] - U11*I3[488] + loo2p*I2[668]
        + (oneo2z)*I1[344] - (oneo4zn)*I4[344];
*(vp++) = U01*I0[489] - U11*I3[489] + loo2p*I2[669]
        + (oneo2z)*I1[345] - (oneo4zn)*I4[345] - (sixo4zn)*I5[379];
*(vp++) = U01*I0[490] - U11*I3[490] + loo2p*I2[670]
        + (oneo2z)*I1[346] - (oneo4zn)*I4[346] - (fiveo4zn)*I5[380];
*(vp++) = U01*I0[491] - U11*I3[491] + loo2p*I2[671]
        + (oneo2z)*I1[347] - (oneo4zn)*I4[347] - (fouro4zn)*I5[381];
*(vp++) = U01*I0[492] - U11*I3[492] + loo2p*I2[672]
        + (oneo2z)*I1[348] - (oneo4zn)*I4[348] - (threeo4zn)*I5[382];
*(vp++) = U01*I0[493] - U11*I3[493] + loo2p*I2[673]
        + (oneo2z)*I1[349] - (oneo4zn)*I4[349] - (twoo4zn)*I5[383];
*(vp++) = U01*I0[494] - U11*I3[494] + loo2p*I2[674]
        + (oneo2z)*I1[350] - (oneo4zn)*I4[350] - (oneo4zn)*I5[384];
*(vp++) = U01*I0[495] - U11*I3[495] + loo2p*I2[675]
        + (oneo2z)*I1[351] - (oneo4zn)*I4[351];
*(vp++) = U01*I0[496] - U11*I3[496] + loo2p*I2[676]
        + (oneo2z)*I1[352] - (oneo4zn)*I4[352] - (seveno4zn)*I5[385];
*(vp++) = U01*I0[497] - U11*I3[497] + loo2p*I2[677]
        + (oneo2z)*I1[353] - (oneo4zn)*I4[353] - (sixo4zn)*I5[386];
*(vp++) = U01*I0[498] - U11*I3[498] + loo2p*I2[678]
        + (oneo2z)*I1[354] - (oneo4zn)*I4[354] - (fiveo4zn)*I5[387];
*(vp++) = U01*I0[499] - U11*I3[499] + loo2p*I2[679]
        + (oneo2z)*I1[355] - (oneo4zn)*I4[355] - (fouro4zn)*I5[388];
*(vp++) = U01*I0[500] - U11*I3[500] + loo2p*I2[680]
        + (oneo2z)*I1[356] - (oneo4zn)*I4[356] - (threeo4zn)*I5[389];
*(vp++) = U01*I0[501] - U11*I3[501] + loo2p*I2[681]
        + (oneo2z)*I1[357] - (oneo4zn)*I4[357] - (twoo4zn)*I5[390];
*(vp++) = U01*I0[502] - U11*I3[502] + loo2p*I2[682]
        + (oneo2z)*I1[358] - (oneo4zn)*I4[358] - (oneo4zn)*I5[391];
*(vp++) = U01*I0[503] - U11*I3[503] + loo2p*I2[683]
        + (oneo2z)*I1[359] - (oneo4zn)*I4[359];
*(vp++) = U01*I0[504] - U11*I3[504] + loo2p*I2[684];
*(vp++) = U01*I0[505] - U11*I3[505] + loo2p*I2[685] - (oneo4zn)*I5[392];
*(vp++) = U01*I0[506] - U11*I3[506] + loo2p*I2[686];
*(vp++) = U01*I0[507] - U11*I3[507] + loo2p*I2[687] - (twoo4zn)*I5[393];
*(vp++) = U01*I0[508] - U11*I3[508] + loo2p*I2[688] - (oneo4zn)*I5[394];
*(vp++) = U01*I0[509] - U11*I3[509] + loo2p*I2[689];
*(vp++) = U01*I0[510] - U11*I3[510] + loo2p*I2[690] - (threeo4zn)*I5[395];
*(vp++) = U01*I0[511] - U11*I3[511] + loo2p*I2[691] - (twoo4zn)*I5[396];
*(vp++) = U01*I0[512] - U11*I3[512] + loo2p*I2[692] - (oneo4zn)*I5[397];
*(vp++) = U01*I0[513] - U11*I3[513] + loo2p*I2[693];
*(vp++) = U01*I0[514] - U11*I3[514] + loo2p*I2[694] - (fouro4zn)*I5[398];
*(vp++) = U01*I0[515] - U11*I3[515] + loo2p*I2[695] - (threeo4zn)*I5[399];
*(vp++) = U01*I0[516] - U11*I3[516] + loo2p*I2[696] - (twoo4zn)*I5[400];
*(vp++) = U01*I0[517] - U11*I3[517] + loo2p*I2[697] - (oneo4zn)*I5[401];
*(vp++) = U01*I0[518] - U11*I3[518] + loo2p*I2[698];
*(vp++) = U01*I0[519] - U11*I3[519] + loo2p*I2[699] - (fiveo4zn)*I5[402];
*(vp++) = U01*I0[520] - U11*I3[520] + loo2p*I2[700] - (fouro4zn)*I5[403];
*(vp++) = U01*I0[521] - U11*I3[521] + loo2p*I2[701] - (threeo4zn)*I5[404];
*(vp++) = U01*I0[522] - U11*I3[522] + loo2p*I2[702] - (twoo4zn)*I5[405];
*(vp++) = U01*I0[523] - U11*I3[523] + loo2p*I2[703] - (oneo4zn)*I5[406];
*(vp++) = U01*I0[524] - U11*I3[524] + loo2p*I2[704];
*(vp++) = U01*I0[525] - U11*I3[525] + loo2p*I2[705] - (sixo4zn)*I5[407];
*(vp++) = U01*I0[526] - U11*I3[526] + loo2p*I2[706] - (fiveo4zn)*I5[408];
*(vp++) = U01*I0[527] - U11*I3[527] + loo2p*I2[707] - (fouro4zn)*I5[409];
*(vp++) = U01*I0[528] - U11*I3[528] + loo2p*I2[708] - (threeo4zn)*I5[410];
*(vp++) = U01*I0[529] - U11*I3[529] + loo2p*I2[709] - (twoo4zn)*I5[411];
*(vp++) = U01*I0[530] - U11*I3[530] + loo2p*I2[710] - (oneo4zn)*I5[412];
*(vp++) = U01*I0[531] - U11*I3[531] + loo2p*I2[711];
*(vp++) = U01*I0[532] - U11*I3[532] + loo2p*I2[712] - (seveno4zn)*I5[413];
*(vp++) = U01*I0[533] - U11*I3[533] + loo2p*I2[713] - (sixo4zn)*I5[414];
*(vp++) = U01*I0[534] - U11*I3[534] + loo2p*I2[714] - (fiveo4zn)*I5[415];
*(vp++) = U01*I0[535] - U11*I3[535] + loo2p*I2[715] - (fouro4zn)*I5[416];
*(vp++) = U01*I0[536] - U11*I3[536] + loo2p*I2[716] - (threeo4zn)*I5[417];
*(vp++) = U01*I0[537] - U11*I3[537] + loo2p*I2[717] - (twoo4zn)*I5[418];
*(vp++) = U01*I0[538] - U11*I3[538] + loo2p*I2[718] - (oneo4zn)*I5[419];
*(vp++) = U01*I0[539] - U11*I3[539] + loo2p*I2[719];
*(vp++) = U02*I0[504] - U12*I3[504] + loo2p*I2[720]
        + (fouro2z)*I1[324] - (fouro4zn)*I4[324];
*(vp++) = U02*I0[505] - U12*I3[505] + loo2p*I2[721]
        + (fouro2z)*I1[325] - (fouro4zn)*I4[325];
*(vp++) = U02*I0[506] - U12*I3[506] + loo2p*I2[722]
        + (fouro2z)*I1[326] - (fouro4zn)*I4[326] - (oneo4zn)*I5[392];
*(vp++) = U02*I0[507] - U12*I3[507] + loo2p*I2[723]
        + (fouro2z)*I1[327] - (fouro4zn)*I4[327];
*(vp++) = U02*I0[508] - U12*I3[508] + loo2p*I2[724]
        + (fouro2z)*I1[328] - (fouro4zn)*I4[328] - (oneo4zn)*I5[393];
*(vp++) = U02*I0[509] - U12*I3[509] + loo2p*I2[725]
        + (fouro2z)*I1[329] - (fouro4zn)*I4[329] - (twoo4zn)*I5[394];
*(vp++) = U02*I0[510] - U12*I3[510] + loo2p*I2[726]
        + (fouro2z)*I1[330] - (fouro4zn)*I4[330];
*(vp++) = U02*I0[511] - U12*I3[511] + loo2p*I2[727]
        + (fouro2z)*I1[331] - (fouro4zn)*I4[331] - (oneo4zn)*I5[395];
*(vp++) = U02*I0[512] - U12*I3[512] + loo2p*I2[728]
        + (fouro2z)*I1[332] - (fouro4zn)*I4[332] - (twoo4zn)*I5[396];
*(vp++) = U02*I0[513] - U12*I3[513] + loo2p*I2[729]
        + (fouro2z)*I1[333] - (fouro4zn)*I4[333] - (threeo4zn)*I5[397];
*(vp++) = U02*I0[514] - U12*I3[514] + loo2p*I2[730]
        + (fouro2z)*I1[334] - (fouro4zn)*I4[334];
*(vp++) = U02*I0[515] - U12*I3[515] + loo2p*I2[731]
        + (fouro2z)*I1[335] - (fouro4zn)*I4[335] - (oneo4zn)*I5[398];
*(vp++) = U02*I0[516] - U12*I3[516] + loo2p*I2[732]
        + (fouro2z)*I1[336] - (fouro4zn)*I4[336] - (twoo4zn)*I5[399];
*(vp++) = U02*I0[517] - U12*I3[517] + loo2p*I2[733]
        + (fouro2z)*I1[337] - (fouro4zn)*I4[337] - (threeo4zn)*I5[400];
*(vp++) = U02*I0[518] - U12*I3[518] + loo2p*I2[734]
        + (fouro2z)*I1[338] - (fouro4zn)*I4[338] - (fouro4zn)*I5[401];
*(vp++) = U02*I0[519] - U12*I3[519] + loo2p*I2[735]
        + (fouro2z)*I1[339] - (fouro4zn)*I4[339];
*(vp++) = U02*I0[520] - U12*I3[520] + loo2p*I2[736]
        + (fouro2z)*I1[340] - (fouro4zn)*I4[340] - (oneo4zn)*I5[402];
*(vp++) = U02*I0[521] - U12*I3[521] + loo2p*I2[737]
        + (fouro2z)*I1[341] - (fouro4zn)*I4[341] - (twoo4zn)*I5[403];
*(vp++) = U02*I0[522] - U12*I3[522] + loo2p*I2[738]
        + (fouro2z)*I1[342] - (fouro4zn)*I4[342] - (threeo4zn)*I5[404];
*(vp++) = U02*I0[523] - U12*I3[523] + loo2p*I2[739]
        + (fouro2z)*I1[343] - (fouro4zn)*I4[343] - (fouro4zn)*I5[405];
*(vp++) = U02*I0[524] - U12*I3[524] + loo2p*I2[740]
        + (fouro2z)*I1[344] - (fouro4zn)*I4[344] - (fiveo4zn)*I5[406];
*(vp++) = U02*I0[525] - U12*I3[525] + loo2p*I2[741]
        + (fouro2z)*I1[345] - (fouro4zn)*I4[345];
*(vp++) = U02*I0[526] - U12*I3[526] + loo2p*I2[742]
        + (fouro2z)*I1[346] - (fouro4zn)*I4[346] - (oneo4zn)*I5[407];
*(vp++) = U02*I0[527] - U12*I3[527] + loo2p*I2[743]
        + (fouro2z)*I1[347] - (fouro4zn)*I4[347] - (twoo4zn)*I5[408];
*(vp++) = U02*I0[528] - U12*I3[528] + loo2p*I2[744]
        + (fouro2z)*I1[348] - (fouro4zn)*I4[348] - (threeo4zn)*I5[409];
*(vp++) = U02*I0[529] - U12*I3[529] + loo2p*I2[745]
        + (fouro2z)*I1[349] - (fouro4zn)*I4[349] - (fouro4zn)*I5[410];
*(vp++) = U02*I0[530] - U12*I3[530] + loo2p*I2[746]
        + (fouro2z)*I1[350] - (fouro4zn)*I4[350] - (fiveo4zn)*I5[411];
*(vp++) = U02*I0[531] - U12*I3[531] + loo2p*I2[747]
        + (fouro2z)*I1[351] - (fouro4zn)*I4[351] - (sixo4zn)*I5[412];
*(vp++) = U02*I0[532] - U12*I3[532] + loo2p*I2[748]
        + (fouro2z)*I1[352] - (fouro4zn)*I4[352];
*(vp++) = U02*I0[533] - U12*I3[533] + loo2p*I2[749]
        + (fouro2z)*I1[353] - (fouro4zn)*I4[353] - (oneo4zn)*I5[413];
*(vp++) = U02*I0[534] - U12*I3[534] + loo2p*I2[750]
        + (fouro2z)*I1[354] - (fouro4zn)*I4[354] - (twoo4zn)*I5[414];
*(vp++) = U02*I0[535] - U12*I3[535] + loo2p*I2[751]
        + (fouro2z)*I1[355] - (fouro4zn)*I4[355] - (threeo4zn)*I5[415];
*(vp++) = U02*I0[536] - U12*I3[536] + loo2p*I2[752]
        + (fouro2z)*I1[356] - (fouro4zn)*I4[356] - (fouro4zn)*I5[416];
*(vp++) = U02*I0[537] - U12*I3[537] + loo2p*I2[753]
        + (fouro2z)*I1[357] - (fouro4zn)*I4[357] - (fiveo4zn)*I5[417];
*(vp++) = U02*I0[538] - U12*I3[538] + loo2p*I2[754]
        + (fouro2z)*I1[358] - (fouro4zn)*I4[358] - (sixo4zn)*I5[418];
*(vp++) = U02*I0[539] - U12*I3[539] + loo2p*I2[755]
        + (fouro2z)*I1[359] - (fouro4zn)*I4[359] - (seveno4zn)*I5[419];
return vp;
}
