/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ks||fs) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_r_build_k0f0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (sixo2z)*I1[0] - (sixo4zn)*I4[0] - (threeo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (sixo2z)*I1[1] - (sixo4zn)*I4[1] - (twoo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (sixo2z)*I1[2] - (sixo4zn)*I4[2] - (twoo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (sixo2z)*I1[3] - (sixo4zn)*I4[3] - (oneo4zn)*I5[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (sixo2z)*I1[4] - (sixo4zn)*I4[4] - (oneo4zn)*I5[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (sixo2z)*I1[5] - (sixo4zn)*I4[5] - (oneo4zn)*I5[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (sixo2z)*I1[6] - (sixo4zn)*I4[6];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (sixo2z)*I1[7] - (sixo4zn)*I4[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (sixo2z)*I1[8] - (sixo4zn)*I4[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (sixo2z)*I1[9] - (sixo4zn)*I4[9];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (fiveo2z)*I1[10] - (fiveo4zn)*I4[10] - (threeo4zn)*I5[6];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (fiveo2z)*I1[11] - (fiveo4zn)*I4[11] - (twoo4zn)*I5[7];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (fiveo2z)*I1[12] - (fiveo4zn)*I4[12] - (twoo4zn)*I5[8];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (fiveo2z)*I1[13] - (fiveo4zn)*I4[13] - (oneo4zn)*I5[9];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (fiveo2z)*I1[14] - (fiveo4zn)*I4[14] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (fiveo2z)*I1[15] - (fiveo4zn)*I4[15] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (fiveo2z)*I1[16] - (fiveo4zn)*I4[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (fiveo2z)*I1[17] - (fiveo4zn)*I4[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (fiveo2z)*I1[18] - (fiveo4zn)*I4[18];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (fiveo2z)*I1[19] - (fiveo4zn)*I4[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (fiveo2z)*I1[20] - (fiveo4zn)*I4[20] - (threeo4zn)*I5[12];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (fiveo2z)*I1[21] - (fiveo4zn)*I4[21] - (twoo4zn)*I5[13];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (fiveo2z)*I1[22] - (fiveo4zn)*I4[22] - (twoo4zn)*I5[14];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (fiveo2z)*I1[23] - (fiveo4zn)*I4[23] - (oneo4zn)*I5[15];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (fiveo2z)*I1[24] - (fiveo4zn)*I4[24] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (fiveo2z)*I1[25] - (fiveo4zn)*I4[25] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (fiveo2z)*I1[26] - (fiveo4zn)*I4[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (fiveo2z)*I1[27] - (fiveo4zn)*I4[27];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (fiveo2z)*I1[28] - (fiveo4zn)*I4[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (fiveo2z)*I1[29] - (fiveo4zn)*I4[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (fouro2z)*I1[30] - (fouro4zn)*I4[30] - (threeo4zn)*I5[18];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (fouro2z)*I1[31] - (fouro4zn)*I4[31] - (twoo4zn)*I5[19];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (fouro2z)*I1[32] - (fouro4zn)*I4[32] - (twoo4zn)*I5[20];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (fouro2z)*I1[33] - (fouro4zn)*I4[33] - (oneo4zn)*I5[21];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (fouro2z)*I1[34] - (fouro4zn)*I4[34] - (oneo4zn)*I5[22];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (fouro2z)*I1[35] - (fouro4zn)*I4[35] - (oneo4zn)*I5[23];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (fouro2z)*I1[36] - (fouro4zn)*I4[36];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (fouro2z)*I1[37] - (fouro4zn)*I4[37];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (fouro2z)*I1[38] - (fouro4zn)*I4[38];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (fouro2z)*I1[39] - (fouro4zn)*I4[39];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (fouro2z)*I1[40] - (fouro4zn)*I4[40] - (threeo4zn)*I5[24];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (fouro2z)*I1[41] - (fouro4zn)*I4[41] - (twoo4zn)*I5[25];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (fouro2z)*I1[42] - (fouro4zn)*I4[42] - (twoo4zn)*I5[26];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (fouro2z)*I1[43] - (fouro4zn)*I4[43] - (oneo4zn)*I5[27];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (fouro2z)*I1[44] - (fouro4zn)*I4[44] - (oneo4zn)*I5[28];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45]
        + (fouro2z)*I1[45] - (fouro4zn)*I4[45] - (oneo4zn)*I5[29];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46]
        + (fouro2z)*I1[46] - (fouro4zn)*I4[46];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47]
        + (fouro2z)*I1[47] - (fouro4zn)*I4[47];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48]
        + (fouro2z)*I1[48] - (fouro4zn)*I4[48];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49]
        + (fouro2z)*I1[49] - (fouro4zn)*I4[49];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50]
        + (fouro2z)*I1[50] - (fouro4zn)*I4[50] - (threeo4zn)*I5[30];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51]
        + (fouro2z)*I1[51] - (fouro4zn)*I4[51] - (twoo4zn)*I5[31];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52]
        + (fouro2z)*I1[52] - (fouro4zn)*I4[52] - (twoo4zn)*I5[32];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53]
        + (fouro2z)*I1[53] - (fouro4zn)*I4[53] - (oneo4zn)*I5[33];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54]
        + (fouro2z)*I1[54] - (fouro4zn)*I4[54] - (oneo4zn)*I5[34];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55]
        + (fouro2z)*I1[55] - (fouro4zn)*I4[55] - (oneo4zn)*I5[35];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56]
        + (fouro2z)*I1[56] - (fouro4zn)*I4[56];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57]
        + (fouro2z)*I1[57] - (fouro4zn)*I4[57];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58]
        + (fouro2z)*I1[58] - (fouro4zn)*I4[58];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59]
        + (fouro2z)*I1[59] - (fouro4zn)*I4[59];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60]
        + (threeo2z)*I1[60] - (threeo4zn)*I4[60] - (threeo4zn)*I5[36];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61]
        + (threeo2z)*I1[61] - (threeo4zn)*I4[61] - (twoo4zn)*I5[37];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62]
        + (threeo2z)*I1[62] - (threeo4zn)*I4[62] - (twoo4zn)*I5[38];
*(vp++) = U00*I0[63] - U10*I3[63] + loo2p*I2[63]
        + (threeo2z)*I1[63] - (threeo4zn)*I4[63] - (oneo4zn)*I5[39];
*(vp++) = U00*I0[64] - U10*I3[64] + loo2p*I2[64]
        + (threeo2z)*I1[64] - (threeo4zn)*I4[64] - (oneo4zn)*I5[40];
*(vp++) = U00*I0[65] - U10*I3[65] + loo2p*I2[65]
        + (threeo2z)*I1[65] - (threeo4zn)*I4[65] - (oneo4zn)*I5[41];
*(vp++) = U00*I0[66] - U10*I3[66] + loo2p*I2[66]
        + (threeo2z)*I1[66] - (threeo4zn)*I4[66];
*(vp++) = U00*I0[67] - U10*I3[67] + loo2p*I2[67]
        + (threeo2z)*I1[67] - (threeo4zn)*I4[67];
*(vp++) = U00*I0[68] - U10*I3[68] + loo2p*I2[68]
        + (threeo2z)*I1[68] - (threeo4zn)*I4[68];
*(vp++) = U00*I0[69] - U10*I3[69] + loo2p*I2[69]
        + (threeo2z)*I1[69] - (threeo4zn)*I4[69];
*(vp++) = U00*I0[70] - U10*I3[70] + loo2p*I2[70]
        + (threeo2z)*I1[70] - (threeo4zn)*I4[70] - (threeo4zn)*I5[42];
*(vp++) = U00*I0[71] - U10*I3[71] + loo2p*I2[71]
        + (threeo2z)*I1[71] - (threeo4zn)*I4[71] - (twoo4zn)*I5[43];
*(vp++) = U00*I0[72] - U10*I3[72] + loo2p*I2[72]
        + (threeo2z)*I1[72] - (threeo4zn)*I4[72] - (twoo4zn)*I5[44];
*(vp++) = U00*I0[73] - U10*I3[73] + loo2p*I2[73]
        + (threeo2z)*I1[73] - (threeo4zn)*I4[73] - (oneo4zn)*I5[45];
*(vp++) = U00*I0[74] - U10*I3[74] + loo2p*I2[74]
        + (threeo2z)*I1[74] - (threeo4zn)*I4[74] - (oneo4zn)*I5[46];
*(vp++) = U00*I0[75] - U10*I3[75] + loo2p*I2[75]
        + (threeo2z)*I1[75] - (threeo4zn)*I4[75] - (oneo4zn)*I5[47];
*(vp++) = U00*I0[76] - U10*I3[76] + loo2p*I2[76]
        + (threeo2z)*I1[76] - (threeo4zn)*I4[76];
*(vp++) = U00*I0[77] - U10*I3[77] + loo2p*I2[77]
        + (threeo2z)*I1[77] - (threeo4zn)*I4[77];
*(vp++) = U00*I0[78] - U10*I3[78] + loo2p*I2[78]
        + (threeo2z)*I1[78] - (threeo4zn)*I4[78];
*(vp++) = U00*I0[79] - U10*I3[79] + loo2p*I2[79]
        + (threeo2z)*I1[79] - (threeo4zn)*I4[79];
*(vp++) = U00*I0[80] - U10*I3[80] + loo2p*I2[80]
        + (threeo2z)*I1[80] - (threeo4zn)*I4[80] - (threeo4zn)*I5[48];
*(vp++) = U00*I0[81] - U10*I3[81] + loo2p*I2[81]
        + (threeo2z)*I1[81] - (threeo4zn)*I4[81] - (twoo4zn)*I5[49];
*(vp++) = U00*I0[82] - U10*I3[82] + loo2p*I2[82]
        + (threeo2z)*I1[82] - (threeo4zn)*I4[82] - (twoo4zn)*I5[50];
*(vp++) = U00*I0[83] - U10*I3[83] + loo2p*I2[83]
        + (threeo2z)*I1[83] - (threeo4zn)*I4[83] - (oneo4zn)*I5[51];
*(vp++) = U00*I0[84] - U10*I3[84] + loo2p*I2[84]
        + (threeo2z)*I1[84] - (threeo4zn)*I4[84] - (oneo4zn)*I5[52];
*(vp++) = U00*I0[85] - U10*I3[85] + loo2p*I2[85]
        + (threeo2z)*I1[85] - (threeo4zn)*I4[85] - (oneo4zn)*I5[53];
*(vp++) = U00*I0[86] - U10*I3[86] + loo2p*I2[86]
        + (threeo2z)*I1[86] - (threeo4zn)*I4[86];
*(vp++) = U00*I0[87] - U10*I3[87] + loo2p*I2[87]
        + (threeo2z)*I1[87] - (threeo4zn)*I4[87];
*(vp++) = U00*I0[88] - U10*I3[88] + loo2p*I2[88]
        + (threeo2z)*I1[88] - (threeo4zn)*I4[88];
*(vp++) = U00*I0[89] - U10*I3[89] + loo2p*I2[89]
        + (threeo2z)*I1[89] - (threeo4zn)*I4[89];
*(vp++) = U00*I0[90] - U10*I3[90] + loo2p*I2[90]
        + (threeo2z)*I1[90] - (threeo4zn)*I4[90] - (threeo4zn)*I5[54];
*(vp++) = U00*I0[91] - U10*I3[91] + loo2p*I2[91]
        + (threeo2z)*I1[91] - (threeo4zn)*I4[91] - (twoo4zn)*I5[55];
*(vp++) = U00*I0[92] - U10*I3[92] + loo2p*I2[92]
        + (threeo2z)*I1[92] - (threeo4zn)*I4[92] - (twoo4zn)*I5[56];
*(vp++) = U00*I0[93] - U10*I3[93] + loo2p*I2[93]
        + (threeo2z)*I1[93] - (threeo4zn)*I4[93] - (oneo4zn)*I5[57];
*(vp++) = U00*I0[94] - U10*I3[94] + loo2p*I2[94]
        + (threeo2z)*I1[94] - (threeo4zn)*I4[94] - (oneo4zn)*I5[58];
*(vp++) = U00*I0[95] - U10*I3[95] + loo2p*I2[95]
        + (threeo2z)*I1[95] - (threeo4zn)*I4[95] - (oneo4zn)*I5[59];
*(vp++) = U00*I0[96] - U10*I3[96] + loo2p*I2[96]
        + (threeo2z)*I1[96] - (threeo4zn)*I4[96];
*(vp++) = U00*I0[97] - U10*I3[97] + loo2p*I2[97]
        + (threeo2z)*I1[97] - (threeo4zn)*I4[97];
*(vp++) = U00*I0[98] - U10*I3[98] + loo2p*I2[98]
        + (threeo2z)*I1[98] - (threeo4zn)*I4[98];
*(vp++) = U00*I0[99] - U10*I3[99] + loo2p*I2[99]
        + (threeo2z)*I1[99] - (threeo4zn)*I4[99];
*(vp++) = U00*I0[100] - U10*I3[100] + loo2p*I2[100]
        + (twoo2z)*I1[100] - (twoo4zn)*I4[100] - (threeo4zn)*I5[60];
*(vp++) = U00*I0[101] - U10*I3[101] + loo2p*I2[101]
        + (twoo2z)*I1[101] - (twoo4zn)*I4[101] - (twoo4zn)*I5[61];
*(vp++) = U00*I0[102] - U10*I3[102] + loo2p*I2[102]
        + (twoo2z)*I1[102] - (twoo4zn)*I4[102] - (twoo4zn)*I5[62];
*(vp++) = U00*I0[103] - U10*I3[103] + loo2p*I2[103]
        + (twoo2z)*I1[103] - (twoo4zn)*I4[103] - (oneo4zn)*I5[63];
*(vp++) = U00*I0[104] - U10*I3[104] + loo2p*I2[104]
        + (twoo2z)*I1[104] - (twoo4zn)*I4[104] - (oneo4zn)*I5[64];
*(vp++) = U00*I0[105] - U10*I3[105] + loo2p*I2[105]
        + (twoo2z)*I1[105] - (twoo4zn)*I4[105] - (oneo4zn)*I5[65];
*(vp++) = U00*I0[106] - U10*I3[106] + loo2p*I2[106]
        + (twoo2z)*I1[106] - (twoo4zn)*I4[106];
*(vp++) = U00*I0[107] - U10*I3[107] + loo2p*I2[107]
        + (twoo2z)*I1[107] - (twoo4zn)*I4[107];
*(vp++) = U00*I0[108] - U10*I3[108] + loo2p*I2[108]
        + (twoo2z)*I1[108] - (twoo4zn)*I4[108];
*(vp++) = U00*I0[109] - U10*I3[109] + loo2p*I2[109]
        + (twoo2z)*I1[109] - (twoo4zn)*I4[109];
*(vp++) = U00*I0[110] - U10*I3[110] + loo2p*I2[110]
        + (twoo2z)*I1[110] - (twoo4zn)*I4[110] - (threeo4zn)*I5[66];
*(vp++) = U00*I0[111] - U10*I3[111] + loo2p*I2[111]
        + (twoo2z)*I1[111] - (twoo4zn)*I4[111] - (twoo4zn)*I5[67];
*(vp++) = U00*I0[112] - U10*I3[112] + loo2p*I2[112]
        + (twoo2z)*I1[112] - (twoo4zn)*I4[112] - (twoo4zn)*I5[68];
*(vp++) = U00*I0[113] - U10*I3[113] + loo2p*I2[113]
        + (twoo2z)*I1[113] - (twoo4zn)*I4[113] - (oneo4zn)*I5[69];
*(vp++) = U00*I0[114] - U10*I3[114] + loo2p*I2[114]
        + (twoo2z)*I1[114] - (twoo4zn)*I4[114] - (oneo4zn)*I5[70];
*(vp++) = U00*I0[115] - U10*I3[115] + loo2p*I2[115]
        + (twoo2z)*I1[115] - (twoo4zn)*I4[115] - (oneo4zn)*I5[71];
*(vp++) = U00*I0[116] - U10*I3[116] + loo2p*I2[116]
        + (twoo2z)*I1[116] - (twoo4zn)*I4[116];
*(vp++) = U00*I0[117] - U10*I3[117] + loo2p*I2[117]
        + (twoo2z)*I1[117] - (twoo4zn)*I4[117];
*(vp++) = U00*I0[118] - U10*I3[118] + loo2p*I2[118]
        + (twoo2z)*I1[118] - (twoo4zn)*I4[118];
*(vp++) = U00*I0[119] - U10*I3[119] + loo2p*I2[119]
        + (twoo2z)*I1[119] - (twoo4zn)*I4[119];
*(vp++) = U00*I0[120] - U10*I3[120] + loo2p*I2[120]
        + (twoo2z)*I1[120] - (twoo4zn)*I4[120] - (threeo4zn)*I5[72];
*(vp++) = U00*I0[121] - U10*I3[121] + loo2p*I2[121]
        + (twoo2z)*I1[121] - (twoo4zn)*I4[121] - (twoo4zn)*I5[73];
*(vp++) = U00*I0[122] - U10*I3[122] + loo2p*I2[122]
        + (twoo2z)*I1[122] - (twoo4zn)*I4[122] - (twoo4zn)*I5[74];
*(vp++) = U00*I0[123] - U10*I3[123] + loo2p*I2[123]
        + (twoo2z)*I1[123] - (twoo4zn)*I4[123] - (oneo4zn)*I5[75];
*(vp++) = U00*I0[124] - U10*I3[124] + loo2p*I2[124]
        + (twoo2z)*I1[124] - (twoo4zn)*I4[124] - (oneo4zn)*I5[76];
*(vp++) = U00*I0[125] - U10*I3[125] + loo2p*I2[125]
        + (twoo2z)*I1[125] - (twoo4zn)*I4[125] - (oneo4zn)*I5[77];
*(vp++) = U00*I0[126] - U10*I3[126] + loo2p*I2[126]
        + (twoo2z)*I1[126] - (twoo4zn)*I4[126];
*(vp++) = U00*I0[127] - U10*I3[127] + loo2p*I2[127]
        + (twoo2z)*I1[127] - (twoo4zn)*I4[127];
*(vp++) = U00*I0[128] - U10*I3[128] + loo2p*I2[128]
        + (twoo2z)*I1[128] - (twoo4zn)*I4[128];
*(vp++) = U00*I0[129] - U10*I3[129] + loo2p*I2[129]
        + (twoo2z)*I1[129] - (twoo4zn)*I4[129];
*(vp++) = U00*I0[130] - U10*I3[130] + loo2p*I2[130]
        + (twoo2z)*I1[130] - (twoo4zn)*I4[130] - (threeo4zn)*I5[78];
*(vp++) = U00*I0[131] - U10*I3[131] + loo2p*I2[131]
        + (twoo2z)*I1[131] - (twoo4zn)*I4[131] - (twoo4zn)*I5[79];
*(vp++) = U00*I0[132] - U10*I3[132] + loo2p*I2[132]
        + (twoo2z)*I1[132] - (twoo4zn)*I4[132] - (twoo4zn)*I5[80];
*(vp++) = U00*I0[133] - U10*I3[133] + loo2p*I2[133]
        + (twoo2z)*I1[133] - (twoo4zn)*I4[133] - (oneo4zn)*I5[81];
*(vp++) = U00*I0[134] - U10*I3[134] + loo2p*I2[134]
        + (twoo2z)*I1[134] - (twoo4zn)*I4[134] - (oneo4zn)*I5[82];
*(vp++) = U00*I0[135] - U10*I3[135] + loo2p*I2[135]
        + (twoo2z)*I1[135] - (twoo4zn)*I4[135] - (oneo4zn)*I5[83];
*(vp++) = U00*I0[136] - U10*I3[136] + loo2p*I2[136]
        + (twoo2z)*I1[136] - (twoo4zn)*I4[136];
*(vp++) = U00*I0[137] - U10*I3[137] + loo2p*I2[137]
        + (twoo2z)*I1[137] - (twoo4zn)*I4[137];
*(vp++) = U00*I0[138] - U10*I3[138] + loo2p*I2[138]
        + (twoo2z)*I1[138] - (twoo4zn)*I4[138];
*(vp++) = U00*I0[139] - U10*I3[139] + loo2p*I2[139]
        + (twoo2z)*I1[139] - (twoo4zn)*I4[139];
*(vp++) = U00*I0[140] - U10*I3[140] + loo2p*I2[140]
        + (twoo2z)*I1[140] - (twoo4zn)*I4[140] - (threeo4zn)*I5[84];
*(vp++) = U00*I0[141] - U10*I3[141] + loo2p*I2[141]
        + (twoo2z)*I1[141] - (twoo4zn)*I4[141] - (twoo4zn)*I5[85];
*(vp++) = U00*I0[142] - U10*I3[142] + loo2p*I2[142]
        + (twoo2z)*I1[142] - (twoo4zn)*I4[142] - (twoo4zn)*I5[86];
*(vp++) = U00*I0[143] - U10*I3[143] + loo2p*I2[143]
        + (twoo2z)*I1[143] - (twoo4zn)*I4[143] - (oneo4zn)*I5[87];
*(vp++) = U00*I0[144] - U10*I3[144] + loo2p*I2[144]
        + (twoo2z)*I1[144] - (twoo4zn)*I4[144] - (oneo4zn)*I5[88];
*(vp++) = U00*I0[145] - U10*I3[145] + loo2p*I2[145]
        + (twoo2z)*I1[145] - (twoo4zn)*I4[145] - (oneo4zn)*I5[89];
*(vp++) = U00*I0[146] - U10*I3[146] + loo2p*I2[146]
        + (twoo2z)*I1[146] - (twoo4zn)*I4[146];
*(vp++) = U00*I0[147] - U10*I3[147] + loo2p*I2[147]
        + (twoo2z)*I1[147] - (twoo4zn)*I4[147];
*(vp++) = U00*I0[148] - U10*I3[148] + loo2p*I2[148]
        + (twoo2z)*I1[148] - (twoo4zn)*I4[148];
*(vp++) = U00*I0[149] - U10*I3[149] + loo2p*I2[149]
        + (twoo2z)*I1[149] - (twoo4zn)*I4[149];
*(vp++) = U00*I0[150] - U10*I3[150] + loo2p*I2[150]
        + (oneo2z)*I1[150] - (oneo4zn)*I4[150] - (threeo4zn)*I5[90];
*(vp++) = U00*I0[151] - U10*I3[151] + loo2p*I2[151]
        + (oneo2z)*I1[151] - (oneo4zn)*I4[151] - (twoo4zn)*I5[91];
*(vp++) = U00*I0[152] - U10*I3[152] + loo2p*I2[152]
        + (oneo2z)*I1[152] - (oneo4zn)*I4[152] - (twoo4zn)*I5[92];
*(vp++) = U00*I0[153] - U10*I3[153] + loo2p*I2[153]
        + (oneo2z)*I1[153] - (oneo4zn)*I4[153] - (oneo4zn)*I5[93];
*(vp++) = U00*I0[154] - U10*I3[154] + loo2p*I2[154]
        + (oneo2z)*I1[154] - (oneo4zn)*I4[154] - (oneo4zn)*I5[94];
*(vp++) = U00*I0[155] - U10*I3[155] + loo2p*I2[155]
        + (oneo2z)*I1[155] - (oneo4zn)*I4[155] - (oneo4zn)*I5[95];
*(vp++) = U00*I0[156] - U10*I3[156] + loo2p*I2[156]
        + (oneo2z)*I1[156] - (oneo4zn)*I4[156];
*(vp++) = U00*I0[157] - U10*I3[157] + loo2p*I2[157]
        + (oneo2z)*I1[157] - (oneo4zn)*I4[157];
*(vp++) = U00*I0[158] - U10*I3[158] + loo2p*I2[158]
        + (oneo2z)*I1[158] - (oneo4zn)*I4[158];
*(vp++) = U00*I0[159] - U10*I3[159] + loo2p*I2[159]
        + (oneo2z)*I1[159] - (oneo4zn)*I4[159];
*(vp++) = U00*I0[160] - U10*I3[160] + loo2p*I2[160]
        + (oneo2z)*I1[160] - (oneo4zn)*I4[160] - (threeo4zn)*I5[96];
*(vp++) = U00*I0[161] - U10*I3[161] + loo2p*I2[161]
        + (oneo2z)*I1[161] - (oneo4zn)*I4[161] - (twoo4zn)*I5[97];
*(vp++) = U00*I0[162] - U10*I3[162] + loo2p*I2[162]
        + (oneo2z)*I1[162] - (oneo4zn)*I4[162] - (twoo4zn)*I5[98];
*(vp++) = U00*I0[163] - U10*I3[163] + loo2p*I2[163]
        + (oneo2z)*I1[163] - (oneo4zn)*I4[163] - (oneo4zn)*I5[99];
*(vp++) = U00*I0[164] - U10*I3[164] + loo2p*I2[164]
        + (oneo2z)*I1[164] - (oneo4zn)*I4[164] - (oneo4zn)*I5[100];
*(vp++) = U00*I0[165] - U10*I3[165] + loo2p*I2[165]
        + (oneo2z)*I1[165] - (oneo4zn)*I4[165] - (oneo4zn)*I5[101];
*(vp++) = U00*I0[166] - U10*I3[166] + loo2p*I2[166]
        + (oneo2z)*I1[166] - (oneo4zn)*I4[166];
*(vp++) = U00*I0[167] - U10*I3[167] + loo2p*I2[167]
        + (oneo2z)*I1[167] - (oneo4zn)*I4[167];
*(vp++) = U00*I0[168] - U10*I3[168] + loo2p*I2[168]
        + (oneo2z)*I1[168] - (oneo4zn)*I4[168];
*(vp++) = U00*I0[169] - U10*I3[169] + loo2p*I2[169]
        + (oneo2z)*I1[169] - (oneo4zn)*I4[169];
*(vp++) = U00*I0[170] - U10*I3[170] + loo2p*I2[170]
        + (oneo2z)*I1[170] - (oneo4zn)*I4[170] - (threeo4zn)*I5[102];
*(vp++) = U00*I0[171] - U10*I3[171] + loo2p*I2[171]
        + (oneo2z)*I1[171] - (oneo4zn)*I4[171] - (twoo4zn)*I5[103];
*(vp++) = U00*I0[172] - U10*I3[172] + loo2p*I2[172]
        + (oneo2z)*I1[172] - (oneo4zn)*I4[172] - (twoo4zn)*I5[104];
*(vp++) = U00*I0[173] - U10*I3[173] + loo2p*I2[173]
        + (oneo2z)*I1[173] - (oneo4zn)*I4[173] - (oneo4zn)*I5[105];
*(vp++) = U00*I0[174] - U10*I3[174] + loo2p*I2[174]
        + (oneo2z)*I1[174] - (oneo4zn)*I4[174] - (oneo4zn)*I5[106];
*(vp++) = U00*I0[175] - U10*I3[175] + loo2p*I2[175]
        + (oneo2z)*I1[175] - (oneo4zn)*I4[175] - (oneo4zn)*I5[107];
*(vp++) = U00*I0[176] - U10*I3[176] + loo2p*I2[176]
        + (oneo2z)*I1[176] - (oneo4zn)*I4[176];
*(vp++) = U00*I0[177] - U10*I3[177] + loo2p*I2[177]
        + (oneo2z)*I1[177] - (oneo4zn)*I4[177];
*(vp++) = U00*I0[178] - U10*I3[178] + loo2p*I2[178]
        + (oneo2z)*I1[178] - (oneo4zn)*I4[178];
*(vp++) = U00*I0[179] - U10*I3[179] + loo2p*I2[179]
        + (oneo2z)*I1[179] - (oneo4zn)*I4[179];
*(vp++) = U00*I0[180] - U10*I3[180] + loo2p*I2[180]
        + (oneo2z)*I1[180] - (oneo4zn)*I4[180] - (threeo4zn)*I5[108];
return vp;
}

REALTYPE *_r_build_k0f0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE sixo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  sixo4zn = 6.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[181] - U10*I3[181] + loo2p*I2[181]
        + (oneo2z)*I1[181] - (oneo4zn)*I4[181] - (twoo4zn)*I5[109];
*(vp++) = U00*I0[182] - U10*I3[182] + loo2p*I2[182]
        + (oneo2z)*I1[182] - (oneo4zn)*I4[182] - (twoo4zn)*I5[110];
*(vp++) = U00*I0[183] - U10*I3[183] + loo2p*I2[183]
        + (oneo2z)*I1[183] - (oneo4zn)*I4[183] - (oneo4zn)*I5[111];
*(vp++) = U00*I0[184] - U10*I3[184] + loo2p*I2[184]
        + (oneo2z)*I1[184] - (oneo4zn)*I4[184] - (oneo4zn)*I5[112];
*(vp++) = U00*I0[185] - U10*I3[185] + loo2p*I2[185]
        + (oneo2z)*I1[185] - (oneo4zn)*I4[185] - (oneo4zn)*I5[113];
*(vp++) = U00*I0[186] - U10*I3[186] + loo2p*I2[186]
        + (oneo2z)*I1[186] - (oneo4zn)*I4[186];
*(vp++) = U00*I0[187] - U10*I3[187] + loo2p*I2[187]
        + (oneo2z)*I1[187] - (oneo4zn)*I4[187];
*(vp++) = U00*I0[188] - U10*I3[188] + loo2p*I2[188]
        + (oneo2z)*I1[188] - (oneo4zn)*I4[188];
*(vp++) = U00*I0[189] - U10*I3[189] + loo2p*I2[189]
        + (oneo2z)*I1[189] - (oneo4zn)*I4[189];
*(vp++) = U00*I0[190] - U10*I3[190] + loo2p*I2[190]
        + (oneo2z)*I1[190] - (oneo4zn)*I4[190] - (threeo4zn)*I5[114];
*(vp++) = U00*I0[191] - U10*I3[191] + loo2p*I2[191]
        + (oneo2z)*I1[191] - (oneo4zn)*I4[191] - (twoo4zn)*I5[115];
*(vp++) = U00*I0[192] - U10*I3[192] + loo2p*I2[192]
        + (oneo2z)*I1[192] - (oneo4zn)*I4[192] - (twoo4zn)*I5[116];
*(vp++) = U00*I0[193] - U10*I3[193] + loo2p*I2[193]
        + (oneo2z)*I1[193] - (oneo4zn)*I4[193] - (oneo4zn)*I5[117];
*(vp++) = U00*I0[194] - U10*I3[194] + loo2p*I2[194]
        + (oneo2z)*I1[194] - (oneo4zn)*I4[194] - (oneo4zn)*I5[118];
*(vp++) = U00*I0[195] - U10*I3[195] + loo2p*I2[195]
        + (oneo2z)*I1[195] - (oneo4zn)*I4[195] - (oneo4zn)*I5[119];
*(vp++) = U00*I0[196] - U10*I3[196] + loo2p*I2[196]
        + (oneo2z)*I1[196] - (oneo4zn)*I4[196];
*(vp++) = U00*I0[197] - U10*I3[197] + loo2p*I2[197]
        + (oneo2z)*I1[197] - (oneo4zn)*I4[197];
*(vp++) = U00*I0[198] - U10*I3[198] + loo2p*I2[198]
        + (oneo2z)*I1[198] - (oneo4zn)*I4[198];
*(vp++) = U00*I0[199] - U10*I3[199] + loo2p*I2[199]
        + (oneo2z)*I1[199] - (oneo4zn)*I4[199];
*(vp++) = U00*I0[200] - U10*I3[200] + loo2p*I2[200]
        + (oneo2z)*I1[200] - (oneo4zn)*I4[200] - (threeo4zn)*I5[120];
*(vp++) = U00*I0[201] - U10*I3[201] + loo2p*I2[201]
        + (oneo2z)*I1[201] - (oneo4zn)*I4[201] - (twoo4zn)*I5[121];
*(vp++) = U00*I0[202] - U10*I3[202] + loo2p*I2[202]
        + (oneo2z)*I1[202] - (oneo4zn)*I4[202] - (twoo4zn)*I5[122];
*(vp++) = U00*I0[203] - U10*I3[203] + loo2p*I2[203]
        + (oneo2z)*I1[203] - (oneo4zn)*I4[203] - (oneo4zn)*I5[123];
*(vp++) = U00*I0[204] - U10*I3[204] + loo2p*I2[204]
        + (oneo2z)*I1[204] - (oneo4zn)*I4[204] - (oneo4zn)*I5[124];
*(vp++) = U00*I0[205] - U10*I3[205] + loo2p*I2[205]
        + (oneo2z)*I1[205] - (oneo4zn)*I4[205] - (oneo4zn)*I5[125];
*(vp++) = U00*I0[206] - U10*I3[206] + loo2p*I2[206]
        + (oneo2z)*I1[206] - (oneo4zn)*I4[206];
*(vp++) = U00*I0[207] - U10*I3[207] + loo2p*I2[207]
        + (oneo2z)*I1[207] - (oneo4zn)*I4[207];
*(vp++) = U00*I0[208] - U10*I3[208] + loo2p*I2[208]
        + (oneo2z)*I1[208] - (oneo4zn)*I4[208];
*(vp++) = U00*I0[209] - U10*I3[209] + loo2p*I2[209]
        + (oneo2z)*I1[209] - (oneo4zn)*I4[209];
*(vp++) = U00*I0[210] - U10*I3[210] + loo2p*I2[210] - (threeo4zn)*I5[126];
*(vp++) = U00*I0[211] - U10*I3[211] + loo2p*I2[211] - (twoo4zn)*I5[127];
*(vp++) = U00*I0[212] - U10*I3[212] + loo2p*I2[212] - (twoo4zn)*I5[128];
*(vp++) = U00*I0[213] - U10*I3[213] + loo2p*I2[213] - (oneo4zn)*I5[129];
*(vp++) = U00*I0[214] - U10*I3[214] + loo2p*I2[214] - (oneo4zn)*I5[130];
*(vp++) = U00*I0[215] - U10*I3[215] + loo2p*I2[215] - (oneo4zn)*I5[131];
*(vp++) = U00*I0[216] - U10*I3[216] + loo2p*I2[216];
*(vp++) = U00*I0[217] - U10*I3[217] + loo2p*I2[217];
*(vp++) = U00*I0[218] - U10*I3[218] + loo2p*I2[218];
*(vp++) = U00*I0[219] - U10*I3[219] + loo2p*I2[219];
*(vp++) = U00*I0[220] - U10*I3[220] + loo2p*I2[220] - (threeo4zn)*I5[132];
*(vp++) = U00*I0[221] - U10*I3[221] + loo2p*I2[221] - (twoo4zn)*I5[133];
*(vp++) = U00*I0[222] - U10*I3[222] + loo2p*I2[222] - (twoo4zn)*I5[134];
*(vp++) = U00*I0[223] - U10*I3[223] + loo2p*I2[223] - (oneo4zn)*I5[135];
*(vp++) = U00*I0[224] - U10*I3[224] + loo2p*I2[224] - (oneo4zn)*I5[136];
*(vp++) = U00*I0[225] - U10*I3[225] + loo2p*I2[225] - (oneo4zn)*I5[137];
*(vp++) = U00*I0[226] - U10*I3[226] + loo2p*I2[226];
*(vp++) = U00*I0[227] - U10*I3[227] + loo2p*I2[227];
*(vp++) = U00*I0[228] - U10*I3[228] + loo2p*I2[228];
*(vp++) = U00*I0[229] - U10*I3[229] + loo2p*I2[229];
*(vp++) = U00*I0[230] - U10*I3[230] + loo2p*I2[230] - (threeo4zn)*I5[138];
*(vp++) = U00*I0[231] - U10*I3[231] + loo2p*I2[231] - (twoo4zn)*I5[139];
*(vp++) = U00*I0[232] - U10*I3[232] + loo2p*I2[232] - (twoo4zn)*I5[140];
*(vp++) = U00*I0[233] - U10*I3[233] + loo2p*I2[233] - (oneo4zn)*I5[141];
*(vp++) = U00*I0[234] - U10*I3[234] + loo2p*I2[234] - (oneo4zn)*I5[142];
*(vp++) = U00*I0[235] - U10*I3[235] + loo2p*I2[235] - (oneo4zn)*I5[143];
*(vp++) = U00*I0[236] - U10*I3[236] + loo2p*I2[236];
*(vp++) = U00*I0[237] - U10*I3[237] + loo2p*I2[237];
*(vp++) = U00*I0[238] - U10*I3[238] + loo2p*I2[238];
*(vp++) = U00*I0[239] - U10*I3[239] + loo2p*I2[239];
*(vp++) = U00*I0[240] - U10*I3[240] + loo2p*I2[240] - (threeo4zn)*I5[144];
*(vp++) = U00*I0[241] - U10*I3[241] + loo2p*I2[241] - (twoo4zn)*I5[145];
*(vp++) = U00*I0[242] - U10*I3[242] + loo2p*I2[242] - (twoo4zn)*I5[146];
*(vp++) = U00*I0[243] - U10*I3[243] + loo2p*I2[243] - (oneo4zn)*I5[147];
*(vp++) = U00*I0[244] - U10*I3[244] + loo2p*I2[244] - (oneo4zn)*I5[148];
*(vp++) = U00*I0[245] - U10*I3[245] + loo2p*I2[245] - (oneo4zn)*I5[149];
*(vp++) = U00*I0[246] - U10*I3[246] + loo2p*I2[246];
*(vp++) = U00*I0[247] - U10*I3[247] + loo2p*I2[247];
*(vp++) = U00*I0[248] - U10*I3[248] + loo2p*I2[248];
*(vp++) = U00*I0[249] - U10*I3[249] + loo2p*I2[249];
*(vp++) = U00*I0[250] - U10*I3[250] + loo2p*I2[250] - (threeo4zn)*I5[150];
*(vp++) = U00*I0[251] - U10*I3[251] + loo2p*I2[251] - (twoo4zn)*I5[151];
*(vp++) = U00*I0[252] - U10*I3[252] + loo2p*I2[252] - (twoo4zn)*I5[152];
*(vp++) = U00*I0[253] - U10*I3[253] + loo2p*I2[253] - (oneo4zn)*I5[153];
*(vp++) = U00*I0[254] - U10*I3[254] + loo2p*I2[254] - (oneo4zn)*I5[154];
*(vp++) = U00*I0[255] - U10*I3[255] + loo2p*I2[255] - (oneo4zn)*I5[155];
*(vp++) = U00*I0[256] - U10*I3[256] + loo2p*I2[256];
*(vp++) = U00*I0[257] - U10*I3[257] + loo2p*I2[257];
*(vp++) = U00*I0[258] - U10*I3[258] + loo2p*I2[258];
*(vp++) = U00*I0[259] - U10*I3[259] + loo2p*I2[259];
*(vp++) = U00*I0[260] - U10*I3[260] + loo2p*I2[260] - (threeo4zn)*I5[156];
*(vp++) = U00*I0[261] - U10*I3[261] + loo2p*I2[261] - (twoo4zn)*I5[157];
*(vp++) = U00*I0[262] - U10*I3[262] + loo2p*I2[262] - (twoo4zn)*I5[158];
*(vp++) = U00*I0[263] - U10*I3[263] + loo2p*I2[263] - (oneo4zn)*I5[159];
*(vp++) = U00*I0[264] - U10*I3[264] + loo2p*I2[264] - (oneo4zn)*I5[160];
*(vp++) = U00*I0[265] - U10*I3[265] + loo2p*I2[265] - (oneo4zn)*I5[161];
*(vp++) = U00*I0[266] - U10*I3[266] + loo2p*I2[266];
*(vp++) = U00*I0[267] - U10*I3[267] + loo2p*I2[267];
*(vp++) = U00*I0[268] - U10*I3[268] + loo2p*I2[268];
*(vp++) = U00*I0[269] - U10*I3[269] + loo2p*I2[269];
*(vp++) = U00*I0[270] - U10*I3[270] + loo2p*I2[270] - (threeo4zn)*I5[162];
*(vp++) = U00*I0[271] - U10*I3[271] + loo2p*I2[271] - (twoo4zn)*I5[163];
*(vp++) = U00*I0[272] - U10*I3[272] + loo2p*I2[272] - (twoo4zn)*I5[164];
*(vp++) = U00*I0[273] - U10*I3[273] + loo2p*I2[273] - (oneo4zn)*I5[165];
*(vp++) = U00*I0[274] - U10*I3[274] + loo2p*I2[274] - (oneo4zn)*I5[166];
*(vp++) = U00*I0[275] - U10*I3[275] + loo2p*I2[275] - (oneo4zn)*I5[167];
*(vp++) = U00*I0[276] - U10*I3[276] + loo2p*I2[276];
*(vp++) = U00*I0[277] - U10*I3[277] + loo2p*I2[277];
*(vp++) = U00*I0[278] - U10*I3[278] + loo2p*I2[278];
*(vp++) = U00*I0[279] - U10*I3[279] + loo2p*I2[279];
*(vp++) = U01*I0[210] - U11*I3[210] + loo2p*I2[280]
        + (sixo2z)*I1[150] - (sixo4zn)*I4[150];
*(vp++) = U01*I0[211] - U11*I3[211] + loo2p*I2[281]
        + (sixo2z)*I1[151] - (sixo4zn)*I4[151] - (oneo4zn)*I5[126];
*(vp++) = U01*I0[212] - U11*I3[212] + loo2p*I2[282]
        + (sixo2z)*I1[152] - (sixo4zn)*I4[152];
*(vp++) = U01*I0[213] - U11*I3[213] + loo2p*I2[283]
        + (sixo2z)*I1[153] - (sixo4zn)*I4[153] - (twoo4zn)*I5[127];
*(vp++) = U01*I0[214] - U11*I3[214] + loo2p*I2[284]
        + (sixo2z)*I1[154] - (sixo4zn)*I4[154] - (oneo4zn)*I5[128];
*(vp++) = U01*I0[215] - U11*I3[215] + loo2p*I2[285]
        + (sixo2z)*I1[155] - (sixo4zn)*I4[155];
*(vp++) = U01*I0[216] - U11*I3[216] + loo2p*I2[286]
        + (sixo2z)*I1[156] - (sixo4zn)*I4[156] - (threeo4zn)*I5[129];
*(vp++) = U01*I0[217] - U11*I3[217] + loo2p*I2[287]
        + (sixo2z)*I1[157] - (sixo4zn)*I4[157] - (twoo4zn)*I5[130];
*(vp++) = U01*I0[218] - U11*I3[218] + loo2p*I2[288]
        + (sixo2z)*I1[158] - (sixo4zn)*I4[158] - (oneo4zn)*I5[131];
*(vp++) = U01*I0[219] - U11*I3[219] + loo2p*I2[289]
        + (sixo2z)*I1[159] - (sixo4zn)*I4[159];
*(vp++) = U01*I0[220] - U11*I3[220] + loo2p*I2[290]
        + (fiveo2z)*I1[160] - (fiveo4zn)*I4[160];
*(vp++) = U01*I0[221] - U11*I3[221] + loo2p*I2[291]
        + (fiveo2z)*I1[161] - (fiveo4zn)*I4[161] - (oneo4zn)*I5[132];
*(vp++) = U01*I0[222] - U11*I3[222] + loo2p*I2[292]
        + (fiveo2z)*I1[162] - (fiveo4zn)*I4[162];
*(vp++) = U01*I0[223] - U11*I3[223] + loo2p*I2[293]
        + (fiveo2z)*I1[163] - (fiveo4zn)*I4[163] - (twoo4zn)*I5[133];
*(vp++) = U01*I0[224] - U11*I3[224] + loo2p*I2[294]
        + (fiveo2z)*I1[164] - (fiveo4zn)*I4[164] - (oneo4zn)*I5[134];
*(vp++) = U01*I0[225] - U11*I3[225] + loo2p*I2[295]
        + (fiveo2z)*I1[165] - (fiveo4zn)*I4[165];
*(vp++) = U01*I0[226] - U11*I3[226] + loo2p*I2[296]
        + (fiveo2z)*I1[166] - (fiveo4zn)*I4[166] - (threeo4zn)*I5[135];
*(vp++) = U01*I0[227] - U11*I3[227] + loo2p*I2[297]
        + (fiveo2z)*I1[167] - (fiveo4zn)*I4[167] - (twoo4zn)*I5[136];
*(vp++) = U01*I0[228] - U11*I3[228] + loo2p*I2[298]
        + (fiveo2z)*I1[168] - (fiveo4zn)*I4[168] - (oneo4zn)*I5[137];
*(vp++) = U01*I0[229] - U11*I3[229] + loo2p*I2[299]
        + (fiveo2z)*I1[169] - (fiveo4zn)*I4[169];
*(vp++) = U01*I0[230] - U11*I3[230] + loo2p*I2[300]
        + (fouro2z)*I1[170] - (fouro4zn)*I4[170];
*(vp++) = U01*I0[231] - U11*I3[231] + loo2p*I2[301]
        + (fouro2z)*I1[171] - (fouro4zn)*I4[171] - (oneo4zn)*I5[138];
*(vp++) = U01*I0[232] - U11*I3[232] + loo2p*I2[302]
        + (fouro2z)*I1[172] - (fouro4zn)*I4[172];
*(vp++) = U01*I0[233] - U11*I3[233] + loo2p*I2[303]
        + (fouro2z)*I1[173] - (fouro4zn)*I4[173] - (twoo4zn)*I5[139];
*(vp++) = U01*I0[234] - U11*I3[234] + loo2p*I2[304]
        + (fouro2z)*I1[174] - (fouro4zn)*I4[174] - (oneo4zn)*I5[140];
*(vp++) = U01*I0[235] - U11*I3[235] + loo2p*I2[305]
        + (fouro2z)*I1[175] - (fouro4zn)*I4[175];
*(vp++) = U01*I0[236] - U11*I3[236] + loo2p*I2[306]
        + (fouro2z)*I1[176] - (fouro4zn)*I4[176] - (threeo4zn)*I5[141];
*(vp++) = U01*I0[237] - U11*I3[237] + loo2p*I2[307]
        + (fouro2z)*I1[177] - (fouro4zn)*I4[177] - (twoo4zn)*I5[142];
*(vp++) = U01*I0[238] - U11*I3[238] + loo2p*I2[308]
        + (fouro2z)*I1[178] - (fouro4zn)*I4[178] - (oneo4zn)*I5[143];
*(vp++) = U01*I0[239] - U11*I3[239] + loo2p*I2[309]
        + (fouro2z)*I1[179] - (fouro4zn)*I4[179];
*(vp++) = U01*I0[240] - U11*I3[240] + loo2p*I2[310]
        + (threeo2z)*I1[180] - (threeo4zn)*I4[180];
*(vp++) = U01*I0[241] - U11*I3[241] + loo2p*I2[311]
        + (threeo2z)*I1[181] - (threeo4zn)*I4[181] - (oneo4zn)*I5[144];
*(vp++) = U01*I0[242] - U11*I3[242] + loo2p*I2[312]
        + (threeo2z)*I1[182] - (threeo4zn)*I4[182];
*(vp++) = U01*I0[243] - U11*I3[243] + loo2p*I2[313]
        + (threeo2z)*I1[183] - (threeo4zn)*I4[183] - (twoo4zn)*I5[145];
*(vp++) = U01*I0[244] - U11*I3[244] + loo2p*I2[314]
        + (threeo2z)*I1[184] - (threeo4zn)*I4[184] - (oneo4zn)*I5[146];
*(vp++) = U01*I0[245] - U11*I3[245] + loo2p*I2[315]
        + (threeo2z)*I1[185] - (threeo4zn)*I4[185];
*(vp++) = U01*I0[246] - U11*I3[246] + loo2p*I2[316]
        + (threeo2z)*I1[186] - (threeo4zn)*I4[186] - (threeo4zn)*I5[147];
*(vp++) = U01*I0[247] - U11*I3[247] + loo2p*I2[317]
        + (threeo2z)*I1[187] - (threeo4zn)*I4[187] - (twoo4zn)*I5[148];
*(vp++) = U01*I0[248] - U11*I3[248] + loo2p*I2[318]
        + (threeo2z)*I1[188] - (threeo4zn)*I4[188] - (oneo4zn)*I5[149];
*(vp++) = U01*I0[249] - U11*I3[249] + loo2p*I2[319]
        + (threeo2z)*I1[189] - (threeo4zn)*I4[189];
*(vp++) = U01*I0[250] - U11*I3[250] + loo2p*I2[320]
        + (twoo2z)*I1[190] - (twoo4zn)*I4[190];
*(vp++) = U01*I0[251] - U11*I3[251] + loo2p*I2[321]
        + (twoo2z)*I1[191] - (twoo4zn)*I4[191] - (oneo4zn)*I5[150];
*(vp++) = U01*I0[252] - U11*I3[252] + loo2p*I2[322]
        + (twoo2z)*I1[192] - (twoo4zn)*I4[192];
*(vp++) = U01*I0[253] - U11*I3[253] + loo2p*I2[323]
        + (twoo2z)*I1[193] - (twoo4zn)*I4[193] - (twoo4zn)*I5[151];
*(vp++) = U01*I0[254] - U11*I3[254] + loo2p*I2[324]
        + (twoo2z)*I1[194] - (twoo4zn)*I4[194] - (oneo4zn)*I5[152];
*(vp++) = U01*I0[255] - U11*I3[255] + loo2p*I2[325]
        + (twoo2z)*I1[195] - (twoo4zn)*I4[195];
*(vp++) = U01*I0[256] - U11*I3[256] + loo2p*I2[326]
        + (twoo2z)*I1[196] - (twoo4zn)*I4[196] - (threeo4zn)*I5[153];
*(vp++) = U01*I0[257] - U11*I3[257] + loo2p*I2[327]
        + (twoo2z)*I1[197] - (twoo4zn)*I4[197] - (twoo4zn)*I5[154];
*(vp++) = U01*I0[258] - U11*I3[258] + loo2p*I2[328]
        + (twoo2z)*I1[198] - (twoo4zn)*I4[198] - (oneo4zn)*I5[155];
*(vp++) = U01*I0[259] - U11*I3[259] + loo2p*I2[329]
        + (twoo2z)*I1[199] - (twoo4zn)*I4[199];
*(vp++) = U01*I0[260] - U11*I3[260] + loo2p*I2[330]
        + (oneo2z)*I1[200] - (oneo4zn)*I4[200];
*(vp++) = U01*I0[261] - U11*I3[261] + loo2p*I2[331]
        + (oneo2z)*I1[201] - (oneo4zn)*I4[201] - (oneo4zn)*I5[156];
*(vp++) = U01*I0[262] - U11*I3[262] + loo2p*I2[332]
        + (oneo2z)*I1[202] - (oneo4zn)*I4[202];
*(vp++) = U01*I0[263] - U11*I3[263] + loo2p*I2[333]
        + (oneo2z)*I1[203] - (oneo4zn)*I4[203] - (twoo4zn)*I5[157];
*(vp++) = U01*I0[264] - U11*I3[264] + loo2p*I2[334]
        + (oneo2z)*I1[204] - (oneo4zn)*I4[204] - (oneo4zn)*I5[158];
*(vp++) = U01*I0[265] - U11*I3[265] + loo2p*I2[335]
        + (oneo2z)*I1[205] - (oneo4zn)*I4[205];
*(vp++) = U01*I0[266] - U11*I3[266] + loo2p*I2[336]
        + (oneo2z)*I1[206] - (oneo4zn)*I4[206] - (threeo4zn)*I5[159];
*(vp++) = U01*I0[267] - U11*I3[267] + loo2p*I2[337]
        + (oneo2z)*I1[207] - (oneo4zn)*I4[207] - (twoo4zn)*I5[160];
*(vp++) = U01*I0[268] - U11*I3[268] + loo2p*I2[338]
        + (oneo2z)*I1[208] - (oneo4zn)*I4[208] - (oneo4zn)*I5[161];
*(vp++) = U01*I0[269] - U11*I3[269] + loo2p*I2[339]
        + (oneo2z)*I1[209] - (oneo4zn)*I4[209];
*(vp++) = U01*I0[270] - U11*I3[270] + loo2p*I2[340];
*(vp++) = U01*I0[271] - U11*I3[271] + loo2p*I2[341] - (oneo4zn)*I5[162];
*(vp++) = U01*I0[272] - U11*I3[272] + loo2p*I2[342];
*(vp++) = U01*I0[273] - U11*I3[273] + loo2p*I2[343] - (twoo4zn)*I5[163];
*(vp++) = U01*I0[274] - U11*I3[274] + loo2p*I2[344] - (oneo4zn)*I5[164];
*(vp++) = U01*I0[275] - U11*I3[275] + loo2p*I2[345];
*(vp++) = U01*I0[276] - U11*I3[276] + loo2p*I2[346] - (threeo4zn)*I5[165];
*(vp++) = U01*I0[277] - U11*I3[277] + loo2p*I2[347] - (twoo4zn)*I5[166];
*(vp++) = U01*I0[278] - U11*I3[278] + loo2p*I2[348] - (oneo4zn)*I5[167];
*(vp++) = U01*I0[279] - U11*I3[279] + loo2p*I2[349];
*(vp++) = U02*I0[270] - U12*I3[270] + loo2p*I2[350]
        + (sixo2z)*I1[200] - (sixo4zn)*I4[200];
*(vp++) = U02*I0[271] - U12*I3[271] + loo2p*I2[351]
        + (sixo2z)*I1[201] - (sixo4zn)*I4[201];
*(vp++) = U02*I0[272] - U12*I3[272] + loo2p*I2[352]
        + (sixo2z)*I1[202] - (sixo4zn)*I4[202] - (oneo4zn)*I5[162];
*(vp++) = U02*I0[273] - U12*I3[273] + loo2p*I2[353]
        + (sixo2z)*I1[203] - (sixo4zn)*I4[203];
*(vp++) = U02*I0[274] - U12*I3[274] + loo2p*I2[354]
        + (sixo2z)*I1[204] - (sixo4zn)*I4[204] - (oneo4zn)*I5[163];
*(vp++) = U02*I0[275] - U12*I3[275] + loo2p*I2[355]
        + (sixo2z)*I1[205] - (sixo4zn)*I4[205] - (twoo4zn)*I5[164];
*(vp++) = U02*I0[276] - U12*I3[276] + loo2p*I2[356]
        + (sixo2z)*I1[206] - (sixo4zn)*I4[206];
*(vp++) = U02*I0[277] - U12*I3[277] + loo2p*I2[357]
        + (sixo2z)*I1[207] - (sixo4zn)*I4[207] - (oneo4zn)*I5[165];
*(vp++) = U02*I0[278] - U12*I3[278] + loo2p*I2[358]
        + (sixo2z)*I1[208] - (sixo4zn)*I4[208] - (twoo4zn)*I5[166];
*(vp++) = U02*I0[279] - U12*I3[279] + loo2p*I2[359]
        + (sixo2z)*I1[209] - (sixo4zn)*I4[209] - (threeo4zn)*I5[167];
return vp;
}
