/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ps||ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_p0d0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0] - (twoo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1] - (oneo4zn)*I5[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2] - (oneo4zn)*I5[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5];
*(vp++) = U01*I0[0] - U11*I3[0] + loo2p*I2[6];
*(vp++) = U01*I0[1] - U11*I3[1] + loo2p*I2[7] - (oneo4zn)*I5[0];
*(vp++) = U01*I0[2] - U11*I3[2] + loo2p*I2[8];
*(vp++) = U01*I0[3] - U11*I3[3] + loo2p*I2[9] - (twoo4zn)*I5[1];
*(vp++) = U01*I0[4] - U11*I3[4] + loo2p*I2[10] - (oneo4zn)*I5[2];
*(vp++) = U01*I0[5] - U11*I3[5] + loo2p*I2[11];
*(vp++) = U02*I0[0] - U12*I3[0] + loo2p*I2[12];
*(vp++) = U02*I0[1] - U12*I3[1] + loo2p*I2[13];
*(vp++) = U02*I0[2] - U12*I3[2] + loo2p*I2[14] - (oneo4zn)*I5[0];
*(vp++) = U02*I0[3] - U12*I3[3] + loo2p*I2[15];
*(vp++) = U02*I0[4] - U12*I3[4] + loo2p*I2[16] - (oneo4zn)*I5[1];
*(vp++) = U02*I0[5] - U12*I3[5] + loo2p*I2[17] - (twoo4zn)*I5[2];

}
