/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (gs|[r12,T1]|ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t1_build_g0d0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 5.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[6] - I2[1])
          - U12*(I1[12] - I2[2])
          + (fourzboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[7] - I2[3])
          - U12*(I1[13] - I2[4])
          + (fourzboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[8] - I2[4])
          - U12*(I1[14] - I2[5])
          + (fourzboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[9] - I2[6])
          - U12*(I1[15] - I2[7])
          + (fourzboz)*(I3[3] - AC0*I4[3]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[10] - I2[7])
          - U12*(I1[16] - I2[8])
          + (fourzboz)*(I3[4] - AC0*I4[4]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[11] - I2[8])
          - U12*(I1[17] - I2[9])
          + (fourzboz)*(I3[5] - AC0*I4[5]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[10])
          - U11*(I1[18] - I2[11])
          - U12*(I1[24] - I2[12])
          + (threezboz)*(I3[10] - AC0*I4[6])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[11])
          - U11*(I1[19] - I2[13])
          - U12*(I1[25] - I2[14])
          + (threezboz)*(I3[11] - AC0*I4[7])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[12])
          - U11*(I1[20] - I2[14])
          - U12*(I1[26] - I2[15])
          + (threezboz)*(I3[12] - AC0*I4[8])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[13])
          - U11*(I1[21] - I2[16])
          - U12*(I1[27] - I2[17])
          + (threezboz)*(I3[13] - AC0*I4[9])
          + (onezboz)*(I3[6] - AC1*I4[3]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[14])
          - U11*(I1[22] - I2[17])
          - U12*(I1[28] - I2[18])
          + (threezboz)*(I3[14] - AC0*I4[10])
          + (onezboz)*(I3[7] - AC1*I4[4]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[15])
          - U11*(I1[23] - I2[18])
          - U12*(I1[29] - I2[19])
          + (threezboz)*(I3[15] - AC0*I4[11])
          + (onezboz)*(I3[8] - AC1*I4[5]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[20])
          - U11*(I1[24] - I2[21])
          - U12*(I1[30] - I2[22])
          + (threezboz)*(I3[20] - AC0*I4[12])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[21])
          - U11*(I1[25] - I2[23])
          - U12*(I1[31] - I2[24])
          + (threezboz)*(I3[21] - AC0*I4[13])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[22])
          - U11*(I1[26] - I2[24])
          - U12*(I1[32] - I2[25])
          + (threezboz)*(I3[22] - AC0*I4[14])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[23])
          - U11*(I1[27] - I2[26])
          - U12*(I1[33] - I2[27])
          + (threezboz)*(I3[23] - AC0*I4[15])
          + (onezboz)*(I3[7] - AC2*I4[3]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[24])
          - U11*(I1[28] - I2[27])
          - U12*(I1[34] - I2[28])
          + (threezboz)*(I3[24] - AC0*I4[16])
          + (onezboz)*(I3[8] - AC2*I4[4]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[25])
          - U11*(I1[29] - I2[28])
          - U12*(I1[35] - I2[29])
          + (threezboz)*(I3[25] - AC0*I4[17])
          + (onezboz)*(I3[9] - AC2*I4[5]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[30])
          - U11*(I1[36] - I2[31])
          - U12*(I1[42] - I2[32])
          + (twozboz)*(I3[30] - AC0*I4[18])
          + (twozboz)*(I3[11] - AC1*I4[6]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[31])
          - U11*(I1[37] - I2[33])
          - U12*(I1[43] - I2[34])
          + (twozboz)*(I3[31] - AC0*I4[19])
          + (twozboz)*(I3[13] - AC1*I4[7]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[32])
          - U11*(I1[38] - I2[34])
          - U12*(I1[44] - I2[35])
          + (twozboz)*(I3[32] - AC0*I4[20])
          + (twozboz)*(I3[14] - AC1*I4[8]);
*(vp++) = U0*I0[21]
          - U10*(I1[21] - I2[33])
          - U11*(I1[39] - I2[36])
          - U12*(I1[45] - I2[37])
          + (twozboz)*(I3[33] - AC0*I4[21])
          + (twozboz)*(I3[16] - AC1*I4[9]);
*(vp++) = U0*I0[22]
          - U10*(I1[22] - I2[34])
          - U11*(I1[40] - I2[37])
          - U12*(I1[46] - I2[38])
          + (twozboz)*(I3[34] - AC0*I4[22])
          + (twozboz)*(I3[17] - AC1*I4[10]);
*(vp++) = U0*I0[23]
          - U10*(I1[23] - I2[35])
          - U11*(I1[41] - I2[38])
          - U12*(I1[47] - I2[39])
          + (twozboz)*(I3[35] - AC0*I4[23])
          + (twozboz)*(I3[18] - AC1*I4[11]);
*(vp++) = U0*I0[24]
          - U10*(I1[24] - I2[40])
          - U11*(I1[42] - I2[41])
          - U12*(I1[48] - I2[42])
          + (twozboz)*(I3[40] - AC0*I4[24])
          + (onezboz)*(I3[21] - AC1*I4[12])
          + (onezboz)*(I3[12] - AC2*I4[6]);
*(vp++) = U0*I0[25]
          - U10*(I1[25] - I2[41])
          - U11*(I1[43] - I2[43])
          - U12*(I1[49] - I2[44])
          + (twozboz)*(I3[41] - AC0*I4[25])
          + (onezboz)*(I3[23] - AC1*I4[13])
          + (onezboz)*(I3[14] - AC2*I4[7]);
*(vp++) = U0*I0[26]
          - U10*(I1[26] - I2[42])
          - U11*(I1[44] - I2[44])
          - U12*(I1[50] - I2[45])
          + (twozboz)*(I3[42] - AC0*I4[26])
          + (onezboz)*(I3[24] - AC1*I4[14])
          + (onezboz)*(I3[15] - AC2*I4[8]);
*(vp++) = U0*I0[27]
          - U10*(I1[27] - I2[43])
          - U11*(I1[45] - I2[46])
          - U12*(I1[51] - I2[47])
          + (twozboz)*(I3[43] - AC0*I4[27])
          + (onezboz)*(I3[26] - AC1*I4[15])
          + (onezboz)*(I3[17] - AC2*I4[9]);
*(vp++) = U0*I0[28]
          - U10*(I1[28] - I2[44])
          - U11*(I1[46] - I2[47])
          - U12*(I1[52] - I2[48])
          + (twozboz)*(I3[44] - AC0*I4[28])
          + (onezboz)*(I3[27] - AC1*I4[16])
          + (onezboz)*(I3[18] - AC2*I4[10]);
*(vp++) = U0*I0[29]
          - U10*(I1[29] - I2[45])
          - U11*(I1[47] - I2[48])
          - U12*(I1[53] - I2[49])
          + (twozboz)*(I3[45] - AC0*I4[29])
          + (onezboz)*(I3[28] - AC1*I4[17])
          + (onezboz)*(I3[19] - AC2*I4[11]);
*(vp++) = U0*I0[30]
          - U10*(I1[30] - I2[50])
          - U11*(I1[48] - I2[51])
          - U12*(I1[54] - I2[52])
          + (twozboz)*(I3[50] - AC0*I4[30])
          + (twozboz)*(I3[22] - AC2*I4[12]);
*(vp++) = U0*I0[31]
          - U10*(I1[31] - I2[51])
          - U11*(I1[49] - I2[53])
          - U12*(I1[55] - I2[54])
          + (twozboz)*(I3[51] - AC0*I4[31])
          + (twozboz)*(I3[24] - AC2*I4[13]);
*(vp++) = U0*I0[32]
          - U10*(I1[32] - I2[52])
          - U11*(I1[50] - I2[54])
          - U12*(I1[56] - I2[55])
          + (twozboz)*(I3[52] - AC0*I4[32])
          + (twozboz)*(I3[25] - AC2*I4[14]);
*(vp++) = U0*I0[33]
          - U10*(I1[33] - I2[53])
          - U11*(I1[51] - I2[56])
          - U12*(I1[57] - I2[57])
          + (twozboz)*(I3[53] - AC0*I4[33])
          + (twozboz)*(I3[27] - AC2*I4[15]);
*(vp++) = U0*I0[34]
          - U10*(I1[34] - I2[54])
          - U11*(I1[52] - I2[57])
          - U12*(I1[58] - I2[58])
          + (twozboz)*(I3[54] - AC0*I4[34])
          + (twozboz)*(I3[28] - AC2*I4[16]);
*(vp++) = U0*I0[35]
          - U10*(I1[35] - I2[55])
          - U11*(I1[53] - I2[58])
          - U12*(I1[59] - I2[59])
          + (twozboz)*(I3[55] - AC0*I4[35])
          + (twozboz)*(I3[29] - AC2*I4[17]);
*(vp++) = U0*I0[36]
          - U10*(I1[36] - I2[60])
          - U11*(I1[60] - I2[61])
          - U12*(I1[66] - I2[62])
          + (onezboz)*(I3[60] - AC0*I4[36])
          + (threezboz)*(I3[31] - AC1*I4[18]);
*(vp++) = U0*I0[37]
          - U10*(I1[37] - I2[61])
          - U11*(I1[61] - I2[63])
          - U12*(I1[67] - I2[64])
          + (onezboz)*(I3[61] - AC0*I4[37])
          + (threezboz)*(I3[33] - AC1*I4[19]);
*(vp++) = U0*I0[38]
          - U10*(I1[38] - I2[62])
          - U11*(I1[62] - I2[64])
          - U12*(I1[68] - I2[65])
          + (onezboz)*(I3[62] - AC0*I4[38])
          + (threezboz)*(I3[34] - AC1*I4[20]);
*(vp++) = U0*I0[39]
          - U10*(I1[39] - I2[63])
          - U11*(I1[63] - I2[66])
          - U12*(I1[69] - I2[67])
          + (onezboz)*(I3[63] - AC0*I4[39])
          + (threezboz)*(I3[36] - AC1*I4[21]);
*(vp++) = U0*I0[40]
          - U10*(I1[40] - I2[64])
          - U11*(I1[64] - I2[67])
          - U12*(I1[70] - I2[68])
          + (onezboz)*(I3[64] - AC0*I4[40])
          + (threezboz)*(I3[37] - AC1*I4[22]);
*(vp++) = U0*I0[41]
          - U10*(I1[41] - I2[65])
          - U11*(I1[65] - I2[68])
          - U12*(I1[71] - I2[69])
          + (onezboz)*(I3[65] - AC0*I4[41])
          + (threezboz)*(I3[38] - AC1*I4[23]);
*(vp++) = U0*I0[42]
          - U10*(I1[42] - I2[70])
          - U11*(I1[66] - I2[71])
          - U12*(I1[72] - I2[72])
          + (onezboz)*(I3[70] - AC0*I4[42])
          + (twozboz)*(I3[41] - AC1*I4[24])
          + (onezboz)*(I3[32] - AC2*I4[18]);
*(vp++) = U0*I0[43]
          - U10*(I1[43] - I2[71])
          - U11*(I1[67] - I2[73])
          - U12*(I1[73] - I2[74])
          + (onezboz)*(I3[71] - AC0*I4[43])
          + (twozboz)*(I3[43] - AC1*I4[25])
          + (onezboz)*(I3[34] - AC2*I4[19]);
*(vp++) = U0*I0[44]
          - U10*(I1[44] - I2[72])
          - U11*(I1[68] - I2[74])
          - U12*(I1[74] - I2[75])
          + (onezboz)*(I3[72] - AC0*I4[44])
          + (twozboz)*(I3[44] - AC1*I4[26])
          + (onezboz)*(I3[35] - AC2*I4[20]);
*(vp++) = U0*I0[45]
          - U10*(I1[45] - I2[73])
          - U11*(I1[69] - I2[76])
          - U12*(I1[75] - I2[77])
          + (onezboz)*(I3[73] - AC0*I4[45])
          + (twozboz)*(I3[46] - AC1*I4[27])
          + (onezboz)*(I3[37] - AC2*I4[21]);
*(vp++) = U0*I0[46]
          - U10*(I1[46] - I2[74])
          - U11*(I1[70] - I2[77])
          - U12*(I1[76] - I2[78])
          + (onezboz)*(I3[74] - AC0*I4[46])
          + (twozboz)*(I3[47] - AC1*I4[28])
          + (onezboz)*(I3[38] - AC2*I4[22]);
*(vp++) = U0*I0[47]
          - U10*(I1[47] - I2[75])
          - U11*(I1[71] - I2[78])
          - U12*(I1[77] - I2[79])
          + (onezboz)*(I3[75] - AC0*I4[47])
          + (twozboz)*(I3[48] - AC1*I4[29])
          + (onezboz)*(I3[39] - AC2*I4[23]);
*(vp++) = U0*I0[48]
          - U10*(I1[48] - I2[80])
          - U11*(I1[72] - I2[81])
          - U12*(I1[78] - I2[82])
          + (onezboz)*(I3[80] - AC0*I4[48])
          + (onezboz)*(I3[51] - AC1*I4[30])
          + (twozboz)*(I3[42] - AC2*I4[24]);
*(vp++) = U0*I0[49]
          - U10*(I1[49] - I2[81])
          - U11*(I1[73] - I2[83])
          - U12*(I1[79] - I2[84])
          + (onezboz)*(I3[81] - AC0*I4[49])
          + (onezboz)*(I3[53] - AC1*I4[31])
          + (twozboz)*(I3[44] - AC2*I4[25]);
*(vp++) = U0*I0[50]
          - U10*(I1[50] - I2[82])
          - U11*(I1[74] - I2[84])
          - U12*(I1[80] - I2[85])
          + (onezboz)*(I3[82] - AC0*I4[50])
          + (onezboz)*(I3[54] - AC1*I4[32])
          + (twozboz)*(I3[45] - AC2*I4[26]);
*(vp++) = U0*I0[51]
          - U10*(I1[51] - I2[83])
          - U11*(I1[75] - I2[86])
          - U12*(I1[81] - I2[87])
          + (onezboz)*(I3[83] - AC0*I4[51])
          + (onezboz)*(I3[56] - AC1*I4[33])
          + (twozboz)*(I3[47] - AC2*I4[27]);
*(vp++) = U0*I0[52]
          - U10*(I1[52] - I2[84])
          - U11*(I1[76] - I2[87])
          - U12*(I1[82] - I2[88])
          + (onezboz)*(I3[84] - AC0*I4[52])
          + (onezboz)*(I3[57] - AC1*I4[34])
          + (twozboz)*(I3[48] - AC2*I4[28]);
*(vp++) = U0*I0[53]
          - U10*(I1[53] - I2[85])
          - U11*(I1[77] - I2[88])
          - U12*(I1[83] - I2[89])
          + (onezboz)*(I3[85] - AC0*I4[53])
          + (onezboz)*(I3[58] - AC1*I4[35])
          + (twozboz)*(I3[49] - AC2*I4[29]);
*(vp++) = U0*I0[54]
          - U10*(I1[54] - I2[90])
          - U11*(I1[78] - I2[91])
          - U12*(I1[84] - I2[92])
          + (onezboz)*(I3[90] - AC0*I4[54])
          + (threezboz)*(I3[52] - AC2*I4[30]);
*(vp++) = U0*I0[55]
          - U10*(I1[55] - I2[91])
          - U11*(I1[79] - I2[93])
          - U12*(I1[85] - I2[94])
          + (onezboz)*(I3[91] - AC0*I4[55])
          + (threezboz)*(I3[54] - AC2*I4[31]);
*(vp++) = U0*I0[56]
          - U10*(I1[56] - I2[92])
          - U11*(I1[80] - I2[94])
          - U12*(I1[86] - I2[95])
          + (onezboz)*(I3[92] - AC0*I4[56])
          + (threezboz)*(I3[55] - AC2*I4[32]);
*(vp++) = U0*I0[57]
          - U10*(I1[57] - I2[93])
          - U11*(I1[81] - I2[96])
          - U12*(I1[87] - I2[97])
          + (onezboz)*(I3[93] - AC0*I4[57])
          + (threezboz)*(I3[57] - AC2*I4[33]);
*(vp++) = U0*I0[58]
          - U10*(I1[58] - I2[94])
          - U11*(I1[82] - I2[97])
          - U12*(I1[88] - I2[98])
          + (onezboz)*(I3[94] - AC0*I4[58])
          + (threezboz)*(I3[58] - AC2*I4[34]);
*(vp++) = U0*I0[59]
          - U10*(I1[59] - I2[95])
          - U11*(I1[83] - I2[98])
          - U12*(I1[89] - I2[99])
          + (onezboz)*(I3[95] - AC0*I4[59])
          + (threezboz)*(I3[59] - AC2*I4[35]);
*(vp++) = U0*I0[60]
          - U10*(I1[60] - I2[100])
          - U11*(I1[90] - I2[101])
          - U12*(I1[96] - I2[102])
          + (fourzboz)*(I3[61] - AC1*I4[36]);
*(vp++) = U0*I0[61]
          - U10*(I1[61] - I2[101])
          - U11*(I1[91] - I2[103])
          - U12*(I1[97] - I2[104])
          + (fourzboz)*(I3[63] - AC1*I4[37]);
*(vp++) = U0*I0[62]
          - U10*(I1[62] - I2[102])
          - U11*(I1[92] - I2[104])
          - U12*(I1[98] - I2[105])
          + (fourzboz)*(I3[64] - AC1*I4[38]);
*(vp++) = U0*I0[63]
          - U10*(I1[63] - I2[103])
          - U11*(I1[93] - I2[106])
          - U12*(I1[99] - I2[107])
          + (fourzboz)*(I3[66] - AC1*I4[39]);
*(vp++) = U0*I0[64]
          - U10*(I1[64] - I2[104])
          - U11*(I1[94] - I2[107])
          - U12*(I1[100] - I2[108])
          + (fourzboz)*(I3[67] - AC1*I4[40]);
*(vp++) = U0*I0[65]
          - U10*(I1[65] - I2[105])
          - U11*(I1[95] - I2[108])
          - U12*(I1[101] - I2[109])
          + (fourzboz)*(I3[68] - AC1*I4[41]);
*(vp++) = U0*I0[66]
          - U10*(I1[66] - I2[110])
          - U11*(I1[96] - I2[111])
          - U12*(I1[102] - I2[112])
          + (threezboz)*(I3[71] - AC1*I4[42])
          + (onezboz)*(I3[62] - AC2*I4[36]);
*(vp++) = U0*I0[67]
          - U10*(I1[67] - I2[111])
          - U11*(I1[97] - I2[113])
          - U12*(I1[103] - I2[114])
          + (threezboz)*(I3[73] - AC1*I4[43])
          + (onezboz)*(I3[64] - AC2*I4[37]);
*(vp++) = U0*I0[68]
          - U10*(I1[68] - I2[112])
          - U11*(I1[98] - I2[114])
          - U12*(I1[104] - I2[115])
          + (threezboz)*(I3[74] - AC1*I4[44])
          + (onezboz)*(I3[65] - AC2*I4[38]);
*(vp++) = U0*I0[69]
          - U10*(I1[69] - I2[113])
          - U11*(I1[99] - I2[116])
          - U12*(I1[105] - I2[117])
          + (threezboz)*(I3[76] - AC1*I4[45])
          + (onezboz)*(I3[67] - AC2*I4[39]);
*(vp++) = U0*I0[70]
          - U10*(I1[70] - I2[114])
          - U11*(I1[100] - I2[117])
          - U12*(I1[106] - I2[118])
          + (threezboz)*(I3[77] - AC1*I4[46])
          + (onezboz)*(I3[68] - AC2*I4[40]);
*(vp++) = U0*I0[71]
          - U10*(I1[71] - I2[115])
          - U11*(I1[101] - I2[118])
          - U12*(I1[107] - I2[119])
          + (threezboz)*(I3[78] - AC1*I4[47])
          + (onezboz)*(I3[69] - AC2*I4[41]);
*(vp++) = U0*I0[72]
          - U10*(I1[72] - I2[120])
          - U11*(I1[102] - I2[121])
          - U12*(I1[108] - I2[122])
          + (twozboz)*(I3[81] - AC1*I4[48])
          + (twozboz)*(I3[72] - AC2*I4[42]);
*(vp++) = U0*I0[73]
          - U10*(I1[73] - I2[121])
          - U11*(I1[103] - I2[123])
          - U12*(I1[109] - I2[124])
          + (twozboz)*(I3[83] - AC1*I4[49])
          + (twozboz)*(I3[74] - AC2*I4[43]);
*(vp++) = U0*I0[74]
          - U10*(I1[74] - I2[122])
          - U11*(I1[104] - I2[124])
          - U12*(I1[110] - I2[125])
          + (twozboz)*(I3[84] - AC1*I4[50])
          + (twozboz)*(I3[75] - AC2*I4[44]);
*(vp++) = U0*I0[75]
          - U10*(I1[75] - I2[123])
          - U11*(I1[105] - I2[126])
          - U12*(I1[111] - I2[127])
          + (twozboz)*(I3[86] - AC1*I4[51])
          + (twozboz)*(I3[77] - AC2*I4[45]);
*(vp++) = U0*I0[76]
          - U10*(I1[76] - I2[124])
          - U11*(I1[106] - I2[127])
          - U12*(I1[112] - I2[128])
          + (twozboz)*(I3[87] - AC1*I4[52])
          + (twozboz)*(I3[78] - AC2*I4[46]);
*(vp++) = U0*I0[77]
          - U10*(I1[77] - I2[125])
          - U11*(I1[107] - I2[128])
          - U12*(I1[113] - I2[129])
          + (twozboz)*(I3[88] - AC1*I4[53])
          + (twozboz)*(I3[79] - AC2*I4[47]);
*(vp++) = U0*I0[78]
          - U10*(I1[78] - I2[130])
          - U11*(I1[108] - I2[131])
          - U12*(I1[114] - I2[132])
          + (onezboz)*(I3[91] - AC1*I4[54])
          + (threezboz)*(I3[82] - AC2*I4[48]);
*(vp++) = U0*I0[79]
          - U10*(I1[79] - I2[131])
          - U11*(I1[109] - I2[133])
          - U12*(I1[115] - I2[134])
          + (onezboz)*(I3[93] - AC1*I4[55])
          + (threezboz)*(I3[84] - AC2*I4[49]);
*(vp++) = U0*I0[80]
          - U10*(I1[80] - I2[132])
          - U11*(I1[110] - I2[134])
          - U12*(I1[116] - I2[135])
          + (onezboz)*(I3[94] - AC1*I4[56])
          + (threezboz)*(I3[85] - AC2*I4[50]);
*(vp++) = U0*I0[81]
          - U10*(I1[81] - I2[133])
          - U11*(I1[111] - I2[136])
          - U12*(I1[117] - I2[137])
          + (onezboz)*(I3[96] - AC1*I4[57])
          + (threezboz)*(I3[87] - AC2*I4[51]);
*(vp++) = U0*I0[82]
          - U10*(I1[82] - I2[134])
          - U11*(I1[112] - I2[137])
          - U12*(I1[118] - I2[138])
          + (onezboz)*(I3[97] - AC1*I4[58])
          + (threezboz)*(I3[88] - AC2*I4[52]);
*(vp++) = U0*I0[83]
          - U10*(I1[83] - I2[135])
          - U11*(I1[113] - I2[138])
          - U12*(I1[119] - I2[139])
          + (onezboz)*(I3[98] - AC1*I4[59])
          + (threezboz)*(I3[89] - AC2*I4[53]);
*(vp++) = U0*I0[84]
          - U10*(I1[84] - I2[140])
          - U11*(I1[114] - I2[141])
          - U12*(I1[120] - I2[142])
          + (fourzboz)*(I3[92] - AC2*I4[54]);
*(vp++) = U0*I0[85]
          - U10*(I1[85] - I2[141])
          - U11*(I1[115] - I2[143])
          - U12*(I1[121] - I2[144])
          + (fourzboz)*(I3[94] - AC2*I4[55]);
*(vp++) = U0*I0[86]
          - U10*(I1[86] - I2[142])
          - U11*(I1[116] - I2[144])
          - U12*(I1[122] - I2[145])
          + (fourzboz)*(I3[95] - AC2*I4[56]);
*(vp++) = U0*I0[87]
          - U10*(I1[87] - I2[143])
          - U11*(I1[117] - I2[146])
          - U12*(I1[123] - I2[147])
          + (fourzboz)*(I3[97] - AC2*I4[57]);
*(vp++) = U0*I0[88]
          - U10*(I1[88] - I2[144])
          - U11*(I1[118] - I2[147])
          - U12*(I1[124] - I2[148])
          + (fourzboz)*(I3[98] - AC2*I4[58]);
*(vp++) = U0*I0[89]
          - U10*(I1[89] - I2[145])
          - U11*(I1[119] - I2[148])
          - U12*(I1[125] - I2[149])
          + (fourzboz)*(I3[99] - AC2*I4[59]);

}
