/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* This machine-generated function computes a quartet of (ff|[r12,T1] integrals */

#include<libint/libint.h>

void t1hrr1_build_ff(REALTYPE *AB, REALTYPE *AC, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, int lc, int ld)
{
  int cd, cd_num, c_num, cp1_num, d_num;
  int pc, qc, d, ind_c, ind_cp1d;
  const REALTYPE *i0, *i1, *i2, *i3, *i4;
  const REALTYPE AB0 = AB[0];
  const REALTYPE AB1 = AB[1];
  const REALTYPE AB2 = AB[2];
  const REALTYPE AC0 = AC[0];
  const REALTYPE AC1 = AC[1];
  const REALTYPE AC2 = AC[2];
  static int io[] = { 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, 66, 78};

  c_num = io[lc];
  cp1_num = io[lc+1];
  d_num = io[ld];

  i0 = I0;
  i2 = I2;
  i1 = I1;
  i3 = I3;
  i4 = I4;
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 1*(c_num*d_num);
  i2 = I2 + 1*(c_num*d_num);
  i1 = I1 + 1*(c_num*d_num);
  i4 = I4 + 1*(c_num*d_num);
  i3 = I3 + 1*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 2*(c_num*d_num);
  i2 = I2 + 2*(c_num*d_num);
  i1 = I1 + 2*(c_num*d_num);
  i4 = I4 + 2*(c_num*d_num);
  i3 = I3 + 2*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 3*(c_num*d_num);
  i2 = I2 + 3*(c_num*d_num);
  i1 = I1 + 3*(c_num*d_num);
  i4 = I4 + 3*(c_num*d_num);
  i3 = I3 + 3*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 4*(c_num*d_num);
  i2 = I2 + 4*(c_num*d_num);
  i1 = I1 + 4*(c_num*d_num);
  i4 = I4 + 4*(c_num*d_num);
  i3 = I3 + 4*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 5*(c_num*d_num);
  i2 = I2 + 5*(c_num*d_num);
  i1 = I1 + 5*(c_num*d_num);
  i4 = I4 + 5*(c_num*d_num);
  i3 = I3 + 5*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 9*(c_num*d_num);
  i2 = I2 + 9*(c_num*d_num);
  i1 = I1 + 3*(c_num*d_num);
  i4 = I4 + 3*(c_num*d_num);
  i3 = I3 + 3*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 10*(c_num*d_num);
  i2 = I2 + 10*(c_num*d_num);
  i1 = I1 + 4*(c_num*d_num);
  i4 = I4 + 4*(c_num*d_num);
  i3 = I3 + 4*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 11*(c_num*d_num);
  i2 = I2 + 11*(c_num*d_num);
  i1 = I1 + 5*(c_num*d_num);
  i4 = I4 + 5*(c_num*d_num);
  i3 = I3 + 5*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 17*(c_num*d_num);
  i2 = I2 + 17*(c_num*d_num);
  i1 = I1 + 5*(c_num*d_num);
  i4 = I4 + 5*(c_num*d_num);
  i3 = I3 + 5*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 6*(c_num*d_num);
  i2 = I2 + 6*(c_num*d_num);
  i1 = I1 + 6*(c_num*d_num);
  i4 = I4 + 6*(c_num*d_num);
  i3 = I3 + 6*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 7*(c_num*d_num);
  i2 = I2 + 7*(c_num*d_num);
  i1 = I1 + 7*(c_num*d_num);
  i4 = I4 + 7*(c_num*d_num);
  i3 = I3 + 7*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 8*(c_num*d_num);
  i2 = I2 + 8*(c_num*d_num);
  i1 = I1 + 8*(c_num*d_num);
  i4 = I4 + 8*(c_num*d_num);
  i3 = I3 + 8*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 9*(c_num*d_num);
  i2 = I2 + 9*(c_num*d_num);
  i1 = I1 + 9*(c_num*d_num);
  i4 = I4 + 9*(c_num*d_num);
  i3 = I3 + 9*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 10*(c_num*d_num);
  i2 = I2 + 10*(c_num*d_num);
  i1 = I1 + 10*(c_num*d_num);
  i4 = I4 + 10*(c_num*d_num);
  i3 = I3 + 10*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 11*(c_num*d_num);
  i2 = I2 + 11*(c_num*d_num);
  i1 = I1 + 11*(c_num*d_num);
  i4 = I4 + 11*(c_num*d_num);
  i3 = I3 + 11*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 21*(c_num*d_num);
  i2 = I2 + 21*(c_num*d_num);
  i1 = I1 + 9*(c_num*d_num);
  i4 = I4 + 9*(c_num*d_num);
  i3 = I3 + 9*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 22*(c_num*d_num);
  i2 = I2 + 22*(c_num*d_num);
  i1 = I1 + 10*(c_num*d_num);
  i4 = I4 + 10*(c_num*d_num);
  i3 = I3 + 10*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 23*(c_num*d_num);
  i2 = I2 + 23*(c_num*d_num);
  i1 = I1 + 11*(c_num*d_num);
  i4 = I4 + 11*(c_num*d_num);
  i3 = I3 + 11*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 29*(c_num*d_num);
  i2 = I2 + 29*(c_num*d_num);
  i1 = I1 + 11*(c_num*d_num);
  i4 = I4 + 11*(c_num*d_num);
  i3 = I3 + 11*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 12*(c_num*d_num);
  i2 = I2 + 12*(c_num*d_num);
  i1 = I1 + 12*(c_num*d_num);
  i4 = I4 + 12*(c_num*d_num);
  i3 = I3 + 12*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 13*(c_num*d_num);
  i2 = I2 + 13*(c_num*d_num);
  i1 = I1 + 13*(c_num*d_num);
  i4 = I4 + 13*(c_num*d_num);
  i3 = I3 + 13*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 14*(c_num*d_num);
  i2 = I2 + 14*(c_num*d_num);
  i1 = I1 + 14*(c_num*d_num);
  i4 = I4 + 14*(c_num*d_num);
  i3 = I3 + 14*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 15*(c_num*d_num);
  i2 = I2 + 15*(c_num*d_num);
  i1 = I1 + 15*(c_num*d_num);
  i4 = I4 + 15*(c_num*d_num);
  i3 = I3 + 15*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 16*(c_num*d_num);
  i2 = I2 + 16*(c_num*d_num);
  i1 = I1 + 16*(c_num*d_num);
  i4 = I4 + 16*(c_num*d_num);
  i3 = I3 + 16*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 17*(c_num*d_num);
  i2 = I2 + 17*(c_num*d_num);
  i1 = I1 + 17*(c_num*d_num);
  i4 = I4 + 17*(c_num*d_num);
  i3 = I3 + 17*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 27*(c_num*d_num);
  i2 = I2 + 27*(c_num*d_num);
  i1 = I1 + 15*(c_num*d_num);
  i4 = I4 + 15*(c_num*d_num);
  i3 = I3 + 15*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 28*(c_num*d_num);
  i2 = I2 + 28*(c_num*d_num);
  i1 = I1 + 16*(c_num*d_num);
  i4 = I4 + 16*(c_num*d_num);
  i3 = I3 + 16*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 29*(c_num*d_num);
  i2 = I2 + 29*(c_num*d_num);
  i1 = I1 + 17*(c_num*d_num);
  i4 = I4 + 17*(c_num*d_num);
  i3 = I3 + 17*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 35*(c_num*d_num);
  i2 = I2 + 35*(c_num*d_num);
  i1 = I1 + 17*(c_num*d_num);
  i4 = I4 + 17*(c_num*d_num);
  i3 = I3 + 17*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 18*(c_num*d_num);
  i2 = I2 + 18*(c_num*d_num);
  i1 = I1 + 18*(c_num*d_num);
  i4 = I4 + 18*(c_num*d_num);
  i3 = I3 + 18*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 19*(c_num*d_num);
  i2 = I2 + 19*(c_num*d_num);
  i1 = I1 + 19*(c_num*d_num);
  i4 = I4 + 19*(c_num*d_num);
  i3 = I3 + 19*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 20*(c_num*d_num);
  i2 = I2 + 20*(c_num*d_num);
  i1 = I1 + 20*(c_num*d_num);
  i4 = I4 + 20*(c_num*d_num);
  i3 = I3 + 20*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 21*(c_num*d_num);
  i2 = I2 + 21*(c_num*d_num);
  i1 = I1 + 21*(c_num*d_num);
  i4 = I4 + 21*(c_num*d_num);
  i3 = I3 + 21*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 22*(c_num*d_num);
  i2 = I2 + 22*(c_num*d_num);
  i1 = I1 + 22*(c_num*d_num);
  i4 = I4 + 22*(c_num*d_num);
  i3 = I3 + 22*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 23*(c_num*d_num);
  i2 = I2 + 23*(c_num*d_num);
  i1 = I1 + 23*(c_num*d_num);
  i4 = I4 + 23*(c_num*d_num);
  i3 = I3 + 23*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 39*(c_num*d_num);
  i2 = I2 + 39*(c_num*d_num);
  i1 = I1 + 21*(c_num*d_num);
  i4 = I4 + 21*(c_num*d_num);
  i3 = I3 + 21*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 40*(c_num*d_num);
  i2 = I2 + 40*(c_num*d_num);
  i1 = I1 + 22*(c_num*d_num);
  i4 = I4 + 22*(c_num*d_num);
  i3 = I3 + 22*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 41*(c_num*d_num);
  i2 = I2 + 41*(c_num*d_num);
  i1 = I1 + 23*(c_num*d_num);
  i4 = I4 + 23*(c_num*d_num);
  i3 = I3 + 23*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 47*(c_num*d_num);
  i2 = I2 + 47*(c_num*d_num);
  i1 = I1 + 23*(c_num*d_num);
  i4 = I4 + 23*(c_num*d_num);
  i3 = I3 + 23*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 24*(c_num*d_num);
  i2 = I2 + 24*(c_num*d_num);
  i1 = I1 + 24*(c_num*d_num);
  i4 = I4 + 24*(c_num*d_num);
  i3 = I3 + 24*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 25*(c_num*d_num);
  i2 = I2 + 25*(c_num*d_num);
  i1 = I1 + 25*(c_num*d_num);
  i4 = I4 + 25*(c_num*d_num);
  i3 = I3 + 25*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 26*(c_num*d_num);
  i2 = I2 + 26*(c_num*d_num);
  i1 = I1 + 26*(c_num*d_num);
  i4 = I4 + 26*(c_num*d_num);
  i3 = I3 + 26*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 27*(c_num*d_num);
  i2 = I2 + 27*(c_num*d_num);
  i1 = I1 + 27*(c_num*d_num);
  i4 = I4 + 27*(c_num*d_num);
  i3 = I3 + 27*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 28*(c_num*d_num);
  i2 = I2 + 28*(c_num*d_num);
  i1 = I1 + 28*(c_num*d_num);
  i4 = I4 + 28*(c_num*d_num);
  i3 = I3 + 28*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 29*(c_num*d_num);
  i2 = I2 + 29*(c_num*d_num);
  i1 = I1 + 29*(c_num*d_num);
  i4 = I4 + 29*(c_num*d_num);
  i3 = I3 + 29*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 45*(c_num*d_num);
  i2 = I2 + 45*(c_num*d_num);
  i1 = I1 + 27*(c_num*d_num);
  i4 = I4 + 27*(c_num*d_num);
  i3 = I3 + 27*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 46*(c_num*d_num);
  i2 = I2 + 46*(c_num*d_num);
  i1 = I1 + 28*(c_num*d_num);
  i4 = I4 + 28*(c_num*d_num);
  i3 = I3 + 28*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 47*(c_num*d_num);
  i2 = I2 + 47*(c_num*d_num);
  i1 = I1 + 29*(c_num*d_num);
  i4 = I4 + 29*(c_num*d_num);
  i3 = I3 + 29*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 53*(c_num*d_num);
  i2 = I2 + 53*(c_num*d_num);
  i1 = I1 + 29*(c_num*d_num);
  i4 = I4 + 29*(c_num*d_num);
  i3 = I3 + 29*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 30*(c_num*d_num);
  i2 = I2 + 30*(c_num*d_num);
  i1 = I1 + 30*(c_num*d_num);
  i4 = I4 + 30*(c_num*d_num);
  i3 = I3 + 30*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 31*(c_num*d_num);
  i2 = I2 + 31*(c_num*d_num);
  i1 = I1 + 31*(c_num*d_num);
  i4 = I4 + 31*(c_num*d_num);
  i3 = I3 + 31*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 32*(c_num*d_num);
  i2 = I2 + 32*(c_num*d_num);
  i1 = I1 + 32*(c_num*d_num);
  i4 = I4 + 32*(c_num*d_num);
  i3 = I3 + 32*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 33*(c_num*d_num);
  i2 = I2 + 33*(c_num*d_num);
  i1 = I1 + 33*(c_num*d_num);
  i4 = I4 + 33*(c_num*d_num);
  i3 = I3 + 33*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 34*(c_num*d_num);
  i2 = I2 + 34*(c_num*d_num);
  i1 = I1 + 34*(c_num*d_num);
  i4 = I4 + 34*(c_num*d_num);
  i3 = I3 + 34*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 35*(c_num*d_num);
  i2 = I2 + 35*(c_num*d_num);
  i1 = I1 + 35*(c_num*d_num);
  i4 = I4 + 35*(c_num*d_num);
  i3 = I3 + 35*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 51*(c_num*d_num);
  i2 = I2 + 51*(c_num*d_num);
  i1 = I1 + 33*(c_num*d_num);
  i4 = I4 + 33*(c_num*d_num);
  i3 = I3 + 33*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 52*(c_num*d_num);
  i2 = I2 + 52*(c_num*d_num);
  i1 = I1 + 34*(c_num*d_num);
  i4 = I4 + 34*(c_num*d_num);
  i3 = I3 + 34*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 53*(c_num*d_num);
  i2 = I2 + 53*(c_num*d_num);
  i1 = I1 + 35*(c_num*d_num);
  i4 = I4 + 35*(c_num*d_num);
  i3 = I3 + 35*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 59*(c_num*d_num);
  i2 = I2 + 59*(c_num*d_num);
  i1 = I1 + 35*(c_num*d_num);
  i4 = I4 + 35*(c_num*d_num);
  i3 = I3 + 35*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 36*(c_num*d_num);
  i2 = I2 + 36*(c_num*d_num);
  i1 = I1 + 36*(c_num*d_num);
  i4 = I4 + 36*(c_num*d_num);
  i3 = I3 + 36*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 37*(c_num*d_num);
  i2 = I2 + 37*(c_num*d_num);
  i1 = I1 + 37*(c_num*d_num);
  i4 = I4 + 37*(c_num*d_num);
  i3 = I3 + 37*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 38*(c_num*d_num);
  i2 = I2 + 38*(c_num*d_num);
  i1 = I1 + 38*(c_num*d_num);
  i4 = I4 + 38*(c_num*d_num);
  i3 = I3 + 38*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 39*(c_num*d_num);
  i2 = I2 + 39*(c_num*d_num);
  i1 = I1 + 39*(c_num*d_num);
  i4 = I4 + 39*(c_num*d_num);
  i3 = I3 + 39*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 40*(c_num*d_num);
  i2 = I2 + 40*(c_num*d_num);
  i1 = I1 + 40*(c_num*d_num);
  i4 = I4 + 40*(c_num*d_num);
  i3 = I3 + 40*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 41*(c_num*d_num);
  i2 = I2 + 41*(c_num*d_num);
  i1 = I1 + 41*(c_num*d_num);
  i4 = I4 + 41*(c_num*d_num);
  i3 = I3 + 41*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 63*(c_num*d_num);
  i2 = I2 + 63*(c_num*d_num);
  i1 = I1 + 39*(c_num*d_num);
  i4 = I4 + 39*(c_num*d_num);
  i3 = I3 + 39*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 64*(c_num*d_num);
  i2 = I2 + 64*(c_num*d_num);
  i1 = I1 + 40*(c_num*d_num);
  i4 = I4 + 40*(c_num*d_num);
  i3 = I3 + 40*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 65*(c_num*d_num);
  i2 = I2 + 65*(c_num*d_num);
  i1 = I1 + 41*(c_num*d_num);
  i4 = I4 + 41*(c_num*d_num);
  i3 = I3 + 41*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 71*(c_num*d_num);
  i2 = I2 + 71*(c_num*d_num);
  i1 = I1 + 41*(c_num*d_num);
  i4 = I4 + 41*(c_num*d_num);
  i3 = I3 + 41*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 42*(c_num*d_num);
  i2 = I2 + 42*(c_num*d_num);
  i1 = I1 + 42*(c_num*d_num);
  i4 = I4 + 42*(c_num*d_num);
  i3 = I3 + 42*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 43*(c_num*d_num);
  i2 = I2 + 43*(c_num*d_num);
  i1 = I1 + 43*(c_num*d_num);
  i4 = I4 + 43*(c_num*d_num);
  i3 = I3 + 43*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 44*(c_num*d_num);
  i2 = I2 + 44*(c_num*d_num);
  i1 = I1 + 44*(c_num*d_num);
  i4 = I4 + 44*(c_num*d_num);
  i3 = I3 + 44*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 45*(c_num*d_num);
  i2 = I2 + 45*(c_num*d_num);
  i1 = I1 + 45*(c_num*d_num);
  i4 = I4 + 45*(c_num*d_num);
  i3 = I3 + 45*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 46*(c_num*d_num);
  i2 = I2 + 46*(c_num*d_num);
  i1 = I1 + 46*(c_num*d_num);
  i4 = I4 + 46*(c_num*d_num);
  i3 = I3 + 46*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 47*(c_num*d_num);
  i2 = I2 + 47*(c_num*d_num);
  i1 = I1 + 47*(c_num*d_num);
  i4 = I4 + 47*(c_num*d_num);
  i3 = I3 + 47*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 69*(c_num*d_num);
  i2 = I2 + 69*(c_num*d_num);
  i1 = I1 + 45*(c_num*d_num);
  i4 = I4 + 45*(c_num*d_num);
  i3 = I3 + 45*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 70*(c_num*d_num);
  i2 = I2 + 70*(c_num*d_num);
  i1 = I1 + 46*(c_num*d_num);
  i4 = I4 + 46*(c_num*d_num);
  i3 = I3 + 46*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 71*(c_num*d_num);
  i2 = I2 + 71*(c_num*d_num);
  i1 = I1 + 47*(c_num*d_num);
  i4 = I4 + 47*(c_num*d_num);
  i3 = I3 + 47*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 77*(c_num*d_num);
  i2 = I2 + 77*(c_num*d_num);
  i1 = I1 + 47*(c_num*d_num);
  i4 = I4 + 47*(c_num*d_num);
  i3 = I3 + 47*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 48*(c_num*d_num);
  i2 = I2 + 48*(c_num*d_num);
  i1 = I1 + 48*(c_num*d_num);
  i4 = I4 + 48*(c_num*d_num);
  i3 = I3 + 48*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 49*(c_num*d_num);
  i2 = I2 + 49*(c_num*d_num);
  i1 = I1 + 49*(c_num*d_num);
  i4 = I4 + 49*(c_num*d_num);
  i3 = I3 + 49*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 50*(c_num*d_num);
  i2 = I2 + 50*(c_num*d_num);
  i1 = I1 + 50*(c_num*d_num);
  i4 = I4 + 50*(c_num*d_num);
  i3 = I3 + 50*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 51*(c_num*d_num);
  i2 = I2 + 51*(c_num*d_num);
  i1 = I1 + 51*(c_num*d_num);
  i4 = I4 + 51*(c_num*d_num);
  i3 = I3 + 51*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 52*(c_num*d_num);
  i2 = I2 + 52*(c_num*d_num);
  i1 = I1 + 52*(c_num*d_num);
  i4 = I4 + 52*(c_num*d_num);
  i3 = I3 + 52*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 53*(c_num*d_num);
  i2 = I2 + 53*(c_num*d_num);
  i1 = I1 + 53*(c_num*d_num);
  i4 = I4 + 53*(c_num*d_num);
  i3 = I3 + 53*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 75*(c_num*d_num);
  i2 = I2 + 75*(c_num*d_num);
  i1 = I1 + 51*(c_num*d_num);
  i4 = I4 + 51*(c_num*d_num);
  i3 = I3 + 51*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 76*(c_num*d_num);
  i2 = I2 + 76*(c_num*d_num);
  i1 = I1 + 52*(c_num*d_num);
  i4 = I4 + 52*(c_num*d_num);
  i3 = I3 + 52*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 77*(c_num*d_num);
  i2 = I2 + 77*(c_num*d_num);
  i1 = I1 + 53*(c_num*d_num);
  i4 = I4 + 53*(c_num*d_num);
  i3 = I3 + 53*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 83*(c_num*d_num);
  i2 = I2 + 83*(c_num*d_num);
  i1 = I1 + 53*(c_num*d_num);
  i4 = I4 + 53*(c_num*d_num);
  i3 = I3 + 53*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 54*(c_num*d_num);
  i2 = I2 + 54*(c_num*d_num);
  i1 = I1 + 54*(c_num*d_num);
  i4 = I4 + 54*(c_num*d_num);
  i3 = I3 + 54*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 55*(c_num*d_num);
  i2 = I2 + 55*(c_num*d_num);
  i1 = I1 + 55*(c_num*d_num);
  i4 = I4 + 55*(c_num*d_num);
  i3 = I3 + 55*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 56*(c_num*d_num);
  i2 = I2 + 56*(c_num*d_num);
  i1 = I1 + 56*(c_num*d_num);
  i4 = I4 + 56*(c_num*d_num);
  i3 = I3 + 56*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 57*(c_num*d_num);
  i2 = I2 + 57*(c_num*d_num);
  i1 = I1 + 57*(c_num*d_num);
  i4 = I4 + 57*(c_num*d_num);
  i3 = I3 + 57*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 58*(c_num*d_num);
  i2 = I2 + 58*(c_num*d_num);
  i1 = I1 + 58*(c_num*d_num);
  i4 = I4 + 58*(c_num*d_num);
  i3 = I3 + 58*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 59*(c_num*d_num);
  i2 = I2 + 59*(c_num*d_num);
  i1 = I1 + 59*(c_num*d_num);
  i4 = I4 + 59*(c_num*d_num);
  i3 = I3 + 59*(cp1_num*d_num);
  for(cd=0;cd<c_num*d_num;cd++)
    *(vp++) = *(i0++) + AB0*(*(i1++)) + *(i2++) + AC0*(*(i4++)) - *(i3++);

  i0 = I0 + 81*(c_num*d_num);
  i2 = I2 + 81*(c_num*d_num);
  i1 = I1 + 57*(c_num*d_num);
  i4 = I4 + 57*(c_num*d_num);
  i3 = I3 + 57*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 82*(c_num*d_num);
  i2 = I2 + 82*(c_num*d_num);
  i1 = I1 + 58*(c_num*d_num);
  i4 = I4 + 58*(c_num*d_num);
  i3 = I3 + 58*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 83*(c_num*d_num);
  i2 = I2 + 83*(c_num*d_num);
  i1 = I1 + 59*(c_num*d_num);
  i4 = I4 + 59*(c_num*d_num);
  i3 = I3 + 59*(cp1_num*d_num);
  ind_c = 1;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB1*(*(i1++)) + *(i2++) + AC1*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

  i0 = I0 + 89*(c_num*d_num);
  i2 = I2 + 89*(c_num*d_num);
  i1 = I1 + 59*(c_num*d_num);
  i4 = I4 + 59*(c_num*d_num);
  i3 = I3 + 59*(cp1_num*d_num);
  ind_c = 2;
  for(pc=0;pc<=lc;pc++) {
    for(qc=0;qc<=pc;qc++) {
      ind_cp1d = (ind_c + pc)*d_num;
      for(d=0;d<d_num;d++) {
        *(vp++) = *(i0++) + AB2*(*(i1++)) + *(i2++) + AC2*(*(i4++)) - i3[ind_cp1d];
        ind_cp1d++;
      }
      ind_c++;
    }
  }

}
