/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ddhf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|hf) integrals */

void d12hrr_order_ddhf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][8][11] = int_stack + 0;
 Libderiv->deriv_classes[4][8][10] = int_stack + 675;
 Libderiv->deriv_classes[4][8][9] = int_stack + 1350;
 Libderiv->deriv_classes[4][8][8] = int_stack + 2025;
 Libderiv->deriv_classes[4][8][7] = int_stack + 2700;
 Libderiv->dvrr_classes[4][7] = int_stack + 3375;
 Libderiv->deriv_classes[4][8][6] = int_stack + 3915;
 Libderiv->deriv_classes[4][8][2] = int_stack + 4590;
 Libderiv->deriv_classes[4][8][1] = int_stack + 5265;
 Libderiv->dvrr_classes[3][8] = int_stack + 5940;
 Libderiv->deriv_classes[4][8][0] = int_stack + 6390;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 7065;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 7191;
 Libderiv->deriv2_classes[2][7][143] = int_stack + 7359;
 Libderiv->deriv2_classes[2][8][143] = int_stack + 7575;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 7845;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 8055;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 8335;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 8695;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 9145;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 9460;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 9880;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 10420;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 11095;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 11221;
 Libderiv->deriv2_classes[2][7][131] = int_stack + 11389;
 Libderiv->deriv2_classes[2][8][131] = int_stack + 11605;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 11875;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 12085;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 12365;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 12725;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 13175;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 13490;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 13910;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 14450;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 15125;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 15251;
 Libderiv->deriv2_classes[2][7][130] = int_stack + 15419;
 Libderiv->deriv2_classes[2][8][130] = int_stack + 15635;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 15905;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 16115;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 16395;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 16755;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 17205;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 17520;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 17940;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 18480;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 19155;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 19281;
 Libderiv->deriv2_classes[2][7][119] = int_stack + 19449;
 Libderiv->deriv2_classes[2][8][119] = int_stack + 19665;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 19935;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 20145;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 20425;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 20785;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 21235;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 21550;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 21970;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 22510;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 23185;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 23311;
 Libderiv->deriv2_classes[2][7][118] = int_stack + 23479;
 Libderiv->deriv2_classes[2][8][118] = int_stack + 23695;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 23965;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 24175;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 24455;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 24815;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 25265;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 25580;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 26000;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 26540;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 27215;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 27341;
 Libderiv->deriv2_classes[2][7][117] = int_stack + 27509;
 Libderiv->deriv2_classes[2][8][117] = int_stack + 27725;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 27995;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 28205;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 28485;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 28845;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 29295;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 29610;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 30030;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 30570;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 31245;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 31371;
 Libderiv->deriv2_classes[2][7][107] = int_stack + 31539;
 Libderiv->deriv2_classes[2][8][107] = int_stack + 31755;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 32025;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 32235;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 32515;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 32875;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 33325;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 33640;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 34060;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 34600;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 35275;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 35401;
 Libderiv->deriv2_classes[2][7][106] = int_stack + 35569;
 Libderiv->deriv2_classes[2][8][106] = int_stack + 35785;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 36055;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 36265;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 36545;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 36905;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 37355;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 37670;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 38090;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 38630;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 39305;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 39431;
 Libderiv->deriv2_classes[2][7][105] = int_stack + 39599;
 Libderiv->deriv2_classes[2][8][105] = int_stack + 39815;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 40085;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 40295;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 40575;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 40935;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 41385;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 41700;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 42120;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 42660;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 43335;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 43461;
 Libderiv->deriv2_classes[2][7][104] = int_stack + 43629;
 Libderiv->deriv2_classes[2][8][104] = int_stack + 43845;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 44115;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 44325;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 44605;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 44965;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 45415;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 45730;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 46150;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 46690;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 47365;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 47491;
 Libderiv->deriv2_classes[2][7][95] = int_stack + 47659;
 Libderiv->deriv2_classes[2][8][95] = int_stack + 47875;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 48145;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 48355;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 48635;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 48995;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 49445;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 49760;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 50180;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 50720;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 51395;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 51521;
 Libderiv->deriv2_classes[2][7][94] = int_stack + 51689;
 Libderiv->deriv2_classes[2][8][94] = int_stack + 51905;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 52175;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 52385;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 52665;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 53025;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 53475;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 53790;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 54210;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 54750;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 55425;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 55551;
 Libderiv->deriv2_classes[2][7][93] = int_stack + 55719;
 Libderiv->deriv2_classes[2][8][93] = int_stack + 55935;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 56205;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 56415;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 56695;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 57055;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 57505;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 57820;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 58240;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 58780;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 59455;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 59581;
 Libderiv->deriv2_classes[2][7][92] = int_stack + 59749;
 Libderiv->deriv2_classes[2][8][92] = int_stack + 59965;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 60235;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 60445;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 60725;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 61085;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 61535;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 61850;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 62270;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 62810;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 63485;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 63611;
 Libderiv->deriv2_classes[2][7][91] = int_stack + 63779;
 Libderiv->deriv2_classes[2][8][91] = int_stack + 63995;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 64265;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 64475;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 64755;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 65115;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 65565;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 65880;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 66300;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 66840;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 67515;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 67641;
 Libderiv->deriv2_classes[2][7][83] = int_stack + 67809;
 Libderiv->deriv2_classes[2][8][83] = int_stack + 68025;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 68295;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 68505;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 68785;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 69145;
 Libderiv->deriv_classes[4][5][11] = int_stack + 69595;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 69910;
 Libderiv->deriv_classes[4][6][11] = int_stack + 70225;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 70645;
 Libderiv->deriv_classes[4][7][11] = int_stack + 71065;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 71605;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 72145;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 72820;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 72946;
 Libderiv->deriv2_classes[2][7][82] = int_stack + 73114;
 Libderiv->deriv2_classes[2][8][82] = int_stack + 73330;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 73600;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 73810;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 74090;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 74450;
 Libderiv->deriv_classes[4][5][10] = int_stack + 74900;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 75215;
 Libderiv->deriv_classes[4][6][10] = int_stack + 75530;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 75950;
 Libderiv->deriv_classes[4][7][10] = int_stack + 76370;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 76910;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 77450;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 78125;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 78251;
 Libderiv->deriv2_classes[2][7][81] = int_stack + 78419;
 Libderiv->deriv2_classes[2][8][81] = int_stack + 78635;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 78905;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 79115;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 79395;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 79755;
 Libderiv->deriv_classes[4][5][9] = int_stack + 80205;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 80520;
 Libderiv->deriv_classes[4][6][9] = int_stack + 80835;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 81255;
 Libderiv->deriv_classes[4][7][9] = int_stack + 81675;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 82215;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 82755;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 83430;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 83556;
 Libderiv->deriv2_classes[2][7][80] = int_stack + 83724;
 Libderiv->deriv2_classes[2][8][80] = int_stack + 83940;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 84210;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 84420;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 84700;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 85060;
 Libderiv->deriv_classes[4][5][8] = int_stack + 85510;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 85825;
 Libderiv->deriv_classes[4][6][8] = int_stack + 86140;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 86560;
 Libderiv->deriv_classes[4][7][8] = int_stack + 86980;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 87520;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 88060;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 88735;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 88861;
 Libderiv->deriv2_classes[2][7][79] = int_stack + 89029;
 Libderiv->deriv2_classes[2][8][79] = int_stack + 89245;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 89515;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 89725;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 90005;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 90365;
 Libderiv->deriv_classes[4][5][7] = int_stack + 90815;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 91130;
 Libderiv->deriv_classes[4][6][7] = int_stack + 91445;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 91865;
 Libderiv->deriv_classes[4][7][7] = int_stack + 92285;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 92825;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 93365;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 94040;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 94166;
 Libderiv->deriv2_classes[2][7][78] = int_stack + 94334;
 Libderiv->deriv2_classes[2][8][78] = int_stack + 94550;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 94820;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 95030;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 95310;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 95670;
 Libderiv->dvrr_classes[4][5] = int_stack + 96120;
 Libderiv->deriv_classes[4][5][6] = int_stack + 96435;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 96750;
 Libderiv->dvrr_classes[4][6] = int_stack + 97065;
 Libderiv->deriv_classes[4][6][6] = int_stack + 97485;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 97905;
 Libderiv->deriv_classes[4][7][6] = int_stack + 98325;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 98865;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 99405;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 100080;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 100206;
 Libderiv->deriv2_classes[2][7][35] = int_stack + 100374;
 Libderiv->deriv2_classes[2][8][35] = int_stack + 100590;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 100860;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 101070;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 101350;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 101710;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 102160;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 102475;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 102895;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 103435;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 104110;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 104236;
 Libderiv->deriv2_classes[2][7][34] = int_stack + 104404;
 Libderiv->deriv2_classes[2][8][34] = int_stack + 104620;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 104890;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 105100;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 105380;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 105740;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 106190;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 106505;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 106925;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 107465;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 108140;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 108266;
 Libderiv->deriv2_classes[2][7][33] = int_stack + 108434;
 Libderiv->deriv2_classes[2][8][33] = int_stack + 108650;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 108920;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 109130;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 109410;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 109770;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 110220;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 110535;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 110955;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 111495;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 112170;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 112296;
 Libderiv->deriv2_classes[2][7][32] = int_stack + 112464;
 Libderiv->deriv2_classes[2][8][32] = int_stack + 112680;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 112950;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 113160;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 113440;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 113800;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 114250;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 114565;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 114985;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 115525;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 116200;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 116326;
 Libderiv->deriv2_classes[2][7][31] = int_stack + 116494;
 Libderiv->deriv2_classes[2][8][31] = int_stack + 116710;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 116980;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 117190;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 117470;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 117830;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 118280;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 118595;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 119015;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 119555;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 120230;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 120356;
 Libderiv->deriv2_classes[2][7][30] = int_stack + 120524;
 Libderiv->deriv2_classes[2][8][30] = int_stack + 120740;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 121010;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 121220;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 121500;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 121860;
 Libderiv->deriv_classes[4][5][2] = int_stack + 122310;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 122625;
 Libderiv->deriv_classes[4][6][2] = int_stack + 122940;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 123360;
 Libderiv->deriv_classes[4][7][2] = int_stack + 123780;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 124320;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 124860;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 125535;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 125661;
 Libderiv->deriv2_classes[2][7][26] = int_stack + 125829;
 Libderiv->deriv2_classes[2][8][26] = int_stack + 126045;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 126315;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 126525;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 126805;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 127165;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 127615;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 127930;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 128350;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 128890;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 129565;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 129691;
 Libderiv->deriv2_classes[2][7][23] = int_stack + 129859;
 Libderiv->deriv2_classes[2][8][23] = int_stack + 130075;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 130345;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 130555;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 130835;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 131195;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 131645;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 131960;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 132380;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 132920;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 133595;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 133721;
 Libderiv->deriv2_classes[2][7][22] = int_stack + 133889;
 Libderiv->deriv2_classes[2][8][22] = int_stack + 134105;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 134375;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 134585;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 134865;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 135225;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 135675;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 135990;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 136410;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 136950;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 137625;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 137751;
 Libderiv->deriv2_classes[2][7][21] = int_stack + 137919;
 Libderiv->deriv2_classes[2][8][21] = int_stack + 138135;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 138405;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 138615;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 138895;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 139255;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 139705;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 140020;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 140440;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 140980;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 141655;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 141781;
 Libderiv->deriv2_classes[2][7][20] = int_stack + 141949;
 Libderiv->deriv2_classes[2][8][20] = int_stack + 142165;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 142435;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 142645;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 142925;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 143285;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 143735;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 144050;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 144470;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 145010;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 145685;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 145811;
 Libderiv->deriv2_classes[2][7][19] = int_stack + 145979;
 Libderiv->deriv2_classes[2][8][19] = int_stack + 146195;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 146465;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 146675;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 146955;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 147315;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 147765;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 148080;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 148500;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 149040;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 149715;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 149841;
 Libderiv->deriv2_classes[2][7][18] = int_stack + 150009;
 Libderiv->deriv2_classes[2][8][18] = int_stack + 150225;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 150495;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 150705;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 150985;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 151345;
 Libderiv->deriv_classes[4][5][1] = int_stack + 151795;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 152110;
 Libderiv->deriv_classes[4][6][1] = int_stack + 152425;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 152845;
 Libderiv->deriv_classes[4][7][1] = int_stack + 153265;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 153805;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 154345;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 155020;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 155146;
 Libderiv->deriv2_classes[2][7][14] = int_stack + 155314;
 Libderiv->deriv2_classes[2][8][14] = int_stack + 155530;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 155800;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 156010;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 156290;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 156650;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 157100;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 157415;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 157835;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 158375;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 159050;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 159176;
 Libderiv->deriv2_classes[2][7][13] = int_stack + 159344;
 Libderiv->deriv2_classes[2][8][13] = int_stack + 159560;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 159830;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 160040;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 160320;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 160680;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 161130;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 161445;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 161865;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 162405;
 Libderiv->deriv_classes[2][5][11] = int_stack + 163080;
 Libderiv->deriv_classes[2][6][11] = int_stack + 163206;
 Libderiv->deriv_classes[2][7][11] = int_stack + 163374;
 Libderiv->deriv_classes[2][8][11] = int_stack + 163590;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 163860;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 163986;
 Libderiv->deriv2_classes[2][7][11] = int_stack + 164154;
 Libderiv->deriv2_classes[2][8][11] = int_stack + 164370;
 Libderiv->deriv_classes[3][5][11] = int_stack + 164640;
 Libderiv->deriv_classes[3][6][11] = int_stack + 164850;
 Libderiv->deriv_classes[3][7][11] = int_stack + 165130;
 Libderiv->deriv_classes[3][8][11] = int_stack + 165490;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 165940;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 166150;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 166430;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 166790;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 167240;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 167555;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 167975;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 168515;
 Libderiv->deriv_classes[2][5][10] = int_stack + 169190;
 Libderiv->deriv_classes[2][6][10] = int_stack + 169316;
 Libderiv->deriv_classes[2][7][10] = int_stack + 169484;
 Libderiv->deriv_classes[2][8][10] = int_stack + 169700;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 169970;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 170096;
 Libderiv->deriv2_classes[2][7][10] = int_stack + 170264;
 Libderiv->deriv2_classes[2][8][10] = int_stack + 170480;
 Libderiv->deriv_classes[3][5][10] = int_stack + 170750;
 Libderiv->deriv_classes[3][6][10] = int_stack + 170960;
 Libderiv->deriv_classes[3][7][10] = int_stack + 171240;
 Libderiv->deriv_classes[3][8][10] = int_stack + 171600;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 172050;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 172260;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 172540;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 172900;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 173350;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 173665;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 174085;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 174625;
 Libderiv->deriv_classes[2][5][9] = int_stack + 175300;
 Libderiv->deriv_classes[2][6][9] = int_stack + 175426;
 Libderiv->deriv_classes[2][7][9] = int_stack + 175594;
 Libderiv->deriv_classes[2][8][9] = int_stack + 175810;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 176080;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 176206;
 Libderiv->deriv2_classes[2][7][9] = int_stack + 176374;
 Libderiv->deriv2_classes[2][8][9] = int_stack + 176590;
 Libderiv->deriv_classes[3][5][9] = int_stack + 176860;
 Libderiv->deriv_classes[3][6][9] = int_stack + 177070;
 Libderiv->deriv_classes[3][7][9] = int_stack + 177350;
 Libderiv->deriv_classes[3][8][9] = int_stack + 177710;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 178160;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 178370;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 178650;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 179010;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 179460;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 179775;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 180195;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 180735;
 Libderiv->deriv_classes[2][5][8] = int_stack + 181410;
 Libderiv->deriv_classes[2][6][8] = int_stack + 181536;
 Libderiv->deriv_classes[2][7][8] = int_stack + 181704;
 Libderiv->deriv_classes[2][8][8] = int_stack + 181920;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 182190;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 182316;
 Libderiv->deriv2_classes[2][7][8] = int_stack + 182484;
 Libderiv->deriv2_classes[2][8][8] = int_stack + 182700;
 Libderiv->deriv_classes[3][5][8] = int_stack + 182970;
 Libderiv->deriv_classes[3][6][8] = int_stack + 183180;
 Libderiv->deriv_classes[3][7][8] = int_stack + 183460;
 Libderiv->deriv_classes[3][8][8] = int_stack + 183820;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 184270;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 184480;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 184760;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 185120;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 185570;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 185885;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 186305;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 186845;
 Libderiv->deriv_classes[2][5][7] = int_stack + 187520;
 Libderiv->deriv_classes[2][6][7] = int_stack + 187646;
 Libderiv->deriv_classes[2][7][7] = int_stack + 187814;
 Libderiv->deriv_classes[2][8][7] = int_stack + 188030;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 188300;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 188426;
 Libderiv->deriv2_classes[2][7][7] = int_stack + 188594;
 Libderiv->deriv2_classes[2][8][7] = int_stack + 188810;
 Libderiv->deriv_classes[3][5][7] = int_stack + 189080;
 Libderiv->deriv_classes[3][6][7] = int_stack + 189290;
 Libderiv->deriv_classes[3][7][7] = int_stack + 189570;
 Libderiv->deriv_classes[3][8][7] = int_stack + 189930;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 190380;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 190590;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 190870;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 191230;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 191680;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 191995;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 192415;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 192955;
 Libderiv->deriv_classes[2][5][6] = int_stack + 193630;
 Libderiv->deriv_classes[2][6][6] = int_stack + 193756;
 Libderiv->deriv_classes[2][7][6] = int_stack + 193924;
 Libderiv->deriv_classes[2][8][6] = int_stack + 194140;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 194410;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 194536;
 Libderiv->deriv2_classes[2][7][6] = int_stack + 194704;
 Libderiv->deriv2_classes[2][8][6] = int_stack + 194920;
 Libderiv->dvrr_classes[3][5] = int_stack + 195190;
 Libderiv->deriv_classes[3][5][6] = int_stack + 195400;
 Libderiv->dvrr_classes[3][6] = int_stack + 195610;
 Libderiv->deriv_classes[3][6][6] = int_stack + 195890;
 Libderiv->dvrr_classes[3][7] = int_stack + 196170;
 Libderiv->deriv_classes[3][7][6] = int_stack + 196530;
 Libderiv->deriv_classes[3][8][6] = int_stack + 196890;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 197340;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 197550;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 197830;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 198190;
 Libderiv->deriv_classes[4][5][0] = int_stack + 198640;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 198955;
 Libderiv->deriv_classes[4][6][0] = int_stack + 199270;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 199690;
 Libderiv->deriv_classes[4][7][0] = int_stack + 200110;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 200650;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 201190;
 Libderiv->deriv_classes[2][5][2] = int_stack + 201865;
 Libderiv->deriv_classes[2][6][2] = int_stack + 201991;
 Libderiv->deriv_classes[2][7][2] = int_stack + 202159;
 Libderiv->deriv_classes[2][8][2] = int_stack + 202375;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 202645;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 202771;
 Libderiv->deriv2_classes[2][7][2] = int_stack + 202939;
 Libderiv->deriv2_classes[2][8][2] = int_stack + 203155;
 Libderiv->deriv_classes[3][5][2] = int_stack + 203425;
 Libderiv->deriv_classes[3][6][2] = int_stack + 203635;
 Libderiv->deriv_classes[3][7][2] = int_stack + 203915;
 Libderiv->deriv_classes[3][8][2] = int_stack + 204275;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 204725;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 204935;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 205215;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 205575;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 206025;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 206340;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 206760;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 207300;
 Libderiv->deriv_classes[2][5][1] = int_stack + 207975;
 Libderiv->deriv_classes[2][6][1] = int_stack + 208101;
 Libderiv->deriv_classes[2][7][1] = int_stack + 208269;
 Libderiv->deriv_classes[2][8][1] = int_stack + 208485;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 208755;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 208881;
 Libderiv->deriv2_classes[2][7][1] = int_stack + 209049;
 Libderiv->deriv2_classes[2][8][1] = int_stack + 209265;
 Libderiv->deriv_classes[3][5][1] = int_stack + 209535;
 Libderiv->deriv_classes[3][6][1] = int_stack + 209745;
 Libderiv->deriv_classes[3][7][1] = int_stack + 210025;
 Libderiv->deriv_classes[3][8][1] = int_stack + 210385;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 210835;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 211045;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 211325;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 211685;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 212135;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 212450;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 212870;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 213410;
 Libderiv->dvrr_classes[2][5] = int_stack + 214085;
 Libderiv->dvrr_classes[2][6] = int_stack + 214211;
 Libderiv->dvrr_classes[2][7] = int_stack + 214379;
 Libderiv->dvrr_classes[2][8] = int_stack + 214595;
 Libderiv->deriv_classes[2][5][0] = int_stack + 214865;
 Libderiv->deriv_classes[2][6][0] = int_stack + 214991;
 Libderiv->deriv_classes[2][7][0] = int_stack + 215159;
 Libderiv->deriv_classes[2][8][0] = int_stack + 215375;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 215645;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 215771;
 Libderiv->deriv2_classes[2][7][0] = int_stack + 215939;
 Libderiv->deriv2_classes[2][8][0] = int_stack + 216155;
 Libderiv->deriv_classes[3][5][0] = int_stack + 216425;
 Libderiv->deriv_classes[3][6][0] = int_stack + 216635;
 Libderiv->deriv_classes[3][7][0] = int_stack + 216915;
 Libderiv->deriv_classes[3][8][0] = int_stack + 217275;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 217725;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 217935;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 218215;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 218575;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 219025;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 219340;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 219760;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 220300;
 memset(int_stack,0,1767800);

 Libderiv->dvrr_stack = int_stack + 631612;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ddhf(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+220975,int_stack+214211,int_stack+214085,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+221353,int_stack+214379,int_stack+214211,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+221857,int_stack+221353,int_stack+220975,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+222613,int_stack+163206,int_stack+163080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214085,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+222991,int_stack+163374,int_stack+163206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214211,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+223495,int_stack+222991,int_stack+222613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+224251,int_stack+163590,int_stack+163374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214379,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+224899,int_stack+224251,int_stack+222991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221353,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+225907,int_stack+224899,int_stack+223495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221857,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+224251,int_stack+195610,int_stack+195190,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+224881,int_stack+196170,int_stack+195610,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+227167,int_stack+224881,int_stack+224251,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228427,int_stack+164850,int_stack+164640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195190,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+229057,int_stack+165130,int_stack+164850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195610,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+229897,int_stack+229057,int_stack+228427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+231157,int_stack+165490,int_stack+165130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196170,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+232237,int_stack+231157,int_stack+229057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224881,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+233917,int_stack+232237,int_stack+229897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+236017,int_stack+233917,int_stack+225907,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+231157,int_stack+97065,int_stack+96120,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+232102,int_stack+3375,int_stack+97065,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+232102,int_stack+231157,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+241687,int_stack+70225,int_stack+69595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96120,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+242632,int_stack+71065,int_stack+70225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97065,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+243892,int_stack+242632,int_stack+241687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231157,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+245782,int_stack+0,int_stack+71065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+247402,int_stack+245782,int_stack+242632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232102,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+249922,int_stack+247402,int_stack+243892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+253072,int_stack+249922,int_stack+233917,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+245782,int_stack+169316,int_stack+169190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214085, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+246160,int_stack+169484,int_stack+169316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214211, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+246664,int_stack+246160,int_stack+245782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+247420,int_stack+169700,int_stack+169484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214379, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+248068,int_stack+247420,int_stack+246160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221353, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+249076,int_stack+248068,int_stack+246664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221857, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+247420,int_stack+170960,int_stack+170750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195190, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+248050,int_stack+171240,int_stack+170960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195610, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+250336,int_stack+248050,int_stack+247420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+251596,int_stack+171600,int_stack+171240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196170, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+259372,int_stack+251596,int_stack+248050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224881, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+261052,int_stack+259372,int_stack+250336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+263152,int_stack+261052,int_stack+249076,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259372,int_stack+75530,int_stack+74900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96120, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251596,int_stack+76370,int_stack+75530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97065, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+266932,int_stack+251596,int_stack+259372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231157, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+268822,int_stack+675,int_stack+76370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+270442,int_stack+268822,int_stack+251596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232102, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+272962,int_stack+270442,int_stack+266932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+276112,int_stack+272962,int_stack+261052,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+268822,int_stack+175426,int_stack+175300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214085, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269200,int_stack+175594,int_stack+175426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214211, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+269704,int_stack+269200,int_stack+268822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+270460,int_stack+175810,int_stack+175594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214379, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+271108,int_stack+270460,int_stack+269200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221353, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+272116,int_stack+271108,int_stack+269704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221857, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+270460,int_stack+177070,int_stack+176860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195190, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+271090,int_stack+177350,int_stack+177070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195610, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273376,int_stack+271090,int_stack+270460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+274636,int_stack+177710,int_stack+177350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196170, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+282412,int_stack+274636,int_stack+271090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224881, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+284092,int_stack+282412,int_stack+273376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+286192,int_stack+284092,int_stack+272116,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+282412,int_stack+80835,int_stack+80205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96120, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+274636,int_stack+81675,int_stack+80835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97065, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+289972,int_stack+274636,int_stack+282412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231157, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+291862,int_stack+1350,int_stack+81675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293482,int_stack+291862,int_stack+274636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232102, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+296002,int_stack+293482,int_stack+289972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+299152,int_stack+296002,int_stack+284092,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+291862,int_stack+181536,int_stack+181410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+292240,int_stack+181704,int_stack+181536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+292744,int_stack+292240,int_stack+291862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+293500,int_stack+181920,int_stack+181704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+294148,int_stack+293500,int_stack+292240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+295156,int_stack+294148,int_stack+292744, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+293500,int_stack+183180,int_stack+182970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+294130,int_stack+183460,int_stack+183180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+296416,int_stack+294130,int_stack+293500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+297676,int_stack+183820,int_stack+183460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+297676,int_stack+294130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+305452,int_stack+0,int_stack+296416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+307552,int_stack+305452,int_stack+295156,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+86140,int_stack+85510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+297676,int_stack+86980,int_stack+86140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+311332,int_stack+297676,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+313222,int_stack+2025,int_stack+86980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+314842,int_stack+313222,int_stack+297676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+317362,int_stack+314842,int_stack+311332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+320512,int_stack+317362,int_stack+305452,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+313222,int_stack+187646,int_stack+187520, 0.0, zero_stack, 1.0, int_stack+214085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+313600,int_stack+187814,int_stack+187646, 0.0, zero_stack, 1.0, int_stack+214211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314104,int_stack+313600,int_stack+313222, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314860,int_stack+188030,int_stack+187814, 0.0, zero_stack, 1.0, int_stack+214379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+315508,int_stack+314860,int_stack+313600, 0.0, zero_stack, 1.0, int_stack+221353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+316516,int_stack+315508,int_stack+314104, 0.0, zero_stack, 1.0, int_stack+221857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314860,int_stack+189290,int_stack+189080, 0.0, zero_stack, 1.0, int_stack+195190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315490,int_stack+189570,int_stack+189290, 0.0, zero_stack, 1.0, int_stack+195610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+317776,int_stack+315490,int_stack+314860, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+319036,int_stack+189930,int_stack+189570, 0.0, zero_stack, 1.0, int_stack+196170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+945,int_stack+319036,int_stack+315490, 0.0, zero_stack, 1.0, int_stack+224881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+326812,int_stack+945,int_stack+317776, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+328912,int_stack+326812,int_stack+316516,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+91445,int_stack+90815, 0.0, zero_stack, 1.0, int_stack+96120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+319036,int_stack+92285,int_stack+91445, 0.0, zero_stack, 1.0, int_stack+97065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+332692,int_stack+319036,int_stack+945, 0.0, zero_stack, 1.0, int_stack+231157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334582,int_stack+2700,int_stack+92285, 0.0, zero_stack, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+336202,int_stack+334582,int_stack+319036, 0.0, zero_stack, 1.0, int_stack+232102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+338722,int_stack+336202,int_stack+332692, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+341872,int_stack+338722,int_stack+326812,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+334582,int_stack+193756,int_stack+193630, 1.0, int_stack+214085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+334960,int_stack+193924,int_stack+193756, 1.0, int_stack+214211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+335464,int_stack+334960,int_stack+334582, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+336220,int_stack+194140,int_stack+193924, 1.0, int_stack+214379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+336868,int_stack+336220,int_stack+334960, 1.0, int_stack+221353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+337876,int_stack+336868,int_stack+335464, 1.0, int_stack+221857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+336220,int_stack+195890,int_stack+195400, 1.0, int_stack+195190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+336850,int_stack+196530,int_stack+195890, 1.0, int_stack+195610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+339136,int_stack+336850,int_stack+336220, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+340396,int_stack+196890,int_stack+196530, 1.0, int_stack+196170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+340396,int_stack+336850, 1.0, int_stack+224881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+349852,int_stack+348172,int_stack+339136, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+351952,int_stack+349852,int_stack+337876,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+348172,int_stack+97485,int_stack+96435, 1.0, int_stack+96120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+340396,int_stack+98325,int_stack+97485, 1.0, int_stack+97065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+340396,int_stack+348172, 1.0, int_stack+231157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+357622,int_stack+3915,int_stack+98325, 1.0, int_stack+3375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1890,int_stack+357622,int_stack+340396, 1.0, int_stack+232102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+357622,int_stack+1890,int_stack+355732, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+360772,int_stack+357622,int_stack+349852,210);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+357622,int_stack+214595,int_stack+214379,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+358270,int_stack+357622,int_stack+221353,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+359278,int_stack+358270,int_stack+221857,6);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+357622,int_stack+5940,int_stack+196170,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+239797,int_stack+357622,int_stack+224881,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+239797,int_stack+227167,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+367072,int_stack+1890,int_stack+359278,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+227167,int_stack+201991,int_stack+201865,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+227545,int_stack+202159,int_stack+201991,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+227545,int_stack+227167,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+240553,int_stack+202375,int_stack+202159,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+357622,int_stack+240553,int_stack+227545,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+231157,int_stack+357622,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+357622,int_stack+203635,int_stack+203425,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+358252,int_stack+203915,int_stack+203635,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+232417,int_stack+358252,int_stack+357622,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+240553,int_stack+204275,int_stack+203915,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+240553,int_stack+358252,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+372532,int_stack+370852,int_stack+232417,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+374632,int_stack+372532,int_stack+231157, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+370852,int_stack+122940,int_stack+122310,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+224251,int_stack+123780,int_stack+122940,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+224251,int_stack+370852,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+220975,int_stack+4590,int_stack+123780,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+380302,int_stack+220975,int_stack+224251,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+382822,int_stack+380302,int_stack+378412,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+385972,int_stack+382822,int_stack+372532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+228049,int_stack+208101,int_stack+207975,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+380302,int_stack+208269,int_stack+208101,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+380806,int_stack+380302,int_stack+228049,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+381562,int_stack+208485,int_stack+208269,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+382210,int_stack+381562,int_stack+380302,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+383218,int_stack+382210,int_stack+380806,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+381562,int_stack+209745,int_stack+209535,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+382192,int_stack+210025,int_stack+209745,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+384478,int_stack+382192,int_stack+381562,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+220975,int_stack+210385,int_stack+210025,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+220975,int_stack+382192,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+393952,int_stack+392272,int_stack+384478,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+396052,int_stack+393952,int_stack+383218, 0.0, zero_stack, 1.0, int_stack+359278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+392272,int_stack+152425,int_stack+151795,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+220975,int_stack+153265,int_stack+152425,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+220975,int_stack+392272,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+401722,int_stack+5265,int_stack+153265,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+403342,int_stack+401722,int_stack+220975,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+405862,int_stack+403342,int_stack+399832,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+409012,int_stack+405862,int_stack+393952, 0.0, zero_stack, 1.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+222235,int_stack+214991,int_stack+214865,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+401722,int_stack+215159,int_stack+214991,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+402226,int_stack+401722,int_stack+222235,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+402982,int_stack+215375,int_stack+215159,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+403630,int_stack+402982,int_stack+401722,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+404638,int_stack+403630,int_stack+402226,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+402982,int_stack+216635,int_stack+216425,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+403612,int_stack+216915,int_stack+216635,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+405898,int_stack+403612,int_stack+402982,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+407158,int_stack+217275,int_stack+216915,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3990,int_stack+407158,int_stack+403612,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+415312,int_stack+3990,int_stack+405898,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+417412,int_stack+415312,int_stack+404638, 1.0, int_stack+359278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3990,int_stack+199270,int_stack+198640,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4935,int_stack+200110,int_stack+199270,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+421192,int_stack+4935,int_stack+3990,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+407158,int_stack+6390,int_stack+200110,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423082,int_stack+407158,int_stack+4935,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+425602,int_stack+423082,int_stack+421192,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+428752,int_stack+425602,int_stack+415312, 1.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+7191,int_stack+7065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+163080,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+7359,int_stack+7191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+163206,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+222613,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423082,int_stack+7575,int_stack+7359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+163374,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423730,int_stack+423082,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+222991,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+424738,int_stack+423730,int_stack+2772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+223495,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423082,int_stack+8055,int_stack+7845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+164640,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+423712,int_stack+8335,int_stack+8055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+164850,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+423712,int_stack+423082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+228427,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+425998,int_stack+8695,int_stack+8335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+165130,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+425998,int_stack+423712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+229057,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+425998,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+229897,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+435052,int_stack+425998,int_stack+424738,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+9460,int_stack+9145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+69595,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+9880,int_stack+9460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+70225,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+423082,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+241687,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+10420,int_stack+9880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+71065,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6195,int_stack+1890,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+242632,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+423082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+243892,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+441982,int_stack+438832,int_stack+425998,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+11221,int_stack+11095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163080, 1.0, int_stack+169190,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439210,int_stack+11389,int_stack+11221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163206, 1.0, int_stack+169316,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+439714,int_stack+439210,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222613, 1.0, int_stack+245782,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+440470,int_stack+11605,int_stack+11389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163374, 1.0, int_stack+169484,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423082,int_stack+440470,int_stack+439210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222991, 1.0, int_stack+246160,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440470,int_stack+423082,int_stack+439714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223495, 1.0, int_stack+246664,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423082,int_stack+12085,int_stack+11875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164640, 1.0, int_stack+170750,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+423712,int_stack+12365,int_stack+12085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164850, 1.0, int_stack+170960,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+424552,int_stack+423712,int_stack+423082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228427, 1.0, int_stack+247420,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+425812,int_stack+12725,int_stack+12365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165130, 1.0, int_stack+171240,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+425812,int_stack+423712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229057, 1.0, int_stack+248050,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+424552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229897, 1.0, int_stack+250336,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+423082,int_stack+1890,int_stack+440470,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+359092,int_stack+13490,int_stack+13175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69595, 1.0, int_stack+74900,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+426862,int_stack+13910,int_stack+13490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70225, 1.0, int_stack+75530,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+438832,int_stack+426862,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241687, 1.0, int_stack+259372,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+359092,int_stack+14450,int_stack+13910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71065, 1.0, int_stack+76370,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242632, 1.0, int_stack+251596,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8715,int_stack+6195,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243892, 1.0, int_stack+266932,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+448282,int_stack+8715,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+15251,int_stack+15125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+169190, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+15419,int_stack+15251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+169316, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+245782, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+15635,int_stack+15419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+169484, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+246160, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+2772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+246664, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+16115,int_stack+15905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+170750, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+16395,int_stack+16115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+170960, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+439462,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+247420, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+16755,int_stack+16395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+171240, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+6195,int_stack+439462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+248050, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+250336, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+8295,int_stack+6195,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+17520,int_stack+17205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+74900, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+17940,int_stack+17520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+75530, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+259372, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+18480,int_stack+17940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+76370, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12075,int_stack+1890,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+251596, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+12075,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+266932, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12075,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+19281,int_stack+19155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163080, 0.0, zero_stack, 1.0, int_stack+175300,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+19449,int_stack+19281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163206, 0.0, zero_stack, 1.0, int_stack+175426,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222613, 0.0, zero_stack, 1.0, int_stack+268822,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+19665,int_stack+19449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163374, 0.0, zero_stack, 1.0, int_stack+175594,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222991, 0.0, zero_stack, 1.0, int_stack+269200,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223495, 0.0, zero_stack, 1.0, int_stack+269704,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+20145,int_stack+19935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164640, 0.0, zero_stack, 1.0, int_stack+176860,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+20425,int_stack+20145, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164850, 0.0, zero_stack, 1.0, int_stack+177070,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228427, 0.0, zero_stack, 1.0, int_stack+270460,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+20785,int_stack+20425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165130, 0.0, zero_stack, 1.0, int_stack+177350,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229057, 0.0, zero_stack, 1.0, int_stack+271090,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229897, 0.0, zero_stack, 1.0, int_stack+273376,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+454582,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+21550,int_stack+21235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69595, 0.0, zero_stack, 1.0, int_stack+80205,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+21970,int_stack+21550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70225, 0.0, zero_stack, 1.0, int_stack+80835,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241687, 0.0, zero_stack, 1.0, int_stack+282412,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+22510,int_stack+21970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71065, 0.0, zero_stack, 1.0, int_stack+81675,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242632, 0.0, zero_stack, 1.0, int_stack+274636,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18375,int_stack+438832,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243892, 0.0, zero_stack, 1.0, int_stack+289972,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+458362,int_stack+18375,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+23311,int_stack+23185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169190, 1.0, int_stack+175300, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+23479,int_stack+23311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169316, 1.0, int_stack+175426, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245782, 1.0, int_stack+268822, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+18375,int_stack+23695,int_stack+23479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169484, 1.0, int_stack+175594, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19023,int_stack+18375,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246160, 1.0, int_stack+269200, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20031,int_stack+19023,int_stack+2772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246664, 1.0, int_stack+269704, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18375,int_stack+24175,int_stack+23965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170750, 1.0, int_stack+176860, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19005,int_stack+24455,int_stack+24175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170960, 1.0, int_stack+177070, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+19005,int_stack+18375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247420, 1.0, int_stack+270460, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21291,int_stack+24815,int_stack+24455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171240, 1.0, int_stack+177350, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+21291,int_stack+19005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248050, 1.0, int_stack+271090, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250336, 1.0, int_stack+273376, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+21291,int_stack+6195,int_stack+20031,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+25580,int_stack+25265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74900, 1.0, int_stack+80205, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+26000,int_stack+25580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75530, 1.0, int_stack+80835, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259372, 1.0, int_stack+282412, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+26540,int_stack+26000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76370, 1.0, int_stack+81675, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18375,int_stack+1890,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251596, 1.0, int_stack+274636, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+18375,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266932, 1.0, int_stack+289972, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+464662,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+27341,int_stack+27215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+175300, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+27509,int_stack+27341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+175426, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+268822, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+27725,int_stack+27509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+175594, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269200, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269704, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+28205,int_stack+27995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+176860, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+28485,int_stack+28205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+177070, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270460, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+28845,int_stack+28485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+177350, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+271090, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+273376, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+25071,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+29610,int_stack+29295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80205, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+30030,int_stack+29610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80835, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+282412, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+30570,int_stack+30030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+81675, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+274636, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+289972, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+474112,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+31371,int_stack+31245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181410,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+31539,int_stack+31371, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181536,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291862,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+31755,int_stack+31539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163374, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181704,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292240,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292744,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+32235,int_stack+32025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182970,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+32515,int_stack+32235, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183180,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228427, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293500,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+32875,int_stack+32515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183460,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+471592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229057, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294130,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296416,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+28851,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+33640,int_stack+33325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+85510,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+34060,int_stack+33640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86140,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241687, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+34600,int_stack+34060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86980,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+1890,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297676,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311332,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+480412,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+35401,int_stack+35275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169190, 0.0, zero_stack, 1.0, int_stack+181410, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+35569,int_stack+35401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169316, 0.0, zero_stack, 1.0, int_stack+181536, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245782, 0.0, zero_stack, 1.0, int_stack+291862, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+35785,int_stack+35569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169484, 0.0, zero_stack, 1.0, int_stack+181704, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246160, 0.0, zero_stack, 1.0, int_stack+292240, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246664, 0.0, zero_stack, 1.0, int_stack+292744, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+36265,int_stack+36055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170750, 0.0, zero_stack, 1.0, int_stack+182970, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+36545,int_stack+36265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170960, 0.0, zero_stack, 1.0, int_stack+183180, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247420, 0.0, zero_stack, 1.0, int_stack+293500, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+36905,int_stack+36545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171240, 0.0, zero_stack, 1.0, int_stack+183460, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248050, 0.0, zero_stack, 1.0, int_stack+294130, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250336, 0.0, zero_stack, 1.0, int_stack+296416, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+32631,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+37670,int_stack+37355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74900, 0.0, zero_stack, 1.0, int_stack+85510, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+38090,int_stack+37670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75530, 0.0, zero_stack, 1.0, int_stack+86140, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259372, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+38630,int_stack+38090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76370, 0.0, zero_stack, 1.0, int_stack+86980, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251596, 0.0, zero_stack, 1.0, int_stack+297676, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266932, 0.0, zero_stack, 1.0, int_stack+311332, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+486712,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+39431,int_stack+39305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175300, 1.0, int_stack+181410, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+39599,int_stack+39431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175426, 1.0, int_stack+181536, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268822, 1.0, int_stack+291862, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+39815,int_stack+39599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175594, 1.0, int_stack+181704, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269200, 1.0, int_stack+292240, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269704, 1.0, int_stack+292744, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+40295,int_stack+40085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176860, 1.0, int_stack+182970, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+40575,int_stack+40295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177070, 1.0, int_stack+183180, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270460, 1.0, int_stack+293500, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+40935,int_stack+40575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177350, 1.0, int_stack+183460, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+471592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271090, 1.0, int_stack+294130, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273376, 1.0, int_stack+296416, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+36411,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+41700,int_stack+41385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80205, 1.0, int_stack+85510, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+42120,int_stack+41700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80835, 1.0, int_stack+86140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282412, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+42660,int_stack+42120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81675, 1.0, int_stack+86980, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+1890,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274636, 1.0, int_stack+297676, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289972, 1.0, int_stack+311332, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+493012,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+43461,int_stack+43335, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+181410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+43629,int_stack+43461, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+181536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+291862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+43845,int_stack+43629, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+181704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+292240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+292744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+44325,int_stack+44115, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+182970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+44605,int_stack+44325, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+183180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+293500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+44965,int_stack+44605, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+183460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+294130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+296416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+40191,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+45730,int_stack+45415, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+85510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+46150,int_stack+45730, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+86140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+46690,int_stack+46150, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+86980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+359092, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+297676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+311332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+499312,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+47491,int_stack+47365, 0.0, zero_stack, 1.0, int_stack+163080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187520,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+47659,int_stack+47491, 0.0, zero_stack, 1.0, int_stack+163206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187646,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 1.0, int_stack+222613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313222,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+47875,int_stack+47659, 0.0, zero_stack, 1.0, int_stack+163374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187814,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 0.0, zero_stack, 1.0, int_stack+222991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313600,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 0.0, zero_stack, 1.0, int_stack+223495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314104,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+48355,int_stack+48145, 0.0, zero_stack, 1.0, int_stack+164640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189080,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+48635,int_stack+48355, 0.0, zero_stack, 1.0, int_stack+164850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189290,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 0.0, zero_stack, 1.0, int_stack+228427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314860,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+48995,int_stack+48635, 0.0, zero_stack, 1.0, int_stack+165130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189570,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+471592, 0.0, zero_stack, 1.0, int_stack+229057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315490,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 1.0, int_stack+229897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317776,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+43971,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+49760,int_stack+49445, 0.0, zero_stack, 1.0, int_stack+69595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90815,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+50180,int_stack+49760, 0.0, zero_stack, 1.0, int_stack+70225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91445,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 1.0, int_stack+241687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+50720,int_stack+50180, 0.0, zero_stack, 1.0, int_stack+71065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92285,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+1890,int_stack+359092, 0.0, zero_stack, 1.0, int_stack+242632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319036,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 0.0, zero_stack, 1.0, int_stack+243892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332692,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+505612,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+51521,int_stack+51395, 0.0, zero_stack, 1.0, int_stack+169190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187520, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+51689,int_stack+51521, 0.0, zero_stack, 1.0, int_stack+169316, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187646, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+245782, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313222, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+51905,int_stack+51689, 0.0, zero_stack, 1.0, int_stack+169484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187814, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 1.0, int_stack+246160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313600, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 1.0, int_stack+246664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314104, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+52385,int_stack+52175, 0.0, zero_stack, 1.0, int_stack+170750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189080, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+52665,int_stack+52385, 0.0, zero_stack, 1.0, int_stack+170960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189290, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 1.0, int_stack+247420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314860, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+53025,int_stack+52665, 0.0, zero_stack, 1.0, int_stack+171240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189570, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 0.0, zero_stack, 1.0, int_stack+248050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315490, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+250336, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317776, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+47751,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+53790,int_stack+53475, 0.0, zero_stack, 1.0, int_stack+74900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90815, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+54210,int_stack+53790, 0.0, zero_stack, 1.0, int_stack+75530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91445, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+259372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+54750,int_stack+54210, 0.0, zero_stack, 1.0, int_stack+76370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92285, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+359092, 0.0, zero_stack, 1.0, int_stack+251596, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319036, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 0.0, zero_stack, 1.0, int_stack+266932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332692, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+511912,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+55551,int_stack+55425, 0.0, zero_stack, 1.0, int_stack+175300, 0.0, zero_stack, 1.0, int_stack+187520, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+55719,int_stack+55551, 0.0, zero_stack, 1.0, int_stack+175426, 0.0, zero_stack, 1.0, int_stack+187646, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 1.0, int_stack+268822, 0.0, zero_stack, 1.0, int_stack+313222, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+55935,int_stack+55719, 0.0, zero_stack, 1.0, int_stack+175594, 0.0, zero_stack, 1.0, int_stack+187814, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 0.0, zero_stack, 1.0, int_stack+269200, 0.0, zero_stack, 1.0, int_stack+313600, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 0.0, zero_stack, 1.0, int_stack+269704, 0.0, zero_stack, 1.0, int_stack+314104, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+56415,int_stack+56205, 0.0, zero_stack, 1.0, int_stack+176860, 0.0, zero_stack, 1.0, int_stack+189080, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+56695,int_stack+56415, 0.0, zero_stack, 1.0, int_stack+177070, 0.0, zero_stack, 1.0, int_stack+189290, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 0.0, zero_stack, 1.0, int_stack+270460, 0.0, zero_stack, 1.0, int_stack+314860, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+57055,int_stack+56695, 0.0, zero_stack, 1.0, int_stack+177350, 0.0, zero_stack, 1.0, int_stack+189570, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+471592, 0.0, zero_stack, 1.0, int_stack+271090, 0.0, zero_stack, 1.0, int_stack+315490, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 1.0, int_stack+273376, 0.0, zero_stack, 1.0, int_stack+317776, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+51531,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+57820,int_stack+57505, 0.0, zero_stack, 1.0, int_stack+80205, 0.0, zero_stack, 1.0, int_stack+90815, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+58240,int_stack+57820, 0.0, zero_stack, 1.0, int_stack+80835, 0.0, zero_stack, 1.0, int_stack+91445, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 1.0, int_stack+282412, 0.0, zero_stack, 1.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+58780,int_stack+58240, 0.0, zero_stack, 1.0, int_stack+81675, 0.0, zero_stack, 1.0, int_stack+92285, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+1890,int_stack+359092, 0.0, zero_stack, 1.0, int_stack+274636, 0.0, zero_stack, 1.0, int_stack+319036, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 0.0, zero_stack, 1.0, int_stack+289972, 0.0, zero_stack, 1.0, int_stack+332692, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+518212,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+59581,int_stack+59455, 0.0, zero_stack, 1.0, int_stack+181410, 1.0, int_stack+187520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+59749,int_stack+59581, 0.0, zero_stack, 1.0, int_stack+181536, 1.0, int_stack+187646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+291862, 1.0, int_stack+313222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+59965,int_stack+59749, 0.0, zero_stack, 1.0, int_stack+181704, 1.0, int_stack+187814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 1.0, int_stack+292240, 1.0, int_stack+313600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 1.0, int_stack+292744, 1.0, int_stack+314104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+60445,int_stack+60235, 0.0, zero_stack, 1.0, int_stack+182970, 1.0, int_stack+189080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+60725,int_stack+60445, 0.0, zero_stack, 1.0, int_stack+183180, 1.0, int_stack+189290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 1.0, int_stack+293500, 1.0, int_stack+314860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+61085,int_stack+60725, 0.0, zero_stack, 1.0, int_stack+183460, 1.0, int_stack+189570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 0.0, zero_stack, 1.0, int_stack+294130, 1.0, int_stack+315490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+296416, 1.0, int_stack+317776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+55311,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+61850,int_stack+61535, 0.0, zero_stack, 1.0, int_stack+85510, 1.0, int_stack+90815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+62270,int_stack+61850, 0.0, zero_stack, 1.0, int_stack+86140, 1.0, int_stack+91445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+62810,int_stack+62270, 0.0, zero_stack, 1.0, int_stack+86980, 1.0, int_stack+92285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+359092, 0.0, zero_stack, 1.0, int_stack+297676, 1.0, int_stack+319036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 0.0, zero_stack, 1.0, int_stack+311332, 1.0, int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+524512,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+63611,int_stack+63485, 0.0, zero_stack, 2.0, int_stack+187520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+63779,int_stack+63611, 0.0, zero_stack, 2.0, int_stack+187646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 0.0, zero_stack, 2.0, int_stack+313222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+63995,int_stack+63779, 0.0, zero_stack, 2.0, int_stack+187814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 0.0, zero_stack, 2.0, int_stack+313600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 0.0, zero_stack, 2.0, int_stack+314104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+64475,int_stack+64265, 0.0, zero_stack, 2.0, int_stack+189080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+64755,int_stack+64475, 0.0, zero_stack, 2.0, int_stack+189290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 0.0, zero_stack, 2.0, int_stack+314860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+65115,int_stack+64755, 0.0, zero_stack, 2.0, int_stack+189570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+471592, 0.0, zero_stack, 2.0, int_stack+315490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+1890, 0.0, zero_stack, 2.0, int_stack+317776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+59091,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+65880,int_stack+65565, 0.0, zero_stack, 2.0, int_stack+90815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+66300,int_stack+65880, 0.0, zero_stack, 2.0, int_stack+91445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+1890, 0.0, zero_stack, 2.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1890,int_stack+66840,int_stack+66300, 0.0, zero_stack, 2.0, int_stack+92285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+1890,int_stack+359092, 0.0, zero_stack, 2.0, int_stack+319036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 0.0, zero_stack, 2.0, int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+530812,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+67641,int_stack+67515, 1.0, int_stack+163080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193630,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+67809,int_stack+67641, 1.0, int_stack+163206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193756,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 1.0, int_stack+222613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334582,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+68025,int_stack+67809, 1.0, int_stack+163374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193924,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 1.0, int_stack+222991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334960,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 1.0, int_stack+223495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335464,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+68505,int_stack+68295, 1.0, int_stack+164640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195400,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+68785,int_stack+68505, 1.0, int_stack+164850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195890,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+222613,int_stack+439462,int_stack+438832, 1.0, int_stack+228427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336220,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+69145,int_stack+68785, 1.0, int_stack+165130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196530,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+6195,int_stack+439462, 1.0, int_stack+229057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336850,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+359092,int_stack+222613, 1.0, int_stack+229897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339136,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+62871,int_stack+6195,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+222613,int_stack+70645,int_stack+69910, 1.0, int_stack+69595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96435,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+359092,int_stack+71605,int_stack+70645, 1.0, int_stack+70225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97485,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+359092,int_stack+222613, 1.0, int_stack+241687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348172,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+222613,int_stack+72145,int_stack+71605, 1.0, int_stack+71065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98325,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+228427,int_stack+222613,int_stack+359092, 1.0, int_stack+242632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340396,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+228427,int_stack+426862, 1.0, int_stack+243892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355732,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+537112,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+72946,int_stack+72820, 1.0, int_stack+169190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193630, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+73114,int_stack+72946, 1.0, int_stack+169316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193756, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 1.0, int_stack+245782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334582, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+73330,int_stack+73114, 1.0, int_stack+169484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193924, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 1.0, int_stack+246160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334960, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 1.0, int_stack+246664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335464, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+73810,int_stack+73600, 1.0, int_stack+170750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195400, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+74090,int_stack+73810, 1.0, int_stack+170960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195890, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 1.0, int_stack+247420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336220, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426862,int_stack+74450,int_stack+74090, 1.0, int_stack+171240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196530, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359092,int_stack+426862,int_stack+439462, 1.0, int_stack+248050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336850, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+359092,int_stack+6195, 1.0, int_stack+250336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339136, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+66651,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+250336,int_stack+75950,int_stack+75215, 1.0, int_stack+74900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96435, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6195,int_stack+76910,int_stack+75950, 1.0, int_stack+75530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97485, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+6195,int_stack+250336, 1.0, int_stack+259372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348172, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+259372,int_stack+77450,int_stack+76910, 1.0, int_stack+76370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98325, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+259372,int_stack+6195, 1.0, int_stack+251596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340396, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 1.0, int_stack+266932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355732, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+70431,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+78251,int_stack+78125, 1.0, int_stack+175300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193630, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+78419,int_stack+78251, 1.0, int_stack+175426, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193756, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 1.0, int_stack+268822, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334582, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+78635,int_stack+78419, 1.0, int_stack+175594, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193924, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 1.0, int_stack+269200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334960, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 1.0, int_stack+269704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335464, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+79115,int_stack+78905, 1.0, int_stack+176860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195400, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+79395,int_stack+79115, 1.0, int_stack+177070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195890, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 1.0, int_stack+270460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336220, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+266932,int_stack+79755,int_stack+79395, 1.0, int_stack+177350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196530, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+259372,int_stack+266932,int_stack+471592, 1.0, int_stack+271090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336850, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+259372,int_stack+1890, 1.0, int_stack+273376, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339136, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+266932,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+273376,int_stack+81255,int_stack+80520, 1.0, int_stack+80205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96435, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1890,int_stack+82215,int_stack+81255, 1.0, int_stack+80835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97485, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+1890,int_stack+273376, 1.0, int_stack+282412, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348172, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+282412,int_stack+82755,int_stack+82215, 1.0, int_stack+81675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98325, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+282412,int_stack+1890, 1.0, int_stack+274636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340396, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 1.0, int_stack+289972, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355732, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+76731,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+83556,int_stack+83430, 1.0, int_stack+181410, 0.0, zero_stack, 1.0, int_stack+193630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+83724,int_stack+83556, 1.0, int_stack+181536, 0.0, zero_stack, 1.0, int_stack+193756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 1.0, int_stack+291862, 0.0, zero_stack, 1.0, int_stack+334582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+83940,int_stack+83724, 1.0, int_stack+181704, 0.0, zero_stack, 1.0, int_stack+193924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 1.0, int_stack+292240, 0.0, zero_stack, 1.0, int_stack+334960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 1.0, int_stack+292744, 0.0, zero_stack, 1.0, int_stack+335464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+84420,int_stack+84210, 1.0, int_stack+182970, 0.0, zero_stack, 1.0, int_stack+195400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+84700,int_stack+84420, 1.0, int_stack+183180, 0.0, zero_stack, 1.0, int_stack+195890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 1.0, int_stack+293500, 0.0, zero_stack, 1.0, int_stack+336220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289972,int_stack+85060,int_stack+84700, 1.0, int_stack+183460, 0.0, zero_stack, 1.0, int_stack+196530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+282412,int_stack+289972,int_stack+439462, 1.0, int_stack+294130, 0.0, zero_stack, 1.0, int_stack+336850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1890,int_stack+282412,int_stack+6195, 1.0, int_stack+296416, 0.0, zero_stack, 1.0, int_stack+339136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+289972,int_stack+1890,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+296416,int_stack+86560,int_stack+85825, 1.0, int_stack+85510, 0.0, zero_stack, 1.0, int_stack+96435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6195,int_stack+87520,int_stack+86560, 1.0, int_stack+86140, 0.0, zero_stack, 1.0, int_stack+97485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+6195,int_stack+296416, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+282412,int_stack+88060,int_stack+87520, 1.0, int_stack+86980, 0.0, zero_stack, 1.0, int_stack+98325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+282412,int_stack+6195, 1.0, int_stack+297676, 0.0, zero_stack, 1.0, int_stack+340396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 1.0, int_stack+311332, 0.0, zero_stack, 1.0, int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+240553,int_stack+470962,int_stack+1890,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+88861,int_stack+88735, 1.0, int_stack+187520, 1.0, int_stack+193630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+89029,int_stack+88861, 1.0, int_stack+187646, 1.0, int_stack+193756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2772,int_stack+2268,int_stack+1890, 1.0, int_stack+313222, 1.0, int_stack+334582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+89245,int_stack+89029, 1.0, int_stack+187814, 1.0, int_stack+193924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+2268, 1.0, int_stack+313600, 1.0, int_stack+334960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+2772, 1.0, int_stack+314104, 1.0, int_stack+335464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+89725,int_stack+89515, 1.0, int_stack+189080, 1.0, int_stack+195400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+90005,int_stack+89725, 1.0, int_stack+189290, 1.0, int_stack+195890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1890,int_stack+471592,int_stack+470962, 1.0, int_stack+314860, 1.0, int_stack+336220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+311332,int_stack+90365,int_stack+90005, 1.0, int_stack+189570, 1.0, int_stack+196530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+282412,int_stack+311332,int_stack+471592, 1.0, int_stack+315490, 1.0, int_stack+336850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+282412,int_stack+1890, 1.0, int_stack+317776, 1.0, int_stack+339136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+311332,int_stack+6195,int_stack+472618,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+91865,int_stack+91130, 1.0, int_stack+90815, 1.0, int_stack+96435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+317776,int_stack+92825,int_stack+91865, 1.0, int_stack+91445, 1.0, int_stack+97485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+317776,int_stack+0, 1.0, int_stack+945, 1.0, int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+93365,int_stack+92825, 1.0, int_stack+92285, 1.0, int_stack+98325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+0,int_stack+317776, 1.0, int_stack+319036, 1.0, int_stack+340396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 1.0, int_stack+332692, 1.0, int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+83031,int_stack+438832,int_stack+6195,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+94166,int_stack+94040, 2.0, int_stack+193630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+94334,int_stack+94166, 2.0, int_stack+193756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 2.0, int_stack+334582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+94550,int_stack+94334, 2.0, int_stack+193924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 2.0, int_stack+334960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 2.0, int_stack+335464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+95030,int_stack+94820, 2.0, int_stack+195400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+95310,int_stack+95030, 2.0, int_stack+195890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 2.0, int_stack+336220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+332692,int_stack+95670,int_stack+95310, 2.0, int_stack+196530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+282412,int_stack+332692,int_stack+439462, 2.0, int_stack+336850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+332692,int_stack+282412,int_stack+6195, 2.0, int_stack+339136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+332692,int_stack+440488,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+339136,int_stack+97905,int_stack+96750, 2.0, int_stack+96435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6195,int_stack+98865,int_stack+97905, 2.0, int_stack+97485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+6195,int_stack+339136, 2.0, int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+348172,int_stack+99405,int_stack+98865, 2.0, int_stack+98325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334792,int_stack+348172,int_stack+6195, 2.0, int_stack+340396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+334792,int_stack+426862, 2.0, int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+89331,int_stack+438832,int_stack+332692,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+332692,int_stack+100206,int_stack+100080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201865,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+333070,int_stack+100374,int_stack+100206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201991,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333574,int_stack+333070,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334330,int_stack+100590,int_stack+100374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202159,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334978,int_stack+334330,int_stack+333070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227545,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+335986,int_stack+334978,int_stack+333574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+337246,int_stack+101070,int_stack+100860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203425,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+332692,int_stack+101350,int_stack+101070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203635,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333532,int_stack+332692,int_stack+337246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357622,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334792,int_stack+101710,int_stack+101350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203915,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+334792,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358252,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+348172,int_stack+333532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232417,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+95631,int_stack+6195,int_stack+335986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+348172,int_stack+102475,int_stack+102160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122310,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+332692,int_stack+102895,int_stack+102475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122940,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+332692,int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370852,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+348172,int_stack+103435,int_stack+102895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123780,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333952,int_stack+348172,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+333952,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378412,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+543412,int_stack+438832,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+104236,int_stack+104110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201865, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+104404,int_stack+104236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201991, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+104620,int_stack+104404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202159, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227545, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+438832,int_stack+105100,int_stack+104890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203425, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+439462,int_stack+105380,int_stack+105100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203635, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+439462,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357622, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+355732,int_stack+105740,int_stack+105380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203915, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+355732,int_stack+439462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358252, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+332692,int_stack+348172,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232417, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+99411,int_stack+332692,int_stack+440488, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+106505,int_stack+106190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122310, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+348172,int_stack+106925,int_stack+106505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122940, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+348172,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370852, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+107465,int_stack+106925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123780, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+6195,int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378412, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+549712,int_stack+470962,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+332692,int_stack+108266,int_stack+108140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201865, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+333070,int_stack+108434,int_stack+108266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201991, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333574,int_stack+333070,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334330,int_stack+108650,int_stack+108434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202159, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334978,int_stack+334330,int_stack+333070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227545, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+335986,int_stack+334978,int_stack+333574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+337246,int_stack+109130,int_stack+108920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203425, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+332692,int_stack+109410,int_stack+109130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203635, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333532,int_stack+332692,int_stack+337246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357622, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334792,int_stack+109770,int_stack+109410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203915, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+334792,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358252, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+348172,int_stack+333532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232417, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+103191,int_stack+6195,int_stack+335986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+348172,int_stack+110535,int_stack+110220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122310, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+332692,int_stack+110955,int_stack+110535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122940, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+332692,int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370852, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+348172,int_stack+111495,int_stack+110955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123780, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333952,int_stack+348172,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+333952,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378412, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+556012,int_stack+470962,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+284092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+112296,int_stack+112170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+112464,int_stack+112296, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+112680,int_stack+112464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+202159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+471610,int_stack+470962,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+472618,int_stack+471610,int_stack+7077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+470962,int_stack+113160,int_stack+112950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+471592,int_stack+113440,int_stack+113160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+471592,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+355732,int_stack+113800,int_stack+113440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+355732,int_stack+471592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+332692,int_stack+348172,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+106971,int_stack+332692,int_stack+472618, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+114565,int_stack+114250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+348172,int_stack+114985,int_stack+114565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+348172,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+115525,int_stack+114985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+6195,int_stack+348172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+562312,int_stack+438832,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+332692,int_stack+116326,int_stack+116200, 0.0, zero_stack, 1.0, int_stack+201865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+333070,int_stack+116494,int_stack+116326, 0.0, zero_stack, 1.0, int_stack+201991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333574,int_stack+333070,int_stack+332692, 0.0, zero_stack, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334330,int_stack+116710,int_stack+116494, 0.0, zero_stack, 1.0, int_stack+202159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334978,int_stack+334330,int_stack+333070, 0.0, zero_stack, 1.0, int_stack+227545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+335986,int_stack+334978,int_stack+333574, 0.0, zero_stack, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+337246,int_stack+117190,int_stack+116980, 0.0, zero_stack, 1.0, int_stack+203425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+332692,int_stack+117470,int_stack+117190, 0.0, zero_stack, 1.0, int_stack+203635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333532,int_stack+332692,int_stack+337246, 0.0, zero_stack, 1.0, int_stack+357622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+334792,int_stack+117830,int_stack+117470, 0.0, zero_stack, 1.0, int_stack+203915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+334792,int_stack+332692, 0.0, zero_stack, 1.0, int_stack+358252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+348172,int_stack+333532, 0.0, zero_stack, 1.0, int_stack+232417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+110751,int_stack+6195,int_stack+335986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+348172,int_stack+118595,int_stack+118280, 0.0, zero_stack, 1.0, int_stack+122310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+332692,int_stack+119015,int_stack+118595, 0.0, zero_stack, 1.0, int_stack+122940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+332692,int_stack+348172, 0.0, zero_stack, 1.0, int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+348172,int_stack+119555,int_stack+119015, 0.0, zero_stack, 1.0, int_stack+123780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333952,int_stack+348172,int_stack+332692, 0.0, zero_stack, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+333952,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+568612,int_stack+438832,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+120356,int_stack+120230, 1.0, int_stack+201865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+120524,int_stack+120356, 1.0, int_stack+201991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7077,int_stack+6573,int_stack+6195, 1.0, int_stack+227167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+438832,int_stack+120740,int_stack+120524, 1.0, int_stack+202159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+439480,int_stack+438832,int_stack+6573, 1.0, int_stack+227545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440488,int_stack+439480,int_stack+7077, 1.0, int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+121220,int_stack+121010, 1.0, int_stack+203425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+438832,int_stack+121500,int_stack+121220, 1.0, int_stack+203635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6195,int_stack+438832,int_stack+239797, 1.0, int_stack+357622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+355732,int_stack+121860,int_stack+121500, 1.0, int_stack+203915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+348172,int_stack+355732,int_stack+438832, 1.0, int_stack+358252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+348172,int_stack+6195, 1.0, int_stack+232417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+332692,int_stack+355732,int_stack+440488, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+232417,int_stack+123360,int_stack+122625, 1.0, int_stack+122310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6195,int_stack+124320,int_stack+123360, 1.0, int_stack+122940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+6195,int_stack+232417, 1.0, int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370852,int_stack+124860,int_stack+124320, 1.0, int_stack+123780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+370852,int_stack+6195, 1.0, int_stack+224251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862, 1.0, int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+114531,int_stack+470962,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+125661,int_stack+125535,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+356110,int_stack+125829,int_stack+125661,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+356110,int_stack+355732,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+356614,int_stack+126045,int_stack+125829,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+357262,int_stack+356614,int_stack+356110,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+357262,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+126525,int_stack+126315,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+356992,int_stack+126805,int_stack+126525,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+357832,int_stack+356992,int_stack+239797,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+359092,int_stack+127165,int_stack+126805,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+359092,int_stack+356992,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+357832,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+356992,int_stack+6195,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+231157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+127930,int_stack+127615,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+370852,int_stack+128350,int_stack+127930,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+370852,int_stack+355732,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+128890,int_stack+128350,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+370852,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+378412,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+120831,int_stack+470962,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+372532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+129691,int_stack+129565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207975,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+129859,int_stack+129691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208101,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228049,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+130075,int_stack+129859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208269,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380302,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380806,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+130555,int_stack+130345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209535,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+130835,int_stack+130555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209745,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381562,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+131195,int_stack+130835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210025,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+6195,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382192,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+471802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384478,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+127131,int_stack+6195,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+225907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+131960,int_stack+131645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151795,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+370852,int_stack+132380,int_stack+131960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152425,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+370852,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392272,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+132920,int_stack+132380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153265,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399832,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+574912,int_stack+470962,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+233917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+133721,int_stack+133595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207975, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+133889,int_stack+133721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208101, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228049, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+134105,int_stack+133889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208269, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380302, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380806, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+134585,int_stack+134375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209535, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+134865,int_stack+134585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209745, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381562, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+135225,int_stack+134865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210025, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+6195,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382192, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+471802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384478, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+130911,int_stack+6195,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+249076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+135990,int_stack+135675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151795, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+370852,int_stack+136410,int_stack+135990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152425, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+370852,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392272, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+136950,int_stack+136410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153265, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399832, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+581212,int_stack+470962,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+261052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+137751,int_stack+137625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207975, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+137919,int_stack+137751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208101, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228049, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+138135,int_stack+137919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208269, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380302, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380806, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+138615,int_stack+138405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209535, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+138895,int_stack+138615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209745, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381562, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+139255,int_stack+138895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210025, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+6195,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382192, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+471802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384478, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+134691,int_stack+6195,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+272116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+140020,int_stack+139705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151795, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+370852,int_stack+140440,int_stack+140020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152425, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+370852,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392272, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+140980,int_stack+140440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153265, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399832, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+587512,int_stack+470962,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+284092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+141781,int_stack+141655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+141949,int_stack+141781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+142165,int_stack+141949, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+142645,int_stack+142435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+142925,int_stack+142645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+143285,int_stack+142925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+6195,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+471802, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+138471,int_stack+6195,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+295156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+144050,int_stack+143735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+370852,int_stack+144470,int_stack+144050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+370852,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+145010,int_stack+144470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+370852, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+378412, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+593812,int_stack+470962,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+305452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+145811,int_stack+145685, 0.0, zero_stack, 1.0, int_stack+207975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+145979,int_stack+145811, 0.0, zero_stack, 1.0, int_stack+208101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+228049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+146195,int_stack+145979, 0.0, zero_stack, 1.0, int_stack+208269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 1.0, int_stack+380302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 1.0, int_stack+380806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+146675,int_stack+146465, 0.0, zero_stack, 1.0, int_stack+209535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+146955,int_stack+146675, 0.0, zero_stack, 1.0, int_stack+209745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797, 0.0, zero_stack, 1.0, int_stack+381562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+147315,int_stack+146955, 0.0, zero_stack, 1.0, int_stack+210025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+6195,int_stack+470962, 0.0, zero_stack, 1.0, int_stack+382192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+471802, 0.0, zero_stack, 1.0, int_stack+384478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+142251,int_stack+6195,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+316516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+148080,int_stack+147765, 0.0, zero_stack, 1.0, int_stack+151795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+370852,int_stack+148500,int_stack+148080, 0.0, zero_stack, 1.0, int_stack+152425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378412,int_stack+370852,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+392272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+470962,int_stack+149040,int_stack+148500, 0.0, zero_stack, 1.0, int_stack+153265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+370852, 0.0, zero_stack, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+378412, 0.0, zero_stack, 1.0, int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+600112,int_stack+470962,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+326812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+149841,int_stack+149715, 1.0, int_stack+207975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+150009,int_stack+149841, 1.0, int_stack+208101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 1.0, int_stack+228049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+150225,int_stack+150009, 1.0, int_stack+208269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 1.0, int_stack+380302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 1.0, int_stack+380806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+150705,int_stack+150495, 1.0, int_stack+209535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+150985,int_stack+150705, 1.0, int_stack+209745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797, 1.0, int_stack+381562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6195,int_stack+151345,int_stack+150985, 1.0, int_stack+210025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370852,int_stack+6195,int_stack+470962, 1.0, int_stack+382192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+370852,int_stack+471802, 1.0, int_stack+384478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+378412,int_stack+6195,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+337876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+152845,int_stack+152110, 1.0, int_stack+151795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+384478,int_stack+153805,int_stack+152845, 1.0, int_stack+152425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+384478,int_stack+355732, 1.0, int_stack+392272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+154345,int_stack+153805, 1.0, int_stack+153265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+392272,int_stack+384478, 1.0, int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 1.0, int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+146031,int_stack+438832,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+349852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+155146,int_stack+155020,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+155314,int_stack+155146,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+155530,int_stack+155314,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+7077,int_stack+6573,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+220975,int_stack+438832,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+156010,int_stack+155800,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+438832,int_stack+156290,int_stack+156010,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+438832,int_stack+239797,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+439672,int_stack+156650,int_stack+156290,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+439672,int_stack+438832,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+392272,int_stack+355732,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+227167,int_stack+6195,int_stack+220975, 0.0, zero_stack, 1.0, int_stack+231157, 1.0, int_stack+383218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+220975,int_stack+157415,int_stack+157100,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+355732,int_stack+157835,int_stack+157415,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+355732,int_stack+220975,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+158375,int_stack+157835,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+392272,int_stack+355732,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+399832,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+152331,int_stack+470962,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+372532, 1.0, int_stack+393952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+159176,int_stack+159050,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+159344,int_stack+159176,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+159560,int_stack+159344,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+160040,int_stack+159830,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+160320,int_stack+160040,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+220975,int_stack+470962,int_stack+239797,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+471802,int_stack+160680,int_stack+160320,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+471802,int_stack+470962,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+392272,int_stack+220975,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+606412,int_stack+6195,int_stack+355732, 0.0, zero_stack, 2.0, int_stack+383218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+161445,int_stack+161130,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+220975,int_stack+161865,int_stack+161445,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+220975,int_stack+355732,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+162405,int_stack+161865,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+392272,int_stack+220975,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+399832,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+610192,int_stack+438832,int_stack+6195, 0.0, zero_stack, 2.0, int_stack+393952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+163986,int_stack+163860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214865,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+164154,int_stack+163986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214991,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222235,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+164370,int_stack+164154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215159,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401722,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+220975,int_stack+438832,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402226,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+166150,int_stack+165940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216425,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+438832,int_stack+166430,int_stack+166150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216635,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+438832,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402982,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+439672,int_stack+166790,int_stack+166430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216915,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+439672,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403612,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+392272,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405898,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+158631,int_stack+6195,int_stack+220975, 1.0, int_stack+225907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+220975,int_stack+167555,int_stack+167240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198640,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+355732,int_stack+167975,int_stack+167555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199270,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+355732,int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3990,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+168515,int_stack+167975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200110,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+392272,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4935,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421192,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+162411,int_stack+470962,int_stack+6195, 1.0, int_stack+233917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+170096,int_stack+169970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214865, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+170264,int_stack+170096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214991, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222235, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+170480,int_stack+170264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215159, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401722, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402226, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+172260,int_stack+172050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216425, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+172540,int_stack+172260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216635, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+220975,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402982, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471802,int_stack+172900,int_stack+172540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216915, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+471802,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403612, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+392272,int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405898, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+222613,int_stack+6195,int_stack+355732, 1.0, int_stack+249076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+173665,int_stack+173350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198640, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+220975,int_stack+174085,int_stack+173665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199270, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+220975,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3990, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+174625,int_stack+174085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200110, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+392272,int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4935, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421192, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+168711,int_stack+438832,int_stack+6195, 1.0, int_stack+261052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+176206,int_stack+176080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214865, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+176374,int_stack+176206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214991, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222235, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+176590,int_stack+176374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215159, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401722, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+220975,int_stack+438832,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402226, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+178370,int_stack+178160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216425, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+438832,int_stack+178650,int_stack+178370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216635, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355732,int_stack+438832,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402982, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+439672,int_stack+179010,int_stack+178650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216915, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+439672,int_stack+438832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403612, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+392272,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405898, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+259372,int_stack+6195,int_stack+220975, 1.0, int_stack+272116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+220975,int_stack+179775,int_stack+179460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+355732,int_stack+180195,int_stack+179775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199270, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+355732,int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3990, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+180735,int_stack+180195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200110, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+392272,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4935, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421192, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+175011,int_stack+470962,int_stack+6195, 1.0, int_stack+284092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6195,int_stack+182316,int_stack+182190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6573,int_stack+182484,int_stack+182316, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+6573,int_stack+6195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7077,int_stack+182700,int_stack+182484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+7077,int_stack+6573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+184480,int_stack+184270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+184760,int_stack+184480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+220975,int_stack+470962,int_stack+239797, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+471802,int_stack+185120,int_stack+184760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+471802,int_stack+470962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6195,int_stack+392272,int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+282412,int_stack+6195,int_stack+355732, 1.0, int_stack+295156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+185885,int_stack+185570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+220975,int_stack+186305,int_stack+185885, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+220975,int_stack+355732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+392272,int_stack+186845,int_stack+186305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+392272,int_stack+220975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+399832, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+181311,int_stack+438832,int_stack+6195, 1.0, int_stack+305452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+305452,int_stack+188426,int_stack+188300, 0.0, zero_stack, 1.0, int_stack+214865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+305830,int_stack+188594,int_stack+188426, 0.0, zero_stack, 1.0, int_stack+214991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+305830,int_stack+305452, 0.0, zero_stack, 1.0, int_stack+222235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+306334,int_stack+188810,int_stack+188594, 0.0, zero_stack, 1.0, int_stack+215159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6195,int_stack+306334,int_stack+305830, 0.0, zero_stack, 1.0, int_stack+401722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+220975,int_stack+6195,int_stack+239797, 0.0, zero_stack, 1.0, int_stack+402226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+190590,int_stack+190380, 0.0, zero_stack, 1.0, int_stack+216425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6195,int_stack+190870,int_stack+190590, 0.0, zero_stack, 1.0, int_stack+216635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7035,int_stack+6195,int_stack+239797, 0.0, zero_stack, 1.0, int_stack+402982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+305452,int_stack+191230,int_stack+190870, 0.0, zero_stack, 1.0, int_stack+216915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+305452,int_stack+6195, 0.0, zero_stack, 1.0, int_stack+403612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+305452,int_stack+392272,int_stack+7035, 0.0, zero_stack, 1.0, int_stack+405898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+293752,int_stack+305452,int_stack+220975, 1.0, int_stack+316516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+220975,int_stack+191995,int_stack+191680, 0.0, zero_stack, 1.0, int_stack+198640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+355732,int_stack+192415,int_stack+191995, 0.0, zero_stack, 1.0, int_stack+199270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399832,int_stack+355732,int_stack+220975, 0.0, zero_stack, 1.0, int_stack+3990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+297532,int_stack+192955,int_stack+192415, 0.0, zero_stack, 1.0, int_stack+200110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+297532,int_stack+355732, 0.0, zero_stack, 1.0, int_stack+4935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+399832, 0.0, zero_stack, 1.0, int_stack+421192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+187611,int_stack+470962,int_stack+305452, 1.0, int_stack+326812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326812,int_stack+194536,int_stack+194410, 1.0, int_stack+214865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327190,int_stack+194704,int_stack+194536, 1.0, int_stack+214991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+327190,int_stack+326812, 1.0, int_stack+222235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+327694,int_stack+194920,int_stack+194704, 1.0, int_stack+215159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+305452,int_stack+327694,int_stack+327190, 1.0, int_stack+401722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+305452,int_stack+239797, 1.0, int_stack+402226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+197550,int_stack+197340, 1.0, int_stack+216425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+305452,int_stack+197830,int_stack+197550, 1.0, int_stack+216635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+306292,int_stack+305452,int_stack+239797, 1.0, int_stack+402982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+326812,int_stack+198190,int_stack+197830, 1.0, int_stack+216915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+326812,int_stack+305452, 1.0, int_stack+403612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+326812,int_stack+392272,int_stack+306292, 1.0, int_stack+405898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+399832,int_stack+326812,int_stack+355732, 1.0, int_stack+337876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+199690,int_stack+198955, 1.0, int_stack+198640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+405898,int_stack+200650,int_stack+199690, 1.0, int_stack+199270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+405898,int_stack+355732, 1.0, int_stack+3990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+297532,int_stack+201190,int_stack+200650, 1.0, int_stack+200110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+297532,int_stack+405898, 1.0, int_stack+4935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+426862, 1.0, int_stack+421192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+193911,int_stack+438832,int_stack+326812, 1.0, int_stack+349852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+326812,int_stack+202771,int_stack+202645,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+327190,int_stack+202939,int_stack+202771,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+327190,int_stack+326812,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+327694,int_stack+203155,int_stack+202939,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+327694,int_stack+327190,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+438832,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+204935,int_stack+204725,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+438832,int_stack+205215,int_stack+204935,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+439672,int_stack+438832,int_stack+239797,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+326812,int_stack+205575,int_stack+205215,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+326812,int_stack+438832,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+326812,int_stack+392272,int_stack+439672,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+348172,int_stack+326812,int_stack+355732, 1.0, int_stack+231157, 0.0, zero_stack, 1.0, int_stack+404638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+206340,int_stack+206025,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+392272,int_stack+206760,int_stack+206340,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+421192,int_stack+392272,int_stack+355732,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+297532,int_stack+207300,int_stack+206760,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+297532,int_stack+392272,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+421192,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+200211,int_stack+470962,int_stack+326812, 1.0, int_stack+372532, 0.0, zero_stack, 1.0, int_stack+415312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+326812,int_stack+208881,int_stack+208755,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+327190,int_stack+209049,int_stack+208881,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+327190,int_stack+326812,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+327694,int_stack+209265,int_stack+209049,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+327694,int_stack+327190,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+470962,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+211045,int_stack+210835,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+470962,int_stack+211325,int_stack+211045,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+471802,int_stack+470962,int_stack+239797,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+326812,int_stack+211685,int_stack+211325,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+392272,int_stack+326812,int_stack+470962,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+326812,int_stack+392272,int_stack+471802,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+370852,int_stack+326812,int_stack+355732, 1.0, int_stack+383218, 1.0, int_stack+404638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+212450,int_stack+212135,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+392272,int_stack+212870,int_stack+212450,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+421192,int_stack+392272,int_stack+355732,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+297532,int_stack+213410,int_stack+212870,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+470962,int_stack+297532,int_stack+392272,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+438832,int_stack+470962,int_stack+421192,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+206511,int_stack+438832,int_stack+326812, 1.0, int_stack+393952, 1.0, int_stack+415312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+326812,int_stack+215771,int_stack+215645,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+327190,int_stack+215939,int_stack+215771,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239797,int_stack+327190,int_stack+326812,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+327694,int_stack+216155,int_stack+215939,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+327694,int_stack+327190,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+355732,int_stack+438832,int_stack+239797,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+239797,int_stack+217935,int_stack+217725,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+438832,int_stack+218215,int_stack+217935,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+439672,int_stack+438832,int_stack+239797,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+326812,int_stack+218575,int_stack+218215,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+421192,int_stack+326812,int_stack+438832,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+326812,int_stack+421192,int_stack+439672,10);
 /*--- compute (dp|hf) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+392272,int_stack+326812,int_stack+355732, 2.0, int_stack+404638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+355732,int_stack+219340,int_stack+219025,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+421192,int_stack+219760,int_stack+219340,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+426862,int_stack+421192,int_stack+355732,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+297532,int_stack+220300,int_stack+219760,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+438832,int_stack+297532,int_stack+421192,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+470962,int_stack+438832,int_stack+426862,15);
 /*--- compute (fp|hf) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+212811,int_stack+470962,int_stack+326812, 2.0, int_stack+415312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+616492,int_stack+253072,int_stack+236017,210);
     Libderiv->ABCD[11] = int_stack + 616492;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+246853,int_stack+276112,int_stack+263152,210);
     Libderiv->ABCD[10] = int_stack + 246853;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+270712,int_stack+299152,int_stack+286192,210);
     Libderiv->ABCD[9] = int_stack + 270712;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+297532,int_stack+320512,int_stack+307552,210);
     Libderiv->ABCD[8] = int_stack + 297532;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+315112,int_stack+341872,int_stack+328912,210);
     Libderiv->ABCD[7] = int_stack + 315112;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+336472,int_stack+360772,int_stack+351952,210);
     Libderiv->ABCD[6] = int_stack + 336472;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+624052,int_stack+385972,int_stack+374632, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[2] = int_stack + 624052;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+382192,int_stack+409012,int_stack+396052, 0.0, zero_stack, 1.0, int_stack+367072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[1] = int_stack + 382192;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+403612,int_stack+428752,int_stack+417412, 1.0, int_stack+367072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[0] = int_stack + 403612;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+360772,int_stack+441982,int_stack+435052,210);
     Libderiv->ABCD[155] = int_stack + 360772;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+426862,int_stack+448282,int_stack+423082,210);
     Libderiv->ABCD[143] = int_stack + 426862;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+434422,int_stack+12075,int_stack+8295,210);
     Libderiv->ABCD[142] = int_stack + 434422;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+441982,int_stack+458362,int_stack+454582,210);
     Libderiv->ABCD[131] = int_stack + 441982;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+449542,int_stack+464662,int_stack+21291,210);
     Libderiv->ABCD[130] = int_stack + 449542;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+457102,int_stack+474112,int_stack+25071,210);
     Libderiv->ABCD[129] = int_stack + 457102;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+464662,int_stack+480412,int_stack+28851,210);
     Libderiv->ABCD[119] = int_stack + 464662;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+472222,int_stack+486712,int_stack+32631,210);
     Libderiv->ABCD[118] = int_stack + 472222;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+479782,int_stack+493012,int_stack+36411,210);
     Libderiv->ABCD[117] = int_stack + 479782;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+487342,int_stack+499312,int_stack+40191,210);
     Libderiv->ABCD[116] = int_stack + 487342;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+494902,int_stack+505612,int_stack+43971,210);
     Libderiv->ABCD[107] = int_stack + 494902;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+502462,int_stack+511912,int_stack+47751,210);
     Libderiv->ABCD[106] = int_stack + 502462;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+510022,int_stack+518212,int_stack+51531,210);
     Libderiv->ABCD[105] = int_stack + 510022;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+3780,int_stack+524512,int_stack+55311,210);
     Libderiv->ABCD[104] = int_stack + 3780;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+517582,int_stack+530812,int_stack+59091,210);
     Libderiv->ABCD[103] = int_stack + 517582;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+525142,int_stack+537112,int_stack+62871,210);
     Libderiv->ABCD[95] = int_stack + 525142;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+532702,int_stack+70431,int_stack+66651,210);
     Libderiv->ABCD[94] = int_stack + 532702;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+11340,int_stack+76731,int_stack+266932,210);
     Libderiv->ABCD[93] = int_stack + 11340;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+18900,int_stack+240553,int_stack+289972,210);
     Libderiv->ABCD[92] = int_stack + 18900;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+26460,int_stack+83031,int_stack+311332,210);
     Libderiv->ABCD[91] = int_stack + 26460;
 /*--- compute (dd|hf) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+34020,int_stack+89331,int_stack+0,210);
     Libderiv->ABCD[90] = int_stack + 34020;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+41580,int_stack+543412,int_stack+95631, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[47] = int_stack + 41580;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+540262,int_stack+549712,int_stack+99411, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[46] = int_stack + 540262;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+547822,int_stack+556012,int_stack+103191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+286192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[45] = int_stack + 547822;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+49140,int_stack+562312,int_stack+106971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[44] = int_stack + 49140;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+555382,int_stack+568612,int_stack+110751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[43] = int_stack + 555382;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+562942,int_stack+114531,int_stack+332692, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[42] = int_stack + 562942;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+56700,int_stack+120831,int_stack+356992, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+374632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[38] = int_stack + 56700;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+64260,int_stack+574912,int_stack+127131, 0.0, zero_stack, 1.0, int_stack+236017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[35] = int_stack + 64260;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+570502,int_stack+581212,int_stack+130911, 0.0, zero_stack, 1.0, int_stack+263152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[34] = int_stack + 570502;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+578062,int_stack+587512,int_stack+134691, 0.0, zero_stack, 1.0, int_stack+286192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[33] = int_stack + 578062;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+585622,int_stack+593812,int_stack+138471, 0.0, zero_stack, 1.0, int_stack+307552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[32] = int_stack + 585622;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+71820,int_stack+600112,int_stack+142251, 0.0, zero_stack, 1.0, int_stack+328912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[31] = int_stack + 71820;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+593182,int_stack+146031,int_stack+378412, 0.0, zero_stack, 1.0, int_stack+351952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[30] = int_stack + 593182;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+79380,int_stack+152331,int_stack+227167, 0.0, zero_stack, 1.0, int_stack+374632, 1.0, int_stack+396052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[26] = int_stack + 79380;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+86940,int_stack+610192,int_stack+606412, 0.0, zero_stack, 2.0, int_stack+396052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[25] = int_stack + 86940;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+600742,int_stack+162411,int_stack+158631, 1.0, int_stack+236017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[23] = int_stack + 600742;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+608302,int_stack+168711,int_stack+222613, 1.0, int_stack+263152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[22] = int_stack + 608302;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+263152,int_stack+175011,int_stack+259372, 1.0, int_stack+286192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[21] = int_stack + 263152;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+286192,int_stack+181311,int_stack+282412, 1.0, int_stack+307552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[20] = int_stack + 286192;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+305092,int_stack+187611,int_stack+293752, 1.0, int_stack+328912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[19] = int_stack + 305092;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+94500,int_stack+193911,int_stack+399832, 1.0, int_stack+351952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[18] = int_stack + 94500;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+351952,int_stack+200211,int_stack+348172, 1.0, int_stack+374632, 0.0, zero_stack, 1.0, int_stack+417412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[14] = int_stack + 351952;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+374632,int_stack+206511,int_stack+370852, 1.0, int_stack+396052, 1.0, int_stack+417412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[13] = int_stack + 374632;
 /*--- compute (dd|hf) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+396052,int_stack+212811,int_stack+392272, 2.0, int_stack+417412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[12] = int_stack + 396052;

}
